/**
 * Copyright (C) 2010-2012 Graham Breach
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * jQuery.tagcanvas 1.17.1
 * For more information, please contact <graham@goat1000.com>
 */
/**
 * Modified by Shad Laws 2012/06/08 -- all modified lines have "mod Shad Laws" comments
 * - built a physics-based model for motion, which is activated with the physModel flag
 * - included initialDecel, deadZone, maxInputZone, and physModel as options
 * - set defaults of new options to mimic behavior without them (false, 0, 0, and false)
 * - removed two unnecessary variable declarations caught by YUI Compressor
 * - fixed initialization of a few variables (minSpeed, decel, yaw/pitch)
 * - fixed problem with html margin-top changing coordinates in IE (but not Chrome or Firefox)
 */
(function(I){var S,R,G=Math.abs,r=Math.sin,h=Math.cos,z=Math.max,W=Math.min,M=Math.sqrt,B={},C={},D={0:"0,",1:"17,",2:"34,",3:"51,",4:"68,",5:"85,",6:"102,",7:"119,",8:"136,",9:"153,",a:"170,",A:"170,",b:"187,",B:"187,",c:"204,",C:"204,",d:"221,",D:"221,",e:"238,",E:"238,",f:"255,",F:"255,"},e,J,d,l=document,y,c={};for(S=0;S<256;++S){R=S.toString(16);if(S<16){R="0"+R}C[R]=C[R.toUpperCase()]=S.toString()+","}function O(i){return typeof(i)!="undefined"}function H(j){var Z=j.length-1,Y,aa;while(Z){aa=~~(Math.random()*Z);Y=j[Z];j[Z]=j[aa];j[aa]=Y;--Z}}function n(Z,ab,ag,ad){var ac,af,j,ae,ah=[],aa=Math.PI*(3-Math.sqrt(5)),Y=2/Z;for(ac=0;ac<Z;++ac){af=ac*Y-1+(Y/2);j=Math.sqrt(1-af*af);ae=ac*aa;ah.push([h(ae)*j*ab,af*ag,r(ae)*j*ad])}return ah}function V(aa,Y,ad,aj,ai,ag,af,ae,ac){var ah,ak=[],ab=Math.PI*(3-Math.sqrt(5)),Z=2/aa;for(ag=0;ag<aa;++ag){af=ag*Z-1+(Z/2);ah=ag*ab;ae=h(ah);ac=r(ah);ak.push(Y?[af*ad,ae*aj,ac*ai]:[ae*ad,af*aj,ac*ai])}return ak}function w(Z,i,j,Y){return V(Z,0,i,j,Y)}function F(Z,i,j,Y){return V(Z,1,i,j,Y)}function p(ab,i){var aa=ab,Z,Y,j=(i*1).toPrecision(3)+")";if(ab[0]==="#"){if(!B[ab]){if(ab.length===4){B[ab]="rgba("+D[ab[1]]+D[ab[2]]+D[ab[3]]}else{B[ab]="rgba("+C[ab.substr(1,2)]+C[ab.substr(3,2)]+C[ab.substr(5,2)]}}aa=B[ab]+j}else{if(ab.substr(0,4)==="rgb("||ab.substr(0,4)==="hsl("){aa=(ab.replace("(","a(").replace(")",","+j))}else{if(ab.substr(0,5)==="rgba("||ab.substr(0,5)==="hsla("){Z=ab.lastIndexOf(",")+1,Y=ab.indexOf(")");i*=parseFloat(ab.substring(Z,Y));aa=ab.substr(0,Z)+i.toPrecision(3)+")"}}}return aa}function g(i,j){if(window.G_vmlCanvasManager){return null}var Y=l.createElement("canvas");Y.width=i;Y.height=j;return Y}function v(){var j=g(3,3),Z,Y;if(!j){return false}Z=j.getContext("2d");Z.strokeStyle="#000";Z.shadowColor="#fff";Z.shadowBlur=3;Z.globalAlpha=0;Z.strokeRect(2,2,2,2);Z.globalAlpha=1;Y=Z.getImageData(2,2,1,1);j=null;return(Y.data[0]>0)}function X(af,j){var Y=1024,ab=af.weightGradient,aa,ad,Z,ae,ac;if(af.gCanvas){ad=af.gCanvas.getContext("2d")}else{af.gCanvas=aa=g(Y,1);if(!aa){return null}ad=aa.getContext("2d");ae=ad.createLinearGradient(0,0,Y,0);for(Z in ab){ae.addColorStop(1-Z,ab[Z])}ad.fillStyle=ae;ad.fillRect(0,0,Y,1)}ac=ad.getImageData(~~((Y-1)*j),0,1,1).data;return"rgba("+ac[0]+","+ac[1]+","+ac[2]+","+(ac[3]/255)+")"}function u(ab,aa,Y,ae,ac,ad,j){var Z=(ad||0)+(j&&j[0]<0?G(j[0]):0),i=(ad||0)+(j&&j[1]<0?G(j[1]):0);ab.font=aa;ab.textBaseline="top";ab.fillStyle=Y;ac&&(ab.shadowColor=ac);ad&&(ab.shadowBlur=ad);j&&(ab.shadowOffsetX=j[0],ab.shadowOffsetY=j[1]);ab.fillText(ae,Z,i)}function m(ak,ac,ag,ai,ab,Y,ae,af,j,aj,ah){var Z=ai+G(j[0])+af+af,i=ab+G(j[1])+af+af,aa,ad;aa=g(Z+aj,i+ah);if(!aa){return null}ad=aa.getContext("2d");u(ad,ac,Y,ak,ae,af,j);return aa}function Q(ac,af,ag,Z){var aa=ac.width+G(Z[0])+ag+ag,j=ac.height+G(Z[1])+ag+ag,ad,ae,ab=(ag||0)+(Z&&Z[0]<0?G(Z[0]):0),Y=(ag||0)+(Z&&Z[1]<0?G(Z[1]):0);ad=g(aa,j);if(!ad){return null}ae=ad.getContext("2d");af&&(ae.shadowColor=af);ag&&(ae.shadowBlur=ag);Z&&(ae.shadowOffsetX=Z[0],ae.shadowOffsetY=Z[1]);ae.drawImage(ac,ab,Y);return ad}function K(ak,ac,ai){var aj=parseInt(ak.length*ai),ab=parseInt(ai*2),Z=g(aj,ab),af,j,aa,ae,ah,ag,Y,ad;if(!Z){return null}af=Z.getContext("2d");af.fillStyle="#000";af.fillRect(0,0,aj,ab);u(af,ai+"px "+ac,"#fff",ak);j=af.getImageData(0,0,aj,ab);aa=j.width;ae=j.height;ad={min:{x:aa,y:ae},max:{x:-1,y:-1}};for(ag=0;ag<ae;++ag){for(ah=0;ah<aa;++ah){Y=(ag*aa+ah)*4;if(j.data[Y+1]>0){if(ah<ad.min.x){ad.min.x=ah}if(ah>ad.max.x){ad.max.x=ah}if(ag<ad.min.y){ad.min.y=ag}if(ag>ad.max.y){ad.max.y=ag}}}}if(aa!=aj){ad.min.x*=(aj/aa);ad.max.x*=(aj/aa)}if(ae!=ab){ad.min.y*=(aj/ae);ad.max.y*=(aj/ae)}Z=null;return ad}function t(i){return"'"+i.replace(/(\'|\")/g,"").replace(/\s*,\s*/g,"', '")+"'"}function A(i,j,Y){Y=Y||l;if(Y.addEventListener){Y.addEventListener(i,j,false)}else{Y.attachEvent("on"+i,j)}}function P(aa,ac,Z,j){var Y=j.taglist,ab=j.imageScale;if(ab&&!(ac.width&&ac.height)){A("load",function(){P(aa,ac,Z,j)},window);return}if(!aa.complete){A("load",function(){P(aa,ac,Z,j)},aa);return}ac.width=ac.width;ac.height=ac.height;if(ab){aa.width=ac.width*ab;aa.height=ac.height*ab}Z.w=aa.width;Z.h=aa.height;Y.push(Z)}function N(Z,Y){var j=l.defaultView,i=Y.replace(/\-([a-z])/g,function(aa){return aa.charAt(1).toUpperCase()});return(j&&j.getComputedStyle&&j.getComputedStyle(Z,null).getPropertyValue(Y))||(Z.currentStyle&&Z.currentStyle[i])}function x(Y,j){var i=1,Z;if(Y.weightFrom){i=1*(j.getAttribute(Y.weightFrom)||Y.textHeight)}else{if(Z=N(j,"font-size")){i=(Z.indexOf("px")>-1&&Z.replace("px","")*1)||(Z.indexOf("pt")>-1&&Z.replace("pt","")*1.25)||Z*3.3}else{Y.weight=false}}return i}function k(Y){L(Y);var j=Y.target||Y.fromElement.parentNode,i=s.tc[j.id];i&&(i.mx=i.my=-1)}function L(aa){var Z,Y,j=l.documentElement,ab;for(Z in s.tc){Y=s.tc[Z];if(Y.tttimer){clearTimeout(Y.tttimer);Y.tttimer=null}ab=I(Y.canvas).offset();if(aa.offsetX){Y.mx=aa.offsetX;Y.my=aa.offsetY}else{if(aa.pageX){Y.mx=aa.pageX-ab.left;Y.my=aa.pageY-ab.top}else{Y.mx=aa.clientX+(j.scrollLeft||l.body.scrollLeft)-ab.left;Y.my=aa.clientY+(j.scrollTop||l.body.scrollTop)-ab.top}}}}function q(Z){var j=s,i=l.addEventListener?0:1,Y=Z.target&&O(Z.target.id)?Z.target.id:Z.srcElement.parentNode.id;if(Y&&Z.button==i&&j.tc[Y]){L(Z);j.tc[Y].Clicked(Z)}}function U(Y){var i=s,j=Y.target&&O(Y.target.id)?Y.target.id:Y.srcElement.parentNode.id;if(j&&i.tc[j]){Y.cancelBubble=true;Y.returnValue=false;Y.preventDefault&&Y.preventDefault();i.tc[j].Wheel((Y.wheelDelta||Y.detail)>0)}}function o(){var Y=s.tc,j;for(j in Y){Y[j].Draw()}}function b(Y,i){var j=r(i),Z=h(i);return{x:Y.x,y:(Y.y*Z)+(Y.z*j),z:(Y.y*-j)+(Y.z*Z)}}function a(Y,i){var j=r(i),Z=h(i);return{x:(Y.x*Z)+(Y.z*-j),y:Y.y,z:(Y.x*j)+(Y.z*Z)}}function T(Y,af,ae,aa,ad,ab){var i,Z,ac,j=Y.z1/(Y.z1+Y.z2+af.z);i=af.y*j*ab;Z=af.x*j*ad;ac=Y.z2+af.z;return{x:Z,y:i,z:ac}}function f(i){this.ts=new Date().valueOf();this.tc=i;this.x=this.y=this.w=this.h=this.sc=1;this.z=0;this.Draw=i.pulsateTo<1&&i.outlineMethod!="colour"?this.DrawPulsate:this.DrawSimple;this.SetMethod(i.outlineMethod)}e=f.prototype;e.SetMethod=function(Y){var j={block:["PreDraw","DrawBlock"],colour:["PreDraw","DrawColour"],outline:["PostDraw","DrawOutline"],classic:["LastDraw","DrawOutline"],none:["LastDraw"]},i=j[Y]||j.outline;if(Y=="none"){this.Draw=function(){return 1}}else{this.drawFunc=this[i[1]]}this[i[0]]=this.Draw};e.Update=function(ae,ad,af,ab,ac,j,aa,i){var Y=this.tc.outlineOffset,Z=2*Y;this.x=ac*ae+aa-Y;this.y=ac*ad+i-Y;this.w=ac*af+Z;this.h=ac*ab+Z;this.sc=ac;this.z=j.z};e.DrawOutline=function(ab,i,aa,j,Y,Z){ab.strokeStyle=Z;ab.strokeRect(i,aa,j,Y)};e.DrawColour=function(Z,ac,aa,ad,Y,i,ae,j,ab){return this[ae.image?"DrawColourImage":"DrawColourText"](Z,ac,aa,ad,Y,i,ae,j,ab)};e.DrawColourText=function(aa,ad,ab,ae,Y,i,af,j,ac){var Z=af.colour;af.colour=i;af.Draw(aa,j,ac);af.colour=Z;return 1};e.DrawColourImage=function(ad,ag,ae,ah,ac,i,ak,j,af){var ai=ad.canvas,aa=~~z(ag,0),Z=~~z(ae,0),ab=W(ai.width-aa,ah)+0.5|0,aj=W(ai.height-Z,ac)+0.5|0,Y;if(y){y.width=ab,y.height=aj}else{y=g(ab,aj)}if(!y){return this.SetMethod("outline")}Y=y.getContext("2d");Y.drawImage(ai,aa,Z,ab,aj,0,0,ab,aj);ad.clearRect(aa,Z,ab,aj);ak.Draw(ad,j,af);ad.setTransform(1,0,0,1,0,0);ad.save();ad.beginPath();ad.rect(aa,Z,ab,aj);ad.clip();ad.globalCompositeOperation="source-in";ad.fillStyle=i;ad.fillRect(aa,Z,ab,aj);ad.restore();ad.globalCompositeOperation="destination-over";ad.drawImage(y,0,0,ab,aj,aa,Z,ab,aj);ad.globalCompositeOperation="source-over";return 1};e.DrawBlock=function(ab,i,aa,j,Y,Z){ab.fillStyle=Z;ab.fillRect(i,aa,j,Y)};e.DrawSimple=function(aa,i,j,Z){var Y=this.tc;aa.setTransform(1,0,0,1,0,0);aa.strokeStyle=Y.outlineColour;aa.lineWidth=Y.outlineThickness;aa.shadowBlur=aa.shadowOffsetX=aa.shadowOffsetY=0;aa.globalAlpha=1;return this.drawFunc(aa,this.x,this.y,this.w,this.h,Y.outlineColour,i,j,Z)};e.DrawPulsate=function(ab,i,j,Z){var aa=new Date().valueOf()-this.ts,Y=this.tc;ab.setTransform(1,0,0,1,0,0);ab.strokeStyle=Y.outlineColour;ab.lineWidth=Y.outlineThickness;ab.shadowBlur=ab.shadowOffsetX=ab.shadowOffsetY=0;ab.globalAlpha=Y.pulsateTo+((1-Y.pulsateTo)*(0.5+(h(2*Math.PI*aa/(1000*Y.pulsateTime))/2)));return this.drawFunc(ab,this.x,this.y,this.w,this.h,Y.outlineColour,i,j,Z)};e.Active=function(Y,i,j){return(i>=this.x&&j>=this.y&&i<=this.x+this.w&&j<=this.y+this.h)};e.PreDraw=e.PostDraw=e.LastDraw=function(){};function E(aa,j,ae,ag,af,ac,Y,Z){var ad=aa.ctxt,ab;this.tc=aa;this.image=j.src?j:null;this.name=j.src?"":j;this.title=ae.title||null;this.a=ae;this.p3d={x:ag[0]*aa.radius*1.1,y:ag[1]*aa.radius*1.1,z:ag[2]*aa.radius*1.1};this.x=this.y=0;this.w=af;this.h=ac;this.colour=Y||aa.textColour;this.textFont=Z||aa.textFont;this.weight=this.sc=this.alpha=1;this.weighted=!aa.weight;this.outline=new f(aa);if(this.image){if(aa.txtOpt&&aa.shadow){ab=Q(this.image,aa.shadow,aa.shadowBlur,aa.shadowOffset);if(ab){this.image=ab;this.w=ab.width;this.h=ab.height}}}else{this.textHeight=aa.textHeight;this.extents=K(this.name,this.textFont,this.textHeight);this.Measure(ad,aa)}this.SetShadowColour=aa.shadowAlpha?this.SetShadowColourAlpha:this.SetShadowColourFixed;this.SetDraw(aa)}J=E.prototype;J.SetDraw=function(i){this.Draw=this.image?(i.ie>7?this.DrawImageIE:this.DrawImage):this.DrawText;i.noSelect&&(this.CheckActive=function(){})};J.Measure=function(ac,j){this.h=this.extents?this.extents.max.y+this.extents.min.y:this.textHeight;ac.font=this.font=this.textHeight+"px "+this.textFont;this.w=ac.measureText(this.name).width;if(j.txtOpt){var Z=j.txtScale,aa=Z*this.textHeight,ab=aa+"px "+this.textFont,Y=[Z*j.shadowOffset[0],Z*j.shadowOffset[1]],i;ac.font=ab;i=ac.measureText(this.name).width;this.image=m(this.name,ab,aa,i,Z*this.h,this.colour,j.shadow,Z*j.shadowBlur,Y,Z,Z);if(this.image){this.w=this.image.width/Z;this.h=this.image.height/Z}this.SetDraw(j);j.txtOpt=this.image}};J.SetWeight=function(i){if(!this.name.length){return}this.weight=i;this.Weight(this.tc.ctxt,this.tc);this.Measure(this.tc.ctxt,this.tc)};J.Weight=function(Z,Y){var j=this.weight,i=Y.weightMode;this.weighted=true;if(i=="colour"||i=="both"){this.colour=X(Y,(j-Y.min_weight)/(Y.max_weight-Y.min_weight))}if(i=="size"||i=="both"){this.textHeight=j*Y.weightSize}this.extents=K(this.name,this.textFont,this.textHeight)};J.SetShadowColourFixed=function(Y,j,i){Y.shadowColor=j};J.SetShadowColourAlpha=function(Y,j,i){Y.shadowColor=p(j,i)};J.DrawText=function(Y,ac,j){var ad=this.tc,aa=this.x,Z=this.y,ab,i,ae=this.sc;Y.globalAlpha=this.alpha;Y.setTransform(ae,0,0,ae,0,0);Y.fillStyle=this.colour;ad.shadow&&this.SetShadowColour(Y,ad.shadow,this.alpha);Y.font=this.font;ab=this.w;i=this.h;aa+=(ac/ae)-(ab/2);Z+=(j/ae)-(i/2);Y.fillText(this.name,aa,Z)};J.DrawImage=function(aa,ag,Z){var ad=this.x,ab=this.y,ah=this.sc,j=this.image,ae=this.w,Y=this.h,ac=this.alpha,af=this.shadow;aa.globalAlpha=ac;aa.setTransform(ah,0,0,ah,0,0);aa.fillStyle=this.colour;af&&this.SetShadowColour(aa,af,ac);ad+=(ag/ah)-(ae/2);ab+=(Z/ah)-(Y/2);aa.drawImage(j,ad,ab,ae,Y)};J.DrawImageIE=function(aa,ae,Z){var j=this.image,af=this.sc,ad=j.width=this.w*af,Y=j.height=this.h*af,ac=(this.x*af)+ae-(ad/2),ab=(this.y*af)+Z-(Y/2);aa.setTransform(1,0,0,1,0,0);aa.globalAlpha=this.alpha;aa.drawImage(j,ac,ab)};J.Calc=function(aa,Z){var i=a(this.p3d,aa),j=this.tc,ab=j.minBrightness,Y=j.radius;this.p3d=b(i,Z);i=T(j,this.p3d,this.w,this.h,j.stretchX,j.stretchY);this.x=i.x;this.y=i.y;this.sc=(j.z1+j.z2-i.z)/j.z2;this.alpha=z(ab,W(1,ab+1-((i.z-j.z2+Y)/(2*Y))))};J.CheckActive=function(Z,ad,Y){var ae=this.tc,i=this.outline,ac=this.w,j=this.h,ab=this.x-ac/2,aa=this.y-j/2;i.Update(ab,aa,ac,j,this.sc,this.p3d,ad,Y);return i.Active(Z,ae.mx,ae.my)?i:null};J.Clicked=function(ab){var j=this.a,Y=j.target,Z=j.href,i;if(Y!=""&&Y!="_self"){if(self.frames[Y]){self.frames[Y]=Z}else{try{if(top.frames[Y]){top.frames[Y]=Z;return}}catch(aa){}window.open(Z,Y)}return}if(l.createEvent){i=l.createEvent("MouseEvents");i.initMouseEvent("click",1,1,window,0,0,0,0,0,0,0,0,0,0,null);if(!j.dispatchEvent(i)){return}}else{if(j.fireEvent){if(!j.fireEvent("onclick")){return}}}l.location=Z};function s(){var j,Y={mx:-1,my:-1,z1:20000,z2:20000,z0:0.0002,freezeActive:false,activeCursor:"pointer",pulsateTo:1,pulsateTime:3,reverse:false,depth:0.5,maxSpeed:0.05,minSpeed:0,decel:0.95,interval:20,initial:null,initialDecel:false,deadZone:0,physModel:false,maxInputZone:0,hideTags:true,minBrightness:0.1,outlineColour:"#ffff99",outlineThickness:2,outlineOffset:5,outlineMethod:"outline",textColour:"#ff99ff",textHeight:15,textFont:"Helvetica, Arial, sans-serif",shadow:"#000",shadowBlur:0,shadowOffset:[0,0],zoom:1,weight:false,weightMode:"size",weightFrom:null,weightSize:1,weightGradient:{0:"#f00",0.33:"#ff0",0.66:"#0f0",1:"#00f"},txtOpt:true,txtScale:2,frontSelect:false,wheelZoom:true,zoomMin:0.3,zoomMax:3,zoomStep:0.05,shape:"sphere",lock:null,tooltip:null,tooltipDelay:300,tooltipClass:"tctooltip",radiusX:1,radiusY:1,radiusZ:1,stretchX:1,stretchY:1,shuffleTags:false,noSelect:false,noMouse:false,imageScale:1};for(j in Y){this[j]=Y[j]}this.max_weight=0;this.min_weight=200}d=s.prototype;d.Draw=function(){var ah=this.canvas,af=ah.width,Y=ah.height,j=0,ae=this.yaw,Z=this.pitch,aa=af/2,ak=Y/2,ai=this.ctxt,ac,aj,ag,ad=-1,am=this.taglist,ab=am.length,al=this.frontSelect;if(ae==0&&Z==0&&this.drawn&&!this.zoneActive){return this.Animate(af,Y)}ai.setTransform(1,0,0,1,0,0);this.active=null;for(ag=0;ag<ab;++ag){am[ag].Calc(ae,Z)}am=am.sort(function(an,i){return an.sc-i.sc});for(ag=0;ag<ab;++ag){aj=am[ag].CheckActive(ai,aa,ak);aj=this.mx>=0&&this.my>=0&&am[ag].CheckActive(ai,aa,ak);if(aj&&aj.sc>j&&(!al||aj.z<=0)){ac=aj;ac.index=ad=ag;j=aj.sc}}this.active=ac;if(!this.txtOpt&&this.shadow){ai.shadowBlur=this.shadowBlur;ai.shadowOffsetX=this.shadowOffset[0];ai.shadowOffsetY=this.shadowOffset[1]}ai.clearRect(0,0,af,Y);for(ag=0;ag<ab;++ag){if(!(ad==ag&&ac.PreDraw(ai,am[ag],aa,ak))){am[ag].Draw(ai,aa,ak)}ad==ag&&ac.PostDraw(ai)}if(this.freezeActive&&ac){this.yaw=this.pitch=this.drawn=0}else{this.Animate(af,Y);this.drawn=(ab==this.listLength)}ac&&ac.LastDraw(ai);ah.style.cursor=ac?this.activeCursor:"";this.Tooltip(ac,am[ad])};d.TooltipNone=function(){};d.TooltipNative=function(j,i){this.canvas.title=j&&i.title?i.title:""};d.TooltipDiv=function(Z,j){var i=this,Y=i.ttdiv.style;if(Z&&j.title){i.ttdiv.innerHTML=j.title;if(Y.display=="none"&&!i.tttimer){i.tttimer=setTimeout(function(){var aa=I(i.canvas).offset();Y.display="block";Y.left=aa.left+i.mx+"px";Y.top=aa.top+i.my+24+"px";i.tttimer=null},i.tooltipDelay)}}else{Y.display="none"}};d.Animate=function(ae,aw){var Z=this;if(Z.physModel){var ac=Z.mx,aa=Z.my,aq=ae-1,ax=aw-1,ai=Z.stretchX,av=Z.stretchY;var aj=Z.reverse?-1:1,au=Z.lock,al=Z.maxInputZone,i=Z.z0;var aA=1-Z.decel,az=Z.deadZone,at=Z.maxSpeed*aA,ar=Z.minSpeed*aA;var aC=Z.pitch,aB=Z.yaw,ae=M(aC*aC+aB*aB),ao,aD,ad;var Y,j,ag,am,ak,af;this.zoneActive=false;if(ac>=0&&aa>=0&&ac<=aq&&aa<=ax){Y=-aj*(2*aa/ax-1)*z(ax/aq,1)/av;j=aj*(2*ac/aq-1)*z(aq/ax,1)/ai;if(G(Y)<=1+al&&G(j)<=1+al){Y=(au!="y")?Y:0;j=(au!="x")?j:0;ag=M(Y*Y+j*j);if(ag<=az||az>=1-i){this.initial=null;this.zoneActive=true;Y=0,j=0,ag=0;am=0,ak=0,af=0}else{if(ag<=1){this.initial=null;this.zoneActive=true;Y=Y/ag*(ag-az)/(1-az),j=j/ag*(ag-az)/(1-az),ag=(ag-az)/(1-az);am=0,ak=0,af=0}else{if(ag<=1+al){this.initial=null;this.zoneActive=true;Y=Y/ag,j=j/ag,ag=1;am=0,ak=0,af=0}}}}}if(!this.zoneActive){Y=0,j=0,ag=0;if(ae>=i){am=aC/ae,ak=aB/ae,af=1}else{af=2*Math.PI*Math.random();if(au=="x"){am=0,ak=af<Math.PI?1:-1,af=1}else{if(au=="y"){am=af<Math.PI?1:-1,ak=0,af=1}else{am=h(af),ak=r(af),af=1}}}}if(!Z.initial||Z.initialDecel){ao=aC-aA*aC+at*Y+ar*am;aD=aB-aA*aB+at*j+ar*ak;ad=M(ao*ao+aD*aD);if(ad<i){ao=0,aD=0,ad=0}this.pitch=ao;this.yaw=aD}}else{var ac=Z.mx,aa=Z.my,au=Z.lock,ah,ab,an,aj;Z.zoneActive=false;if(ac>=0&&aa>=0&&ac<ae&&aa<aw){Z.zoneActive=true;ah=Z.maxSpeed,aj=Z.reverse?-1:1,dz=Z.deadZone;if(au!="x"){this.yaw=aj*ah/z(1-dz,0.000001)*(z(2*ac/ae-1-dz,0)+W(2*ac/ae-1+dz,0))}if(au!="y"){this.pitch=-aj*ah/z(1-dz,0.000001)*(z(2*aa/aw-1-dz,0)+W(2*aa/aw-1+dz,0))}this.initial=null}else{if(!Z.initial||Z.initialDecel){ah=Z.minSpeed,ab=G(Z.yaw),an=G(Z.pitch);if(au!="x"&&ab>ah){this.yaw=ab>Z.z0?Z.yaw*Z.decel:0}if(au!="y"&&an>ah){this.pitch=an>Z.z0?Z.pitch*Z.decel:0}}}}};d.Zoom=function(i){this.z2=this.z1*(1/i);this.drawn=0};d.Clicked=function(Z){var Y=this.taglist,i=this.active;try{if(i&&Y[i.index]){Y[i.index].Clicked(Z)}}catch(j){}};d.Wheel=function(j){var Y=this.zoom+this.zoomStep*(j?1:-1);this.zoom=W(this.zoomMax,z(this.zoomMin,Y));this.Zoom(this.zoom)};s.tc={};jQuery.fn.tagcanvas=function(Y,j){var i,Z=j?jQuery("#"+j):this;if(l.all&&!j){return false}i=Z.find("a");if(O(window.G_vmlCanvasManager)){this.each(function(){I(this)[0]=window.G_vmlCanvasManager.initElement(I(this)[0])});Y.ie=parseFloat(navigator.appVersion.split("MSIE")[1])}if(!i.length||!this[0].getContext||!this[0].getContext("2d").fillText){return false}this.each(function(){var ac,aa,ae,ah,ai,ad,ag,af=[],ab={sphere:n,vcylinder:w,hcylinder:F};j||(i=I(this).find("a"));ad=new s;for(ac in Y){ad[ac]=Y[ac]}ad.z1=(19800/(Math.exp(ad.depth)*(1-1/Math.E)))+20000-19800/(1-(1/Math.E));ad.z2=ad.z1*(1/ad.zoom);ad.radius=(this.height>this.width?this.width:this.height)*0.33*(ad.z2+ad.z1)/(ad.z1);ad.yaw=ad.initial&&(ad.lock!="x")?ad.initial[0]*ad.maxSpeed:0;ad.pitch=ad.initial&&(ad.lock!="y")?ad.initial[1]*ad.maxSpeed:0;ad.canvas=I(this)[0];ad.ctxt=ad.canvas.getContext("2d");ad.textFont=ad.textFont&&t(ad.textFont);ad.deadZone*=1;ad.minSpeed*=1;ad.decel*=1;ad.maxInputZone*=1;ad.pulsateTo*=1;ad.textHeight*=1;ad.minBrightness*=1;ad.ctxt.textBaseline="top";if(ad.shadowBlur||ad.shadowOffset[0]||ad.shadowOffset[1]){ad.ctxt.shadowColor=ad.shadow;ad.shadow=ad.ctxt.shadowColor;ad.shadowAlpha=v()}else{delete ad.shadow}ad.taglist=[];ad.shape=ab[ad.shape]||ab.sphere;aa=ad.shape(i.length,ad.radiusX,ad.radiusY,ad.radiusZ);ad.shuffleTags&&H(aa);ad.listLength=i.length;for(ac=0;ac<i.length;++ac){ae=i[ac].getElementsByTagName("img");if(ae.length){ah=new Image;ah.src=ae[0].src;ai=new E(ad,ah,i[ac],aa[ac],1,1);P(ah,ae[0],ai,ad)}else{ad.taglist.push(new E(ad,i[ac].innerText||i[ac].textContent,i[ac],aa[ac],2,ad.textHeight+2,ad.textColour||N(i[ac],"color"),ad.textFont||t(N(i[ac],"font-family"))))}if(ad.weight){ag=x(ad,i[ac]);if(ag>ad.max_weight){ad.max_weight=ag}if(ag<ad.min_weight){ad.min_weight=ag}af.push(ag)}}if(ad.weight=(ad.max_weight>ad.min_weight)){for(ac=0;ac<ad.taglist.length;++ac){ad.taglist[ac].SetWeight(af[ac])}}s.tc[I(this)[0].id]=ad;ad.Tooltip=(ad.tooltip=="native"?ad.TooltipNative:(ad.tooltip?ad.TooltipDiv:ad.TooltipNone));if(ad.tooltip){if(ad.tooltip=="native"){ad.Tooltip=ad.TooltipNative}else{ad.Tooltip=ad.TooltipDiv;if(!ad.ttdiv){ad.ttdiv=l.createElement("div");ad.ttdiv.className=ad.tooltipClass;ad.ttdiv.style.position="absolute";ad.ttdiv.style.zIndex=ad.canvas.style.zIndex+1;A("mouseover",function(aj){aj.target.style.display="none"},ad.ttdiv);l.body.appendChild(ad.ttdiv)}}}else{ad.Tooltip=ad.TooltipNone}if(!ad.noMouse&&!c[I(this)[0].id]){A("mousemove",L,this);A("mouseout",k,this);A("mouseup",q,this);if(ad.wheelZoom){A("mousewheel",U,this);A("DOMMouseScroll",U,this)}c[I(this)[0].id]=1}if(j&&ad.hideTags){if(s.loaded){I(Z).hide()}else{A("load",function(){I(Z).hide()},window)}}Y.interval=Y.interval||ad.interval});return !!(s.started||(s.started=setInterval(o,Y.interval)))};A("load",function(){s.loaded=1},window)})(jQuery);