<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2013 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class transliterate_Core {
  static $UTF8_TRANSLATE = array(
    "¢" => "C", "£" => "PS", "¥" => "Y=", "§" => "SS", "©" => "(c)", "ª" => "a",
    "®" => "(r)", "°" => "deg", "²" => "2", "³" => "3", "µ" => "u", "¶" => "P",
    "¹" => "1", "º" => "o", "¼" => "1/4", "½" => "1/2", "¾" => "3/4", "À" => "A",
    "Á" => "A", "Â" => "A", "Ã" => "A", "Ä" => "A", "Å" => "A", "Æ" => "AE",
    "Ç" => "C", "È" => "E", "É" => "E", "Ê" => "E", "Ë" => "E", "Ì" => "I",
    "Í" => "I", "Î" => "I", "Ï" => "I", "Ð" => "D", "Ñ" => "N", "Ò" => "O",
    "Ó" => "O", "Ô" => "O", "Õ" => "O", "Ö" => "O", "×" => "x", "Ø" => "O",
    "Ù" => "U", "Ú" => "U", "Û" => "U", "Ü" => "U", "Ý" => "U", "Þ" => "Th",
    "ß" => "ss", "à" => "a", "á" => "a", "â" => "a", "ã" => "a", "ä" => "a",
    "å" => "a", "æ" => "ae", "ç" => "c", "è" => "e", "é" => "e", "ê" => "e",
    "ë" => "e", "ì" => "i", "í" => "i", "î" => "i", "ï" => "i", "ð" => "d",
    "ñ" => "n", "ò" => "o", "ó" => "o", "ô" => "o", "õ" => "o", "ö" => "o",
    "ø" => "o", "ù" => "u", "ú" => "u", "û" => "u", "ü" => "u", "ý" => "y",
    "þ" => "th", "ÿ" => "y", "ā" => "a", "Ă" => "A", "ă" => "a", "Ą" => "A",
    "ą" => "a", "Ć" => "C", "ć" => "c", "Ĉ" => "C", "ĉ" => "c", "Ċ" => "C",
    "ċ" => "c", "Č" => "C", "č" => "c", "Ď" => "D", "ď" => "d", "Đ" => "D",
    "đ" => "d", "Ē" => "E", "ē" => "e", "Ĕ" => "E", "ĕ" => "e", "Ė" => "E",
    "ė" => "e", "Ę" => "E", "ę" => "e", "Ě" => "E", "ě" => "e", "Ĝ" => "G",
    "ĝ" => "g", "Ğ" => "G", "ğ" => "g", "Ġ" => "G", "ġ" => "g", "Ģ" => "G",
    "ģ" => "g", "Ĥ" => "H", "ĥ" => "h", "Ħ" => "H", "ħ" => "h", "Ĩ" => "I",
    "ĩ" => "i", "Ī" => "I", "ī" => "i", "Ĭ" => "I", "ĭ" => "i", "Į" => "I",
    "į" => "i", "İ" => "I", "ı" => "i", "Ĳ" => "IJ", "Ĵ" => "J", "ĵ" => "j",
    "Ķ" => "K", "ķ" => "k", "ĸ" => "k", "Ĺ" => "L", "ĺ" => "l", "Ļ" => "L",
    "ļ" => "l", "Ľ" => "L", "ľ" => "l", "Ŀ" => "L", "ŀ" => "l", "Ł" => "L",
    "ł" => "l", "Ń" => "N", "ń" => "n", "Ņ" => "N", "ņ" => "n", "Ň" => "N",
    "ň" => "n", "ŉ" => "'n", "Ŋ" => "ng", "ŋ" => "NG", "Ō" => "O", "ō" => "o",
    "Ŏ" => "O", "ŏ" => "o", "Ő" => "O", "ő" => "o", "Œ" => "OE", "œ" => "oe",
    "Ŕ" => "R", "ŕ" => "r", "Ŗ" => "R", "ŗ" => "r", "Ř" => "R", "ř" => "r",
    "Ś" => "S", "ś" => "s", "Ŝ" => "S", "ŝ" => "s", "Ş" => "S", "ş" => "s",
    "Š" => "S", "š" => "s", "Ţ" => "T", "ţ" => "t", "Ť" => "T", "ť" => "t",
    "Ŧ" => "T", "ŧ" => "t", "Ũ" => "U", "ũ" => "u", "Ū" => "U", "ū" => "u",
    "Ŭ" => "U", "ŭ" => "u", "Ů" => "U", "ů" => "u", "Ű" => "U", "ű" => "u",
    "Ų" => "U", "ų" => "u", "Ŵ" => "W", "ŵ" => "w", "Ŷ" => "Y", "ŷ" => "y",
    "Ÿ" => "Y", "Ź" => "Z", "ź" => "z", "Ż" => "Z", "ż" => "z", "Ž" => "Z",
    "ž" => "z", "ſ" => "s", "ƀ" => "b", "Ɓ" => "B", "Ƃ" => "B", "ƃ" => "b",
    "Ƅ" => "6", "ƅ" => "6", "Ɔ" => "O", "Ƈ" => "C", "ƈ" => "c", "Ɖ" => "D",
    "Ɗ" => "D", "Ƌ" => "D", "ƌ" => "d", "ƍ" => "d", "Ǝ" => "3", "Ɛ" => "E",
    "Ƒ" => "F", "ƒ" => "f", "Ɠ" => "G", "Ɣ" => "G", "ƕ" => "hv", "Ɩ" => "I",
    "Ɨ" => "I", "Ƙ" => "K", "ƙ" => "k", "ƚ" => "l", "ƛ" => "l", "Ɯ" => "W",
    "Ɲ" => "N", "ƞ" => "n", "Ɵ" => "O", "Ơ" => "O", "ơ" => "o", "Ƣ" => "OI",
    "ƣ" => "oi", "Ƥ" => "P", "ƥ" => "p", "Ʀ" => "YR", "Ƨ" => "2", "ƨ" => "2",
    "Ʃ" => "SH", "ƪ" => "sh", "ƫ" => "t", "Ƭ" => "T", "ƭ" => "t", "Ʈ" => "T",
    "Ư" => "U", "ư" => "u", "Ʊ" => "Y", "Ʋ" => "V", "Ƴ" => "Y", "ƴ" => "y",
    "Ƶ" => "Z", "ƶ" => "z", "Ʒ" => "ZH", "Ƹ" => "ZH", "ƹ" => "zh", "ƺ" => "zh",
    "ƻ" => "2", "Ƽ" => "5", "ƽ" => "5", "ƾ" => "ts", "ƿ" => "w", "Ǆ" => "DZ",
    "ǅ" => "Dz", "ǆ" => "dz", "Ǉ" => "LJ", "ǈ" => "Lj", "ǉ" => "lj", "Ǌ" => "NJ",
    "ǋ" => "Nj", "ǌ" => "nj", "Ǎ" => "A", "ǎ" => "a", "Ǐ" => "I", "ǐ" => "i",
    "Ǒ" => "O", "ǒ" => "o", "Ǔ" => "U", "ǔ" => "u", "Ǖ" => "U", "ǖ" => "u",
    "Ǘ" => "U", "ǘ" => "u", "Ǚ" => "U", "ǚ" => "u", "Ǜ" => "U", "ǜ" => "u",
    "Ǟ" => "A", "ǟ" => "a", "Ǡ" => "A", "ǡ" => "a", "Ǣ" => "AE", "ǣ" => "ae",
    "Ǥ" => "G", "ǥ" => "g", "Ǧ" => "G", "ǧ" => "g", "Ǩ" => "K", "ǩ" => "k",
    "Ǫ" => "O", "ǫ" => "o", "Ǭ" => "O", "ǭ" => "o", "Ǯ" => "ZH", "ǯ" => "zh",
    "ǰ" => "j", "Ǳ" => "DZ", "ǲ" => "D", "ǳ" => "dz", "Ǵ" => "G", "ǵ" => "g",
    "Ƕ" => "HV", "Ƿ" => "W", "Ǹ" => "N", "ǹ" => "n", "Ǻ" => "A", "ǻ" => "a",
    "Ǽ" => "AE", "ǽ" => "ae", "Ǿ" => "O", "ǿ" => "o", "ȁ" => "a", "Ȃ" => "A",
    "ȃ" => "a", "Ȅ" => "E", "ȅ" => "e", "Ȇ" => "E", "ȇ" => "e", "Ȉ" => "I",
    "ȉ" => "i", "Ȋ" => "I", "ȋ" => "i", "Ȍ" => "O", "ȍ" => "o", "Ȏ" => "O",
    "ȏ" => "o", "Ȑ" => "R", "ȑ" => "r", "Ȓ" => "R", "ȓ" => "r", "Ȕ" => "U",
    "ȕ" => "u", "Ȗ" => "U", "ȗ" => "u", "Ș" => "S", "ș" => "s", "Ț" => "T",
    "ț" => "t", "Ȝ" => "Y", "ȝ" => "y", "Ȟ" => "H", "ȟ" => "h", "Ȣ" => "OU",
    "ȣ" => "ou", "Ȥ" => "Z", "ȥ" => "z", "Ȧ" => "A", "ȧ" => "a", "Ȩ" => "E",
    "ȩ" => "e", "Ȫ" => "O", "ȫ" => "o", "Ȭ" => "O", "ȭ" => "o", "Ȯ" => "O",
    "ȯ" => "o", "Ȱ" => "O", "ȱ" => "o", "Ȳ" => "Y", "ȳ" => "y", "ɐ" => "a",
    "ɑ" => "a", "ɒ" => "a", "ɓ" => "b", "ɔ" => "o", "ɕ" => "c", "ɖ" => "d",
    "ɗ" => "d", "ɘ" => "e", "ɛ" => "e", "ɜ" => "e", "ɝ" => "e", "ɞ" => "e",
    "ɟ" => "j", "ɠ" => "g", "ɡ" => "g", "ɢ" => "g", "ɣ" => "g", "ɤ" => "u",
    "ɥ" => "Y", "ɦ" => "h", "ɧ" => "h", "ɨ" => "i", "ɩ" => "i", "ɪ" => "I",
    "ɫ" => "l", "ɬ" => "l", "ɭ" => "l", "ɮ" => "lZ", "ɯ" => "W", "ɰ" => "W",
    "ɱ" => "m", "ɲ" => "n", "ɳ" => "n", "ɴ" => "n", "ɵ" => "o", "ɶ" => "OE",
    "ɷ" => "O", "ɸ" => "F", "ɹ" => "R", "ɺ" => "R", "ɻ" => "R", "ɼ" => "R",
    "ɽ" => "r", "ɾ" => "r", "ɿ" => "R", "ʀ" => "R", "ʁ" => "R", "ʂ" => "s",
    "ʃ" => "S", "ʄ" => "j", "ʅ" => "S", "ʆ" => "S", "ʇ" => "t", "ʈ" => "t",
    "ʉ" => "U", "ʊ" => "U", "ʋ" => "v", "ʍ" => "W", "ʎ" => "Y", "ʏ" => "Y",
    "ʐ" => "z", "ʑ" => "z", "ʒ" => "Z", "ʓ" => "Z", "ʗ" => "C", "ʙ" => "B",
    "ʚ" => "E", "ʛ" => "G", "ʜ" => "H", "ʝ" => "j", "ʞ" => "k", "ʟ" => "L",
    "ʠ" => "q", "ʣ" => "dz", "ʤ" => "dZ", "ʥ" => "dz", "ʦ" => "ts", "ʧ" => "tS",
    "ʨ" => "tC", "ʩ" => "fN", "ʪ" => "ls", "ʫ" => "lz", "ʬ" => "WW", "ʰ" => "k",
    "ʱ" => "h", "ʲ" => "j", "ʳ" => "r", "ʴ" => "r", "ʵ" => "r", "ʶ" => "r",
    "ʷ" => "w", "ʸ" => "y", "˅" => "V", "ˇ" => "V", "˕" => "V", "˘" => "V",
    "˞" => "R", "˟" => "X", "ˠ" => "G", "ˡ" => "l", "ˢ" => "s", "ˣ" => "x",
    "ˬ" => "V", "Ά" => "A", "Έ" => "E", "Ή" => "E", "Ί" => "I", "Ό" => "O",
    "Ύ" => "U", "Ώ" => "O", "ΐ" => "I", "Α" => "A", "Β" => "B", "Γ" => "G",
    "Δ" => "D", "Ε" => "E", "Ζ" => "Z", "Η" => "E", "Θ" => "Th", "Ι" => "I",
    "Κ" => "K", "Λ" => "L", "Μ" => "M", "Ν" => "N", "Ξ" => "Ks", "Ο" => "O",
    "Π" => "P", "Ρ" => "R", "Σ" => "S", "Τ" => "T", "Υ" => "U", "Φ" => "Ph",
    "Χ" => "Kh", "Ψ" => "Ps", "Ω" => "O", "Ϊ" => "I", "Ϋ" => "U", "ά" => "a",
    "έ" => "e", "ή" => "e", "ί" => "i", "ΰ" => "u", "α" => "a", "β" => "b",
    "γ" => "g", "δ" => "d", "ε" => "e", "ζ" => "z", "η" => "e", "θ" => "th",
    "ι" => "i", "κ" => "k", "λ" => "l", "μ" => "m", "ν" => "n", "ξ" => "x",
    "ο" => "o", "π" => "p", "ρ" => "r", "ς" => "s", "σ" => "s", "τ" => "t",
    "υ" => "u", "φ" => "ph", "χ" => "kh", "ψ" => "ps", "ω" => "o", "ϊ" => "i",
    "ϋ" => "u", "ό" => "o", "ύ" => "u", "ώ" => "o", "ϐ" => "b", "ϑ" => "th",
    "ϒ" => "U", "ϓ" => "U", "ϔ" => "U", "ϕ" => "ph", "ϖ" => "p", "Ϛ" => "St",
    "ϛ" => "st", "Ϝ" => "W", "ϝ" => "w", "Ϟ" => "Q", "ϟ" => "q", "Ϡ" => "Sp",
    "ϡ" => "sp", "Ϣ" => "Sh", "ϣ" => "sh", "Ϥ" => "F", "ϥ" => "f", "Ϧ" => "Kh",
    "ϧ" => "kh", "Ϩ" => "H", "ϩ" => "h", "Ϫ" => "G", "ϫ" => "g", "Ϭ" => "CH",
    "ϭ" => "ch", "Ϯ" => "Ti", "ϯ" => "ti", "ϰ" => "k", "ϱ" => "r", "ϲ" => "c",
    "ϳ" => "j", "Ё" => "Io", "Ђ" => "Dj", "Ѓ" => "Gj", "Є" => "Ie", "Ѕ" => "Dz",
    "І" => "I", "Ї" => "Yi", "Ј" => "J", "Љ" => "Lj", "Њ" => "Nj", "Ћ" => "Tsh",
    "Ќ" => "Kj", "Ѝ" => "I", "Ў" => "U", "Џ" => "Dzh", "А" => "A", "Б" => "B",
    "В" => "V", "Г" => "G", "Д" => "D", "Е" => "Ie", "Ж" => "Zh", "З" => "Z",
    "И" => "I", "Й" => "I", "К" => "K", "Л" => "L", "М" => "M", "Н" => "N",
    "О" => "O", "П" => "P", "Р" => "R", "С" => "S", "Т" => "T", "У" => "U",
    "Ф" => "F", "Х" => "Kh", "Ц" => "Ts", "Ч" => "Ch", "Ш" => "Sh", "Щ" => "Shch",
    "Ы" => "Y", "Э" => "E", "Ю" => "Iu", "Я" => "Ia", "а" => "a", "б" => "b",
    "в" => "v", "г" => "gh", "д" => "d", "е" => "ie", "ж" => "zh", "з" => "z",
    "и" => "i", "й" => "i", "к" => "k", "л" => "l", "м" => "m", "н" => "n",
    "о" => "o", "п" => "p", "р" => "r", "с" => "s", "т" => "t", "у" => "u",
    "ф" => "f", "х" => "kh", "ц" => "ts", "ч" => "ch", "ш" => "sh", "щ" => "shch",
    "ы" => "y", "э" => "e", "ю" => "iu", "я" => "ia", "ѐ" => "ie", "ё" => "io",
    "ђ" => "dj", "ѓ" => "gj", "є" => "ie", "ѕ" => "dz", "і" => "i", "ї" => "yi",
    "ј" => "j", "љ" => "lj", "њ" => "nj", "ћ" => "tsh", "ќ" => "kj", "ѝ" => "i",
    "ў" => "u", "џ" => "dzh", "Ѡ" => "O", "ѡ" => "o", "Ѣ" => "E", "ѣ" => "e",
    "Ѥ" => "Ie", "ѥ" => "ie", "Ѧ" => "E", "ѧ" => "e", "Ѩ" => "Ie", "ѩ" => "ie",
    "Ѫ" => "O", "ѫ" => "o", "Ѭ" => "Io", "ѭ" => "io", "Ѯ" => "Ks", "ѯ" => "ks",
    "Ѱ" => "Ps", "ѱ" => "ps", "Ѳ" => "F", "ѳ" => "f", "Ѵ" => "Y", "ѵ" => "y",
    "Ѷ" => "Y", "ѷ" => "y", "Ѹ" => "u", "ѹ" => "u", "Ѻ" => "O", "ѻ" => "o",
    "Ѽ" => "O", "ѽ" => "o", "Ѿ" => "Ot", "ѿ" => "ot", "Ҁ" => "Q", "ҁ" => "q",
    "҂" => "*1000*", "҈" => "*100.000*", "҉" => "*1.000.000*", "Ҏ" => "R'", "ҏ" => "r'", "Ґ" => "G'",
    "ґ" => "g'", "Ғ" => "G'", "ғ" => "g'", "Ҕ" => "G'", "ҕ" => "g'", "Җ" => "Zh'",
    "җ" => "zh'", "Ҙ" => "Z'", "ҙ" => "z'", "Қ" => "K'", "қ" => "k'", "Ҝ" => "K'",
    "ҝ" => "k'", "Ҟ" => "K'", "ҟ" => "k'", "Ҡ" => "K'", "ҡ" => "k'", "Ң" => "N'",
    "ң" => "n'", "Ҥ" => "Ng", "ҥ" => "ng", "Ҧ" => "P'", "ҧ" => "p'", "Ҩ" => "Kh",
    "ҩ" => "kh", "Ҫ" => "S'", "ҫ" => "s'", "Ҭ" => "T'", "ҭ" => "t'", "Ү" => "U",
    "ү" => "u", "Ұ" => "U'", "ұ" => "u'", "Ҳ" => "Kh'", "ҳ" => "kh'", "Ҵ" => "Tts",
    "ҵ" => "tts", "Ҷ" => "Ch'", "ҷ" => "ch'", "Ҹ" => "Ch'", "ҹ" => "ch'", "Һ" => "H",
    "һ" => "h", "Ҽ" => "Ch", "ҽ" => "ch", "Ҿ" => "Ch'", "ҿ" => "ch'", "Ӂ" => "Zh",
    "ӂ" => "zh", "Ӄ" => "K'", "ӄ" => "k'", "Ӈ" => "N'", "ӈ" => "n'", "Ӌ" => "Ch",
    "ӌ" => "ch", "Ӑ" => "a", "ӑ" => "a", "Ӓ" => "A", "ӓ" => "a", "Ӕ" => "Ae",
    "ӕ" => "ae", "Ӗ" => "Ie", "ӗ" => "ie", "Ӝ" => "Zh", "ӝ" => "zh", "Ӟ" => "Z",
    "ӟ" => "z", "Ӡ" => "Dz", "ӡ" => "dz", "Ӣ" => "I", "ӣ" => "i", "Ӥ" => "I",
    "ӥ" => "i", "Ӧ" => "O", "ӧ" => "o", "Ө" => "O", "ө" => "o", "Ӫ" => "O",
    "ӫ" => "o", "Ӭ" => "E", "ӭ" => "e", "Ӯ" => "U", "ӯ" => "u", "Ӱ" => "U",
    "ӱ" => "u", "Ӳ" => "U", "ӳ" => "u", "Ӵ" => "Ch", "ӵ" => "ch", "Ӹ" => "Y",
    "ӹ" => "y", "Ա" => "A", "Բ" => "B", "Գ" => "G", "Դ" => "D", "Ե" => "E",
    "Զ" => "Z", "Է" => "E", "Ը" => "E", "Թ" => "T`", "Ժ" => "Zh", "Ի" => "I",
    "Լ" => "L", "Խ" => "Kh", "Ծ" => "Ts", "Կ" => "K", "Հ" => "H", "Ձ" => "Dz",
    "Ղ" => "Gh", "Ճ" => "Ch", "Մ" => "M", "Յ" => "Y", "Ն" => "N", "Շ" => "Sh",
    "Ո" => "O", "Չ" => "Ch`", "Պ" => "P", "Ջ" => "J", "Ռ" => "Rh", "Ս" => "S",
    "Վ" => "V", "Տ" => "T", "Ր" => "R", "Ց" => "Ts`", "Ւ" => "W", "Փ" => "P`",
    "Ք" => "K`", "Օ" => "O", "Ֆ" => "F", "ա" => "a", "բ" => "b", "գ" => "g",
    "դ" => "d", "ե" => "e", "զ" => "z", "է" => "e", "ը" => "e", "թ" => "t`",
    "ժ" => "zh", "ի" => "i", "լ" => "l", "խ" => "kh", "ծ" => "ts", "կ" => "k",
    "հ" => "h", "ձ" => "dz", "ղ" => "gh", "ճ" => "ch", "մ" => "m", "յ" => "y",
    "ն" => "n", "շ" => "sh", "ո" => "o", "չ" => "ch`", "պ" => "p", "ջ" => "j",
    "ռ" => "rh", "ս" => "s", "վ" => "v", "տ" => "t", "ր" => "r", "ց" => "ts`",
    "ւ" => "w", "փ" => "p`", "ք" => "k`", "օ" => "o", "ֆ" => "f", "և" => "ew",
    "ֱ" => "e", "ֲ" => "a", "ֳ" => "o", "ִ" => "i", "ֵ" => "e", "ֶ" => "e",
    "ַ" => "a", "ָ" => "a", "ֹ" => "o", "ֻ" => "u", "ב" => "b", "ג" => "g",
    "ד" => "d", "ה" => "h", "ו" => "v", "ז" => "z", "ח" => "kh", "ט" => "t",
    "י" => "y", "ך" => "k", "כ" => "k", "ל" => "l", "ם" => "m", "מ" => "m",
    "ן" => "n", "נ" => "n", "ס" => "s", "ף" => "p", "פ" => "p", "ץ" => "ts",
    "צ" => "ts", "ק" => "q", "ר" => "r", "ש" => "sh", "ת" => "t", "װ" => "V",
    "ױ" => "oy", "ײ" => "i", "آ" => "a", "ؤ" => "w'", "ئ" => "y'", "ب" => "b",
    "ت" => "t", "ث" => "th", "ج" => "j", "ح" => "H", "خ" => "kh", "د" => "d",
    "ذ" => "dh", "ر" => "r", "ز" => "z", "س" => "s", "ش" => "sh", "ص" => "S",
    "ض" => "D", "ط" => "T", "ظ" => "Z", "غ" => "G", "ف" => "f", "ق" => "q",
    "ك" => "k", "ل" => "l", "م" => "m", "ن" => "n", "ه" => "h", "و" => "w",
    "ي" => "y", "ً" => "an", "ٌ" => "un", "ٍ" => "in", "َ" => "a", "ُ" => "u",
    "ِ" => "i", "ّ" => "W", "١" => "1", "٢" => "2", "٣" => "3", "٤" => "4",
    "٥" => "5", "٦" => "6", "٧" => "7", "٨" => "8", "٩" => "9", "ٶ" => "'w",
    "ٷ" => "'u", "ٸ" => "'y", "ٹ" => "tt", "ٺ" => "tth", "ٻ" => "b", "ټ" => "t",
    "ٽ" => "T", "پ" => "p", "ٿ" => "th", "ڀ" => "bh", "ځ" => "'h", "ڂ" => "H",
    "ڃ" => "ny", "ڄ" => "dy", "څ" => "H", "چ" => "ch", "ڇ" => "cch", "ڈ" => "dd",
    "ډ" => "D", "ڊ" => "D", "ڋ" => "Dt", "ڌ" => "dh", "ڍ" => "ddh", "ڎ" => "d",
    "ڏ" => "D", "ڐ" => "D", "ڑ" => "rr", "ڒ" => "R", "ړ" => "R", "ڔ" => "R",
    "ڕ" => "R", "ږ" => "R", "ڗ" => "R", "ژ" => "j", "ڙ" => "R", "ښ" => "S",
    "ڛ" => "S", "ڜ" => "S", "ڝ" => "S", "ڞ" => "S", "ڟ" => "T", "ڠ" => "GH",
    "ڡ" => "F", "ڢ" => "F", "ڣ" => "F", "ڤ" => "v", "ڥ" => "f", "ڦ" => "ph",
    "ڧ" => "Q", "ڨ" => "Q", "ک" => "kh", "ڪ" => "k", "ګ" => "K", "ڬ" => "K",
    "ڭ" => "ng", "ڮ" => "K", "گ" => "g", "ڰ" => "G", "ڱ" => "N", "ڲ" => "G",
    "ڳ" => "G", "ڴ" => "G", "ڵ" => "L", "ڶ" => "L", "ڷ" => "L", "ڸ" => "L",
    "ڹ" => "N", "ں" => "N", "ڻ" => "N", "ڼ" => "N", "ڽ" => "N", "ھ" => "h",
    "ڿ" => "Ch", "ۀ" => "hy", "ہ" => "h", "ۂ" => "H", "ۄ" => "W", "ۅ" => "oe",
    "ۆ" => "oe", "ۇ" => "u", "ۈ" => "yu", "ۉ" => "yu", "ۊ" => "W", "ۋ" => "v",
    "ی" => "y", "ۍ" => "Y", "ێ" => "Y", "ۏ" => "W", "ے" => "y", "ۓ" => "y'",
    "ە" => "ae", "۱" => "1", "۲" => "2", "۳" => "3", "۴" => "4", "۵" => "5",
    "۶" => "6", "۷" => "7", "۸" => "8", "۹" => "9", "ۺ" => "Sh", "ۻ" => "D",
    "ۼ" => "Gh", "۾" => "+m", "ܒ" => "b", "ܓ" => "g", "ܔ" => "g", "ܕ" => "d",
    "ܖ" => "d", "ܗ" => "h", "ܘ" => "w", "ܙ" => "z", "ܚ" => "H", "ܛ" => "t",
    "ܜ" => "t", "ܝ" => "y", "ܞ" => "yh", "ܟ" => "k", "ܠ" => "l", "ܡ" => "m",
    "ܢ" => "n", "ܣ" => "s", "ܤ" => "s", "ܦ" => "p", "ܧ" => "p", "ܨ" => "S",
    "ܩ" => "q", "ܪ" => "r", "ܫ" => "sh", "ܬ" => "t", "ܰ" => "a", "ܱ" => "a",
    "ܲ" => "a", "ܳ" => "A", "ܴ" => "A", "ܵ" => "A", "ܶ" => "e", "ܷ" => "e",
    "ܸ" => "e", "ܹ" => "E", "ܺ" => "i", "ܻ" => "i", "ܼ" => "u", "ܽ" => "u",
    "ܾ" => "u", "ܿ" => "o", "݅" => "X", "݆" => "Q", "ހ" => "h", "ށ" => "sh",
    "ނ" => "n", "ރ" => "r", "ބ" => "b", "ޅ" => "L", "ކ" => "k", "ވ" => "v",
    "މ" => "m", "ފ" => "f", "ދ" => "dh", "ތ" => "th", "ލ" => "l", "ގ" => "g",
    "ޏ" => "ny", "ސ" => "s", "ޑ" => "d", "ޒ" => "z", "ޓ" => "t", "ޔ" => "y",
    "ޕ" => "p", "ޖ" => "j", "ޗ" => "ch", "ޘ" => "tt", "ޙ" => "hh", "ޚ" => "kh",
    "ޛ" => "th", "ޜ" => "z", "ޝ" => "sh", "ޞ" => "s", "ޟ" => "d", "ޠ" => "t",
    "ޡ" => "z", "ޣ" => "gh", "ޤ" => "q", "ޥ" => "w", "ަ" => "a", "ާ" => "aa",
    "ި" => "i", "ީ" => "ee", "ު" => "u", "ޫ" => "oo", "ެ" => "e", "ޭ" => "ey",
    "ޮ" => "o", "ޯ" => "oa", "ँ" => "N", "ं" => "N", "ः" => "H", "अ" => "a",
    "आ" => "aa", "इ" => "i", "ई" => "ii", "उ" => "u", "ऊ" => "uu", "ऋ" => "R",
    "ऌ" => "L", "ऍ" => "eN", "ऎ" => "e", "ए" => "e", "ऐ" => "ai", "ऑ" => "oN",
    "ऒ" => "o", "ओ" => "o", "औ" => "au", "क" => "k", "ख" => "kh", "ग" => "g",
    "घ" => "gh", "ङ" => "ng", "च" => "c", "छ" => "ch", "ज" => "j", "झ" => "jh",
    "ञ" => "ny", "ट" => "tt", "ठ" => "tth", "ड" => "dd", "ढ" => "ddh", "ण" => "nn",
    "त" => "t", "थ" => "th", "द" => "d", "ध" => "dh", "न" => "n", "ऩ" => "nnn",
    "प" => "p", "फ" => "ph", "ब" => "b", "भ" => "bh", "म" => "m", "य" => "y",
    "र" => "r", "ऱ" => "rr", "ल" => "l", "ळ" => "l", "ऴ" => "lll", "व" => "v",
    "श" => "sh", "ष" => "ss", "स" => "s", "ह" => "h", "ा" => "aa", "ि" => "i",
    "ी" => "ii", "ु" => "u", "ू" => "uu", "ृ" => "R", "ॄ" => "RR", "ॅ" => "eN",
    "ॆ" => "e", "े" => "e", "ै" => "ai", "ॉ" => "oN", "ॊ" => "o", "ो" => "o",
    "ौ" => "au", "ॐ" => "AUM", "क़" => "q", "ख़" => "khh", "ग़" => "ghh", "ज़" => "z",
    "ड़" => "dddh", "ढ़" => "rh", "फ़" => "f", "य़" => "yy", "ॠ" => "RR", "ॡ" => "LL",
    "ॢ" => "L", "ॣ" => "LL", "१" => "1", "२" => "2", "३" => "3", "४" => "4",
    "५" => "5", "६" => "6", "७" => "7", "८" => "8", "९" => "9", "ঁ" => "N",
    "ং" => "N", "ঃ" => "H", "অ" => "a", "আ" => "aa", "ই" => "i", "ঈ" => "ii",
    "উ" => "u", "ঊ" => "uu", "ঋ" => "R", "ঌ" => "RR", "এ" => "e", "ঐ" => "ai",
    "ও" => "o", "ঔ" => "au", "ক" => "k", "খ" => "kh", "গ" => "g", "ঘ" => "gh",
    "ঙ" => "ng", "চ" => "c", "ছ" => "ch", "জ" => "j", "ঝ" => "jh", "ঞ" => "ny",
    "ট" => "tt", "ঠ" => "tth", "ড" => "dd", "ঢ" => "ddh", "ণ" => "nn", "ত" => "t",
    "থ" => "th", "দ" => "d", "ধ" => "dh", "ন" => "n", "প" => "p", "ফ" => "ph",
    "ব" => "b", "ভ" => "bh", "ম" => "m", "য" => "y", "র" => "r", "ল" => "l",
    "শ" => "sh", "ষ" => "ss", "স" => "s", "হ" => "h", "া" => "aa", "ি" => "i",
    "ী" => "ii", "ু" => "u", "ূ" => "uu", "ৃ" => "R", "ৄ" => "RR", "ে" => "e",
    "ৈ" => "ai", "ো" => "o", "ৌ" => "au", "ড়" => "rr", "ঢ়" => "rh", "য়" => "yy",
    "ৠ" => "RR", "ৡ" => "LL", "ৢ" => "L", "ৣ" => "LL", "১" => "1", "২" => "2",
    "৩" => "3", "৪" => "4", "৫" => "5", "৬" => "6", "৭" => "7", "৮" => "8",
    "৯" => "9", "ৰ" => "r'", "ৱ" => "r`", "৲" => "Rs", "৳" => "Rs", "৴" => "1",
    "৵" => "2", "৶" => "3", "৷" => "4", "৹" => "16", "ਂ" => "N", "ਅ" => "a",
    "ਆ" => "aa", "ਇ" => "i", "ਈ" => "ii", "ਉ" => "u", "ਊ" => "uu", "ਏ" => "ee",
    "ਐ" => "ai", "ਓ" => "oo", "ਔ" => "au", "ਕ" => "k", "ਖ" => "kh", "ਗ" => "g",
    "ਘ" => "gh", "ਙ" => "ng", "ਚ" => "c", "ਛ" => "ch", "ਜ" => "j", "ਝ" => "jh",
    "ਞ" => "ny", "ਟ" => "tt", "ਠ" => "tth", "ਡ" => "dd", "ਢ" => "ddh", "ਣ" => "nn",
    "ਤ" => "t", "ਥ" => "th", "ਦ" => "d", "ਧ" => "dh", "ਨ" => "n", "ਪ" => "p",
    "ਫ" => "ph", "ਬ" => "b", "ਭ" => "bb", "ਮ" => "m", "ਯ" => "y", "ਰ" => "r",
    "ਲ" => "l", "ਲ਼" => "ll", "ਵ" => "v", "ਸ਼" => "sh", "ਸ" => "s", "ਹ" => "h",
    "ਾ" => "aa", "ਿ" => "i", "ੀ" => "ii", "ੁ" => "u", "ੂ" => "uu", "ੇ" => "ee",
    "ੈ" => "ai", "ੋ" => "oo", "ੌ" => "au", "ਖ਼" => "khh", "ਗ਼" => "ghh", "ਜ਼" => "z",
    "ੜ" => "rr", "ਫ਼" => "f", "੧" => "1", "੨" => "2", "੩" => "3", "੪" => "4",
    "੫" => "5", "੬" => "6", "੭" => "7", "੮" => "8", "੯" => "9", "ੰ" => "N",
    "ੱ" => "H", "ੴ" => "G.E.O.", "ઁ" => "N", "ં" => "N", "ઃ" => "H", "અ" => "a",
    "આ" => "aa", "ઇ" => "i", "ઈ" => "ii", "ઉ" => "u", "ઊ" => "uu", "ઋ" => "R",
    "ઍ" => "eN", "એ" => "e", "ઐ" => "ai", "ઑ" => "oN", "ઓ" => "o", "ઔ" => "au",
    "ક" => "k", "ખ" => "kh", "ગ" => "g", "ઘ" => "gh", "ઙ" => "ng", "ચ" => "c",
    "છ" => "ch", "જ" => "j", "ઝ" => "jh", "ઞ" => "ny", "ટ" => "tt", "ઠ" => "tth",
    "ડ" => "dd", "ઢ" => "ddh", "ણ" => "nn", "ત" => "t", "થ" => "th", "દ" => "d",
    "ધ" => "dh", "ન" => "n", "પ" => "p", "ફ" => "ph", "બ" => "b", "ભ" => "bh",
    "મ" => "m", "ય" => "ya", "ર" => "r", "લ" => "l", "ળ" => "ll", "વ" => "v",
    "શ" => "sh", "ષ" => "ss", "સ" => "s", "હ" => "h", "ા" => "aa", "િ" => "i",
    "ી" => "ii", "ુ" => "u", "ૂ" => "uu", "ૃ" => "R", "ૄ" => "RR", "ૅ" => "eN",
    "ે" => "e", "ૈ" => "ai", "ૉ" => "oN", "ો" => "o", "ૌ" => "au", "ૐ" => "AUM",
    "ૠ" => "RR", "૧" => "1", "૨" => "2", "૩" => "3", "૪" => "4", "૫" => "5",
    "૬" => "6", "૭" => "7", "૮" => "8", "૯" => "9", "ଁ" => "N", "ଂ" => "N",
    "ଃ" => "H", "ଅ" => "a", "ଆ" => "aa", "ଇ" => "i", "ଈ" => "ii", "ଉ" => "u",
    "ଊ" => "uu", "ଋ" => "R", "ଌ" => "L", "ଏ" => "e", "ଐ" => "ai", "ଓ" => "o",
    "ଔ" => "au", "କ" => "k", "ଖ" => "kh", "ଗ" => "g", "ଘ" => "gh", "ଙ" => "ng",
    "ଚ" => "c", "ଛ" => "ch", "ଜ" => "j", "ଝ" => "jh", "ଞ" => "ny", "ଟ" => "tt",
    "ଠ" => "tth", "ଡ" => "dd", "ଢ" => "ddh", "ଣ" => "nn", "ତ" => "t", "ଥ" => "th",
    "ଦ" => "d", "ଧ" => "dh", "ନ" => "n", "ପ" => "p", "ଫ" => "ph", "ବ" => "b",
    "ଭ" => "bh", "ମ" => "m", "ଯ" => "y", "ର" => "r", "ଲ" => "l", "ଳ" => "ll",
    "ଶ" => "sh", "ଷ" => "ss", "ସ" => "s", "ହ" => "h", "ା" => "aa", "ି" => "i",
    "ୀ" => "ii", "ୁ" => "u", "ୂ" => "uu", "ୃ" => "R", "େ" => "e", "ୈ" => "ai",
    "ୋ" => "o", "ୌ" => "au", "ଡ଼" => "rr", "ଢ଼" => "rh", "ୟ" => "yy", "ୠ" => "RR",
    "ୡ" => "LL", "୧" => "1", "୨" => "2", "୩" => "3", "୪" => "4", "୫" => "5",
    "୬" => "6", "୭" => "7", "୮" => "8", "୯" => "9", "ஂ" => "N", "ஃ" => "H",
    "அ" => "a", "ஆ" => "aa", "இ" => "i", "ஈ" => "ii", "உ" => "u", "ஊ" => "uu",
    "எ" => "e", "ஏ" => "ee", "ஐ" => "ai", "ஒ" => "o", "ஓ" => "oo", "ஔ" => "au",
    "க" => "k", "ங" => "ng", "ச" => "c", "ஜ" => "j", "ஞ" => "ny", "ட" => "tt",
    "ண" => "nn", "த" => "t", "ந" => "n", "ன" => "nnn", "ப" => "p", "ம" => "m",
    "ய" => "y", "ர" => "r", "ற" => "rr", "ல" => "l", "ள" => "ll", "ழ" => "lll",
    "வ" => "v", "ஷ" => "ss", "ஸ" => "s", "ஹ" => "h", "ா" => "aa", "ி" => "i",
    "ீ" => "ii", "ு" => "u", "ூ" => "uu", "ெ" => "e", "ே" => "ee", "ை" => "ai",
    "ொ" => "o", "ோ" => "oo", "ௌ" => "au", "௧" => "1", "௨" => "2", "௩" => "3",
    "௪" => "4", "௫" => "5", "௬" => "6", "௭" => "7", "௮" => "8", "௯" => "9",
    "௰" => "+10+", "௱" => "+100+", "௲" => "+1000+", "ఁ" => "N", "ం" => "N", "ః" => "H",
    "అ" => "a", "ఆ" => "aa", "ఇ" => "i", "ఈ" => "ii", "ఉ" => "u", "ఊ" => "uu",
    "ఋ" => "R", "ఌ" => "L", "ఎ" => "e", "ఏ" => "ee", "ఐ" => "ai", "ఒ" => "o",
    "ఓ" => "oo", "ఔ" => "au", "క" => "k", "ఖ" => "kh", "గ" => "g", "ఘ" => "gh",
    "ఙ" => "ng", "చ" => "c", "ఛ" => "ch", "జ" => "j", "ఝ" => "jh", "ఞ" => "ny",
    "ట" => "tt", "ఠ" => "tth", "డ" => "dd", "ఢ" => "ddh", "ణ" => "nn", "త" => "t",
    "థ" => "th", "ద" => "d", "ధ" => "dh", "న" => "n", "ప" => "p", "ఫ" => "ph",
    "బ" => "b", "భ" => "bh", "మ" => "m", "య" => "y", "ర" => "r", "ఱ" => "rr",
    "ల" => "l", "ళ" => "ll", "వ" => "v", "శ" => "sh", "ష" => "ss", "స" => "s",
    "హ" => "h", "ా" => "aa", "ి" => "i", "ీ" => "ii", "ు" => "u", "ూ" => "uu",
    "ృ" => "R", "ౄ" => "RR", "ె" => "e", "ే" => "ee", "ై" => "ai", "ొ" => "o",
    "ో" => "oo", "ౌ" => "au", "ౠ" => "RR", "ౡ" => "LL", "౧" => "1", "౨" => "2",
    "౩" => "3", "౪" => "4", "౫" => "5", "౬" => "6", "౭" => "7", "౮" => "8",
    "౯" => "9", "ಂ" => "N", "ಃ" => "H", "ಅ" => "a", "ಆ" => "aa", "ಇ" => "i",
    "ಈ" => "ii", "ಉ" => "u", "ಊ" => "uu", "ಋ" => "R", "ಌ" => "L", "ಎ" => "e",
    "ಏ" => "ee", "ಐ" => "ai", "ಒ" => "o", "ಓ" => "oo", "ಔ" => "au", "ಕ" => "k",
    "ಖ" => "kh", "ಗ" => "g", "ಘ" => "gh", "ಙ" => "ng", "ಚ" => "c", "ಛ" => "ch",
    "ಜ" => "j", "ಝ" => "jh", "ಞ" => "ny", "ಟ" => "tt", "ಠ" => "tth", "ಡ" => "dd",
    "ಢ" => "ddh", "ಣ" => "nn", "ತ" => "t", "ಥ" => "th", "ದ" => "d", "ಧ" => "dh",
    "ನ" => "n", "ಪ" => "p", "ಫ" => "ph", "ಬ" => "b", "ಭ" => "bh", "ಮ" => "m",
    "ಯ" => "y", "ರ" => "r", "ಱ" => "rr", "ಲ" => "l", "ಳ" => "ll", "ವ" => "v",
    "ಶ" => "sh", "ಷ" => "ss", "ಸ" => "s", "ಹ" => "h", "ಾ" => "aa", "ಿ" => "i",
    "ೀ" => "ii", "ು" => "u", "ೂ" => "uu", "ೃ" => "R", "ೄ" => "RR", "ೆ" => "e",
    "ೇ" => "ee", "ೈ" => "ai", "ೊ" => "o", "ೋ" => "oo", "ೌ" => "au", "ೞ" => "lll",
    "ೠ" => "RR", "ೡ" => "LL", "೧" => "1", "೨" => "2", "೩" => "3", "೪" => "4",
    "೫" => "5", "೬" => "6", "೭" => "7", "೮" => "8", "೯" => "9", "ം" => "N",
    "ഃ" => "H", "അ" => "a", "ആ" => "aa", "ഇ" => "i", "ഈ" => "ii", "ഉ" => "u",
    "ഊ" => "uu", "ഋ" => "R", "ഌ" => "L", "എ" => "e", "ഏ" => "ee", "ഐ" => "ai",
    "ഒ" => "o", "ഓ" => "oo", "ഔ" => "au", "ക" => "k", "ഖ" => "kh", "ഗ" => "g",
    "ഘ" => "gh", "ങ" => "ng", "ച" => "c", "ഛ" => "ch", "ജ" => "j", "ഝ" => "jh",
    "ഞ" => "ny", "ട" => "tt", "ഠ" => "tth", "ഡ" => "dd", "ഢ" => "ddh", "ണ" => "nn",
    "ത" => "t", "ഥ" => "th", "ദ" => "d", "ധ" => "dh", "ന" => "n", "പ" => "p",
    "ഫ" => "ph", "ബ" => "b", "ഭ" => "bh", "മ" => "m", "യ" => "y", "ര" => "r",
    "റ" => "rr", "ല" => "l", "ള" => "ll", "ഴ" => "lll", "വ" => "v", "ശ" => "sh",
    "ഷ" => "ss", "സ" => "s", "ഹ" => "h", "ാ" => "aa", "ി" => "i", "ീ" => "ii",
    "ു" => "u", "ൂ" => "uu", "ൃ" => "R", "െ" => "e", "േ" => "ee", "ൈ" => "ai",
    "ൊ" => "o", "ോ" => "oo", "ൌ" => "au", "ൠ" => "RR", "ൡ" => "LL", "൧" => "1",
    "൨" => "2", "൩" => "3", "൪" => "4", "൫" => "5", "൬" => "6", "൭" => "7",
    "൮" => "8", "൯" => "9", "ං" => "N", "ඃ" => "H", "අ" => "a", "ආ" => "aa",
    "ඇ" => "ae", "ඈ" => "aae", "ඉ" => "i", "ඊ" => "ii", "උ" => "u", "ඌ" => "uu",
    "ඍ" => "R", "ඎ" => "RR", "ඏ" => "L", "ඐ" => "LL", "එ" => "e", "ඒ" => "ee",
    "ඓ" => "ai", "ඔ" => "o", "ඕ" => "oo", "ඖ" => "au", "ක" => "k", "ඛ" => "kh",
    "ග" => "g", "ඝ" => "gh", "ඞ" => "ng", "ඟ" => "nng", "ච" => "c", "ඡ" => "ch",
    "ජ" => "j", "ඣ" => "jh", "ඤ" => "ny", "ඥ" => "jny", "ඦ" => "nyj", "ට" => "tt",
    "ඨ" => "tth", "ඩ" => "dd", "ඪ" => "ddh", "ණ" => "nn", "ඬ" => "nndd", "ත" => "t",
    "ථ" => "th", "ද" => "d", "ධ" => "dh", "න" => "n", "ඳ" => "nd", "ප" => "p",
    "ඵ" => "ph", "බ" => "b", "භ" => "bh", "ම" => "m", "ඹ" => "mb", "ය" => "y",
    "ර" => "r", "ල" => "l", "ව" => "v", "ශ" => "sh", "ෂ" => "ss", "ස" => "s",
    "හ" => "h", "ළ" => "ll", "ෆ" => "f", "ා" => "aa", "ැ" => "ae", "ෑ" => "aae",
    "ි" => "i", "ී" => "ii", "ු" => "u", "ූ" => "uu", "ෘ" => "R", "ෙ" => "e",
    "ේ" => "ee", "ෛ" => "ai", "ො" => "o", "ෝ" => "oo", "ෞ" => "au", "ෟ" => "L",
    "ෲ" => "RR", "ෳ" => "LL", "ก" => "k", "ข" => "kh", "ฃ" => "kh", "ค" => "kh",
    "ฅ" => "kh", "ฆ" => "kh", "ง" => "ng", "จ" => "cch", "ฉ" => "ch", "ช" => "ch",
    "ซ" => "ch", "ฌ" => "ch", "ญ" => "y", "ฎ" => "d", "ฏ" => "t", "ฐ" => "th",
    "ฑ" => "th", "ฒ" => "th", "ณ" => "n", "ด" => "d", "ต" => "t", "ถ" => "th",
    "ท" => "th", "ธ" => "th", "น" => "n", "บ" => "b", "ป" => "p", "ผ" => "ph",
    "ฝ" => "f", "พ" => "ph", "ฟ" => "f", "ภ" => "ph", "ม" => "m", "ย" => "y",
    "ร" => "r", "ฤ" => "R", "ล" => "l", "ฦ" => "L", "ว" => "w", "ศ" => "s",
    "ษ" => "s", "ส" => "s", "ห" => "h", "ฬ" => "l", "ฮ" => "h", "ะ" => "a",
    "ั" => "a", "า" => "aa", "ำ" => "am", "ิ" => "i", "ี" => "ii", "ึ" => "ue",
    "ื" => "uue", "ุ" => "u", "ู" => "uu", "฿" => "Bh.", "เ" => "e", "แ" => "ae",
    "โ" => "o", "ใ" => "ai", "ไ" => "ai", "ๅ" => "ao", "ํ" => "M", "๑" => "1",
    "๒" => "2", "๓" => "3", "๔" => "4", "๕" => "5", "๖" => "6", "๗" => "7",
    "๘" => "8", "๙" => "9", "ກ" => "k", "ຂ" => "kh", "ຄ" => "kh", "ງ" => "ng",
    "ຈ" => "ch", "ຊ" => "s", "ຍ" => "ny", "ດ" => "d", "ຕ" => "h", "ຖ" => "th",
    "ທ" => "th", "ນ" => "n", "ບ" => "b", "ປ" => "p", "ຜ" => "ph", "ຝ" => "f",
    "ພ" => "ph", "ຟ" => "f", "ມ" => "m", "ຢ" => "y", "ຣ" => "r", "ລ" => "l",
    "ວ" => "w", "ສ" => "s", "ຫ" => "h", "ະ" => "a", "າ" => "aa", "ຳ" => "am",
    "ິ" => "i", "ີ" => "ii", "ຶ" => "y", "ື" => "yy", "ຸ" => "u", "ູ" => "uu",
    "ົ" => "o", "ຼ" => "l", "ຽ" => "ny", "ເ" => "e", "ແ" => "ei", "ໂ" => "o",
    "ໃ" => "ay", "ໄ" => "ai", "ໍ" => "M", "໑" => "1", "໒" => "2", "໓" => "3",
    "໔" => "4", "໕" => "5", "໖" => "6", "໗" => "7", "໘" => "8", "໙" => "9",
    "ໜ" => "hn", "ໝ" => "hm", "༑" => "X", "༒" => "XX", "༓" => "X", "༡" => "1",
    "༢" => "2", "༣" => "3", "༤" => "4", "༥" => "5", "༦" => "6", "༧" => "7",
    "༨" => "8", "༩" => "9", "༪" => ".5", "༫" => "1.5", "༬" => "2.5", "༭" => "3.5",
    "༮" => "4.5", "༯" => "5.5", "༰" => "6.5", "༱" => "7.5", "༲" => "8.5", "༳" => "-.5",
    "ཀ" => "k", "ཁ" => "kh", "ག" => "g", "གྷ" => "gh", "ང" => "ng", "ཅ" => "c",
    "ཆ" => "ch", "ཇ" => "j", "ཉ" => "ny", "ཊ" => "tt", "ཋ" => "tth", "ཌ" => "dd",
    "ཌྷ" => "ddh", "ཎ" => "nn", "ཏ" => "t", "ཐ" => "th", "ད" => "d", "དྷ" => "dh",
    "ན" => "n", "པ" => "p", "ཕ" => "ph", "བ" => "b", "བྷ" => "bh", "མ" => "m",
    "ཙ" => "ts", "ཚ" => "tsh", "ཛ" => "dz", "ཛྷ" => "dzh", "ཝ" => "w", "ཞ" => "zh",
    "ཟ" => "z", "ཡ" => "y", "ར" => "r", "ལ" => "l", "ཤ" => "sh", "ཥ" => "ssh",
    "ས" => "s", "ཧ" => "h", "ཨ" => "a", "ཀྵ" => "kss", "ཪ" => "r", "ཱ" => "aa",
    "ི" => "i", "ཱི" => "ii", "ུ" => "u", "ཱུ" => "uu", "ྲྀ" => "R", "ཷ" => "RR",
    "ླྀ" => "L", "ཹ" => "LL", "ེ" => "e", "ཻ" => "ee", "ོ" => "o", "ཽ" => "oo",
    "ཾ" => "M", "ཿ" => "H", "ྀ" => "i", "ཱྀ" => "ii", "ྐ" => "k", "ྑ" => "kh",
    "ྒ" => "g", "ྒྷ" => "gh", "ྔ" => "ng", "ྕ" => "c", "ྖ" => "ch", "ྗ" => "j",
    "ྙ" => "ny", "ྚ" => "tt", "ྛ" => "tth", "ྜ" => "dd", "ྜྷ" => "ddh", "ྞ" => "nn",
    "ྟ" => "t", "ྠ" => "th", "ྡ" => "d", "ྡྷ" => "dh", "ྣ" => "n", "ྤ" => "p",
    "ྥ" => "ph", "ྦ" => "b", "ྦྷ" => "bh", "ྨ" => "m", "ྩ" => "ts", "ྪ" => "tsh",
    "ྫ" => "dz", "ྫྷ" => "dzh", "ྭ" => "w", "ྮ" => "zh", "ྯ" => "z", "ྱ" => "y",
    "ྲ" => "r", "ླ" => "l", "ྴ" => "sh", "ྵ" => "ss", "ྶ" => "s", "ྷ" => "h",
    "ྸ" => "a", "ྐྵ" => "kss", "ྺ" => "w", "ྻ" => "y", "ྼ" => "r", "྾" => "X",
    "྿" => ":X:", "࿀" => "O", "࿁" => "o", "࿂" => "o", "࿃" => "(O)", "ခ" => "kh",
    "ဂ" => "g", "ဃ" => "gh", "င" => "ng", "စ" => "c", "ဆ" => "ch", "ဇ" => "j",
    "ဈ" => "jh", "ဉ" => "ny", "ည" => "nny", "ဋ" => "tt", "ဌ" => "tth", "ဍ" => "dd",
    "ဎ" => "ddh", "ဏ" => "nn", "တ" => "tt", "ထ" => "th", "ဒ" => "d", "ဓ" => "dh",
    "န" => "n", "ပ" => "p", "ဖ" => "ph", "ဗ" => "b", "ဘ" => "bh", "မ" => "m",
    "ယ" => "y", "ရ" => "r", "လ" => "l", "ဝ" => "w", "သ" => "s", "ဟ" => "h",
    "ဠ" => "ll", "အ" => "a", "ဣ" => "i", "ဤ" => "ii", "ဥ" => "u", "ဦ" => "uu",
    "ဧ" => "e", "ဩ" => "o", "ဪ" => "au", "ာ" => "aa", "ိ" => "i", "ီ" => "ii",
    "ု" => "u", "ူ" => "uu", "ေ" => "e", "ဲ" => "ai", "ံ" => "N", "၁" => "1",
    "၂" => "2", "၃" => "3", "၄" => "4", "၅" => "5", "၆" => "6", "၇" => "7",
    "၈" => "8", "၉" => "9", "၌" => "n*", "၍" => "r*", "၎" => "l*", "၏" => "e*",
    "ၐ" => "sh", "ၑ" => "ss", "ၒ" => "R", "ၓ" => "RR", "ၔ" => "L", "ၕ" => "LL",
    "ၖ" => "R", "ၗ" => "RR", "ၘ" => "L", "ၙ" => "LL", "Ⴀ" => "A", "Ⴁ" => "B",
    "Ⴂ" => "G", "Ⴃ" => "D", "Ⴄ" => "E", "Ⴅ" => "V", "Ⴆ" => "Z", "Ⴇ" => "T`",
    "Ⴈ" => "I", "Ⴉ" => "K", "Ⴊ" => "L", "Ⴋ" => "M", "Ⴌ" => "N", "Ⴍ" => "O",
    "Ⴎ" => "P", "Ⴏ" => "Zh", "Ⴐ" => "R", "Ⴑ" => "S", "Ⴒ" => "T", "Ⴓ" => "U",
    "Ⴔ" => "P`", "Ⴕ" => "K`", "Ⴖ" => "G'", "Ⴗ" => "Q", "Ⴘ" => "Sh", "Ⴙ" => "Ch`",
    "Ⴚ" => "C`", "Ⴛ" => "Z'", "Ⴜ" => "C", "Ⴝ" => "Ch", "Ⴞ" => "X", "Ⴟ" => "J",
    "Ⴠ" => "H", "Ⴡ" => "E", "Ⴢ" => "Y", "Ⴣ" => "W", "Ⴤ" => "Xh", "Ⴥ" => "OE",
    "ა" => "a", "ბ" => "b", "გ" => "g", "დ" => "d", "ე" => "e", "ვ" => "v",
    "ზ" => "z", "თ" => "t`", "ი" => "i", "კ" => "k", "ლ" => "l", "მ" => "m",
    "ნ" => "n", "ო" => "o", "პ" => "p", "ჟ" => "zh", "რ" => "r", "ს" => "s",
    "ტ" => "t", "უ" => "u", "ფ" => "p`", "ქ" => "k`", "ღ" => "g'", "ყ" => "q",
    "შ" => "sh", "ჩ" => "ch`", "ც" => "c`", "ძ" => "z'", "წ" => "c", "ჭ" => "ch",
    "ხ" => "x", "ჯ" => "j", "ჰ" => "h", "ჱ" => "e", "ჲ" => "y", "ჳ" => "w",
    "ჴ" => "xh", "ჵ" => "oe", "ჶ" => "f", "ᄁ" => "gg", "ᄂ" => "n", "ᄃ" => "d",
    "ᄄ" => "dd", "ᄅ" => "r", "ᄆ" => "m", "ᄇ" => "b", "ᄈ" => "bb", "ᄉ" => "s",
    "ᄊ" => "ss", "ᄌ" => "j", "ᄍ" => "jj", "ᄎ" => "c", "ᄏ" => "k", "ᄐ" => "t",
    "ᄑ" => "p", "ᄒ" => "h", "ᄓ" => "ng", "ᄔ" => "nn", "ᄕ" => "nd", "ᄖ" => "nb",
    "ᄗ" => "dg", "ᄘ" => "rn", "ᄙ" => "rr", "ᄚ" => "rh", "ᄛ" => "rN", "ᄜ" => "mb",
    "ᄝ" => "mN", "ᄞ" => "bg", "ᄟ" => "bn", "ᄡ" => "bs", "ᄢ" => "bsg", "ᄣ" => "bst",
    "ᄤ" => "bsb", "ᄥ" => "bss", "ᄦ" => "bsj", "ᄧ" => "bj", "ᄨ" => "bc", "ᄩ" => "bt",
    "ᄪ" => "bp", "ᄫ" => "bN", "ᄬ" => "bbN", "ᄭ" => "sg", "ᄮ" => "sn", "ᄯ" => "sd",
    "ᄰ" => "sr", "ᄱ" => "sm", "ᄲ" => "sb", "ᄳ" => "sbg", "ᄴ" => "sss", "ᄵ" => "s",
    "ᄶ" => "sj", "ᄷ" => "sc", "ᄸ" => "sk", "ᄹ" => "st", "ᄺ" => "sp", "ᄻ" => "sh",
    "ᅀ" => "Z", "ᅁ" => "g", "ᅂ" => "d", "ᅃ" => "m", "ᅄ" => "b", "ᅅ" => "s",
    "ᅆ" => "Z", "ᅈ" => "j", "ᅉ" => "c", "ᅊ" => "t", "ᅋ" => "p", "ᅌ" => "N",
    "ᅍ" => "j", "ᅒ" => "ck", "ᅓ" => "ch", "ᅖ" => "pb", "ᅗ" => "pN", "ᅘ" => "hh",
    "ᅙ" => "Q", "ᅡ" => "a", "ᅢ" => "ae", "ᅣ" => "ya", "ᅤ" => "yae", "ᅥ" => "eo",
    "ᅦ" => "e", "ᅧ" => "yeo", "ᅨ" => "ye", "ᅩ" => "o", "ᅪ" => "wa", "ᅫ" => "wae",
    "ᅬ" => "oe", "ᅭ" => "yo", "ᅮ" => "u", "ᅯ" => "weo", "ᅰ" => "we", "ᅱ" => "wi",
    "ᅲ" => "yu", "ᅳ" => "eu", "ᅴ" => "yi", "ᅵ" => "i", "ᅶ" => "a-o", "ᅷ" => "a-u",
    "ᅸ" => "ya-o", "ᅹ" => "ya-yo", "ᅺ" => "eo-o", "ᅻ" => "eo-u", "ᅼ" => "eo-eu", "ᅽ" => "yeo-o",
    "ᅾ" => "yeo-u", "ᅿ" => "o-eo", "ᆀ" => "o-e", "ᆁ" => "o-ye", "ᆂ" => "o-o", "ᆃ" => "o-u",
    "ᆄ" => "yo-ya", "ᆅ" => "yo-yae", "ᆆ" => "yo-yeo", "ᆇ" => "yo-o", "ᆈ" => "yo-i", "ᆉ" => "u-a",
    "ᆊ" => "u-ae", "ᆋ" => "u-eo-eu", "ᆌ" => "u-ye", "ᆍ" => "u-u", "ᆎ" => "yu-a", "ᆏ" => "yu-eo",
    "ᆐ" => "yu-e", "ᆑ" => "yu-yeo", "ᆒ" => "yu-ye", "ᆓ" => "yu-u", "ᆔ" => "yu-i", "ᆕ" => "eu-u",
    "ᆖ" => "eu-eu", "ᆗ" => "yi-u", "ᆘ" => "i-a", "ᆙ" => "i-ya", "ᆚ" => "i-o", "ᆛ" => "i-u",
    "ᆜ" => "i-eu", "ᆝ" => "i-U", "ᆞ" => "U", "ᆟ" => "U-eo", "ᆠ" => "U-u", "ᆡ" => "U-i",
    "ᆢ" => "UU", "ᆨ" => "g", "ᆩ" => "gg", "ᆪ" => "gs", "ᆫ" => "n", "ᆬ" => "nj",
    "ᆭ" => "nh", "ᆮ" => "d", "ᆯ" => "l", "ᆰ" => "lg", "ᆱ" => "lm", "ᆲ" => "lb",
    "ᆳ" => "ls", "ᆴ" => "lt", "ᆵ" => "lp", "ᆶ" => "lh", "ᆷ" => "m", "ᆸ" => "b",
    "ᆹ" => "bs", "ᆺ" => "s", "ᆻ" => "ss", "ᆼ" => "ng", "ᆽ" => "j", "ᆾ" => "c",
    "ᆿ" => "k", "ᇀ" => "t", "ᇁ" => "p", "ᇂ" => "h", "ᇃ" => "gl", "ᇄ" => "gsg",
    "ᇅ" => "ng", "ᇆ" => "nd", "ᇇ" => "ns", "ᇈ" => "nZ", "ᇉ" => "nt", "ᇊ" => "dg",
    "ᇋ" => "tl", "ᇌ" => "lgs", "ᇍ" => "ln", "ᇎ" => "ld", "ᇏ" => "lth", "ᇐ" => "ll",
    "ᇑ" => "lmg", "ᇒ" => "lms", "ᇓ" => "lbs", "ᇔ" => "lbh", "ᇕ" => "rNp", "ᇖ" => "lss",
    "ᇗ" => "lZ", "ᇘ" => "lk", "ᇙ" => "lQ", "ᇚ" => "mg", "ᇛ" => "ml", "ᇜ" => "mb",
    "ᇝ" => "ms", "ᇞ" => "mss", "ᇟ" => "mZ", "ᇠ" => "mc", "ᇡ" => "mh", "ᇢ" => "mN",
    "ᇣ" => "bl", "ᇤ" => "bp", "ᇥ" => "ph", "ᇦ" => "pN", "ᇧ" => "sg", "ᇨ" => "sd",
    "ᇩ" => "sl", "ᇪ" => "sb", "ᇫ" => "Z", "ᇬ" => "g", "ᇭ" => "ss", "ᇯ" => "kh",
    "ᇰ" => "N", "ᇱ" => "Ns", "ᇲ" => "NZ", "ᇳ" => "pb", "ᇴ" => "pN", "ᇵ" => "hn",
    "ᇶ" => "hl", "ᇷ" => "hm", "ᇸ" => "hb", "ᇹ" => "Q", "ሁ" => "hu", "ሂ" => "hi",
    "ሃ" => "haa", "ሄ" => "hee", "ህ" => "he", "ሆ" => "ho", "ለ" => "la", "ሉ" => "lu",
    "ሊ" => "li", "ላ" => "laa", "ሌ" => "lee", "ል" => "le", "ሎ" => "lo", "ሏ" => "lwa",
    "ሐ" => "hha", "ሑ" => "hhu", "ሒ" => "hhi", "ሓ" => "hhaa", "ሔ" => "hhee", "ሕ" => "hhe",
    "ሖ" => "hho", "ሗ" => "hhwa", "መ" => "ma", "ሙ" => "mu", "ሚ" => "mi", "ማ" => "maa",
    "ሜ" => "mee", "ም" => "me", "ሞ" => "mo", "ሟ" => "mwa", "ሠ" => "sza", "ሡ" => "szu",
    "ሢ" => "szi", "ሣ" => "szaa", "ሤ" => "szee", "ሥ" => "sze", "ሦ" => "szo", "ሧ" => "szwa",
    "ረ" => "ra", "ሩ" => "ru", "ሪ" => "ri", "ራ" => "raa", "ሬ" => "ree", "ር" => "re",
    "ሮ" => "ro", "ሯ" => "rwa", "ሰ" => "sa", "ሱ" => "su", "ሲ" => "si", "ሳ" => "saa",
    "ሴ" => "see", "ስ" => "se", "ሶ" => "so", "ሷ" => "swa", "ሸ" => "sha", "ሹ" => "shu",
    "ሺ" => "shi", "ሻ" => "shaa", "ሼ" => "shee", "ሽ" => "she", "ሾ" => "sho", "ሿ" => "shwa",
    "ቀ" => "qa", "ቁ" => "qu", "ቂ" => "qi", "ቃ" => "qaa", "ቄ" => "qee", "ቅ" => "qe",
    "ቆ" => "qo", "ቈ" => "qwa", "ቊ" => "qwi", "ቋ" => "qwaa", "ቌ" => "qwee", "ቍ" => "qwe",
    "ቐ" => "qha", "ቑ" => "qhu", "ቒ" => "qhi", "ቓ" => "qhaa", "ቔ" => "qhee", "ቕ" => "qhe",
    "ቖ" => "qho", "ቘ" => "qhwa", "ቚ" => "qhwi", "ቛ" => "qhwaa", "ቜ" => "qhwee", "ቝ" => "qhwe",
    "በ" => "ba", "ቡ" => "bu", "ቢ" => "bi", "ባ" => "baa", "ቤ" => "bee", "ብ" => "be",
    "ቦ" => "bo", "ቧ" => "bwa", "ቨ" => "va", "ቩ" => "vu", "ቪ" => "vi", "ቫ" => "vaa",
    "ቬ" => "vee", "ቭ" => "ve", "ቮ" => "vo", "ቯ" => "vwa", "ተ" => "ta", "ቱ" => "tu",
    "ቲ" => "ti", "ታ" => "taa", "ቴ" => "tee", "ት" => "te", "ቶ" => "to", "ቷ" => "twa",
    "ቸ" => "ca", "ቹ" => "cu", "ቺ" => "ci", "ቻ" => "caa", "ቼ" => "cee", "ች" => "ce",
    "ቾ" => "co", "ቿ" => "cwa", "ኀ" => "xa", "ኁ" => "xu", "ኂ" => "xi", "ኃ" => "xaa",
    "ኄ" => "xee", "ኅ" => "xe", "ኆ" => "xo", "ኈ" => "xwa", "ኊ" => "xwi", "ኋ" => "xwaa",
    "ኌ" => "xwee", "ኍ" => "xwe", "ነ" => "na", "ኑ" => "nu", "ኒ" => "ni", "ና" => "naa",
    "ኔ" => "nee", "ን" => "ne", "ኖ" => "no", "ኗ" => "nwa", "ኘ" => "nya", "ኙ" => "nyu",
    "ኚ" => "nyi", "ኛ" => "nyaa", "ኜ" => "nyee", "ኝ" => "nye", "ኞ" => "nyo", "ኟ" => "nywa",
    "አ" => "'a", "ኡ" => "'u", "ኣ" => "'aa", "ኤ" => "'ee", "እ" => "'e", "ኦ" => "'o",
    "ኧ" => "'wa", "ከ" => "ka", "ኩ" => "ku", "ኪ" => "ki", "ካ" => "kaa", "ኬ" => "kee",
    "ክ" => "ke", "ኮ" => "ko", "ኰ" => "kwa", "ኲ" => "kwi", "ኳ" => "kwaa", "ኴ" => "kwee",
    "ኵ" => "kwe", "ኸ" => "kxa", "ኹ" => "kxu", "ኺ" => "kxi", "ኻ" => "kxaa", "ኼ" => "kxee",
    "ኽ" => "kxe", "ኾ" => "kxo", "ዀ" => "kxwa", "ዂ" => "kxwi", "ዃ" => "kxwaa", "ዄ" => "kxwee",
    "ዅ" => "kxwe", "ወ" => "wa", "ዉ" => "wu", "ዊ" => "wi", "ዋ" => "waa", "ዌ" => "wee",
    "ው" => "we", "ዎ" => "wo", "ዐ" => "`a", "ዑ" => "`u", "ዒ" => "`i", "ዓ" => "`aa",
    "ዔ" => "`ee", "ዕ" => "`e", "ዖ" => "`o", "ዘ" => "za", "ዙ" => "zu", "ዚ" => "zi",
    "ዛ" => "zaa", "ዜ" => "zee", "ዝ" => "ze", "ዞ" => "zo", "ዟ" => "zwa", "ዠ" => "zha",
    "ዡ" => "zhu", "ዢ" => "zhi", "ዣ" => "zhaa", "ዤ" => "zhee", "ዥ" => "zhe", "ዦ" => "zho",
    "ዧ" => "zhwa", "የ" => "ya", "ዩ" => "yu", "ዪ" => "yi", "ያ" => "yaa", "ዬ" => "yee",
    "ይ" => "ye", "ዮ" => "yo", "ደ" => "da", "ዱ" => "du", "ዲ" => "di", "ዳ" => "daa",
    "ዴ" => "dee", "ድ" => "de", "ዶ" => "do", "ዷ" => "dwa", "ዸ" => "dda", "ዹ" => "ddu",
    "ዺ" => "ddi", "ዻ" => "ddaa", "ዼ" => "ddee", "ዽ" => "dde", "ዾ" => "ddo", "ዿ" => "ddwa",
    "ጁ" => "ju", "ጂ" => "ji", "ጃ" => "jaa", "ጄ" => "jee", "ጅ" => "je", "ጆ" => "jo",
    "ጇ" => "jwa", "ገ" => "ga", "ጉ" => "gu", "ጊ" => "gi", "ጋ" => "gaa", "ጌ" => "gee",
    "ግ" => "ge", "ጎ" => "go", "ጐ" => "gwa", "ጒ" => "gwi", "ጓ" => "gwaa", "ጔ" => "gwee",
    "ጕ" => "gwe", "ጘ" => "gga", "ጙ" => "ggu", "ጚ" => "ggi", "ጛ" => "ggaa", "ጜ" => "ggee",
    "ጝ" => "gge", "ጞ" => "ggo", "ጠ" => "tha", "ጡ" => "thu", "ጢ" => "thi", "ጣ" => "thaa",
    "ጤ" => "thee", "ጥ" => "the", "ጦ" => "tho", "ጧ" => "thwa", "ጨ" => "cha", "ጩ" => "chu",
    "ጪ" => "chi", "ጫ" => "chaa", "ጬ" => "chee", "ጭ" => "che", "ጮ" => "cho", "ጯ" => "chwa",
    "ጰ" => "pha", "ጱ" => "phu", "ጲ" => "phi", "ጳ" => "phaa", "ጴ" => "phee", "ጵ" => "phe",
    "ጶ" => "pho", "ጷ" => "phwa", "ጸ" => "tsa", "ጹ" => "tsu", "ጺ" => "tsi", "ጻ" => "tsaa",
    "ጼ" => "tsee", "ጽ" => "tse", "ጾ" => "tso", "ጿ" => "tswa", "ፀ" => "tza", "ፁ" => "tzu",
    "ፂ" => "tzi", "ፃ" => "tzaa", "ፄ" => "tzee", "ፅ" => "tze", "ፆ" => "tzo", "ፈ" => "fa",
    "ፉ" => "fu", "ፊ" => "fi", "ፋ" => "faa", "ፌ" => "fee", "ፍ" => "fe", "ፎ" => "fo",
    "ፏ" => "fwa", "ፐ" => "pa", "ፑ" => "pu", "ፒ" => "pi", "ፓ" => "paa", "ፔ" => "pee",
    "ፕ" => "pe", "ፖ" => "po", "ፗ" => "pwa", "ፘ" => "rya", "ፙ" => "mya", "ፚ" => "fya",
    "፩" => "1", "፪" => "2", "፫" => "3", "፬" => "4", "፭" => "5", "፮" => "6",
    "፯" => "7", "፰" => "8", "፱" => "9", "፲" => "10+", "፳" => "20+", "፴" => "30+",
    "፵" => "40+", "፶" => "50+", "፷" => "60+", "፸" => "70+", "፹" => "80+", "፺" => "90+",
    "፻" => "100+", "፼" => "10,000+", "Ꭰ" => "a", "Ꭱ" => "e", "Ꭲ" => "i", "Ꭳ" => "o",
    "Ꭴ" => "u", "Ꭵ" => "v", "Ꭶ" => "ga", "Ꭷ" => "ka", "Ꭸ" => "ge", "Ꭹ" => "gi",
    "Ꭺ" => "go", "Ꭻ" => "gu", "Ꭼ" => "gv", "Ꭽ" => "ha", "Ꭾ" => "he", "Ꭿ" => "hi",
    "Ꮀ" => "ho", "Ꮁ" => "hu", "Ꮂ" => "hv", "Ꮃ" => "la", "Ꮄ" => "le", "Ꮅ" => "li",
    "Ꮆ" => "lo", "Ꮇ" => "lu", "Ꮈ" => "lv", "Ꮉ" => "ma", "Ꮊ" => "me", "Ꮋ" => "mi",
    "Ꮌ" => "mo", "Ꮍ" => "mu", "Ꮎ" => "na", "Ꮏ" => "hna", "Ꮐ" => "nah", "Ꮑ" => "ne",
    "Ꮒ" => "ni", "Ꮓ" => "no", "Ꮔ" => "nu", "Ꮕ" => "nv", "Ꮖ" => "qua", "Ꮗ" => "que",
    "Ꮘ" => "qui", "Ꮙ" => "quo", "Ꮚ" => "quu", "Ꮛ" => "quv", "Ꮜ" => "sa", "Ꮝ" => "s",
    "Ꮞ" => "se", "Ꮟ" => "si", "Ꮠ" => "so", "Ꮡ" => "su", "Ꮢ" => "sv", "Ꮣ" => "da",
    "Ꮤ" => "ta", "Ꮥ" => "de", "Ꮦ" => "te", "Ꮧ" => "di", "Ꮨ" => "ti", "Ꮩ" => "do",
    "Ꮪ" => "du", "Ꮫ" => "dv", "Ꮬ" => "dla", "Ꮭ" => "tla", "Ꮮ" => "tle", "Ꮯ" => "tli",
    "Ꮰ" => "tlo", "Ꮱ" => "tlu", "Ꮲ" => "tlv", "Ꮳ" => "tsa", "Ꮴ" => "tse", "Ꮵ" => "tsi",
    "Ꮶ" => "tso", "Ꮷ" => "tsu", "Ꮸ" => "tsv", "Ꮹ" => "wa", "Ꮺ" => "we", "Ꮻ" => "wi",
    "Ꮼ" => "wo", "Ꮽ" => "wu", "Ꮾ" => "wv", "Ꮿ" => "ya", "Ᏸ" => "ye", "Ᏹ" => "yi",
    "Ᏺ" => "yo", "Ᏻ" => "yu", "Ᏼ" => "yv", "ᐁ" => "e", "ᐂ" => "aai", "ᐃ" => "i",
    "ᐄ" => "ii", "ᐅ" => "o", "ᐆ" => "oo", "ᐇ" => "oo", "ᐈ" => "ee", "ᐉ" => "i",
    "ᐊ" => "a", "ᐋ" => "aa", "ᐌ" => "we", "ᐍ" => "we", "ᐎ" => "wi", "ᐏ" => "wi",
    "ᐐ" => "wii", "ᐑ" => "wii", "ᐒ" => "wo", "ᐓ" => "wo", "ᐔ" => "woo", "ᐕ" => "woo",
    "ᐖ" => "woo", "ᐗ" => "wa", "ᐘ" => "wa", "ᐙ" => "waa", "ᐚ" => "waa", "ᐛ" => "waa",
    "ᐜ" => "ai", "ᐝ" => "w", "ᐟ" => "t", "ᐠ" => "k", "ᐡ" => "sh", "ᐢ" => "s",
    "ᐣ" => "n", "ᐤ" => "w", "ᐥ" => "n", "ᐧ" => "w", "ᐨ" => "c", "ᐪ" => "l",
    "ᐫ" => "en", "ᐬ" => "in", "ᐭ" => "on", "ᐮ" => "an", "ᐯ" => "pe", "ᐰ" => "paai",
    "ᐱ" => "pi", "ᐲ" => "pii", "ᐳ" => "po", "ᐴ" => "poo", "ᐵ" => "poo", "ᐶ" => "hee",
    "ᐷ" => "hi", "ᐸ" => "pa", "ᐹ" => "paa", "ᐺ" => "pwe", "ᐻ" => "pwe", "ᐼ" => "pwi",
    "ᐽ" => "pwi", "ᐾ" => "pwii", "ᐿ" => "pwii", "ᑀ" => "pwo", "ᑁ" => "pwo", "ᑂ" => "pwoo",
    "ᑃ" => "pwoo", "ᑄ" => "pwa", "ᑅ" => "pwa", "ᑆ" => "pwaa", "ᑇ" => "pwaa", "ᑈ" => "pwaa",
    "ᑉ" => "p", "ᑊ" => "p", "ᑋ" => "h", "ᑌ" => "te", "ᑍ" => "taai", "ᑎ" => "ti",
    "ᑏ" => "tii", "ᑐ" => "to", "ᑑ" => "too", "ᑒ" => "too", "ᑓ" => "dee", "ᑔ" => "di",
    "ᑕ" => "ta", "ᑖ" => "taa", "ᑗ" => "twe", "ᑘ" => "twe", "ᑙ" => "twi", "ᑚ" => "twi",
    "ᑛ" => "twii", "ᑜ" => "twii", "ᑝ" => "two", "ᑞ" => "two", "ᑟ" => "twoo", "ᑠ" => "twoo",
    "ᑡ" => "twa", "ᑢ" => "twa", "ᑣ" => "twaa", "ᑤ" => "twaa", "ᑥ" => "twaa", "ᑦ" => "t",
    "ᑧ" => "tte", "ᑨ" => "tti", "ᑩ" => "tto", "ᑪ" => "tta", "ᑫ" => "ke", "ᑬ" => "kaai",
    "ᑭ" => "ki", "ᑮ" => "kii", "ᑯ" => "ko", "ᑰ" => "koo", "ᑱ" => "koo", "ᑲ" => "ka",
    "ᑳ" => "kaa", "ᑴ" => "kwe", "ᑵ" => "kwe", "ᑶ" => "kwi", "ᑷ" => "kwi", "ᑸ" => "kwii",
    "ᑹ" => "kwii", "ᑺ" => "kwo", "ᑻ" => "kwo", "ᑼ" => "kwoo", "ᑽ" => "kwoo", "ᑾ" => "kwa",
    "ᑿ" => "kwa", "ᒀ" => "kwaa", "ᒁ" => "kwaa", "ᒂ" => "kwaa", "ᒃ" => "k", "ᒄ" => "kw",
    "ᒅ" => "keh", "ᒆ" => "kih", "ᒇ" => "koh", "ᒈ" => "kah", "ᒉ" => "ce", "ᒊ" => "caai",
    "ᒋ" => "ci", "ᒌ" => "cii", "ᒍ" => "co", "ᒎ" => "coo", "ᒏ" => "coo", "ᒐ" => "ca",
    "ᒑ" => "caa", "ᒒ" => "cwe", "ᒓ" => "cwe", "ᒔ" => "cwi", "ᒕ" => "cwi", "ᒖ" => "cwii",
    "ᒗ" => "cwii", "ᒘ" => "cwo", "ᒙ" => "cwo", "ᒚ" => "cwoo", "ᒛ" => "cwoo", "ᒜ" => "cwa",
    "ᒝ" => "cwa", "ᒞ" => "cwaa", "ᒟ" => "cwaa", "ᒠ" => "cwaa", "ᒡ" => "c", "ᒢ" => "th",
    "ᒣ" => "me", "ᒤ" => "maai", "ᒥ" => "mi", "ᒦ" => "mii", "ᒧ" => "mo", "ᒨ" => "moo",
    "ᒩ" => "moo", "ᒪ" => "ma", "ᒫ" => "maa", "ᒬ" => "mwe", "ᒭ" => "mwe", "ᒮ" => "mwi",
    "ᒯ" => "mwi", "ᒰ" => "mwii", "ᒱ" => "mwii", "ᒲ" => "mwo", "ᒳ" => "mwo", "ᒴ" => "mwoo",
    "ᒵ" => "mwoo", "ᒶ" => "mwa", "ᒷ" => "mwa", "ᒸ" => "mwaa", "ᒹ" => "mwaa", "ᒺ" => "mwaa",
    "ᒻ" => "m", "ᒼ" => "m", "ᒽ" => "mh", "ᒾ" => "m", "ᒿ" => "m", "ᓀ" => "ne",
    "ᓁ" => "naai", "ᓂ" => "ni", "ᓃ" => "nii", "ᓄ" => "no", "ᓅ" => "noo", "ᓆ" => "noo",
    "ᓇ" => "na", "ᓈ" => "naa", "ᓉ" => "nwe", "ᓊ" => "nwe", "ᓋ" => "nwa", "ᓌ" => "nwa",
    "ᓍ" => "nwaa", "ᓎ" => "nwaa", "ᓏ" => "nwaa", "ᓐ" => "n", "ᓑ" => "ng", "ᓒ" => "nh",
    "ᓓ" => "le", "ᓔ" => "laai", "ᓕ" => "li", "ᓖ" => "lii", "ᓗ" => "lo", "ᓘ" => "loo",
    "ᓙ" => "loo", "ᓚ" => "la", "ᓛ" => "laa", "ᓜ" => "lwe", "ᓝ" => "lwe", "ᓞ" => "lwi",
    "ᓟ" => "lwi", "ᓠ" => "lwii", "ᓡ" => "lwii", "ᓢ" => "lwo", "ᓣ" => "lwo", "ᓤ" => "lwoo",
    "ᓥ" => "lwoo", "ᓦ" => "lwa", "ᓧ" => "lwa", "ᓨ" => "lwaa", "ᓩ" => "lwaa", "ᓪ" => "l",
    "ᓫ" => "l", "ᓬ" => "l", "ᓭ" => "se", "ᓮ" => "saai", "ᓯ" => "si", "ᓰ" => "sii",
    "ᓱ" => "so", "ᓲ" => "soo", "ᓳ" => "soo", "ᓴ" => "sa", "ᓵ" => "saa", "ᓶ" => "swe",
    "ᓷ" => "swe", "ᓸ" => "swi", "ᓹ" => "swi", "ᓺ" => "swii", "ᓻ" => "swii", "ᓼ" => "swo",
    "ᓽ" => "swo", "ᓾ" => "swoo", "ᓿ" => "swoo", "ᔁ" => "swa", "ᔂ" => "swaa", "ᔃ" => "swaa",
    "ᔄ" => "swaa", "ᔅ" => "s", "ᔆ" => "s", "ᔇ" => "sw", "ᔈ" => "s", "ᔉ" => "sk",
    "ᔊ" => "skw", "ᔋ" => "sW", "ᔌ" => "spwa", "ᔍ" => "stwa", "ᔎ" => "skwa", "ᔏ" => "scwa",
    "ᔐ" => "she", "ᔑ" => "shi", "ᔒ" => "shii", "ᔓ" => "sho", "ᔔ" => "shoo", "ᔕ" => "sha",
    "ᔖ" => "shaa", "ᔗ" => "shwe", "ᔘ" => "shwe", "ᔙ" => "shwi", "ᔚ" => "shwi", "ᔛ" => "shwii",
    "ᔜ" => "shwii", "ᔝ" => "shwo", "ᔞ" => "shwo", "ᔟ" => "shwoo", "ᔠ" => "shwoo", "ᔡ" => "shwa",
    "ᔢ" => "shwa", "ᔣ" => "shwaa", "ᔤ" => "shwaa", "ᔥ" => "sh", "ᔦ" => "ye", "ᔧ" => "yaai",
    "ᔨ" => "yi", "ᔩ" => "yii", "ᔪ" => "yo", "ᔫ" => "yoo", "ᔬ" => "yoo", "ᔭ" => "ya",
    "ᔮ" => "yaa", "ᔯ" => "ywe", "ᔰ" => "ywe", "ᔱ" => "ywi", "ᔲ" => "ywi", "ᔳ" => "ywii",
    "ᔴ" => "ywii", "ᔵ" => "ywo", "ᔶ" => "ywo", "ᔷ" => "ywoo", "ᔸ" => "ywoo", "ᔹ" => "ywa",
    "ᔺ" => "ywa", "ᔻ" => "ywaa", "ᔼ" => "ywaa", "ᔽ" => "ywaa", "ᔾ" => "y", "ᔿ" => "y",
    "ᕀ" => "y", "ᕁ" => "yi", "ᕂ" => "re", "ᕃ" => "re", "ᕄ" => "le", "ᕅ" => "raai",
    "ᕆ" => "ri", "ᕇ" => "rii", "ᕈ" => "ro", "ᕉ" => "roo", "ᕊ" => "lo", "ᕋ" => "ra",
    "ᕌ" => "raa", "ᕍ" => "la", "ᕎ" => "rwaa", "ᕏ" => "rwaa", "ᕐ" => "r", "ᕑ" => "r",
    "ᕒ" => "r", "ᕓ" => "fe", "ᕔ" => "faai", "ᕕ" => "fi", "ᕖ" => "fii", "ᕗ" => "fo",
    "ᕘ" => "foo", "ᕙ" => "fa", "ᕚ" => "faa", "ᕛ" => "fwaa", "ᕜ" => "fwaa", "ᕝ" => "f",
    "ᕞ" => "the", "ᕟ" => "the", "ᕠ" => "thi", "ᕡ" => "thi", "ᕢ" => "thii", "ᕣ" => "thii",
    "ᕤ" => "tho", "ᕥ" => "thoo", "ᕦ" => "tha", "ᕧ" => "thaa", "ᕨ" => "thwaa", "ᕩ" => "thwaa",
    "ᕪ" => "th", "ᕫ" => "tthe", "ᕬ" => "tthi", "ᕭ" => "ttho", "ᕮ" => "ttha", "ᕯ" => "tth",
    "ᕰ" => "tye", "ᕱ" => "tyi", "ᕲ" => "tyo", "ᕳ" => "tya", "ᕴ" => "he", "ᕵ" => "hi",
    "ᕶ" => "hii", "ᕷ" => "ho", "ᕸ" => "hoo", "ᕹ" => "ha", "ᕺ" => "haa", "ᕻ" => "h",
    "ᕼ" => "h", "ᕽ" => "hk", "ᕾ" => "qaai", "ᕿ" => "qi", "ᖀ" => "qii", "ᖁ" => "qo",
    "ᖂ" => "qoo", "ᖃ" => "qa", "ᖄ" => "qaa", "ᖅ" => "q", "ᖆ" => "tlhe", "ᖇ" => "tlhi",
    "ᖈ" => "tlho", "ᖉ" => "tlha", "ᖊ" => "re", "ᖋ" => "ri", "ᖌ" => "ro", "ᖍ" => "ra",
    "ᖎ" => "ngaai", "ᖏ" => "ngi", "ᖐ" => "ngii", "ᖑ" => "ngo", "ᖒ" => "ngoo", "ᖓ" => "nga",
    "ᖔ" => "ngaa", "ᖕ" => "ng", "ᖖ" => "nng", "ᖗ" => "she", "ᖘ" => "shi", "ᖙ" => "sho",
    "ᖚ" => "sha", "ᖛ" => "the", "ᖜ" => "thi", "ᖝ" => "tho", "ᖞ" => "tha", "ᖟ" => "th",
    "ᖠ" => "lhi", "ᖡ" => "lhii", "ᖢ" => "lho", "ᖣ" => "lhoo", "ᖤ" => "lha", "ᖥ" => "lhaa",
    "ᖦ" => "lh", "ᖧ" => "the", "ᖨ" => "thi", "ᖩ" => "thii", "ᖪ" => "tho", "ᖫ" => "thoo",
    "ᖬ" => "tha", "ᖭ" => "thaa", "ᖮ" => "th", "ᖯ" => "b", "ᖰ" => "e", "ᖱ" => "i",
    "ᖲ" => "o", "ᖳ" => "a", "ᖴ" => "we", "ᖵ" => "wi", "ᖶ" => "wo", "ᖷ" => "wa",
    "ᖸ" => "ne", "ᖹ" => "ni", "ᖺ" => "no", "ᖻ" => "na", "ᖼ" => "ke", "ᖽ" => "ki",
    "ᖾ" => "ko", "ᖿ" => "ka", "ᗀ" => "he", "ᗁ" => "hi", "ᗂ" => "ho", "ᗃ" => "ha",
    "ᗄ" => "ghu", "ᗅ" => "gho", "ᗆ" => "ghe", "ᗇ" => "ghee", "ᗈ" => "ghi", "ᗉ" => "gha",
    "ᗊ" => "ru", "ᗋ" => "ro", "ᗌ" => "re", "ᗍ" => "ree", "ᗎ" => "ri", "ᗏ" => "ra",
    "ᗐ" => "wu", "ᗑ" => "wo", "ᗒ" => "we", "ᗓ" => "wee", "ᗔ" => "wi", "ᗕ" => "wa",
    "ᗖ" => "hwu", "ᗗ" => "hwo", "ᗘ" => "hwe", "ᗙ" => "hwee", "ᗚ" => "hwi", "ᗛ" => "hwa",
    "ᗜ" => "thu", "ᗝ" => "tho", "ᗞ" => "the", "ᗟ" => "thee", "ᗠ" => "thi", "ᗡ" => "tha",
    "ᗢ" => "ttu", "ᗣ" => "tto", "ᗤ" => "tte", "ᗥ" => "ttee", "ᗦ" => "tti", "ᗧ" => "tta",
    "ᗨ" => "pu", "ᗩ" => "po", "ᗪ" => "pe", "ᗫ" => "pee", "ᗬ" => "pi", "ᗭ" => "pa",
    "ᗮ" => "p", "ᗯ" => "gu", "ᗰ" => "go", "ᗱ" => "ge", "ᗲ" => "gee", "ᗳ" => "gi",
    "ᗴ" => "ga", "ᗵ" => "khu", "ᗶ" => "kho", "ᗷ" => "khe", "ᗸ" => "khee", "ᗹ" => "khi",
    "ᗺ" => "kha", "ᗻ" => "kku", "ᗼ" => "kko", "ᗽ" => "kke", "ᗾ" => "kkee", "ᗿ" => "kki",
    "ᘁ" => "kk", "ᘂ" => "nu", "ᘃ" => "no", "ᘄ" => "ne", "ᘅ" => "nee", "ᘆ" => "ni",
    "ᘇ" => "na", "ᘈ" => "mu", "ᘉ" => "mo", "ᘊ" => "me", "ᘋ" => "mee", "ᘌ" => "mi",
    "ᘍ" => "ma", "ᘎ" => "yu", "ᘏ" => "yo", "ᘐ" => "ye", "ᘑ" => "yee", "ᘒ" => "yi",
    "ᘓ" => "ya", "ᘔ" => "ju", "ᘕ" => "ju", "ᘖ" => "jo", "ᘗ" => "je", "ᘘ" => "jee",
    "ᘙ" => "ji", "ᘚ" => "ji", "ᘛ" => "ja", "ᘜ" => "jju", "ᘝ" => "jjo", "ᘞ" => "jje",
    "ᘟ" => "jjee", "ᘠ" => "jji", "ᘡ" => "jja", "ᘢ" => "lu", "ᘣ" => "lo", "ᘤ" => "le",
    "ᘥ" => "lee", "ᘦ" => "li", "ᘧ" => "la", "ᘨ" => "dlu", "ᘩ" => "dlo", "ᘪ" => "dle",
    "ᘫ" => "dlee", "ᘬ" => "dli", "ᘭ" => "dla", "ᘮ" => "lhu", "ᘯ" => "lho", "ᘰ" => "lhe",
    "ᘱ" => "lhee", "ᘲ" => "lhi", "ᘳ" => "lha", "ᘴ" => "tlhu", "ᘵ" => "tlho", "ᘶ" => "tlhe",
    "ᘷ" => "tlhee", "ᘸ" => "tlhi", "ᘹ" => "tlha", "ᘺ" => "tlu", "ᘻ" => "tlo", "ᘼ" => "tle",
    "ᘽ" => "tlee", "ᘾ" => "tli", "ᘿ" => "tla", "ᙀ" => "zu", "ᙁ" => "zo", "ᙂ" => "ze",
    "ᙃ" => "zee", "ᙄ" => "zi", "ᙅ" => "za", "ᙆ" => "z", "ᙇ" => "z", "ᙈ" => "dzu",
    "ᙉ" => "dzo", "ᙊ" => "dze", "ᙋ" => "dzee", "ᙌ" => "dzi", "ᙍ" => "dza", "ᙎ" => "su",
    "ᙏ" => "so", "ᙐ" => "se", "ᙑ" => "see", "ᙒ" => "si", "ᙓ" => "sa", "ᙔ" => "shu",
    "ᙕ" => "sho", "ᙖ" => "she", "ᙗ" => "shee", "ᙘ" => "shi", "ᙙ" => "sha", "ᙚ" => "sh",
    "ᙛ" => "tsu", "ᙜ" => "tso", "ᙝ" => "tse", "ᙞ" => "tsee", "ᙟ" => "tsi", "ᙠ" => "tsa",
    "ᙡ" => "chu", "ᙢ" => "cho", "ᙣ" => "che", "ᙤ" => "chee", "ᙥ" => "chi", "ᙦ" => "cha",
    "ᙧ" => "ttsu", "ᙨ" => "ttso", "ᙩ" => "ttse", "ᙪ" => "ttsee", "ᙫ" => "ttsi", "ᙬ" => "ttsa",
    "᙭" => "X", "ᙯ" => "qai", "ᙰ" => "ngai", "ᙱ" => "nngi", "ᙲ" => "nngii", "ᙳ" => "nngo",
    "ᙴ" => "nngoo", "ᙵ" => "nnga", "ᙶ" => "nngaa", "ᚁ" => "b", "ᚂ" => "l", "ᚃ" => "f",
    "ᚄ" => "s", "ᚅ" => "n", "ᚆ" => "h", "ᚇ" => "d", "ᚈ" => "t", "ᚉ" => "c",
    "ᚊ" => "q", "ᚋ" => "m", "ᚌ" => "g", "ᚍ" => "ng", "ᚎ" => "z", "ᚏ" => "r",
    "ᚐ" => "a", "ᚑ" => "o", "ᚒ" => "u", "ᚓ" => "e", "ᚔ" => "i", "ᚕ" => "ch",
    "ᚖ" => "th", "ᚗ" => "ph", "ᚘ" => "p", "ᚙ" => "x", "ᚚ" => "p", "ᚠ" => "f",
    "ᚡ" => "v", "ᚢ" => "u", "ᚣ" => "yr", "ᚤ" => "y", "ᚥ" => "w", "ᚦ" => "th",
    "ᚧ" => "th", "ᚨ" => "a", "ᚩ" => "o", "ᚪ" => "ac", "ᚫ" => "ae", "ᚬ" => "o",
    "ᚭ" => "o", "ᚮ" => "o", "ᚯ" => "oe", "ᚰ" => "on", "ᚱ" => "r", "ᚲ" => "k",
    "ᚳ" => "c", "ᚴ" => "k", "ᚵ" => "g", "ᚶ" => "ng", "ᚷ" => "g", "ᚸ" => "g",
    "ᚹ" => "w", "ᚺ" => "h", "ᚻ" => "h", "ᚼ" => "h", "ᚽ" => "h", "ᚾ" => "n",
    "ᚿ" => "n", "ᛀ" => "n", "ᛁ" => "i", "ᛂ" => "e", "ᛃ" => "j", "ᛄ" => "g",
    "ᛅ" => "ae", "ᛆ" => "a", "ᛇ" => "eo", "ᛈ" => "p", "ᛉ" => "z", "ᛊ" => "s",
    "ᛋ" => "s", "ᛌ" => "s", "ᛍ" => "c", "ᛎ" => "z", "ᛏ" => "t", "ᛐ" => "t",
    "ᛑ" => "d", "ᛒ" => "b", "ᛓ" => "b", "ᛔ" => "p", "ᛕ" => "p", "ᛖ" => "e",
    "ᛗ" => "m", "ᛘ" => "m", "ᛙ" => "m", "ᛚ" => "l", "ᛛ" => "l", "ᛜ" => "ng",
    "ᛝ" => "ng", "ᛞ" => "d", "ᛟ" => "o", "ᛠ" => "ear", "ᛡ" => "ior", "ᛢ" => "qu",
    "ᛣ" => "qu", "ᛤ" => "qu", "ᛥ" => "s", "ᛦ" => "yr", "ᛧ" => "yr", "ᛨ" => "yr",
    "ᛩ" => "q", "ᛪ" => "x", "ᛮ" => "17", "ᛯ" => "18", "ᛰ" => "19", "ក" => "k",
    "ខ" => "kh", "គ" => "g", "ឃ" => "gh", "ង" => "ng", "ច" => "c", "ឆ" => "ch",
    "ជ" => "j", "ឈ" => "jh", "ញ" => "ny", "ដ" => "t", "ឋ" => "tth", "ឌ" => "d",
    "ឍ" => "ddh", "ណ" => "nn", "ត" => "t", "ថ" => "th", "ទ" => "d", "ធ" => "dh",
    "ន" => "n", "ប" => "p", "ផ" => "ph", "ព" => "b", "ភ" => "bh", "ម" => "m",
    "យ" => "y", "រ" => "r", "ល" => "l", "វ" => "v", "ឝ" => "sh", "ឞ" => "ss",
    "ស" => "s", "ហ" => "h", "ឡ" => "l", "អ" => "q", "ឣ" => "a", "ឤ" => "aa",
    "ឥ" => "i", "ឦ" => "ii", "ឧ" => "u", "ឨ" => "uk", "ឩ" => "uu", "ឪ" => "uuv",
    "ឫ" => "ry", "ឬ" => "ryy", "ឭ" => "ly", "ឮ" => "lyy", "ឯ" => "e", "ឰ" => "ai",
    "ឱ" => "oo", "ឲ" => "oo", "ឳ" => "au", "឴" => "a", "឵" => "aa", "ា" => "aa",
    "ិ" => "i", "ី" => "ii", "ឹ" => "y", "ឺ" => "yy", "ុ" => "u", "ូ" => "uu",
    "ួ" => "ua", "ើ" => "oe", "ឿ" => "ya", "ៀ" => "ie", "េ" => "e", "ែ" => "ae",
    "ៃ" => "ai", "ោ" => "oo", "ៅ" => "au", "ំ" => "M", "ះ" => "H", "ៈ" => "a`",
    "៌" => "r", "៛" => "KR", "១" => "1", "២" => "2", "៣" => "3", "៤" => "4",
    "៥" => "5", "៦" => "6", "៧" => "7", "៨" => "8", "៩" => "9", "᠑" => "1",
    "᠒" => "2", "᠓" => "3", "᠔" => "4", "᠕" => "5", "᠖" => "6", "᠗" => "7",
    "᠘" => "8", "᠙" => "9", "ᠠ" => "a", "ᠡ" => "e", "ᠢ" => "i", "ᠣ" => "o",
    "ᠤ" => "u", "ᠥ" => "O", "ᠦ" => "U", "ᠧ" => "ee", "ᠨ" => "n", "ᠩ" => "ng",
    "ᠪ" => "b", "ᠫ" => "p", "ᠬ" => "q", "ᠭ" => "g", "ᠮ" => "m", "ᠯ" => "l",
    "ᠰ" => "s", "ᠱ" => "sh", "ᠲ" => "t", "ᠳ" => "d", "ᠴ" => "ch", "ᠵ" => "j",
    "ᠶ" => "y", "ᠷ" => "r", "ᠸ" => "w", "ᠹ" => "f", "ᠺ" => "k", "ᠻ" => "kha",
    "ᠼ" => "ts", "ᠽ" => "z", "ᠾ" => "h", "ᠿ" => "zr", "ᡀ" => "lh", "ᡁ" => "zh",
    "ᡂ" => "ch", "ᡄ" => "e", "ᡅ" => "i", "ᡆ" => "o", "ᡇ" => "u", "ᡈ" => "O",
    "ᡉ" => "U", "ᡊ" => "ng", "ᡋ" => "b", "ᡌ" => "p", "ᡍ" => "q", "ᡎ" => "g",
    "ᡏ" => "m", "ᡐ" => "t", "ᡑ" => "d", "ᡒ" => "ch", "ᡓ" => "j", "ᡔ" => "ts",
    "ᡕ" => "y", "ᡖ" => "w", "ᡗ" => "k", "ᡘ" => "g", "ᡙ" => "h", "ᡚ" => "jy",
    "ᡛ" => "ny", "ᡜ" => "dz", "ᡝ" => "e", "ᡞ" => "i", "ᡟ" => "iy", "ᡠ" => "U",
    "ᡡ" => "u", "ᡢ" => "ng", "ᡣ" => "k", "ᡤ" => "g", "ᡥ" => "h", "ᡦ" => "p",
    "ᡧ" => "sh", "ᡨ" => "t", "ᡩ" => "d", "ᡪ" => "j", "ᡫ" => "f", "ᡬ" => "g",
    "ᡭ" => "h", "ᡮ" => "ts", "ᡯ" => "z", "ᡰ" => "r", "ᡱ" => "ch", "ᡲ" => "zh",
    "ᡳ" => "i", "ᡴ" => "k", "ᡵ" => "r", "ᡶ" => "f", "ᡷ" => "zh", "ᢁ" => "H",
    "ᢂ" => "X", "ᢃ" => "W", "ᢄ" => "M", "ᢅ" => "3", "ᢆ" => "333", "ᢇ" => "a",
    "ᢈ" => "i", "ᢉ" => "k", "ᢊ" => "ng", "ᢋ" => "c", "ᢌ" => "tt", "ᢍ" => "tth",
    "ᢎ" => "dd", "ᢏ" => "nn", "ᢐ" => "t", "ᢑ" => "d", "ᢒ" => "p", "ᢓ" => "ph",
    "ᢔ" => "ss", "ᢕ" => "zh", "ᢖ" => "z", "ᢗ" => "a", "ᢘ" => "t", "ᢙ" => "zh",
    "ᢚ" => "gh", "ᢛ" => "ng", "ᢜ" => "c", "ᢝ" => "jh", "ᢞ" => "tta", "ᢟ" => "ddh",
    "ᢠ" => "t", "ᢡ" => "dh", "ᢢ" => "ss", "ᢣ" => "cy", "ᢤ" => "zh", "ᢥ" => "z",
    "ᢦ" => "u", "ᢧ" => "y", "ᢨ" => "bh", "ḁ" => "a", "Ḃ" => "B", "ḃ" => "b",
    "Ḅ" => "B", "ḅ" => "b", "Ḇ" => "B", "ḇ" => "b", "Ḉ" => "C", "ḉ" => "c",
    "Ḋ" => "D", "ḋ" => "d", "Ḍ" => "D", "ḍ" => "d", "Ḏ" => "D", "ḏ" => "d",
    "Ḑ" => "D", "ḑ" => "d", "Ḓ" => "D", "ḓ" => "d", "Ḕ" => "E", "ḕ" => "e",
    "Ḗ" => "E", "ḗ" => "e", "Ḙ" => "E", "ḙ" => "e", "Ḛ" => "E", "ḛ" => "e",
    "Ḝ" => "E", "ḝ" => "e", "Ḟ" => "F", "ḟ" => "f", "Ḡ" => "G", "ḡ" => "g",
    "Ḣ" => "H", "ḣ" => "h", "Ḥ" => "H", "ḥ" => "h", "Ḧ" => "H", "ḧ" => "h",
    "Ḩ" => "H", "ḩ" => "h", "Ḫ" => "H", "ḫ" => "h", "Ḭ" => "I", "ḭ" => "i",
    "Ḯ" => "I", "ḯ" => "i", "Ḱ" => "K", "ḱ" => "k", "Ḳ" => "K", "ḳ" => "k",
    "Ḵ" => "K", "ḵ" => "k", "Ḷ" => "L", "ḷ" => "l", "Ḹ" => "L", "ḹ" => "l",
    "Ḻ" => "L", "ḻ" => "l", "Ḽ" => "L", "ḽ" => "l", "Ḿ" => "M", "ḿ" => "m",
    "Ṁ" => "M", "ṁ" => "m", "Ṃ" => "M", "ṃ" => "m", "Ṅ" => "N", "ṅ" => "n",
    "Ṇ" => "N", "ṇ" => "n", "Ṉ" => "N", "ṉ" => "n", "Ṋ" => "N", "ṋ" => "n",
    "Ṍ" => "O", "ṍ" => "o", "Ṏ" => "O", "ṏ" => "o", "Ṑ" => "O", "ṑ" => "o",
    "Ṓ" => "O", "ṓ" => "o", "Ṕ" => "P", "ṕ" => "p", "Ṗ" => "P", "ṗ" => "p",
    "Ṙ" => "R", "ṙ" => "r", "Ṛ" => "R", "ṛ" => "r", "Ṝ" => "R", "ṝ" => "r",
    "Ṟ" => "R", "ṟ" => "r", "Ṡ" => "S", "ṡ" => "s", "Ṣ" => "S", "ṣ" => "s",
    "Ṥ" => "S", "ṥ" => "s", "Ṧ" => "S", "ṧ" => "s", "Ṩ" => "S", "ṩ" => "s",
    "Ṫ" => "T", "ṫ" => "t", "Ṭ" => "T", "ṭ" => "t", "Ṯ" => "T", "ṯ" => "t",
    "Ṱ" => "T", "ṱ" => "t", "Ṳ" => "U", "ṳ" => "u", "Ṵ" => "U", "ṵ" => "u",
    "Ṷ" => "U", "ṷ" => "u", "Ṹ" => "U", "ṹ" => "u", "Ṻ" => "U", "ṻ" => "u",
    "Ṽ" => "V", "ṽ" => "v", "Ṿ" => "V", "ṿ" => "v", "Ẁ" => "W", "ẁ" => "w",
    "Ẃ" => "W", "ẃ" => "w", "Ẅ" => "W", "ẅ" => "w", "Ẇ" => "W", "ẇ" => "w",
    "Ẉ" => "W", "ẉ" => "w", "Ẋ" => "X", "ẋ" => "x", "Ẍ" => "X", "ẍ" => "x",
    "Ẏ" => "Y", "ẏ" => "y", "Ẑ" => "Z", "ẑ" => "z", "Ẓ" => "Z", "ẓ" => "z",
    "Ẕ" => "Z", "ẕ" => "z", "ẖ" => "h", "ẗ" => "t", "ẘ" => "w", "ẙ" => "y",
    "ẚ" => "a", "ẛ" => "S", "Ạ" => "A", "ạ" => "a", "Ả" => "A", "ả" => "a",
    "Ấ" => "A", "ấ" => "a", "Ầ" => "A", "ầ" => "a", "Ẩ" => "A", "ẩ" => "a",
    "Ẫ" => "A", "ẫ" => "a", "Ậ" => "A", "ậ" => "a", "Ắ" => "A", "ắ" => "a",
    "Ằ" => "A", "ằ" => "a", "Ẳ" => "A", "ẳ" => "a", "Ẵ" => "A", "ẵ" => "a",
    "Ặ" => "A", "ặ" => "a", "Ẹ" => "E", "ẹ" => "e", "Ẻ" => "E", "ẻ" => "e",
    "Ẽ" => "E", "ẽ" => "e", "Ế" => "E", "ế" => "e", "Ề" => "E", "ề" => "e",
    "Ể" => "E", "ể" => "e", "Ễ" => "E", "ễ" => "e", "Ệ" => "E", "ệ" => "e",
    "Ỉ" => "I", "ỉ" => "i", "Ị" => "I", "ị" => "i", "Ọ" => "O", "ọ" => "o",
    "Ỏ" => "O", "ỏ" => "o", "Ố" => "O", "ố" => "o", "Ồ" => "O", "ồ" => "o",
    "Ổ" => "O", "ổ" => "o", "Ỗ" => "O", "ỗ" => "o", "Ộ" => "O", "ộ" => "o",
    "Ớ" => "O", "ớ" => "o", "Ờ" => "O", "ờ" => "o", "Ở" => "O", "ở" => "o",
    "Ỡ" => "O", "ỡ" => "o", "Ợ" => "O", "ợ" => "o", "Ụ" => "U", "ụ" => "u",
    "Ủ" => "U", "ủ" => "u", "Ứ" => "U", "ứ" => "u", "Ừ" => "U", "ừ" => "u",
    "Ử" => "U", "ử" => "u", "Ữ" => "U", "ữ" => "u", "Ự" => "U", "ự" => "u",
    "Ỳ" => "Y", "ỳ" => "y", "Ỵ" => "Y", "ỵ" => "y", "Ỷ" => "Y", "ỷ" => "y",
    "Ỹ" => "Y", "ỹ" => "y", "ἁ" => "a", "ἂ" => "a", "ἃ" => "a", "ἄ" => "a",
    "ἅ" => "a", "ἆ" => "a", "ἇ" => "a", "Ἀ" => "A", "Ἁ" => "A", "Ἂ" => "A",
    "Ἃ" => "A", "Ἄ" => "A", "Ἅ" => "A", "Ἆ" => "A", "Ἇ" => "A", "ἐ" => "e",
    "ἑ" => "e", "ἒ" => "e", "ἓ" => "e", "ἔ" => "e", "ἕ" => "e", "Ἐ" => "E",
    "Ἑ" => "E", "Ἒ" => "E", "Ἓ" => "E", "Ἔ" => "E", "Ἕ" => "E", "ἠ" => "e",
    "ἡ" => "e", "ἢ" => "e", "ἣ" => "e", "ἤ" => "e", "ἥ" => "e", "ἦ" => "e",
    "ἧ" => "e", "Ἠ" => "E", "Ἡ" => "E", "Ἢ" => "E", "Ἣ" => "E", "Ἤ" => "E",
    "Ἥ" => "E", "Ἦ" => "E", "Ἧ" => "E", "ἰ" => "i", "ἱ" => "i", "ἲ" => "i",
    "ἳ" => "i", "ἴ" => "i", "ἵ" => "i", "ἶ" => "i", "ἷ" => "i", "Ἰ" => "I",
    "Ἱ" => "I", "Ἲ" => "I", "Ἳ" => "I", "Ἴ" => "I", "Ἵ" => "I", "Ἶ" => "I",
    "Ἷ" => "I", "ὀ" => "o", "ὁ" => "o", "ὂ" => "o", "ὃ" => "o", "ὄ" => "o",
    "ὅ" => "o", "Ὀ" => "O", "Ὁ" => "O", "Ὂ" => "O", "Ὃ" => "O", "Ὄ" => "O",
    "Ὅ" => "O", "ὐ" => "u", "ὑ" => "u", "ὒ" => "u", "ὓ" => "u", "ὔ" => "u",
    "ὕ" => "u", "ὖ" => "u", "ὗ" => "u", "Ὑ" => "U", "Ὓ" => "U", "Ὕ" => "U",
    "Ὗ" => "U", "ὠ" => "o", "ὡ" => "o", "ὢ" => "o", "ὣ" => "o", "ὤ" => "o",
    "ὥ" => "o", "ὦ" => "o", "ὧ" => "o", "Ὠ" => "O", "Ὡ" => "O", "Ὢ" => "O",
    "Ὣ" => "O", "Ὤ" => "O", "Ὥ" => "O", "Ὦ" => "O", "Ὧ" => "O", "ὰ" => "a",
    "ά" => "a", "ὲ" => "e", "έ" => "e", "ὴ" => "e", "ή" => "e", "ὶ" => "i",
    "ί" => "i", "ὸ" => "o", "ό" => "o", "ὺ" => "u", "ύ" => "u", "ὼ" => "o",
    "ώ" => "o", "ᾀ" => "a", "ᾁ" => "a", "ᾂ" => "a", "ᾃ" => "a", "ᾄ" => "a",
    "ᾅ" => "a", "ᾆ" => "a", "ᾇ" => "a", "ᾈ" => "A", "ᾉ" => "A", "ᾊ" => "A",
    "ᾋ" => "A", "ᾌ" => "A", "ᾍ" => "A", "ᾎ" => "A", "ᾏ" => "A", "ᾐ" => "e",
    "ᾑ" => "e", "ᾒ" => "e", "ᾓ" => "e", "ᾔ" => "e", "ᾕ" => "e", "ᾖ" => "e",
    "ᾗ" => "e", "ᾘ" => "E", "ᾙ" => "E", "ᾚ" => "E", "ᾛ" => "E", "ᾜ" => "E",
    "ᾝ" => "E", "ᾞ" => "E", "ᾟ" => "E", "ᾠ" => "o", "ᾡ" => "o", "ᾢ" => "o",
    "ᾣ" => "o", "ᾤ" => "o", "ᾥ" => "o", "ᾦ" => "o", "ᾧ" => "o", "ᾨ" => "O",
    "ᾩ" => "O", "ᾪ" => "O", "ᾫ" => "O", "ᾬ" => "O", "ᾭ" => "O", "ᾮ" => "O",
    "ᾯ" => "O", "ᾰ" => "a", "ᾱ" => "a", "ᾲ" => "a", "ᾳ" => "a", "ᾴ" => "a",
    "ᾶ" => "a", "ᾷ" => "a", "Ᾰ" => "A", "Ᾱ" => "A", "Ὰ" => "A", "Ά" => "A",
    "ᾼ" => "A", "ι" => "i", "ῂ" => "e", "ῃ" => "e", "ῄ" => "e", "ῆ" => "e",
    "ῇ" => "e", "Ὲ" => "E", "Έ" => "E", "Ὴ" => "E", "Ή" => "E", "ῌ" => "E",
    "ῐ" => "i", "ῑ" => "i", "ῒ" => "i", "ΐ" => "i", "ῖ" => "i", "ῗ" => "i",
    "Ῐ" => "I", "Ῑ" => "I", "Ὶ" => "I", "Ί" => "I", "ῠ" => "u", "ῡ" => "u",
    "ῢ" => "u", "ΰ" => "u", "ῤ" => "R", "ῥ" => "R", "ῦ" => "u", "ῧ" => "u",
    "Ῠ" => "U", "Ῡ" => "U", "Ὺ" => "U", "Ύ" => "U", "Ῥ" => "R", "ῲ" => "o",
    "ῳ" => "o", "ῴ" => "o", "ῶ" => "o", "ῷ" => "o", "Ὸ" => "O", "Ό" => "O",
    "Ὼ" => "O", "Ώ" => "O", "ῼ" => "O", "‰" => "%0", "‱" => "%00", "⁊" => "7",
    "⁋" => "PP", "⁴" => "4", "⁵" => "5", "⁶" => "6", "⁷" => "7", "⁸" => "8",
    "⁹" => "9", "ⁿ" => "n", "₁" => "1", "₂" => "2", "₃" => "3", "₄" => "4",
    "₅" => "5", "₆" => "6", "₇" => "7", "₈" => "8", "₉" => "9", "₠" => "ECU",
    "₡" => "CL", "₢" => "Cr", "₣" => "FF", "₤" => "L", "₥" => "mil", "₦" => "N",
    "₧" => "Pts", "₨" => "Rs", "₩" => "W", "₪" => "NS", "₫" => "D", "€" => "EU",
    "₭" => "K", "₮" => "T", "₯" => "Dr", "⅓" => "1/3", "⅔" => "2/3", "⅕" => "1/5",
    "⅖" => "2/5", "⅗" => "3/5", "⅘" => "4/5", "⅙" => "1/6", "⅚" => "5/6", "⅛" => "1/8",
    "⅜" => "3/8", "⅝" => "5/8", "⅞" => "7/8", "⅟" => "1", "Ⅰ" => "I", "Ⅱ" => "II",
    "Ⅲ" => "III", "Ⅳ" => "IV", "Ⅴ" => "V", "Ⅵ" => "VI", "Ⅶ" => "VII", "Ⅷ" => "VIII",
    "Ⅸ" => "IX", "Ⅹ" => "X", "Ⅺ" => "XI", "Ⅻ" => "XII", "Ⅼ" => "L", "Ⅽ" => "C",
    "Ⅾ" => "D", "Ⅿ" => "M", "ⅰ" => "i", "ⅱ" => "ii", "ⅲ" => "iii", "ⅳ" => "iv",
    "ⅴ" => "v", "ⅵ" => "vi", "ⅶ" => "vii", "ⅷ" => "viii", "ⅸ" => "ix", "ⅹ" => "x",
    "ⅺ" => "xi", "ⅻ" => "xii", "ⅼ" => "l", "ⅽ" => "c", "ⅾ" => "d", "ⅿ" => "m",
    "ↀ" => "(D", "ↁ" => "D)", "↷" => "V", "↺" => "V", "╳" => "X", "▼" => "V",
    "▽" => "V", "▾" => "V", "▿" => "V", "◯" => "O", "⠁" => "a", "⠂" => "1",
    "⠃" => "b", "⠅" => "k", "⠆" => "2", "⠇" => "l", "⠉" => "c", "⠊" => "i",
    "⠋" => "f", "⠍" => "m", "⠎" => "s", "⠏" => "p", "⠑" => "e", "⠒" => "3",
    "⠓" => "h", "⠔" => "9", "⠕" => "o", "⠖" => "6", "⠗" => "r", "⠙" => "d",
    "⠚" => "j", "⠛" => "g", "⠝" => "n", "⠞" => "t", "⠟" => "q", "⠢" => "5",
    "⠥" => "u", "⠦" => "8", "⠧" => "v", "⠭" => "x", "⠲" => "4", "⠵" => "z",
    "⠶" => "7", "⠺" => "w", "⠽" => "y", "⡀" => "d7", "⡁" => "d17", "⡂" => "d27",
    "⡃" => "d127", "⡄" => "d37", "⡅" => "d137", "⡆" => "d237", "⡇" => "d1237", "⡈" => "d47",
    "⡉" => "d147", "⡊" => "d247", "⡋" => "d1247", "⡌" => "d347", "⡍" => "d1347", "⡎" => "d2347",
    "⡏" => "d12347", "⡐" => "d57", "⡑" => "d157", "⡒" => "d257", "⡓" => "d1257", "⡔" => "d357",
    "⡕" => "d1357", "⡖" => "d2357", "⡗" => "d12357", "⡘" => "d457", "⡙" => "d1457", "⡚" => "d2457",
    "⡛" => "d12457", "⡜" => "d3457", "⡝" => "d13457", "⡞" => "d23457", "⡟" => "d123457", "⡠" => "d67",
    "⡡" => "d167", "⡢" => "d267", "⡣" => "d1267", "⡤" => "d367", "⡥" => "d1367", "⡦" => "d2367",
    "⡧" => "d12367", "⡨" => "d467", "⡩" => "d1467", "⡪" => "d2467", "⡫" => "d12467", "⡬" => "d3467",
    "⡭" => "d13467", "⡮" => "d23467", "⡯" => "d123467", "⡰" => "d567", "⡱" => "d1567", "⡲" => "d2567",
    "⡳" => "d12567", "⡴" => "d3567", "⡵" => "d13567", "⡶" => "d23567", "⡷" => "d123567", "⡸" => "d4567",
    "⡹" => "d14567", "⡺" => "d24567", "⡻" => "d124567", "⡼" => "d34567", "⡽" => "d134567", "⡾" => "d234567",
    "⡿" => "d1234567", "⢀" => "d8", "⢁" => "d18", "⢂" => "d28", "⢃" => "d128", "⢄" => "d38",
    "⢅" => "d138", "⢆" => "d238", "⢇" => "d1238", "⢈" => "d48", "⢉" => "d148", "⢊" => "d248",
    "⢋" => "d1248", "⢌" => "d348", "⢍" => "d1348", "⢎" => "d2348", "⢏" => "d12348", "⢐" => "d58",
    "⢑" => "d158", "⢒" => "d258", "⢓" => "d1258", "⢔" => "d358", "⢕" => "d1358", "⢖" => "d2358",
    "⢗" => "d12358", "⢘" => "d458", "⢙" => "d1458", "⢚" => "d2458", "⢛" => "d12458", "⢜" => "d3458",
    "⢝" => "d13458", "⢞" => "d23458", "⢟" => "d123458", "⢠" => "d68", "⢡" => "d168", "⢢" => "d268",
    "⢣" => "d1268", "⢤" => "d368", "⢥" => "d1368", "⢦" => "d2368", "⢧" => "d12368", "⢨" => "d468",
    "⢩" => "d1468", "⢪" => "d2468", "⢫" => "d12468", "⢬" => "d3468", "⢭" => "d13468", "⢮" => "d23468",
    "⢯" => "d123468", "⢰" => "d568", "⢱" => "d1568", "⢲" => "d2568", "⢳" => "d12568", "⢴" => "d3568",
    "⢵" => "d13568", "⢶" => "d23568", "⢷" => "d123568", "⢸" => "d4568", "⢹" => "d14568", "⢺" => "d24568",
    "⢻" => "d124568", "⢼" => "d34568", "⢽" => "d134568", "⢾" => "d234568", "⢿" => "d1234568", "⣀" => "d78",
    "⣁" => "d178", "⣂" => "d278", "⣃" => "d1278", "⣄" => "d378", "⣅" => "d1378", "⣆" => "d2378",
    "⣇" => "d12378", "⣈" => "d478", "⣉" => "d1478", "⣊" => "d2478", "⣋" => "d12478", "⣌" => "d3478",
    "⣍" => "d13478", "⣎" => "d23478", "⣏" => "d123478", "⣐" => "d578", "⣑" => "d1578", "⣒" => "d2578",
    "⣓" => "d12578", "⣔" => "d3578", "⣕" => "d13578", "⣖" => "d23578", "⣗" => "d123578", "⣘" => "d4578",
    "⣙" => "d14578", "⣚" => "d24578", "⣛" => "d124578", "⣜" => "d34578", "⣝" => "d134578", "⣞" => "d234578",
    "⣟" => "d1234578", "⣠" => "d678", "⣡" => "d1678", "⣢" => "d2678", "⣣" => "d12678", "⣤" => "d3678",
    "⣥" => "d13678", "⣦" => "d23678", "⣧" => "d123678", "⣨" => "d4678", "⣩" => "d14678", "⣪" => "d24678",
    "⣫" => "d124678", "⣬" => "d34678", "⣭" => "d134678", "⣮" => "d234678", "⣯" => "d1234678", "⣰" => "d5678",
    "⣱" => "d15678", "⣲" => "d25678", "⣳" => "d125678", "⣴" => "d35678", "⣵" => "d135678", "⣶" => "d235678",
    "⣷" => "d1235678", "⣸" => "d45678", "⣹" => "d145678", "⣺" => "d245678", "⣻" => "d1245678", "⣼" => "d345678",
    "⣽" => "d1345678", "⣾" => "d2345678", "⣿" => "d12345678", "〄" => "JIS", "〓" => "X", "〡" => "1",
    "〢" => "2", "〣" => "3", "〤" => "4", "〥" => "5", "〦" => "6", "〧" => "7",
    "〨" => "8", "〩" => "9", "〸" => "+10+", "〹" => "+20+", "〺" => "+30+", "ぁ" => "a",
    "あ" => "a", "ぃ" => "i", "い" => "i", "ぅ" => "u", "う" => "u", "ぇ" => "e",
    "え" => "e", "ぉ" => "o", "お" => "o", "か" => "ka", "が" => "ga", "き" => "ki",
    "ぎ" => "gi", "く" => "ku", "ぐ" => "gu", "け" => "ke", "げ" => "ge", "こ" => "ko",
    "ご" => "go", "さ" => "sa", "ざ" => "za", "し" => "si", "じ" => "zi", "す" => "su",
    "ず" => "zu", "せ" => "se", "ぜ" => "ze", "そ" => "so", "ぞ" => "zo", "た" => "ta",
    "だ" => "da", "ち" => "ti", "ぢ" => "di", "っ" => "tu", "つ" => "tu", "づ" => "du",
    "て" => "te", "で" => "de", "と" => "to", "ど" => "do", "な" => "na", "に" => "ni",
    "ぬ" => "nu", "ね" => "ne", "の" => "no", "は" => "ha", "ば" => "ba", "ぱ" => "pa",
    "ひ" => "hi", "び" => "bi", "ぴ" => "pi", "ふ" => "hu", "ぶ" => "bu", "ぷ" => "pu",
    "へ" => "he", "べ" => "be", "ぺ" => "pe", "ほ" => "ho", "ぼ" => "bo", "ぽ" => "po",
    "ま" => "ma", "み" => "mi", "む" => "mu", "め" => "me", "も" => "mo", "ゃ" => "ya",
    "や" => "ya", "ゅ" => "yu", "ゆ" => "yu", "ょ" => "yo", "よ" => "yo", "ら" => "ra",
    "り" => "ri", "る" => "ru", "れ" => "re", "ろ" => "ro", "ゎ" => "wa", "わ" => "wa",
    "ゐ" => "wi", "ゑ" => "we", "を" => "wo", "ん" => "n", "ゔ" => "vu", "ァ" => "a",
    "ア" => "a", "ィ" => "i", "イ" => "i", "ゥ" => "u", "ウ" => "u", "ェ" => "e",
    "エ" => "e", "ォ" => "o", "オ" => "o", "カ" => "ka", "ガ" => "ga", "キ" => "ki",
    "ギ" => "gi", "ク" => "ku", "グ" => "gu", "ケ" => "ke", "ゲ" => "ge", "コ" => "ko",
    "ゴ" => "go", "サ" => "sa", "ザ" => "za", "シ" => "si", "ジ" => "zi", "ス" => "su",
    "ズ" => "zu", "セ" => "se", "ゼ" => "ze", "ソ" => "so", "ゾ" => "zo", "タ" => "ta",
    "ダ" => "da", "チ" => "ti", "ヂ" => "di", "ッ" => "tu", "ツ" => "tu", "ヅ" => "du",
    "テ" => "te", "デ" => "de", "ト" => "to", "ド" => "do", "ナ" => "na", "ニ" => "ni",
    "ヌ" => "nu", "ネ" => "ne", "ノ" => "no", "ハ" => "ha", "バ" => "ba", "パ" => "pa",
    "ヒ" => "hi", "ビ" => "bi", "ピ" => "pi", "フ" => "hu", "ブ" => "bu", "プ" => "pu",
    "ヘ" => "he", "ベ" => "be", "ペ" => "pe", "ホ" => "ho", "ボ" => "bo", "ポ" => "po",
    "マ" => "ma", "ミ" => "mi", "ム" => "mu", "メ" => "me", "モ" => "mo", "ャ" => "ya",
    "ヤ" => "ya", "ュ" => "yu", "ユ" => "yu", "ョ" => "yo", "ヨ" => "yo", "ラ" => "ra",
    "リ" => "ri", "ル" => "ru", "レ" => "re", "ロ" => "ro", "ヮ" => "wa", "ワ" => "wa",
    "ヰ" => "wi", "ヱ" => "we", "ヲ" => "wo", "ン" => "n", "ヴ" => "vu", "ヵ" => "ka",
    "ヶ" => "ke", "ヷ" => "va", "ヸ" => "vi", "ヹ" => "ve", "ヺ" => "vo", "ㄅ" => "B",
    "ㄆ" => "P", "ㄇ" => "M", "ㄈ" => "F", "ㄉ" => "D", "ㄊ" => "T", "ㄋ" => "N",
    "ㄌ" => "L", "ㄍ" => "G", "ㄎ" => "K", "ㄏ" => "H", "ㄐ" => "J", "ㄑ" => "Q",
    "ㄒ" => "X", "ㄓ" => "ZH", "ㄔ" => "CH", "ㄕ" => "SH", "ㄖ" => "R", "ㄗ" => "Z",
    "ㄘ" => "C", "ㄙ" => "S", "ㄚ" => "A", "ㄛ" => "O", "ㄜ" => "E", "ㄝ" => "EH",
    "ㄞ" => "AI", "ㄟ" => "EI", "ㄠ" => "AU", "ㄡ" => "OU", "ㄢ" => "AN", "ㄣ" => "EN",
    "ㄤ" => "ANG", "ㄥ" => "ENG", "ㄦ" => "ER", "ㄧ" => "I", "ㄨ" => "U", "ㄩ" => "IU",
    "ㄪ" => "V", "ㄫ" => "NG", "ㄬ" => "GN", "ㄱ" => "g", "ㄲ" => "gg", "ㄳ" => "gs",
    "ㄴ" => "n", "ㄵ" => "nj", "ㄶ" => "nh", "ㄷ" => "d", "ㄸ" => "dd", "ㄹ" => "r",
    "ㄺ" => "lg", "ㄻ" => "lm", "ㄼ" => "lb", "ㄽ" => "ls", "ㄾ" => "lt", "ㄿ" => "lp",
    "ㅀ" => "rh", "ㅁ" => "m", "ㅂ" => "b", "ㅃ" => "bb", "ㅄ" => "bs", "ㅅ" => "s",
    "ㅆ" => "ss", "ㅈ" => "j", "ㅉ" => "jj", "ㅊ" => "c", "ㅋ" => "k", "ㅌ" => "t",
    "ㅍ" => "p", "ㅎ" => "h", "ㅏ" => "a", "ㅐ" => "ae", "ㅑ" => "ya", "ㅒ" => "yae",
    "ㅓ" => "eo", "ㅔ" => "e", "ㅕ" => "yeo", "ㅖ" => "ye", "ㅗ" => "o", "ㅘ" => "wa",
    "ㅙ" => "wae", "ㅚ" => "oe", "ㅛ" => "yo", "ㅜ" => "u", "ㅝ" => "weo", "ㅞ" => "we",
    "ㅟ" => "wi", "ㅠ" => "yu", "ㅡ" => "eu", "ㅢ" => "yi", "ㅣ" => "i", "ㅥ" => "nn",
    "ㅦ" => "nd", "ㅧ" => "ns", "ㅨ" => "nZ", "ㅩ" => "lgs", "ㅪ" => "ld", "ㅫ" => "lbs",
    "ㅬ" => "lZ", "ㅭ" => "lQ", "ㅮ" => "mb", "ㅯ" => "ms", "ㅰ" => "mZ", "ㅱ" => "mN",
    "ㅲ" => "bg", "ㅴ" => "bsg", "ㅵ" => "bst", "ㅶ" => "bj", "ㅷ" => "bt", "ㅸ" => "bN",
    "ㅹ" => "bbN", "ㅺ" => "sg", "ㅻ" => "sn", "ㅼ" => "sd", "ㅽ" => "sb", "ㅾ" => "sj",
    "ㅿ" => "Z", "ㆁ" => "N", "ㆂ" => "Ns", "ㆃ" => "NZ", "ㆄ" => "pN", "ㆅ" => "hh",
    "ㆆ" => "Q", "ㆇ" => "yo-ya", "ㆈ" => "yo-yae", "ㆉ" => "yo-i", "ㆊ" => "yu-yeo", "ㆋ" => "yu-ye",
    "ㆌ" => "yu-i", "ㆍ" => "U", "ㆎ" => "U-i", "ㆠ" => "BU", "ㆡ" => "ZI", "ㆢ" => "JI",
    "ㆣ" => "GU", "ㆤ" => "EE", "ㆥ" => "ENN", "ㆦ" => "OO", "ㆧ" => "ONN", "ㆨ" => "IR",
    "ㆩ" => "ANN", "ㆪ" => "INN", "ㆫ" => "UNN", "ㆬ" => "IM", "ㆭ" => "NGG", "ㆮ" => "AINN",
    "ㆯ" => "AUNN", "ㆰ" => "AM", "ㆱ" => "OM", "ㆲ" => "ONG", "ㆳ" => "INNN", "ㆴ" => "P",
    "ㆵ" => "T", "ㆶ" => "K", "ㆷ" => "H", "㈁" => "(n)", "㈂" => "(d)", "㈃" => "(r)",
    "㈄" => "(m)", "㈅" => "(b)", "㈆" => "(s)", "㈈" => "(j)", "㈉" => "(c)", "㈊" => "(k)",
    "㈋" => "(t)", "㈌" => "(p)", "㈍" => "(h)", "㈎" => "(ga)", "㈏" => "(na)", "㈐" => "(da)",
    "㈑" => "(ra)", "㈒" => "(ma)", "㈓" => "(ba)", "㈔" => "(sa)", "㈕" => "(a)", "㈖" => "(ja)",
    "㈗" => "(ca)", "㈘" => "(ka)", "㈙" => "(ta)", "㈚" => "(pa)", "㈛" => "(ha)", "㈜" => "(ju)",
    "㈠" => "(1)", "㈡" => "(2)", "㈢" => "(3)", "㈣" => "(4)", "㈤" => "(5)", "㈥" => "(6)",
    "㈦" => "(7)", "㈧" => "(8)", "㈨" => "(9)", "㈩" => "(10)", "㈪" => "(Yue)", "㈫" => "(Huo)",
    "㈬" => "(Shui)", "㈭" => "(Mu)", "㈮" => "(Jin)", "㈯" => "(Tu)", "㈰" => "(Ri)", "㈱" => "(Zhu)",
    "㈲" => "(You)", "㈳" => "(She)", "㈴" => "(Ming)", "㈵" => "(Te)", "㈶" => "(Cai)", "㈷" => "(Zhu)",
    "㈸" => "(Lao)", "㈹" => "(Dai)", "㈺" => "(Hu)", "㈻" => "(Xue)", "㈼" => "(Jian)", "㈽" => "(Qi)",
    "㈾" => "(Zi)", "㈿" => "(Xie)", "㉀" => "(Ji)", "㉁" => "(Xiu)", "㉠" => "(g)", "㉡" => "(n)",
    "㉢" => "(d)", "㉣" => "(r)", "㉤" => "(m)", "㉥" => "(b)", "㉦" => "(s)", "㉨" => "(j)",
    "㉩" => "(c)", "㉪" => "(k)", "㉫" => "(t)", "㉬" => "(p)", "㉭" => "(h)", "㉮" => "(ga)",
    "㉯" => "(na)", "㉰" => "(da)", "㉱" => "(ra)", "㉲" => "(ma)", "㉳" => "(ba)", "㉴" => "(sa)",
    "㉵" => "(a)", "㉶" => "(ja)", "㉷" => "(ca)", "㉸" => "(ka)", "㉹" => "(ta)", "㉺" => "(pa)",
    "㉻" => "(ha)", "㉿" => "KIS", "㊀" => "(1)", "㊁" => "(2)", "㊂" => "(3)", "㊃" => "(4)",
    "㊄" => "(5)", "㊅" => "(6)", "㊆" => "(7)", "㊇" => "(8)", "㊈" => "(9)", "㊉" => "(10)",
    "㊊" => "(Yue)", "㊋" => "(Huo)", "㊌" => "(Shui)", "㊍" => "(Mu)", "㊎" => "(Jin)", "㊏" => "(Tu)",
    "㊐" => "(Ri)", "㊑" => "(Zhu)", "㊒" => "(You)", "㊓" => "(She)", "㊔" => "(Ming)", "㊕" => "(Te)",
    "㊖" => "(Cai)", "㊗" => "(Zhu)", "㊘" => "(Lao)", "㊙" => "(Mi)", "㊚" => "(Nan)", "㊛" => "(Nu)",
    "㊜" => "(Shi)", "㊝" => "(You)", "㊞" => "(Yin)", "㊟" => "(Zhu)", "㊠" => "(Xiang)", "㊡" => "(Xiu)",
    "㊢" => "(Xie)", "㊣" => "(Zheng)", "㊤" => "(Shang)", "㊥" => "(Zhong)", "㊦" => "(Xia)", "㊧" => "(Zuo)",
    "㊨" => "(You)", "㊩" => "(Yi)", "㊪" => "(Zong)", "㊫" => "(Xue)", "㊬" => "(Jian)", "㊭" => "(Qi)",
    "㊮" => "(Zi)", "㊯" => "(Xie)", "㊰" => "(Ye)", "㋀" => "1M", "㋁" => "2M", "㋂" => "3M",
    "㋃" => "4M", "㋄" => "5M", "㋅" => "6M", "㋆" => "7M", "㋇" => "8M", "㋈" => "9M",
    "㋉" => "10M", "㋊" => "11M", "㋋" => "12M", "㋐" => "a", "㋑" => "i", "㋒" => "u",
    "㋓" => "u", "㋔" => "o", "㋕" => "ka", "㋖" => "ki", "㋗" => "ku", "㋘" => "ke",
    "㋙" => "ko", "㋚" => "sa", "㋛" => "si", "㋜" => "su", "㋝" => "se", "㋞" => "so",
    "㋟" => "ta", "㋠" => "ti", "㋡" => "tu", "㋢" => "te", "㋣" => "to", "㋤" => "na",
    "㋥" => "ni", "㋦" => "nu", "㋧" => "ne", "㋨" => "no", "㋩" => "ha", "㋪" => "hi",
    "㋫" => "hu", "㋬" => "he", "㋭" => "ho", "㋮" => "ma", "㋯" => "mi", "㋰" => "mu",
    "㋱" => "me", "㋲" => "mo", "㋳" => "ya", "㋴" => "yu", "㋵" => "yo", "㋶" => "ra",
    "㋷" => "ri", "㋸" => "ru", "㋹" => "re", "㋺" => "ro", "㋻" => "wa", "㋼" => "wi",
    "㋽" => "we", "㋾" => "wo", "㌁" => "alpha", "㌂" => "ampere", "㌃" => "are", "㌄" => "inning",
    "㌅" => "inch", "㌆" => "won", "㌇" => "escudo", "㌈" => "acre", "㌉" => "ounce", "㌊" => "ohm",
    "㌋" => "kai-ri", "㌌" => "carat", "㌍" => "calorie", "㌎" => "gallon", "㌏" => "gamma", "㌐" => "giga",
    "㌑" => "guinea", "㌒" => "curie", "㌓" => "guilder", "㌔" => "kilo", "㌕" => "kilogram", "㌖" => "kilometer",
    "㌗" => "kilowatt", "㌘" => "gram", "㌚" => "cruzeiro", "㌛" => "krone", "㌜" => "case", "㌝" => "koruna",
    "㌞" => "co-op", "㌟" => "cycle", "㌠" => "centime", "㌡" => "shilling", "㌢" => "centi", "㌣" => "cent",
    "㌤" => "dozen", "㌥" => "desi", "㌦" => "dollar", "㌧" => "ton", "㌨" => "nano", "㌩" => "knot",
    "㌪" => "heights", "㌫" => "percent", "㌬" => "parts", "㌭" => "barrel", "㌮" => "piaster", "㌯" => "picul",
    "㌰" => "pico", "㌱" => "building", "㌲" => "farad", "㌳" => "feet", "㌴" => "bushel", "㌵" => "franc",
    "㌶" => "hectare", "㌷" => "peso", "㌸" => "pfennig", "㌹" => "hertz", "㌺" => "pence", "㌻" => "page",
    "㌼" => "beta", "㌽" => "point", "㌾" => "volt", "㌿" => "hon", "㍀" => "pound", "㍁" => "hall",
    "㍂" => "horn", "㍃" => "micro", "㍄" => "mile", "㍅" => "mach", "㍆" => "mark", "㍇" => "mansion",
    "㍈" => "micron", "㍉" => "milli", "㍊" => "millibar", "㍋" => "mega", "㍌" => "megaton", "㍍" => "meter",
    "㍎" => "yard", "㍏" => "yard", "㍐" => "yuan", "㍑" => "liter", "㍒" => "lira", "㍓" => "rupee",
    "㍔" => "ruble", "㍕" => "rem", "㍖" => "roentgen", "㍗" => "watt", "㍘" => "0h", "㍙" => "1h",
    "㍚" => "2h", "㍛" => "3h", "㍜" => "4h", "㍝" => "5h", "㍞" => "6h", "㍟" => "7h",
    "㍠" => "8h", "㍡" => "9h", "㍢" => "10h", "㍣" => "11h", "㍤" => "12h", "㍥" => "13h",
    "㍦" => "14h", "㍧" => "15h", "㍨" => "16h", "㍩" => "17h", "㍪" => "18h", "㍫" => "19h",
    "㍬" => "20h", "㍭" => "21h", "㍮" => "22h", "㍯" => "23h", "㍰" => "24h", "㍱" => "HPA",
    "㍲" => "da", "㍳" => "AU", "㍴" => "bar", "㍵" => "oV", "㍶" => "pc", "㍻" => "Heisei",
    "㍼" => "Syouwa", "㍽" => "Taisyou", "㍾" => "Meiji", "㍿" => "Inc.", "㎀" => "pA", "㎁" => "nA",
    "㎂" => "microamp", "㎃" => "mA", "㎄" => "kA", "㎅" => "kB", "㎆" => "MB", "㎇" => "GB",
    "㎈" => "cal", "㎉" => "kcal", "㎊" => "pF", "㎋" => "nF", "㎌" => "microFarad", "㎍" => "microgram",
    "㎎" => "mg", "㎏" => "kg", "㎐" => "Hz", "㎑" => "kHz", "㎒" => "MHz", "㎓" => "GHz",
    "㎔" => "THz", "㎕" => "microliter", "㎖" => "ml", "㎗" => "dl", "㎘" => "kl", "㎙" => "fm",
    "㎚" => "nm", "㎛" => "micrometer", "㎜" => "mm", "㎝" => "cm", "㎞" => "km", "㎟" => "mm^2",
    "㎠" => "cm^2", "㎡" => "m^2", "㎢" => "km^2", "㎣" => "mm^4", "㎤" => "cm^3", "㎥" => "m^3",
    "㎦" => "km^3", "㎧" => "m/s", "㎨" => "m/s^2", "㎩" => "Pa", "㎪" => "kPa", "㎫" => "MPa",
    "㎬" => "GPa", "㎭" => "rad", "㎮" => "rad/s", "㎯" => "rad/s^2", "㎰" => "ps", "㎱" => "ns",
    "㎲" => "microsecond", "㎳" => "ms", "㎴" => "pV", "㎵" => "nV", "㎶" => "microvolt", "㎷" => "mV",
    "㎸" => "kV", "㎹" => "MV", "㎺" => "pW", "㎻" => "nW", "㎼" => "microwatt", "㎽" => "mW",
    "㎾" => "kW", "㎿" => "MW", "㏀" => "kOhm", "㏁" => "MOhm", "㏂" => "a.m.", "㏃" => "Bq",
    "㏄" => "cc", "㏅" => "cd", "㏆" => "C/kg", "㏇" => "Co.", "㏈" => "dB", "㏉" => "Gy",
    "㏊" => "ha", "㏋" => "HP", "㏌" => "in", "㏍" => "K.K.", "㏎" => "KM", "㏏" => "kt",
    "㏐" => "lm", "㏑" => "ln", "㏒" => "log", "㏓" => "lx", "㏔" => "mb", "㏕" => "mil",
    "㏖" => "mol", "㏗" => "pH", "㏘" => "p.m.", "㏙" => "PPM", "㏚" => "PR", "㏛" => "sr",
    "㏜" => "Sv", "㏝" => "Wb", "㏠" => "1d", "㏡" => "2d", "㏢" => "3d", "㏣" => "4d",
    "㏤" => "5d", "㏥" => "6d", "㏦" => "7d", "㏧" => "8d", "㏨" => "9d", "㏩" => "10d",
    "㏪" => "11d", "㏫" => "12d", "㏬" => "13d", "㏭" => "14d", "㏮" => "15d", "㏯" => "16d",
    "㏰" => "17d", "㏱" => "18d", "㏲" => "19d", "㏳" => "20d", "㏴" => "21d", "㏵" => "22d",
    "㏶" => "23d", "㏷" => "24d", "㏸" => "25d", "㏹" => "26d", "㏺" => "27d", "㏻" => "28d",
    "㏼" => "29d", "㏽" => "30d", "㏾" => "31d", "丁" => "Ding", "丂" => "Kao", "七" => "Qi",
    "丄" => "Shang", "丅" => "Xia", "万" => "Mo", "丈" => "Zhang", "三" => "San", "上" => "Shang",
    "下" => "Xia", "丌" => "Ji", "不" => "Bu", "与" => "Yu", "丏" => "Mian", "丐" => "Gai",
    "丑" => "Chou", "丒" => "Chou", "专" => "Zhuan", "且" => "Qie", "丕" => "Pi", "世" => "Shi",
    "丗" => "Shi", "丘" => "Qiu", "丙" => "Bing", "业" => "Ye", "丛" => "Cong", "东" => "Dong",
    "丝" => "Si", "丞" => "Cheng", "丟" => "Diu", "丠" => "Qiu", "両" => "Liang", "丢" => "Diu",
    "丣" => "You", "两" => "Liang", "严" => "Yan", "並" => "Bing", "丧" => "Sang", "丨" => "Gun",
    "丩" => "Jiu", "个" => "Ge", "丫" => "Ya", "丬" => "Qiang", "中" => "Zhong", "丮" => "Ji",
    "丯" => "Jie", "丰" => "Feng", "丱" => "Guan", "串" => "Chuan", "丳" => "Chan", "临" => "Lin",
    "丵" => "Zhuo", "丶" => "Zhu", "丷" => "Ha", "丸" => "Wan", "丹" => "Dan", "为" => "Wei",
    "主" => "Zhu", "丼" => "Jing", "丽" => "Li", "举" => "Ju", "丿" => "Pie", "乀" => "Fu",
    "乁" => "Yi", "乂" => "Yi", "乃" => "Nai", "乄" => "Shime", "久" => "Jiu", "乆" => "Jiu",
    "乇" => "Zhe", "么" => "Yao", "义" => "Yi", "之" => "Zhi", "乌" => "Wu", "乍" => "Zha",
    "乎" => "Hu", "乏" => "Fa", "乐" => "Le", "乑" => "Zhong", "乒" => "Ping", "乓" => "Pang",
    "乔" => "Qiao", "乕" => "Hu", "乖" => "Guai", "乗" => "Cheng", "乘" => "Cheng", "乙" => "Yi",
    "乚" => "Yin", "乜" => "Mie", "九" => "Jiu", "乞" => "Qi", "也" => "Ye", "习" => "Xi",
    "乡" => "Xiang", "乢" => "Gai", "乣" => "Diu", "乤" => "Hal", "书" => "Shu", "乧" => "Twul",
    "乨" => "Shi", "乩" => "Ji", "乪" => "Nang", "乫" => "Jia", "乬" => "Kel", "乭" => "Shi",
    "乯" => "Ol", "买" => "Mai", "乱" => "Luan", "乲" => "Cal", "乳" => "Ru", "乴" => "Xue",
    "乵" => "Yan", "乶" => "Fu", "乷" => "Sha", "乸" => "Na", "乹" => "Gan", "乺" => "Sol",
    "乻" => "El", "乼" => "Cwul", "乾" => "Gan", "乿" => "Chi", "亀" => "Gui", "亁" => "Gan",
    "亂" => "Luan", "亃" => "Lin", "亄" => "Yi", "亅" => "Jue", "了" => "Liao", "亇" => "Ma",
    "予" => "Yu", "争" => "Zheng", "亊" => "Shi", "事" => "Shi", "二" => "Er", "亍" => "Chu",
    "于" => "Yu", "亏" => "Yu", "亐" => "Yu", "云" => "Yun", "互" => "Hu", "亓" => "Qi",
    "五" => "Wu", "井" => "Jing", "亖" => "Si", "亗" => "Sui", "亘" => "Gen", "亙" => "Gen",
    "亚" => "Ya", "些" => "Xie", "亜" => "Ya", "亝" => "Qi", "亞" => "Ya", "亟" => "Ji",
    "亠" => "Tou", "亡" => "Wang", "亢" => "Kang", "亣" => "Ta", "交" => "Jiao", "亥" => "Hai",
    "亦" => "Yi", "产" => "Chan", "亨" => "Heng", "亩" => "Mu", "享" => "Xiang", "京" => "Jing",
    "亭" => "Ting", "亮" => "Liang", "亯" => "Xiang", "亰" => "Jing", "亱" => "Ye", "亲" => "Qin",
    "亳" => "Bo", "亴" => "You", "亵" => "Xie", "亶" => "Dan", "亷" => "Lian", "亸" => "Duo",
    "亹" => "Wei", "人" => "Ren", "亻" => "Ren", "亼" => "Ji", "亽" => "La", "亾" => "Wang",
    "亿" => "Yi", "什" => "Shi", "仁" => "Ren", "仂" => "Le", "仃" => "Ding", "仄" => "Ze",
    "仅" => "Jin", "仆" => "Pu", "仇" => "Chou", "仈" => "Ba", "仉" => "Zhang", "今" => "Jin",
    "介" => "Jie", "仌" => "Bing", "仍" => "Reng", "从" => "Cong", "仏" => "Fo", "仐" => "San",
    "仑" => "Lun", "仒" => "Sya", "仓" => "Cang", "仔" => "Zi", "仕" => "Shi", "他" => "Ta",
    "仗" => "Zhang", "付" => "Fu", "仙" => "Xian", "仚" => "Xian", "仛" => "Tuo", "仜" => "Hong",
    "仝" => "Tong", "仞" => "Ren", "仟" => "Qian", "仠" => "Gan", "仡" => "Yi", "仢" => "Di",
    "代" => "Dai", "令" => "Ling", "以" => "Yi", "仦" => "Chao", "仧" => "Chang", "仨" => "Sa",
    "仪" => "Yi", "仫" => "Mu", "们" => "Men", "仭" => "Ren", "仮" => "Jia", "仯" => "Chao",
    "仰" => "Yang", "仱" => "Qian", "仲" => "Zhong", "仳" => "Pi", "仴" => "Wan", "仵" => "Wu",
    "件" => "Jian", "价" => "Jie", "仸" => "Yao", "仹" => "Feng", "仺" => "Cang", "任" => "Ren",
    "仼" => "Wang", "份" => "Fen", "仾" => "Di", "仿" => "Fang", "企" => "Qi", "伂" => "Pei",
    "伃" => "Yu", "伄" => "Diao", "伅" => "Dun", "伆" => "Wen", "伇" => "Yi", "伈" => "Xin",
    "伉" => "Kang", "伊" => "Yi", "伋" => "Ji", "伌" => "Ai", "伍" => "Wu", "伎" => "Ji",
    "伏" => "Fu", "伐" => "Fa", "休" => "Xiu", "伒" => "Jin", "伓" => "Bei", "伔" => "Dan",
    "伕" => "Fu", "伖" => "Tang", "众" => "Zhong", "优" => "You", "伙" => "Huo", "会" => "Hui",
    "伛" => "Yu", "伜" => "Cui", "伝" => "Chuan", "伞" => "San", "伟" => "Wei", "传" => "Chuan",
    "伡" => "Che", "伢" => "Ya", "伣" => "Xian", "伤" => "Shang", "伥" => "Chang", "伦" => "Lun",
    "伧" => "Cang", "伨" => "Xun", "伩" => "Xin", "伪" => "Wei", "伫" => "Zhu", "伭" => "Xuan",
    "伮" => "Nu", "伯" => "Bo", "估" => "Gu", "伱" => "Ni", "伲" => "Ni", "伳" => "Xie",
    "伴" => "Ban", "伵" => "Xu", "伶" => "Ling", "伷" => "Zhou", "伸" => "Shen", "伹" => "Qu",
    "伺" => "Si", "伻" => "Beng", "似" => "Si", "伽" => "Jia", "伾" => "Pi", "伿" => "Yi",
    "佀" => "Si", "佁" => "Ai", "佂" => "Zheng", "佃" => "Dian", "佄" => "Han", "佅" => "Mai",
    "但" => "Dan", "佇" => "Zhu", "佈" => "Bu", "佉" => "Qu", "佊" => "Bi", "佋" => "Shao",
    "佌" => "Ci", "位" => "Wei", "低" => "Di", "住" => "Zhu", "佐" => "Zuo", "佑" => "You",
    "佒" => "Yang", "体" => "Ti", "佔" => "Zhan", "何" => "He", "佖" => "Bi", "佗" => "Tuo",
    "佘" => "She", "余" => "Yu", "佚" => "Yi", "佛" => "Fo", "作" => "Zuo", "佝" => "Kou",
    "佞" => "Ning", "佟" => "Tong", "你" => "Ni", "佡" => "Xuan", "佢" => "Qu", "佣" => "Yong",
    "佤" => "Wa", "佥" => "Qian", "佧" => "Ka", "佩" => "Pei", "佪" => "Huai", "佫" => "He",
    "佬" => "Lao", "佭" => "Xiang", "佮" => "Ge", "佯" => "Yang", "佰" => "Bai", "佱" => "Fa",
    "佲" => "Ming", "佳" => "Jia", "佴" => "Er", "併" => "Bing", "佶" => "Ji", "佷" => "Hen",
    "佸" => "Huo", "佹" => "Gui", "佺" => "Quan", "佻" => "Tiao", "佼" => "Jiao", "佽" => "Ci",
    "佾" => "Yi", "使" => "Shi", "侀" => "Xing", "侁" => "Shen", "侂" => "Tuo", "侃" => "Kan",
    "侄" => "Zhi", "侅" => "Gai", "來" => "Lai", "侇" => "Yi", "侈" => "Chi", "侉" => "Kua",
    "侊" => "Guang", "例" => "Li", "侌" => "Yin", "侍" => "Shi", "侎" => "Mi", "侏" => "Zhu",
    "侐" => "Xu", "侑" => "You", "侒" => "An", "侓" => "Lu", "侔" => "Mou", "侕" => "Er",
    "侖" => "Lun", "侗" => "Tong", "侘" => "Cha", "侙" => "Chi", "侚" => "Xun", "供" => "Gong",
    "侜" => "Zhou", "依" => "Yi", "侞" => "Ru", "侟" => "Jian", "侠" => "Xia", "価" => "Jia",
    "侢" => "Zai", "侣" => "Lu", "侤" => "Ko", "侥" => "Jiao", "侦" => "Zhen", "侧" => "Ce",
    "侨" => "Qiao", "侩" => "Kuai", "侪" => "Chai", "侫" => "Ning", "侬" => "Nong", "侭" => "Jin",
    "侮" => "Wu", "侯" => "Hou", "侰" => "Jiong", "侱" => "Cheng", "侲" => "Zhen", "侳" => "Zuo",
    "侴" => "Chou", "侵" => "Qin", "侶" => "Lu", "侷" => "Ju", "侸" => "Shu", "侹" => "Ting",
    "侺" => "Shen", "侻" => "Tuo", "侼" => "Bo", "侽" => "Nan", "侾" => "Hao", "便" => "Bian",
    "俀" => "Tui", "俁" => "Yu", "係" => "Xi", "促" => "Cu", "俄" => "E", "俅" => "Qiu",
    "俆" => "Xu", "俇" => "Kuang", "俈" => "Ku", "俉" => "Wu", "俊" => "Jun", "俋" => "Yi",
    "俌" => "Fu", "俍" => "Lang", "俎" => "Zu", "俏" => "Qiao", "俐" => "Li", "俑" => "Yong",
    "俒" => "Hun", "俓" => "Jing", "俔" => "Xian", "俕" => "San", "俖" => "Pai", "俗" => "Su",
    "俘" => "Fu", "俙" => "Xi", "俚" => "Li", "俛" => "Fu", "俜" => "Ping", "保" => "Bao",
    "俞" => "Yu", "俟" => "Si", "俠" => "Xia", "信" => "Xin", "俢" => "Xiu", "俣" => "Yu",
    "俤" => "Ti", "俥" => "Che", "俦" => "Chou", "俨" => "Yan", "俩" => "Lia", "俪" => "Li",
    "俫" => "Lai", "俭" => "Jian", "修" => "Xiu", "俯" => "Fu", "俰" => "He", "俱" => "Ju",
    "俲" => "Xiao", "俳" => "Pai", "俴" => "Jian", "俵" => "Biao", "俶" => "Chu", "俷" => "Fei",
    "俸" => "Feng", "俹" => "Ya", "俺" => "An", "俻" => "Bei", "俼" => "Yu", "俽" => "Xin",
    "俾" => "Bi", "俿" => "Jian", "倁" => "Chi", "倂" => "Bing", "倃" => "Zan", "倄" => "Yao",
    "倅" => "Cui", "倆" => "Lia", "倇" => "Wan", "倈" => "Lai", "倉" => "Cang", "倊" => "Zong",
    "個" => "Ge", "倌" => "Guan", "倍" => "Bei", "倎" => "Tian", "倏" => "Shu", "倐" => "Shu",
    "們" => "Men", "倒" => "Dao", "倓" => "Tan", "倔" => "Jue", "倕" => "Chui", "倖" => "Xing",
    "倗" => "Peng", "倘" => "Tang", "候" => "Hou", "倚" => "Yi", "倛" => "Qi", "倜" => "Ti",
    "倝" => "Gan", "倞" => "Jing", "借" => "Jie", "倠" => "Sui", "倡" => "Chang", "倢" => "Jie",
    "倣" => "Fang", "値" => "Zhi", "倥" => "Kong", "倦" => "Juan", "倧" => "Zong", "倨" => "Ju",
    "倩" => "Qian", "倪" => "Ni", "倫" => "Lun", "倬" => "Zhuo", "倭" => "Wei", "倮" => "Luo",
    "倯" => "Song", "倰" => "Leng", "倱" => "Hun", "倲" => "Dong", "倳" => "Zi", "倴" => "Ben",
    "倵" => "Wu", "倶" => "Ju", "倷" => "Nai", "倸" => "Cai", "倹" => "Jian", "债" => "Zhai",
    "倻" => "Ye", "值" => "Zhi", "倽" => "Sha", "倾" => "Qing", "偀" => "Ying", "偁" => "Cheng",
    "偂" => "Jian", "偃" => "Yan", "偄" => "Nuan", "偅" => "Zhong", "偆" => "Chun", "假" => "Jia",
    "偈" => "Jie", "偉" => "Wei", "偊" => "Yu", "偋" => "Bing", "偌" => "Ruo", "偍" => "Ti",
    "偎" => "Wei", "偏" => "Pian", "偐" => "Yan", "偑" => "Feng", "偒" => "Tang", "偓" => "Wo",
    "偔" => "E", "偕" => "Xie", "偖" => "Che", "偗" => "Sheng", "偘" => "Kan", "偙" => "Di",
    "做" => "Zuo", "偛" => "Cha", "停" => "Ting", "偝" => "Bei", "偞" => "Ye", "偟" => "Huang",
    "偠" => "Yao", "偡" => "Zhan", "偢" => "Chou", "偣" => "Yan", "偤" => "You", "健" => "Jian",
    "偦" => "Xu", "偧" => "Zha", "偨" => "Ci", "偩" => "Fu", "偪" => "Bi", "偫" => "Zhi",
    "偬" => "Zong", "偭" => "Mian", "偮" => "Ji", "偯" => "Yi", "偰" => "Xie", "偱" => "Xun",
    "偲" => "Si", "偳" => "Duan", "側" => "Ce", "偵" => "Zhen", "偶" => "Ou", "偷" => "Tou",
    "偸" => "Tou", "偹" => "Bei", "偺" => "Za", "偻" => "Lu", "偼" => "Jie", "偽" => "Wei",
    "偾" => "Fen", "偿" => "Chang", "傀" => "Gui", "傁" => "Sou", "傂" => "Zhi", "傃" => "Su",
    "傄" => "Xia", "傅" => "Fu", "傆" => "Yuan", "傇" => "Rong", "傈" => "Li", "傉" => "Ru",
    "傊" => "Yun", "傋" => "Gou", "傌" => "Ma", "傍" => "Bang", "傎" => "Dian", "傏" => "Tang",
    "傐" => "Hao", "傑" => "Jie", "傒" => "Xi", "傓" => "Shan", "傔" => "Qian", "傕" => "Jue",
    "傖" => "Cang", "傗" => "Chu", "傘" => "San", "備" => "Bei", "傚" => "Xiao", "傛" => "Yong",
    "傜" => "Yao", "傝" => "Tan", "傞" => "Suo", "傟" => "Yang", "傠" => "Fa", "傡" => "Bing",
    "傢" => "Jia", "傣" => "Dai", "傤" => "Zai", "傥" => "Tang", "傧" => "Bin", "储" => "Chu",
    "傩" => "Nuo", "傪" => "Can", "傫" => "Lei", "催" => "Cui", "傭" => "Yong", "傮" => "Zao",
    "傯" => "Zong", "傰" => "Peng", "傱" => "Song", "傲" => "Ao", "傳" => "Chuan", "傴" => "Yu",
    "債" => "Zhai", "傶" => "Cou", "傷" => "Shang", "傸" => "Qiang", "傹" => "Jing", "傺" => "Chi",
    "傻" => "Sha", "傼" => "Han", "傽" => "Zhang", "傾" => "Qing", "傿" => "Yan", "僀" => "Di",
    "僁" => "Xi", "僂" => "Lu", "僃" => "Bei", "僄" => "Piao", "僅" => "Jin", "僆" => "Lian",
    "僇" => "Lu", "僈" => "Man", "僉" => "Qian", "僊" => "Xian", "僋" => "Tan", "僌" => "Ying",
    "働" => "Dong", "僎" => "Zhuan", "像" => "Xiang", "僐" => "Shan", "僑" => "Qiao", "僒" => "Jiong",
    "僓" => "Tui", "僔" => "Zun", "僕" => "Pu", "僖" => "Xi", "僗" => "Lao", "僘" => "Chang",
    "僙" => "Guang", "僚" => "Liao", "僛" => "Qi", "僜" => "Deng", "僝" => "Chan", "僞" => "Wei",
    "僟" => "Ji", "僠" => "Fan", "僡" => "Hui", "僢" => "Chuan", "僣" => "Jian", "僤" => "Dan",
    "僥" => "Jiao", "僦" => "Jiu", "僧" => "Seng", "僨" => "Fen", "僩" => "Xian", "僪" => "Jue",
    "僫" => "E", "僬" => "Jiao", "僭" => "Jian", "僮" => "Tong", "僯" => "Lin", "僰" => "Bo",
    "僱" => "Gu", "僳" => "Su", "僴" => "Xian", "僵" => "Jiang", "僶" => "Min", "僷" => "Ye",
    "僸" => "Jin", "價" => "Jia", "僺" => "Qiao", "僻" => "Pi", "僼" => "Feng", "僽" => "Zhou",
    "僾" => "Ai", "僿" => "Sai", "儁" => "Jun", "儂" => "Nong", "儃" => "Chan", "億" => "Yi",
    "儅" => "Dang", "儆" => "Jing", "儇" => "Xuan", "儈" => "Kuai", "儉" => "Jian", "儊" => "Chu",
    "儋" => "Dan", "儌" => "Jiao", "儍" => "Sha", "儎" => "Zai", "儐" => "Bin", "儑" => "An",
    "儒" => "Ru", "儓" => "Tai", "儔" => "Chou", "儕" => "Chai", "儖" => "Lan", "儗" => "Ni",
    "儘" => "Jin", "儙" => "Qian", "儚" => "Meng", "儛" => "Wu", "儜" => "Ning", "儝" => "Qiong",
    "儞" => "Ni", "償" => "Chang", "儠" => "Lie", "儡" => "Lei", "儢" => "Lu", "儣" => "Kuang",
    "儤" => "Bao", "儥" => "Du", "儦" => "Biao", "儧" => "Zan", "儨" => "Zhi", "儩" => "Si",
    "優" => "You", "儫" => "Hao", "儬" => "Chen", "儭" => "Chen", "儮" => "Li", "儯" => "Teng",
    "儰" => "Wei", "儱" => "Long", "儲" => "Chu", "儳" => "Chan", "儴" => "Rang", "儵" => "Shu",
    "儶" => "Hui", "儷" => "Li", "儸" => "Luo", "儹" => "Zan", "儺" => "Nuo", "儻" => "Tang",
    "儼" => "Yan", "儽" => "Lei", "儾" => "Nang", "儿" => "Er", "兀" => "Wu", "允" => "Yun",
    "兂" => "Zan", "元" => "Yuan", "兄" => "Xiong", "充" => "Chong", "兆" => "Zhao", "兇" => "Xiong",
    "先" => "Xian", "光" => "Guang", "兊" => "Dui", "克" => "Ke", "兌" => "Dui", "免" => "Mian",
    "兎" => "Tu", "兏" => "Chang", "児" => "Er", "兑" => "Dui", "兒" => "Er", "兓" => "Xin",
    "兔" => "Tu", "兕" => "Si", "兖" => "Yan", "兗" => "Yan", "兘" => "Shi", "兙" => "Shi",
    "党" => "Dang", "兛" => "Qian", "兜" => "Dou", "兝" => "Fen", "兞" => "Mao", "兟" => "Shen",
    "兠" => "Dou", "兡" => "Bai", "兢" => "Jing", "兣" => "Li", "兤" => "Huang", "入" => "Ru",
    "兦" => "Wang", "內" => "Nei", "全" => "Quan", "兩" => "Liang", "兪" => "Yu", "八" => "Ba",
    "公" => "Gong", "六" => "Liu", "兮" => "Xi", "兰" => "Lan", "共" => "Gong", "兲" => "Tian",
    "关" => "Guan", "兴" => "Xing", "兵" => "Bing", "其" => "Qi", "具" => "Ju", "典" => "Dian",
    "兹" => "Zi", "兺" => "Ppwun", "养" => "Yang", "兼" => "Jian", "兽" => "Shou", "兾" => "Ji",
    "兿" => "Yi", "冀" => "Ji", "冁" => "Chan", "冂" => "Jiong", "冃" => "Mao", "冄" => "Ran",
    "内" => "Nei", "円" => "Yuan", "冇" => "Mao", "冈" => "Gang", "冉" => "Ran", "冊" => "Ce",
    "冋" => "Jiong", "册" => "Ce", "再" => "Zai", "冎" => "Gua", "冏" => "Jiong", "冐" => "Mao",
    "冑" => "Zhou", "冒" => "Mou", "冓" => "Gou", "冔" => "Xu", "冕" => "Mian", "冖" => "Mi",
    "冗" => "Rong", "冘" => "Yin", "写" => "Xie", "冚" => "Kan", "军" => "Jun", "农" => "Nong",
    "冝" => "Yi", "冞" => "Mi", "冟" => "Shi", "冠" => "Guan", "冡" => "Meng", "冢" => "Zhong",
    "冣" => "Ju", "冤" => "Yuan", "冥" => "Ming", "冦" => "Kou", "冧" => "Lam", "冨" => "Fu",
    "冩" => "Xie", "冪" => "Mi", "冫" => "Bing", "冬" => "Dong", "冭" => "Tai", "冮" => "Gang",
    "冯" => "Feng", "冰" => "Bing", "冱" => "Hu", "冲" => "Chong", "决" => "Jue", "冴" => "Hu",
    "况" => "Kuang", "冶" => "Ye", "冷" => "Leng", "冸" => "Pan", "冹" => "Fu", "冺" => "Min",
    "冻" => "Dong", "冼" => "Xian", "冽" => "Lie", "冾" => "Xia", "冿" => "Jian", "净" => "Jing",
    "凁" => "Shu", "凂" => "Mei", "凃" => "Tu", "凄" => "Qi", "凅" => "Gu", "准" => "Zhun",
    "凇" => "Song", "凈" => "Jing", "凉" => "Liang", "凊" => "Qing", "凋" => "Diao", "凌" => "Ling",
    "凍" => "Dong", "凎" => "Gan", "减" => "Jian", "凐" => "Yin", "凑" => "Cou", "凒" => "Yi",
    "凓" => "Li", "凔" => "Cang", "凕" => "Ming", "凖" => "Zhuen", "凗" => "Cui", "凘" => "Si",
    "凙" => "Duo", "凚" => "Jin", "凛" => "Lin", "凜" => "Lin", "凝" => "Ning", "凞" => "Xi",
    "凟" => "Du", "几" => "Ji", "凡" => "Fan", "凢" => "Fan", "凣" => "Fan", "凤" => "Feng",
    "凥" => "Ju", "処" => "Chu", "凧" => "Tako", "凨" => "Feng", "凩" => "Mok", "凪" => "Ci",
    "凫" => "Fu", "凬" => "Feng", "凭" => "Ping", "凮" => "Feng", "凯" => "Kai", "凰" => "Huang",
    "凱" => "Kai", "凲" => "Gan", "凳" => "Deng", "凴" => "Ping", "凵" => "Qu", "凶" => "Xiong",
    "凷" => "Kuai", "凸" => "Tu", "凹" => "Ao", "出" => "Chu", "击" => "Ji", "凼" => "Dang",
    "函" => "Han", "凾" => "Han", "凿" => "Zao", "刁" => "Diao", "刂" => "Dao", "刃" => "Ren",
    "刄" => "Ren", "刅" => "Chuang", "分" => "Fen", "切" => "Qie", "刈" => "Yi", "刉" => "Ji",
    "刊" => "Kan", "刋" => "Qian", "刌" => "Cun", "刍" => "Chu", "刎" => "Wen", "刏" => "Ji",
    "刐" => "Dan", "刑" => "Xing", "划" => "Hua", "刓" => "Wan", "刔" => "Jue", "刕" => "Li",
    "刖" => "Yue", "列" => "Lie", "刘" => "Liu", "则" => "Ze", "刚" => "Gang", "创" => "Chuang",
    "刜" => "Fu", "初" => "Chu", "刞" => "Qu", "刟" => "Ju", "删" => "Shan", "刡" => "Min",
    "刢" => "Ling", "刣" => "Zhong", "判" => "Pan", "別" => "Bie", "刦" => "Jie", "刧" => "Jie",
    "刨" => "Bao", "利" => "Li", "刪" => "Shan", "别" => "Bie", "刬" => "Chan", "刭" => "Jing",
    "刮" => "Gua", "刯" => "Gen", "到" => "Dao", "刱" => "Chuang", "刲" => "Kui", "刳" => "Ku",
    "刴" => "Duo", "刵" => "Er", "制" => "Zhi", "刷" => "Shua", "券" => "Quan", "刹" => "Cha",
    "刺" => "Ci", "刻" => "Ke", "刼" => "Jie", "刽" => "Gui", "刾" => "Ci", "刿" => "Gui",
    "剀" => "Kai", "剁" => "Duo", "剂" => "Ji", "剃" => "Ti", "剄" => "Jing", "剅" => "Lou",
    "剆" => "Gen", "則" => "Ze", "剈" => "Yuan", "剉" => "Cuo", "削" => "Xue", "剋" => "Ke",
    "剌" => "La", "前" => "Qian", "剎" => "Cha", "剏" => "Chuang", "剐" => "Gua", "剑" => "Jian",
    "剒" => "Cuo", "剓" => "Li", "剔" => "Ti", "剕" => "Fei", "剖" => "Pou", "剗" => "Chan",
    "剘" => "Qi", "剙" => "Chuang", "剚" => "Zi", "剛" => "Gang", "剜" => "Wan", "剝" => "Bo",
    "剞" => "Ji", "剟" => "Duo", "剠" => "Qing", "剡" => "Yan", "剢" => "Zhuo", "剣" => "Jian",
    "剤" => "Ji", "剥" => "Bo", "剦" => "Yan", "剧" => "Ju", "剨" => "Huo", "剩" => "Sheng",
    "剪" => "Jian", "剫" => "Duo", "剬" => "Duan", "剭" => "Wu", "剮" => "Gua", "副" => "Fu",
    "剰" => "Sheng", "剱" => "Jian", "割" => "Ge", "剳" => "Zha", "剴" => "Kai", "創" => "Chuang",
    "剶" => "Juan", "剷" => "Chan", "剸" => "Tuan", "剹" => "Lu", "剺" => "Li", "剻" => "Fou",
    "剼" => "Shan", "剽" => "Piao", "剾" => "Kou", "剿" => "Jiao", "劀" => "Gua", "劁" => "Qiao",
    "劂" => "Jue", "劃" => "Hua", "劄" => "Zha", "劅" => "Zhuo", "劆" => "Lian", "劇" => "Ju",
    "劈" => "Pi", "劉" => "Liu", "劊" => "Gui", "劋" => "Jiao", "劌" => "Gui", "劍" => "Jian",
    "劎" => "Jian", "劏" => "Tang", "劐" => "Huo", "劑" => "Ji", "劒" => "Jian", "劓" => "Yi",
    "劔" => "Jian", "劕" => "Zhi", "劖" => "Chan", "劗" => "Cuan", "劘" => "Mo", "劙" => "Li",
    "劚" => "Zhu", "力" => "Li", "劜" => "Ya", "劝" => "Quan", "办" => "Ban", "功" => "Gong",
    "加" => "Jia", "务" => "Wu", "劢" => "Mai", "劣" => "Lie", "劤" => "Jin", "劥" => "Keng",
    "劦" => "Xie", "劧" => "Zhi", "动" => "Dong", "助" => "Zhu", "努" => "Nu", "劫" => "Jie",
    "劬" => "Qu", "劭" => "Shao", "劮" => "Yi", "劯" => "Zhu", "劰" => "Miao", "励" => "Li",
    "劲" => "Jing", "劳" => "Lao", "労" => "Lao", "劵" => "Juan", "劶" => "Kou", "劷" => "Yang",
    "劸" => "Wa", "効" => "Xiao", "劺" => "Mou", "劻" => "Kuang", "劼" => "Jie", "劽" => "Lie",
    "劾" => "He", "势" => "Shi", "勀" => "Ke", "勁" => "Jing", "勂" => "Hao", "勃" => "Bo",
    "勄" => "Min", "勅" => "Chi", "勆" => "Lang", "勇" => "Yong", "勈" => "Yong", "勉" => "Mian",
    "勊" => "Ke", "勋" => "Xun", "勌" => "Juan", "勍" => "Qing", "勎" => "Lu", "勏" => "Pou",
    "勐" => "Meng", "勑" => "Lai", "勒" => "Le", "勓" => "Kai", "勔" => "Mian", "動" => "Dong",
    "勖" => "Xu", "勗" => "Xu", "勘" => "Kan", "務" => "Wu", "勚" => "Yi", "勛" => "Xun",
    "勜" => "Weng", "勝" => "Sheng", "勞" => "Lao", "募" => "Mu", "勠" => "Lu", "勡" => "Piao",
    "勢" => "Shi", "勣" => "Ji", "勤" => "Qin", "勥" => "Qiang", "勦" => "Jiao", "勧" => "Quan",
    "勨" => "Yang", "勩" => "Yi", "勪" => "Jue", "勫" => "Fan", "勬" => "Juan", "勭" => "Tong",
    "勮" => "Ju", "勯" => "Dan", "勰" => "Xie", "勱" => "Mai", "勲" => "Xun", "勳" => "Xun",
    "勴" => "Lu", "勵" => "Li", "勶" => "Che", "勷" => "Rang", "勸" => "Quan", "勹" => "Bao",
    "勺" => "Shao", "勻" => "Yun", "勼" => "Jiu", "勽" => "Bao", "勾" => "Gou", "勿" => "Wu",
    "匁" => "Mwun", "匂" => "Nay", "匃" => "Gai", "匄" => "Gai", "包" => "Bao", "匆" => "Cong",
    "匈" => "Xiong", "匉" => "Peng", "匊" => "Ju", "匋" => "Tao", "匌" => "Ge", "匍" => "Pu",
    "匎" => "An", "匏" => "Pao", "匐" => "Fu", "匑" => "Gong", "匒" => "Da", "匓" => "Jiu",
    "匔" => "Qiong", "匕" => "Bi", "化" => "Hua", "北" => "Bei", "匘" => "Nao", "匙" => "Chi",
    "匚" => "Fang", "匛" => "Jiu", "匜" => "Yi", "匝" => "Za", "匞" => "Jiang", "匟" => "Kang",
    "匠" => "Jiang", "匡" => "Kuang", "匢" => "Hu", "匣" => "Xia", "匤" => "Qu", "匥" => "Bian",
    "匦" => "Gui", "匧" => "Qie", "匨" => "Zang", "匩" => "Kuang", "匪" => "Fei", "匫" => "Hu",
    "匬" => "Tou", "匭" => "Gui", "匮" => "Gui", "匯" => "Hui", "匰" => "Dan", "匱" => "Gui",
    "匲" => "Lian", "匳" => "Lian", "匴" => "Suan", "匵" => "Du", "匶" => "Jiu", "匷" => "Qu",
    "匸" => "Xi", "匹" => "Pi", "区" => "Qu", "医" => "Yi", "匼" => "Qia", "匽" => "Yan",
    "匾" => "Bian", "匿" => "Ni", "區" => "Qu", "十" => "Shi", "卂" => "Xin", "千" => "Qian",
    "卄" => "Nian", "卅" => "Sa", "卆" => "Zu", "升" => "Sheng", "午" => "Wu", "卉" => "Hui",
    "半" => "Ban", "卋" => "Shi", "卌" => "Xi", "卍" => "Wan", "华" => "Hua", "协" => "Xie",
    "卐" => "Wan", "卑" => "Bei", "卒" => "Zu", "卓" => "Zhuo", "協" => "Xie", "单" => "Dan",
    "卖" => "Mai", "南" => "Nan", "単" => "Dan", "卙" => "Ji", "博" => "Bo", "卛" => "Shuai",
    "卜" => "Bu", "卝" => "Kuang", "卞" => "Bian", "卟" => "Bu", "占" => "Zhan", "卡" => "Qia",
    "卢" => "Lu", "卣" => "You", "卤" => "Lu", "卥" => "Xi", "卦" => "Gua", "卧" => "Wo",
    "卨" => "Xie", "卩" => "Jie", "卪" => "Jie", "卫" => "Wei", "卬" => "Ang", "卭" => "Qiong",
    "卮" => "Zhi", "卯" => "Mao", "印" => "Yin", "危" => "Wei", "卲" => "Shao", "即" => "Ji",
    "却" => "Que", "卵" => "Luan", "卶" => "Shi", "卷" => "Juan", "卸" => "Xie", "卹" => "Xu",
    "卺" => "Jin", "卻" => "Que", "卼" => "Wu", "卽" => "Ji", "卾" => "E", "卿" => "Qing",
    "厀" => "Xi", "厂" => "Han", "厃" => "Zhan", "厄" => "E", "厅" => "Ting", "历" => "Li",
    "厇" => "Zhe", "厈" => "Han", "厉" => "Li", "厊" => "Ya", "压" => "Ya", "厌" => "Yan",
    "厍" => "She", "厎" => "Zhi", "厏" => "Zha", "厐" => "Pang", "厒" => "He", "厓" => "Ya",
    "厔" => "Zhi", "厕" => "Ce", "厖" => "Pang", "厗" => "Ti", "厘" => "Li", "厙" => "She",
    "厚" => "Hou", "厛" => "Ting", "厜" => "Zui", "厝" => "Cuo", "厞" => "Fei", "原" => "Yuan",
    "厠" => "Ce", "厡" => "Yuan", "厢" => "Xiang", "厣" => "Yan", "厤" => "Li", "厥" => "Jue",
    "厦" => "Sha", "厧" => "Dian", "厨" => "Chu", "厩" => "Jiu", "厪" => "Qin", "厫" => "Ao",
    "厬" => "Gui", "厭" => "Yan", "厮" => "Si", "厯" => "Li", "厰" => "Chang", "厱" => "Lan",
    "厲" => "Li", "厳" => "Yan", "厴" => "Yan", "厵" => "Yuan", "厶" => "Si", "厷" => "Gong",
    "厸" => "Lin", "厹" => "Qiu", "厺" => "Qu", "去" => "Qu", "厼" => "Uk", "厽" => "Lei",
    "厾" => "Du", "县" => "Xian", "叀" => "Zhuan", "叁" => "San", "参" => "Can", "參" => "Can",
    "叄" => "Can", "叅" => "Can", "叆" => "Ai", "叇" => "Dai", "又" => "You", "叉" => "Cha",
    "及" => "Ji", "友" => "You", "双" => "Shuang", "反" => "Fan", "収" => "Shou", "叏" => "Guai",
    "叐" => "Ba", "发" => "Fa", "叒" => "Ruo", "叓" => "Shi", "叔" => "Shu", "叕" => "Zhuo",
    "取" => "Qu", "受" => "Shou", "变" => "Bian", "叙" => "Xu", "叚" => "Jia", "叛" => "Pan",
    "叜" => "Sou", "叝" => "Gao", "叞" => "Wei", "叟" => "Sou", "叠" => "Die", "叡" => "Rui",
    "叢" => "Cong", "口" => "Kou", "古" => "Gu", "句" => "Ju", "另" => "Ling", "叧" => "Gua",
    "叨" => "Tao", "叩" => "Kou", "只" => "Zhi", "叫" => "Jiao", "召" => "Zhao", "叭" => "Ba",
    "叮" => "Ding", "可" => "Ke", "台" => "Tai", "叱" => "Chi", "史" => "Shi", "右" => "You",
    "叴" => "Qiu", "叵" => "Po", "叶" => "Xie", "号" => "Hao", "司" => "Si", "叹" => "Tan",
    "叺" => "Chi", "叻" => "Le", "叼" => "Diao", "叽" => "Ji", "叿" => "Hong", "吁" => "Xu",
    "吂" => "Mang", "吃" => "Chi", "各" => "Ge", "吅" => "Xuan", "吆" => "Yao", "吇" => "Zi",
    "合" => "He", "吉" => "Ji", "吊" => "Diao", "吋" => "Cun", "同" => "Tong", "名" => "Ming",
    "后" => "Hou", "吏" => "Li", "吐" => "Tu", "向" => "Xiang", "吒" => "Zha", "吓" => "Xia",
    "吔" => "Ye", "吕" => "Lu", "吖" => "A", "吗" => "Ma", "吘" => "Ou", "吙" => "Xue",
    "吚" => "Yi", "君" => "Jun", "吜" => "Chou", "吝" => "Lin", "吞" => "Tun", "吟" => "Yin",
    "吠" => "Fei", "吡" => "Bi", "吢" => "Qin", "吣" => "Qin", "吤" => "Jie", "吥" => "Bu",
    "否" => "Fou", "吧" => "Ba", "吨" => "Dun", "吩" => "Fen", "吪" => "E", "含" => "Han",
    "听" => "Ting", "吭" => "Hang", "吮" => "Shun", "启" => "Qi", "吰" => "Hong", "吱" => "Zhi",
    "吲" => "Shen", "吳" => "Wu", "吴" => "Wu", "吵" => "Chao", "吶" => "Ne", "吷" => "Xue",
    "吸" => "Xi", "吹" => "Chui", "吺" => "Dou", "吻" => "Wen", "吼" => "Hou", "吽" => "Ou",
    "吾" => "Wu", "吿" => "Gao", "呀" => "Ya", "呁" => "Jun", "呂" => "Lu", "呃" => "E",
    "呄" => "Ge", "呅" => "Mei", "呆" => "Ai", "呇" => "Qi", "呈" => "Cheng", "呉" => "Wu",
    "告" => "Gao", "呋" => "Fu", "呌" => "Jiao", "呍" => "Hong", "呎" => "Chi", "呏" => "Sheng",
    "呐" => "Ne", "呑" => "Tun", "呒" => "Fu", "呓" => "Yi", "呔" => "Dai", "呕" => "Ou",
    "呖" => "Li", "呗" => "Bai", "员" => "Yuan", "呙" => "Kuai", "呛" => "Qiang", "呜" => "Wu",
    "呝" => "E", "呞" => "Shi", "呟" => "Quan", "呠" => "Pen", "呡" => "Wen", "呢" => "Ni",
    "呣" => "M", "呤" => "Ling", "呥" => "Ran", "呦" => "You", "呧" => "Di", "周" => "Zhou",
    "呩" => "Shi", "呪" => "Zhou", "呫" => "Tie", "呬" => "Xi", "呭" => "Yi", "呮" => "Qi",
    "呯" => "Ping", "呰" => "Zi", "呱" => "Gu", "呲" => "Zi", "味" => "Wei", "呴" => "Xu",
    "呵" => "He", "呶" => "Nao", "呷" => "Xia", "呸" => "Pei", "呹" => "Yi", "呺" => "Xiao",
    "呻" => "Shen", "呼" => "Hu", "命" => "Ming", "呾" => "Da", "呿" => "Qu", "咀" => "Ju",
    "咁" => "Gem", "咂" => "Za", "咃" => "Tuo", "咄" => "Duo", "咅" => "Pou", "咆" => "Pao",
    "咇" => "Bi", "咈" => "Fu", "咉" => "Yang", "咊" => "He", "咋" => "Zha", "和" => "He",
    "咍" => "Hai", "咎" => "Jiu", "咏" => "Yong", "咐" => "Fu", "咑" => "Que", "咒" => "Zhou",
    "咓" => "Wa", "咔" => "Ka", "咕" => "Gu", "咖" => "Ka", "咗" => "Zuo", "咘" => "Bu",
    "咙" => "Long", "咚" => "Dong", "咛" => "Ning", "咜" => "Tha", "咝" => "Si", "咞" => "Xian",
    "咟" => "Huo", "咠" => "Qi", "咡" => "Er", "咢" => "E", "咣" => "Guang", "咤" => "Zha",
    "咥" => "Xi", "咦" => "Yi", "咧" => "Lie", "咨" => "Zi", "咩" => "Mie", "咪" => "Mi",
    "咫" => "Zhi", "咬" => "Yao", "咭" => "Ji", "咮" => "Zhou", "咯" => "Ge", "咰" => "Shuai",
    "咱" => "Zan", "咲" => "Xiao", "咳" => "Ke", "咴" => "Hui", "咵" => "Kua", "咶" => "Huai",
    "咷" => "Tao", "咸" => "Xian", "咹" => "E", "咺" => "Xuan", "咻" => "Xiu", "咼" => "Wai",
    "咽" => "Yan", "咾" => "Lao", "咿" => "Yi", "哀" => "Ai", "品" => "Pin", "哂" => "Shen",
    "哃" => "Tong", "哄" => "Hong", "哅" => "Xiong", "哆" => "Chi", "哇" => "Wa", "哈" => "Ha",
    "哉" => "Zai", "哊" => "Yu", "哋" => "Di", "哌" => "Pai", "响" => "Xiang", "哎" => "Ai",
    "哏" => "Hen", "哐" => "Kuang", "哑" => "Ya", "哒" => "Da", "哓" => "Xiao", "哔" => "Bi",
    "哕" => "Yue", "哗" => "Hua", "哘" => "Sasou", "哙" => "Kuai", "哚" => "Duo", "哜" => "Ji",
    "哝" => "Nong", "哞" => "Mou", "哟" => "Yo", "哠" => "Hao", "員" => "Yuan", "哢" => "Long",
    "哣" => "Pou", "哤" => "Mang", "哥" => "Ge", "哦" => "E", "哧" => "Chi", "哨" => "Shao",
    "哩" => "Li", "哪" => "Na", "哫" => "Zu", "哬" => "He", "哭" => "Ku", "哮" => "Xiao",
    "哯" => "Xian", "哰" => "Lao", "哱" => "Bo", "哲" => "Zhe", "哳" => "Zha", "哴" => "Liang",
    "哵" => "Ba", "哶" => "Mie", "哷" => "Le", "哸" => "Sui", "哹" => "Fou", "哺" => "Bu",
    "哻" => "Han", "哼" => "Heng", "哽" => "Geng", "哾" => "Shuo", "哿" => "Ge", "唁" => "Yan",
    "唂" => "Gu", "唃" => "Gu", "唄" => "Bai", "唅" => "Han", "唆" => "Suo", "唇" => "Chun",
    "唈" => "Yi", "唉" => "Ai", "唊" => "Jia", "唋" => "Tu", "唌" => "Xian", "唍" => "Huan",
    "唎" => "Li", "唏" => "Xi", "唐" => "Tang", "唑" => "Zuo", "唒" => "Qiu", "唓" => "Che",
    "唔" => "Wu", "唕" => "Zao", "唖" => "Ya", "唗" => "Dou", "唘" => "Qi", "唙" => "Di",
    "唚" => "Qin", "唛" => "Ma", "唜" => "Mal", "唝" => "Hong", "唞" => "Dou", "唟" => "Kes",
    "唠" => "Lao", "唡" => "Liang", "唢" => "Suo", "唣" => "Zao", "唤" => "Huan", "唥" => "Lang",
    "唦" => "Sha", "唧" => "Ji", "唨" => "Zuo", "唩" => "Wo", "唪" => "Feng", "唫" => "Yin",
    "唬" => "Hu", "唭" => "Qi", "售" => "Shou", "唯" => "Wei", "唰" => "Shua", "唱" => "Chang",
    "唲" => "Er", "唳" => "Li", "唴" => "Qiang", "唵" => "An", "唶" => "Jie", "唷" => "Yo",
    "唸" => "Nian", "唹" => "Yu", "唺" => "Tian", "唻" => "Lai", "唼" => "Sha", "唽" => "Xi",
    "唾" => "Tuo", "唿" => "Hu", "啀" => "Ai", "啁" => "Zhou", "啂" => "Nou", "啃" => "Ken",
    "啄" => "Zhuo", "啅" => "Zhuo", "商" => "Shang", "啇" => "Di", "啈" => "Heng", "啉" => "Lan",
    "啊" => "A", "啋" => "Xiao", "啌" => "Xiang", "啍" => "Tun", "啎" => "Wu", "問" => "Wen",
    "啐" => "Cui", "啑" => "Sha", "啒" => "Hu", "啓" => "Qi", "啔" => "Qi", "啕" => "Tao",
    "啖" => "Dan", "啗" => "Dan", "啘" => "Ye", "啙" => "Zi", "啚" => "Bi", "啛" => "Cui",
    "啜" => "Chuo", "啝" => "He", "啞" => "Ya", "啟" => "Qi", "啠" => "Zhe", "啡" => "Pei",
    "啢" => "Liang", "啣" => "Xian", "啤" => "Pi", "啥" => "Sha", "啦" => "La", "啧" => "Ze",
    "啨" => "Qing", "啩" => "Gua", "啪" => "Pa", "啫" => "Zhe", "啬" => "Se", "啭" => "Zhuan",
    "啮" => "Nie", "啯" => "Guo", "啰" => "Luo", "啱" => "Yan", "啲" => "Di", "啳" => "Quan",
    "啴" => "Tan", "啵" => "Bo", "啶" => "Ding", "啷" => "Lang", "啸" => "Xiao", "啺" => "Tang",
    "啻" => "Chi", "啼" => "Ti", "啽" => "An", "啾" => "Jiu", "啿" => "Dan", "喀" => "Ke",
    "喁" => "Yong", "喂" => "Wei", "喃" => "Nan", "善" => "Shan", "喅" => "Yu", "喆" => "Zhe",
    "喇" => "La", "喈" => "Jie", "喉" => "Hou", "喊" => "Han", "喋" => "Die", "喌" => "Zhou",
    "喍" => "Chai", "喎" => "Wai", "喏" => "Re", "喐" => "Yu", "喑" => "Yin", "喒" => "Zan",
    "喓" => "Yao", "喔" => "Wo", "喕" => "Mian", "喖" => "Hu", "喗" => "Yun", "喘" => "Chuan",
    "喙" => "Hui", "喚" => "Huan", "喛" => "Huan", "喜" => "Xi", "喝" => "He", "喞" => "Ji",
    "喟" => "Kui", "喠" => "Zhong", "喡" => "Wei", "喢" => "Sha", "喣" => "Xu", "喤" => "Huang",
    "喥" => "Du", "喦" => "Nie", "喧" => "Xuan", "喨" => "Liang", "喩" => "Yu", "喪" => "Sang",
    "喫" => "Chi", "喬" => "Qiao", "喭" => "Yan", "單" => "Dan", "喯" => "Pen", "喰" => "Can",
    "喱" => "Li", "喲" => "Yo", "喳" => "Zha", "喴" => "Wei", "喵" => "Miao", "営" => "Ying",
    "喷" => "Pen", "喸" => "Phos", "喹" => "Kui", "喺" => "Xi", "喻" => "Yu", "喼" => "Jie",
    "喽" => "Lou", "喾" => "Ku", "喿" => "Sao", "嗀" => "Huo", "嗁" => "Ti", "嗂" => "Yao",
    "嗃" => "He", "嗄" => "A", "嗅" => "Xiu", "嗆" => "Qiang", "嗇" => "Se", "嗈" => "Yong",
    "嗉" => "Su", "嗊" => "Hong", "嗋" => "Xie", "嗌" => "Yi", "嗍" => "Suo", "嗎" => "Ma",
    "嗏" => "Cha", "嗐" => "Hai", "嗑" => "Ke", "嗒" => "Ta", "嗓" => "Sang", "嗔" => "Tian",
    "嗕" => "Ru", "嗖" => "Sou", "嗗" => "Wa", "嗘" => "Ji", "嗙" => "Pang", "嗚" => "Wu",
    "嗛" => "Xian", "嗜" => "Shi", "嗝" => "Ge", "嗞" => "Zi", "嗟" => "Jie", "嗠" => "Luo",
    "嗡" => "Weng", "嗢" => "Wa", "嗣" => "Si", "嗤" => "Chi", "嗥" => "Hao", "嗦" => "Suo",
    "嗧" => "Jia", "嗨" => "Hai", "嗩" => "Suo", "嗪" => "Qin", "嗫" => "Nie", "嗬" => "He",
    "嗭" => "Cis", "嗮" => "Sai", "嗯" => "Ng", "嗰" => "Ge", "嗱" => "Na", "嗲" => "Dia",
    "嗳" => "Ai", "嗵" => "Tong", "嗶" => "Bi", "嗷" => "Ao", "嗸" => "Ao", "嗹" => "Lian",
    "嗺" => "Cui", "嗻" => "Zhe", "嗼" => "Mo", "嗽" => "Sou", "嗾" => "Sou", "嗿" => "Tan",
    "嘁" => "Qi", "嘂" => "Jiao", "嘃" => "Chong", "嘄" => "Jiao", "嘅" => "Kai", "嘆" => "Tan",
    "嘇" => "San", "嘈" => "Cao", "嘉" => "Jia", "嘊" => "Ai", "嘋" => "Xiao", "嘌" => "Piao",
    "嘍" => "Lou", "嘎" => "Ga", "嘏" => "Gu", "嘐" => "Xiao", "嘑" => "Hu", "嘒" => "Hui",
    "嘓" => "Guo", "嘔" => "Ou", "嘕" => "Xian", "嘖" => "Ze", "嘗" => "Chang", "嘘" => "Xu",
    "嘙" => "Po", "嘚" => "De", "嘛" => "Ma", "嘜" => "Ma", "嘝" => "Hu", "嘞" => "Lei",
    "嘟" => "Du", "嘠" => "Ga", "嘡" => "Tang", "嘢" => "Ye", "嘣" => "Beng", "嘤" => "Ying",
    "嘥" => "Saai", "嘦" => "Jiao", "嘧" => "Mi", "嘨" => "Xiao", "嘩" => "Hua", "嘪" => "Mai",
    "嘫" => "Ran", "嘬" => "Zuo", "嘭" => "Peng", "嘮" => "Lao", "嘯" => "Xiao", "嘰" => "Ji",
    "嘱" => "Zhu", "嘲" => "Chao", "嘳" => "Kui", "嘴" => "Zui", "嘵" => "Xiao", "嘶" => "Si",
    "嘷" => "Hao", "嘸" => "Fu", "嘹" => "Liao", "嘺" => "Qiao", "嘻" => "Xi", "嘼" => "Xiu",
    "嘽" => "Tan", "嘾" => "Tan", "嘿" => "Mo", "噀" => "Xun", "噁" => "E", "噂" => "Zun",
    "噃" => "Fan", "噄" => "Chi", "噅" => "Hui", "噆" => "Zan", "噇" => "Chuang", "噈" => "Cu",
    "噉" => "Dan", "噊" => "Yu", "噋" => "Tun", "噌" => "Cheng", "噍" => "Jiao", "噎" => "Ye",
    "噏" => "Xi", "噐" => "Qi", "噑" => "Hao", "噒" => "Lian", "噓" => "Xu", "噔" => "Deng",
    "噕" => "Hui", "噖" => "Yin", "噗" => "Pu", "噘" => "Jue", "噙" => "Qin", "噚" => "Xun",
    "噛" => "Nie", "噜" => "Lu", "噝" => "Si", "噞" => "Yan", "噟" => "Ying", "噠" => "Da",
    "噡" => "Dan", "噢" => "Yu", "噣" => "Zhou", "噤" => "Jin", "噥" => "Nong", "噦" => "Yue",
    "噧" => "Hui", "器" => "Qi", "噩" => "E", "噪" => "Zao", "噫" => "Yi", "噬" => "Shi",
    "噭" => "Jiao", "噮" => "Yuan", "噯" => "Ai", "噰" => "Yong", "噱" => "Jue", "噲" => "Kuai",
    "噳" => "Yu", "噴" => "Pen", "噵" => "Dao", "噶" => "Ge", "噷" => "Xin", "噸" => "Dun",
    "噹" => "Dang", "噺" => "Sin", "噻" => "Sai", "噼" => "Pi", "噽" => "Pi", "噾" => "Yin",
    "噿" => "Zui", "嚀" => "Ning", "嚁" => "Di", "嚂" => "Lan", "嚃" => "Ta", "嚄" => "Huo",
    "嚅" => "Ru", "嚆" => "Hao", "嚇" => "Xia", "嚈" => "Ya", "嚉" => "Duo", "嚊" => "Xi",
    "嚋" => "Chou", "嚌" => "Ji", "嚍" => "Jin", "嚎" => "Hao", "嚏" => "Ti", "嚐" => "Chang",
    "嚓" => "Ca", "嚔" => "Ti", "嚕" => "Lu", "嚖" => "Hui", "嚗" => "Bo", "嚘" => "You",
    "嚙" => "Nie", "嚚" => "Yin", "嚛" => "Hu", "嚜" => "Mo", "嚝" => "Huang", "嚞" => "Zhe",
    "嚟" => "Li", "嚠" => "Liu", "嚡" => "Haai", "嚢" => "Nang", "嚣" => "Xiao", "嚤" => "Mo",
    "嚥" => "Yan", "嚦" => "Li", "嚧" => "Lu", "嚨" => "Long", "嚩" => "Fu", "嚪" => "Dan",
    "嚫" => "Chen", "嚬" => "Pin", "嚭" => "Pi", "嚮" => "Xiang", "嚯" => "Huo", "嚰" => "Mo",
    "嚱" => "Xi", "嚲" => "Duo", "嚳" => "Ku", "嚴" => "Yan", "嚵" => "Chan", "嚶" => "Ying",
    "嚷" => "Rang", "嚸" => "Dian", "嚹" => "La", "嚺" => "Ta", "嚻" => "Xiao", "嚼" => "Jiao",
    "嚽" => "Chuo", "嚾" => "Huan", "嚿" => "Huo", "囀" => "Zhuan", "囁" => "Nie", "囂" => "Xiao",
    "囃" => "Ca", "囄" => "Li", "囅" => "Chan", "囆" => "Chai", "囇" => "Li", "囈" => "Yi",
    "囉" => "Luo", "囊" => "Nang", "囋" => "Zan", "囌" => "Su", "囍" => "Xi", "囎" => "So",
    "囏" => "Jian", "囐" => "Za", "囑" => "Zhu", "囒" => "Lan", "囓" => "Nie", "囔" => "Nang",
    "囗" => "Wei", "囘" => "Hui", "囙" => "Yin", "囚" => "Qiu", "四" => "Si", "囜" => "Nin",
    "囝" => "Jian", "回" => "Hui", "囟" => "Xin", "因" => "Yin", "囡" => "Nan", "团" => "Tuan",
    "団" => "Tuan", "囤" => "Dun", "囥" => "Kang", "囦" => "Yuan", "囧" => "Jiong", "囨" => "Pian",
    "囩" => "Yun", "囪" => "Cong", "囫" => "Hu", "囬" => "Hui", "园" => "Yuan", "囮" => "You",
    "囯" => "Guo", "困" => "Kun", "囱" => "Cong", "囲" => "Wei", "図" => "Tu", "围" => "Wei",
    "囵" => "Lun", "囶" => "Guo", "囷" => "Qun", "囸" => "Ri", "囹" => "Ling", "固" => "Gu",
    "囻" => "Guo", "囼" => "Tai", "国" => "Guo", "图" => "Tu", "囿" => "You", "圁" => "Yin",
    "圂" => "Hun", "圃" => "Pu", "圄" => "Yu", "圅" => "Han", "圆" => "Yuan", "圇" => "Lun",
    "圈" => "Quan", "圉" => "Yu", "圊" => "Qing", "國" => "Guo", "圌" => "Chuan", "圍" => "Wei",
    "圎" => "Yuan", "圏" => "Quan", "圐" => "Ku", "圑" => "Fu", "園" => "Yuan", "圓" => "Yuan",
    "圔" => "E", "圕" => "Tu", "圖" => "Tu", "圗" => "Tu", "團" => "Tuan", "圙" => "Lue",
    "圚" => "Hui", "圛" => "Yi", "圜" => "Yuan", "圝" => "Luan", "圞" => "Luan", "土" => "Tu",
    "圠" => "Ya", "圡" => "Tu", "圢" => "Ting", "圣" => "Sheng", "圤" => "Pu", "圥" => "Lu",
    "圦" => "Iri", "圧" => "Ya", "在" => "Zai", "圩" => "Wei", "圪" => "Ge", "圫" => "Yu",
    "圬" => "Wu", "圭" => "Gui", "圮" => "Pi", "圯" => "Yi", "地" => "Di", "圱" => "Qian",
    "圲" => "Qian", "圳" => "Zhen", "圴" => "Zhuo", "圵" => "Dang", "圶" => "Qia", "圷" => "Akutsu",
    "圸" => "Yama", "圹" => "Kuang", "场" => "Chang", "圻" => "Qi", "圼" => "Nie", "圽" => "Mo",
    "圾" => "Ji", "圿" => "Jia", "址" => "Zhi", "坁" => "Zhi", "坂" => "Ban", "坃" => "Xun",
    "坄" => "Tou", "坅" => "Qin", "坆" => "Fen", "均" => "Jun", "坈" => "Keng", "坉" => "Tun",
    "坊" => "Fang", "坋" => "Fen", "坌" => "Ben", "坍" => "Tan", "坎" => "Kan", "坏" => "Pi",
    "坐" => "Zuo", "坑" => "Keng", "坒" => "Bi", "坓" => "Xing", "坔" => "Di", "坕" => "Jing",
    "坖" => "Ji", "块" => "Kuai", "坘" => "Di", "坙" => "Jing", "坚" => "Jian", "坛" => "Tan",
    "坜" => "Li", "坝" => "Ba", "坞" => "Wu", "坟" => "Fen", "坠" => "Zhui", "坡" => "Po",
    "坢" => "Pan", "坣" => "Tang", "坤" => "Kun", "坥" => "Qu", "坦" => "Tan", "坧" => "Zhi",
    "坨" => "Tuo", "坩" => "Gan", "坪" => "Ping", "坫" => "Dian", "坬" => "Gua", "坭" => "Ni",
    "坮" => "Tai", "坯" => "Pi", "坰" => "Jiong", "坱" => "Yang", "坲" => "Fo", "坳" => "Ao",
    "坴" => "Liu", "坵" => "Qiu", "坶" => "Mu", "坷" => "Ke", "坸" => "Gou", "坹" => "Xue",
    "坺" => "Ba", "坻" => "Chi", "坼" => "Che", "坽" => "Ling", "坾" => "Zhu", "坿" => "Fu",
    "垀" => "Hu", "垁" => "Zhi", "垂" => "Chui", "垃" => "La", "垄" => "Long", "垅" => "Long",
    "垆" => "Lu", "垇" => "Ao", "垈" => "Tay", "垉" => "Pao", "型" => "Xing", "垌" => "Dong",
    "垍" => "Ji", "垎" => "Ke", "垏" => "Lu", "垐" => "Ci", "垑" => "Chi", "垒" => "Lei",
    "垓" => "Gai", "垔" => "Yin", "垕" => "Hou", "垖" => "Dui", "垗" => "Zhao", "垘" => "Fu",
    "垙" => "Guang", "垚" => "Yao", "垛" => "Duo", "垜" => "Duo", "垝" => "Gui", "垞" => "Cha",
    "垟" => "Yang", "垠" => "Yin", "垡" => "Fa", "垢" => "Gou", "垣" => "Yuan", "垤" => "Die",
    "垥" => "Xie", "垦" => "Ken", "垧" => "Jiong", "垨" => "Shou", "垩" => "E", "垪" => "Ha",
    "垫" => "Dian", "垬" => "Hong", "垭" => "Wu", "垮" => "Kua", "垰" => "Tao", "垱" => "Dang",
    "垲" => "Kai", "垳" => "Gake", "垴" => "Nao", "垵" => "An", "垶" => "Xing", "垷" => "Xian",
    "垸" => "Huan", "垹" => "Bang", "垺" => "Pei", "垻" => "Ba", "垼" => "Yi", "垽" => "Yin",
    "垾" => "Han", "垿" => "Xu", "埀" => "Chui", "埁" => "Cen", "埂" => "Geng", "埃" => "Ai",
    "埄" => "Peng", "埅" => "Fang", "埆" => "Que", "埇" => "Yong", "埈" => "Xun", "埉" => "Jia",
    "埊" => "Di", "埋" => "Mai", "埌" => "Lang", "埍" => "Xuan", "城" => "Cheng", "埏" => "Yan",
    "埐" => "Jin", "埑" => "Zhe", "埒" => "Lei", "埓" => "Lie", "埔" => "Bu", "埕" => "Cheng",
    "埖" => "Gomi", "埗" => "Bu", "埘" => "Shi", "埙" => "Xun", "埚" => "Guo", "埛" => "Jiong",
    "埜" => "Ye", "埝" => "Nian", "埞" => "Di", "域" => "Yu", "埠" => "Bu", "埡" => "Ya",
    "埢" => "Juan", "埣" => "Sui", "埤" => "Pi", "埥" => "Cheng", "埦" => "Wan", "埧" => "Ju",
    "埨" => "Lun", "埩" => "Zheng", "埪" => "Kong", "埫" => "Chong", "埬" => "Dong", "埭" => "Dai",
    "埮" => "Tan", "埯" => "An", "埰" => "Cai", "埱" => "Shu", "埲" => "Beng", "埳" => "Kan",
    "埴" => "Zhi", "埵" => "Duo", "埶" => "Yi", "執" => "Zhi", "埸" => "Yi", "培" => "Pei",
    "基" => "Ji", "埻" => "Zhun", "埼" => "Qi", "埽" => "Sao", "埾" => "Ju", "埿" => "Ni",
    "堁" => "Ke", "堂" => "Tang", "堃" => "Kun", "堄" => "Ni", "堅" => "Jian", "堆" => "Dui",
    "堇" => "Jin", "堈" => "Gang", "堉" => "Yu", "堊" => "E", "堋" => "Peng", "堌" => "Gu",
    "堍" => "Tu", "堎" => "Leng", "堐" => "Ya", "堑" => "Qian", "堓" => "An", "堕" => "Duo",
    "堖" => "Nao", "堗" => "Tu", "堘" => "Cheng", "堙" => "Yin", "堚" => "Hun", "堛" => "Bi",
    "堜" => "Lian", "堝" => "Guo", "堞" => "Die", "堟" => "Zhuan", "堠" => "Hou", "堡" => "Bao",
    "堢" => "Bao", "堣" => "Yu", "堤" => "Di", "堥" => "Mao", "堦" => "Jie", "堧" => "Ruan",
    "堨" => "E", "堩" => "Geng", "堪" => "Kan", "堫" => "Zong", "堬" => "Yu", "堭" => "Huang",
    "堮" => "E", "堯" => "Yao", "堰" => "Yan", "報" => "Bao", "堲" => "Ji", "堳" => "Mei",
    "場" => "Chang", "堵" => "Du", "堶" => "Tuo", "堷" => "Yin", "堸" => "Feng", "堹" => "Zhong",
    "堺" => "Jie", "堻" => "Zhen", "堼" => "Feng", "堽" => "Gang", "堾" => "Chuan", "堿" => "Jian",
    "塀" => "Pyeng", "塁" => "Toride", "塂" => "Xiang", "塃" => "Huang", "塄" => "Leng", "塅" => "Duan",
    "塇" => "Xuan", "塈" => "Ji", "塉" => "Ji", "塊" => "Kuai", "塋" => "Ying", "塌" => "Ta",
    "塍" => "Cheng", "塎" => "Yong", "塏" => "Kai", "塐" => "Su", "塑" => "Su", "塒" => "Shi",
    "塓" => "Mi", "塔" => "Ta", "塕" => "Weng", "塖" => "Cheng", "塗" => "Tu", "塘" => "Tang",
    "塙" => "Que", "塚" => "Zhong", "塛" => "Li", "塜" => "Peng", "塝" => "Bang", "塞" => "Sai",
    "塟" => "Zang", "塠" => "Dui", "塡" => "Tian", "塢" => "Wu", "塣" => "Cheng", "塤" => "Xun",
    "塥" => "Ge", "塦" => "Zhen", "塧" => "Ai", "塨" => "Gong", "塩" => "Yan", "塪" => "Kan",
    "填" => "Tian", "塬" => "Yuan", "塭" => "Wen", "塮" => "Xie", "塯" => "Liu", "塰" => "Ama",
    "塱" => "Lang", "塲" => "Chang", "塳" => "Peng", "塴" => "Beng", "塵" => "Chen", "塶" => "Cu",
    "塷" => "Lu", "塸" => "Ou", "塹" => "Qian", "塺" => "Mei", "塻" => "Mo", "塼" => "Zhuan",
    "塽" => "Shuang", "塾" => "Shu", "塿" => "Lou", "墀" => "Chi", "墁" => "Man", "墂" => "Biao",
    "境" => "Jing", "墄" => "Qi", "墅" => "Shu", "墆" => "Di", "墇" => "Zhang", "墈" => "Kan",
    "墉" => "Yong", "墊" => "Dian", "墋" => "Chen", "墌" => "Zhi", "墍" => "Xi", "墎" => "Guo",
    "墏" => "Qiang", "墐" => "Jin", "墑" => "Di", "墒" => "Shang", "墓" => "Mu", "墔" => "Cui",
    "墕" => "Yan", "墖" => "Ta", "増" => "Zeng", "墘" => "Qi", "墙" => "Qiang", "墚" => "Liang",
    "墜" => "Zhui", "墝" => "Qiao", "增" => "Zeng", "墟" => "Xu", "墠" => "Shan", "墡" => "Shan",
    "墢" => "Ba", "墣" => "Pu", "墤" => "Kuai", "墥" => "Dong", "墦" => "Fan", "墧" => "Que",
    "墨" => "Mo", "墩" => "Dun", "墪" => "Dun", "墫" => "Dun", "墬" => "Di", "墭" => "Sheng",
    "墮" => "Duo", "墯" => "Duo", "墰" => "Tan", "墱" => "Deng", "墲" => "Wu", "墳" => "Fen",
    "墴" => "Huang", "墵" => "Tan", "墶" => "Da", "墷" => "Ye", "墸" => "Sho", "墹" => "Mama",
    "墺" => "Yu", "墻" => "Qiang", "墼" => "Ji", "墽" => "Qiao", "墾" => "Ken", "墿" => "Yi",
    "壀" => "Pi", "壁" => "Bi", "壂" => "Dian", "壃" => "Jiang", "壄" => "Ye", "壅" => "Yong",
    "壆" => "Bo", "壇" => "Tan", "壈" => "Lan", "壉" => "Ju", "壊" => "Huai", "壋" => "Dang",
    "壌" => "Rang", "壍" => "Qian", "壎" => "Xun", "壏" => "Lan", "壐" => "Xi", "壑" => "He",
    "壒" => "Ai", "壓" => "Ya", "壔" => "Dao", "壕" => "Hao", "壖" => "Ruan", "壗" => "Mama",
    "壘" => "Lei", "壙" => "Kuang", "壚" => "Lu", "壛" => "Yan", "壜" => "Tan", "壝" => "Wei",
    "壞" => "Huai", "壟" => "Long", "壠" => "Long", "壡" => "Rui", "壢" => "Li", "壣" => "Lin",
    "壤" => "Rang", "壥" => "Ten", "壦" => "Xun", "壧" => "Yan", "壨" => "Lei", "壩" => "Ba",
    "士" => "Shi", "壬" => "Ren", "壮" => "Zhuang", "壯" => "Zhuang", "声" => "Sheng", "壱" => "Yi",
    "売" => "Mai", "壳" => "Ke", "壴" => "Zhu", "壵" => "Zhuang", "壶" => "Hu", "壷" => "Hu",
    "壸" => "Kun", "壹" => "Yi", "壺" => "Hu", "壻" => "Xu", "壼" => "Kun", "壽" => "Shou",
    "壾" => "Mang", "壿" => "Zun", "夁" => "Yi", "夂" => "Zhi", "夃" => "Gu", "处" => "Chu",
    "夅" => "Jiang", "夆" => "Feng", "备" => "Bei", "夈" => "Cay", "変" => "Bian", "夊" => "Sui",
    "夋" => "Qun", "夌" => "Ling", "复" => "Fu", "夎" => "Zuo", "夏" => "Xia", "夐" => "Xiong",
    "夒" => "Nao", "夓" => "Xia", "夔" => "Kui", "夕" => "Xi", "外" => "Wai", "夗" => "Yuan",
    "夘" => "Mao", "夙" => "Su", "多" => "Duo", "夛" => "Duo", "夜" => "Ye", "夝" => "Qing",
    "夞" => "Uys", "够" => "Gou", "夠" => "Gou", "夡" => "Qi", "夢" => "Meng", "夣" => "Meng",
    "夤" => "Yin", "夥" => "Huo", "夦" => "Chen", "大" => "Da", "夨" => "Ze", "天" => "Tian",
    "太" => "Tai", "夫" => "Fu", "夬" => "Guai", "夭" => "Yao", "央" => "Yang", "夯" => "Hang",
    "夰" => "Gao", "失" => "Shi", "夲" => "Ben", "夳" => "Tai", "头" => "Tou", "夵" => "Yan",
    "夶" => "Bi", "夷" => "Yi", "夸" => "Kua", "夹" => "Jia", "夺" => "Duo", "夻" => "Kwu",
    "夼" => "Kuang", "夽" => "Yun", "夾" => "Jia", "夿" => "Pa", "奀" => "En", "奁" => "Lian",
    "奂" => "Huan", "奃" => "Di", "奄" => "Yan", "奅" => "Pao", "奆" => "Quan", "奇" => "Qi",
    "奈" => "Nai", "奉" => "Feng", "奊" => "Xie", "奋" => "Fen", "奌" => "Dian", "奎" => "Kui",
    "奏" => "Zou", "奐" => "Huan", "契" => "Qi", "奒" => "Kai", "奓" => "Zha", "奔" => "Ben",
    "奕" => "Yi", "奖" => "Jiang", "套" => "Tao", "奘" => "Zang", "奙" => "Ben", "奚" => "Xi",
    "奛" => "Xiang", "奜" => "Fei", "奝" => "Diao", "奞" => "Xun", "奟" => "Keng", "奠" => "Dian",
    "奡" => "Ao", "奢" => "She", "奣" => "Weng", "奤" => "Pan", "奥" => "Ao", "奦" => "Wu",
    "奧" => "Ao", "奨" => "Jiang", "奩" => "Lian", "奪" => "Duo", "奫" => "Yun", "奬" => "Jiang",
    "奭" => "Shi", "奮" => "Fen", "奯" => "Huo", "奰" => "Bi", "奱" => "Lian", "奲" => "Duo",
    "女" => "Nu", "奴" => "Nu", "奵" => "Ding", "奶" => "Nai", "奷" => "Qian", "奸" => "Jian",
    "她" => "Ta", "奺" => "Jiu", "奻" => "Nan", "奼" => "Cha", "好" => "Hao", "奾" => "Xian",
    "奿" => "Fan", "妀" => "Ji", "妁" => "Shuo", "如" => "Ru", "妃" => "Fei", "妄" => "Wang",
    "妅" => "Hong", "妆" => "Zhuang", "妇" => "Fu", "妈" => "Ma", "妉" => "Dan", "妊" => "Ren",
    "妋" => "Fu", "妌" => "Jing", "妍" => "Yan", "妎" => "Xie", "妏" => "Wen", "妐" => "Zhong",
    "妑" => "Pa", "妒" => "Du", "妓" => "Ji", "妔" => "Keng", "妕" => "Zhong", "妖" => "Yao",
    "妗" => "Jin", "妘" => "Yun", "妙" => "Miao", "妚" => "Pei", "妛" => "Shi", "妜" => "Yue",
    "妝" => "Zhuang", "妞" => "Niu", "妟" => "Yan", "妠" => "Na", "妡" => "Xin", "妢" => "Fen",
    "妣" => "Bi", "妤" => "Yu", "妥" => "Tuo", "妦" => "Feng", "妧" => "Yuan", "妨" => "Fang",
    "妩" => "Wu", "妪" => "Yu", "妫" => "Gui", "妬" => "Du", "妭" => "Ba", "妮" => "Ni",
    "妯" => "Zhou", "妰" => "Zhuo", "妱" => "Zhao", "妲" => "Da", "妳" => "Nai", "妴" => "Yuan",
    "妵" => "Tou", "妶" => "Xuan", "妷" => "Zhi", "妸" => "E", "妹" => "Mei", "妺" => "Mo",
    "妻" => "Qi", "妼" => "Bi", "妽" => "Shen", "妾" => "Qie", "妿" => "E", "姀" => "He",
    "姁" => "Xu", "姂" => "Fa", "姃" => "Zheng", "姄" => "Min", "姅" => "Ban", "姆" => "Mu",
    "姇" => "Fu", "姈" => "Ling", "姉" => "Zi", "姊" => "Zi", "始" => "Shi", "姌" => "Ran",
    "姍" => "Shan", "姎" => "Yang", "姏" => "Man", "姐" => "Jie", "姑" => "Gu", "姒" => "Si",
    "姓" => "Xing", "委" => "Wei", "姕" => "Zi", "姖" => "Ju", "姗" => "Shan", "姘" => "Pin",
    "姙" => "Ren", "姚" => "Yao", "姛" => "Tong", "姜" => "Jiang", "姝" => "Shu", "姞" => "Ji",
    "姟" => "Gai", "姠" => "Shang", "姡" => "Kuo", "姢" => "Juan", "姣" => "Jiao", "姤" => "Gou",
    "姥" => "Mu", "姦" => "Jian", "姧" => "Jian", "姨" => "Yi", "姩" => "Nian", "姪" => "Zhi",
    "姫" => "Ji", "姬" => "Ji", "姭" => "Xian", "姮" => "Heng", "姯" => "Guang", "姰" => "Jun",
    "姱" => "Kua", "姲" => "Yan", "姳" => "Ming", "姴" => "Lie", "姵" => "Pei", "姶" => "Yan",
    "姷" => "You", "姸" => "Yan", "姹" => "Cha", "姺" => "Shen", "姻" => "Yin", "姼" => "Chi",
    "姽" => "Gui", "姾" => "Quan", "姿" => "Zi", "威" => "Wei", "娂" => "Hong", "娃" => "Wa",
    "娄" => "Lou", "娅" => "Ya", "娆" => "Rao", "娇" => "Jiao", "娈" => "Luan", "娉" => "Ping",
    "娊" => "Xian", "娋" => "Shao", "娌" => "Li", "娍" => "Cheng", "娎" => "Xiao", "娏" => "Mang",
    "娐" => "Fu", "娑" => "Suo", "娒" => "Wu", "娓" => "Wei", "娔" => "Ke", "娕" => "Lai",
    "娖" => "Chuo", "娗" => "Ding", "娘" => "Niang", "娙" => "Xing", "娚" => "Nan", "娛" => "Yu",
    "娜" => "Nuo", "娝" => "Pei", "娞" => "Nei", "娟" => "Juan", "娠" => "Shen", "娡" => "Zhi",
    "娢" => "Han", "娣" => "Di", "娤" => "Zhuang", "娥" => "E", "娦" => "Pin", "娧" => "Tui",
    "娨" => "Han", "娩" => "Mian", "娪" => "Wu", "娫" => "Yan", "娬" => "Wu", "娭" => "Xi",
    "娮" => "Yan", "娯" => "Yu", "娰" => "Si", "娱" => "Yu", "娲" => "Wa", "娴" => "Xian",
    "娵" => "Ju", "娶" => "Qu", "娷" => "Shui", "娸" => "Qi", "娹" => "Xian", "娺" => "Zhui",
    "娻" => "Dong", "娼" => "Chang", "娽" => "Lu", "娾" => "Ai", "娿" => "E", "婀" => "E",
    "婁" => "Lou", "婂" => "Mian", "婃" => "Cong", "婄" => "Pou", "婅" => "Ju", "婆" => "Po",
    "婇" => "Cai", "婈" => "Ding", "婉" => "Wan", "婊" => "Biao", "婋" => "Xiao", "婌" => "Shu",
    "婍" => "Qi", "婎" => "Hui", "婏" => "Fu", "婐" => "E", "婑" => "Wo", "婒" => "Tan",
    "婓" => "Fei", "婔" => "Wei", "婕" => "Jie", "婖" => "Tian", "婗" => "Ni", "婘" => "Quan",
    "婙" => "Jing", "婚" => "Hun", "婛" => "Jing", "婜" => "Qian", "婝" => "Dian", "婞" => "Xing",
    "婟" => "Hu", "婠" => "Wa", "婡" => "Lai", "婢" => "Bi", "婣" => "Yin", "婤" => "Chou",
    "婥" => "Chuo", "婦" => "Fu", "婧" => "Jing", "婨" => "Lun", "婩" => "Yan", "婪" => "Lan",
    "婫" => "Kun", "婬" => "Yin", "婭" => "Ya", "婮" => "Ju", "婯" => "Li", "婰" => "Dian",
    "婱" => "Xian", "婲" => "Hwa", "婳" => "Hua", "婴" => "Ying", "婵" => "Chan", "婶" => "Shen",
    "婷" => "Ting", "婸" => "Dang", "婹" => "Yao", "婺" => "Wu", "婻" => "Nan", "婼" => "Ruo",
    "婽" => "Jia", "婾" => "Tou", "婿" => "Xu", "媀" => "Yu", "媁" => "Wei", "媂" => "Ti",
    "媃" => "Rou", "媄" => "Mei", "媅" => "Dan", "媆" => "Ruan", "媇" => "Qin", "媈" => "Hui",
    "媉" => "Wu", "媊" => "Qian", "媋" => "Chun", "媌" => "Mao", "媍" => "Fu", "媎" => "Jie",
    "媏" => "Duan", "媐" => "Xi", "媑" => "Zhong", "媒" => "Mei", "媓" => "Huang", "媔" => "Mian",
    "媕" => "An", "媖" => "Ying", "媗" => "Xuan", "媘" => "Jie", "媙" => "Wei", "媚" => "Mei",
    "媛" => "Yuan", "媜" => "Zhen", "媝" => "Qiu", "媞" => "Ti", "媟" => "Xie", "媠" => "Tuo",
    "媡" => "Lian", "媢" => "Mao", "媣" => "Ran", "媤" => "Si", "媥" => "Pian", "媦" => "Wei",
    "媧" => "Wa", "媨" => "Jiu", "媩" => "Hu", "媪" => "Ao", "媬" => "Bou", "媭" => "Xu",
    "媮" => "Tou", "媯" => "Gui", "媰" => "Zou", "媱" => "Yao", "媲" => "Pi", "媳" => "Xi",
    "媴" => "Yuan", "媵" => "Ying", "媶" => "Rong", "媷" => "Ru", "媸" => "Chi", "媹" => "Liu",
    "媺" => "Mei", "媻" => "Pan", "媼" => "Ao", "媽" => "Ma", "媾" => "Gou", "媿" => "Kui",
    "嫀" => "Qin", "嫁" => "Jia", "嫂" => "Sao", "嫃" => "Zhen", "嫄" => "Yuan", "嫅" => "Cha",
    "嫆" => "Yong", "嫇" => "Ming", "嫈" => "Ying", "嫉" => "Ji", "嫊" => "Su", "嫋" => "Niao",
    "嫌" => "Xian", "嫍" => "Tao", "嫎" => "Pang", "嫏" => "Lang", "嫐" => "Nao", "嫑" => "Bao",
    "嫒" => "Ai", "嫓" => "Pi", "嫔" => "Pin", "嫕" => "Yi", "嫖" => "Piao", "嫗" => "Yu",
    "嫘" => "Lei", "嫙" => "Xuan", "嫚" => "Man", "嫛" => "Yi", "嫜" => "Zhang", "嫝" => "Kang",
    "嫞" => "Yong", "嫟" => "Ni", "嫠" => "Li", "嫡" => "Di", "嫢" => "Gui", "嫣" => "Yan",
    "嫤" => "Jin", "嫥" => "Zhuan", "嫦" => "Chang", "嫧" => "Ce", "嫨" => "Han", "嫩" => "Nen",
    "嫪" => "Lao", "嫫" => "Mo", "嫬" => "Zhe", "嫭" => "Hu", "嫮" => "Hu", "嫯" => "Ao",
    "嫰" => "Nen", "嫱" => "Qiang", "嫲" => "Ma", "嫳" => "Pie", "嫴" => "Gu", "嫵" => "Wu",
    "嫶" => "Jiao", "嫷" => "Tuo", "嫸" => "Zhan", "嫹" => "Mao", "嫺" => "Xian", "嫻" => "Xian",
    "嫼" => "Mo", "嫽" => "Liao", "嫾" => "Lian", "嫿" => "Hua", "嬁" => "Deng", "嬂" => "Zhi",
    "嬃" => "Xu", "嬄" => "Yi", "嬅" => "Hua", "嬆" => "Xi", "嬇" => "Hui", "嬈" => "Rao",
    "嬉" => "Xi", "嬊" => "Yan", "嬋" => "Chan", "嬌" => "Jiao", "嬍" => "Mei", "嬎" => "Fan",
    "嬏" => "Fan", "嬐" => "Xian", "嬑" => "Yi", "嬒" => "Wei", "嬓" => "Jiao", "嬔" => "Fu",
    "嬕" => "Shi", "嬖" => "Bi", "嬗" => "Shan", "嬘" => "Sui", "嬙" => "Qiang", "嬚" => "Lian",
    "嬛" => "Huan", "嬜" => "Xin", "嬝" => "Niao", "嬞" => "Dong", "嬟" => "Yi", "嬠" => "Can",
    "嬡" => "Ai", "嬢" => "Niang", "嬣" => "Neng", "嬤" => "Ma", "嬥" => "Tiao", "嬦" => "Chou",
    "嬧" => "Jin", "嬨" => "Ci", "嬩" => "Yu", "嬪" => "Pin", "嬫" => "Yong", "嬬" => "Xu",
    "嬭" => "Nai", "嬮" => "Yan", "嬯" => "Tai", "嬰" => "Ying", "嬱" => "Can", "嬲" => "Niao",
    "嬳" => "Wo", "嬴" => "Ying", "嬵" => "Mian", "嬶" => "Kaka", "嬷" => "Ma", "嬸" => "Shen",
    "嬹" => "Xing", "嬺" => "Ni", "嬻" => "Du", "嬼" => "Liu", "嬽" => "Yuan", "嬾" => "Lan",
    "嬿" => "Yan", "孀" => "Shuang", "孁" => "Ling", "孂" => "Jiao", "孃" => "Niang", "孄" => "Lan",
    "孅" => "Xian", "孆" => "Ying", "孇" => "Shuang", "孈" => "Shuai", "孉" => "Quan", "孊" => "Mi",
    "孋" => "Li", "孌" => "Luan", "孍" => "Yan", "孎" => "Zhu", "孏" => "Lan", "子" => "Zi",
    "孑" => "Jie", "孒" => "Jue", "孓" => "Jue", "孔" => "Kong", "孕" => "Yun", "孖" => "Zi",
    "字" => "Zi", "存" => "Cun", "孙" => "Sun", "孚" => "Fu", "孛" => "Bei", "孜" => "Zi",
    "孝" => "Xiao", "孞" => "Xin", "孟" => "Meng", "孠" => "Si", "孡" => "Tai", "孢" => "Bao",
    "季" => "Ji", "孤" => "Gu", "孥" => "Nu", "学" => "Xue", "孨" => "Zhuan", "孩" => "Hai",
    "孪" => "Luan", "孫" => "Sun", "孬" => "Huai", "孭" => "Mie", "孮" => "Cong", "孯" => "Qian",
    "孰" => "Shu", "孱" => "Chan", "孲" => "Ya", "孳" => "Zi", "孴" => "Ni", "孵" => "Fu",
    "孶" => "Zi", "孷" => "Li", "學" => "Xue", "孹" => "Bo", "孺" => "Ru", "孻" => "Lai",
    "孼" => "Nie", "孽" => "Nie", "孾" => "Ying", "孿" => "Luan", "宀" => "Mian", "宁" => "Zhu",
    "宂" => "Rong", "它" => "Ta", "宄" => "Gui", "宅" => "Zhai", "宆" => "Qiong", "宇" => "Yu",
    "守" => "Shou", "安" => "An", "宊" => "Tu", "宋" => "Song", "完" => "Wan", "宍" => "Rou",
    "宎" => "Yao", "宏" => "Hong", "宐" => "Yi", "宑" => "Jing", "宒" => "Zhun", "宓" => "Mi",
    "宔" => "Zhu", "宕" => "Dang", "宖" => "Hong", "宗" => "Zong", "官" => "Guan", "宙" => "Zhou",
    "定" => "Ding", "宛" => "Wan", "宜" => "Yi", "宝" => "Bao", "实" => "Shi", "実" => "Shi",
    "宠" => "Chong", "审" => "Shen", "客" => "Ke", "宣" => "Xuan", "室" => "Shi", "宥" => "You",
    "宦" => "Huan", "宧" => "Yi", "宨" => "Tiao", "宩" => "Shi", "宪" => "Xian", "宫" => "Gong",
    "宬" => "Cheng", "宭" => "Qun", "宮" => "Gong", "宯" => "Xiao", "宰" => "Zai", "宱" => "Zha",
    "宲" => "Bao", "害" => "Hai", "宴" => "Yan", "宵" => "Xiao", "家" => "Jia", "宷" => "Shen",
    "宸" => "Chen", "容" => "Rong", "宺" => "Huang", "宻" => "Mi", "宼" => "Kou", "宽" => "Kuan",
    "宾" => "Bin", "宿" => "Su", "寀" => "Cai", "寁" => "Zan", "寂" => "Ji", "寃" => "Yuan",
    "寄" => "Ji", "寅" => "Yin", "密" => "Mi", "寇" => "Kou", "寈" => "Qing", "寉" => "Que",
    "寊" => "Zhen", "寋" => "Jian", "富" => "Fu", "寍" => "Ning", "寎" => "Bing", "寏" => "Huan",
    "寐" => "Mei", "寑" => "Qin", "寒" => "Han", "寓" => "Yu", "寔" => "Shi", "寕" => "Ning",
    "寖" => "Qin", "寗" => "Ning", "寘" => "Zhi", "寙" => "Yu", "寚" => "Bao", "寛" => "Kuan",
    "寜" => "Ning", "寝" => "Qin", "寞" => "Mo", "察" => "Cha", "寠" => "Ju", "寡" => "Gua",
    "寢" => "Qin", "寣" => "Hu", "寤" => "Wu", "寥" => "Liao", "實" => "Shi", "寧" => "Zhu",
    "寨" => "Zhai", "審" => "Shen", "寪" => "Wei", "寫" => "Xie", "寬" => "Kuan", "寭" => "Hui",
    "寮" => "Liao", "寯" => "Jun", "寰" => "Huan", "寱" => "Yi", "寲" => "Yi", "寳" => "Bao",
    "寴" => "Qin", "寵" => "Chong", "寶" => "Bao", "寷" => "Feng", "寸" => "Cun", "对" => "Dui",
    "寺" => "Si", "寻" => "Xun", "导" => "Dao", "寽" => "Lu", "対" => "Dui", "寿" => "Shou",
    "封" => "Feng", "専" => "Zhuan", "尃" => "Fu", "射" => "She", "尅" => "Ke", "将" => "Jiang",
    "將" => "Jiang", "專" => "Zhuan", "尉" => "Wei", "尊" => "Zun", "尋" => "Xun", "尌" => "Shu",
    "對" => "Dui", "導" => "Dao", "小" => "Xiao", "尐" => "Ji", "少" => "Shao", "尒" => "Er",
    "尓" => "Er", "尔" => "Er", "尕" => "Ga", "尖" => "Jian", "尗" => "Shu", "尘" => "Chen",
    "尙" => "Shang", "尚" => "Shang", "尛" => "Mo", "尜" => "Ga", "尝" => "Chang", "尞" => "Liao",
    "尟" => "Xian", "尠" => "Xian", "尢" => "Wang", "尣" => "Wang", "尤" => "You", "尥" => "Liao",
    "尦" => "Liao", "尧" => "Yao", "尨" => "Mang", "尩" => "Wang", "尪" => "Wang", "尫" => "Wang",
    "尬" => "Ga", "尭" => "Yao", "尮" => "Duo", "尯" => "Kui", "尰" => "Zhong", "就" => "Jiu",
    "尲" => "Gan", "尳" => "Gu", "尴" => "Gan", "尵" => "Tui", "尶" => "Gan", "尷" => "Gan",
    "尸" => "Shi", "尹" => "Yin", "尺" => "Chi", "尻" => "Kao", "尼" => "Ni", "尽" => "Jin",
    "尾" => "Wei", "尿" => "Niao", "局" => "Ju", "屁" => "Pi", "层" => "Ceng", "屃" => "Xi",
    "屄" => "Bi", "居" => "Ju", "屆" => "Jie", "屇" => "Tian", "屈" => "Qu", "屉" => "Ti",
    "届" => "Jie", "屋" => "Wu", "屌" => "Diao", "屍" => "Shi", "屎" => "Shi", "屏" => "Ping",
    "屐" => "Ji", "屑" => "Xie", "屒" => "Chen", "屓" => "Xi", "屔" => "Ni", "展" => "Zhan",
    "屖" => "Xi", "屘" => "Man", "屙" => "E", "屚" => "Lou", "屛" => "Ping", "屜" => "Ti",
    "屝" => "Fei", "属" => "Shu", "屟" => "Xie", "屠" => "Tu", "屡" => "Lu", "屢" => "Lu",
    "屣" => "Xi", "層" => "Ceng", "履" => "Lu", "屦" => "Ju", "屧" => "Xie", "屨" => "Ju",
    "屩" => "Jue", "屪" => "Liao", "屫" => "Jue", "屬" => "Shu", "屭" => "Xi", "屮" => "Che",
    "屯" => "Tun", "屰" => "Ni", "山" => "Shan", "屳" => "Xian", "屴" => "Li", "屵" => "Xue",
    "屶" => "Nata", "屸" => "Long", "屹" => "Yi", "屺" => "Qi", "屻" => "Ren", "屼" => "Wu",
    "屽" => "Han", "屾" => "Shen", "屿" => "Yu", "岀" => "Chu", "岁" => "Sui", "岂" => "Qi",
    "岄" => "Yue", "岅" => "Ban", "岆" => "Yao", "岇" => "Ang", "岈" => "Ya", "岉" => "Wu",
    "岊" => "Jie", "岋" => "E", "岌" => "Ji", "岍" => "Qian", "岎" => "Fen", "岏" => "Yuan",
    "岐" => "Qi", "岑" => "Cen", "岒" => "Qian", "岓" => "Qi", "岔" => "Cha", "岕" => "Jie",
    "岖" => "Qu", "岗" => "Gang", "岘" => "Xian", "岙" => "Ao", "岚" => "Lan", "岛" => "Dao",
    "岜" => "Ba", "岝" => "Zuo", "岞" => "Zuo", "岟" => "Yang", "岠" => "Ju", "岡" => "Gang",
    "岢" => "Ke", "岣" => "Gou", "岤" => "Xue", "岥" => "Bei", "岦" => "Li", "岧" => "Tiao",
    "岨" => "Ju", "岩" => "Yan", "岪" => "Fu", "岫" => "Xiu", "岬" => "Jia", "岭" => "Ling",
    "岮" => "Tuo", "岯" => "Pei", "岰" => "You", "岱" => "Dai", "岲" => "Kuang", "岳" => "Yue",
    "岴" => "Qu", "岵" => "Hu", "岶" => "Po", "岷" => "Min", "岸" => "An", "岹" => "Tiao",
    "岺" => "Ling", "岻" => "Chi", "岼" => "Yuri", "岽" => "Dong", "岾" => "Cem", "岿" => "Kui",
    "峀" => "Xiu", "峁" => "Mao", "峂" => "Tong", "峃" => "Xue", "峄" => "Yi", "峅" => "Kura",
    "峆" => "He", "峇" => "Ke", "峈" => "Luo", "峉" => "E", "峊" => "Fu", "峋" => "Xun",
    "峌" => "Die", "峍" => "Lu", "峎" => "An", "峏" => "Er", "峐" => "Gai", "峑" => "Quan",
    "峒" => "Tong", "峓" => "Yi", "峔" => "Mu", "峕" => "Shi", "峖" => "An", "峗" => "Wei",
    "峘" => "Hu", "峙" => "Zhi", "峚" => "Mi", "峛" => "Li", "峜" => "Ji", "峝" => "Tong",
    "峞" => "Wei", "峟" => "You", "峠" => "Sang", "峡" => "Xia", "峢" => "Li", "峣" => "Yao",
    "峤" => "Jiao", "峥" => "Zheng", "峦" => "Luan", "峧" => "Jiao", "峨" => "E", "峩" => "E",
    "峪" => "Yu", "峫" => "Ye", "峬" => "Bu", "峭" => "Qiao", "峮" => "Qun", "峯" => "Feng",
    "峰" => "Feng", "峱" => "Nao", "峲" => "Li", "峳" => "You", "峴" => "Xian", "峵" => "Hong",
    "島" => "Dao", "峷" => "Shen", "峸" => "Cheng", "峹" => "Tu", "峺" => "Geng", "峻" => "Jun",
    "峼" => "Hao", "峽" => "Xia", "峾" => "Yin", "峿" => "Yu", "崁" => "Kan", "崂" => "Lao",
    "崃" => "Lai", "崄" => "Xian", "崅" => "Que", "崆" => "Kong", "崇" => "Chong", "崈" => "Chong",
    "崉" => "Ta", "崊" => "Lin", "崋" => "Hua", "崌" => "Ju", "崍" => "Lai", "崎" => "Qi",
    "崏" => "Min", "崐" => "Kun", "崑" => "Kun", "崒" => "Zu", "崓" => "Gu", "崔" => "Cui",
    "崕" => "Ya", "崖" => "Ya", "崗" => "Gang", "崘" => "Lun", "崙" => "Lun", "崚" => "Leng",
    "崛" => "Jue", "崜" => "Duo", "崝" => "Zheng", "崞" => "Guo", "崟" => "Yin", "崠" => "Dong",
    "崡" => "Han", "崢" => "Zheng", "崣" => "Wei", "崤" => "Yao", "崥" => "Pi", "崦" => "Yan",
    "崧" => "Song", "崨" => "Jie", "崩" => "Beng", "崪" => "Zu", "崫" => "Jue", "崬" => "Dong",
    "崭" => "Zhan", "崮" => "Gu", "崯" => "Yin", "崱" => "Ze", "崲" => "Huang", "崳" => "Yu",
    "崴" => "Wei", "崵" => "Yang", "崶" => "Feng", "崷" => "Qiu", "崸" => "Dun", "崹" => "Ti",
    "崺" => "Yi", "崻" => "Zhi", "崼" => "Shi", "崽" => "Zai", "崾" => "Yao", "崿" => "E",
    "嵀" => "Zhu", "嵁" => "Kan", "嵂" => "Lu", "嵃" => "Yan", "嵄" => "Mei", "嵅" => "Gan",
    "嵆" => "Ji", "嵇" => "Ji", "嵈" => "Huan", "嵉" => "Ting", "嵊" => "Sheng", "嵋" => "Mei",
    "嵌" => "Qian", "嵍" => "Wu", "嵎" => "Yu", "嵏" => "Zong", "嵐" => "Lan", "嵑" => "Jue",
    "嵒" => "Yan", "嵓" => "Yan", "嵔" => "Wei", "嵕" => "Zong", "嵖" => "Cha", "嵗" => "Sui",
    "嵘" => "Rong", "嵙" => "Yamashina", "嵚" => "Qin", "嵛" => "Yu", "嵜" => "Kewashii", "嵝" => "Lou",
    "嵞" => "Tu", "嵟" => "Dui", "嵠" => "Xi", "嵡" => "Weng", "嵢" => "Cang", "嵣" => "Dang",
    "嵤" => "Hong", "嵥" => "Jie", "嵦" => "Ai", "嵧" => "Liu", "嵨" => "Wu", "嵩" => "Song",
    "嵪" => "Qiao", "嵫" => "Zi", "嵬" => "Wei", "嵭" => "Beng", "嵮" => "Dian", "嵯" => "Cuo",
    "嵰" => "Qian", "嵱" => "Yong", "嵲" => "Nie", "嵳" => "Cuo", "嵴" => "Ji", "嵶" => "Tao",
    "嵷" => "Song", "嵸" => "Zong", "嵹" => "Jiang", "嵺" => "Liao", "嵻" => "Kang", "嵼" => "Chan",
    "嵽" => "Die", "嵾" => "Cen", "嵿" => "Ding", "嶀" => "Tu", "嶁" => "Lou", "嶂" => "Zhang",
    "嶃" => "Zhan", "嶄" => "Zhan", "嶅" => "Ao", "嶆" => "Cao", "嶇" => "Qu", "嶈" => "Qiang",
    "嶉" => "Zui", "嶊" => "Zui", "嶋" => "Dao", "嶌" => "Dao", "嶍" => "Xi", "嶎" => "Yu",
    "嶏" => "Bo", "嶐" => "Long", "嶑" => "Xiang", "嶒" => "Ceng", "嶓" => "Bo", "嶔" => "Qin",
    "嶕" => "Jiao", "嶖" => "Yan", "嶗" => "Lao", "嶘" => "Zhan", "嶙" => "Lin", "嶚" => "Liao",
    "嶛" => "Liao", "嶜" => "Jin", "嶝" => "Deng", "嶞" => "Duo", "嶟" => "Zun", "嶠" => "Jiao",
    "嶡" => "Gui", "嶢" => "Yao", "嶣" => "Qiao", "嶤" => "Yao", "嶥" => "Jue", "嶦" => "Zhan",
    "嶧" => "Yi", "嶨" => "Xue", "嶩" => "Nao", "嶪" => "Ye", "嶫" => "Ye", "嶬" => "Yi",
    "嶭" => "E", "嶮" => "Xian", "嶯" => "Ji", "嶰" => "Xie", "嶱" => "Ke", "嶲" => "Xi",
    "嶳" => "Di", "嶴" => "Ao", "嶵" => "Zui", "嶷" => "Ni", "嶸" => "Rong", "嶹" => "Dao",
    "嶺" => "Ling", "嶻" => "Za", "嶼" => "Yu", "嶽" => "Yue", "嶾" => "Yin", "巀" => "Jie",
    "巁" => "Li", "巂" => "Sui", "巃" => "Long", "巄" => "Long", "巅" => "Dian", "巆" => "Ying",
    "巇" => "Xi", "巈" => "Ju", "巉" => "Chan", "巊" => "Ying", "巋" => "Kui", "巌" => "Yan",
    "巍" => "Wei", "巎" => "Nao", "巏" => "Quan", "巐" => "Chao", "巑" => "Cuan", "巒" => "Luan",
    "巓" => "Dian", "巔" => "Dian", "巖" => "Yan", "巗" => "Yan", "巘" => "Yan", "巙" => "Nao",
    "巚" => "Yan", "巛" => "Chuan", "巜" => "Gui", "川" => "Chuan", "州" => "Zhou", "巟" => "Huang",
    "巠" => "Jing", "巡" => "Xun", "巢" => "Chao", "巣" => "Chao", "巤" => "Lie", "工" => "Gong",
    "左" => "Zuo", "巧" => "Qiao", "巨" => "Ju", "巩" => "Gong", "巪" => "Kek", "巫" => "Wu",
    "巬" => "Pwu", "巭" => "Pwu", "差" => "Chai", "巯" => "Qiu", "巰" => "Qiu", "己" => "Ji",
    "已" => "Yi", "巳" => "Si", "巴" => "Ba", "巵" => "Zhi", "巶" => "Zhao", "巷" => "Xiang",
    "巸" => "Yi", "巹" => "Jin", "巺" => "Xun", "巻" => "Juan", "巼" => "Phas", "巽" => "Xun",
    "巾" => "Jin", "巿" => "Fu", "币" => "Bi", "市" => "Shi", "布" => "Bu", "帄" => "Ding",
    "帅" => "Shuai", "帆" => "Fan", "帇" => "Nie", "师" => "Shi", "帉" => "Fen", "帊" => "Pa",
    "帋" => "Zhi", "希" => "Xi", "帍" => "Hu", "帎" => "Dan", "帏" => "Wei", "帐" => "Zhang",
    "帑" => "Tang", "帒" => "Dai", "帓" => "Ma", "帔" => "Pei", "帕" => "Pa", "帖" => "Tie",
    "帗" => "Fu", "帘" => "Lian", "帙" => "Zhi", "帚" => "Zhou", "帛" => "Bo", "帜" => "Zhi",
    "帝" => "Di", "帞" => "Mo", "帟" => "Yi", "帠" => "Yi", "帡" => "Ping", "帢" => "Qia",
    "帣" => "Juan", "帤" => "Ru", "帥" => "Shuai", "带" => "Dai", "帧" => "Zheng", "帨" => "Shui",
    "帩" => "Qiao", "帪" => "Zhen", "師" => "Shi", "帬" => "Qun", "席" => "Xi", "帮" => "Bang",
    "帯" => "Dai", "帰" => "Gui", "帱" => "Chou", "帲" => "Ping", "帳" => "Zhang", "帴" => "Sha",
    "帵" => "Wan", "帶" => "Dai", "帷" => "Wei", "常" => "Chang", "帹" => "Sha", "帺" => "Qi",
    "帻" => "Ze", "帼" => "Guo", "帽" => "Mao", "帾" => "Du", "帿" => "Hou", "幀" => "Zheng",
    "幁" => "Xu", "幂" => "Mi", "幃" => "Wei", "幄" => "Wo", "幅" => "Fu", "幆" => "Yi",
    "幇" => "Bang", "幈" => "Ping", "幉" => "Tazuna", "幊" => "Gong", "幋" => "Pan", "幌" => "Huang",
    "幍" => "Dao", "幎" => "Mi", "幏" => "Jia", "幐" => "Teng", "幑" => "Hui", "幒" => "Zhong",
    "幓" => "Shan", "幔" => "Man", "幕" => "Mu", "幖" => "Biao", "幗" => "Guo", "幘" => "Ze",
    "幙" => "Mu", "幚" => "Bang", "幛" => "Zhang", "幜" => "Jiong", "幝" => "Chan", "幞" => "Fu",
    "幟" => "Zhi", "幠" => "Hu", "幡" => "Fan", "幢" => "Chuang", "幣" => "Bi", "幤" => "Hei",
    "幦" => "Mi", "幧" => "Qiao", "幨" => "Chan", "幩" => "Fen", "幪" => "Meng", "幫" => "Bang",
    "幬" => "Chou", "幭" => "Mie", "幮" => "Chu", "幯" => "Jie", "幰" => "Xian", "幱" => "Lan",
    "干" => "Gan", "平" => "Ping", "年" => "Nian", "幵" => "Qian", "并" => "Bing", "幷" => "Bing",
    "幸" => "Xing", "幹" => "Gan", "幺" => "Yao", "幻" => "Huan", "幼" => "You", "幽" => "You",
    "幾" => "Ji", "广" => "Yan", "庀" => "Pi", "庁" => "Ting", "庂" => "Ze", "広" => "Guang",
    "庄" => "Zhuang", "庅" => "Mo", "庆" => "Qing", "庇" => "Bi", "庈" => "Qin", "庉" => "Dun",
    "床" => "Chuang", "庋" => "Gui", "庌" => "Ya", "庍" => "Bai", "庎" => "Jie", "序" => "Xu",
    "庐" => "Lu", "庑" => "Wu", "库" => "Ku", "应" => "Ying", "底" => "Di", "庖" => "Pao",
    "店" => "Dian", "庘" => "Ya", "庙" => "Miao", "庚" => "Geng", "庛" => "Ci", "府" => "Fu",
    "庝" => "Tong", "庞" => "Pang", "废" => "Fei", "庠" => "Xiang", "庡" => "Yi", "庢" => "Zhi",
    "庣" => "Tiao", "庤" => "Zhi", "庥" => "Xiu", "度" => "Du", "座" => "Zuo", "庨" => "Xiao",
    "庩" => "Tu", "庪" => "Gui", "庫" => "Ku", "庬" => "Pang", "庭" => "Ting", "庮" => "You",
    "庯" => "Bu", "庰" => "Ding", "庱" => "Cheng", "庲" => "Lai", "庳" => "Bei", "庴" => "Ji",
    "庵" => "An", "庶" => "Shu", "康" => "Kang", "庸" => "Yong", "庹" => "Tuo", "庺" => "Song",
    "庻" => "Shu", "庼" => "Qing", "庽" => "Yu", "庾" => "Yu", "庿" => "Miao", "廀" => "Sou",
    "廁" => "Ce", "廂" => "Xiang", "廃" => "Fei", "廄" => "Jiu", "廅" => "He", "廆" => "Hui",
    "廇" => "Liu", "廈" => "Sha", "廉" => "Lian", "廊" => "Lang", "廋" => "Sou", "廌" => "Jian",
    "廍" => "Pou", "廎" => "Qing", "廏" => "Jiu", "廐" => "Jiu", "廑" => "Qin", "廒" => "Ao",
    "廓" => "Kuo", "廔" => "Lou", "廕" => "Yin", "廖" => "Liao", "廗" => "Dai", "廘" => "Lu",
    "廙" => "Yi", "廚" => "Chu", "廛" => "Chan", "廜" => "Tu", "廝" => "Si", "廞" => "Xin",
    "廟" => "Miao", "廠" => "Chang", "廡" => "Wu", "廢" => "Fei", "廣" => "Guang", "廤" => "Koc",
    "廥" => "Kuai", "廦" => "Bi", "廧" => "Qiang", "廨" => "Xie", "廩" => "Lin", "廪" => "Lin",
    "廫" => "Liao", "廬" => "Lu", "廮" => "Ying", "廯" => "Xian", "廰" => "Ting", "廱" => "Yong",
    "廲" => "Li", "廳" => "Ting", "廴" => "Yin", "廵" => "Xun", "延" => "Yan", "廷" => "Ting",
    "廸" => "Di", "廹" => "Po", "建" => "Jian", "廻" => "Hui", "廼" => "Nai", "廽" => "Hui",
    "廾" => "Gong", "廿" => "Nian", "弁" => "Bian", "异" => "Yi", "弃" => "Qi", "弄" => "Nong",
    "弅" => "Fen", "弆" => "Ju", "弇" => "Yan", "弈" => "Yi", "弉" => "Zang", "弊" => "Bi",
    "弋" => "Yi", "弌" => "Yi", "弍" => "Er", "弎" => "San", "式" => "Shi", "弐" => "Er",
    "弑" => "Shi", "弒" => "Shi", "弓" => "Gong", "弔" => "Diao", "引" => "Yin", "弖" => "Hu",
    "弗" => "Fu", "弘" => "Hong", "弙" => "Wu", "弚" => "Tui", "弛" => "Chi", "弜" => "Jiang",
    "弝" => "Ba", "弞" => "Shen", "弟" => "Di", "张" => "Zhang", "弡" => "Jue", "弢" => "Tao",
    "弣" => "Fu", "弤" => "Di", "弥" => "Mi", "弦" => "Xian", "弧" => "Hu", "弨" => "Chao",
    "弩" => "Nu", "弪" => "Jing", "弫" => "Zhen", "弬" => "Yi", "弭" => "Mi", "弮" => "Quan",
    "弯" => "Wan", "弰" => "Shao", "弱" => "Ruo", "弲" => "Xuan", "弳" => "Jing", "弴" => "Dun",
    "張" => "Zhang", "弶" => "Jiang", "強" => "Qiang", "弸" => "Peng", "弹" => "Dan", "强" => "Qiang",
    "弻" => "Bi", "弼" => "Bi", "弽" => "She", "弾" => "Dan", "弿" => "Jian", "彀" => "Gou",
    "彁" => "Sei", "彂" => "Fa", "彃" => "Bi", "彄" => "Kou", "彅" => "Nagi", "彆" => "Bie",
    "彇" => "Xiao", "彈" => "Dan", "彉" => "Kuo", "彊" => "Qiang", "彋" => "Hong", "彌" => "Mi",
    "彍" => "Kuo", "彎" => "Wan", "彏" => "Jue", "彐" => "Ji", "彑" => "Ji", "归" => "Gui",
    "当" => "Dang", "彔" => "Lu", "录" => "Lu", "彖" => "Tuan", "彗" => "Hui", "彘" => "Zhi",
    "彙" => "Hui", "彚" => "Hui", "彛" => "Yi", "彜" => "Yi", "彝" => "Yi", "彞" => "Yi",
    "彟" => "Huo", "彠" => "Huo", "彡" => "Shan", "形" => "Xing", "彣" => "Wen", "彤" => "Tong",
    "彥" => "Yan", "彦" => "Yan", "彧" => "Yu", "彨" => "Chi", "彩" => "Cai", "彪" => "Biao",
    "彫" => "Diao", "彬" => "Bin", "彭" => "Peng", "彮" => "Yong", "彯" => "Piao", "彰" => "Zhang",
    "影" => "Ying", "彲" => "Chi", "彳" => "Chi", "彴" => "Zhuo", "彵" => "Tuo", "彶" => "Ji",
    "彷" => "Pang", "彸" => "Zhong", "役" => "Yi", "彺" => "Wang", "彻" => "Che", "彼" => "Bi",
    "彽" => "Chi", "彾" => "Ling", "彿" => "Fu", "往" => "Wang", "征" => "Zheng", "徂" => "Cu",
    "徃" => "Wang", "径" => "Jing", "待" => "Dai", "徆" => "Xi", "徇" => "Xun", "很" => "Hen",
    "徉" => "Yang", "徊" => "Huai", "律" => "Lu", "後" => "Hou", "徍" => "Wa", "徎" => "Cheng",
    "徏" => "Zhi", "徐" => "Xu", "徑" => "Jing", "徒" => "Tu", "従" => "Cong", "徕" => "Lai",
    "徖" => "Cong", "得" => "De", "徘" => "Pai", "徙" => "Xi", "徛" => "Qi", "徜" => "Chang",
    "徝" => "Zhi", "從" => "Cong", "徟" => "Zhou", "徠" => "Lai", "御" => "Yu", "徢" => "Xie",
    "徣" => "Jie", "徤" => "Jian", "徥" => "Chi", "徦" => "Jia", "徧" => "Bian", "徨" => "Huang",
    "復" => "Fu", "循" => "Xun", "徫" => "Wei", "徬" => "Pang", "徭" => "Yao", "微" => "Wei",
    "徯" => "Xi", "徰" => "Zheng", "徱" => "Piao", "徲" => "Chi", "徳" => "De", "徴" => "Zheng",
    "徵" => "Zheng", "徶" => "Bie", "德" => "De", "徸" => "Chong", "徹" => "Che", "徺" => "Jiao",
    "徻" => "Wei", "徼" => "Jiao", "徽" => "Hui", "徾" => "Mei", "徿" => "Long", "忀" => "Xiang",
    "忁" => "Bao", "忂" => "Qu", "心" => "Xin", "忄" => "Shu", "必" => "Bi", "忆" => "Yi",
    "忇" => "Le", "忈" => "Ren", "忉" => "Dao", "忊" => "Ding", "忋" => "Gai", "忌" => "Ji",
    "忍" => "Ren", "忎" => "Ren", "忏" => "Chan", "忐" => "Tan", "忑" => "Te", "忒" => "Te",
    "忓" => "Gan", "忔" => "Qi", "忕" => "Shi", "忖" => "Cun", "志" => "Zhi", "忘" => "Wang",
    "忙" => "Mang", "忚" => "Xi", "忛" => "Fan", "応" => "Ying", "忝" => "Tian", "忞" => "Min",
    "忟" => "Min", "忠" => "Zhong", "忡" => "Chong", "忢" => "Wu", "忣" => "Ji", "忤" => "Wu",
    "忥" => "Xi", "忦" => "Ye", "忧" => "You", "忨" => "Wan", "忩" => "Cong", "忪" => "Zhong",
    "快" => "Kuai", "忬" => "Yu", "忭" => "Bian", "忮" => "Zhi", "忯" => "Qi", "忰" => "Cui",
    "忱" => "Chen", "忲" => "Tai", "忳" => "Tun", "忴" => "Qian", "念" => "Nian", "忶" => "Hun",
    "忷" => "Xiong", "忸" => "Niu", "忹" => "Wang", "忺" => "Xian", "忻" => "Xin", "忼" => "Kang",
    "忽" => "Hu", "忾" => "Kai", "忿" => "Fen", "态" => "Tai", "怂" => "Song", "怃" => "Wu",
    "怄" => "Ou", "怅" => "Chang", "怆" => "Chuang", "怇" => "Ju", "怈" => "Yi", "怉" => "Bao",
    "怊" => "Chao", "怋" => "Min", "怌" => "Pei", "怍" => "Zuo", "怎" => "Zen", "怏" => "Yang",
    "怐" => "Kou", "怑" => "Ban", "怒" => "Nu", "怓" => "Nao", "怔" => "Zheng", "怕" => "Pa",
    "怖" => "Bu", "怗" => "Tie", "怘" => "Gu", "怙" => "Hu", "怚" => "Ju", "怛" => "Da",
    "怜" => "Lian", "思" => "Si", "怞" => "Chou", "怟" => "Di", "怠" => "Dai", "怡" => "Yi",
    "怢" => "Tu", "怣" => "You", "怤" => "Fu", "急" => "Ji", "怦" => "Peng", "性" => "Xing",
    "怨" => "Yuan", "怩" => "Ni", "怪" => "Guai", "怫" => "Fu", "怬" => "Xi", "怭" => "Bi",
    "怮" => "You", "怯" => "Qie", "怰" => "Xuan", "怱" => "Cong", "怲" => "Bing", "怳" => "Huang",
    "怴" => "Xu", "怵" => "Chu", "怶" => "Pi", "怷" => "Xi", "怸" => "Xi", "怹" => "Tan",
    "怺" => "Koraeru", "总" => "Zong", "怼" => "Dui", "怾" => "Ki", "怿" => "Yi", "恀" => "Chi",
    "恁" => "Ren", "恂" => "Xun", "恃" => "Shi", "恄" => "Xi", "恅" => "Lao", "恆" => "Heng",
    "恇" => "Kuang", "恈" => "Mu", "恉" => "Zhi", "恊" => "Xie", "恋" => "Lian", "恌" => "Tiao",
    "恍" => "Huang", "恎" => "Die", "恏" => "Hao", "恐" => "Kong", "恑" => "Gui", "恒" => "Heng",
    "恓" => "Xi", "恔" => "Xiao", "恕" => "Shu", "恖" => "S", "恗" => "Kua", "恘" => "Qiu",
    "恙" => "Yang", "恚" => "Hui", "恛" => "Hui", "恜" => "Chi", "恝" => "Jia", "恞" => "Yi",
    "恟" => "Xiong", "恠" => "Guai", "恡" => "Lin", "恢" => "Hui", "恣" => "Zi", "恤" => "Xu",
    "恥" => "Chi", "恦" => "Xiang", "恧" => "Nu", "恨" => "Hen", "恩" => "En", "恪" => "Ke",
    "恫" => "Tong", "恬" => "Tian", "恭" => "Gong", "恮" => "Quan", "息" => "Xi", "恰" => "Qia",
    "恱" => "Yue", "恲" => "Peng", "恳" => "Ken", "恴" => "De", "恵" => "Hui", "恶" => "E",
    "恷" => "Kyuu", "恸" => "Tong", "恹" => "Yan", "恺" => "Kai", "恻" => "Ce", "恼" => "Nao",
    "恽" => "Yun", "恾" => "Mang", "恿" => "Yong", "悀" => "Yong", "悁" => "Yuan", "悂" => "Pi",
    "悃" => "Kun", "悄" => "Qiao", "悅" => "Yue", "悆" => "Yu", "悇" => "Yu", "悈" => "Jie",
    "悉" => "Xi", "悊" => "Zhe", "悋" => "Lin", "悌" => "Ti", "悍" => "Han", "悎" => "Hao",
    "悏" => "Qie", "悐" => "Ti", "悑" => "Bu", "悒" => "Yi", "悓" => "Qian", "悔" => "Hui",
    "悕" => "Xi", "悖" => "Bei", "悗" => "Man", "悘" => "Yi", "悙" => "Heng", "悚" => "Song",
    "悛" => "Quan", "悜" => "Cheng", "悝" => "Hui", "悞" => "Wu", "悟" => "Wu", "悠" => "You",
    "悡" => "Li", "悢" => "Liang", "患" => "Huan", "悤" => "Cong", "悥" => "Yi", "悦" => "Yue",
    "悧" => "Li", "您" => "Nin", "悩" => "Nao", "悪" => "E", "悫" => "Que", "悬" => "Xuan",
    "悭" => "Qian", "悮" => "Wu", "悯" => "Min", "悰" => "Cong", "悱" => "Fei", "悲" => "Bei",
    "悳" => "Duo", "悴" => "Cui", "悵" => "Chang", "悶" => "Men", "悷" => "Li", "悸" => "Ji",
    "悹" => "Guan", "悺" => "Guan", "悻" => "Xing", "悼" => "Dao", "悽" => "Qi", "悾" => "Kong",
    "悿" => "Tian", "惀" => "Lun", "惁" => "Xi", "惂" => "Kan", "惃" => "Kun", "惄" => "Ni",
    "情" => "Qing", "惆" => "Chou", "惇" => "Dun", "惈" => "Guo", "惉" => "Chan", "惊" => "Liang",
    "惋" => "Wan", "惌" => "Yuan", "惍" => "Jin", "惎" => "Ji", "惏" => "Lin", "惐" => "Yu",
    "惑" => "Huo", "惒" => "He", "惓" => "Quan", "惔" => "Tan", "惕" => "Ti", "惖" => "Ti",
    "惗" => "Nie", "惘" => "Wang", "惙" => "Chuo", "惚" => "Bu", "惛" => "Hun", "惜" => "Xi",
    "惝" => "Tang", "惞" => "Xin", "惟" => "Wei", "惠" => "Hui", "惡" => "E", "惢" => "Rui",
    "惣" => "Zong", "惤" => "Jian", "惥" => "Yong", "惦" => "Dian", "惧" => "Ju", "惨" => "Can",
    "惩" => "Cheng", "惪" => "De", "惫" => "Bei", "惬" => "Qie", "惭" => "Can", "惮" => "Dan",
    "惯" => "Guan", "惰" => "Duo", "惱" => "Nao", "惲" => "Yun", "想" => "Xiang", "惴" => "Zhui",
    "惵" => "Die", "惶" => "Huang", "惷" => "Chun", "惸" => "Qiong", "惹" => "Re", "惺" => "Xing",
    "惻" => "Ce", "惼" => "Bian", "惽" => "Hun", "惾" => "Zong", "惿" => "Ti", "愁" => "Chou",
    "愂" => "Bei", "愃" => "Xuan", "愄" => "Wei", "愅" => "Ge", "愆" => "Qian", "愇" => "Wei",
    "愈" => "Yu", "愉" => "Yu", "愊" => "Bi", "愋" => "Xuan", "愌" => "Huan", "愍" => "Min",
    "愎" => "Bi", "意" => "Yi", "愐" => "Mian", "愑" => "Yong", "愒" => "Kai", "愓" => "Dang",
    "愔" => "Yin", "愕" => "E", "愖" => "Chen", "愗" => "Mou", "愘" => "Ke", "愙" => "Ke",
    "愚" => "Yu", "愛" => "Ai", "愜" => "Qie", "愝" => "Yan", "愞" => "Nuo", "感" => "Gan",
    "愠" => "Yun", "愡" => "Zong", "愢" => "Sai", "愣" => "Leng", "愤" => "Fen", "愦" => "Kui",
    "愧" => "Kui", "愨" => "Que", "愩" => "Gong", "愪" => "Yun", "愫" => "Su", "愬" => "Su",
    "愭" => "Qi", "愮" => "Yao", "愯" => "Song", "愰" => "Huang", "愱" => "Ji", "愲" => "Gu",
    "愳" => "Ju", "愴" => "Chuang", "愵" => "Ni", "愶" => "Xie", "愷" => "Kai", "愸" => "Zheng",
    "愹" => "Yong", "愺" => "Cao", "愻" => "Sun", "愼" => "Shen", "愽" => "Bo", "愾" => "Kai",
    "愿" => "Yuan", "慀" => "Xie", "慁" => "Hun", "慂" => "Yong", "慃" => "Yang", "慄" => "Li",
    "慅" => "Sao", "慆" => "Tao", "慇" => "Yin", "慈" => "Ci", "慉" => "Xu", "慊" => "Qian",
    "態" => "Tai", "慌" => "Huang", "慍" => "Yun", "慎" => "Shen", "慏" => "Ming", "慑" => "She",
    "慒" => "Cong", "慓" => "Piao", "慔" => "Mo", "慕" => "Mu", "慖" => "Guo", "慗" => "Chi",
    "慘" => "Can", "慙" => "Can", "慚" => "Can", "慛" => "Cui", "慜" => "Min", "慝" => "Te",
    "慞" => "Zhang", "慟" => "Tong", "慠" => "Ao", "慡" => "Shuang", "慢" => "Man", "慣" => "Guan",
    "慤" => "Que", "慥" => "Zao", "慦" => "Jiu", "慧" => "Hui", "慨" => "Kai", "慩" => "Lian",
    "慪" => "Ou", "慫" => "Song", "慬" => "Jin", "慭" => "Yin", "慮" => "Lu", "慯" => "Shang",
    "慰" => "Wei", "慱" => "Tuan", "慲" => "Man", "慳" => "Qian", "慴" => "She", "慵" => "Yong",
    "慶" => "Qing", "慷" => "Kang", "慸" => "Di", "慹" => "Zhi", "慺" => "Lou", "慻" => "Juan",
    "慼" => "Qi", "慽" => "Qi", "慾" => "Yu", "慿" => "Ping", "憀" => "Liao", "憁" => "Cong",
    "憂" => "You", "憃" => "Chong", "憄" => "Zhi", "憅" => "Tong", "憆" => "Cheng", "憇" => "Qi",
    "憈" => "Qu", "憉" => "Peng", "憊" => "Bei", "憋" => "Bie", "憌" => "Chun", "憍" => "Jiao",
    "憎" => "Zeng", "憏" => "Chi", "憐" => "Lian", "憑" => "Ping", "憒" => "Kui", "憓" => "Hui",
    "憔" => "Qiao", "憕" => "Cheng", "憖" => "Yin", "憗" => "Yin", "憘" => "Xi", "憙" => "Xi",
    "憚" => "Dan", "憛" => "Tan", "憜" => "Duo", "憝" => "Dui", "憞" => "Dui", "憟" => "Su",
    "憠" => "Jue", "憡" => "Ce", "憢" => "Xiao", "憣" => "Fan", "憤" => "Fen", "憥" => "Lao",
    "憦" => "Lao", "憧" => "Chong", "憨" => "Han", "憩" => "Qi", "憪" => "Xian", "憫" => "Min",
    "憬" => "Jing", "憭" => "Liao", "憮" => "Wu", "憯" => "Can", "憰" => "Jue", "憱" => "Cu",
    "憲" => "Xian", "憳" => "Tan", "憴" => "Sheng", "憵" => "Pi", "憶" => "Yi", "憷" => "Chu",
    "憸" => "Xian", "憹" => "Nao", "憺" => "Dan", "憻" => "Tan", "憼" => "Jing", "憽" => "Song",
    "憾" => "Han", "憿" => "Jiao", "懀" => "Wai", "懁" => "Huan", "懂" => "Dong", "懃" => "Qin",
    "懄" => "Qin", "懅" => "Qu", "懆" => "Cao", "懇" => "Ken", "懈" => "Xie", "應" => "Ying",
    "懊" => "Ao", "懋" => "Mao", "懌" => "Yi", "懍" => "Lin", "懎" => "Se", "懏" => "Jun",
    "懐" => "Huai", "懑" => "Men", "懒" => "Lan", "懓" => "Ai", "懔" => "Lin", "懕" => "Yan",
    "懖" => "Gua", "懗" => "Xia", "懘" => "Chi", "懙" => "Yu", "懚" => "Yin", "懛" => "Dai",
    "懜" => "Meng", "懝" => "Ai", "懞" => "Meng", "懟" => "Dui", "懠" => "Qi", "懡" => "Mo",
    "懢" => "Lan", "懣" => "Men", "懤" => "Chou", "懥" => "Zhi", "懦" => "Nuo", "懧" => "Nuo",
    "懨" => "Yan", "懩" => "Yang", "懪" => "Bo", "懫" => "Zhi", "懬" => "Kuang", "懭" => "Kuang",
    "懮" => "You", "懯" => "Fu", "懰" => "Liu", "懱" => "Mie", "懲" => "Cheng", "懴" => "Chan",
    "懵" => "Meng", "懶" => "Lan", "懷" => "Huai", "懸" => "Xuan", "懹" => "Rang", "懺" => "Chan",
    "懻" => "Ji", "懼" => "Ju", "懽" => "Huan", "懾" => "She", "懿" => "Yi", "戁" => "Nan",
    "戂" => "Mi", "戃" => "Tang", "戄" => "Jue", "戅" => "Gang", "戆" => "Gang", "戇" => "Gang",
    "戈" => "Ge", "戉" => "Yue", "戊" => "Wu", "戋" => "Jian", "戌" => "Xu", "戍" => "Shu",
    "戎" => "Rong", "戏" => "Xi", "成" => "Cheng", "我" => "Wo", "戒" => "Jie", "戓" => "Ge",
    "戔" => "Jian", "戕" => "Qiang", "或" => "Huo", "戗" => "Qiang", "战" => "Zhan", "戙" => "Dong",
    "戚" => "Qi", "戛" => "Jia", "戜" => "Die", "戝" => "Zei", "戞" => "Jia", "戟" => "Ji",
    "戠" => "Shi", "戡" => "Kan", "戢" => "Ji", "戣" => "Kui", "戤" => "Gai", "戥" => "Deng",
    "戦" => "Zhan", "戧" => "Chuang", "戨" => "Ge", "戩" => "Jian", "截" => "Jie", "戫" => "Yu",
    "戬" => "Jian", "戭" => "Yan", "戮" => "Lu", "戯" => "Xi", "戰" => "Zhan", "戱" => "Xi",
    "戲" => "Xi", "戳" => "Chuo", "戴" => "Dai", "戵" => "Qu", "戶" => "Hu", "户" => "Hu",
    "戸" => "Hu", "戹" => "E", "戺" => "Shi", "戻" => "Li", "戼" => "Mao", "戽" => "Hu",
    "戾" => "Li", "房" => "Fang", "所" => "Suo", "扁" => "Bian", "扂" => "Dian", "扃" => "Jiong",
    "扄" => "Shang", "扅" => "Yi", "扆" => "Yi", "扇" => "Shan", "扈" => "Hu", "扉" => "Fei",
    "扊" => "Yan", "手" => "Shou", "扌" => "T", "才" => "Cai", "扎" => "Zha", "扏" => "Qiu",
    "扐" => "Le", "扑" => "Bu", "扒" => "Ba", "打" => "Da", "扔" => "Reng", "払" => "Fu",
    "扖" => "Hameru", "扗" => "Zai", "托" => "Tuo", "扙" => "Zhang", "扚" => "Diao", "扛" => "Kang",
    "扜" => "Yu", "扝" => "Ku", "扞" => "Han", "扟" => "Shen", "扠" => "Cha", "扡" => "Yi",
    "扢" => "Gu", "扣" => "Kou", "扤" => "Wu", "扥" => "Tuo", "扦" => "Qian", "执" => "Zhi",
    "扨" => "Ren", "扩" => "Kuo", "扪" => "Men", "扫" => "Sao", "扬" => "Yang", "扭" => "Niu",
    "扮" => "Ban", "扯" => "Che", "扰" => "Rao", "扱" => "Xi", "扲" => "Qian", "扳" => "Ban",
    "扴" => "Jia", "扵" => "Yu", "扶" => "Fu", "扷" => "Ao", "扸" => "Xi", "批" => "Pi",
    "扺" => "Zhi", "扻" => "Zi", "扼" => "E", "扽" => "Dun", "找" => "Zhao", "承" => "Cheng",
    "技" => "Ji", "抁" => "Yan", "抂" => "Kuang", "抃" => "Bian", "抄" => "Chao", "抅" => "Ju",
    "抆" => "Wen", "抇" => "Hu", "抈" => "Yue", "抉" => "Jue", "把" => "Ba", "抋" => "Qin",
    "抌" => "Zhen", "抍" => "Zheng", "抎" => "Yun", "抏" => "Wan", "抐" => "Nu", "抑" => "Yi",
    "抒" => "Shu", "抓" => "Zhua", "抔" => "Pou", "投" => "Tou", "抖" => "Dou", "抗" => "Kang",
    "折" => "Zhe", "抙" => "Pou", "抚" => "Fu", "抛" => "Pao", "抜" => "Ba", "抝" => "Ao",
    "択" => "Ze", "抟" => "Tuan", "抠" => "Kou", "抡" => "Lun", "抢" => "Qiang", "护" => "Hu",
    "报" => "Bao", "抦" => "Bing", "抧" => "Zhi", "抨" => "Peng", "抩" => "Tan", "抪" => "Pu",
    "披" => "Pi", "抬" => "Tai", "抭" => "Yao", "抮" => "Zhen", "抯" => "Zha", "抰" => "Yang",
    "抱" => "Bao", "抲" => "He", "抳" => "Ni", "抴" => "Yi", "抵" => "Di", "抶" => "Chi",
    "抷" => "Pi", "抸" => "Za", "抹" => "Mo", "抺" => "Mo", "抻" => "Shen", "押" => "Ya",
    "抽" => "Chou", "抾" => "Qu", "抿" => "Min", "拀" => "Chu", "拁" => "Jia", "拂" => "Fu",
    "拃" => "Zhan", "拄" => "Zhu", "担" => "Dan", "拆" => "Chai", "拇" => "Mu", "拈" => "Nian",
    "拉" => "La", "拊" => "Fu", "拋" => "Pao", "拌" => "Ban", "拍" => "Pai", "拎" => "Ling",
    "拏" => "Na", "拐" => "Guai", "拑" => "Qian", "拒" => "Ju", "拓" => "Tuo", "拔" => "Ba",
    "拕" => "Tuo", "拖" => "Tuo", "拗" => "Ao", "拘" => "Ju", "拙" => "Zhuo", "拚" => "Pan",
    "招" => "Zhao", "拜" => "Bai", "拝" => "Bai", "拞" => "Di", "拟" => "Ni", "拠" => "Ju",
    "拡" => "Kuo", "拢" => "Long", "拣" => "Jian", "拥" => "Yong", "拦" => "Lan", "拧" => "Ning",
    "拨" => "Bo", "择" => "Ze", "拪" => "Qian", "拫" => "Hen", "括" => "Gua", "拭" => "Shi",
    "拮" => "Jie", "拯" => "Zheng", "拰" => "Nin", "拱" => "Gong", "拲" => "Gong", "拳" => "Quan",
    "拴" => "Shuan", "拵" => "Cun", "拶" => "Zan", "拷" => "Kao", "拸" => "Chi", "拹" => "Xie",
    "拺" => "Ce", "拻" => "Hui", "拼" => "Pin", "拽" => "Zhuai", "拾" => "Shi", "拿" => "Na",
    "持" => "Chi", "挂" => "Gua", "挃" => "Zhi", "挄" => "Kuo", "挅" => "Duo", "挆" => "Duo",
    "指" => "Zhi", "挈" => "Qie", "按" => "An", "挊" => "Nong", "挋" => "Zhen", "挌" => "Ge",
    "挍" => "Jiao", "挎" => "Ku", "挏" => "Dong", "挐" => "Ru", "挑" => "Tiao", "挒" => "Lie",
    "挓" => "Zha", "挔" => "Lu", "挕" => "Die", "挖" => "Wa", "挗" => "Jue", "挘" => "Mushiru",
    "挙" => "Ju", "挚" => "Zhi", "挛" => "Luan", "挜" => "Ya", "挝" => "Zhua", "挞" => "Ta",
    "挟" => "Xie", "挠" => "Nao", "挡" => "Dang", "挢" => "Jiao", "挣" => "Zheng", "挤" => "Ji",
    "挥" => "Hui", "挦" => "Xun", "挧" => "Ku", "挨" => "Ai", "挩" => "Tuo", "挪" => "Nuo",
    "挫" => "Cuo", "挬" => "Bo", "挭" => "Geng", "挮" => "Ti", "振" => "Zhen", "挰" => "Cheng",
    "挱" => "Suo", "挲" => "Suo", "挳" => "Keng", "挴" => "Mei", "挵" => "Long", "挶" => "Ju",
    "挷" => "Peng", "挸" => "Jian", "挹" => "Yi", "挺" => "Ting", "挻" => "Shan", "挼" => "Nuo",
    "挽" => "Wan", "挾" => "Xie", "挿" => "Cha", "捀" => "Feng", "捁" => "Jiao", "捂" => "Wu",
    "捃" => "Jun", "捄" => "Jiu", "捅" => "Tong", "捆" => "Kun", "捇" => "Huo", "捈" => "Tu",
    "捉" => "Zhuo", "捊" => "Pou", "捋" => "Le", "捌" => "Ba", "捍" => "Han", "捎" => "Shao",
    "捏" => "Nie", "捐" => "Juan", "捑" => "Ze", "捒" => "Song", "捓" => "Ye", "捔" => "Jue",
    "捕" => "Bu", "捖" => "Huan", "捗" => "Bu", "捘" => "Zun", "捙" => "Yi", "捚" => "Zhai",
    "捛" => "Lu", "捜" => "Sou", "捝" => "Tuo", "捞" => "Lao", "损" => "Sun", "捠" => "Bang",
    "捡" => "Jian", "换" => "Huan", "捣" => "Dao", "捥" => "Wan", "捦" => "Qin", "捧" => "Peng",
    "捨" => "She", "捩" => "Lie", "捪" => "Min", "捫" => "Men", "捬" => "Fu", "捭" => "Bai",
    "据" => "Ju", "捯" => "Dao", "捰" => "Wo", "捱" => "Ai", "捲" => "Juan", "捳" => "Yue",
    "捴" => "Zong", "捵" => "Chen", "捶" => "Chui", "捷" => "Jie", "捸" => "Tu", "捹" => "Ben",
    "捺" => "Na", "捻" => "Nian", "捼" => "Nuo", "捽" => "Zu", "捾" => "Wo", "捿" => "Xi",
    "掀" => "Xian", "掁" => "Cheng", "掂" => "Dian", "掃" => "Sao", "掄" => "Lun", "掅" => "Qing",
    "掆" => "Gang", "掇" => "Duo", "授" => "Shou", "掉" => "Diao", "掊" => "Pou", "掋" => "Di",
    "掌" => "Zhang", "掍" => "Gun", "掎" => "Ji", "掏" => "Tao", "掐" => "Qia", "掑" => "Qi",
    "排" => "Pai", "掓" => "Shu", "掔" => "Qian", "掕" => "Ling", "掖" => "Yi", "掗" => "Ya",
    "掘" => "Jue", "掙" => "Zheng", "掚" => "Liang", "掛" => "Gua", "掜" => "Yi", "掝" => "Huo",
    "掞" => "Shan", "掟" => "Zheng", "掠" => "Lue", "採" => "Cai", "探" => "Tan", "掣" => "Che",
    "掤" => "Bing", "接" => "Jie", "掦" => "Ti", "控" => "Kong", "推" => "Tui", "掩" => "Yan",
    "措" => "Cuo", "掫" => "Zou", "掬" => "Ju", "掭" => "Tian", "掮" => "Qian", "掯" => "Ken",
    "掰" => "Bai", "掱" => "Shou", "掲" => "Jie", "掳" => "Lu", "掴" => "Guo", "掵" => "Haba",
    "掷" => "Zhi", "掸" => "Dan", "掹" => "Mang", "掺" => "Xian", "掻" => "Sao", "掼" => "Guan",
    "掽" => "Peng", "掾" => "Yuan", "掿" => "Nuo", "揀" => "Jian", "揁" => "Zhen", "揂" => "Jiu",
    "揃" => "Jian", "揄" => "Yu", "揅" => "Yan", "揆" => "Kui", "揇" => "Nan", "揈" => "Hong",
    "揉" => "Rou", "揊" => "Pi", "揋" => "Wei", "揌" => "Sai", "揍" => "Zou", "揎" => "Xuan",
    "描" => "Miao", "提" => "Ti", "揑" => "Nie", "插" => "Cha", "揓" => "Shi", "揔" => "Zong",
    "揕" => "Zhen", "揖" => "Yi", "揗" => "Shun", "揘" => "Heng", "揙" => "Bian", "揚" => "Yang",
    "換" => "Huan", "揜" => "Yan", "揝" => "Zuan", "揞" => "An", "揟" => "Xu", "揠" => "Ya",
    "握" => "Wo", "揢" => "Ke", "揣" => "Chuai", "揤" => "Ji", "揥" => "Ti", "揦" => "La",
    "揧" => "La", "揨" => "Cheng", "揩" => "Kai", "揪" => "Jiu", "揫" => "Jiu", "揬" => "Tu",
    "揭" => "Jie", "揮" => "Hui", "揯" => "Geng", "揰" => "Chong", "揱" => "Shuo", "揲" => "She",
    "揳" => "Xie", "援" => "Yuan", "揵" => "Qian", "揶" => "Ye", "揷" => "Cha", "揸" => "Zha",
    "揹" => "Bei", "揺" => "Yao", "揽" => "Lan", "揾" => "Wen", "揿" => "Qin", "搁" => "Ge",
    "搂" => "Lou", "搃" => "Zong", "搄" => "Geng", "搅" => "Jiao", "搆" => "Gou", "搇" => "Qin",
    "搈" => "Yong", "搉" => "Que", "搊" => "Chou", "搋" => "Chi", "搌" => "Zhan", "損" => "Sun",
    "搎" => "Sun", "搏" => "Bo", "搐" => "Chu", "搑" => "Rong", "搒" => "Beng", "搓" => "Cuo",
    "搔" => "Sao", "搕" => "Ke", "搖" => "Yao", "搗" => "Dao", "搘" => "Zhi", "搙" => "Nu",
    "搚" => "Xie", "搛" => "Jian", "搜" => "Sou", "搝" => "Qiu", "搞" => "Gao", "搟" => "Xian",
    "搠" => "Shuo", "搡" => "Sang", "搢" => "Jin", "搣" => "Mie", "搤" => "E", "搥" => "Chui",
    "搦" => "Nuo", "搧" => "Shan", "搨" => "Ta", "搩" => "Jie", "搪" => "Tang", "搫" => "Pan",
    "搬" => "Ban", "搭" => "Da", "搮" => "Li", "搯" => "Tao", "搰" => "Hu", "搱" => "Zhi",
    "搲" => "Wa", "搳" => "Xia", "搴" => "Qian", "搵" => "Wen", "搶" => "Qiang", "搷" => "Tian",
    "搸" => "Zhen", "搹" => "E", "携" => "Xi", "搻" => "Nuo", "搼" => "Quan", "搽" => "Cha",
    "搾" => "Zha", "搿" => "Ge", "摀" => "Wu", "摁" => "En", "摂" => "She", "摃" => "Kang",
    "摄" => "She", "摅" => "Shu", "摆" => "Bai", "摇" => "Yao", "摈" => "Bin", "摉" => "Sou",
    "摊" => "Tan", "摋" => "Sa", "摌" => "Chan", "摍" => "Suo", "摎" => "Liao", "摏" => "Chong",
    "摐" => "Chuang", "摑" => "Guo", "摒" => "Bing", "摓" => "Feng", "摔" => "Shuai", "摕" => "Di",
    "摖" => "Qi", "摗" => "Sou", "摘" => "Zhai", "摙" => "Lian", "摚" => "Tang", "摛" => "Chi",
    "摜" => "Guan", "摝" => "Lu", "摞" => "Luo", "摟" => "Lou", "摠" => "Zong", "摡" => "Gai",
    "摢" => "Hu", "摣" => "Zha", "摤" => "Chuang", "摥" => "Tang", "摦" => "Hua", "摧" => "Cui",
    "摨" => "Nai", "摩" => "Mo", "摪" => "Jiang", "摫" => "Gui", "摬" => "Ying", "摭" => "Zhi",
    "摮" => "Ao", "摯" => "Zhi", "摰" => "Nie", "摱" => "Man", "摲" => "Shan", "摳" => "Kou",
    "摴" => "Shu", "摵" => "Suo", "摶" => "Tuan", "摷" => "Jiao", "摸" => "Mo", "摹" => "Mo",
    "摺" => "Zhe", "摻" => "Xian", "摼" => "Keng", "摽" => "Piao", "摾" => "Jiang", "摿" => "Yin",
    "撀" => "Gou", "撁" => "Qian", "撂" => "Lue", "撃" => "Ji", "撄" => "Ying", "撅" => "Jue",
    "撆" => "Pie", "撇" => "Pie", "撈" => "Lao", "撉" => "Dun", "撊" => "Xian", "撋" => "Ruan",
    "撌" => "Kui", "撍" => "Zan", "撎" => "Yi", "撏" => "Xun", "撐" => "Cheng", "撑" => "Cheng",
    "撒" => "Sa", "撓" => "Nao", "撔" => "Heng", "撕" => "Si", "撖" => "Qian", "撗" => "Huang",
    "撘" => "Da", "撙" => "Zun", "撚" => "Nian", "撛" => "Lin", "撜" => "Zheng", "撝" => "Hui",
    "撞" => "Zhuang", "撟" => "Jiao", "撠" => "Ji", "撡" => "Cao", "撢" => "Dan", "撣" => "Dan",
    "撤" => "Che", "撥" => "Bo", "撦" => "Che", "撧" => "Jue", "撨" => "Xiao", "撩" => "Liao",
    "撪" => "Ben", "撫" => "Fu", "撬" => "Qiao", "播" => "Bo", "撮" => "Cuo", "撯" => "Zhuo",
    "撰" => "Zhuan", "撱" => "Tuo", "撲" => "Pu", "撳" => "Qin", "撴" => "Dun", "撵" => "Nian",
    "撷" => "Xie", "撸" => "Lu", "撹" => "Jiao", "撺" => "Cuan", "撻" => "Ta", "撼" => "Han",
    "撽" => "Qiao", "撾" => "Zhua", "撿" => "Jian", "擀" => "Gan", "擁" => "Yong", "擂" => "Lei",
    "擃" => "Kuo", "擄" => "Lu", "擅" => "Shan", "擆" => "Zhuo", "擇" => "Ze", "擈" => "Pu",
    "擉" => "Chuo", "擊" => "Ji", "擋" => "Dang", "擌" => "Suo", "操" => "Cao", "擎" => "Qing",
    "擏" => "Jing", "擐" => "Huan", "擑" => "Jie", "擒" => "Qin", "擓" => "Kuai", "擔" => "Dan",
    "擕" => "Xi", "擖" => "Ge", "擗" => "Pi", "擘" => "Bo", "擙" => "Ao", "據" => "Ju",
    "擛" => "Ye", "擝" => "Mang", "擞" => "Sou", "擟" => "Mi", "擠" => "Ji", "擡" => "Tai",
    "擢" => "Zhuo", "擣" => "Dao", "擤" => "Xing", "擥" => "Lan", "擦" => "Ca", "擧" => "Ju",
    "擨" => "Ye", "擩" => "Ru", "擪" => "Ye", "擫" => "Ye", "擬" => "Ni", "擭" => "Hu",
    "擮" => "Ji", "擯" => "Bin", "擰" => "Ning", "擱" => "Ge", "擲" => "Zhi", "擳" => "Jie",
    "擴" => "Kuo", "擵" => "Mo", "擶" => "Jian", "擷" => "Xie", "擸" => "Lie", "擹" => "Tan",
    "擺" => "Bai", "擻" => "Sou", "擼" => "Lu", "擽" => "Lue", "擾" => "Rao", "擿" => "Zhi",
    "攁" => "Yang", "攂" => "Lei", "攃" => "Sa", "攄" => "Shu", "攅" => "Zan", "攆" => "Nian",
    "攇" => "Xian", "攈" => "Jun", "攉" => "Huo", "攊" => "Li", "攋" => "La", "攌" => "Han",
    "攍" => "Ying", "攎" => "Lu", "攏" => "Long", "攐" => "Qian", "攑" => "Qian", "攒" => "Zan",
    "攓" => "Qian", "攔" => "Lan", "攕" => "San", "攖" => "Ying", "攗" => "Mei", "攘" => "Rang",
    "攙" => "Chan", "攛" => "Cuan", "攜" => "Xi", "攝" => "She", "攞" => "Luo", "攟" => "Jun",
    "攠" => "Mi", "攡" => "Li", "攢" => "Zan", "攣" => "Luan", "攤" => "Tan", "攥" => "Zuan",
    "攦" => "Li", "攧" => "Dian", "攨" => "Wa", "攩" => "Dang", "攪" => "Jiao", "攫" => "Jue",
    "攬" => "Lan", "攭" => "Li", "攮" => "Nang", "支" => "Zhi", "攰" => "Gui", "攱" => "Gui",
    "攲" => "Qi", "攳" => "Xin", "攴" => "Pu", "攵" => "Sui", "收" => "Shou", "攷" => "Kao",
    "攸" => "You", "改" => "Gai", "攺" => "Yi", "攻" => "Gong", "攼" => "Gan", "攽" => "Ban",
    "放" => "Fang", "政" => "Zheng", "敀" => "Bo", "敁" => "Dian", "敂" => "Kou", "敃" => "Min",
    "敄" => "Wu", "故" => "Gu", "敆" => "He", "敇" => "Ce", "效" => "Xiao", "敉" => "Mi",
    "敊" => "Chu", "敋" => "Ge", "敌" => "Di", "敍" => "Xu", "敎" => "Jiao", "敏" => "Min",
    "敐" => "Chen", "救" => "Jiu", "敒" => "Zhen", "敓" => "Duo", "敔" => "Yu", "敕" => "Chi",
    "敖" => "Ao", "敗" => "Bai", "敘" => "Xu", "教" => "Jiao", "敚" => "Duo", "敛" => "Lian",
    "敜" => "Nie", "敝" => "Bi", "敞" => "Chang", "敟" => "Dian", "敠" => "Duo", "敡" => "Yi",
    "敢" => "Gan", "散" => "San", "敤" => "Ke", "敥" => "Yan", "敦" => "Dun", "敧" => "Qi",
    "敨" => "Dou", "敩" => "Xiao", "敪" => "Duo", "敫" => "Jiao", "敬" => "Jing", "敭" => "Yang",
    "敮" => "Xia", "敯" => "Min", "数" => "Shu", "敱" => "Ai", "敲" => "Qiao", "敳" => "Ai",
    "整" => "Zheng", "敵" => "Di", "敶" => "Zhen", "敷" => "Fu", "數" => "Shu", "敹" => "Liao",
    "敺" => "Qu", "敻" => "Xiong", "敼" => "Xi", "敽" => "Jiao", "敾" => "Sen", "敿" => "Jiao",
    "斀" => "Zhuo", "斁" => "Yi", "斂" => "Lian", "斃" => "Bi", "斄" => "Li", "斅" => "Xiao",
    "斆" => "Xiao", "文" => "Wen", "斈" => "Xue", "斉" => "Qi", "斊" => "Qi", "斋" => "Zhai",
    "斌" => "Bin", "斍" => "Jue", "斎" => "Zhai", "斐" => "Fei", "斑" => "Ban", "斒" => "Ban",
    "斓" => "Lan", "斔" => "Yu", "斕" => "Lan", "斖" => "Wei", "斗" => "Dou", "斘" => "Sheng",
    "料" => "Liao", "斚" => "Jia", "斛" => "Hu", "斜" => "Xie", "斝" => "Jia", "斞" => "Yu",
    "斟" => "Zhen", "斠" => "Jiao", "斡" => "Wo", "斢" => "Tou", "斣" => "Chu", "斤" => "Jin",
    "斥" => "Chi", "斦" => "Yin", "斧" => "Fu", "斨" => "Qiang", "斩" => "Zhan", "斪" => "Qu",
    "斫" => "Zhuo", "斬" => "Zhan", "断" => "Duan", "斮" => "Zhuo", "斯" => "Si", "新" => "Xin",
    "斱" => "Zhuo", "斲" => "Zhuo", "斳" => "Qin", "斴" => "Lin", "斵" => "Zhuo", "斶" => "Chu",
    "斷" => "Duan", "斸" => "Zhu", "方" => "Fang", "斺" => "Xie", "斻" => "Hang", "於" => "Yu",
    "施" => "Shi", "斾" => "Pei", "斿" => "You", "旀" => "Mye", "旁" => "Pang", "旂" => "Qi",
    "旃" => "Zhan", "旄" => "Mao", "旅" => "Lu", "旆" => "Pei", "旇" => "Pi", "旈" => "Liu",
    "旉" => "Fu", "旊" => "Fang", "旋" => "Xuan", "旌" => "Jing", "旍" => "Jing", "旎" => "Ni",
    "族" => "Zu", "旐" => "Zhao", "旑" => "Yi", "旒" => "Liu", "旓" => "Shao", "旔" => "Jian",
    "旕" => "Es", "旖" => "Yi", "旗" => "Qi", "旘" => "Zhi", "旙" => "Fan", "旚" => "Piao",
    "旛" => "Fan", "旜" => "Zhan", "旝" => "Guai", "旞" => "Sui", "旟" => "Yu", "无" => "Wu",
    "旡" => "Ji", "既" => "Ji", "旣" => "Ji", "旤" => "Huo", "日" => "Ri", "旦" => "Dan",
    "旧" => "Jiu", "旨" => "Zhi", "早" => "Zao", "旪" => "Xie", "旫" => "Tiao", "旬" => "Xun",
    "旭" => "Xu", "旮" => "Xu", "旯" => "Xu", "旰" => "Gan", "旱" => "Han", "旲" => "Tai",
    "旳" => "Di", "旴" => "Xu", "旵" => "Chan", "时" => "Shi", "旷" => "Kuang", "旸" => "Yang",
    "旹" => "Shi", "旺" => "Wang", "旻" => "Min", "旼" => "Min", "旽" => "Tun", "旾" => "Chun",
    "旿" => "Wu", "昁" => "Bei", "昂" => "Ang", "昃" => "Ze", "昄" => "Ban", "昅" => "Jie",
    "昆" => "Kun", "昇" => "Sheng", "昈" => "Hu", "昉" => "Fang", "昊" => "Hao", "昋" => "Gui",
    "昌" => "Chang", "昍" => "Xuan", "明" => "Ming", "昏" => "Hun", "昐" => "Fen", "昑" => "Qin",
    "昒" => "Hu", "易" => "Yi", "昔" => "Xi", "昕" => "Xin", "昖" => "Yan", "昗" => "Ze",
    "昘" => "Fang", "昙" => "Tan", "昚" => "Shen", "昛" => "Ju", "昜" => "Yang", "昝" => "Zan",
    "昞" => "Bing", "星" => "Xing", "映" => "Ying", "昡" => "Xuan", "昢" => "Pei", "昣" => "Zhen",
    "昤" => "Ling", "春" => "Chun", "昦" => "Hao", "昧" => "Mei", "昨" => "Zuo", "昩" => "Mo",
    "昪" => "Bian", "昫" => "Xu", "昬" => "Hun", "昭" => "Zhao", "昮" => "Zong", "是" => "Shi",
    "昰" => "Shi", "昱" => "Yu", "昲" => "Fei", "昳" => "Die", "昴" => "Mao", "昵" => "Ni",
    "昶" => "Chang", "昷" => "Wen", "昸" => "Dong", "昹" => "Ai", "昺" => "Bing", "昻" => "Ang",
    "昼" => "Zhou", "昽" => "Long", "显" => "Xian", "昿" => "Kuang", "晀" => "Tiao", "晁" => "Chao",
    "時" => "Shi", "晃" => "Huang", "晄" => "Huang", "晅" => "Xuan", "晆" => "Kui", "晇" => "Xu",
    "晈" => "Jiao", "晉" => "Jin", "晊" => "Zhi", "晋" => "Jin", "晌" => "Shang", "晍" => "Tong",
    "晎" => "Hong", "晏" => "Yan", "晐" => "Gai", "晑" => "Xiang", "晒" => "Shai", "晓" => "Xiao",
    "晔" => "Ye", "晕" => "Yun", "晖" => "Hui", "晗" => "Han", "晘" => "Han", "晙" => "Jun",
    "晚" => "Wan", "晛" => "Xian", "晜" => "Kun", "晝" => "Zhou", "晞" => "Xi", "晟" => "Cheng",
    "晠" => "Sheng", "晡" => "Bu", "晢" => "Zhe", "晣" => "Zhe", "晤" => "Wu", "晥" => "Han",
    "晦" => "Hui", "晧" => "Hao", "晨" => "Chen", "晩" => "Wan", "晪" => "Tian", "晫" => "Zhuo",
    "晬" => "Zui", "晭" => "Zhou", "普" => "Pu", "景" => "Jing", "晰" => "Xi", "晱" => "Shan",
    "晲" => "Yi", "晳" => "Xi", "晴" => "Qing", "晵" => "Qi", "晶" => "Jing", "晷" => "Gui",
    "晸" => "Zhen", "晹" => "Yi", "智" => "Zhi", "晻" => "An", "晼" => "Wan", "晽" => "Lin",
    "晾" => "Liang", "晿" => "Chang", "暀" => "Wang", "暁" => "Xiao", "暂" => "Zan", "暃" => "Hi",
    "暄" => "Xuan", "暅" => "Xuan", "暆" => "Yi", "暇" => "Xia", "暈" => "Yun", "暉" => "Hui",
    "暊" => "Fu", "暋" => "Min", "暌" => "Kui", "暍" => "He", "暎" => "Ying", "暏" => "Du",
    "暐" => "Wei", "暑" => "Shu", "暒" => "Qing", "暓" => "Mao", "暔" => "Nan", "暕" => "Jian",
    "暖" => "Nuan", "暗" => "An", "暘" => "Yang", "暙" => "Chun", "暚" => "Yao", "暛" => "Suo",
    "暜" => "Jin", "暝" => "Ming", "暞" => "Jiao", "暟" => "Kai", "暠" => "Gao", "暡" => "Weng",
    "暢" => "Chang", "暣" => "Qi", "暤" => "Hao", "暥" => "Yan", "暦" => "Li", "暧" => "Ai",
    "暨" => "Ji", "暩" => "Gui", "暪" => "Men", "暫" => "Zan", "暬" => "Xie", "暭" => "Hao",
    "暮" => "Mu", "暯" => "Mo", "暰" => "Cong", "暱" => "Ni", "暲" => "Zhang", "暳" => "Hui",
    "暴" => "Bao", "暵" => "Han", "暶" => "Xuan", "暷" => "Chuan", "暸" => "Liao", "暹" => "Xian",
    "暺" => "Dan", "暻" => "Jing", "暼" => "Pie", "暽" => "Lin", "暾" => "Tun", "暿" => "Xi",
    "曀" => "Yi", "曁" => "Ji", "曂" => "Huang", "曃" => "Tai", "曄" => "Ye", "曅" => "Ye",
    "曆" => "Li", "曇" => "Tan", "曈" => "Tong", "曉" => "Xiao", "曊" => "Fei", "曋" => "Qin",
    "曌" => "Zhao", "曍" => "Hao", "曎" => "Yi", "曏" => "Xiang", "曐" => "Xing", "曑" => "Sen",
    "曒" => "Jiao", "曓" => "Bao", "曔" => "Jing", "曕" => "Yian", "曖" => "Ai", "曗" => "Ye",
    "曘" => "Ru", "曙" => "Shu", "曚" => "Meng", "曛" => "Xun", "曜" => "Yao", "曝" => "Pu",
    "曞" => "Li", "曟" => "Chen", "曠" => "Kuang", "曡" => "Die", "曣" => "Yan", "曤" => "Huo",
    "曥" => "Lu", "曦" => "Xi", "曧" => "Rong", "曨" => "Long", "曩" => "Nang", "曪" => "Luo",
    "曫" => "Luan", "曬" => "Shai", "曭" => "Tang", "曮" => "Yan", "曯" => "Chu", "曰" => "Yue",
    "曱" => "Yue", "曲" => "Qu", "曳" => "Yi", "更" => "Geng", "曵" => "Ye", "曶" => "Hu",
    "曷" => "He", "書" => "Shu", "曹" => "Cao", "曺" => "Cao", "曻" => "Noboru", "曼" => "Man",
    "曽" => "Ceng", "曾" => "Ceng", "替" => "Ti", "朁" => "Can", "朂" => "Xu", "會" => "Hui",
    "朄" => "Yin", "朅" => "Qie", "朆" => "Fen", "朇" => "Pi", "月" => "Yue", "有" => "You",
    "朊" => "Ruan", "朋" => "Peng", "朌" => "Ban", "服" => "Fu", "朎" => "Ling", "朏" => "Fei",
    "朐" => "Qu", "朒" => "Nu", "朓" => "Tiao", "朔" => "Shuo", "朕" => "Zhen", "朖" => "Lang",
    "朗" => "Lang", "朘" => "Juan", "朙" => "Ming", "朚" => "Huang", "望" => "Wang", "朜" => "Tun",
    "朝" => "Zhao", "朞" => "Ji", "期" => "Qi", "朠" => "Ying", "朡" => "Zong", "朢" => "Wang",
    "朣" => "Tong", "朤" => "Lang", "朦" => "Meng", "朧" => "Long", "木" => "Mu", "朩" => "Deng",
    "未" => "Wei", "末" => "Mo", "本" => "Ben", "札" => "Zha", "朮" => "Zhu", "术" => "Zhu",
    "朱" => "Zhu", "朲" => "Ren", "朳" => "Ba", "朴" => "Po", "朵" => "Duo", "朶" => "Duo",
    "朷" => "Dao", "朸" => "Li", "朹" => "Qiu", "机" => "Ji", "朻" => "Jiu", "朼" => "Bi",
    "朽" => "Xiu", "朾" => "Ting", "朿" => "Ci", "杀" => "Sha", "杁" => "Eburi", "杂" => "Za",
    "权" => "Quan", "杄" => "Qian", "杅" => "Yu", "杆" => "Gan", "杇" => "Wu", "杈" => "Cha",
    "杉" => "Shan", "杊" => "Xun", "杋" => "Fan", "杌" => "Wu", "杍" => "Zi", "李" => "Li",
    "杏" => "Xing", "材" => "Cai", "村" => "Cun", "杒" => "Ren", "杓" => "Shao", "杔" => "Tuo",
    "杕" => "Di", "杖" => "Zhang", "杗" => "Mang", "杘" => "Chi", "杙" => "Yi", "杚" => "Gu",
    "杛" => "Gong", "杜" => "Du", "杝" => "Yi", "杞" => "Qi", "束" => "Shu", "杠" => "Gang",
    "条" => "Tiao", "杢" => "Moku", "杣" => "Soma", "杤" => "Tochi", "来" => "Lai", "杦" => "Sugi",
    "杧" => "Mang", "杨" => "Yang", "杩" => "Ma", "杪" => "Miao", "杫" => "Si", "杬" => "Yuan",
    "杭" => "Hang", "杮" => "Fei", "杯" => "Bei", "杰" => "Jie", "東" => "Dong", "杲" => "Gao",
    "杳" => "Yao", "杴" => "Xian", "杵" => "Chu", "杶" => "Qun", "杷" => "Pa", "杸" => "Shu",
    "杹" => "Hua", "杺" => "Xin", "杻" => "Chou", "杼" => "Zhu", "杽" => "Chou", "松" => "Song",
    "板" => "Ban", "枀" => "Song", "极" => "Ji", "枂" => "Yue", "枃" => "Jin", "构" => "Gou",
    "枅" => "Ji", "枆" => "Mao", "枇" => "Pi", "枈" => "Bi", "枉" => "Wang", "枊" => "Ang",
    "枋" => "Fang", "枌" => "Fen", "枍" => "Yi", "枎" => "Fu", "枏" => "Nan", "析" => "Xi",
    "枑" => "Hu", "枒" => "Ya", "枓" => "Dou", "枔" => "Xun", "枕" => "Zhen", "枖" => "Yao",
    "林" => "Lin", "枘" => "Rui", "枙" => "E", "枚" => "Mei", "枛" => "Zhao", "果" => "Guo",
    "枝" => "Zhi", "枞" => "Cong", "枟" => "Yun", "枠" => "Waku", "枡" => "Dou", "枢" => "Shu",
    "枣" => "Zao", "枥" => "Li", "枦" => "Haze", "枧" => "Jian", "枨" => "Cheng", "枩" => "Matsu",
    "枪" => "Qiang", "枫" => "Feng", "枬" => "Nan", "枭" => "Xiao", "枮" => "Xian", "枯" => "Ku",
    "枰" => "Ping", "枱" => "Yi", "枲" => "Xi", "枳" => "Zhi", "枴" => "Guai", "枵" => "Xiao",
    "架" => "Jia", "枷" => "Jia", "枸" => "Gou", "枹" => "Fu", "枺" => "Mo", "枻" => "Yi",
    "枼" => "Ye", "枽" => "Ye", "枾" => "Shi", "枿" => "Nie", "柀" => "Bi", "柁" => "Duo",
    "柂" => "Yi", "柃" => "Ling", "柄" => "Bing", "柅" => "Ni", "柆" => "La", "柇" => "He",
    "柈" => "Pan", "柉" => "Fan", "柊" => "Zhong", "柋" => "Dai", "柌" => "Ci", "柍" => "Yang",
    "柎" => "Fu", "柏" => "Bo", "某" => "Mou", "柑" => "Gan", "柒" => "Qi", "染" => "Ran",
    "柔" => "Rou", "柕" => "Mao", "柖" => "Zhao", "柗" => "Song", "柘" => "Zhe", "柙" => "Xia",
    "柚" => "You", "柛" => "Shen", "柜" => "Ju", "柝" => "Tuo", "柞" => "Zuo", "柟" => "Nan",
    "柠" => "Ning", "柡" => "Yong", "柢" => "Di", "柣" => "Zhi", "柤" => "Zha", "查" => "Cha",
    "柦" => "Dan", "柧" => "Gu", "柨" => "Pu", "柩" => "Jiu", "柪" => "Ao", "柫" => "Fu",
    "柬" => "Jian", "柭" => "Bo", "柮" => "Duo", "柯" => "Ke", "柰" => "Nai", "柱" => "Zhu",
    "柲" => "Bi", "柳" => "Liu", "柴" => "Chai", "柵" => "Zha", "柶" => "Si", "柷" => "Zhu",
    "柸" => "Pei", "柹" => "Shi", "柺" => "Guai", "査" => "Cha", "柼" => "Yao", "柽" => "Jue",
    "柾" => "Jiu", "柿" => "Shi", "栁" => "Liu", "栂" => "Mei", "栃" => "Hoy", "栄" => "Rong",
    "栅" => "Zha", "标" => "Biao", "栈" => "Zhan", "栉" => "Jie", "栊" => "Long", "栋" => "Dong",
    "栌" => "Lu", "栍" => "Sayng", "栎" => "Li", "栏" => "Lan", "栐" => "Yong", "树" => "Shu",
    "栒" => "Xun", "栓" => "Shuan", "栔" => "Qi", "栕" => "Zhen", "栖" => "Qi", "栗" => "Li",
    "栘" => "Yi", "栙" => "Xiang", "栚" => "Zhen", "栛" => "Li", "栜" => "Su", "栝" => "Gua",
    "栞" => "Kan", "栟" => "Bing", "栠" => "Ren", "校" => "Xiao", "栢" => "Bo", "栣" => "Ren",
    "栤" => "Bing", "栥" => "Zi", "栦" => "Chou", "栧" => "Yi", "栨" => "Jie", "栩" => "Xu",
    "株" => "Zhu", "栫" => "Jian", "栬" => "Zui", "栭" => "Er", "栮" => "Er", "栯" => "You",
    "栰" => "Fa", "栱" => "Gong", "栲" => "Kao", "栳" => "Lao", "栴" => "Zhan", "栵" => "Li",
    "栶" => "Yin", "样" => "Yang", "核" => "He", "根" => "Gen", "栺" => "Zhi", "栻" => "Chi",
    "格" => "Ge", "栽" => "Zai", "栾" => "Luan", "栿" => "Fu", "桀" => "Jie", "桁" => "Hang",
    "桂" => "Gui", "桃" => "Tao", "桄" => "Guang", "桅" => "Wei", "框" => "Kuang", "桇" => "Ru",
    "案" => "An", "桉" => "An", "桊" => "Juan", "桋" => "Yi", "桌" => "Zhuo", "桍" => "Ku",
    "桎" => "Zhi", "桏" => "Qiong", "桐" => "Tong", "桑" => "Sang", "桒" => "Sang", "桓" => "Huan",
    "桔" => "Jie", "桕" => "Jiu", "桖" => "Xue", "桗" => "Duo", "桘" => "Zhui", "桙" => "Yu",
    "桚" => "Zan", "桛" => "Kasei", "桜" => "Ying", "桝" => "Masu", "桟" => "Zhan", "桠" => "Ya",
    "桡" => "Nao", "桢" => "Zhen", "档" => "Dang", "桤" => "Qi", "桥" => "Qiao", "桦" => "Hua",
    "桧" => "Kuai", "桨" => "Jiang", "桩" => "Zhuang", "桪" => "Xun", "桫" => "Suo", "桬" => "Sha",
    "桭" => "Zhen", "桮" => "Bei", "桯" => "Ting", "桰" => "Gua", "桱" => "Jing", "桲" => "Bo",
    "桳" => "Ben", "桴" => "Fu", "桵" => "Rui", "桶" => "Tong", "桷" => "Jue", "桸" => "Xi",
    "桹" => "Lang", "桺" => "Liu", "桻" => "Feng", "桼" => "Qi", "桽" => "Wen", "桾" => "Jun",
    "桿" => "Gan", "梀" => "Cu", "梁" => "Liang", "梂" => "Qiu", "梃" => "Ting", "梄" => "You",
    "梅" => "Mei", "梆" => "Bang", "梇" => "Long", "梈" => "Peng", "梉" => "Zhuang", "梊" => "Di",
    "梋" => "Xuan", "梌" => "Tu", "梍" => "Zao", "梎" => "Ao", "梏" => "Gu", "梐" => "Bi",
    "梑" => "Di", "梒" => "Han", "梓" => "Zi", "梔" => "Zhi", "梕" => "Ren", "梖" => "Bei",
    "梗" => "Geng", "梘" => "Jian", "梙" => "Huan", "梚" => "Wan", "梛" => "Nuo", "梜" => "Jia",
    "條" => "Tiao", "梞" => "Ji", "梟" => "Xiao", "梠" => "Lu", "梡" => "Huan", "梢" => "Shao",
    "梣" => "Cen", "梤" => "Fen", "梥" => "Song", "梦" => "Meng", "梧" => "Wu", "梨" => "Li",
    "梩" => "Li", "梪" => "Dou", "梫" => "Cen", "梬" => "Ying", "梭" => "Suo", "梮" => "Ju",
    "梯" => "Ti", "械" => "Jie", "梱" => "Kun", "梲" => "Zhuo", "梳" => "Shu", "梴" => "Chan",
    "梵" => "Fan", "梶" => "Wei", "梷" => "Jing", "梸" => "Li", "梹" => "Bing", "梺" => "Fumoto",
    "梻" => "Shikimi", "梼" => "Tao", "梽" => "Zhi", "梾" => "Lai", "梿" => "Lian", "检" => "Jian",
    "棁" => "Zhuo", "棂" => "Ling", "棃" => "Li", "棄" => "Qi", "棅" => "Bing", "棆" => "Zhun",
    "棇" => "Cong", "棈" => "Qian", "棉" => "Mian", "棊" => "Qi", "棋" => "Qi", "棌" => "Cai",
    "棍" => "Gun", "棎" => "Chan", "棏" => "Te", "棐" => "Fei", "棑" => "Pai", "棒" => "Bang",
    "棓" => "Pou", "棔" => "Hun", "棕" => "Zong", "棖" => "Cheng", "棗" => "Zao", "棘" => "Ji",
    "棙" => "Li", "棚" => "Peng", "棛" => "Yu", "棜" => "Yu", "棝" => "Gu", "棞" => "Hun",
    "棟" => "Dong", "棠" => "Tang", "棡" => "Gang", "棢" => "Wang", "棣" => "Di", "棤" => "Xi",
    "棥" => "Fan", "棦" => "Cheng", "棧" => "Zhan", "棨" => "Qi", "棩" => "Yuan", "棪" => "Yan",
    "棫" => "Yu", "棬" => "Quan", "棭" => "Yi", "森" => "Sen", "棯" => "Ren", "棰" => "Chui",
    "棱" => "Leng", "棲" => "Qi", "棳" => "Zhuo", "棴" => "Fu", "棵" => "Ke", "棶" => "Lai",
    "棷" => "Zou", "棸" => "Zou", "棹" => "Zhuo", "棺" => "Guan", "棻" => "Fen", "棼" => "Fen",
    "棽" => "Chen", "棾" => "Qiong", "棿" => "Nie", "椁" => "Guo", "椂" => "Lu", "椃" => "Hao",
    "椄" => "Jie", "椅" => "Yi", "椆" => "Chou", "椇" => "Ju", "椈" => "Ju", "椉" => "Cheng",
    "椊" => "Zuo", "椋" => "Liang", "椌" => "Qiang", "植" => "Zhi", "椎" => "Zhui", "椏" => "Ya",
    "椐" => "Ju", "椑" => "Bei", "椒" => "Jiao", "椓" => "Zhuo", "椔" => "Zi", "椕" => "Bin",
    "椖" => "Peng", "椗" => "Ding", "椘" => "Chu", "椙" => "Chang", "椚" => "Kunugi", "椛" => "Momiji",
    "検" => "Jian", "椝" => "Gui", "椞" => "Xi", "椟" => "Du", "椠" => "Qian", "椡" => "Kunugi",
    "椢" => "Soko", "椣" => "Shide", "椤" => "Luo", "椥" => "Zhi", "椦" => "Ken", "椧" => "Myeng",
    "椨" => "Tafu", "椪" => "Peng", "椫" => "Zhan", "椭" => "Tuo", "椮" => "Sen", "椯" => "Duo",
    "椰" => "Ye", "椱" => "Fou", "椲" => "Wei", "椳" => "Wei", "椴" => "Duan", "椵" => "Jia",
    "椶" => "Zong", "椷" => "Jian", "椸" => "Yi", "椹" => "Shen", "椺" => "Xi", "椻" => "Yan",
    "椼" => "Yan", "椽" => "Chuan", "椾" => "Zhan", "椿" => "Chun", "楀" => "Yu", "楁" => "He",
    "楂" => "Zha", "楃" => "Wo", "楄" => "Pian", "楅" => "Bi", "楆" => "Yao", "楇" => "Huo",
    "楈" => "Xu", "楉" => "Ruo", "楊" => "Yang", "楋" => "La", "楌" => "Yan", "楍" => "Ben",
    "楎" => "Hun", "楏" => "Kui", "楐" => "Jie", "楑" => "Kui", "楒" => "Si", "楓" => "Feng",
    "楔" => "Xie", "楕" => "Tuo", "楖" => "Zhi", "楗" => "Jian", "楘" => "Mu", "楙" => "Mao",
    "楚" => "Chu", "楛" => "Hu", "楜" => "Hu", "楝" => "Lian", "楞" => "Leng", "楟" => "Ting",
    "楠" => "Nan", "楡" => "Yu", "楢" => "You", "楣" => "Mei", "楤" => "Song", "楥" => "Xuan",
    "楦" => "Xuan", "楧" => "Ying", "楨" => "Zhen", "楩" => "Pian", "楪" => "Ye", "楫" => "Ji",
    "楬" => "Jie", "業" => "Ye", "楮" => "Chu", "楯" => "Shun", "楰" => "Yu", "楱" => "Cou",
    "楲" => "Wei", "楳" => "Mei", "楴" => "Di", "極" => "Ji", "楶" => "Jie", "楷" => "Kai",
    "楸" => "Qiu", "楹" => "Ying", "楺" => "Rou", "楻" => "Heng", "楼" => "Lou", "楽" => "Le",
    "楾" => "Hazou", "楿" => "Katsura", "榀" => "Pin", "榁" => "Muro", "概" => "Gai", "榃" => "Tan",
    "榄" => "Lan", "榅" => "Yun", "榆" => "Yu", "榇" => "Chen", "榈" => "Lu", "榉" => "Ju",
    "榊" => "Sakaki", "榌" => "Pi", "榍" => "Xie", "榎" => "Jia", "榏" => "Yi", "榐" => "Zhan",
    "榑" => "Fu", "榒" => "Nai", "榓" => "Mi", "榔" => "Lang", "榕" => "Rong", "榖" => "Gu",
    "榗" => "Jian", "榘" => "Ju", "榙" => "Ta", "榚" => "Yao", "榛" => "Zhen", "榜" => "Bang",
    "榝" => "Sha", "榞" => "Yuan", "榟" => "Zi", "榠" => "Ming", "榡" => "Su", "榢" => "Jia",
    "榣" => "Yao", "榤" => "Jie", "榥" => "Huang", "榦" => "Gan", "榧" => "Fei", "榨" => "Zha",
    "榩" => "Qian", "榪" => "Ma", "榫" => "Sun", "榬" => "Yuan", "榭" => "Xie", "榮" => "Rong",
    "榯" => "Shi", "榰" => "Zhi", "榱" => "Cui", "榲" => "Yun", "榳" => "Ting", "榴" => "Liu",
    "榵" => "Rong", "榶" => "Tang", "榷" => "Que", "榸" => "Zhai", "榹" => "Si", "榺" => "Sheng",
    "榻" => "Ta", "榼" => "Ke", "榽" => "Xi", "榾" => "Gu", "榿" => "Qi", "槀" => "Kao",
    "槁" => "Gao", "槂" => "Sun", "槃" => "Pan", "槄" => "Tao", "槅" => "Ge", "槆" => "Xun",
    "槇" => "Dian", "槈" => "Nou", "槉" => "Ji", "槊" => "Shuo", "構" => "Gou", "槌" => "Chui",
    "槍" => "Qiang", "槎" => "Cha", "槏" => "Qian", "槐" => "Huai", "槑" => "Mei", "槒" => "Xu",
    "槓" => "Gang", "槔" => "Gao", "槕" => "Zhuo", "槖" => "Tuo", "槗" => "Hashi", "様" => "Yang",
    "槙" => "Dian", "槚" => "Jia", "槛" => "Jian", "槜" => "Zui", "槝" => "Kashi", "槞" => "Ori",
    "槟" => "Bin", "槠" => "Zhu", "槢" => "Xi", "槣" => "Qi", "槤" => "Lian", "槥" => "Hui",
    "槦" => "Yong", "槧" => "Qian", "槨" => "Guo", "槩" => "Gai", "槪" => "Gai", "槫" => "Tuan",
    "槬" => "Hua", "槭" => "Cu", "槮" => "Sen", "槯" => "Cui", "槰" => "Beng", "槱" => "You",
    "槲" => "Hu", "槳" => "Jiang", "槴" => "Hu", "槵" => "Huan", "槶" => "Kui", "槷" => "Yi",
    "槸" => "Nie", "槹" => "Gao", "槺" => "Kang", "槻" => "Gui", "槼" => "Gui", "槽" => "Cao",
    "槾" => "Man", "槿" => "Jin", "樁" => "Zhuang", "樂" => "Le", "樃" => "Lang", "樄" => "Chen",
    "樅" => "Cong", "樆" => "Li", "樇" => "Xiu", "樈" => "Qing", "樉" => "Shuang", "樊" => "Fan",
    "樋" => "Tong", "樌" => "Guan", "樍" => "Ji", "樎" => "Suo", "樏" => "Lei", "樐" => "Lu",
    "樑" => "Liang", "樒" => "Mi", "樓" => "Lou", "樔" => "Chao", "樕" => "Su", "樖" => "Ke",
    "樗" => "Shu", "樘" => "Tang", "標" => "Biao", "樚" => "Lu", "樛" => "Jiu", "樜" => "Shu",
    "樝" => "Zha", "樞" => "Shu", "樟" => "Zhang", "樠" => "Men", "模" => "Mo", "樢" => "Niao",
    "樣" => "Yang", "樤" => "Tiao", "樥" => "Peng", "樦" => "Zhu", "樧" => "Sha", "樨" => "Xi",
    "権" => "Quan", "横" => "Heng", "樫" => "Jian", "樬" => "Cong", "樮" => "Hokuso", "樯" => "Qiang",
    "樰" => "Tara", "樱" => "Ying", "樲" => "Er", "樳" => "Xin", "樴" => "Zhi", "樵" => "Qiao",
    "樶" => "Zui", "樷" => "Cong", "樸" => "Pu", "樹" => "Shu", "樺" => "Hua", "樻" => "Kui",
    "樼" => "Zhen", "樽" => "Zun", "樾" => "Yue", "樿" => "Zhan", "橀" => "Xi", "橁" => "Xun",
    "橂" => "Dian", "橃" => "Fa", "橄" => "Gan", "橅" => "Mo", "橆" => "Wu", "橇" => "Qiao",
    "橈" => "Nao", "橉" => "Lin", "橊" => "Liu", "橋" => "Qiao", "橌" => "Xian", "橍" => "Run",
    "橎" => "Fan", "橏" => "Zhan", "橐" => "Tuo", "橑" => "Lao", "橒" => "Yun", "橓" => "Shun",
    "橔" => "Tui", "橕" => "Cheng", "橖" => "Tang", "橗" => "Meng", "橘" => "Ju", "橙" => "Cheng",
    "橚" => "Su", "橛" => "Jue", "橜" => "Jue", "橝" => "Tan", "橞" => "Hui", "機" => "Ji",
    "橠" => "Nuo", "橡" => "Xiang", "橢" => "Tuo", "橣" => "Ning", "橤" => "Rui", "橥" => "Zhu",
    "橦" => "Chuang", "橧" => "Zeng", "橨" => "Fen", "橩" => "Qiong", "橪" => "Ran", "橫" => "Heng",
    "橬" => "Cen", "橭" => "Gu", "橮" => "Liu", "橯" => "Lao", "橰" => "Gao", "橱" => "Chu",
    "橲" => "Zusa", "橳" => "Nude", "橴" => "Ca", "橵" => "San", "橶" => "Ji", "橷" => "Dou",
    "橸" => "Shou", "橹" => "Lu", "橼" => "Yuan", "橽" => "Ta", "橾" => "Shu", "橿" => "Jiang",
    "檀" => "Tan", "檁" => "Lin", "檂" => "Nong", "檃" => "Yin", "檄" => "Xi", "檅" => "Sui",
    "檆" => "Shan", "檇" => "Zui", "檈" => "Xuan", "檉" => "Cheng", "檊" => "Gan", "檋" => "Ju",
    "檌" => "Zui", "檍" => "Yi", "檎" => "Qin", "檏" => "Pu", "檐" => "Yan", "檑" => "Lei",
    "檒" => "Feng", "檓" => "Hui", "檔" => "Dang", "檕" => "Ji", "檖" => "Sui", "檗" => "Bo",
    "檘" => "Bi", "檙" => "Ding", "檚" => "Chu", "檛" => "Zhua", "檜" => "Kuai", "檝" => "Ji",
    "檞" => "Jie", "檟" => "Jia", "檠" => "Qing", "檡" => "Zhe", "檢" => "Jian", "檣" => "Qiang",
    "檤" => "Dao", "檥" => "Yi", "檦" => "Biao", "檧" => "Song", "檨" => "She", "檩" => "Lin",
    "檪" => "Kunugi", "檫" => "Cha", "檬" => "Meng", "檭" => "Yin", "檮" => "Tao", "檯" => "Tai",
    "檰" => "Mian", "檱" => "Qi", "檲" => "Toan", "檳" => "Bin", "檴" => "Huo", "檵" => "Ji",
    "檶" => "Qian", "檷" => "Mi", "檸" => "Ning", "檹" => "Yi", "檺" => "Gao", "檻" => "Jian",
    "檼" => "Yin", "檽" => "Er", "檾" => "Qing", "檿" => "Yan", "櫀" => "Qi", "櫁" => "Mi",
    "櫂" => "Zhao", "櫃" => "Gui", "櫄" => "Chun", "櫅" => "Ji", "櫆" => "Kui", "櫇" => "Po",
    "櫈" => "Deng", "櫉" => "Chu", "櫋" => "Mian", "櫌" => "You", "櫍" => "Zhi", "櫎" => "Guang",
    "櫏" => "Qian", "櫐" => "Lei", "櫑" => "Lei", "櫒" => "Sa", "櫓" => "Lu", "櫔" => "Li",
    "櫕" => "Cuan", "櫖" => "Lu", "櫗" => "Mie", "櫘" => "Hui", "櫙" => "Ou", "櫚" => "Lu",
    "櫛" => "Jie", "櫜" => "Gao", "櫝" => "Du", "櫞" => "Yuan", "櫟" => "Li", "櫠" => "Fei",
    "櫡" => "Zhuo", "櫢" => "Sou", "櫣" => "Lian", "櫤" => "Tamo", "櫥" => "Chu", "櫧" => "Zhu",
    "櫨" => "Lu", "櫩" => "Yan", "櫪" => "Li", "櫫" => "Zhu", "櫬" => "Chen", "櫭" => "Jie",
    "櫮" => "E", "櫯" => "Su", "櫰" => "Huai", "櫱" => "Nie", "櫲" => "Yu", "櫳" => "Long",
    "櫴" => "Lai", "櫶" => "Xian", "櫷" => "Kwi", "櫸" => "Ju", "櫹" => "Xiao", "櫺" => "Ling",
    "櫻" => "Ying", "櫼" => "Jian", "櫽" => "Yin", "櫾" => "You", "櫿" => "Ying", "欁" => "Nong",
    "欂" => "Bo", "欃" => "Chan", "欄" => "Lan", "欅" => "Ju", "欆" => "Shuang", "欇" => "She",
    "欈" => "Wei", "欉" => "Cong", "權" => "Quan", "欋" => "Qu", "欌" => "Cang", "欎" => "Yu",
    "欏" => "Luo", "欐" => "Li", "欑" => "Zan", "欒" => "Luan", "欓" => "Dang", "欔" => "Jue",
    "欕" => "Em", "欖" => "Lan", "欗" => "Lan", "欘" => "Zhu", "欙" => "Lei", "欚" => "Li",
    "欛" => "Ba", "欜" => "Nang", "欝" => "Yu", "欞" => "Ling", "欟" => "Tsuki", "欠" => "Qian",
    "次" => "Ci", "欢" => "Huan", "欣" => "Xin", "欤" => "Yu", "欥" => "Yu", "欦" => "Qian",
    "欧" => "Ou", "欨" => "Xu", "欩" => "Chao", "欪" => "Chu", "欫" => "Chi", "欬" => "Kai",
    "欭" => "Yi", "欮" => "Jue", "欯" => "Xi", "欰" => "Xu", "欱" => "Xia", "欲" => "Yu",
    "欳" => "Kuai", "欴" => "Lang", "欵" => "Kuan", "欶" => "Shuo", "欷" => "Xi", "欸" => "Ai",
    "欹" => "Yi", "欺" => "Qi", "欻" => "Hu", "欼" => "Chi", "欽" => "Qin", "款" => "Kuan",
    "欿" => "Kan", "歀" => "Kuan", "歁" => "Kan", "歂" => "Chuan", "歃" => "Sha", "歄" => "Gua",
    "歅" => "Yin", "歆" => "Xin", "歇" => "Xie", "歈" => "Yu", "歉" => "Qian", "歊" => "Xiao",
    "歋" => "Yi", "歌" => "Ge", "歍" => "Wu", "歎" => "Tan", "歏" => "Jin", "歐" => "Ou",
    "歑" => "Hu", "歒" => "Ti", "歓" => "Huan", "歔" => "Xu", "歕" => "Pen", "歖" => "Xi",
    "歗" => "Xiao", "歘" => "Xu", "歙" => "Xi", "歚" => "Sen", "歛" => "Lian", "歜" => "Chu",
    "歝" => "Yi", "歞" => "Kan", "歟" => "Yu", "歠" => "Chuo", "歡" => "Huan", "止" => "Zhi",
    "正" => "Zheng", "此" => "Ci", "步" => "Bu", "武" => "Wu", "歧" => "Qi", "歨" => "Bu",
    "歩" => "Bu", "歪" => "Wai", "歫" => "Ju", "歬" => "Qian", "歭" => "Chi", "歮" => "Se",
    "歯" => "Chi", "歰" => "Se", "歱" => "Zhong", "歲" => "Sui", "歳" => "Sui", "歴" => "Li",
    "歵" => "Cuo", "歶" => "Yu", "歷" => "Li", "歸" => "Gui", "歹" => "Dai", "歺" => "Dai",
    "死" => "Si", "歼" => "Jian", "歽" => "Zhe", "歾" => "Mo", "歿" => "Mo", "殀" => "Yao",
    "殁" => "Mo", "殂" => "Cu", "殃" => "Yang", "殄" => "Tian", "殅" => "Sheng", "殆" => "Dai",
    "殇" => "Shang", "殈" => "Xu", "殉" => "Xun", "殊" => "Shu", "残" => "Can", "殌" => "Jue",
    "殍" => "Piao", "殎" => "Qia", "殏" => "Qiu", "殐" => "Su", "殑" => "Qing", "殒" => "Yun",
    "殓" => "Lian", "殔" => "Yi", "殕" => "Fou", "殖" => "Zhi", "殗" => "Ye", "殘" => "Can",
    "殙" => "Hun", "殚" => "Dan", "殛" => "Ji", "殜" => "Ye", "殝" => "Zhen", "殞" => "Yun",
    "殟" => "Wen", "殠" => "Chou", "殡" => "Bin", "殢" => "Ti", "殣" => "Jin", "殤" => "Shang",
    "殥" => "Yin", "殦" => "Diao", "殧" => "Cu", "殨" => "Hui", "殩" => "Cuan", "殪" => "Yi",
    "殫" => "Dan", "殬" => "Du", "殭" => "Jiang", "殮" => "Lian", "殯" => "Bin", "殰" => "Du",
    "殱" => "Tsukusu", "殲" => "Jian", "殳" => "Shu", "殴" => "Ou", "段" => "Duan", "殶" => "Zhu",
    "殷" => "Yin", "殸" => "Qing", "殹" => "Yi", "殺" => "Sha", "殻" => "Que", "殼" => "Ke",
    "殽" => "Yao", "殾" => "Jun", "殿" => "Dian", "毀" => "Hui", "毁" => "Hui", "毂" => "Gu",
    "毃" => "Que", "毄" => "Ji", "毅" => "Yi", "毆" => "Ou", "毇" => "Hui", "毈" => "Duan",
    "毉" => "Yi", "毊" => "Xiao", "毋" => "Wu", "毌" => "Guan", "母" => "Mu", "毎" => "Mei",
    "每" => "Mei", "毐" => "Ai", "毑" => "Zuo", "毒" => "Du", "毓" => "Yu", "比" => "Bi",
    "毕" => "Bi", "毖" => "Bi", "毗" => "Pi", "毘" => "Pi", "毙" => "Bi", "毚" => "Chan",
    "毛" => "Mao", "毞" => "Pu", "毟" => "Mushiru", "毠" => "Jia", "毡" => "Zhan", "毢" => "Sai",
    "毣" => "Mu", "毤" => "Tuo", "毥" => "Xun", "毦" => "Er", "毧" => "Rong", "毨" => "Xian",
    "毩" => "Ju", "毪" => "Mu", "毫" => "Hao", "毬" => "Qiu", "毭" => "Dou", "毮" => "Mushiru",
    "毯" => "Tan", "毰" => "Pei", "毱" => "Ju", "毲" => "Duo", "毳" => "Cui", "毴" => "Bi",
    "毵" => "San", "毷" => "Mao", "毸" => "Sui", "毹" => "Yu", "毺" => "Yu", "毻" => "Tuo",
    "毼" => "He", "毽" => "Jian", "毾" => "Ta", "毿" => "San", "氁" => "Mu", "氂" => "Li",
    "氃" => "Tong", "氄" => "Rong", "氅" => "Chang", "氆" => "Pu", "氇" => "Luo", "氈" => "Zhan",
    "氉" => "Sao", "氊" => "Zhan", "氋" => "Meng", "氌" => "Luo", "氍" => "Qu", "氎" => "Die",
    "氏" => "Shi", "氐" => "Di", "民" => "Min", "氒" => "Jue", "氓" => "Mang", "气" => "Qi",
    "氕" => "Pie", "氖" => "Nai", "気" => "Qi", "氘" => "Dao", "氙" => "Xian", "氚" => "Chuan",
    "氛" => "Fen", "氜" => "Ri", "氝" => "Nei", "氟" => "Fu", "氠" => "Shen", "氡" => "Dong",
    "氢" => "Qing", "氣" => "Qi", "氤" => "Yin", "氥" => "Xi", "氦" => "Hai", "氧" => "Yang",
    "氨" => "An", "氩" => "Ya", "氪" => "Ke", "氫" => "Qing", "氬" => "Ya", "氭" => "Dong",
    "氮" => "Dan", "氯" => "Lu", "氰" => "Qing", "氱" => "Yang", "氲" => "Yun", "氳" => "Yun",
    "水" => "Shui", "氵" => "San", "氶" => "Zheng", "氷" => "Bing", "永" => "Yong", "氹" => "Dang",
    "氺" => "Shitamizu", "氻" => "Le", "氼" => "Ni", "氽" => "Tun", "氾" => "Fan", "氿" => "Gui",
    "汀" => "Ting", "汁" => "Zhi", "求" => "Qiu", "汃" => "Bin", "汄" => "Ze", "汅" => "Mian",
    "汆" => "Cuan", "汇" => "Hui", "汈" => "Diao", "汉" => "Yi", "汊" => "Cha", "汋" => "Zhuo",
    "汌" => "Chuan", "汍" => "Wan", "汎" => "Fan", "汏" => "Dai", "汐" => "Xi", "汑" => "Tuo",
    "汒" => "Mang", "汓" => "Qiu", "汔" => "Qi", "汕" => "Shan", "汖" => "Pai", "汗" => "Han",
    "汘" => "Qian", "汙" => "Wu", "汚" => "Wu", "汛" => "Xun", "汜" => "Si", "汝" => "Ru",
    "汞" => "Gong", "江" => "Jiang", "池" => "Chi", "污" => "Wu", "汢" => "Tsuchi", "汤" => "Tang",
    "汥" => "Zhi", "汦" => "Chi", "汧" => "Qian", "汨" => "Mi", "汩" => "Yu", "汪" => "Wang",
    "汫" => "Qing", "汬" => "Jing", "汭" => "Rui", "汮" => "Jun", "汯" => "Hong", "汰" => "Tai",
    "汱" => "Quan", "汲" => "Ji", "汳" => "Bian", "汴" => "Bian", "汵" => "Gan", "汶" => "Wen",
    "汷" => "Zhong", "汸" => "Fang", "汹" => "Xiong", "決" => "Jue", "汻" => "Hang", "汼" => "Niou",
    "汽" => "Qi", "汾" => "Fen", "汿" => "Xu", "沀" => "Xu", "沁" => "Qin", "沂" => "Yi",
    "沃" => "Wo", "沄" => "Yun", "沅" => "Yuan", "沆" => "Hang", "沇" => "Yan", "沈" => "Chen",
    "沉" => "Chen", "沊" => "Dan", "沋" => "You", "沌" => "Dun", "沍" => "Hu", "沎" => "Huo",
    "沏" => "Qie", "沐" => "Mu", "沑" => "Rou", "沒" => "Mei", "沓" => "Ta", "沔" => "Mian",
    "沕" => "Wu", "沖" => "Chong", "沗" => "Tian", "沘" => "Bi", "沙" => "Sha", "沚" => "Zhi",
    "沛" => "Pei", "沜" => "Pan", "沝" => "Zhui", "沞" => "Za", "沟" => "Gou", "沠" => "Liu",
    "没" => "Mei", "沢" => "Ze", "沣" => "Feng", "沤" => "Ou", "沥" => "Li", "沦" => "Lun",
    "沧" => "Cang", "沨" => "Feng", "沩" => "Wei", "沪" => "Hu", "沫" => "Mo", "沬" => "Mei",
    "沭" => "Shu", "沮" => "Ju", "沯" => "Zan", "沰" => "Tuo", "沱" => "Tuo", "沲" => "Tuo",
    "河" => "He", "沴" => "Li", "沵" => "Mi", "沶" => "Yi", "沷" => "Fa", "沸" => "Fei",
    "油" => "You", "沺" => "Tian", "治" => "Zhi", "沼" => "Zhao", "沽" => "Gu", "沾" => "Zhan",
    "沿" => "Yan", "泀" => "Si", "況" => "Kuang", "泂" => "Jiong", "泃" => "Ju", "泄" => "Xie",
    "泅" => "Qiu", "泆" => "Yi", "泇" => "Jia", "泈" => "Zhong", "泉" => "Quan", "泊" => "Bo",
    "泋" => "Hui", "泌" => "Mi", "泍" => "Ben", "泎" => "Zhuo", "泏" => "Chu", "泐" => "Le",
    "泑" => "You", "泒" => "Gu", "泓" => "Hong", "泔" => "Gan", "法" => "Fa", "泖" => "Mao",
    "泗" => "Si", "泘" => "Hu", "泙" => "Ping", "泚" => "Ci", "泛" => "Fan", "泜" => "Chi",
    "泝" => "Su", "泞" => "Ning", "泟" => "Cheng", "泠" => "Ling", "泡" => "Pao", "波" => "Bo",
    "泣" => "Qi", "泤" => "Si", "泥" => "Ni", "泦" => "Ju", "泧" => "Yue", "注" => "Zhu",
    "泩" => "Sheng", "泪" => "Lei", "泫" => "Xuan", "泬" => "Xue", "泭" => "Fu", "泮" => "Pan",
    "泯" => "Min", "泰" => "Tai", "泱" => "Yang", "泲" => "Ji", "泳" => "Yong", "泴" => "Guan",
    "泵" => "Beng", "泶" => "Xue", "泷" => "Long", "泸" => "Lu", "泺" => "Bo", "泻" => "Xie",
    "泼" => "Po", "泽" => "Ze", "泾" => "Jing", "泿" => "Yin", "洁" => "Ji", "洂" => "Yi",
    "洃" => "Hui", "洄" => "Hui", "洅" => "Zui", "洆" => "Cheng", "洇" => "Yin", "洈" => "Wei",
    "洉" => "Hou", "洊" => "Jian", "洋" => "Yang", "洌" => "Lie", "洍" => "Si", "洎" => "Ji",
    "洏" => "Er", "洐" => "Xing", "洑" => "Fu", "洒" => "Sa", "洓" => "Suo", "洔" => "Zhi",
    "洕" => "Yin", "洖" => "Wu", "洗" => "Xi", "洘" => "Kao", "洙" => "Zhu", "洚" => "Jiang",
    "洛" => "Luo", "洝" => "An", "洞" => "Dong", "洟" => "Yi", "洠" => "Mou", "洡" => "Lei",
    "洢" => "Yi", "洣" => "Mi", "洤" => "Quan", "津" => "Jin", "洦" => "Mo", "洧" => "Wei",
    "洨" => "Xiao", "洩" => "Xie", "洪" => "Hong", "洫" => "Xu", "洬" => "Shuo", "洭" => "Kuang",
    "洮" => "Tao", "洯" => "Qie", "洰" => "Ju", "洱" => "Er", "洲" => "Zhou", "洳" => "Ru",
    "洴" => "Ping", "洵" => "Xun", "洶" => "Xiong", "洷" => "Zhi", "洸" => "Guang", "洹" => "Huan",
    "洺" => "Ming", "活" => "Huo", "洼" => "Wa", "洽" => "Qia", "派" => "Pai", "洿" => "Wu",
    "浀" => "Qu", "流" => "Liu", "浂" => "Yi", "浃" => "Jia", "浄" => "Jing", "浅" => "Qian",
    "浆" => "Jiang", "浇" => "Jiao", "浈" => "Cheng", "浉" => "Shi", "浊" => "Zhuo", "测" => "Ce",
    "浌" => "Pal", "浍" => "Kuai", "济" => "Ji", "浏" => "Liu", "浐" => "Chan", "浑" => "Hun",
    "浒" => "Hu", "浓" => "Nong", "浔" => "Xun", "浕" => "Jin", "浖" => "Lie", "浗" => "Qiu",
    "浘" => "Wei", "浙" => "Zhe", "浚" => "Jun", "浛" => "Han", "浜" => "Bang", "浝" => "Mang",
    "浞" => "Zhuo", "浟" => "You", "浠" => "Xi", "浡" => "Bo", "浢" => "Dou", "浣" => "Wan",
    "浤" => "Hong", "浥" => "Yi", "浦" => "Pu", "浧" => "Ying", "浨" => "Lan", "浩" => "Hao",
    "浪" => "Lang", "浫" => "Han", "浬" => "Li", "浭" => "Geng", "浮" => "Fu", "浯" => "Wu",
    "浰" => "Lian", "浱" => "Chun", "浲" => "Feng", "浳" => "Yi", "浴" => "Yu", "浵" => "Tong",
    "浶" => "Lao", "海" => "Hai", "浸" => "Jin", "浹" => "Jia", "浺" => "Chong", "浻" => "Weng",
    "浼" => "Mei", "浽" => "Sui", "浾" => "Cheng", "浿" => "Pei", "涀" => "Xian", "涁" => "Shen",
    "涂" => "Tu", "涃" => "Kun", "涄" => "Pin", "涅" => "Nie", "涆" => "Han", "涇" => "Jing",
    "消" => "Xiao", "涉" => "She", "涊" => "Nian", "涋" => "Tu", "涌" => "Yong", "涍" => "Xiao",
    "涎" => "Xian", "涏" => "Ting", "涐" => "E", "涑" => "Su", "涒" => "Tun", "涓" => "Juan",
    "涔" => "Cen", "涕" => "Ti", "涖" => "Li", "涗" => "Shui", "涘" => "Si", "涙" => "Lei",
    "涚" => "Shui", "涛" => "Tao", "涜" => "Du", "涝" => "Lao", "涞" => "Lai", "涟" => "Lian",
    "涠" => "Wei", "涡" => "Wo", "涢" => "Yun", "涣" => "Huan", "涤" => "Di", "润" => "Run",
    "涧" => "Jian", "涨" => "Zhang", "涩" => "Se", "涪" => "Fu", "涫" => "Guan", "涬" => "Xing",
    "涭" => "Shou", "涮" => "Shuan", "涯" => "Ya", "涰" => "Chuo", "涱" => "Zhang", "液" => "Ye",
    "涳" => "Kong", "涴" => "Wo", "涵" => "Han", "涶" => "Tuo", "涷" => "Dong", "涸" => "He",
    "涹" => "Wo", "涺" => "Ju", "涻" => "Gan", "涼" => "Liang", "涽" => "Hun", "涾" => "Ta",
    "涿" => "Zhuo", "淀" => "Dian", "淁" => "Qie", "淂" => "De", "淃" => "Juan", "淄" => "Zi",
    "淅" => "Xi", "淆" => "Yao", "淇" => "Qi", "淈" => "Gu", "淉" => "Guo", "淊" => "Han",
    "淋" => "Lin", "淌" => "Tang", "淍" => "Zhou", "淎" => "Peng", "淏" => "Hao", "淐" => "Chang",
    "淑" => "Shu", "淒" => "Qi", "淓" => "Fang", "淔" => "Chi", "淕" => "Lu", "淖" => "Nao",
    "淗" => "Ju", "淘" => "Tao", "淙" => "Cong", "淚" => "Lei", "淛" => "Zhi", "淜" => "Peng",
    "淝" => "Fei", "淞" => "Song", "淟" => "Tian", "淠" => "Pi", "淡" => "Dan", "淢" => "Yu",
    "淣" => "Ni", "淤" => "Yu", "淥" => "Lu", "淦" => "Gan", "淧" => "Mi", "淨" => "Jing",
    "淩" => "Ling", "淪" => "Lun", "淫" => "Yin", "淬" => "Cui", "淭" => "Qu", "淮" => "Huai",
    "淯" => "Yu", "淰" => "Nian", "深" => "Shen", "淲" => "Piao", "淳" => "Chun", "淴" => "Wa",
    "淵" => "Yuan", "淶" => "Lai", "混" => "Hun", "淸" => "Qing", "淹" => "Yan", "淺" => "Qian",
    "添" => "Tian", "淼" => "Miao", "淽" => "Zhi", "淾" => "Yin", "淿" => "Mi", "渁" => "Yuan",
    "渂" => "Wen", "渃" => "Re", "渄" => "Fei", "清" => "Qing", "渆" => "Yuan", "渇" => "Ke",
    "済" => "Ji", "渉" => "She", "渊" => "Yuan", "渋" => "Shibui", "渌" => "Lu", "渍" => "Zi",
    "渎" => "Du", "渐" => "Jian", "渑" => "Min", "渒" => "Pi", "渓" => "Tani", "渔" => "Yu",
    "渕" => "Yuan", "渖" => "Shen", "渗" => "Shen", "渘" => "Rou", "渙" => "Huan", "渚" => "Zhu",
    "減" => "Jian", "渜" => "Nuan", "渝" => "Yu", "渞" => "Qiu", "渟" => "Ting", "渠" => "Qu",
    "渡" => "Du", "渢" => "Feng", "渣" => "Zha", "渤" => "Bo", "渥" => "Wo", "渦" => "Wo",
    "渧" => "Di", "渨" => "Wei", "温" => "Wen", "渪" => "Ru", "渫" => "Xie", "測" => "Ce",
    "渭" => "Wei", "渮" => "Ge", "港" => "Gang", "渰" => "Yan", "渱" => "Hong", "渲" => "Xuan",
    "渳" => "Mi", "渴" => "Ke", "渵" => "Mao", "渶" => "Ying", "渷" => "Yan", "游" => "You",
    "渹" => "Hong", "渺" => "Miao", "渻" => "Xing", "渼" => "Mei", "渽" => "Zai", "渾" => "Hun",
    "渿" => "Nai", "湀" => "Kui", "湁" => "Shi", "湂" => "E", "湃" => "Pai", "湄" => "Mei",
    "湅" => "Lian", "湆" => "Qi", "湇" => "Qi", "湈" => "Mei", "湉" => "Tian", "湊" => "Cou",
    "湋" => "Wei", "湌" => "Can", "湍" => "Tuan", "湎" => "Mian", "湏" => "Hui", "湐" => "Mo",
    "湑" => "Xu", "湒" => "Ji", "湓" => "Pen", "湔" => "Jian", "湕" => "Jian", "湖" => "Hu",
    "湗" => "Feng", "湘" => "Xiang", "湙" => "Yi", "湚" => "Yin", "湛" => "Zhan", "湜" => "Shi",
    "湝" => "Jie", "湞" => "Cheng", "湟" => "Huang", "湠" => "Tan", "湡" => "Yu", "湢" => "Bi",
    "湣" => "Min", "湤" => "Shi", "湥" => "Tu", "湦" => "Sheng", "湧" => "Yong", "湨" => "Qu",
    "湩" => "Zhong", "湪" => "Suei", "湫" => "Jiu", "湬" => "Jiao", "湭" => "Qiou", "湮" => "Yin",
    "湯" => "Tang", "湰" => "Long", "湱" => "Huo", "湲" => "Yuan", "湳" => "Nan", "湴" => "Ban",
    "湵" => "You", "湶" => "Quan", "湷" => "Chui", "湸" => "Liang", "湹" => "Chan", "湺" => "Yan",
    "湻" => "Chun", "湼" => "Nie", "湽" => "Zi", "湾" => "Wan", "湿" => "Shi", "満" => "Man",
    "溁" => "Ying", "溂" => "Ratsu", "溃" => "Kui", "溅" => "Jian", "溆" => "Xu", "溇" => "Lu",
    "溈" => "Gui", "溉" => "Gai", "溌" => "Po", "溍" => "Jin", "溎" => "Gui", "溏" => "Tang",
    "源" => "Yuan", "溑" => "Suo", "溒" => "Yuan", "溓" => "Lian", "溔" => "Yao", "溕" => "Meng",
    "準" => "Zhun", "溗" => "Sheng", "溘" => "Ke", "溙" => "Tai", "溚" => "Da", "溛" => "Wa",
    "溜" => "Liu", "溝" => "Gou", "溞" => "Sao", "溟" => "Ming", "溠" => "Zha", "溡" => "Shi",
    "溢" => "Yi", "溣" => "Lun", "溤" => "Ma", "溥" => "Pu", "溦" => "Wei", "溧" => "Li",
    "溨" => "Cai", "溩" => "Wu", "溪" => "Xi", "溫" => "Wen", "溬" => "Qiang", "溭" => "Ze",
    "溮" => "Shi", "溯" => "Su", "溰" => "Yi", "溱" => "Zhen", "溲" => "Sou", "溳" => "Yun",
    "溴" => "Xiu", "溵" => "Yin", "溶" => "Rong", "溷" => "Hun", "溸" => "Su", "溹" => "Su",
    "溺" => "Ni", "溻" => "Ta", "溼" => "Shi", "溽" => "Ru", "溾" => "Wei", "溿" => "Pan",
    "滀" => "Chu", "滁" => "Chu", "滂" => "Pang", "滃" => "Weng", "滄" => "Cang", "滅" => "Mie",
    "滆" => "He", "滇" => "Dian", "滈" => "Hao", "滉" => "Huang", "滊" => "Xi", "滋" => "Zi",
    "滌" => "Di", "滍" => "Zhi", "滎" => "Ying", "滏" => "Fu", "滐" => "Jie", "滑" => "Hua",
    "滒" => "Ge", "滓" => "Zi", "滔" => "Tao", "滕" => "Teng", "滖" => "Sui", "滗" => "Bi",
    "滘" => "Jiao", "滙" => "Hui", "滚" => "Gun", "滛" => "Yin", "滜" => "Gao", "滝" => "Long",
    "滞" => "Zhi", "滟" => "Yan", "滠" => "She", "满" => "Man", "滢" => "Ying", "滣" => "Chun",
    "滤" => "Lu", "滥" => "Lan", "滦" => "Luan", "滨" => "Bin", "滩" => "Tan", "滪" => "Yu",
    "滫" => "Sou", "滬" => "Hu", "滭" => "Bi", "滮" => "Biao", "滯" => "Zhi", "滰" => "Jiang",
    "滱" => "Kou", "滲" => "Shen", "滳" => "Shang", "滴" => "Di", "滵" => "Mi", "滶" => "Ao",
    "滷" => "Lu", "滸" => "Hu", "滹" => "Hu", "滺" => "You", "滻" => "Chan", "滼" => "Fan",
    "滽" => "Yong", "滾" => "Gun", "滿" => "Man", "漁" => "Yu", "漂" => "Piao", "漃" => "Ji",
    "漄" => "Ya", "漅" => "Jiao", "漆" => "Qi", "漇" => "Xi", "漈" => "Ji", "漉" => "Lu",
    "漊" => "Lu", "漋" => "Long", "漌" => "Jin", "漍" => "Guo", "漎" => "Cong", "漏" => "Lou",
    "漐" => "Zhi", "漑" => "Gai", "漒" => "Qiang", "漓" => "Li", "演" => "Yan", "漕" => "Cao",
    "漖" => "Jiao", "漗" => "Cong", "漘" => "Qun", "漙" => "Tuan", "漚" => "Ou", "漛" => "Teng",
    "漜" => "Ye", "漝" => "Xi", "漞" => "Mi", "漟" => "Tang", "漠" => "Mo", "漡" => "Shang",
    "漢" => "Han", "漣" => "Lian", "漤" => "Lan", "漥" => "Wa", "漦" => "Li", "漧" => "Qian",
    "漨" => "Feng", "漩" => "Xuan", "漪" => "Yi", "漫" => "Man", "漬" => "Zi", "漭" => "Mang",
    "漮" => "Kang", "漯" => "Lei", "漰" => "Peng", "漱" => "Shu", "漲" => "Zhang", "漳" => "Zhang",
    "漴" => "Chong", "漵" => "Xu", "漶" => "Huan", "漷" => "Kuo", "漸" => "Jian", "漹" => "Yan",
    "漺" => "Chuang", "漻" => "Liao", "漼" => "Cui", "漽" => "Ti", "漾" => "Yang", "漿" => "Jiang",
    "潀" => "Cong", "潁" => "Ying", "潂" => "Hong", "潃" => "Xun", "潄" => "Shu", "潅" => "Guan",
    "潆" => "Ying", "潇" => "Xiao", "潊" => "Xu", "潋" => "Lian", "潌" => "Zhi", "潍" => "Wei",
    "潎" => "Pi", "潏" => "Jue", "潐" => "Jiao", "潑" => "Po", "潒" => "Dang", "潓" => "Hui",
    "潔" => "Jie", "潕" => "Wu", "潖" => "Pa", "潗" => "Ji", "潘" => "Pan", "潙" => "Gui",
    "潚" => "Xiao", "潛" => "Qian", "潜" => "Qian", "潝" => "Xi", "潞" => "Lu", "潟" => "Xi",
    "潠" => "Xuan", "潡" => "Dun", "潢" => "Huang", "潣" => "Min", "潤" => "Run", "潥" => "Su",
    "潦" => "Liao", "潧" => "Zhen", "潨" => "Zhong", "潩" => "Yi", "潪" => "Di", "潫" => "Wan",
    "潬" => "Dan", "潭" => "Tan", "潮" => "Chao", "潯" => "Xun", "潰" => "Kui", "潱" => "Yie",
    "潲" => "Shao", "潳" => "Tu", "潴" => "Zhu", "潵" => "San", "潶" => "Hei", "潷" => "Bi",
    "潸" => "Shan", "潹" => "Chan", "潺" => "Chan", "潻" => "Shu", "潼" => "Tong", "潽" => "Pu",
    "潾" => "Lin", "潿" => "Wei", "澀" => "Se", "澁" => "Se", "澂" => "Cheng", "澃" => "Jiong",
    "澄" => "Cheng", "澅" => "Hua", "澆" => "Jiao", "澇" => "Lao", "澈" => "Che", "澉" => "Gan",
    "澊" => "Cun", "澋" => "Heng", "澌" => "Si", "澍" => "Shu", "澎" => "Peng", "澏" => "Han",
    "澐" => "Yun", "澑" => "Liu", "澒" => "Hong", "澓" => "Fu", "澔" => "Hao", "澕" => "He",
    "澖" => "Xian", "澗" => "Jian", "澘" => "Shan", "澙" => "Xi", "澚" => "Oki", "澜" => "Lan",
    "澞" => "Yu", "澟" => "Lin", "澠" => "Min", "澡" => "Zao", "澢" => "Dang", "澣" => "Wan",
    "澤" => "Ze", "澥" => "Xie", "澦" => "Yu", "澧" => "Li", "澨" => "Shi", "澩" => "Xue",
    "澪" => "Ling", "澫" => "Man", "澬" => "Zi", "澭" => "Yong", "澮" => "Kuai", "澯" => "Can",
    "澰" => "Lian", "澱" => "Dian", "澲" => "Ye", "澳" => "Ao", "澴" => "Huan", "澵" => "Zhen",
    "澶" => "Chan", "澷" => "Man", "澸" => "Dan", "澹" => "Dan", "澺" => "Yi", "澻" => "Sui",
    "澼" => "Pi", "澽" => "Ju", "澾" => "Ta", "澿" => "Qin", "激" => "Ji", "濁" => "Zhuo",
    "濂" => "Lian", "濃" => "Nong", "濄" => "Guo", "濅" => "Jin", "濆" => "Fen", "濇" => "Se",
    "濈" => "Ji", "濉" => "Sui", "濊" => "Hui", "濋" => "Chu", "濌" => "Ta", "濍" => "Song",
    "濎" => "Ding", "濐" => "Zhu", "濑" => "Lai", "濒" => "Bin", "濓" => "Lian", "濔" => "Mi",
    "濕" => "Shi", "濖" => "Shu", "濗" => "Mi", "濘" => "Ning", "濙" => "Ying", "濚" => "Ying",
    "濛" => "Meng", "濜" => "Jin", "濝" => "Qi", "濞" => "Pi", "濟" => "Ji", "濠" => "Hao",
    "濡" => "Ru", "濢" => "Zui", "濣" => "Wo", "濤" => "Tao", "濥" => "Yin", "濦" => "Yin",
    "濧" => "Dui", "濨" => "Ci", "濩" => "Huo", "濪" => "Jing", "濫" => "Lan", "濬" => "Jun",
    "濭" => "Ai", "濮" => "Pu", "濯" => "Zhuo", "濰" => "Wei", "濱" => "Bin", "濲" => "Gu",
    "濳" => "Qian", "濴" => "Xing", "濵" => "Hama", "濶" => "Kuo", "濷" => "Fei", "濹" => "Boku",
    "濺" => "Jian", "濻" => "Wei", "濼" => "Luo", "濽" => "Zan", "濾" => "Lu", "濿" => "Li",
    "瀁" => "Yang", "瀂" => "Lu", "瀃" => "Si", "瀄" => "Jie", "瀅" => "Ying", "瀆" => "Du",
    "瀇" => "Wang", "瀈" => "Hui", "瀉" => "Xie", "瀊" => "Pan", "瀋" => "Shen", "瀌" => "Biao",
    "瀍" => "Chan", "瀎" => "Mo", "瀏" => "Liu", "瀐" => "Jian", "瀑" => "Pu", "瀒" => "Se",
    "瀓" => "Cheng", "瀔" => "Gu", "瀕" => "Bin", "瀖" => "Huo", "瀗" => "Xian", "瀘" => "Lu",
    "瀙" => "Qin", "瀚" => "Han", "瀛" => "Ying", "瀜" => "Yong", "瀝" => "Li", "瀞" => "Jing",
    "瀟" => "Xiao", "瀠" => "Ying", "瀡" => "Sui", "瀢" => "Wei", "瀣" => "Xie", "瀤" => "Huai",
    "瀥" => "Hao", "瀦" => "Zhu", "瀧" => "Long", "瀨" => "Lai", "瀩" => "Dui", "瀪" => "Fan",
    "瀫" => "Hu", "瀬" => "Lai", "瀯" => "Ying", "瀰" => "Mi", "瀱" => "Ji", "瀲" => "Lian",
    "瀳" => "Jian", "瀴" => "Ying", "瀵" => "Fen", "瀶" => "Lin", "瀷" => "Yi", "瀸" => "Jian",
    "瀹" => "Yue", "瀺" => "Chan", "瀻" => "Dai", "瀼" => "Rang", "瀽" => "Jian", "瀾" => "Lan",
    "瀿" => "Fan", "灀" => "Shuang", "灁" => "Yuan", "灂" => "Zhuo", "灃" => "Feng", "灄" => "She",
    "灅" => "Lei", "灆" => "Lan", "灇" => "Cong", "灈" => "Qu", "灉" => "Yong", "灊" => "Qian",
    "灋" => "Fa", "灌" => "Guan", "灍" => "Que", "灎" => "Yan", "灏" => "Hao", "灐" => "Hyeng",
    "灑" => "Sa", "灒" => "Zan", "灓" => "Luan", "灔" => "Yan", "灕" => "Li", "灖" => "Mi",
    "灗" => "Shan", "灘" => "Tan", "灙" => "Dang", "灚" => "Jiao", "灛" => "Chan", "灝" => "Hao",
    "灞" => "Ba", "灟" => "Zhu", "灠" => "Lan", "灡" => "Lan", "灢" => "Nang", "灣" => "Wan",
    "灤" => "Luan", "灥" => "Xun", "灦" => "Xian", "灧" => "Yan", "灨" => "Gan", "灩" => "Yan",
    "灪" => "Yu", "火" => "Huo", "灬" => "Si", "灭" => "Mie", "灮" => "Guang", "灯" => "Deng",
    "灰" => "Hui", "灱" => "Xiao", "灲" => "Xiao", "灳" => "Hu", "灴" => "Hong", "灵" => "Ling",
    "灶" => "Zao", "灷" => "Zhuan", "灸" => "Jiu", "灹" => "Zha", "灺" => "Xie", "灻" => "Chi",
    "灼" => "Zhuo", "災" => "Zai", "灾" => "Zai", "灿" => "Can", "炀" => "Yang", "炁" => "Qi",
    "炂" => "Zhong", "炃" => "Fen", "炄" => "Niu", "炅" => "Jiong", "炆" => "Wen", "炇" => "Po",
    "炈" => "Yi", "炉" => "Lu", "炊" => "Chui", "炋" => "Pi", "炌" => "Kai", "炍" => "Pan",
    "炎" => "Yan", "炏" => "Kai", "炐" => "Pang", "炑" => "Mu", "炒" => "Chao", "炓" => "Liao",
    "炔" => "Gui", "炕" => "Kang", "炖" => "Tun", "炗" => "Guang", "炘" => "Xin", "炙" => "Zhi",
    "炚" => "Guang", "炛" => "Guang", "炜" => "Wei", "炝" => "Qiang", "炟" => "Da", "炠" => "Xia",
    "炡" => "Zheng", "炢" => "Zhu", "炣" => "Ke", "炤" => "Zhao", "炥" => "Fu", "炦" => "Ba",
    "炧" => "Duo", "炨" => "Duo", "炩" => "Ling", "炪" => "Zhuo", "炫" => "Xuan", "炬" => "Ju",
    "炭" => "Tan", "炮" => "Pao", "炯" => "Jiong", "炰" => "Pao", "炱" => "Tai", "炲" => "Tai",
    "炳" => "Bing", "炴" => "Yang", "炵" => "Tong", "炶" => "Han", "炷" => "Zhu", "炸" => "Zha",
    "点" => "Dian", "為" => "Wei", "炻" => "Shi", "炼" => "Lian", "炽" => "Chi", "炾" => "Huang",
    "烀" => "Hu", "烁" => "Shuo", "烂" => "Lan", "烃" => "Jing", "烄" => "Jiao", "烅" => "Xu",
    "烆" => "Xing", "烇" => "Quan", "烈" => "Lie", "烉" => "Huan", "烊" => "Yang", "烋" => "Xiao",
    "烌" => "Xiu", "烍" => "Xian", "烎" => "Yin", "烏" => "Wu", "烐" => "Zhou", "烑" => "Yao",
    "烒" => "Shi", "烓" => "Wei", "烔" => "Tong", "烕" => "Xue", "烖" => "Zai", "烗" => "Kai",
    "烘" => "Hong", "烙" => "Luo", "烚" => "Xia", "烛" => "Zhu", "烜" => "Xuan", "烝" => "Zheng",
    "烞" => "Po", "烟" => "Yan", "烠" => "Hui", "烡" => "Guang", "烢" => "Zhe", "烣" => "Hui",
    "烤" => "Kao", "烦" => "Fan", "烧" => "Shao", "烨" => "Ye", "烩" => "Hui", "烫" => "Tang",
    "烬" => "Jin", "热" => "Re", "烯" => "Xi", "烰" => "Fu", "烱" => "Jiong", "烲" => "Che",
    "烳" => "Pu", "烴" => "Jing", "烵" => "Zhuo", "烶" => "Ting", "烷" => "Wan", "烸" => "Hai",
    "烹" => "Peng", "烺" => "Lang", "烻" => "Shan", "烼" => "Hu", "烽" => "Feng", "烾" => "Chi",
    "烿" => "Rong", "焁" => "Xi", "焂" => "Shu", "焃" => "He", "焄" => "Xun", "焅" => "Ku",
    "焆" => "Jue", "焇" => "Xiao", "焈" => "Xi", "焉" => "Yan", "焊" => "Han", "焋" => "Zhuang",
    "焌" => "Jun", "焍" => "Di", "焎" => "Xie", "焏" => "Ji", "焐" => "Wu", "焓" => "Han",
    "焔" => "Yan", "焕" => "Huan", "焖" => "Men", "焗" => "Ju", "焘" => "Chou", "焙" => "Bei",
    "焚" => "Fen", "焛" => "Lin", "焜" => "Kun", "焝" => "Hun", "焞" => "Tun", "焟" => "Xi",
    "焠" => "Cui", "無" => "Wu", "焢" => "Hong", "焣" => "Ju", "焤" => "Fu", "焥" => "Wo",
    "焦" => "Jiao", "焧" => "Cong", "焨" => "Feng", "焩" => "Ping", "焪" => "Qiong", "焫" => "Ruo",
    "焬" => "Xi", "焭" => "Qiong", "焮" => "Xin", "焯" => "Zhuo", "焰" => "Yan", "焱" => "Yan",
    "焲" => "Yi", "焳" => "Jue", "焴" => "Yu", "焵" => "Gang", "然" => "Ran", "焷" => "Pi",
    "焸" => "Gu", "焺" => "Sheng", "焻" => "Chang", "焼" => "Shao", "煁" => "Chen", "煂" => "He",
    "煃" => "Kui", "煄" => "Zhong", "煅" => "Duan", "煆" => "Xia", "煇" => "Hui", "煈" => "Feng",
    "煉" => "Lian", "煊" => "Xuan", "煋" => "Xing", "煌" => "Huang", "煍" => "Jiao", "煎" => "Jian",
    "煏" => "Bi", "煐" => "Ying", "煑" => "Zhu", "煒" => "Wei", "煓" => "Tuan", "煔" => "Tian",
    "煕" => "Xi", "煖" => "Nuan", "煗" => "Nuan", "煘" => "Chan", "煙" => "Yan", "煚" => "Jiong",
    "煛" => "Jiong", "煜" => "Yu", "煝" => "Mei", "煞" => "Sha", "煟" => "Wei", "煠" => "Ye",
    "煡" => "Xin", "煢" => "Qiong", "煣" => "Rou", "煤" => "Mei", "煥" => "Huan", "煦" => "Xu",
    "照" => "Zhao", "煨" => "Wei", "煩" => "Fan", "煪" => "Qiu", "煫" => "Sui", "煬" => "Yang",
    "煭" => "Lie", "煮" => "Zhu", "煯" => "Jie", "煰" => "Gao", "煱" => "Gua", "煲" => "Bao",
    "煳" => "Hu", "煴" => "Yun", "煵" => "Xia", "煸" => "Bian", "煹" => "Gou", "煺" => "Tui",
    "煻" => "Tang", "煼" => "Chao", "煽" => "Shan", "煾" => "N", "煿" => "Bo", "熀" => "Huang",
    "熁" => "Xie", "熂" => "Xi", "熃" => "Wu", "熄" => "Xi", "熅" => "Yun", "熆" => "He",
    "熇" => "He", "熈" => "Xi", "熉" => "Yun", "熊" => "Xiong", "熋" => "Nai", "熌" => "Shan",
    "熍" => "Qiong", "熎" => "Yao", "熏" => "Xun", "熐" => "Mi", "熑" => "Lian", "熒" => "Ying",
    "熓" => "Wen", "熔" => "Rong", "熕" => "Oozutsu", "熗" => "Qiang", "熘" => "Liu", "熙" => "Xi",
    "熚" => "Bi", "熛" => "Biao", "熜" => "Zong", "熝" => "Lu", "熞" => "Jian", "熟" => "Shou",
    "熠" => "Yi", "熡" => "Lou", "熢" => "Feng", "熣" => "Sui", "熤" => "Yi", "熥" => "Tong",
    "熦" => "Jue", "熧" => "Zong", "熨" => "Yun", "熩" => "Hu", "熪" => "Yi", "熫" => "Zhi",
    "熬" => "Ao", "熭" => "Wei", "熮" => "Liao", "熯" => "Han", "熰" => "Ou", "熱" => "Re",
    "熲" => "Jiong", "熳" => "Man", "熵" => "Shang", "熶" => "Cuan", "熷" => "Zeng", "熸" => "Jian",
    "熹" => "Xi", "熺" => "Xi", "熻" => "Xi", "熼" => "Yi", "熽" => "Xiao", "熾" => "Chi",
    "熿" => "Huang", "燀" => "Chan", "燁" => "Ye", "燂" => "Qian", "燃" => "Ran", "燄" => "Yan",
    "燅" => "Xian", "燆" => "Qiao", "燇" => "Zun", "燈" => "Deng", "燉" => "Dun", "燊" => "Shen",
    "燋" => "Jiao", "燌" => "Fen", "燍" => "Si", "燎" => "Liao", "燏" => "Yu", "燐" => "Lin",
    "燑" => "Tong", "燒" => "Shao", "燓" => "Fen", "燔" => "Fan", "燕" => "Yan", "燖" => "Xun",
    "燗" => "Lan", "燘" => "Mei", "燙" => "Tang", "燚" => "Yi", "燛" => "Jing", "燜" => "Men",
    "營" => "Ying", "燠" => "Yu", "燡" => "Yi", "燢" => "Xue", "燣" => "Lan", "燤" => "Tai",
    "燥" => "Zao", "燦" => "Can", "燧" => "Sui", "燨" => "Xi", "燩" => "Que", "燪" => "Cong",
    "燫" => "Lian", "燬" => "Hui", "燭" => "Zhu", "燮" => "Xie", "燯" => "Ling", "燰" => "Wei",
    "燱" => "Yi", "燲" => "Xie", "燳" => "Zhao", "燴" => "Hui", "燵" => "Tatsu", "燶" => "Nung",
    "燷" => "Lan", "燸" => "Ru", "燹" => "Xian", "燺" => "Kao", "燻" => "Xun", "燼" => "Jin",
    "燽" => "Chou", "燾" => "Chou", "燿" => "Yao", "爁" => "Lan", "爂" => "Biao", "爃" => "Rong",
    "爄" => "Li", "爅" => "Mo", "爆" => "Bao", "爇" => "Ruo", "爈" => "Lu", "爉" => "La",
    "爊" => "Ao", "爋" => "Xun", "爌" => "Kuang", "爍" => "Shuo", "爏" => "Li", "爐" => "Lu",
    "爑" => "Jue", "爒" => "Liao", "爓" => "Yan", "爔" => "Xi", "爕" => "Xie", "爖" => "Long",
    "爗" => "Ye", "爙" => "Rang", "爚" => "Yue", "爛" => "Lan", "爜" => "Cong", "爝" => "Jue",
    "爞" => "Tong", "爟" => "Guan", "爡" => "Che", "爢" => "Mi", "爣" => "Tang", "爤" => "Lan",
    "爥" => "Zhu", "爧" => "Ling", "爨" => "Cuan", "爩" => "Yu", "爪" => "Zhua", "爫" => "Tsumekanmuri",
    "爬" => "Pa", "爭" => "Zheng", "爮" => "Pao", "爯" => "Cheng", "爰" => "Yuan", "爱" => "Ai",
    "爲" => "Wei", "爴" => "Jue", "爵" => "Jue", "父" => "Fu", "爷" => "Ye", "爸" => "Ba",
    "爹" => "Die", "爺" => "Ye", "爻" => "Yao", "爼" => "Zu", "爽" => "Shuang", "爾" => "Er",
    "爿" => "Qiang", "牀" => "Chuang", "牁" => "Ge", "牂" => "Zang", "牃" => "Die", "牄" => "Qiang",
    "牅" => "Yong", "牆" => "Qiang", "片" => "Pian", "版" => "Ban", "牉" => "Pan", "牊" => "Shao",
    "牋" => "Jian", "牌" => "Pai", "牍" => "Du", "牎" => "Chuang", "牏" => "Tou", "牐" => "Zha",
    "牑" => "Bian", "牒" => "Die", "牓" => "Bang", "牔" => "Bo", "牕" => "Chuang", "牖" => "You",
    "牘" => "Du", "牙" => "Ya", "牚" => "Cheng", "牛" => "Niu", "牜" => "Ushihen", "牝" => "Pin",
    "牞" => "Jiu", "牟" => "Mou", "牠" => "Tuo", "牡" => "Mu", "牢" => "Lao", "牣" => "Ren",
    "牤" => "Mang", "牥" => "Fang", "牦" => "Mao", "牧" => "Mu", "牨" => "Gang", "物" => "Wu",
    "牪" => "Yan", "牫" => "Ge", "牬" => "Bei", "牭" => "Si", "牮" => "Jian", "牯" => "Gu",
    "牰" => "You", "牱" => "Ge", "牲" => "Sheng", "牳" => "Mu", "牴" => "Di", "牵" => "Qian",
    "牶" => "Quan", "牷" => "Quan", "牸" => "Zi", "特" => "Te", "牺" => "Xi", "牻" => "Mang",
    "牼" => "Keng", "牽" => "Qian", "牾" => "Wu", "牿" => "Gu", "犀" => "Xi", "犁" => "Li",
    "犂" => "Li", "犃" => "Pou", "犄" => "Ji", "犅" => "Gang", "犆" => "Zhi", "犇" => "Ben",
    "犈" => "Quan", "犉" => "Run", "犊" => "Du", "犋" => "Ju", "犌" => "Jia", "犍" => "Jian",
    "犎" => "Feng", "犏" => "Pian", "犐" => "Ke", "犑" => "Ju", "犒" => "Kao", "犓" => "Chu",
    "犔" => "Xi", "犕" => "Bei", "犖" => "Luo", "犗" => "Jie", "犘" => "Ma", "犙" => "San",
    "犚" => "Wei", "犛" => "Li", "犜" => "Dun", "犝" => "Tong", "犟" => "Jiang", "犠" => "Ikenie",
    "犡" => "Li", "犢" => "Du", "犣" => "Lie", "犤" => "Pi", "犥" => "Piao", "犦" => "Bao",
    "犧" => "Xi", "犨" => "Chou", "犩" => "Wei", "犪" => "Kui", "犫" => "Chou", "犬" => "Quan",
    "犭" => "Fan", "犮" => "Ba", "犯" => "Fan", "犰" => "Qiu", "犱" => "Ji", "犲" => "Cai",
    "犳" => "Chuo", "犴" => "An", "犵" => "Jie", "状" => "Zhuang", "犷" => "Guang", "犸" => "Ma",
    "犹" => "You", "犺" => "Kang", "犻" => "Bo", "犼" => "Hou", "犽" => "Ya", "犾" => "Yin",
    "犿" => "Huan", "狀" => "Zhuang", "狁" => "Yun", "狂" => "Kuang", "狃" => "Niu", "狄" => "Di",
    "狅" => "Qing", "狆" => "Zhong", "狇" => "Mu", "狈" => "Bei", "狉" => "Pi", "狊" => "Ju",
    "狋" => "Ni", "狌" => "Sheng", "狍" => "Pao", "狎" => "Xia", "狏" => "Tuo", "狐" => "Hu",
    "狑" => "Ling", "狒" => "Fei", "狓" => "Pi", "狔" => "Ni", "狕" => "Ao", "狖" => "You",
    "狗" => "Gou", "狘" => "Yue", "狙" => "Ju", "狚" => "Dan", "狛" => "Po", "狜" => "Gu",
    "狝" => "Xian", "狞" => "Ning", "狟" => "Huan", "狠" => "Hen", "狡" => "Jiao", "狢" => "He",
    "狣" => "Zhao", "狤" => "Ji", "狥" => "Xun", "狦" => "Shan", "狧" => "Ta", "狨" => "Rong",
    "狩" => "Shou", "狪" => "Tong", "狫" => "Lao", "独" => "Du", "狭" => "Xia", "狮" => "Shi",
    "狯" => "Hua", "狰" => "Zheng", "狱" => "Yu", "狲" => "Sun", "狳" => "Yu", "狴" => "Bi",
    "狵" => "Mang", "狶" => "Xi", "狷" => "Juan", "狸" => "Li", "狹" => "Xia", "狺" => "Yin",
    "狻" => "Suan", "狼" => "Lang", "狽" => "Bei", "狾" => "Zhi", "狿" => "Yan", "猁" => "Li",
    "猂" => "Han", "猃" => "Xian", "猄" => "Jing", "猅" => "Pai", "猆" => "Fei", "猇" => "Yao",
    "猈" => "Ba", "猉" => "Qi", "猊" => "Ni", "猋" => "Biao", "猌" => "Yin", "猍" => "Lai",
    "猎" => "Xi", "猏" => "Jian", "猐" => "Qiang", "猑" => "Kun", "猒" => "Yan", "猓" => "Guo",
    "猔" => "Zong", "猕" => "Mi", "猖" => "Chang", "猗" => "Yi", "猘" => "Zhi", "猙" => "Zheng",
    "猚" => "Ya", "猛" => "Meng", "猜" => "Cai", "猝" => "Cu", "猞" => "She", "猟" => "Kari",
    "猠" => "Cen", "猡" => "Luo", "猢" => "Hu", "猣" => "Zong", "猤" => "Ji", "猥" => "Wei",
    "猦" => "Feng", "猧" => "Wo", "猨" => "Yuan", "猩" => "Xing", "猪" => "Zhu", "猫" => "Mao",
    "猬" => "Wei", "猭" => "Yuan", "献" => "Xian", "猯" => "Tuan", "猰" => "Ya", "猱" => "Nao",
    "猲" => "Xie", "猳" => "Jia", "猴" => "Hou", "猵" => "Bian", "猶" => "You", "猷" => "You",
    "猸" => "Mei", "猹" => "Zha", "猺" => "Yao", "猻" => "Sun", "猼" => "Bo", "猽" => "Ming",
    "猾" => "Hua", "猿" => "Yuan", "獀" => "Sou", "獁" => "Ma", "獂" => "Yuan", "獃" => "Dai",
    "獄" => "Yu", "獅" => "Shi", "獆" => "Hao", "獈" => "Yi", "獉" => "Zhen", "獊" => "Chuang",
    "獋" => "Hao", "獌" => "Man", "獍" => "Jing", "獎" => "Jiang", "獏" => "Mu", "獐" => "Zhang",
    "獑" => "Chan", "獒" => "Ao", "獓" => "Ao", "獔" => "Hao", "獕" => "Cui", "獖" => "Fen",
    "獗" => "Jue", "獘" => "Bi", "獙" => "Bi", "獚" => "Huang", "獛" => "Pu", "獜" => "Lin",
    "獝" => "Yu", "獞" => "Tong", "獟" => "Yao", "獠" => "Liao", "獡" => "Shuo", "獢" => "Xiao",
    "獣" => "Swu", "獤" => "Ton", "獥" => "Xi", "獦" => "Ge", "獧" => "Juan", "獨" => "Du",
    "獩" => "Hui", "獪" => "Kuai", "獫" => "Xian", "獬" => "Xie", "獭" => "Ta", "獮" => "Xian",
    "獯" => "Xun", "獰" => "Ning", "獱" => "Pin", "獲" => "Huo", "獳" => "Nou", "獴" => "Meng",
    "獵" => "Lie", "獶" => "Nao", "獷" => "Guang", "獸" => "Shou", "獹" => "Lu", "獺" => "Ta",
    "獻" => "Xian", "獼" => "Mi", "獽" => "Rang", "獾" => "Huan", "獿" => "Nao", "玀" => "Luo",
    "玁" => "Xian", "玂" => "Qi", "玃" => "Jue", "玄" => "Xuan", "玅" => "Miao", "玆" => "Zi",
    "率" => "Lu", "玈" => "Lu", "玉" => "Yu", "玊" => "Su", "王" => "Wang", "玌" => "Qiu",
    "玍" => "Ga", "玎" => "Ding", "玏" => "Le", "玐" => "Ba", "玑" => "Ji", "玒" => "Hong",
    "玓" => "Di", "玔" => "Quan", "玕" => "Gan", "玖" => "Jiu", "玗" => "Yu", "玘" => "Ji",
    "玙" => "Yu", "玚" => "Yang", "玛" => "Ma", "玜" => "Gong", "玝" => "Wu", "玞" => "Fu",
    "玟" => "Wen", "玠" => "Jie", "玡" => "Ya", "玢" => "Fen", "玣" => "Bian", "玤" => "Beng",
    "玥" => "Yue", "玦" => "Jue", "玧" => "Yun", "玨" => "Jue", "玩" => "Wan", "玪" => "Jian",
    "玫" => "Mei", "玬" => "Dan", "玭" => "Pi", "玮" => "Wei", "环" => "Huan", "现" => "Xian",
    "玱" => "Qiang", "玲" => "Ling", "玳" => "Dai", "玴" => "Yi", "玵" => "An", "玶" => "Ping",
    "玷" => "Dian", "玸" => "Fu", "玹" => "Xuan", "玺" => "Xi", "玻" => "Bo", "玼" => "Ci",
    "玽" => "Gou", "玾" => "Jia", "玿" => "Shao", "珀" => "Po", "珁" => "Ci", "珂" => "Ke",
    "珃" => "Ran", "珄" => "Sheng", "珅" => "Shen", "珆" => "Yi", "珇" => "Zu", "珈" => "Jia",
    "珉" => "Min", "珊" => "Shan", "珋" => "Liu", "珌" => "Bi", "珍" => "Zhen", "珎" => "Zhen",
    "珏" => "Jue", "珐" => "Fa", "珑" => "Long", "珒" => "Jin", "珓" => "Jiao", "珔" => "Jian",
    "珕" => "Li", "珖" => "Guang", "珗" => "Xian", "珘" => "Zhou", "珙" => "Gong", "珚" => "Yan",
    "珛" => "Xiu", "珜" => "Yang", "珝" => "Xu", "珞" => "Luo", "珟" => "Su", "珠" => "Zhu",
    "珡" => "Qin", "珢" => "Ken", "珣" => "Xun", "珤" => "Bao", "珥" => "Er", "珦" => "Xiang",
    "珧" => "Yao", "珨" => "Xia", "珩" => "Heng", "珪" => "Gui", "珫" => "Chong", "珬" => "Xu",
    "班" => "Ban", "珮" => "Pei", "珰" => "Dang", "珱" => "Ei", "珲" => "Hun", "珳" => "Wen",
    "珴" => "E", "珵" => "Cheng", "珶" => "Ti", "珷" => "Wu", "珸" => "Wu", "珹" => "Cheng",
    "珺" => "Jun", "珻" => "Mei", "珼" => "Bei", "珽" => "Ting", "現" => "Xian", "珿" => "Chuo",
    "琁" => "Xuan", "琂" => "Yan", "球" => "Qiu", "琄" => "Quan", "琅" => "Lang", "理" => "Li",
    "琇" => "Xiu", "琈" => "Fu", "琉" => "Liu", "琊" => "Ye", "琋" => "Xi", "琌" => "Ling",
    "琍" => "Li", "琎" => "Jin", "琏" => "Lian", "琐" => "Suo", "琑" => "Chiisai", "琓" => "Wan",
    "琔" => "Dian", "琕" => "Pin", "琖" => "Zhan", "琗" => "Cui", "琘" => "Min", "琙" => "Yu",
    "琚" => "Ju", "琛" => "Chen", "琜" => "Lai", "琝" => "Wen", "琞" => "Sheng", "琟" => "Wei",
    "琠" => "Dian", "琡" => "Chu", "琢" => "Zhuo", "琣" => "Pei", "琤" => "Cheng", "琥" => "Hu",
    "琦" => "Qi", "琧" => "E", "琨" => "Kun", "琩" => "Chang", "琪" => "Qi", "琫" => "Beng",
    "琬" => "Wan", "琭" => "Lu", "琮" => "Cong", "琯" => "Guan", "琰" => "Yan", "琱" => "Diao",
    "琲" => "Bei", "琳" => "Lin", "琴" => "Qin", "琵" => "Pi", "琶" => "Pa", "琷" => "Que",
    "琸" => "Zhuo", "琹" => "Qin", "琺" => "Fa", "琼" => "Qiong", "琽" => "Du", "琾" => "Jie",
    "琿" => "Hun", "瑀" => "Yu", "瑁" => "Mao", "瑂" => "Mei", "瑃" => "Chun", "瑄" => "Xuan",
    "瑅" => "Ti", "瑆" => "Xing", "瑇" => "Dai", "瑈" => "Rou", "瑉" => "Min", "瑊" => "Zhen",
    "瑋" => "Wei", "瑌" => "Ruan", "瑍" => "Huan", "瑎" => "Jie", "瑏" => "Chuan", "瑐" => "Jian",
    "瑑" => "Zhuan", "瑒" => "Yang", "瑓" => "Lian", "瑔" => "Quan", "瑕" => "Xia", "瑖" => "Duan",
    "瑗" => "Yuan", "瑘" => "Ye", "瑙" => "Nao", "瑚" => "Hu", "瑛" => "Ying", "瑜" => "Yu",
    "瑝" => "Huang", "瑞" => "Rui", "瑟" => "Se", "瑠" => "Liu", "瑡" => "Shi", "瑢" => "Rong",
    "瑣" => "Suo", "瑤" => "Yao", "瑥" => "Wen", "瑦" => "Wu", "瑧" => "Jin", "瑨" => "Jin",
    "瑩" => "Ying", "瑪" => "Ma", "瑫" => "Tao", "瑬" => "Liu", "瑭" => "Tang", "瑮" => "Li",
    "瑯" => "Lang", "瑰" => "Gui", "瑱" => "Zhen", "瑲" => "Qiang", "瑳" => "Cuo", "瑴" => "Jue",
    "瑵" => "Zhao", "瑶" => "Yao", "瑷" => "Ai", "瑸" => "Bin", "瑹" => "Tu", "瑺" => "Chang",
    "瑻" => "Kun", "瑼" => "Zhuan", "瑽" => "Cong", "瑾" => "Jin", "瑿" => "Yi", "璀" => "Cui",
    "璁" => "Cong", "璂" => "Qi", "璃" => "Li", "璄" => "Ying", "璅" => "Suo", "璆" => "Qiu",
    "璇" => "Xuan", "璈" => "Ao", "璉" => "Lian", "璊" => "Man", "璋" => "Zhang", "璌" => "Yin",
    "璎" => "Ying", "璏" => "Zhi", "璐" => "Lu", "璑" => "Wu", "璒" => "Deng", "璓" => "Xiou",
    "璔" => "Zeng", "璕" => "Xun", "璖" => "Qu", "璗" => "Dang", "璘" => "Lin", "璙" => "Liao",
    "璚" => "Qiong", "璛" => "Su", "璜" => "Huang", "璝" => "Gui", "璞" => "Pu", "璟" => "Jing",
    "璠" => "Fan", "璡" => "Jin", "璢" => "Liu", "璣" => "Ji", "璥" => "Jing", "璦" => "Ai",
    "璧" => "Bi", "璨" => "Can", "璩" => "Qu", "璪" => "Zao", "璫" => "Dang", "璬" => "Jiao",
    "璭" => "Gun", "璮" => "Tan", "璯" => "Hui", "環" => "Huan", "璱" => "Se", "璲" => "Sui",
    "璳" => "Tian", "璵" => "Yu", "璶" => "Jin", "璷" => "Lu", "璸" => "Bin", "璹" => "Shou",
    "璺" => "Wen", "璻" => "Zui", "璼" => "Lan", "璽" => "Xi", "璾" => "Ji", "璿" => "Xuan",
    "瓀" => "Ruan", "瓁" => "Huo", "瓂" => "Gai", "瓃" => "Lei", "瓄" => "Du", "瓅" => "Li",
    "瓆" => "Zhi", "瓇" => "Rou", "瓈" => "Li", "瓉" => "Zan", "瓊" => "Qiong", "瓋" => "Zhe",
    "瓌" => "Gui", "瓍" => "Sui", "瓎" => "La", "瓏" => "Long", "瓐" => "Lu", "瓑" => "Li",
    "瓒" => "Zan", "瓓" => "Lan", "瓔" => "Ying", "瓕" => "Mi", "瓖" => "Xiang", "瓗" => "Xi",
    "瓘" => "Guan", "瓙" => "Dao", "瓚" => "Zan", "瓛" => "Huan", "瓜" => "Gua", "瓝" => "Bo",
    "瓞" => "Die", "瓟" => "Bao", "瓠" => "Hu", "瓡" => "Zhi", "瓢" => "Piao", "瓣" => "Ban",
    "瓤" => "Rang", "瓥" => "Li", "瓦" => "Wa", "瓧" => "Dekaguramu", "瓨" => "Jiang", "瓩" => "Qian",
    "瓪" => "Fan", "瓫" => "Pen", "瓬" => "Fang", "瓭" => "Dan", "瓮" => "Weng", "瓯" => "Ou",
    "瓰" => "Deshiguramu", "瓱" => "Miriguramu", "瓲" => "Thon", "瓳" => "Hu", "瓴" => "Ling", "瓵" => "Yi",
    "瓶" => "Ping", "瓷" => "Ci", "瓸" => "Hekutogura", "瓹" => "Juan", "瓺" => "Chang", "瓻" => "Chi",
    "瓼" => "Sarake", "瓽" => "Dang", "瓾" => "Meng", "瓿" => "Pou", "甁" => "Ping", "甂" => "Bian",
    "甃" => "Zhou", "甄" => "Zhen", "甅" => "Senchigura", "甆" => "Ci", "甇" => "Ying", "甈" => "Qi",
    "甉" => "Xian", "甊" => "Lou", "甋" => "Di", "甌" => "Ou", "甍" => "Meng", "甎" => "Zhuan",
    "甏" => "Peng", "甐" => "Lin", "甑" => "Zeng", "甒" => "Wu", "甓" => "Pi", "甔" => "Dan",
    "甕" => "Weng", "甖" => "Ying", "甗" => "Yan", "甘" => "Gan", "甙" => "Dai", "甚" => "Shen",
    "甛" => "Tian", "甜" => "Tian", "甝" => "Han", "甞" => "Chang", "生" => "Sheng", "甠" => "Qing",
    "甡" => "Sheng", "產" => "Chan", "産" => "Chan", "甤" => "Rui", "甥" => "Sheng", "甦" => "Su",
    "甧" => "Sen", "用" => "Yong", "甩" => "Shuai", "甪" => "Lu", "甫" => "Fu", "甬" => "Yong",
    "甭" => "Beng", "甮" => "Feng", "甯" => "Ning", "田" => "Tian", "由" => "You", "甲" => "Jia",
    "申" => "Shen", "甴" => "Zha", "电" => "Dian", "甶" => "Fu", "男" => "Nan", "甸" => "Dian",
    "甹" => "Ping", "町" => "Ting", "画" => "Hua", "甼" => "Ting", "甽" => "Quan", "甾" => "Zi",
    "甿" => "Meng", "畀" => "Bi", "畁" => "Qi", "畂" => "Liu", "畃" => "Xun", "畄" => "Liu",
    "畅" => "Chang", "畆" => "Mu", "畇" => "Yun", "畈" => "Fan", "畉" => "Fu", "畊" => "Geng",
    "畋" => "Tian", "界" => "Jie", "畍" => "Jie", "畎" => "Quan", "畏" => "Wei", "畐" => "Fu",
    "畑" => "Tian", "畒" => "Mu", "畓" => "Tap", "畔" => "Pan", "畕" => "Jiang", "畖" => "Wa",
    "畗" => "Da", "畘" => "Nan", "留" => "Liu", "畚" => "Ben", "畛" => "Zhen", "畜" => "Chu",
    "畝" => "Mu", "畞" => "Mu", "畟" => "Ce", "畠" => "Cen", "畡" => "Gai", "畢" => "Bi",
    "畣" => "Da", "畤" => "Zhi", "略" => "Lue", "畦" => "Qi", "畧" => "Lue", "畨" => "Pan",
    "畩" => "Kesa", "番" => "Fan", "畫" => "Hua", "畬" => "Yu", "畭" => "Yu", "畮" => "Mu",
    "畯" => "Jun", "異" => "Yi", "畱" => "Liu", "畲" => "Yu", "畳" => "Die", "畴" => "Chou",
    "畵" => "Hua", "當" => "Dang", "畷" => "Chuo", "畸" => "Ji", "畹" => "Wan", "畺" => "Jiang",
    "畻" => "Sheng", "畼" => "Chang", "畽" => "Tuan", "畾" => "Lei", "畿" => "Ji", "疀" => "Cha",
    "疁" => "Liu", "疂" => "Tatamu", "疃" => "Tuan", "疄" => "Lin", "疅" => "Jiang", "疆" => "Jiang",
    "疇" => "Chou", "疈" => "Bo", "疉" => "Die", "疊" => "Die", "疋" => "Pi", "疌" => "Nie",
    "疍" => "Dan", "疎" => "Shu", "疏" => "Shu", "疐" => "Zhi", "疑" => "Yi", "疒" => "Chuang",
    "疓" => "Nai", "疔" => "Ding", "疕" => "Bi", "疖" => "Jie", "疗" => "Liao", "疘" => "Gong",
    "疙" => "Ge", "疚" => "Jiu", "疛" => "Zhou", "疜" => "Xia", "疝" => "Shan", "疞" => "Xu",
    "疟" => "Nue", "疠" => "Li", "疡" => "Yang", "疢" => "Chen", "疣" => "You", "疤" => "Ba",
    "疥" => "Jie", "疦" => "Jue", "疧" => "Zhi", "疨" => "Xia", "疩" => "Cui", "疪" => "Bi",
    "疫" => "Yi", "疬" => "Li", "疭" => "Zong", "疮" => "Chuang", "疯" => "Feng", "疰" => "Zhu",
    "疱" => "Pao", "疲" => "Pi", "疳" => "Gan", "疴" => "Ke", "疵" => "Ci", "疶" => "Xie",
    "疷" => "Qi", "疸" => "Dan", "疹" => "Zhen", "疺" => "Fa", "疻" => "Zhi", "疼" => "Teng",
    "疽" => "Ju", "疾" => "Ji", "疿" => "Fei", "痀" => "Qu", "痁" => "Dian", "痂" => "Jia",
    "痃" => "Xian", "痄" => "Cha", "病" => "Bing", "痆" => "Ni", "症" => "Zheng", "痈" => "Yong",
    "痉" => "Jing", "痊" => "Quan", "痋" => "Chong", "痌" => "Tong", "痍" => "Yi", "痎" => "Kai",
    "痏" => "Wei", "痐" => "Hui", "痑" => "Duo", "痒" => "Yang", "痓" => "Chi", "痔" => "Zhi",
    "痕" => "Hen", "痖" => "Ya", "痗" => "Mei", "痘" => "Dou", "痙" => "Jing", "痚" => "Xiao",
    "痛" => "Tong", "痜" => "Tu", "痝" => "Mang", "痞" => "Pi", "痟" => "Xiao", "痠" => "Suan",
    "痡" => "Pu", "痢" => "Li", "痣" => "Zhi", "痤" => "Cuo", "痥" => "Duo", "痦" => "Wu",
    "痧" => "Sha", "痨" => "Lao", "痩" => "Shou", "痪" => "Huan", "痫" => "Xian", "痬" => "Yi",
    "痭" => "Peng", "痮" => "Zhang", "痯" => "Guan", "痰" => "Tan", "痱" => "Fei", "痲" => "Ma",
    "痳" => "Lin", "痴" => "Chi", "痵" => "Ji", "痶" => "Dian", "痷" => "An", "痸" => "Chi",
    "痹" => "Bi", "痺" => "Bei", "痻" => "Min", "痼" => "Gu", "痽" => "Dui", "痾" => "E",
    "痿" => "Wei", "瘁" => "Cui", "瘂" => "Ya", "瘃" => "Zhu", "瘄" => "Cu", "瘅" => "Dan",
    "瘆" => "Shen", "瘇" => "Zhung", "瘈" => "Ji", "瘉" => "Yu", "瘊" => "Hou", "瘋" => "Feng",
    "瘌" => "La", "瘍" => "Yang", "瘎" => "Shen", "瘏" => "Tu", "瘐" => "Yu", "瘑" => "Gua",
    "瘒" => "Wen", "瘓" => "Huan", "瘔" => "Ku", "瘕" => "Jia", "瘖" => "Yin", "瘗" => "Yi",
    "瘘" => "Lu", "瘙" => "Sao", "瘚" => "Jue", "瘛" => "Chi", "瘜" => "Xi", "瘝" => "Guan",
    "瘞" => "Yi", "瘟" => "Wen", "瘠" => "Ji", "瘡" => "Chuang", "瘢" => "Ban", "瘣" => "Lei",
    "瘤" => "Liu", "瘥" => "Chai", "瘦" => "Shou", "瘧" => "Nue", "瘨" => "Dian", "瘩" => "Da",
    "瘪" => "Pie", "瘫" => "Tan", "瘬" => "Zhang", "瘭" => "Biao", "瘮" => "Shen", "瘯" => "Cu",
    "瘰" => "Luo", "瘱" => "Yi", "瘲" => "Zong", "瘳" => "Chou", "瘴" => "Zhang", "瘵" => "Zhai",
    "瘶" => "Sou", "瘷" => "Suo", "瘸" => "Que", "瘹" => "Diao", "瘺" => "Lou", "瘻" => "Lu",
    "瘼" => "Mo", "瘽" => "Jin", "瘾" => "Yin", "瘿" => "Ying", "癀" => "Huang", "癁" => "Fu",
    "療" => "Liao", "癃" => "Long", "癄" => "Qiao", "癅" => "Liu", "癆" => "Lao", "癇" => "Xian",
    "癈" => "Fei", "癉" => "Dan", "癊" => "Yin", "癋" => "He", "癌" => "Yan", "癍" => "Ban",
    "癎" => "Xian", "癏" => "Guan", "癐" => "Guai", "癑" => "Nong", "癒" => "Yu", "癓" => "Wei",
    "癔" => "Yi", "癕" => "Yong", "癖" => "Pi", "癗" => "Lei", "癘" => "Li", "癙" => "Shu",
    "癚" => "Dan", "癛" => "Lin", "癜" => "Dian", "癝" => "Lin", "癞" => "Lai", "癟" => "Pie",
    "癠" => "Ji", "癡" => "Chi", "癢" => "Yang", "癣" => "Xian", "癤" => "Jie", "癥" => "Zheng",
    "癧" => "Li", "癨" => "Huo", "癩" => "Lai", "癪" => "Shaku", "癫" => "Dian", "癬" => "Xian",
    "癭" => "Ying", "癮" => "Yin", "癯" => "Qu", "癰" => "Yong", "癱" => "Tan", "癲" => "Dian",
    "癳" => "Luo", "癴" => "Luan", "癵" => "Luan", "癶" => "Bo", "癸" => "Gui", "癹" => "Po",
    "発" => "Fa", "登" => "Deng", "發" => "Fa", "白" => "Bai", "百" => "Bai", "癿" => "Qie",
    "皀" => "Bi", "皁" => "Zao", "皂" => "Zao", "皃" => "Mao", "的" => "De", "皅" => "Pa",
    "皆" => "Jie", "皇" => "Huang", "皈" => "Gui", "皉" => "Ci", "皊" => "Ling", "皋" => "Gao",
    "皌" => "Mo", "皍" => "Ji", "皎" => "Jiao", "皏" => "Peng", "皐" => "Gao", "皑" => "Ai",
    "皒" => "E", "皓" => "Hao", "皔" => "Han", "皕" => "Bi", "皖" => "Wan", "皗" => "Chou",
    "皘" => "Qian", "皙" => "Xi", "皚" => "Ai", "皛" => "Jiong", "皜" => "Hao", "皝" => "Huang",
    "皞" => "Hao", "皟" => "Ze", "皠" => "Cui", "皡" => "Hao", "皢" => "Xiao", "皣" => "Ye",
    "皤" => "Po", "皥" => "Hao", "皦" => "Jiao", "皧" => "Ai", "皨" => "Xing", "皩" => "Huang",
    "皪" => "Li", "皫" => "Piao", "皬" => "He", "皭" => "Jiao", "皮" => "Pi", "皯" => "Gan",
    "皰" => "Pao", "皱" => "Zhou", "皲" => "Jun", "皳" => "Qiu", "皴" => "Cun", "皵" => "Que",
    "皶" => "Zha", "皷" => "Gu", "皸" => "Jun", "皹" => "Jun", "皺" => "Zhou", "皻" => "Zha",
    "皼" => "Gu", "皽" => "Zhan", "皾" => "Du", "皿" => "Min", "盀" => "Qi", "盁" => "Ying",
    "盂" => "Yu", "盃" => "Bei", "盄" => "Zhao", "盅" => "Zhong", "盆" => "Pen", "盇" => "He",
    "盈" => "Ying", "盉" => "He", "益" => "Yi", "盋" => "Bo", "盌" => "Wan", "盍" => "He",
    "盎" => "Ang", "盏" => "Zhan", "盐" => "Yan", "监" => "Jian", "盒" => "He", "盓" => "Yu",
    "盔" => "Kui", "盕" => "Fan", "盖" => "Gai", "盗" => "Dao", "盘" => "Pan", "盙" => "Fu",
    "盚" => "Qiu", "盛" => "Sheng", "盜" => "Dao", "盝" => "Lu", "盞" => "Zhan", "盟" => "Meng",
    "盠" => "Li", "盡" => "Jin", "盢" => "Xu", "監" => "Jian", "盤" => "Pan", "盥" => "Guan",
    "盦" => "An", "盧" => "Lu", "盨" => "Shu", "盩" => "Zhou", "盪" => "Dang", "盫" => "An",
    "盬" => "Gu", "盭" => "Li", "目" => "Mu", "盯" => "Cheng", "盰" => "Gan", "盱" => "Xu",
    "盲" => "Mang", "盳" => "Mang", "直" => "Zhi", "盵" => "Qi", "盶" => "Ruan", "盷" => "Tian",
    "相" => "Xiang", "盹" => "Dun", "盺" => "Xin", "盻" => "Xi", "盼" => "Pan", "盽" => "Feng",
    "盾" => "Dun", "盿" => "Min", "省" => "Sheng", "眂" => "Shi", "眃" => "Yun", "眄" => "Mian",
    "眅" => "Pan", "眆" => "Fang", "眇" => "Miao", "眈" => "Dan", "眉" => "Mei", "眊" => "Mao",
    "看" => "Kan", "県" => "Xian", "眍" => "Ou", "眎" => "Shi", "眏" => "Yang", "眐" => "Zheng",
    "眑" => "Yao", "眒" => "Shen", "眓" => "Huo", "眔" => "Da", "眕" => "Zhen", "眖" => "Kuang",
    "眗" => "Ju", "眘" => "Shen", "眙" => "Chi", "眚" => "Sheng", "眛" => "Mei", "眜" => "Mo",
    "眝" => "Zhu", "眞" => "Zhen", "真" => "Zhen", "眠" => "Mian", "眡" => "Di", "眢" => "Yuan",
    "眣" => "Die", "眤" => "Yi", "眥" => "Zi", "眦" => "Zi", "眧" => "Chao", "眨" => "Zha",
    "眩" => "Xuan", "眪" => "Bing", "眫" => "Mi", "眬" => "Long", "眭" => "Sui", "眮" => "Dong",
    "眯" => "Mi", "眰" => "Die", "眱" => "Yi", "眲" => "Er", "眳" => "Ming", "眴" => "Xuan",
    "眵" => "Chi", "眶" => "Kuang", "眷" => "Juan", "眸" => "Mou", "眹" => "Zhen", "眺" => "Tiao",
    "眻" => "Yang", "眼" => "Yan", "眽" => "Mo", "眾" => "Zhong", "眿" => "Mai", "着" => "Zhao",
    "睁" => "Zheng", "睂" => "Mei", "睃" => "Jun", "睄" => "Shao", "睅" => "Han", "睆" => "Huan",
    "睇" => "Di", "睈" => "Cheng", "睉" => "Cuo", "睊" => "Juan", "睋" => "E", "睌" => "Wan",
    "睍" => "Xian", "睎" => "Xi", "睏" => "Kun", "睐" => "Lai", "睑" => "Jian", "睒" => "Shan",
    "睓" => "Tian", "睔" => "Hun", "睕" => "Wan", "睖" => "Ling", "睗" => "Shi", "睘" => "Qiong",
    "睙" => "Lie", "睚" => "Yai", "睛" => "Jing", "睜" => "Zheng", "睝" => "Li", "睞" => "Lai",
    "睟" => "Sui", "睠" => "Juan", "睡" => "Shui", "睢" => "Sui", "督" => "Du", "睤" => "Bi",
    "睥" => "Bi", "睦" => "Mu", "睧" => "Hun", "睨" => "Ni", "睩" => "Lu", "睪" => "Yi",
    "睫" => "Jie", "睬" => "Cai", "睭" => "Zhou", "睮" => "Yu", "睯" => "Hun", "睰" => "Ma",
    "睱" => "Xia", "睲" => "Xing", "睳" => "Xi", "睴" => "Gun", "睵" => "Cai", "睶" => "Chun",
    "睷" => "Jian", "睸" => "Mei", "睹" => "Du", "睺" => "Hou", "睻" => "Xuan", "睼" => "Ti",
    "睽" => "Kui", "睾" => "Gao", "睿" => "Rui", "瞀" => "Mou", "瞁" => "Xu", "瞂" => "Fa",
    "瞃" => "Wen", "瞄" => "Miao", "瞅" => "Chou", "瞆" => "Kui", "瞇" => "Mi", "瞈" => "Weng",
    "瞉" => "Kou", "瞊" => "Dang", "瞋" => "Chen", "瞌" => "Ke", "瞍" => "Sou", "瞎" => "Xia",
    "瞏" => "Qiong", "瞐" => "Mao", "瞑" => "Ming", "瞒" => "Man", "瞓" => "Shui", "瞔" => "Ze",
    "瞕" => "Zhang", "瞖" => "Yi", "瞗" => "Diao", "瞘" => "Ou", "瞙" => "Mo", "瞚" => "Shun",
    "瞛" => "Cong", "瞜" => "Lou", "瞝" => "Chi", "瞞" => "Man", "瞟" => "Piao", "瞠" => "Cheng",
    "瞡" => "Ji", "瞢" => "Meng", "瞤" => "Run", "瞥" => "Pie", "瞦" => "Xi", "瞧" => "Qiao",
    "瞨" => "Pu", "瞩" => "Zhu", "瞪" => "Deng", "瞫" => "Shen", "瞬" => "Shun", "瞭" => "Liao",
    "瞮" => "Che", "瞯" => "Xian", "瞰" => "Kan", "瞱" => "Ye", "瞲" => "Xu", "瞳" => "Tong",
    "瞴" => "Mou", "瞵" => "Lin", "瞶" => "Kui", "瞷" => "Xian", "瞸" => "Ye", "瞹" => "Ai",
    "瞺" => "Hui", "瞻" => "Zhan", "瞼" => "Jian", "瞽" => "Gu", "瞾" => "Zhao", "瞿" => "Qu",
    "矀" => "Wei", "矁" => "Chou", "矂" => "Sao", "矃" => "Ning", "矄" => "Xun", "矅" => "Yao",
    "矆" => "Huo", "矇" => "Meng", "矈" => "Mian", "矉" => "Bin", "矊" => "Mian", "矋" => "Li",
    "矌" => "Kuang", "矍" => "Jue", "矎" => "Xuan", "矏" => "Mian", "矐" => "Huo", "矑" => "Lu",
    "矒" => "Meng", "矓" => "Long", "矔" => "Guan", "矕" => "Man", "矖" => "Xi", "矗" => "Chu",
    "矘" => "Tang", "矙" => "Kan", "矚" => "Zhu", "矛" => "Mao", "矜" => "Jin", "矝" => "Lin",
    "矞" => "Yu", "矟" => "Shuo", "矠" => "Ce", "矡" => "Jue", "矢" => "Shi", "矣" => "Yi",
    "矤" => "Shen", "知" => "Zhi", "矦" => "Hou", "矧" => "Shen", "矨" => "Ying", "矩" => "Ju",
    "矪" => "Zhou", "矫" => "Jiao", "矬" => "Cuo", "短" => "Duan", "矮" => "Ai", "矯" => "Jiao",
    "矰" => "Zeng", "矱" => "Huo", "矲" => "Bai", "石" => "Shi", "矴" => "Ding", "矵" => "Qi",
    "矶" => "Ji", "矷" => "Zi", "矸" => "Gan", "矹" => "Wu", "矺" => "Tuo", "矻" => "Ku",
    "矼" => "Qiang", "矽" => "Xi", "矾" => "Fan", "矿" => "Kuang", "码" => "Ma", "砂" => "Sha",
    "砃" => "Dan", "砄" => "Jue", "砅" => "Li", "砆" => "Fu", "砇" => "Min", "砈" => "Nuo",
    "砉" => "Huo", "砊" => "Kang", "砋" => "Zhi", "砌" => "Qi", "砍" => "Kan", "砎" => "Jie",
    "砏" => "Fen", "砐" => "E", "砑" => "Ya", "砒" => "Pi", "砓" => "Zhe", "研" => "Yan",
    "砕" => "Sui", "砖" => "Zhuan", "砗" => "Che", "砘" => "Dun", "砙" => "Pan", "砚" => "Yan",
    "砜" => "Feng", "砝" => "Fa", "砞" => "Mo", "砟" => "Zha", "砠" => "Qu", "砡" => "Yu",
    "砢" => "Luo", "砣" => "Tuo", "砤" => "Tuo", "砥" => "Di", "砦" => "Zhai", "砧" => "Zhen",
    "砨" => "Ai", "砩" => "Fei", "砪" => "Mu", "砫" => "Zhu", "砬" => "Li", "砭" => "Bian",
    "砮" => "Nu", "砯" => "Ping", "砰" => "Peng", "砱" => "Ling", "砲" => "Pao", "砳" => "Le",
    "破" => "Po", "砵" => "Bo", "砶" => "Po", "砷" => "Shen", "砸" => "Za", "砹" => "Nuo",
    "砺" => "Li", "砻" => "Long", "砼" => "Tong", "砾" => "Li", "砿" => "Aragane", "础" => "Chu",
    "硁" => "Keng", "硂" => "Quan", "硃" => "Zhu", "硄" => "Kuang", "硅" => "Huo", "硆" => "E",
    "硇" => "Nao", "硈" => "Jia", "硉" => "Lu", "硊" => "Wei", "硋" => "Ai", "硌" => "Luo",
    "硍" => "Ken", "硎" => "Xing", "硏" => "Yan", "硐" => "Tong", "硑" => "Peng", "硒" => "Xi",
    "硔" => "Hong", "硕" => "Shuo", "硖" => "Xia", "硗" => "Qiao", "硙" => "Wei", "硚" => "Qiao",
    "硜" => "Keng", "硝" => "Xiao", "硞" => "Que", "硟" => "Chan", "硠" => "Lang", "硡" => "Hong",
    "硢" => "Yu", "硣" => "Xiao", "硤" => "Xia", "硥" => "Mang", "硦" => "Long", "硧" => "Iong",
    "硨" => "Che", "硩" => "Che", "硪" => "E", "硫" => "Liu", "硬" => "Ying", "硭" => "Mang",
    "确" => "Que", "硯" => "Yan", "硰" => "Sha", "硱" => "Kun", "硲" => "Yu", "硴" => "Kaki",
    "硵" => "Lu", "硶" => "Chen", "硷" => "Jian", "硸" => "Nue", "硹" => "Song", "硺" => "Zhuo",
    "硻" => "Keng", "硼" => "Peng", "硽" => "Yan", "硾" => "Zhui", "硿" => "Kong", "碀" => "Ceng",
    "碁" => "Qi", "碂" => "Zong", "碃" => "Qing", "碄" => "Lin", "碅" => "Jun", "碆" => "Bo",
    "碇" => "Ding", "碈" => "Min", "碉" => "Diao", "碊" => "Jian", "碋" => "He", "碌" => "Lu",
    "碍" => "Ai", "碎" => "Sui", "碏" => "Que", "碐" => "Ling", "碑" => "Bei", "碒" => "Yin",
    "碓" => "Dui", "碔" => "Wu", "碕" => "Qi", "碖" => "Lun", "碗" => "Wan", "碘" => "Dian",
    "碙" => "Gang", "碚" => "Pei", "碛" => "Qi", "碜" => "Chen", "碝" => "Ruan", "碞" => "Yan",
    "碟" => "Die", "碠" => "Ding", "碡" => "Du", "碢" => "Tuo", "碣" => "Jie", "碤" => "Ying",
    "碥" => "Bian", "碦" => "Ke", "碧" => "Bi", "碨" => "Wei", "碩" => "Shuo", "碪" => "Zhen",
    "碫" => "Duan", "碬" => "Xia", "碭" => "Dang", "碮" => "Ti", "碯" => "Nao", "碰" => "Peng",
    "碱" => "Jian", "碲" => "Di", "碳" => "Tan", "碴" => "Cha", "碵" => "Seki", "碶" => "Qi",
    "碸" => "Feng", "碹" => "Xuan", "確" => "Que", "碻" => "Que", "碼" => "Ma", "碽" => "Gong",
    "碾" => "Nian", "碿" => "Su", "磀" => "E", "磁" => "Ci", "磂" => "Liu", "磃" => "Si",
    "磄" => "Tang", "磅" => "Bang", "磆" => "Hua", "磇" => "Pi", "磈" => "Wei", "磉" => "Sang",
    "磊" => "Lei", "磋" => "Cuo", "磌" => "Zhen", "磍" => "Xia", "磎" => "Qi", "磏" => "Lian",
    "磐" => "Pan", "磑" => "Wei", "磒" => "Yun", "磓" => "Dui", "磔" => "Zhe", "磕" => "Ke",
    "磖" => "La", "磘" => "Qing", "磙" => "Gun", "磚" => "Zhuan", "磛" => "Chan", "磜" => "Qi",
    "磝" => "Ao", "磞" => "Peng", "磟" => "Lu", "磠" => "Lu", "磡" => "Kan", "磢" => "Qiang",
    "磣" => "Chen", "磤" => "Yin", "磥" => "Lei", "磦" => "Biao", "磧" => "Qi", "磨" => "Mo",
    "磩" => "Qi", "磪" => "Cui", "磫" => "Zong", "磬" => "Qing", "磭" => "Chuo", "磯" => "Ji",
    "磰" => "Shan", "磱" => "Lao", "磲" => "Qu", "磳" => "Zeng", "磴" => "Deng", "磵" => "Jian",
    "磶" => "Xi", "磷" => "Lin", "磸" => "Ding", "磹" => "Dian", "磺" => "Huang", "磻" => "Pan",
    "磼" => "Za", "磽" => "Qiao", "磾" => "Di", "磿" => "Li", "礁" => "Jiao", "礃" => "Zhang",
    "礄" => "Qiao", "礅" => "Dun", "礆" => "Xian", "礇" => "Yu", "礈" => "Zhui", "礉" => "He",
    "礊" => "Huo", "礋" => "Zhai", "礌" => "Lei", "礍" => "Ke", "礎" => "Chu", "礏" => "Ji",
    "礐" => "Que", "礑" => "Dang", "礒" => "Yi", "礓" => "Jiang", "礔" => "Pi", "礕" => "Pi",
    "礖" => "Yu", "礗" => "Pin", "礘" => "Qi", "礙" => "Ai", "礚" => "Kai", "礛" => "Jian",
    "礜" => "Yu", "礝" => "Ruan", "礞" => "Meng", "礟" => "Pao", "礠" => "Ci", "礣" => "Mie",
    "礤" => "Ca", "礥" => "Xian", "礦" => "Kuang", "礧" => "Lei", "礨" => "Lei", "礩" => "Zhi",
    "礪" => "Li", "礫" => "Li", "礬" => "Fan", "礭" => "Que", "礮" => "Pao", "礯" => "Ying",
    "礰" => "Li", "礱" => "Long", "礲" => "Long", "礳" => "Mo", "礴" => "Bo", "礵" => "Shuang",
    "礶" => "Guan", "礷" => "Lan", "礸" => "Zan", "礹" => "Yan", "示" => "Shi", "礻" => "Shi",
    "礼" => "Li", "礽" => "Reng", "社" => "She", "礿" => "Yue", "祀" => "Si", "祁" => "Qi",
    "祂" => "Ta", "祃" => "Ma", "祄" => "Xie", "祅" => "Xian", "祆" => "Xian", "祇" => "Zhi",
    "祈" => "Qi", "祉" => "Zhi", "祊" => "Beng", "祋" => "Dui", "祌" => "Zhong", "祎" => "Yi",
    "祏" => "Shi", "祐" => "You", "祑" => "Zhi", "祒" => "Tiao", "祓" => "Fu", "祔" => "Fu",
    "祕" => "Mi", "祖" => "Zu", "祗" => "Zhi", "祘" => "Suan", "祙" => "Mei", "祚" => "Zuo",
    "祛" => "Qu", "祜" => "Hu", "祝" => "Zhu", "神" => "Shen", "祟" => "Sui", "祠" => "Ci",
    "祡" => "Chai", "祢" => "Mi", "祣" => "Lu", "祤" => "Yu", "祥" => "Xiang", "祦" => "Wu",
    "祧" => "Tiao", "票" => "Piao", "祩" => "Zhu", "祪" => "Gui", "祫" => "Xia", "祬" => "Zhi",
    "祭" => "Ji", "祮" => "Gao", "祯" => "Zhen", "祰" => "Gao", "祱" => "Shui", "祲" => "Jin",
    "祳" => "Chen", "祴" => "Gai", "祵" => "Kun", "祶" => "Di", "祷" => "Dao", "祸" => "Huo",
    "祹" => "Tao", "祺" => "Qi", "祻" => "Gu", "祼" => "Guan", "祽" => "Zui", "祾" => "Ling",
    "祿" => "Lu", "禀" => "Bing", "禁" => "Jin", "禂" => "Dao", "禃" => "Zhi", "禄" => "Lu",
    "禅" => "Shan", "禆" => "Bei", "禇" => "Zhe", "禈" => "Hui", "禉" => "You", "禊" => "Xi",
    "禋" => "Yin", "禌" => "Zi", "禍" => "Huo", "禎" => "Zhen", "福" => "Fu", "禐" => "Yuan",
    "禑" => "Wu", "禒" => "Xian", "禓" => "Yang", "禔" => "Ti", "禕" => "Yi", "禖" => "Mei",
    "禗" => "Si", "禘" => "Di", "禚" => "Zhuo", "禛" => "Zhen", "禜" => "Yong", "禝" => "Ji",
    "禞" => "Gao", "禟" => "Tang", "禠" => "Si", "禡" => "Ma", "禢" => "Ta", "禤" => "Xuan",
    "禥" => "Qi", "禦" => "Yu", "禧" => "Xi", "禨" => "Ji", "禩" => "Si", "禪" => "Chan",
    "禫" => "Tan", "禬" => "Kuai", "禭" => "Sui", "禮" => "Li", "禯" => "Nong", "禰" => "Ni",
    "禱" => "Dao", "禲" => "Li", "禳" => "Rang", "禴" => "Yue", "禵" => "Ti", "禶" => "Zan",
    "禷" => "Lei", "禸" => "Rou", "禹" => "Yu", "禺" => "Yu", "离" => "Chi", "禼" => "Xie",
    "禽" => "Qin", "禾" => "He", "禿" => "Tu", "秀" => "Xiu", "私" => "Si", "秂" => "Ren",
    "秃" => "Tu", "秄" => "Zi", "秅" => "Cha", "秆" => "Gan", "秇" => "Yi", "秈" => "Xian",
    "秉" => "Bing", "秊" => "Nian", "秋" => "Qiu", "秌" => "Qiu", "种" => "Chong", "秎" => "Fen",
    "秏" => "Hao", "秐" => "Yun", "科" => "Ke", "秒" => "Miao", "秓" => "Zhi", "秔" => "Geng",
    "秕" => "Bi", "秖" => "Zhi", "秗" => "Yu", "秘" => "Mi", "秙" => "Ku", "秚" => "Ban",
    "秛" => "Pi", "秜" => "Ni", "秝" => "Li", "秞" => "You", "租" => "Zu", "秠" => "Pi",
    "秡" => "Ba", "秢" => "Ling", "秣" => "Mo", "秤" => "Cheng", "秥" => "Nian", "秦" => "Qin",
    "秧" => "Yang", "秨" => "Zuo", "秩" => "Zhi", "秪" => "Zhi", "秫" => "Shu", "秬" => "Ju",
    "秭" => "Zi", "秮" => "Huo", "积" => "Ji", "称" => "Cheng", "秱" => "Tong", "秲" => "Zhi",
    "秳" => "Huo", "秴" => "He", "秵" => "Yin", "秶" => "Zi", "秷" => "Zhi", "秸" => "Jie",
    "秹" => "Ren", "秺" => "Du", "移" => "Yi", "秼" => "Zhu", "秽" => "Hui", "秾" => "Nong",
    "秿" => "Fu", "稁" => "Kao", "稂" => "Lang", "稃" => "Fu", "稄" => "Ze", "稅" => "Shui",
    "稆" => "Lu", "稇" => "Kun", "稈" => "Gan", "稉" => "Geng", "稊" => "Ti", "程" => "Cheng",
    "稌" => "Tu", "稍" => "Shao", "税" => "Shui", "稏" => "Ya", "稐" => "Lun", "稑" => "Lu",
    "稒" => "Gu", "稓" => "Zuo", "稔" => "Ren", "稕" => "Zhun", "稖" => "Bang", "稗" => "Bai",
    "稘" => "Ji", "稙" => "Zhi", "稚" => "Zhi", "稛" => "Kun", "稜" => "Leng", "稝" => "Peng",
    "稞" => "Ke", "稟" => "Bing", "稠" => "Chou", "稡" => "Zu", "稢" => "Yu", "稣" => "Su",
    "稤" => "Lue", "稦" => "Yi", "稧" => "Xi", "稨" => "Bian", "稩" => "Ji", "稪" => "Fu",
    "稫" => "Bi", "稬" => "Nuo", "稭" => "Jie", "種" => "Zhong", "稯" => "Zong", "稰" => "Xu",
    "稱" => "Cheng", "稲" => "Dao", "稳" => "Wen", "稴" => "Lian", "稵" => "Zi", "稶" => "Yu",
    "稷" => "Ji", "稸" => "Xu", "稹" => "Zhen", "稺" => "Zhi", "稻" => "Dao", "稼" => "Jia",
    "稽" => "Ji", "稾" => "Gao", "稿" => "Gao", "穀" => "Gu", "穁" => "Rong", "穂" => "Sui",
    "穃" => "You", "穄" => "Ji", "穅" => "Kang", "穆" => "Mu", "穇" => "Shan", "穈" => "Men",
    "穉" => "Zhi", "穊" => "Ji", "穋" => "Lu", "穌" => "Su", "積" => "Ji", "穎" => "Ying",
    "穏" => "Wen", "穐" => "Qiu", "穑" => "Se", "穓" => "Yi", "穔" => "Huang", "穕" => "Qie",
    "穖" => "Ji", "穗" => "Sui", "穘" => "Xiao", "穙" => "Pu", "穚" => "Jiao", "穛" => "Zhuo",
    "穜" => "Tong", "穝" => "Sai", "穞" => "Lu", "穟" => "Sui", "穠" => "Nong", "穡" => "Se",
    "穢" => "Hui", "穣" => "Rang", "穤" => "Nuo", "穥" => "Yu", "穦" => "Bin", "穧" => "Ji",
    "穨" => "Tui", "穩" => "Wen", "穪" => "Cheng", "穫" => "Huo", "穬" => "Gong", "穭" => "Lu",
    "穮" => "Biao", "穰" => "Rang", "穱" => "Zhuo", "穲" => "Li", "穳" => "Zan", "穴" => "Xue",
    "穵" => "Wa", "究" => "Jiu", "穷" => "Qiong", "穸" => "Xi", "穹" => "Qiong", "空" => "Kong",
    "穻" => "Yu", "穼" => "Sen", "穽" => "Jing", "穾" => "Yao", "穿" => "Chuan", "窀" => "Zhun",
    "突" => "Tu", "窂" => "Lao", "窃" => "Qie", "窄" => "Zhai", "窅" => "Yao", "窆" => "Bian",
    "窇" => "Bao", "窈" => "Yao", "窉" => "Bing", "窊" => "Wa", "窋" => "Zhu", "窌" => "Jiao",
    "窍" => "Qiao", "窎" => "Diao", "窏" => "Wu", "窐" => "Gui", "窑" => "Yao", "窒" => "Zhi",
    "窓" => "Chuang", "窔" => "Yao", "窕" => "Tiao", "窖" => "Jiao", "窗" => "Chuang", "窘" => "Jiong",
    "窙" => "Xiao", "窚" => "Cheng", "窛" => "Kou", "窜" => "Cuan", "窝" => "Wo", "窞" => "Dan",
    "窟" => "Ku", "窠" => "Ke", "窡" => "Zhui", "窢" => "Xu", "窣" => "Su", "窤" => "Guan",
    "窥" => "Kui", "窦" => "Dou", "窨" => "Yin", "窩" => "Wo", "窪" => "Wa", "窫" => "Ya",
    "窬" => "Yu", "窭" => "Ju", "窮" => "Qiong", "窯" => "Yao", "窰" => "Yao", "窱" => "Tiao",
    "窲" => "Chao", "窳" => "Yu", "窴" => "Tian", "窵" => "Diao", "窶" => "Ju", "窷" => "Liao",
    "窸" => "Xi", "窹" => "Wu", "窺" => "Kui", "窻" => "Chuang", "窼" => "Zhao", "窾" => "Kuan",
    "窿" => "Long", "竀" => "Cheng", "竁" => "Cui", "竂" => "Piao", "竃" => "Zao", "竄" => "Cuan",
    "竅" => "Qiao", "竆" => "Qiong", "竇" => "Dou", "竈" => "Zao", "竉" => "Long", "竊" => "Qie",
    "立" => "Li", "竌" => "Chu", "竍" => "Shi", "竎" => "Fou", "竏" => "Qian", "竐" => "Chu",
    "竑" => "Hong", "竒" => "Qi", "竓" => "Qian", "竔" => "Gong", "竕" => "Shi", "竖" => "Shu",
    "竗" => "Miao", "竘" => "Ju", "站" => "Zhan", "竚" => "Zhu", "竛" => "Ling", "竜" => "Long",
    "竝" => "Bing", "竞" => "Jing", "竟" => "Jing", "章" => "Zhang", "竡" => "Yi", "竢" => "Si",
    "竣" => "Jun", "竤" => "Hong", "童" => "Tong", "竦" => "Song", "竧" => "Jing", "竨" => "Diao",
    "竩" => "Yi", "竪" => "Shu", "竫" => "Jing", "竬" => "Qu", "竭" => "Jie", "竮" => "Ping",
    "端" => "Duan", "竰" => "Shao", "竱" => "Zhuan", "竲" => "Ceng", "竳" => "Deng", "竴" => "Cui",
    "竵" => "Huai", "競" => "Jing", "竷" => "Kan", "竸" => "Jing", "竹" => "Zhu", "竺" => "Zhu",
    "竻" => "Le", "竼" => "Peng", "竽" => "Yu", "竾" => "Chi", "竿" => "Gan", "笁" => "Zhu",
    "笂" => "Utsubo", "笃" => "Du", "笄" => "Ji", "笅" => "Xiao", "笆" => "Ba", "笇" => "Suan",
    "笈" => "Ji", "笉" => "Zhen", "笊" => "Zhao", "笋" => "Sun", "笌" => "Ya", "笍" => "Zhui",
    "笎" => "Yuan", "笏" => "Hu", "笐" => "Gang", "笑" => "Xiao", "笒" => "Cen", "笓" => "Pi",
    "笔" => "Bi", "笕" => "Jian", "笖" => "Yi", "笗" => "Dong", "笘" => "Shan", "笙" => "Sheng",
    "笚" => "Xia", "笛" => "Di", "笜" => "Zhu", "笝" => "Na", "笞" => "Chi", "笟" => "Gu",
    "笠" => "Li", "笡" => "Qie", "笢" => "Min", "笣" => "Bao", "笤" => "Tiao", "笥" => "Si",
    "符" => "Fu", "笧" => "Ce", "笨" => "Ben", "笩" => "Pei", "笪" => "Da", "笫" => "Zi",
    "第" => "Di", "笭" => "Ling", "笮" => "Ze", "笯" => "Nu", "笰" => "Fu", "笱" => "Gou",
    "笲" => "Fan", "笳" => "Jia", "笴" => "Ge", "笵" => "Fan", "笶" => "Shi", "笷" => "Mao",
    "笸" => "Po", "笹" => "Sey", "笺" => "Jian", "笻" => "Qiong", "笼" => "Long", "笽" => "Souke",
    "笾" => "Bian", "笿" => "Luo", "筀" => "Gui", "筁" => "Qu", "筂" => "Chi", "筃" => "Yin",
    "筄" => "Yao", "筅" => "Xian", "筆" => "Bi", "筇" => "Qiong", "筈" => "Gua", "等" => "Deng",
    "筊" => "Jiao", "筋" => "Jin", "筌" => "Quan", "筍" => "Sun", "筎" => "Ru", "筏" => "Fa",
    "筐" => "Kuang", "筑" => "Zhu", "筒" => "Tong", "筓" => "Ji", "答" => "Da", "筕" => "Xing",
    "策" => "Ce", "筗" => "Zhong", "筘" => "Kou", "筙" => "Lai", "筚" => "Bi", "筛" => "Shai",
    "筜" => "Dang", "筝" => "Zheng", "筞" => "Ce", "筟" => "Fu", "筠" => "Yun", "筡" => "Tu",
    "筢" => "Pa", "筣" => "Li", "筤" => "Lang", "筥" => "Ju", "筦" => "Guan", "筧" => "Jian",
    "筨" => "Han", "筩" => "Tong", "筪" => "Xia", "筫" => "Zhi", "筬" => "Cheng", "筭" => "Suan",
    "筮" => "Shi", "筯" => "Zhu", "筰" => "Zuo", "筱" => "Xiao", "筲" => "Shao", "筳" => "Ting",
    "筴" => "Ce", "筵" => "Yan", "筶" => "Gao", "筷" => "Kuai", "筸" => "Gan", "筹" => "Chou",
    "筺" => "Kago", "筻" => "Gang", "筼" => "Yun", "筽" => "O", "签" => "Qian", "筿" => "Xiao",
    "简" => "Jian", "箁" => "Pu", "箂" => "Lai", "箃" => "Zou", "箄" => "Bi", "箅" => "Bi",
    "箆" => "Bi", "箇" => "Ge", "箈" => "Chi", "箉" => "Guai", "箊" => "Yu", "箋" => "Jian",
    "箌" => "Zhao", "箍" => "Gu", "箎" => "Chi", "箏" => "Zheng", "箐" => "Jing", "箑" => "Sha",
    "箒" => "Zhou", "箓" => "Lu", "箔" => "Bo", "箕" => "Ji", "箖" => "Lin", "算" => "Suan",
    "箘" => "Jun", "箙" => "Fu", "箚" => "Zha", "箛" => "Gu", "箜" => "Kong", "箝" => "Qian",
    "箞" => "Quan", "箟" => "Jun", "箠" => "Chui", "管" => "Guan", "箢" => "Yuan", "箣" => "Ce",
    "箤" => "Ju", "箥" => "Bo", "箦" => "Ze", "箧" => "Qie", "箨" => "Tuo", "箩" => "Luo",
    "箪" => "Dan", "箫" => "Xiao", "箬" => "Ruo", "箭" => "Jian", "箮" => "Xuan", "箯" => "Bian",
    "箰" => "Sun", "箱" => "Xiang", "箲" => "Xian", "箳" => "Ping", "箴" => "Zhen", "箵" => "Sheng",
    "箶" => "Hu", "箷" => "Shi", "箸" => "Zhu", "箹" => "Yue", "箺" => "Chun", "箻" => "Lu",
    "箼" => "Wu", "箽" => "Dong", "箾" => "Xiao", "箿" => "Ji", "節" => "Jie", "篁" => "Huang",
    "篂" => "Xing", "篃" => "Mei", "範" => "Fan", "篅" => "Chui", "篆" => "Zhuan", "篇" => "Pian",
    "篈" => "Feng", "築" => "Zhu", "篊" => "Hong", "篋" => "Qie", "篌" => "Hou", "篍" => "Qiu",
    "篎" => "Miao", "篏" => "Qian", "篑" => "Kui", "篒" => "Sik", "篓" => "Lou", "篔" => "Yun",
    "篕" => "He", "篖" => "Tang", "篗" => "Yue", "篘" => "Chou", "篙" => "Gao", "篚" => "Fei",
    "篛" => "Ruo", "篜" => "Zheng", "篝" => "Gou", "篞" => "Nie", "篟" => "Qian", "篠" => "Xiao",
    "篡" => "Cuan", "篢" => "Gong", "篣" => "Pang", "篤" => "Du", "篥" => "Li", "篦" => "Bi",
    "篧" => "Zhuo", "篨" => "Chu", "篩" => "Shai", "篪" => "Chi", "篫" => "Zhu", "篬" => "Qiang",
    "篭" => "Long", "篮" => "Lan", "篯" => "Jian", "篰" => "Bu", "篱" => "Li", "篲" => "Hui",
    "篳" => "Bi", "篴" => "Di", "篵" => "Cong", "篶" => "Yan", "篷" => "Peng", "篸" => "Sen",
    "篹" => "Zhuan", "篺" => "Pai", "篻" => "Piao", "篼" => "Dou", "篽" => "Yu", "篾" => "Mie",
    "篿" => "Zhuan", "簁" => "Xi", "簂" => "Guo", "簃" => "Yi", "簄" => "Hu", "簅" => "Chan",
    "簆" => "Kou", "簇" => "Cu", "簈" => "Ping", "簉" => "Chou", "簊" => "Ji", "簋" => "Gui",
    "簌" => "Su", "簍" => "Lou", "簎" => "Zha", "簏" => "Lu", "簐" => "Nian", "簑" => "Suo",
    "簒" => "Cuan", "簓" => "Sasara", "簔" => "Suo", "簕" => "Le", "簖" => "Duan", "簗" => "Yana",
    "簘" => "Xiao", "簙" => "Bo", "簚" => "Mi", "簛" => "Si", "簜" => "Dang", "簝" => "Liao",
    "簞" => "Dan", "簟" => "Dian", "簠" => "Fu", "簡" => "Jian", "簢" => "Min", "簣" => "Kui",
    "簤" => "Dai", "簥" => "Qiao", "簦" => "Deng", "簧" => "Huang", "簨" => "Sun", "簩" => "Lao",
    "簪" => "Zan", "簫" => "Xiao", "簬" => "Du", "簭" => "Shi", "簮" => "Zan", "簰" => "Pai",
    "簱" => "Hata", "簲" => "Pai", "簳" => "Gan", "簴" => "Ju", "簵" => "Du", "簶" => "Lu",
    "簷" => "Yan", "簸" => "Bo", "簹" => "Dang", "簺" => "Sai", "簻" => "Ke", "簼" => "Long",
    "簽" => "Qian", "簾" => "Lian", "簿" => "Bo", "籀" => "Zhou", "籁" => "Lai", "籃" => "Lan",
    "籄" => "Kui", "籅" => "Yu", "籆" => "Yue", "籇" => "Hao", "籈" => "Zhen", "籉" => "Tai",
    "籊" => "Ti", "籋" => "Mi", "籌" => "Chou", "籍" => "Ji", "籏" => "Hata", "籐" => "Teng",
    "籑" => "Zhuan", "籒" => "Zhou", "籓" => "Fan", "籔" => "Sou", "籕" => "Zhou", "籖" => "Kuji",
    "籗" => "Zhuo", "籘" => "Teng", "籙" => "Lu", "籚" => "Lu", "籛" => "Jian", "籜" => "Tuo",
    "籝" => "Ying", "籞" => "Yu", "籟" => "Lai", "籠" => "Long", "籡" => "Shinshi", "籢" => "Lian",
    "籣" => "Lan", "籤" => "Qian", "籥" => "Yue", "籦" => "Zhong", "籧" => "Qu", "籨" => "Lian",
    "籩" => "Bian", "籪" => "Duan", "籫" => "Zuan", "籬" => "Li", "籭" => "Si", "籮" => "Luo",
    "籯" => "Ying", "籰" => "Yue", "籱" => "Zhuo", "籲" => "Xu", "米" => "Mi", "籴" => "Di",
    "籵" => "Fan", "籶" => "Shen", "籷" => "Zhe", "籸" => "Shen", "籹" => "Nu", "籺" => "Xie",
    "类" => "Lei", "籼" => "Xian", "籽" => "Zi", "籾" => "Ni", "籿" => "Cun", "粁" => "Qian",
    "粂" => "Kume", "粃" => "Bi", "粄" => "Ban", "粅" => "Wu", "粆" => "Sha", "粇" => "Kang",
    "粈" => "Rou", "粉" => "Fen", "粊" => "Bi", "粋" => "Cui", "粍" => "Li", "粎" => "Chi",
    "粏" => "Nukamiso", "粐" => "Ro", "粑" => "Ba", "粒" => "Li", "粓" => "Gan", "粔" => "Ju",
    "粕" => "Po", "粖" => "Mo", "粗" => "Cu", "粘" => "Nian", "粙" => "Zhou", "粚" => "Li",
    "粛" => "Su", "粜" => "Tiao", "粝" => "Li", "粞" => "Qi", "粟" => "Su", "粠" => "Hong",
    "粡" => "Tong", "粢" => "Zi", "粣" => "Ce", "粤" => "Yue", "粥" => "Zhou", "粦" => "Lin",
    "粧" => "Zhuang", "粨" => "Bai", "粪" => "Fen", "粫" => "Ji", "粭" => "Sukumo", "粮" => "Liang",
    "粯" => "Xian", "粰" => "Fu", "粱" => "Liang", "粲" => "Can", "粳" => "Geng", "粴" => "Li",
    "粵" => "Yue", "粶" => "Lu", "粷" => "Ju", "粸" => "Qi", "粹" => "Cui", "粺" => "Bai",
    "粻" => "Zhang", "粼" => "Lin", "粽" => "Zong", "精" => "Jing", "粿" => "Guo", "糀" => "Kouji",
    "糁" => "San", "糂" => "San", "糃" => "Tang", "糄" => "Bian", "糅" => "Rou", "糆" => "Mian",
    "糇" => "Hou", "糈" => "Xu", "糉" => "Zong", "糊" => "Hu", "糋" => "Jian", "糌" => "Zan",
    "糍" => "Ci", "糎" => "Li", "糏" => "Xie", "糐" => "Fu", "糑" => "Ni", "糒" => "Bei",
    "糓" => "Gu", "糔" => "Xiu", "糕" => "Gao", "糖" => "Tang", "糗" => "Qiu", "糘" => "Sukumo",
    "糙" => "Cao", "糚" => "Zhuang", "糛" => "Tang", "糜" => "Mi", "糝" => "San", "糞" => "Fen",
    "糟" => "Zao", "糠" => "Kang", "糡" => "Jiang", "糢" => "Mo", "糣" => "San", "糤" => "San",
    "糥" => "Nuo", "糦" => "Xi", "糧" => "Liang", "糨" => "Jiang", "糩" => "Kuai", "糪" => "Bo",
    "糫" => "Huan", "糭" => "Zong", "糮" => "Xian", "糯" => "Nuo", "糰" => "Tuan", "糱" => "Nie",
    "糲" => "Li", "糳" => "Zuo", "糴" => "Di", "糵" => "Nie", "糶" => "Tiao", "糷" => "Lan",
    "糸" => "Mi", "糹" => "Jiao", "糺" => "Jiu", "系" => "Xi", "糼" => "Gong", "糽" => "Zheng",
    "糾" => "Jiu", "糿" => "You", "紁" => "Cha", "紂" => "Zhou", "紃" => "Xun", "約" => "Yue",
    "紅" => "Hong", "紆" => "Yu", "紇" => "He", "紈" => "Wan", "紉" => "Ren", "紊" => "Wen",
    "紋" => "Wen", "紌" => "Qiu", "納" => "Na", "紎" => "Zi", "紏" => "Tou", "紐" => "Niu",
    "紑" => "Fou", "紒" => "Jie", "紓" => "Shu", "純" => "Chun", "紕" => "Pi", "紖" => "Yin",
    "紗" => "Sha", "紘" => "Hong", "紙" => "Zhi", "級" => "Ji", "紛" => "Fen", "紜" => "Yun",
    "紝" => "Ren", "紞" => "Dan", "紟" => "Jin", "素" => "Su", "紡" => "Fang", "索" => "Suo",
    "紣" => "Cui", "紤" => "Jiu", "紥" => "Zha", "紦" => "Kinu", "紧" => "Jin", "紨" => "Fu",
    "紩" => "Zhi", "紪" => "Ci", "紫" => "Zi", "紬" => "Chou", "紭" => "Hong", "紮" => "Zha",
    "累" => "Lei", "細" => "Xi", "紱" => "Fu", "紲" => "Xie", "紳" => "Shen", "紴" => "Bei",
    "紵" => "Zhu", "紶" => "Qu", "紷" => "Ling", "紸" => "Zhu", "紹" => "Shao", "紺" => "Gan",
    "紻" => "Yang", "紼" => "Fu", "紽" => "Tuo", "紾" => "Zhen", "紿" => "Dai", "絀" => "Zhuo",
    "絁" => "Shi", "終" => "Zhong", "絃" => "Xian", "組" => "Zu", "絅" => "Jiong", "絆" => "Ban",
    "絇" => "Ju", "絈" => "Mo", "絉" => "Shu", "絊" => "Zui", "絋" => "Wata", "経" => "Jing",
    "絍" => "Ren", "絎" => "Heng", "絏" => "Xie", "結" => "Jie", "絑" => "Zhu", "絒" => "Chou",
    "絓" => "Gua", "絔" => "Bai", "絕" => "Jue", "絖" => "Kuang", "絗" => "Hu", "絘" => "Ci",
    "絙" => "Geng", "絚" => "Geng", "絛" => "Tao", "絜" => "Xie", "絝" => "Ku", "絞" => "Jiao",
    "絟" => "Quan", "絠" => "Gai", "絡" => "Luo", "絢" => "Xuan", "絣" => "Bing", "絤" => "Xian",
    "絥" => "Fu", "給" => "Gei", "絧" => "Tong", "絨" => "Rong", "絩" => "Tiao", "絪" => "Yin",
    "絫" => "Lei", "絬" => "Xie", "絭" => "Quan", "絮" => "Xu", "絯" => "Lun", "絰" => "Die",
    "統" => "Tong", "絲" => "Si", "絳" => "Jiang", "絴" => "Xiang", "絵" => "Hui", "絶" => "Jue",
    "絷" => "Zhi", "絸" => "Jian", "絹" => "Juan", "絺" => "Chi", "絻" => "Mian", "絼" => "Zhen",
    "絽" => "Lu", "絾" => "Cheng", "絿" => "Qiu", "綀" => "Shu", "綁" => "Bang", "綂" => "Tong",
    "綃" => "Xiao", "綄" => "Wan", "綅" => "Qin", "綆" => "Geng", "綇" => "Xiu", "綈" => "Ti",
    "綉" => "Xiu", "綊" => "Xie", "綋" => "Hong", "綌" => "Xi", "綍" => "Fu", "綎" => "Ting",
    "綏" => "Sui", "綐" => "Dui", "綑" => "Kun", "綒" => "Fu", "經" => "Jing", "綔" => "Hu",
    "綕" => "Zhi", "綖" => "Yan", "綗" => "Jiong", "綘" => "Feng", "継" => "Ji", "続" => "Sok",
    "綛" => "Kase", "綜" => "Zong", "綝" => "Lin", "綞" => "Duo", "綟" => "Li", "綠" => "Lu",
    "綡" => "Liang", "綢" => "Chou", "綣" => "Quan", "綤" => "Shao", "綥" => "Qi", "綦" => "Qi",
    "綧" => "Zhun", "綨" => "Qi", "綩" => "Wan", "綪" => "Qian", "綫" => "Xian", "綬" => "Shou",
    "維" => "Wei", "綮" => "Qi", "綯" => "Tao", "綰" => "Wan", "綱" => "Gang", "網" => "Wang",
    "綳" => "Beng", "綴" => "Zhui", "綵" => "Cai", "綶" => "Guo", "綷" => "Cui", "綸" => "Lun",
    "綹" => "Liu", "綺" => "Qi", "綻" => "Zhan", "綼" => "Bei", "綽" => "Chuo", "綾" => "Ling",
    "綿" => "Mian", "緀" => "Qi", "緁" => "Qie", "緂" => "Tan", "緃" => "Zong", "緄" => "Gun",
    "緅" => "Zou", "緆" => "Yi", "緇" => "Zi", "緈" => "Xing", "緉" => "Liang", "緊" => "Jin",
    "緋" => "Fei", "緌" => "Rui", "緍" => "Min", "緎" => "Yu", "総" => "Zong", "緐" => "Fan",
    "緑" => "Lu", "緒" => "Xu", "緓" => "Yingl", "緔" => "Zhang", "緕" => "Kasuri", "緖" => "Xu",
    "緗" => "Xiang", "緘" => "Jian", "緙" => "Ke", "線" => "Xian", "緛" => "Ruan", "緜" => "Mian",
    "緝" => "Qi", "緞" => "Duan", "緟" => "Zhong", "締" => "Di", "緡" => "Min", "緢" => "Miao",
    "緣" => "Yuan", "緤" => "Xie", "緥" => "Bao", "緦" => "Si", "緧" => "Qiu", "編" => "Bian",
    "緩" => "Huan", "緪" => "Geng", "緫" => "Cong", "緬" => "Mian", "緭" => "Wei", "緮" => "Fu",
    "緯" => "Wei", "緰" => "Yu", "緱" => "Gou", "緲" => "Miao", "緳" => "Xie", "練" => "Lian",
    "緵" => "Zong", "緶" => "Bian", "緷" => "Yun", "緸" => "Yin", "緹" => "Ti", "緺" => "Gua",
    "緻" => "Zhi", "緼" => "Yun", "緽" => "Cheng", "緾" => "Chan", "緿" => "Dai", "縁" => "Yuan",
    "縂" => "Zong", "縃" => "Xu", "縄" => "Nawa", "縅" => "Odoshi", "縆" => "Geng", "縇" => "Sen",
    "縈" => "Ying", "縉" => "Jin", "縊" => "Yi", "縋" => "Zhui", "縌" => "Ni", "縍" => "Bang",
    "縎" => "Gu", "縏" => "Pan", "縐" => "Zhou", "縑" => "Jian", "縒" => "Cuo", "縓" => "Quan",
    "縔" => "Shuang", "縕" => "Yun", "縖" => "Xia", "縗" => "Shuai", "縘" => "Xi", "縙" => "Rong",
    "縚" => "Tao", "縛" => "Fu", "縜" => "Yun", "縝" => "Zhen", "縞" => "Gao", "縟" => "Ru",
    "縠" => "Hu", "縡" => "Zai", "縢" => "Teng", "縣" => "Xian", "縤" => "Su", "縥" => "Zhen",
    "縦" => "Zong", "縧" => "Tao", "縨" => "Horo", "縩" => "Cai", "縪" => "Bi", "縫" => "Feng",
    "縬" => "Cu", "縭" => "Li", "縮" => "Suo", "縯" => "Yin", "縰" => "Xi", "縱" => "Zong",
    "縲" => "Lei", "縳" => "Zhuan", "縴" => "Qian", "縵" => "Man", "縶" => "Zhi", "縷" => "Lu",
    "縸" => "Mo", "縹" => "Piao", "縺" => "Lian", "縻" => "Mi", "縼" => "Xuan", "總" => "Zong",
    "績" => "Ji", "縿" => "Shan", "繀" => "Sui", "繁" => "Fan", "繂" => "Shuai", "繃" => "Beng",
    "繄" => "Yi", "繅" => "Sao", "繆" => "Mou", "繇" => "Zhou", "繈" => "Qiang", "繉" => "Hun",
    "繊" => "Sem", "繋" => "Xi", "繌" => "Jung", "繍" => "Xiu", "繎" => "Ran", "繏" => "Xuan",
    "繐" => "Hui", "繑" => "Qiao", "繒" => "Zeng", "繓" => "Zuo", "織" => "Zhi", "繕" => "Shan",
    "繖" => "San", "繗" => "Lin", "繘" => "Yu", "繙" => "Fan", "繚" => "Liao", "繛" => "Chuo",
    "繜" => "Zun", "繝" => "Jian", "繞" => "Rao", "繟" => "Chan", "繠" => "Rui", "繡" => "Xiu",
    "繢" => "Hui", "繣" => "Hua", "繤" => "Zuan", "繥" => "Xi", "繦" => "Qiang", "繧" => "Un",
    "繨" => "Da", "繩" => "Sheng", "繪" => "Hui", "繫" => "Xi", "繬" => "Se", "繭" => "Jian",
    "繮" => "Jiang", "繯" => "Huan", "繰" => "Zao", "繱" => "Cong", "繲" => "Jie", "繳" => "Jiao",
    "繴" => "Bo", "繵" => "Chan", "繶" => "Yi", "繷" => "Nao", "繸" => "Sui", "繹" => "Yi",
    "繺" => "Shai", "繻" => "Xu", "繼" => "Ji", "繽" => "Bin", "繾" => "Qian", "繿" => "Lan",
    "纀" => "Pu", "纁" => "Xun", "纂" => "Zuan", "纃" => "Qi", "纄" => "Peng", "纅" => "Li",
    "纆" => "Mo", "纇" => "Lei", "纈" => "Xie", "纉" => "Zuan", "纊" => "Kuang", "纋" => "You",
    "續" => "Xu", "纍" => "Lei", "纎" => "Xian", "纏" => "Chan", "纐" => "Kou", "纑" => "Lu",
    "纒" => "Chan", "纓" => "Ying", "纔" => "Cai", "纕" => "Xiang", "纖" => "Xian", "纗" => "Zui",
    "纘" => "Zuan", "纙" => "Luo", "纚" => "Xi", "纛" => "Dao", "纜" => "Lan", "纝" => "Lei",
    "纞" => "Lian", "纟" => "Si", "纠" => "Jiu", "纡" => "Yu", "红" => "Hong", "纣" => "Zhou",
    "纤" => "Xian", "纥" => "He", "约" => "Yue", "级" => "Ji", "纨" => "Wan", "纩" => "Kuang",
    "纪" => "Ji", "纫" => "Ren", "纬" => "Wei", "纭" => "Yun", "纮" => "Hong", "纯" => "Chun",
    "纰" => "Pi", "纱" => "Sha", "纲" => "Gang", "纳" => "Na", "纴" => "Ren", "纵" => "Zong",
    "纶" => "Lun", "纷" => "Fen", "纸" => "Zhi", "纹" => "Wen", "纺" => "Fang", "纻" => "Zhu",
    "纼" => "Yin", "纽" => "Niu", "纾" => "Shu", "线" => "Xian", "绀" => "Gan", "绁" => "Xie",
    "绂" => "Fu", "练" => "Lian", "组" => "Zu", "绅" => "Shen", "细" => "Xi", "织" => "Zhi",
    "终" => "Zhong", "绉" => "Zhou", "绊" => "Ban", "绋" => "Fu", "绌" => "Zhuo", "绍" => "Shao",
    "绎" => "Yi", "经" => "Jing", "绐" => "Dai", "绑" => "Bang", "绒" => "Rong", "结" => "Jie",
    "绔" => "Ku", "绕" => "Rao", "绖" => "Die", "绗" => "Heng", "绘" => "Hui", "给" => "Gei",
    "绚" => "Xuan", "绛" => "Jiang", "络" => "Luo", "绝" => "Jue", "绞" => "Jiao", "统" => "Tong",
    "绠" => "Geng", "绡" => "Xiao", "绢" => "Juan", "绣" => "Xiu", "绤" => "Xi", "绥" => "Sui",
    "绦" => "Tao", "继" => "Ji", "绨" => "Ti", "绩" => "Ji", "绪" => "Xu", "绫" => "Ling",
    "续" => "Xu", "绮" => "Qi", "绯" => "Fei", "绰" => "Chuo", "绱" => "Zhang", "绲" => "Gun",
    "绳" => "Sheng", "维" => "Wei", "绵" => "Mian", "绶" => "Shou", "绷" => "Beng", "绸" => "Chou",
    "绹" => "Tao", "绺" => "Liu", "绻" => "Quan", "综" => "Zong", "绽" => "Zhan", "绾" => "Wan",
    "绿" => "Lu", "缁" => "Zi", "缂" => "Ke", "缃" => "Xiang", "缄" => "Jian", "缅" => "Mian",
    "缆" => "Lan", "缇" => "Ti", "缈" => "Miao", "缉" => "Qi", "缊" => "Yun", "缋" => "Hui",
    "缌" => "Si", "缍" => "Duo", "缎" => "Duan", "缏" => "Bian", "缐" => "Xian", "缑" => "Gou",
    "缒" => "Zhui", "缓" => "Huan", "缔" => "Di", "缕" => "Lu", "编" => "Bian", "缗" => "Min",
    "缘" => "Yuan", "缙" => "Jin", "缚" => "Fu", "缛" => "Ru", "缜" => "Zhen", "缝" => "Feng",
    "缞" => "Shuai", "缟" => "Gao", "缠" => "Chan", "缡" => "Li", "缢" => "Yi", "缣" => "Jian",
    "缤" => "Bin", "缥" => "Piao", "缦" => "Man", "缧" => "Lei", "缨" => "Ying", "缩" => "Suo",
    "缪" => "Mou", "缫" => "Sao", "缬" => "Xie", "缭" => "Liao", "缮" => "Shan", "缯" => "Zeng",
    "缰" => "Jiang", "缱" => "Qian", "缲" => "Zao", "缳" => "Huan", "缴" => "Jiao", "缵" => "Zuan",
    "缶" => "Fou", "缷" => "Xie", "缸" => "Gang", "缹" => "Fou", "缺" => "Que", "缻" => "Fou",
    "缼" => "Kaakeru", "缽" => "Bo", "缾" => "Ping", "缿" => "Hou", "罁" => "Gang", "罂" => "Ying",
    "罃" => "Ying", "罄" => "Qing", "罅" => "Xia", "罆" => "Guan", "罇" => "Zun", "罈" => "Tan",
    "罉" => "Chang", "罊" => "Qi", "罋" => "Weng", "罌" => "Ying", "罍" => "Lei", "罎" => "Tan",
    "罏" => "Lu", "罐" => "Guan", "网" => "Wang", "罒" => "Wang", "罓" => "Gang", "罔" => "Wang",
    "罕" => "Han", "罗" => "Luo", "罘" => "Fu", "罙" => "Mi", "罚" => "Fa", "罛" => "Gu",
    "罜" => "Zhu", "罝" => "Ju", "罞" => "Mao", "罟" => "Gu", "罠" => "Min", "罡" => "Gang",
    "罢" => "Ba", "罣" => "Gua", "罤" => "Ti", "罥" => "Juan", "罦" => "Fu", "罧" => "Lin",
    "罨" => "Yan", "罩" => "Zhao", "罪" => "Zui", "罫" => "Gua", "罬" => "Zhuo", "罭" => "Yu",
    "置" => "Zhi", "罯" => "An", "罰" => "Fa", "罱" => "Nan", "署" => "Shu", "罳" => "Si",
    "罴" => "Pi", "罵" => "Ma", "罶" => "Liu", "罷" => "Ba", "罸" => "Fa", "罹" => "Li",
    "罺" => "Chao", "罻" => "Wei", "罼" => "Bi", "罽" => "Ji", "罾" => "Zeng", "罿" => "Tong",
    "羀" => "Liu", "羁" => "Ji", "羂" => "Juan", "羃" => "Mi", "羄" => "Zhao", "羅" => "Luo",
    "羆" => "Pi", "羇" => "Ji", "羈" => "Ji", "羉" => "Luan", "羊" => "Yang", "羋" => "Mie",
    "羌" => "Qiang", "羍" => "Ta", "美" => "Mei", "羏" => "Yang", "羐" => "You", "羑" => "You",
    "羒" => "Fen", "羓" => "Ba", "羔" => "Gao", "羕" => "Yang", "羖" => "Gu", "羗" => "Qiang",
    "羘" => "Zang", "羙" => "Gao", "羚" => "Ling", "羛" => "Yi", "羜" => "Zhu", "羝" => "Di",
    "羞" => "Xiu", "羟" => "Qian", "羠" => "Yi", "羡" => "Xian", "羢" => "Rong", "羣" => "Qun",
    "群" => "Qun", "羥" => "Qian", "羦" => "Huan", "羧" => "Zui", "羨" => "Xian", "義" => "Yi",
    "羪" => "Yashinau", "羫" => "Qiang", "羬" => "Xian", "羭" => "Yu", "羮" => "Geng", "羯" => "Jie",
    "羰" => "Tang", "羱" => "Yuan", "羲" => "Xi", "羳" => "Fan", "羴" => "Shan", "羵" => "Fen",
    "羶" => "Shan", "羷" => "Lian", "羸" => "Lei", "羹" => "Geng", "羺" => "Nou", "羻" => "Qiang",
    "羼" => "Chan", "羽" => "Yu", "羾" => "Gong", "羿" => "Yi", "翀" => "Chong", "翁" => "Weng",
    "翂" => "Fen", "翃" => "Hong", "翄" => "Chi", "翅" => "Chi", "翆" => "Cui", "翇" => "Fu",
    "翈" => "Xia", "翉" => "Pen", "翊" => "Yi", "翋" => "La", "翌" => "Yi", "翍" => "Pi",
    "翎" => "Ling", "翏" => "Liu", "翐" => "Zhi", "翑" => "Qu", "習" => "Xi", "翓" => "Xie",
    "翔" => "Xiang", "翕" => "Xi", "翖" => "Xi", "翗" => "Qi", "翘" => "Qiao", "翙" => "Hui",
    "翚" => "Hui", "翛" => "Xiao", "翜" => "Se", "翝" => "Hong", "翞" => "Jiang", "翟" => "Di",
    "翠" => "Cui", "翡" => "Fei", "翢" => "Tao", "翣" => "Sha", "翤" => "Chi", "翥" => "Zhu",
    "翦" => "Jian", "翧" => "Xuan", "翨" => "Shi", "翩" => "Pian", "翪" => "Zong", "翫" => "Wan",
    "翬" => "Hui", "翭" => "Hou", "翮" => "He", "翯" => "He", "翰" => "Han", "翱" => "Ao",
    "翲" => "Piao", "翳" => "Yi", "翴" => "Lian", "翵" => "Qu", "翷" => "Lin", "翸" => "Pen",
    "翹" => "Qiao", "翺" => "Ao", "翻" => "Fan", "翼" => "Yi", "翽" => "Hui", "翾" => "Xuan",
    "翿" => "Dao", "老" => "Lao", "考" => "Kao", "耄" => "Mao", "者" => "Zhe", "耆" => "Qi",
    "耇" => "Gou", "耈" => "Gou", "耉" => "Gou", "耊" => "Die", "耋" => "Die", "而" => "Er",
    "耍" => "Shua", "耎" => "Ruan", "耏" => "Er", "耐" => "Nai", "耑" => "Zhuan", "耒" => "Lei",
    "耓" => "Ting", "耔" => "Zi", "耕" => "Geng", "耖" => "Chao", "耗" => "Hao", "耘" => "Yun",
    "耙" => "Pa", "耚" => "Pi", "耛" => "Chi", "耜" => "Si", "耝" => "Chu", "耞" => "Jia",
    "耟" => "Ju", "耠" => "He", "耡" => "Chu", "耢" => "Lao", "耣" => "Lun", "耤" => "Ji",
    "耥" => "Tang", "耦" => "Ou", "耧" => "Lou", "耨" => "Nou", "耩" => "Gou", "耪" => "Pang",
    "耫" => "Ze", "耬" => "Lou", "耭" => "Ji", "耮" => "Lao", "耯" => "Huo", "耰" => "You",
    "耱" => "Mo", "耲" => "Huai", "耳" => "Er", "耴" => "Zhe", "耵" => "Ting", "耶" => "Ye",
    "耷" => "Da", "耸" => "Song", "耹" => "Qin", "耺" => "Yun", "耻" => "Chi", "耼" => "Dan",
    "耽" => "Dan", "耾" => "Hong", "耿" => "Geng", "聀" => "Zhi", "聂" => "Nie", "聃" => "Dan",
    "聄" => "Zhen", "聅" => "Che", "聆" => "Ling", "聇" => "Zheng", "聈" => "You", "聉" => "Wa",
    "聊" => "Liao", "聋" => "Long", "职" => "Zhi", "聍" => "Ning", "聎" => "Tiao", "聏" => "Er",
    "聐" => "Ya", "聑" => "Die", "聒" => "Gua", "联" => "Lian", "聕" => "Hao", "聖" => "Sheng",
    "聗" => "Lie", "聘" => "Pin", "聙" => "Jing", "聚" => "Ju", "聛" => "Bi", "聜" => "Di",
    "聝" => "Guo", "聞" => "Wen", "聟" => "Xu", "聠" => "Ping", "聡" => "Cong", "聢" => "Shikato",
    "聤" => "Ting", "聥" => "Yu", "聦" => "Cong", "聧" => "Kui", "聨" => "Tsuraneru", "聩" => "Kui",
    "聪" => "Cong", "聫" => "Lian", "聬" => "Weng", "聭" => "Kui", "聮" => "Lian", "聯" => "Lian",
    "聰" => "Cong", "聱" => "Ao", "聲" => "Sheng", "聳" => "Song", "聴" => "Ting", "聵" => "Kui",
    "聶" => "Nie", "職" => "Zhi", "聸" => "Dan", "聹" => "Ning", "聺" => "Qie", "聻" => "Ji",
    "聼" => "Ting", "聽" => "Ting", "聾" => "Long", "聿" => "Yu", "肀" => "Yu", "肁" => "Zhao",
    "肂" => "Si", "肃" => "Su", "肄" => "Yi", "肅" => "Su", "肆" => "Si", "肇" => "Zhao",
    "肈" => "Zhao", "肉" => "Rou", "肊" => "Yi", "肋" => "Le", "肌" => "Ji", "肍" => "Qiu",
    "肎" => "Ken", "肏" => "Cao", "肐" => "Ge", "肑" => "Di", "肒" => "Huan", "肓" => "Huang",
    "肔" => "Yi", "肕" => "Ren", "肖" => "Xiao", "肗" => "Ru", "肘" => "Zhou", "肙" => "Yuan",
    "肚" => "Du", "肛" => "Gang", "肜" => "Rong", "肝" => "Gan", "肞" => "Cha", "肟" => "Wo",
    "肠" => "Chang", "股" => "Gu", "肢" => "Zhi", "肣" => "Han", "肤" => "Fu", "肥" => "Fei",
    "肦" => "Fen", "肧" => "Pei", "肨" => "Pang", "肩" => "Jian", "肪" => "Fang", "肫" => "Zhun",
    "肬" => "You", "肭" => "Na", "肮" => "Hang", "肯" => "Ken", "肰" => "Ran", "肱" => "Gong",
    "育" => "Yu", "肳" => "Wen", "肴" => "Yao", "肵" => "Jin", "肶" => "Pi", "肷" => "Qian",
    "肸" => "Xi", "肹" => "Xi", "肺" => "Fei", "肻" => "Ken", "肼" => "Jing", "肽" => "Tai",
    "肾" => "Shen", "肿" => "Zhong", "胀" => "Zhang", "胁" => "Xie", "胂" => "Shen", "胃" => "Wei",
    "胄" => "Zhou", "胅" => "Die", "胆" => "Dan", "胇" => "Fei", "胈" => "Ba", "胉" => "Bo",
    "胊" => "Qu", "胋" => "Tian", "背" => "Bei", "胍" => "Gua", "胎" => "Tai", "胏" => "Zi",
    "胐" => "Ku", "胑" => "Zhi", "胒" => "Ni", "胓" => "Ping", "胔" => "Zi", "胕" => "Fu",
    "胖" => "Pang", "胗" => "Zhen", "胘" => "Xian", "胙" => "Zuo", "胚" => "Pei", "胛" => "Jia",
    "胜" => "Sheng", "胝" => "Zhi", "胞" => "Bao", "胟" => "Mu", "胠" => "Qu", "胡" => "Hu",
    "胢" => "Ke", "胣" => "Yi", "胤" => "Yin", "胥" => "Xu", "胦" => "Yang", "胧" => "Long",
    "胨" => "Dong", "胩" => "Ka", "胪" => "Lu", "胫" => "Jing", "胬" => "Nu", "胭" => "Yan",
    "胮" => "Pang", "胯" => "Kua", "胰" => "Yi", "胱" => "Guang", "胲" => "Gai", "胳" => "Ge",
    "胴" => "Dong", "胵" => "Zhi", "胶" => "Xiao", "胷" => "Xiong", "胸" => "Xiong", "胹" => "Er",
    "胺" => "E", "胻" => "Xing", "胼" => "Pian", "能" => "Neng", "胾" => "Zi", "胿" => "Gui",
    "脁" => "Tiao", "脂" => "Zhi", "脃" => "Cui", "脄" => "Mei", "脅" => "Xie", "脆" => "Cui",
    "脇" => "Xie", "脈" => "Mo", "脉" => "Mai", "脊" => "Ji", "脋" => "Obiyaakasu", "脍" => "Kuai",
    "脎" => "Sa", "脏" => "Zang", "脐" => "Qi", "脑" => "Nao", "脒" => "Mi", "脓" => "Nong",
    "脔" => "Luan", "脕" => "Wan", "脖" => "Bo", "脗" => "Wen", "脘" => "Guan", "脙" => "Qiu",
    "脚" => "Jiao", "脛" => "Jing", "脜" => "Rou", "脝" => "Heng", "脞" => "Cuo", "脟" => "Lie",
    "脠" => "Shan", "脡" => "Ting", "脢" => "Mei", "脣" => "Chun", "脤" => "Shen", "脥" => "Xie",
    "脦" => "De", "脧" => "Zui", "脨" => "Cu", "脩" => "Xiu", "脪" => "Xin", "脫" => "Tuo",
    "脬" => "Pao", "脭" => "Cheng", "脮" => "Nei", "脯" => "Fu", "脰" => "Dou", "脱" => "Tuo",
    "脲" => "Niao", "脳" => "Noy", "脴" => "Pi", "脵" => "Gu", "脶" => "Gua", "脷" => "Li",
    "脸" => "Lian", "脹" => "Zhang", "脺" => "Cui", "脻" => "Jie", "脼" => "Liang", "脽" => "Zhou",
    "脾" => "Pi", "脿" => "Biao", "腀" => "Lun", "腁" => "Pian", "腂" => "Guo", "腃" => "Kui",
    "腄" => "Chui", "腅" => "Dan", "腆" => "Tian", "腇" => "Nei", "腈" => "Jing", "腉" => "Jie",
    "腊" => "La", "腋" => "Yi", "腌" => "An", "腍" => "Ren", "腎" => "Shen", "腏" => "Chuo",
    "腐" => "Fu", "腑" => "Fu", "腒" => "Ju", "腓" => "Fei", "腔" => "Qiang", "腕" => "Wan",
    "腖" => "Dong", "腗" => "Pi", "腘" => "Guo", "腙" => "Zong", "腚" => "Ding", "腛" => "Wu",
    "腜" => "Mei", "腝" => "Ruan", "腞" => "Zhuan", "腟" => "Zhi", "腠" => "Cou", "腡" => "Gua",
    "腢" => "Ou", "腣" => "Di", "腤" => "An", "腥" => "Xing", "腦" => "Nao", "腧" => "Yu",
    "腨" => "Chuan", "腩" => "Nan", "腪" => "Yun", "腫" => "Zhong", "腬" => "Rou", "腭" => "E",
    "腮" => "Sai", "腯" => "Tu", "腰" => "Yao", "腱" => "Jian", "腲" => "Wei", "腳" => "Jiao",
    "腴" => "Yu", "腵" => "Jia", "腶" => "Duan", "腷" => "Bi", "腸" => "Chang", "腹" => "Fu",
    "腺" => "Xian", "腻" => "Ni", "腼" => "Mian", "腽" => "Wa", "腾" => "Teng", "腿" => "Tui",
    "膀" => "Bang", "膁" => "Qian", "膂" => "Lu", "膃" => "Wa", "膄" => "Sou", "膅" => "Tang",
    "膆" => "Su", "膇" => "Zhui", "膈" => "Ge", "膉" => "Yi", "膊" => "Bo", "膋" => "Liao",
    "膌" => "Ji", "膍" => "Pi", "膎" => "Xie", "膏" => "Gao", "膐" => "Lu", "膑" => "Bin",
    "膒" => "Ou", "膓" => "Chang", "膔" => "Lu", "膕" => "Guo", "膖" => "Pang", "膗" => "Chuai",
    "膘" => "Piao", "膙" => "Jiang", "膚" => "Fu", "膛" => "Tang", "膜" => "Mo", "膝" => "Xi",
    "膞" => "Zhuan", "膟" => "Lu", "膠" => "Jiao", "膡" => "Ying", "膢" => "Lu", "膣" => "Zhi",
    "膤" => "Tara", "膥" => "Chun", "膦" => "Lian", "膧" => "Tong", "膨" => "Peng", "膩" => "Ni",
    "膪" => "Zha", "膫" => "Liao", "膬" => "Cui", "膭" => "Gui", "膮" => "Xiao", "膯" => "Teng",
    "膰" => "Fan", "膱" => "Zhi", "膲" => "Jiao", "膳" => "Shan", "膴" => "Wu", "膵" => "Cui",
    "膶" => "Run", "膷" => "Xiang", "膸" => "Sui", "膹" => "Fen", "膺" => "Ying", "膻" => "Tan",
    "膼" => "Zhua", "膽" => "Dan", "膾" => "Kuai", "膿" => "Nong", "臀" => "Tun", "臁" => "Lian",
    "臂" => "Bi", "臃" => "Yong", "臄" => "Jue", "臅" => "Chu", "臆" => "Yi", "臇" => "Juan",
    "臈" => "La", "臉" => "Lian", "臊" => "Sao", "臋" => "Tun", "臌" => "Gu", "臍" => "Qi",
    "臎" => "Cui", "臏" => "Bin", "臐" => "Xun", "臑" => "Ru", "臒" => "Huo", "臓" => "Zang",
    "臔" => "Xian", "臕" => "Biao", "臖" => "Xing", "臗" => "Kuan", "臘" => "La", "臙" => "Yan",
    "臚" => "Lu", "臛" => "Huo", "臜" => "Zang", "臝" => "Luo", "臞" => "Qu", "臟" => "Zang",
    "臠" => "Luan", "臡" => "Ni", "臢" => "Zang", "臣" => "Chen", "臤" => "Qian", "臥" => "Wo",
    "臦" => "Guang", "臧" => "Zang", "臨" => "Lin", "臩" => "Guang", "自" => "Zi", "臫" => "Jiao",
    "臬" => "Nie", "臭" => "Chou", "臮" => "Ji", "臯" => "Gao", "臰" => "Chou", "臱" => "Mian",
    "臲" => "Nie", "至" => "Zhi", "致" => "Zhi", "臵" => "Ge", "臶" => "Jian", "臷" => "Die",
    "臸" => "Zhi", "臹" => "Xiu", "臺" => "Tai", "臻" => "Zhen", "臼" => "Jiu", "臽" => "Xian",
    "臾" => "Yu", "臿" => "Cha", "舁" => "Yu", "舂" => "Chong", "舃" => "Xi", "舄" => "Xi",
    "舅" => "Jiu", "舆" => "Yu", "與" => "Yu", "興" => "Xing", "舉" => "Ju", "舊" => "Jiu",
    "舋" => "Xin", "舌" => "She", "舍" => "She", "舎" => "Yadoru", "舏" => "Jiu", "舐" => "Shi",
    "舑" => "Tan", "舒" => "Shu", "舓" => "Shi", "舔" => "Tian", "舕" => "Dan", "舖" => "Pu",
    "舗" => "Pu", "舘" => "Guan", "舙" => "Hua", "舚" => "Tan", "舛" => "Chuan", "舜" => "Shun",
    "舝" => "Xia", "舞" => "Wu", "舟" => "Zhou", "舠" => "Dao", "舡" => "Gang", "舢" => "Shan",
    "舣" => "Yi", "舥" => "Pa", "舦" => "Tai", "舧" => "Fan", "舨" => "Ban", "舩" => "Chuan",
    "航" => "Hang", "舫" => "Fang", "般" => "Ban", "舭" => "Que", "舮" => "Hesaki", "舯" => "Zhong",
    "舰" => "Jian", "舱" => "Cang", "舲" => "Ling", "舳" => "Zhu", "舴" => "Ze", "舵" => "Duo",
    "舶" => "Bo", "舷" => "Xian", "舸" => "Ge", "船" => "Chuan", "舺" => "Jia", "舻" => "Lu",
    "舼" => "Hong", "舽" => "Pang", "舾" => "Xi", "艀" => "Fu", "艁" => "Zao", "艂" => "Feng",
    "艃" => "Li", "艄" => "Shao", "艅" => "Yu", "艆" => "Lang", "艇" => "Ting", "艉" => "Wei",
    "艊" => "Bo", "艋" => "Meng", "艌" => "Nian", "艍" => "Ju", "艎" => "Huang", "艏" => "Shou",
    "艐" => "Zong", "艑" => "Bian", "艒" => "Mao", "艓" => "Die", "艕" => "Bang", "艖" => "Cha",
    "艗" => "Yi", "艘" => "Sao", "艙" => "Cang", "艚" => "Cao", "艛" => "Lou", "艜" => "Dai",
    "艝" => "Sori", "艞" => "Yao", "艟" => "Tong", "艠" => "Yofune", "艡" => "Dang", "艢" => "Tan",
    "艣" => "Lu", "艤" => "Yi", "艥" => "Jie", "艦" => "Jian", "艧" => "Huo", "艨" => "Meng",
    "艩" => "Qi", "艪" => "Lu", "艫" => "Lu", "艬" => "Chan", "艭" => "Shuang", "艮" => "Gen",
    "良" => "Liang", "艰" => "Jian", "艱" => "Jian", "色" => "Se", "艳" => "Yan", "艴" => "Fu",
    "艵" => "Ping", "艶" => "Yan", "艷" => "Yan", "艸" => "Cao", "艹" => "Cao", "艺" => "Yi",
    "艻" => "Le", "艼" => "Ting", "艽" => "Qiu", "艾" => "Ai", "艿" => "Nai", "芀" => "Tiao",
    "芁" => "Jiao", "节" => "Jie", "芃" => "Peng", "芄" => "Wan", "芅" => "Yi", "芆" => "Chai",
    "芇" => "Mian", "芈" => "Mie", "芉" => "Gan", "芊" => "Qian", "芋" => "Yu", "芌" => "Yu",
    "芍" => "Shuo", "芎" => "Qiong", "芏" => "Tu", "芐" => "Xia", "芑" => "Qi", "芒" => "Mang",
    "芓" => "Zi", "芔" => "Hui", "芕" => "Sui", "芖" => "Zhi", "芗" => "Xiang", "芘" => "Bi",
    "芙" => "Fu", "芚" => "Tun", "芛" => "Wei", "芜" => "Wu", "芝" => "Zhi", "芞" => "Qi",
    "芟" => "Shan", "芠" => "Wen", "芡" => "Qian", "芢" => "Ren", "芣" => "Fou", "芤" => "Kou",
    "芥" => "Jie", "芦" => "Lu", "芧" => "Xu", "芨" => "Ji", "芩" => "Qin", "芪" => "Qi",
    "芫" => "Yuan", "芬" => "Fen", "芭" => "Ba", "芮" => "Rui", "芯" => "Xin", "芰" => "Ji",
    "花" => "Hua", "芲" => "Hua", "芳" => "Fang", "芴" => "Wu", "芵" => "Jue", "芶" => "Gou",
    "芷" => "Zhi", "芸" => "Yun", "芹" => "Qin", "芺" => "Ao", "芻" => "Chu", "芼" => "Mao",
    "芽" => "Ya", "芾" => "Fei", "芿" => "Reng", "苀" => "Hang", "苁" => "Cong", "苂" => "Yin",
    "苃" => "You", "苄" => "Bian", "苅" => "Yi", "苆" => "Susa", "苇" => "Wei", "苈" => "Li",
    "苉" => "Pi", "苊" => "E", "苋" => "Xian", "苌" => "Chang", "苍" => "Cang", "苎" => "Meng",
    "苏" => "Su", "苐" => "Yi", "苑" => "Yuan", "苒" => "Ran", "苓" => "Ling", "苔" => "Tai",
    "苕" => "Tiao", "苖" => "Di", "苗" => "Miao", "苘" => "Qiong", "苙" => "Li", "苚" => "Yong",
    "苛" => "Ke", "苜" => "Mu", "苝" => "Pei", "苞" => "Bao", "苟" => "Gou", "苠" => "Min",
    "苡" => "Yi", "苢" => "Yi", "苣" => "Ju", "苤" => "Pi", "若" => "Ruo", "苦" => "Ku",
    "苧" => "Zhu", "苨" => "Ni", "苩" => "Bo", "苪" => "Bing", "苫" => "Shan", "苬" => "Qiu",
    "苭" => "Yao", "苮" => "Xian", "苯" => "Ben", "苰" => "Hong", "英" => "Ying", "苲" => "Zha",
    "苳" => "Dong", "苴" => "Ju", "苵" => "Die", "苶" => "Nie", "苷" => "Gan", "苸" => "Hu",
    "苹" => "Ping", "苺" => "Mei", "苻" => "Fu", "苼" => "Sheng", "苽" => "Gu", "苾" => "Bi",
    "苿" => "Wei", "茁" => "Zhuo", "茂" => "Mao", "范" => "Fan", "茄" => "Qie", "茅" => "Mao",
    "茆" => "Mao", "茇" => "Ba", "茈" => "Zi", "茉" => "Mo", "茊" => "Zi", "茋" => "Di",
    "茌" => "Chi", "茍" => "Ji", "茎" => "Jing", "茏" => "Long", "茑" => "Niao", "茓" => "Xue",
    "茔" => "Ying", "茕" => "Qiong", "茖" => "Ge", "茗" => "Ming", "茘" => "Li", "茙" => "Rong",
    "茚" => "Yin", "茛" => "Gen", "茜" => "Qian", "茝" => "Chai", "茞" => "Chen", "茟" => "Yu",
    "茠" => "Xiu", "茡" => "Zi", "茢" => "Lie", "茣" => "Wu", "茤" => "Ji", "茥" => "Kui",
    "茦" => "Ce", "茧" => "Chong", "茨" => "Ci", "茩" => "Gou", "茪" => "Guang", "茫" => "Mang",
    "茬" => "Chi", "茭" => "Jiao", "茮" => "Jiao", "茯" => "Fu", "茰" => "Yu", "茱" => "Zhu",
    "茲" => "Zi", "茳" => "Jiang", "茴" => "Hui", "茵" => "Yin", "茶" => "Cha", "茷" => "Fa",
    "茸" => "Rong", "茹" => "Ru", "茺" => "Chong", "茻" => "Mang", "茼" => "Tong", "茽" => "Zhong",
    "茿" => "Zhu", "荀" => "Xun", "荁" => "Huan", "荂" => "Kua", "荃" => "Quan", "荄" => "Gai",
    "荅" => "Da", "荆" => "Jing", "荇" => "Xing", "荈" => "Quan", "草" => "Cao", "荊" => "Jing",
    "荋" => "Er", "荌" => "An", "荍" => "Shou", "荎" => "Chi", "荏" => "Ren", "荐" => "Jian",
    "荑" => "Ti", "荒" => "Huang", "荓" => "Ping", "荔" => "Li", "荕" => "Jin", "荖" => "Lao",
    "荗" => "Shu", "荘" => "Zhuang", "荙" => "Da", "荚" => "Jia", "荛" => "Rao", "荜" => "Bi",
    "荝" => "Ze", "荞" => "Qiao", "荟" => "Hui", "荠" => "Qi", "荡" => "Dang", "荣" => "Rong",
    "荤" => "Hun", "荥" => "Ying", "荦" => "Luo", "荧" => "Ying", "荨" => "Xun", "荩" => "Jin",
    "荪" => "Sun", "荫" => "Yin", "荬" => "Mai", "荭" => "Hong", "荮" => "Zhou", "药" => "Yao",
    "荰" => "Du", "荱" => "Wei", "荲" => "Chu", "荳" => "Dou", "荴" => "Fu", "荵" => "Ren",
    "荶" => "Yin", "荷" => "He", "荸" => "Bi", "荹" => "Bu", "荺" => "Yun", "荻" => "Di",
    "荼" => "Tu", "荽" => "Sui", "荾" => "Sui", "荿" => "Cheng", "莀" => "Chen", "莁" => "Wu",
    "莂" => "Bie", "莃" => "Xi", "莄" => "Geng", "莅" => "Li", "莆" => "Fu", "莇" => "Zhu",
    "莈" => "Mo", "莉" => "Li", "莊" => "Zhuang", "莋" => "Ji", "莌" => "Duo", "莍" => "Qiu",
    "莎" => "Sha", "莏" => "Suo", "莐" => "Chen", "莑" => "Feng", "莒" => "Ju", "莓" => "Mei",
    "莔" => "Meng", "莕" => "Xing", "莖" => "Jing", "莗" => "Che", "莘" => "Xin", "莙" => "Jun",
    "莚" => "Yan", "莛" => "Ting", "莜" => "Diao", "莝" => "Cuo", "莞" => "Wan", "莟" => "Han",
    "莠" => "You", "莡" => "Cuo", "莢" => "Jia", "莣" => "Wang", "莤" => "You", "莥" => "Niu",
    "莦" => "Shao", "莧" => "Xian", "莨" => "Lang", "莩" => "Fu", "莪" => "E", "莫" => "Mo",
    "莬" => "Wen", "莭" => "Jie", "莮" => "Nan", "莯" => "Mu", "莰" => "Kan", "莱" => "Lai",
    "莲" => "Lian", "莳" => "Shi", "莴" => "Wo", "莵" => "Usagi", "莶" => "Lian", "获" => "Huo",
    "莸" => "You", "莹" => "Ying", "莺" => "Ying", "莻" => "Nuc", "莼" => "Chun", "莽" => "Mang",
    "莾" => "Mang", "莿" => "Ci", "菀" => "Wan", "菁" => "Jing", "菂" => "Di", "菃" => "Qu",
    "菄" => "Dong", "菅" => "Jian", "菆" => "Zou", "菇" => "Gu", "菈" => "La", "菉" => "Lu",
    "菊" => "Ju", "菋" => "Wei", "菌" => "Jun", "菍" => "Nie", "菎" => "Kun", "菏" => "He",
    "菐" => "Pu", "菑" => "Zi", "菒" => "Gao", "菓" => "Guo", "菔" => "Fu", "菕" => "Lun",
    "菖" => "Chang", "菗" => "Chou", "菘" => "Song", "菙" => "Chui", "菚" => "Zhan", "菛" => "Men",
    "菜" => "Cai", "菝" => "Ba", "菞" => "Li", "菟" => "Tu", "菠" => "Bo", "菡" => "Han",
    "菢" => "Bao", "菣" => "Qin", "菤" => "Juan", "菥" => "Xi", "菦" => "Qin", "菧" => "Di",
    "菨" => "Jie", "菩" => "Pu", "菪" => "Dang", "菫" => "Jin", "菬" => "Zhao", "菭" => "Tai",
    "菮" => "Geng", "華" => "Hua", "菰" => "Gu", "菱" => "Ling", "菲" => "Fei", "菳" => "Jin",
    "菴" => "An", "菵" => "Wang", "菶" => "Beng", "菷" => "Zhou", "菸" => "Yan", "菹" => "Ju",
    "菺" => "Jian", "菻" => "Lin", "菼" => "Tan", "菽" => "Shu", "菾" => "Tian", "菿" => "Dao",
    "萁" => "Qi", "萂" => "He", "萃" => "Cui", "萄" => "Tao", "萅" => "Chun", "萆" => "Bei",
    "萇" => "Chang", "萈" => "Huan", "萉" => "Fei", "萊" => "Lai", "萋" => "Qi", "萌" => "Meng",
    "萍" => "Ping", "萎" => "Wei", "萏" => "Dan", "萐" => "Sha", "萑" => "Huan", "萒" => "Yan",
    "萓" => "Yi", "萔" => "Tiao", "萕" => "Qi", "萖" => "Wan", "萗" => "Ce", "萘" => "Nai",
    "萙" => "Kutabireru", "萚" => "Tuo", "萛" => "Jiu", "萜" => "Tie", "萝" => "Luo", "萠" => "Meng",
    "萢" => "Yaji", "萤" => "Ying", "营" => "Ying", "萦" => "Ying", "萧" => "Xiao", "萨" => "Sa",
    "萩" => "Qiu", "萪" => "Ke", "萫" => "Xiang", "萬" => "Wan", "萭" => "Yu", "萮" => "Yu",
    "萯" => "Fu", "萰" => "Lian", "萱" => "Xuan", "萲" => "Yuan", "萳" => "Nan", "萴" => "Ze",
    "萵" => "Wo", "萶" => "Chun", "萷" => "Xiao", "萸" => "Yu", "萹" => "Pian", "萺" => "Mao",
    "萻" => "An", "萼" => "E", "落" => "Luo", "萾" => "Ying", "萿" => "Huo", "葀" => "Gua",
    "葁" => "Jiang", "葂" => "Mian", "葃" => "Zuo", "葄" => "Zuo", "葅" => "Ju", "葆" => "Bao",
    "葇" => "Rou", "葈" => "Xi", "葉" => "Xie", "葊" => "An", "葋" => "Qu", "葌" => "Jian",
    "葍" => "Fu", "葎" => "Lu", "葏" => "Jing", "葐" => "Pen", "葑" => "Feng", "葒" => "Hong",
    "葓" => "Hong", "葔" => "Hou", "葕" => "Yan", "葖" => "Tu", "著" => "Zhu", "葘" => "Zi",
    "葙" => "Xiang", "葚" => "Shen", "葛" => "Ge", "葜" => "Jie", "葝" => "Jing", "葞" => "Mi",
    "葟" => "Huang", "葠" => "Shen", "葡" => "Pu", "葢" => "Gai", "董" => "Dong", "葤" => "Zhou",
    "葥" => "Qian", "葦" => "Wei", "葧" => "Bo", "葨" => "Wei", "葩" => "Pa", "葪" => "Ji",
    "葫" => "Hu", "葬" => "Zang", "葭" => "Jia", "葮" => "Duan", "葯" => "Yao", "葰" => "Jun",
    "葱" => "Cong", "葲" => "Quan", "葳" => "Wei", "葴" => "Xian", "葵" => "Kui", "葶" => "Ting",
    "葷" => "Hun", "葸" => "Xi", "葹" => "Shi", "葺" => "Qi", "葻" => "Lan", "葼" => "Zong",
    "葽" => "Yao", "葾" => "Yuan", "葿" => "Mei", "蒀" => "Yun", "蒁" => "Shu", "蒂" => "Di",
    "蒃" => "Zhuan", "蒄" => "Guan", "蒅" => "Sukumo", "蒆" => "Xue", "蒇" => "Chan", "蒈" => "Kai",
    "蒉" => "Kui", "蒋" => "Jiang", "蒌" => "Lou", "蒍" => "Wei", "蒎" => "Pai", "蒐" => "Sou",
    "蒑" => "Yin", "蒒" => "Shi", "蒓" => "Chun", "蒔" => "Shi", "蒕" => "Yun", "蒖" => "Zhen",
    "蒗" => "Lang", "蒘" => "Nu", "蒙" => "Meng", "蒚" => "He", "蒛" => "Que", "蒜" => "Suan",
    "蒝" => "Yuan", "蒞" => "Li", "蒟" => "Ju", "蒠" => "Xi", "蒡" => "Pang", "蒢" => "Chu",
    "蒣" => "Xu", "蒤" => "Tu", "蒥" => "Liu", "蒦" => "Wo", "蒧" => "Zhen", "蒨" => "Qian",
    "蒩" => "Zu", "蒪" => "Po", "蒫" => "Cuo", "蒬" => "Yuan", "蒭" => "Chu", "蒮" => "Yu",
    "蒯" => "Kuai", "蒰" => "Pan", "蒱" => "Pu", "蒲" => "Pu", "蒳" => "Na", "蒴" => "Shuo",
    "蒵" => "Xi", "蒶" => "Fen", "蒷" => "Yun", "蒸" => "Zheng", "蒹" => "Jian", "蒺" => "Ji",
    "蒻" => "Ruo", "蒼" => "Cang", "蒽" => "En", "蒾" => "Mi", "蒿" => "Hao", "蓀" => "Sun",
    "蓁" => "Zhen", "蓂" => "Ming", "蓃" => "Sou", "蓄" => "Xu", "蓅" => "Liu", "蓆" => "Xi",
    "蓇" => "Gu", "蓈" => "Lang", "蓉" => "Rong", "蓊" => "Weng", "蓋" => "Gai", "蓌" => "Cuo",
    "蓍" => "Shi", "蓎" => "Tang", "蓏" => "Luo", "蓐" => "Ru", "蓑" => "Suo", "蓒" => "Xian",
    "蓓" => "Bei", "蓔" => "Yao", "蓕" => "Gui", "蓖" => "Bi", "蓗" => "Zong", "蓘" => "Gun",
    "蓙" => "Za", "蓚" => "Xiu", "蓛" => "Ce", "蓜" => "Hai", "蓝" => "Lan", "蓟" => "Ji",
    "蓠" => "Li", "蓡" => "Can", "蓢" => "Lang", "蓣" => "Yu", "蓥" => "Ying", "蓦" => "Mo",
    "蓧" => "Diao", "蓨" => "Tiao", "蓩" => "Mao", "蓪" => "Tong", "蓫" => "Zhu", "蓬" => "Peng",
    "蓭" => "An", "蓮" => "Lian", "蓯" => "Cong", "蓰" => "Xi", "蓱" => "Ping", "蓲" => "Qiu",
    "蓳" => "Jin", "蓴" => "Chun", "蓵" => "Jie", "蓶" => "Wei", "蓷" => "Tui", "蓸" => "Cao",
    "蓹" => "Yu", "蓺" => "Yi", "蓻" => "Ji", "蓼" => "Liao", "蓽" => "Bi", "蓾" => "Lu",
    "蓿" => "Su", "蔁" => "Zhang", "蔂" => "Luo", "蔃" => "Jiang", "蔄" => "Man", "蔅" => "Yan",
    "蔆" => "Ling", "蔇" => "Ji", "蔈" => "Piao", "蔉" => "Gun", "蔊" => "Han", "蔋" => "Di",
    "蔌" => "Su", "蔍" => "Lu", "蔎" => "She", "蔏" => "Shang", "蔐" => "Di", "蔑" => "Mie",
    "蔒" => "Xun", "蔓" => "Man", "蔔" => "Bo", "蔕" => "Di", "蔖" => "Cuo", "蔗" => "Zhe",
    "蔘" => "Sen", "蔙" => "Xuan", "蔚" => "Wei", "蔛" => "Hu", "蔜" => "Ao", "蔝" => "Mi",
    "蔞" => "Lou", "蔟" => "Cu", "蔠" => "Zhong", "蔡" => "Cai", "蔢" => "Po", "蔣" => "Jiang",
    "蔤" => "Mi", "蔥" => "Cong", "蔦" => "Niao", "蔧" => "Hui", "蔨" => "Jun", "蔩" => "Yin",
    "蔪" => "Jian", "蔫" => "Yan", "蔬" => "Shu", "蔭" => "Yin", "蔮" => "Kui", "蔯" => "Chen",
    "蔰" => "Hu", "蔱" => "Sha", "蔲" => "Kou", "蔳" => "Qian", "蔴" => "Ma", "蔵" => "Zang",
    "蔶" => "Sonoko", "蔷" => "Qiang", "蔸" => "Dou", "蔹" => "Lian", "蔺" => "Lin", "蔻" => "Kou",
    "蔼" => "Ai", "蔽" => "Bi", "蔾" => "Li", "蔿" => "Wei", "蕀" => "Ji", "蕁" => "Xun",
    "蕂" => "Sheng", "蕃" => "Fan", "蕄" => "Meng", "蕅" => "Ou", "蕆" => "Chan", "蕇" => "Dian",
    "蕈" => "Xun", "蕉" => "Jiao", "蕊" => "Rui", "蕋" => "Rui", "蕌" => "Lei", "蕍" => "Yu",
    "蕎" => "Qiao", "蕏" => "Chu", "蕐" => "Hua", "蕑" => "Jian", "蕒" => "Mai", "蕓" => "Yun",
    "蕔" => "Bao", "蕕" => "You", "蕖" => "Qu", "蕗" => "Lu", "蕘" => "Rao", "蕙" => "Hui",
    "蕚" => "E", "蕛" => "Teng", "蕜" => "Fei", "蕝" => "Jue", "蕞" => "Zui", "蕟" => "Fa",
    "蕠" => "Ru", "蕡" => "Fen", "蕢" => "Kui", "蕣" => "Shun", "蕤" => "Rui", "蕥" => "Ya",
    "蕦" => "Xu", "蕧" => "Fu", "蕨" => "Jue", "蕩" => "Dang", "蕪" => "Wu", "蕫" => "Tong",
    "蕬" => "Si", "蕭" => "Xiao", "蕮" => "Xi", "蕯" => "Long", "蕰" => "Yun", "蕲" => "Qi",
    "蕳" => "Jian", "蕴" => "Yun", "蕵" => "Sun", "蕶" => "Ling", "蕷" => "Yu", "蕸" => "Xia",
    "蕹" => "Yong", "蕺" => "Ji", "蕻" => "Hong", "蕼" => "Si", "蕽" => "Nong", "蕾" => "Lei",
    "蕿" => "Xuan", "薀" => "Yun", "薁" => "Yu", "薂" => "Xi", "薃" => "Hao", "薄" => "Bo",
    "薅" => "Hao", "薆" => "Ai", "薇" => "Wei", "薈" => "Hui", "薉" => "Wei", "薊" => "Ji",
    "薋" => "Ci", "薌" => "Xiang", "薍" => "Luan", "薎" => "Mie", "薏" => "Yi", "薐" => "Leng",
    "薑" => "Jiang", "薒" => "Can", "薓" => "Shen", "薔" => "Qiang", "薕" => "Lian", "薖" => "Ke",
    "薗" => "Yuan", "薘" => "Da", "薙" => "Ti", "薚" => "Tang", "薛" => "Xie", "薜" => "Bi",
    "薝" => "Zhan", "薞" => "Sun", "薟" => "Lian", "薠" => "Fan", "薡" => "Ding", "薢" => "Jie",
    "薣" => "Gu", "薤" => "Xie", "薥" => "Shu", "薦" => "Jian", "薧" => "Kao", "薨" => "Hong",
    "薩" => "Sa", "薪" => "Xin", "薫" => "Xun", "薬" => "Yao", "薭" => "Hie", "薮" => "Sou",
    "薯" => "Shu", "薰" => "Xun", "薱" => "Dui", "薲" => "Pin", "薳" => "Wei", "薴" => "Neng",
    "薵" => "Chou", "薶" => "Mai", "薷" => "Ru", "薸" => "Piao", "薹" => "Tai", "薺" => "Qi",
    "薻" => "Zao", "薼" => "Chen", "薽" => "Zhen", "薾" => "Er", "薿" => "Ni", "藀" => "Ying",
    "藁" => "Gao", "藂" => "Cong", "藃" => "Xiao", "藄" => "Qi", "藅" => "Fa", "藆" => "Jian",
    "藇" => "Xu", "藈" => "Kui", "藉" => "Jie", "藊" => "Bian", "藋" => "Diao", "藌" => "Mi",
    "藍" => "Lan", "藎" => "Jin", "藏" => "Cang", "藐" => "Miao", "藑" => "Qiong", "藒" => "Qie",
    "藓" => "Xian", "藕" => "Ou", "藖" => "Xian", "藗" => "Su", "藘" => "Lu", "藙" => "Yi",
    "藚" => "Xu", "藛" => "Xie", "藜" => "Li", "藝" => "Yi", "藞" => "La", "藟" => "Lei",
    "藠" => "Xiao", "藡" => "Di", "藢" => "Zhi", "藣" => "Bei", "藤" => "Teng", "藥" => "Yao",
    "藦" => "Mo", "藧" => "Huan", "藨" => "Piao", "藩" => "Fan", "藪" => "Sou", "藫" => "Tan",
    "藬" => "Tui", "藭" => "Qiong", "藮" => "Qiao", "藯" => "Wei", "藰" => "Liu", "藱" => "Hui",
    "藳" => "Gao", "藴" => "Yun", "藶" => "Li", "藷" => "Shu", "藸" => "Chu", "藹" => "Ai",
    "藺" => "Lin", "藻" => "Zao", "藼" => "Xuan", "藽" => "Chen", "藾" => "Lai", "藿" => "Huo",
    "蘁" => "Wu", "蘂" => "Rui", "蘃" => "Rui", "蘄" => "Qi", "蘅" => "Heng", "蘆" => "Lu",
    "蘇" => "Su", "蘈" => "Tui", "蘉" => "Mang", "蘊" => "Yun", "蘋" => "Pin", "蘌" => "Yu",
    "蘍" => "Xun", "蘎" => "Ji", "蘏" => "Jiong", "蘐" => "Xian", "蘑" => "Mo", "蘒" => "Hagi",
    "蘓" => "Su", "蘔" => "Jiong", "蘖" => "Nie", "蘗" => "Bo", "蘘" => "Rang", "蘙" => "Yi",
    "蘚" => "Xian", "蘛" => "Yu", "蘜" => "Ju", "蘝" => "Lian", "蘞" => "Lian", "蘟" => "Yin",
    "蘠" => "Qiang", "蘡" => "Ying", "蘢" => "Long", "蘣" => "Tong", "蘤" => "Wei", "蘥" => "Yue",
    "蘦" => "Ling", "蘧" => "Qu", "蘨" => "Yao", "蘩" => "Fan", "蘪" => "Mi", "蘫" => "Lan",
    "蘬" => "Kui", "蘭" => "Lan", "蘮" => "Ji", "蘯" => "Dang", "蘰" => "Katsura", "蘱" => "Lei",
    "蘲" => "Lei", "蘳" => "Hua", "蘴" => "Feng", "蘵" => "Zhi", "蘶" => "Wei", "蘷" => "Kui",
    "蘸" => "Zhan", "蘹" => "Huai", "蘺" => "Li", "蘻" => "Ji", "蘼" => "Mi", "蘽" => "Lei",
    "蘾" => "Huai", "蘿" => "Luo", "虀" => "Ji", "虁" => "Kui", "虂" => "Lu", "虃" => "Jian",
    "虄" => "San", "虆" => "Lei", "虇" => "Quan", "虈" => "Xiao", "虉" => "Yi", "虊" => "Luan",
    "虋" => "Men", "虌" => "Bie", "虍" => "Hu", "虎" => "Hu", "虏" => "Lu", "虐" => "Nue",
    "虑" => "Lu", "虒" => "Si", "虓" => "Xiao", "虔" => "Qian", "處" => "Chu", "虖" => "Hu",
    "虗" => "Xu", "虘" => "Cuo", "虙" => "Fu", "虚" => "Xu", "虛" => "Xu", "虜" => "Lu",
    "虝" => "Hu", "虞" => "Yu", "號" => "Hao", "虠" => "Jiao", "虡" => "Ju", "虢" => "Guo",
    "虣" => "Bao", "虤" => "Yan", "虥" => "Zhan", "虦" => "Zhan", "虧" => "Kui", "虨" => "Ban",
    "虩" => "Xi", "虪" => "Shu", "虫" => "Chong", "虬" => "Qiu", "虭" => "Diao", "虮" => "Ji",
    "虯" => "Qiu", "虰" => "Cheng", "虱" => "Shi", "虳" => "Di", "虴" => "Zhe", "虵" => "She",
    "虶" => "Yu", "虷" => "Gan", "虸" => "Zi", "虹" => "Hong", "虺" => "Hui", "虻" => "Meng",
    "虼" => "Ge", "虽" => "Sui", "虾" => "Xia", "虿" => "Chai", "蚀" => "Shi", "蚁" => "Yi",
    "蚂" => "Ma", "蚃" => "Xiang", "蚄" => "Fang", "蚅" => "E", "蚆" => "Pa", "蚇" => "Chi",
    "蚈" => "Qian", "蚉" => "Wen", "蚊" => "Wen", "蚋" => "Rui", "蚌" => "Bang", "蚍" => "Bi",
    "蚎" => "Yue", "蚏" => "Yue", "蚐" => "Jun", "蚑" => "Qi", "蚒" => "Ran", "蚓" => "Yin",
    "蚔" => "Qi", "蚕" => "Tian", "蚖" => "Yuan", "蚗" => "Jue", "蚘" => "Hui", "蚙" => "Qin",
    "蚚" => "Qi", "蚛" => "Zhong", "蚜" => "Ya", "蚝" => "Ci", "蚞" => "Mu", "蚟" => "Wang",
    "蚠" => "Fen", "蚡" => "Fen", "蚢" => "Hang", "蚣" => "Gong", "蚤" => "Zao", "蚥" => "Fu",
    "蚦" => "Ran", "蚧" => "Jie", "蚨" => "Fu", "蚩" => "Chi", "蚪" => "Dou", "蚫" => "Piao",
    "蚬" => "Xian", "蚭" => "Ni", "蚮" => "Te", "蚯" => "Qiu", "蚰" => "You", "蚱" => "Zha",
    "蚲" => "Ping", "蚳" => "Chi", "蚴" => "You", "蚵" => "He", "蚶" => "Han", "蚷" => "Ju",
    "蚸" => "Li", "蚹" => "Fu", "蚺" => "Ran", "蚻" => "Zha", "蚼" => "Gou", "蚽" => "Pi",
    "蚾" => "Bo", "蚿" => "Xian", "蛀" => "Zhu", "蛁" => "Diao", "蛂" => "Bie", "蛃" => "Bing",
    "蛄" => "Gu", "蛅" => "Ran", "蛆" => "Qu", "蛇" => "She", "蛈" => "Tie", "蛉" => "Ling",
    "蛊" => "Gu", "蛋" => "Dan", "蛌" => "Gu", "蛍" => "Ying", "蛎" => "Li", "蛏" => "Cheng",
    "蛐" => "Qu", "蛑" => "Mou", "蛒" => "Ge", "蛓" => "Ci", "蛔" => "Hui", "蛕" => "Hui",
    "蛖" => "Mang", "蛗" => "Fu", "蛘" => "Yang", "蛙" => "Wa", "蛚" => "Lie", "蛛" => "Zhu",
    "蛜" => "Yi", "蛝" => "Xian", "蛞" => "Kuo", "蛟" => "Jiao", "蛠" => "Li", "蛡" => "Yi",
    "蛢" => "Ping", "蛣" => "Ji", "蛤" => "Ha", "蛥" => "She", "蛦" => "Yi", "蛧" => "Wang",
    "蛨" => "Mo", "蛩" => "Qiong", "蛪" => "Qie", "蛫" => "Gui", "蛬" => "Gong", "蛭" => "Zhi",
    "蛮" => "Man", "蛯" => "Ebi", "蛰" => "Zhi", "蛱" => "Jia", "蛲" => "Rao", "蛳" => "Si",
    "蛴" => "Qi", "蛵" => "Xing", "蛶" => "Lie", "蛷" => "Qiu", "蛸" => "Shao", "蛹" => "Yong",
    "蛺" => "Jia", "蛻" => "Shui", "蛼" => "Che", "蛽" => "Bai", "蛾" => "E", "蛿" => "Han",
    "蜁" => "Xuan", "蜂" => "Feng", "蜃" => "Shen", "蜄" => "Zhen", "蜅" => "Fu", "蜆" => "Xian",
    "蜇" => "Zhe", "蜈" => "Wu", "蜉" => "Fu", "蜊" => "Li", "蜋" => "Lang", "蜌" => "Bi",
    "蜍" => "Chu", "蜎" => "Yuan", "蜏" => "You", "蜐" => "Jie", "蜑" => "Dan", "蜒" => "Yan",
    "蜓" => "Ting", "蜔" => "Dian", "蜕" => "Shui", "蜖" => "Hui", "蜗" => "Gua", "蜘" => "Zhi",
    "蜙" => "Song", "蜚" => "Fei", "蜛" => "Ju", "蜜" => "Mi", "蜝" => "Qi", "蜞" => "Qi",
    "蜟" => "Yu", "蜠" => "Jun", "蜡" => "Zha", "蜢" => "Meng", "蜣" => "Qiang", "蜤" => "Si",
    "蜥" => "Xi", "蜦" => "Lun", "蜧" => "Li", "蜨" => "Die", "蜩" => "Tiao", "蜪" => "Tao",
    "蜫" => "Kun", "蜬" => "Gan", "蜭" => "Han", "蜮" => "Yu", "蜯" => "Bang", "蜰" => "Fei",
    "蜱" => "Pi", "蜲" => "Wei", "蜳" => "Dun", "蜴" => "Yi", "蜵" => "Yuan", "蜶" => "Su",
    "蜷" => "Quan", "蜸" => "Qian", "蜹" => "Rui", "蜺" => "Ni", "蜻" => "Qing", "蜼" => "Wei",
    "蜽" => "Liang", "蜾" => "Guo", "蜿" => "Wan", "蝀" => "Dong", "蝁" => "E", "蝂" => "Ban",
    "蝃" => "Di", "蝄" => "Wang", "蝅" => "Can", "蝆" => "Yang", "蝇" => "Ying", "蝈" => "Guo",
    "蝉" => "Chan", "蝋" => "La", "蝌" => "Ke", "蝍" => "Ji", "蝎" => "He", "蝏" => "Ting",
    "蝐" => "Mai", "蝑" => "Xu", "蝒" => "Mian", "蝓" => "Yu", "蝔" => "Jie", "蝕" => "Shi",
    "蝖" => "Xuan", "蝗" => "Huang", "蝘" => "Yan", "蝙" => "Bian", "蝚" => "Rou", "蝛" => "Wei",
    "蝜" => "Fu", "蝝" => "Yuan", "蝞" => "Mei", "蝟" => "Wei", "蝠" => "Fu", "蝡" => "Ruan",
    "蝢" => "Xie", "蝣" => "You", "蝤" => "Qiu", "蝥" => "Mao", "蝦" => "Xia", "蝧" => "Ying",
    "蝨" => "Shi", "蝩" => "Chong", "蝪" => "Tang", "蝫" => "Zhu", "蝬" => "Zong", "蝭" => "Ti",
    "蝮" => "Fu", "蝯" => "Yuan", "蝰" => "Hui", "蝱" => "Meng", "蝲" => "La", "蝳" => "Du",
    "蝴" => "Hu", "蝵" => "Qiu", "蝶" => "Die", "蝷" => "Li", "蝸" => "Gua", "蝹" => "Yun",
    "蝺" => "Ju", "蝻" => "Nan", "蝼" => "Lou", "蝽" => "Qun", "蝾" => "Rong", "蝿" => "Ying",
    "螀" => "Jiang", "螂" => "Lang", "螃" => "Pang", "螄" => "Si", "螅" => "Xi", "螆" => "Ci",
    "螇" => "Xi", "螈" => "Yuan", "螉" => "Weng", "螊" => "Lian", "螋" => "Sou", "螌" => "Ban",
    "融" => "Rong", "螎" => "Rong", "螏" => "Ji", "螐" => "Wu", "螑" => "Qiu", "螒" => "Han",
    "螓" => "Qin", "螔" => "Yi", "螕" => "Bi", "螖" => "Hua", "螗" => "Tang", "螘" => "Yi",
    "螙" => "Du", "螚" => "Nai", "螛" => "He", "螜" => "Hu", "螝" => "Hui", "螞" => "Ma",
    "螟" => "Ming", "螠" => "Yi", "螡" => "Wen", "螢" => "Ying", "螣" => "Teng", "螤" => "Yu",
    "螥" => "Cang", "螦" => "So", "螧" => "Ebi", "螨" => "Man", "螪" => "Shang", "螫" => "Zhe",
    "螬" => "Cao", "螭" => "Chi", "螮" => "Di", "螯" => "Ao", "螰" => "Lu", "螱" => "Wei",
    "螲" => "Zhi", "螳" => "Tang", "螴" => "Chen", "螵" => "Piao", "螶" => "Qu", "螷" => "Pi",
    "螸" => "Yu", "螹" => "Jian", "螺" => "Luo", "螻" => "Lou", "螼" => "Qin", "螽" => "Zhong",
    "螾" => "Yin", "螿" => "Jiang", "蟀" => "Shuai", "蟁" => "Wen", "蟂" => "Jiao", "蟃" => "Wan",
    "蟄" => "Zhi", "蟅" => "Zhe", "蟆" => "Ma", "蟇" => "Ma", "蟈" => "Guo", "蟉" => "Liu",
    "蟊" => "Mao", "蟋" => "Xi", "蟌" => "Cong", "蟍" => "Li", "蟎" => "Man", "蟏" => "Xiao",
    "蟐" => "Kamakiri", "蟑" => "Zhang", "蟒" => "Mang", "蟓" => "Xiang", "蟔" => "Mo", "蟕" => "Zui",
    "蟖" => "Si", "蟗" => "Qiu", "蟘" => "Te", "蟙" => "Zhi", "蟚" => "Peng", "蟛" => "Peng",
    "蟜" => "Jiao", "蟝" => "Qu", "蟞" => "Bie", "蟟" => "Liao", "蟠" => "Pan", "蟡" => "Gui",
    "蟢" => "Xi", "蟣" => "Ji", "蟤" => "Zhuan", "蟥" => "Huang", "蟦" => "Fei", "蟧" => "Lao",
    "蟨" => "Jue", "蟩" => "Jue", "蟪" => "Hui", "蟫" => "Yin", "蟬" => "Chan", "蟭" => "Jiao",
    "蟮" => "Shan", "蟯" => "Rao", "蟰" => "Xiao", "蟱" => "Mou", "蟲" => "Chong", "蟳" => "Xun",
    "蟴" => "Si", "蟶" => "Cheng", "蟷" => "Dang", "蟸" => "Li", "蟹" => "Xie", "蟺" => "Shan",
    "蟻" => "Yi", "蟼" => "Jing", "蟽" => "Da", "蟾" => "Chan", "蟿" => "Qi", "蠁" => "Xiang",
    "蠂" => "She", "蠃" => "Luo", "蠄" => "Qin", "蠅" => "Ying", "蠆" => "Chai", "蠇" => "Li",
    "蠈" => "Ze", "蠉" => "Xuan", "蠊" => "Lian", "蠋" => "Zhu", "蠌" => "Ze", "蠍" => "Xie",
    "蠎" => "Mang", "蠏" => "Xie", "蠐" => "Qi", "蠑" => "Rong", "蠒" => "Jian", "蠓" => "Meng",
    "蠔" => "Hao", "蠕" => "Ruan", "蠖" => "Huo", "蠗" => "Zhuo", "蠘" => "Jie", "蠙" => "Bin",
    "蠚" => "He", "蠛" => "Mie", "蠜" => "Fan", "蠝" => "Lei", "蠞" => "Jie", "蠟" => "La",
    "蠠" => "Mi", "蠡" => "Li", "蠢" => "Chun", "蠣" => "Li", "蠤" => "Qiu", "蠥" => "Nie",
    "蠦" => "Lu", "蠧" => "Du", "蠨" => "Xiao", "蠩" => "Zhu", "蠪" => "Long", "蠫" => "Li",
    "蠬" => "Long", "蠭" => "Feng", "蠮" => "Ye", "蠯" => "Beng", "蠰" => "Shang", "蠱" => "Gu",
    "蠲" => "Juan", "蠳" => "Ying", "蠵" => "Xi", "蠶" => "Can", "蠷" => "Qu", "蠸" => "Quan",
    "蠹" => "Du", "蠺" => "Can", "蠻" => "Man", "蠼" => "Jue", "蠽" => "Jie", "蠾" => "Zhu",
    "蠿" => "Zha", "血" => "Xie", "衁" => "Huang", "衂" => "Niu", "衃" => "Pei", "衄" => "Nu",
    "衅" => "Xin", "衆" => "Zhong", "衇" => "Mo", "衈" => "Er", "衉" => "Ke", "衊" => "Mie",
    "衋" => "Xi", "行" => "Xing", "衍" => "Yan", "衎" => "Kan", "衏" => "Yuan", "衑" => "Ling",
    "衒" => "Xuan", "術" => "Shu", "衔" => "Xian", "衕" => "Tong", "衖" => "Long", "街" => "Jie",
    "衘" => "Xian", "衙" => "Ya", "衚" => "Hu", "衛" => "Wei", "衜" => "Dao", "衝" => "Chong",
    "衞" => "Wei", "衟" => "Dao", "衠" => "Zhun", "衡" => "Heng", "衢" => "Qu", "衣" => "Yi",
    "衤" => "Yi", "补" => "Bu", "衦" => "Gan", "衧" => "Yu", "表" => "Biao", "衩" => "Cha",
    "衪" => "Yi", "衫" => "Shan", "衬" => "Chen", "衭" => "Fu", "衮" => "Gun", "衯" => "Fen",
    "衰" => "Shuai", "衱" => "Jie", "衲" => "Na", "衳" => "Zhong", "衴" => "Dan", "衵" => "Ri",
    "衶" => "Zhong", "衷" => "Zhong", "衸" => "Xie", "衹" => "Qi", "衺" => "Xie", "衻" => "Ran",
    "衼" => "Zhi", "衽" => "Ren", "衾" => "Qin", "衿" => "Jin", "袀" => "Jun", "袁" => "Yuan",
    "袂" => "Mei", "袃" => "Chai", "袄" => "Ao", "袅" => "Niao", "袆" => "Hui", "袇" => "Ran",
    "袈" => "Jia", "袉" => "Tuo", "袊" => "Ling", "袋" => "Dai", "袌" => "Bao", "袍" => "Pao",
    "袎" => "Yao", "袏" => "Zuo", "袐" => "Bi", "袑" => "Shao", "袒" => "Tan", "袓" => "Ju",
    "袔" => "He", "袕" => "Shu", "袖" => "Xiu", "袗" => "Zhen", "袘" => "Yi", "袙" => "Pa",
    "袚" => "Bo", "袛" => "Di", "袜" => "Wa", "袝" => "Fu", "袞" => "Gun", "袟" => "Zhi",
    "袠" => "Zhi", "袡" => "Ran", "袢" => "Pan", "袣" => "Yi", "袤" => "Mao", "袥" => "Tuo",
    "袦" => "Na", "袧" => "Kou", "袨" => "Xian", "袩" => "Chan", "袪" => "Qu", "被" => "Bei",
    "袬" => "Gun", "袭" => "Xi", "袮" => "Ne", "袯" => "Bo", "袰" => "Horo", "袱" => "Fu",
    "袲" => "Yi", "袳" => "Chi", "袴" => "Ku", "袵" => "Ren", "袶" => "Jiang", "袷" => "Jia",
    "袸" => "Cun", "袹" => "Mo", "袺" => "Jie", "袻" => "Er", "袼" => "Luo", "袽" => "Ru",
    "袾" => "Zhu", "袿" => "Gui", "裀" => "Yin", "裁" => "Cai", "裂" => "Lie", "裃" => "Kamishimo",
    "裄" => "Yuki", "装" => "Zhuang", "裆" => "Dang", "裈" => "Kun", "裉" => "Ken", "裊" => "Niao",
    "裋" => "Shu", "裌" => "Jia", "裍" => "Kun", "裎" => "Cheng", "裏" => "Li", "裐" => "Juan",
    "裑" => "Shen", "裒" => "Pou", "裓" => "Ge", "裔" => "Yi", "裕" => "Yu", "裖" => "Zhen",
    "裗" => "Liu", "裘" => "Qiu", "裙" => "Qun", "裚" => "Ji", "裛" => "Yi", "補" => "Bu",
    "裝" => "Zhuang", "裞" => "Shui", "裟" => "Sha", "裠" => "Qun", "裡" => "Li", "裢" => "Lian",
    "裣" => "Lian", "裤" => "Ku", "裥" => "Jian", "裦" => "Fou", "裧" => "Chan", "裨" => "Bi",
    "裩" => "Gun", "裪" => "Tao", "裫" => "Yuan", "裬" => "Ling", "裭" => "Chi", "裮" => "Chang",
    "裯" => "Chou", "裰" => "Duo", "裱" => "Biao", "裲" => "Liang", "裳" => "Chang", "裴" => "Pei",
    "裵" => "Pei", "裶" => "Fei", "裷" => "Yuan", "裸" => "Luo", "裹" => "Guo", "裺" => "Yan",
    "裻" => "Du", "裼" => "Xi", "製" => "Zhi", "裾" => "Ju", "裿" => "Qi", "褁" => "Zhi",
    "褂" => "Gua", "褃" => "Ken", "褄" => "Che", "褅" => "Ti", "褆" => "Ti", "複" => "Fu",
    "褈" => "Chong", "褉" => "Xie", "褊" => "Bian", "褋" => "Die", "褌" => "Kun", "褍" => "Duan",
    "褎" => "Xiu", "褏" => "Xiu", "褐" => "He", "褑" => "Yuan", "褒" => "Bao", "褓" => "Bao",
    "褔" => "Fu", "褕" => "Yu", "褖" => "Tuan", "褗" => "Yan", "褘" => "Hui", "褙" => "Bei",
    "褚" => "Chu", "褛" => "Lu", "褜" => "Ena", "褝" => "Hitoe", "褞" => "Yun", "褟" => "Da",
    "褠" => "Gou", "褡" => "Da", "褢" => "Huai", "褣" => "Rong", "褤" => "Yuan", "褥" => "Ru",
    "褦" => "Nai", "褧" => "Jiong", "褨" => "Suo", "褩" => "Ban", "褪" => "Tun", "褫" => "Chi",
    "褬" => "Sang", "褭" => "Niao", "褮" => "Ying", "褯" => "Jie", "褰" => "Qian", "褱" => "Huai",
    "褲" => "Ku", "褳" => "Lian", "褴" => "Bao", "褵" => "Li", "褶" => "Zhe", "褷" => "Shi",
    "褸" => "Lu", "褹" => "Yi", "褺" => "Die", "褻" => "Xie", "褼" => "Xian", "褽" => "Wei",
    "褾" => "Biao", "褿" => "Cao", "襀" => "Ji", "襁" => "Jiang", "襂" => "Sen", "襃" => "Bao",
    "襄" => "Xiang", "襅" => "Chihaya", "襆" => "Pu", "襇" => "Jian", "襈" => "Zhuan", "襉" => "Jian",
    "襊" => "Zui", "襋" => "Ji", "襌" => "Dan", "襍" => "Za", "襎" => "Fan", "襏" => "Bo",
    "襐" => "Xiang", "襑" => "Xin", "襒" => "Bie", "襓" => "Rao", "襔" => "Man", "襕" => "Lan",
    "襖" => "Ao", "襗" => "Duo", "襘" => "Gui", "襙" => "Cao", "襚" => "Sui", "襛" => "Nong",
    "襜" => "Chan", "襝" => "Lian", "襞" => "Bi", "襟" => "Jin", "襠" => "Dang", "襡" => "Shu",
    "襢" => "Tan", "襣" => "Bi", "襤" => "Lan", "襥" => "Pu", "襦" => "Ru", "襧" => "Zhi",
    "襩" => "Shu", "襪" => "Wa", "襫" => "Shi", "襬" => "Bai", "襭" => "Xie", "襮" => "Bo",
    "襯" => "Chen", "襰" => "Lai", "襱" => "Long", "襲" => "Xi", "襳" => "Xian", "襴" => "Lan",
    "襵" => "Zhe", "襶" => "Dai", "襷" => "Tasuki", "襸" => "Zan", "襹" => "Shi", "襺" => "Jian",
    "襻" => "Pan", "襼" => "Yi", "襽" => "Ran", "襾" => "Ya", "西" => "Xi", "覀" => "Xi",
    "要" => "Yao", "覂" => "Feng", "覃" => "Tan", "覅" => "Biao", "覆" => "Fu", "覇" => "Ba",
    "覈" => "He", "覉" => "Ji", "覊" => "Ji", "見" => "Jian", "覌" => "Guan", "覍" => "Bian",
    "覎" => "Yan", "規" => "Gui", "覐" => "Jue", "覑" => "Pian", "覒" => "Mao", "覓" => "Mi",
    "覔" => "Mi", "覕" => "Mie", "視" => "Shi", "覗" => "Si", "覘" => "Zhan", "覙" => "Luo",
    "覚" => "Jue", "覛" => "Mi", "覜" => "Tiao", "覝" => "Lian", "覞" => "Yao", "覟" => "Zhi",
    "覠" => "Jun", "覡" => "Xi", "覢" => "Shan", "覣" => "Wei", "覤" => "Xi", "覥" => "Tian",
    "覦" => "Yu", "覧" => "Lan", "覨" => "E", "覩" => "Du", "親" => "Qin", "覫" => "Pang",
    "覬" => "Ji", "覭" => "Ming", "覮" => "Ying", "覯" => "Gou", "覰" => "Qu", "覱" => "Zhan",
    "覲" => "Jin", "観" => "Guan", "覴" => "Deng", "覵" => "Jian", "覶" => "Luo", "覷" => "Qu",
    "覸" => "Jian", "覹" => "Wei", "覺" => "Jue", "覻" => "Qu", "覼" => "Luo", "覽" => "Lan",
    "覾" => "Shen", "覿" => "Di", "觀" => "Guan", "见" => "Jian", "观" => "Guan", "觃" => "Yan",
    "规" => "Gui", "觅" => "Mi", "视" => "Shi", "觇" => "Zhan", "览" => "Lan", "觉" => "Jue",
    "觊" => "Ji", "觋" => "Xi", "觌" => "Di", "觍" => "Tian", "觎" => "Yu", "觏" => "Gou",
    "觐" => "Jin", "觑" => "Qu", "角" => "Jiao", "觓" => "Jiu", "觔" => "Jin", "觕" => "Cu",
    "觖" => "Jue", "觗" => "Zhi", "觘" => "Chao", "觙" => "Ji", "觚" => "Gu", "觛" => "Dan",
    "觜" => "Zui", "觝" => "Di", "觞" => "Shang", "觟" => "Hua", "觠" => "Quan", "觡" => "Ge",
    "觢" => "Chi", "解" => "Jie", "觤" => "Gui", "觥" => "Gong", "触" => "Hong", "觧" => "Jie",
    "觨" => "Hun", "觩" => "Qiu", "觪" => "Xing", "觫" => "Su", "觬" => "Ni", "觭" => "Ji",
    "觮" => "Lu", "觯" => "Zhi", "觰" => "Zha", "觱" => "Bi", "觲" => "Xing", "觳" => "Hu",
    "觴" => "Shang", "觵" => "Gong", "觶" => "Zhi", "觷" => "Xue", "觸" => "Chu", "觹" => "Xi",
    "觺" => "Yi", "觻" => "Lu", "觼" => "Jue", "觽" => "Xi", "觾" => "Yan", "觿" => "Xi",
    "訁" => "Yan", "訂" => "Ding", "訃" => "Fu", "訄" => "Qiu", "訅" => "Qiu", "訆" => "Jiao",
    "訇" => "Hong", "計" => "Ji", "訉" => "Fan", "訊" => "Xun", "訋" => "Diao", "訌" => "Hong",
    "訍" => "Cha", "討" => "Tao", "訏" => "Xu", "訐" => "Jie", "訑" => "Yi", "訒" => "Ren",
    "訓" => "Xun", "訔" => "Yin", "訕" => "Shan", "訖" => "Qi", "託" => "Tuo", "記" => "Ji",
    "訙" => "Xun", "訚" => "Yin", "訛" => "E", "訜" => "Fen", "訝" => "Ya", "訞" => "Yao",
    "訟" => "Song", "訠" => "Shen", "訡" => "Yin", "訢" => "Xin", "訣" => "Jue", "訤" => "Xiao",
    "訥" => "Ne", "訦" => "Chen", "訧" => "You", "訨" => "Zhi", "訩" => "Xiong", "訪" => "Fang",
    "訫" => "Xin", "訬" => "Chao", "設" => "She", "訮" => "Xian", "訯" => "Sha", "訰" => "Tun",
    "許" => "Xu", "訲" => "Yi", "訳" => "Yi", "訴" => "Su", "訵" => "Chi", "訶" => "He",
    "訷" => "Shen", "訸" => "He", "訹" => "Xu", "診" => "Zhen", "註" => "Zhu", "証" => "Zheng",
    "訽" => "Gou", "訾" => "Zi", "訿" => "Zi", "詀" => "Zhan", "詁" => "Gu", "詂" => "Fu",
    "詃" => "Quan", "詄" => "Die", "詅" => "Ling", "詆" => "Di", "詇" => "Yang", "詈" => "Li",
    "詉" => "Nao", "詊" => "Pan", "詋" => "Zhou", "詌" => "Gan", "詍" => "Yi", "詎" => "Ju",
    "詏" => "Ao", "詐" => "Zha", "詑" => "Tuo", "詒" => "Yi", "詓" => "Qu", "詔" => "Zhao",
    "評" => "Ping", "詖" => "Bi", "詗" => "Xiong", "詘" => "Qu", "詙" => "Ba", "詚" => "Da",
    "詛" => "Zu", "詜" => "Tao", "詝" => "Zhu", "詞" => "Ci", "詟" => "Zhe", "詠" => "Yong",
    "詡" => "Xu", "詢" => "Xun", "詣" => "Yi", "詤" => "Huang", "詥" => "He", "試" => "Shi",
    "詧" => "Cha", "詨" => "Jiao", "詩" => "Shi", "詪" => "Hen", "詫" => "Cha", "詬" => "Gou",
    "詭" => "Gui", "詮" => "Quan", "詯" => "Hui", "詰" => "Jie", "話" => "Hua", "該" => "Gai",
    "詳" => "Xiang", "詴" => "Wei", "詵" => "Shen", "詶" => "Chou", "詷" => "Tong", "詸" => "Mi",
    "詹" => "Zhan", "詺" => "Ming", "詻" => "E", "詼" => "Hui", "詽" => "Yan", "詾" => "Xiong",
    "詿" => "Gua", "誀" => "Er", "誁" => "Beng", "誂" => "Tiao", "誃" => "Chi", "誄" => "Lei",
    "誅" => "Zhu", "誆" => "Kuang", "誇" => "Kua", "誈" => "Wu", "誉" => "Yu", "誊" => "Teng",
    "誋" => "Ji", "誌" => "Zhi", "認" => "Ren", "誎" => "Su", "誏" => "Lang", "誐" => "E",
    "誑" => "Kuang", "誒" => "E", "誓" => "Shi", "誔" => "Ting", "誕" => "Dan", "誖" => "Bo",
    "誗" => "Chan", "誘" => "You", "誙" => "Heng", "誚" => "Qiao", "誛" => "Qin", "誜" => "Shua",
    "誝" => "An", "語" => "Yu", "誟" => "Xiao", "誠" => "Cheng", "誡" => "Jie", "誢" => "Xian",
    "誣" => "Wu", "誤" => "Wu", "誥" => "Gao", "誦" => "Song", "誧" => "Pu", "誨" => "Hui",
    "誩" => "Jing", "說" => "Shuo", "誫" => "Zhen", "説" => "Shuo", "読" => "Du", "誮" => "Yasashi",
    "誯" => "Chang", "誰" => "Shui", "誱" => "Jie", "課" => "Ke", "誳" => "Qu", "誴" => "Cong",
    "誵" => "Xiao", "誶" => "Sui", "誷" => "Wang", "誸" => "Xuan", "誹" => "Fei", "誺" => "Chi",
    "誻" => "Ta", "誼" => "Yi", "誽" => "Na", "誾" => "Yin", "調" => "Diao", "諀" => "Pi",
    "諁" => "Chuo", "諂" => "Chan", "諃" => "Chen", "諄" => "Zhun", "諅" => "Ji", "諆" => "Qi",
    "談" => "Tan", "諈" => "Zhui", "諉" => "Wei", "諊" => "Ju", "請" => "Qing", "諌" => "Jian",
    "諍" => "Zheng", "諎" => "Ze", "諏" => "Zou", "諐" => "Qian", "諑" => "Zhuo", "諒" => "Liang",
    "諓" => "Jian", "諔" => "Zhu", "諕" => "Hao", "論" => "Lun", "諗" => "Shen", "諘" => "Biao",
    "諙" => "Huai", "諚" => "Pian", "諛" => "Yu", "諜" => "Die", "諝" => "Xu", "諞" => "Pian",
    "諟" => "Shi", "諠" => "Xuan", "諡" => "Shi", "諢" => "Hun", "諣" => "Hua", "諤" => "E",
    "諥" => "Zhong", "諦" => "Di", "諧" => "Xie", "諨" => "Fu", "諩" => "Pu", "諪" => "Ting",
    "諫" => "Jian", "諬" => "Qi", "諭" => "Yu", "諮" => "Zi", "諯" => "Chuan", "諰" => "Xi",
    "諱" => "Hui", "諲" => "Yin", "諳" => "An", "諴" => "Xian", "諵" => "Nan", "諶" => "Chen",
    "諷" => "Feng", "諸" => "Zhu", "諹" => "Yang", "諺" => "Yan", "諻" => "Heng", "諼" => "Xuan",
    "諽" => "Ge", "諾" => "Nuo", "諿" => "Qi", "謁" => "Ye", "謂" => "Wei", "謄" => "Teng",
    "謅" => "Zou", "謆" => "Shan", "謇" => "Jian", "謈" => "Bo", "謉" => "Ku", "謊" => "Huang",
    "謋" => "Huo", "謌" => "Ge", "謍" => "Ying", "謎" => "Mi", "謏" => "Xiao", "謐" => "Mi",
    "謑" => "Xi", "謒" => "Qiang", "謓" => "Chen", "謔" => "Nue", "謕" => "Ti", "謖" => "Su",
    "謗" => "Bang", "謘" => "Chi", "謙" => "Qian", "謚" => "Shi", "講" => "Jiang", "謜" => "Yuan",
    "謝" => "Xie", "謞" => "Xue", "謟" => "Tao", "謠" => "Yao", "謡" => "Yao", "謣" => "Yu",
    "謤" => "Biao", "謥" => "Cong", "謦" => "Qing", "謧" => "Li", "謨" => "Mo", "謩" => "Mo",
    "謪" => "Shang", "謫" => "Zhe", "謬" => "Miu", "謭" => "Jian", "謮" => "Ze", "謯" => "Jie",
    "謰" => "Lian", "謱" => "Lou", "謲" => "Can", "謳" => "Ou", "謴" => "Guan", "謵" => "Xi",
    "謶" => "Zhuo", "謷" => "Ao", "謸" => "Ao", "謹" => "Jin", "謺" => "Zhe", "謻" => "Yi",
    "謼" => "Hu", "謽" => "Jiang", "謾" => "Man", "謿" => "Chao", "譀" => "Han", "譁" => "Hua",
    "譂" => "Chan", "譃" => "Xu", "譄" => "Zeng", "譅" => "Se", "譆" => "Xi", "譇" => "She",
    "譈" => "Dui", "證" => "Zheng", "譊" => "Nao", "譋" => "Lan", "譌" => "E", "譍" => "Ying",
    "譎" => "Jue", "譏" => "Ji", "譐" => "Zun", "譑" => "Jiao", "譒" => "Bo", "譓" => "Hui",
    "譔" => "Zhuan", "譕" => "Mu", "譖" => "Zen", "譗" => "Zha", "識" => "Shi", "譙" => "Qiao",
    "譚" => "Tan", "譛" => "Zen", "譜" => "Pu", "譝" => "Sheng", "譞" => "Xuan", "譟" => "Zao",
    "譠" => "Tan", "譡" => "Dang", "譢" => "Sui", "譣" => "Qian", "譤" => "Ji", "譥" => "Jiao",
    "警" => "Jing", "譧" => "Lian", "譨" => "Nou", "譩" => "Yi", "譪" => "Ai", "譫" => "Zhan",
    "譬" => "Pi", "譭" => "Hui", "譮" => "Hua", "譯" => "Yi", "議" => "Yi", "譱" => "Shan",
    "譲" => "Rang", "譳" => "Nou", "譴" => "Qian", "譵" => "Zhui", "譶" => "Ta", "護" => "Hu",
    "譸" => "Zhou", "譹" => "Hao", "譺" => "Ye", "譻" => "Ying", "譼" => "Jian", "譽" => "Yu",
    "譾" => "Jian", "譿" => "Hui", "讀" => "Du", "讁" => "Zhe", "讂" => "Xuan", "讃" => "Zan",
    "讄" => "Lei", "讅" => "Shen", "讆" => "Wei", "讇" => "Chan", "讈" => "Li", "讉" => "Yi",
    "變" => "Bian", "讋" => "Zhe", "讌" => "Yan", "讍" => "E", "讎" => "Chou", "讏" => "Wei",
    "讐" => "Chou", "讑" => "Yao", "讒" => "Chan", "讓" => "Rang", "讔" => "Yin", "讕" => "Lan",
    "讖" => "Chen", "讗" => "Huo", "讘" => "Zhe", "讙" => "Huan", "讚" => "Zan", "讛" => "Yi",
    "讜" => "Dang", "讝" => "Zhan", "讞" => "Yan", "讟" => "Du", "讠" => "Yan", "计" => "Ji",
    "订" => "Ding", "讣" => "Fu", "认" => "Ren", "讥" => "Ji", "讦" => "Jie", "讧" => "Hong",
    "讨" => "Tao", "让" => "Rang", "讪" => "Shan", "讫" => "Qi", "讬" => "Tuo", "训" => "Xun",
    "议" => "Yi", "讯" => "Xun", "记" => "Ji", "讱" => "Ren", "讲" => "Jiang", "讳" => "Hui",
    "讴" => "Ou", "讵" => "Ju", "讶" => "Ya", "讷" => "Ne", "许" => "Xu", "讹" => "E",
    "论" => "Lun", "讻" => "Xiong", "讼" => "Song", "讽" => "Feng", "设" => "She", "访" => "Fang",
    "诀" => "Jue", "证" => "Zheng", "诂" => "Gu", "诃" => "He", "评" => "Ping", "诅" => "Zu",
    "识" => "Shi", "诇" => "Xiong", "诈" => "Zha", "诉" => "Su", "诊" => "Zhen", "诋" => "Di",
    "诌" => "Zou", "词" => "Ci", "诎" => "Qu", "诏" => "Zhao", "诐" => "Bi", "译" => "Yi",
    "诒" => "Yi", "诓" => "Kuang", "诔" => "Lei", "试" => "Shi", "诖" => "Gua", "诗" => "Shi",
    "诘" => "Jie", "诙" => "Hui", "诚" => "Cheng", "诛" => "Zhu", "诜" => "Shen", "话" => "Hua",
    "诞" => "Dan", "诟" => "Gou", "诠" => "Quan", "诡" => "Gui", "询" => "Xun", "诣" => "Yi",
    "诤" => "Zheng", "该" => "Gai", "详" => "Xiang", "诧" => "Cha", "诨" => "Hun", "诩" => "Xu",
    "诪" => "Zhou", "诫" => "Jie", "诬" => "Wu", "语" => "Yu", "诮" => "Qiao", "误" => "Wu",
    "诰" => "Gao", "诱" => "You", "诲" => "Hui", "诳" => "Kuang", "说" => "Shuo", "诵" => "Song",
    "诶" => "Ai", "请" => "Qing", "诸" => "Zhu", "诹" => "Zou", "诺" => "Nuo", "读" => "Du",
    "诼" => "Zhuo", "诽" => "Fei", "课" => "Ke", "诿" => "Wei", "谁" => "Shui", "谂" => "Shen",
    "调" => "Diao", "谄" => "Chan", "谅" => "Liang", "谆" => "Zhun", "谇" => "Sui", "谈" => "Tan",
    "谉" => "Shen", "谊" => "Yi", "谋" => "Mou", "谌" => "Chen", "谍" => "Die", "谎" => "Huang",
    "谏" => "Jian", "谐" => "Xie", "谑" => "Nue", "谒" => "Ye", "谓" => "Wei", "谔" => "E",
    "谕" => "Yu", "谖" => "Xuan", "谗" => "Chan", "谘" => "Zi", "谙" => "An", "谚" => "Yan",
    "谛" => "Di", "谜" => "Mi", "谝" => "Pian", "谞" => "Xu", "谟" => "Mo", "谠" => "Dang",
    "谡" => "Su", "谢" => "Xie", "谣" => "Yao", "谤" => "Bang", "谥" => "Shi", "谦" => "Qian",
    "谧" => "Mi", "谨" => "Jin", "谩" => "Man", "谪" => "Zhe", "谫" => "Jian", "谬" => "Miu",
    "谭" => "Tan", "谮" => "Zen", "谯" => "Qiao", "谰" => "Lan", "谱" => "Pu", "谲" => "Jue",
    "谳" => "Yan", "谴" => "Qian", "谵" => "Zhan", "谶" => "Chen", "谷" => "Gu", "谸" => "Qian",
    "谹" => "Hong", "谺" => "Xia", "谻" => "Jue", "谼" => "Hong", "谽" => "Han", "谾" => "Hong",
    "谿" => "Xi", "豀" => "Xi", "豁" => "Huo", "豂" => "Liao", "豃" => "Han", "豄" => "Du",
    "豅" => "Long", "豆" => "Dou", "豇" => "Jiang", "豈" => "Qi", "豉" => "Shi", "豊" => "Li",
    "豋" => "Deng", "豌" => "Wan", "豍" => "Bi", "豎" => "Shu", "豏" => "Xian", "豐" => "Feng",
    "豑" => "Zhi", "豒" => "Zhi", "豓" => "Yan", "豔" => "Yan", "豕" => "Shi", "豖" => "Chu",
    "豗" => "Hui", "豘" => "Tun", "豙" => "Yi", "豚" => "Tun", "豛" => "Yi", "豜" => "Jian",
    "豝" => "Ba", "豞" => "Hou", "豟" => "E", "豠" => "Cu", "象" => "Xiang", "豢" => "Huan",
    "豣" => "Jian", "豤" => "Ken", "豥" => "Gai", "豦" => "Qu", "豧" => "Fu", "豨" => "Xi",
    "豩" => "Bin", "豪" => "Hao", "豫" => "Yu", "豬" => "Zhu", "豭" => "Jia", "豯" => "Xi",
    "豰" => "Bo", "豱" => "Wen", "豲" => "Huan", "豳" => "Bin", "豴" => "Di", "豵" => "Zong",
    "豶" => "Fen", "豷" => "Yi", "豸" => "Zhi", "豹" => "Bao", "豺" => "Chai", "豻" => "Han",
    "豼" => "Pi", "豽" => "Na", "豾" => "Pi", "豿" => "Gou", "貀" => "Na", "貁" => "You",
    "貂" => "Diao", "貃" => "Mo", "貄" => "Si", "貅" => "Xiu", "貆" => "Huan", "貇" => "Kun",
    "貈" => "He", "貉" => "He", "貊" => "Mo", "貋" => "Han", "貌" => "Mao", "貍" => "Li",
    "貎" => "Ni", "貏" => "Bi", "貐" => "Yu", "貑" => "Jia", "貒" => "Tuan", "貓" => "Mao",
    "貔" => "Pi", "貕" => "Xi", "貖" => "E", "貗" => "Ju", "貘" => "Mo", "貙" => "Chu",
    "貚" => "Tan", "貛" => "Huan", "貜" => "Jue", "貝" => "Bei", "貞" => "Zhen", "貟" => "Yuan",
    "負" => "Fu", "財" => "Cai", "貢" => "Gong", "貣" => "Te", "貤" => "Yi", "貥" => "Hang",
    "貦" => "Wan", "貧" => "Pin", "貨" => "Huo", "販" => "Fan", "貪" => "Tan", "貫" => "Guan",
    "責" => "Ze", "貭" => "Zhi", "貮" => "Er", "貯" => "Zhu", "貰" => "Shi", "貱" => "Bi",
    "貲" => "Zi", "貳" => "Er", "貴" => "Gui", "貵" => "Pian", "貶" => "Bian", "買" => "Mai",
    "貸" => "Dai", "貹" => "Sheng", "貺" => "Kuang", "費" => "Fei", "貼" => "Tie", "貽" => "Yi",
    "貾" => "Chi", "貿" => "Mao", "賀" => "He", "賁" => "Bi", "賂" => "Lu", "賃" => "Ren",
    "賄" => "Hui", "賅" => "Gai", "賆" => "Pian", "資" => "Zi", "賈" => "Jia", "賉" => "Xu",
    "賊" => "Zei", "賋" => "Jiao", "賌" => "Gai", "賍" => "Zang", "賎" => "Jian", "賏" => "Ying",
    "賐" => "Xun", "賑" => "Zhen", "賒" => "She", "賓" => "Bin", "賔" => "Bin", "賕" => "Qiu",
    "賖" => "She", "賗" => "Chuan", "賘" => "Zang", "賙" => "Zhou", "賚" => "Lai", "賛" => "Zan",
    "賜" => "Si", "賝" => "Chen", "賞" => "Shang", "賟" => "Tian", "賠" => "Pei", "賡" => "Geng",
    "賢" => "Xian", "賣" => "Mai", "賤" => "Jian", "賥" => "Sui", "賦" => "Fu", "賧" => "Tan",
    "賨" => "Cong", "賩" => "Cong", "質" => "Zhi", "賫" => "Ji", "賬" => "Zhang", "賭" => "Du",
    "賮" => "Jin", "賯" => "Xiong", "賰" => "Shun", "賱" => "Yun", "賲" => "Bao", "賳" => "Zai",
    "賴" => "Lai", "賵" => "Feng", "賶" => "Cang", "賷" => "Ji", "賸" => "Sheng", "賹" => "Ai",
    "賺" => "Zhuan", "賻" => "Fu", "購" => "Gou", "賽" => "Sai", "賾" => "Ze", "賿" => "Liao",
    "贁" => "Bai", "贂" => "Chen", "贃" => "Zhuan", "贄" => "Zhi", "贅" => "Zhui", "贆" => "Biao",
    "贇" => "Yun", "贈" => "Zeng", "贉" => "Tan", "贊" => "Zan", "贋" => "Yan", "贍" => "Shan",
    "贎" => "Wan", "贏" => "Ying", "贐" => "Jin", "贑" => "Gan", "贒" => "Xian", "贓" => "Zang",
    "贔" => "Bi", "贕" => "Du", "贖" => "Shu", "贗" => "Yan", "贙" => "Xuan", "贚" => "Long",
    "贛" => "Gan", "贜" => "Zang", "贝" => "Bei", "贞" => "Zhen", "负" => "Fu", "贠" => "Yuan",
    "贡" => "Gong", "财" => "Cai", "责" => "Ze", "贤" => "Xian", "败" => "Bai", "账" => "Zhang",
    "货" => "Huo", "质" => "Zhi", "贩" => "Fan", "贪" => "Tan", "贫" => "Pin", "贬" => "Bian",
    "购" => "Gou", "贮" => "Zhu", "贯" => "Guan", "贰" => "Er", "贱" => "Jian", "贲" => "Bi",
    "贳" => "Shi", "贴" => "Tie", "贵" => "Gui", "贶" => "Kuang", "贷" => "Dai", "贸" => "Mao",
    "费" => "Fei", "贺" => "He", "贻" => "Yi", "贼" => "Zei", "贽" => "Zhi", "贾" => "Jia",
    "贿" => "Hui", "赀" => "Zi", "赁" => "Ren", "赂" => "Lu", "赃" => "Zang", "资" => "Zi",
    "赅" => "Gai", "赆" => "Jin", "赇" => "Qiu", "赈" => "Zhen", "赉" => "Lai", "赊" => "She",
    "赋" => "Fu", "赌" => "Du", "赍" => "Ji", "赎" => "Shu", "赏" => "Shang", "赐" => "Si",
    "赑" => "Bi", "赒" => "Zhou", "赓" => "Geng", "赔" => "Pei", "赕" => "Tan", "赖" => "Lai",
    "赗" => "Feng", "赘" => "Zhui", "赙" => "Fu", "赚" => "Zhuan", "赛" => "Sai", "赜" => "Ze",
    "赝" => "Yan", "赞" => "Zan", "赟" => "Yun", "赠" => "Zeng", "赡" => "Shan", "赢" => "Ying",
    "赣" => "Gan", "赤" => "Chi", "赥" => "Xi", "赦" => "She", "赧" => "Nan", "赨" => "Xiong",
    "赩" => "Xi", "赪" => "Cheng", "赫" => "He", "赬" => "Cheng", "赭" => "Zhe", "赮" => "Xia",
    "赯" => "Tang", "走" => "Zou", "赱" => "Zou", "赲" => "Li", "赳" => "Jiu", "赴" => "Fu",
    "赵" => "Zhao", "赶" => "Gan", "起" => "Qi", "赸" => "Shan", "赹" => "Qiong", "赺" => "Qin",
    "赻" => "Xian", "赼" => "Ci", "赽" => "Jue", "赾" => "Qin", "赿" => "Chi", "趀" => "Ci",
    "趁" => "Chen", "趂" => "Chen", "趃" => "Die", "趄" => "Ju", "超" => "Chao", "趆" => "Di",
    "趇" => "Se", "趈" => "Zhan", "趉" => "Zhu", "越" => "Yue", "趋" => "Qu", "趌" => "Jie",
    "趍" => "Chi", "趎" => "Chu", "趏" => "Gua", "趐" => "Xue", "趑" => "Ci", "趒" => "Tiao",
    "趓" => "Duo", "趔" => "Lie", "趕" => "Gan", "趖" => "Suo", "趗" => "Cu", "趘" => "Xi",
    "趙" => "Zhao", "趚" => "Su", "趛" => "Yin", "趜" => "Ju", "趝" => "Jian", "趞" => "Que",
    "趟" => "Tang", "趠" => "Chuo", "趡" => "Cui", "趢" => "Lu", "趣" => "Qu", "趤" => "Dang",
    "趥" => "Qiu", "趦" => "Zi", "趧" => "Ti", "趨" => "Qu", "趩" => "Chi", "趪" => "Huang",
    "趫" => "Qiao", "趬" => "Qiao", "趭" => "Yao", "趮" => "Zao", "趯" => "Ti", "趱" => "Zan",
    "趲" => "Zan", "足" => "Zu", "趴" => "Pa", "趵" => "Bao", "趶" => "Ku", "趷" => "Ke",
    "趸" => "Dun", "趹" => "Jue", "趺" => "Fu", "趻" => "Chen", "趼" => "Jian", "趽" => "Fang",
    "趾" => "Zhi", "趿" => "Sa", "跀" => "Yue", "跁" => "Pa", "跂" => "Qi", "跃" => "Yue",
    "跄" => "Qiang", "跅" => "Tuo", "跆" => "Tai", "跇" => "Yi", "跈" => "Nian", "跉" => "Ling",
    "跊" => "Mei", "跋" => "Ba", "跌" => "Die", "跍" => "Ku", "跎" => "Tuo", "跏" => "Jia",
    "跐" => "Ci", "跑" => "Pao", "跒" => "Qia", "跓" => "Zhu", "跔" => "Ju", "跕" => "Die",
    "跖" => "Zhi", "跗" => "Fu", "跘" => "Pan", "跙" => "Ju", "跚" => "Shan", "跛" => "Bo",
    "跜" => "Ni", "距" => "Ju", "跞" => "Li", "跟" => "Gen", "跠" => "Yi", "跡" => "Ji",
    "跢" => "Dai", "跣" => "Xian", "跤" => "Jiao", "跥" => "Duo", "跦" => "Zhu", "跧" => "Zhuan",
    "跨" => "Kua", "跩" => "Zhuai", "跪" => "Gui", "跫" => "Qiong", "跬" => "Kui", "跭" => "Xiang",
    "跮" => "Chi", "路" => "Lu", "跰" => "Beng", "跱" => "Zhi", "跲" => "Jia", "跳" => "Tiao",
    "跴" => "Cai", "践" => "Jian", "跶" => "Ta", "跷" => "Qiao", "跸" => "Bi", "跹" => "Xian",
    "跺" => "Duo", "跻" => "Ji", "跼" => "Ju", "跽" => "Ji", "跾" => "Shu", "跿" => "Tu",
    "踁" => "Jing", "踂" => "Nie", "踃" => "Xiao", "踄" => "Bo", "踅" => "Chi", "踆" => "Qun",
    "踇" => "Mou", "踈" => "Shu", "踉" => "Lang", "踊" => "Yong", "踋" => "Jiao", "踌" => "Chou",
    "踍" => "Qiao", "踏" => "Ta", "踐" => "Jian", "踑" => "Qi", "踒" => "Wo", "踓" => "Wei",
    "踔" => "Zhuo", "踕" => "Jie", "踖" => "Ji", "踗" => "Nie", "踘" => "Ju", "踙" => "Ju",
    "踚" => "Lun", "踛" => "Lu", "踜" => "Leng", "踝" => "Huai", "踞" => "Ju", "踟" => "Chi",
    "踠" => "Wan", "踡" => "Quan", "踢" => "Ti", "踣" => "Bo", "踤" => "Zu", "踥" => "Qie",
    "踦" => "Ji", "踧" => "Cu", "踨" => "Zong", "踩" => "Cai", "踪" => "Zong", "踫" => "Peng",
    "踬" => "Zhi", "踭" => "Zheng", "踮" => "Dian", "踯" => "Zhi", "踰" => "Yu", "踱" => "Duo",
    "踲" => "Dun", "踳" => "Chun", "踴" => "Yong", "踵" => "Zhong", "踶" => "Di", "踷" => "Zhe",
    "踸" => "Chen", "踹" => "Chuai", "踺" => "Jian", "踻" => "Gua", "踼" => "Tang", "踽" => "Ju",
    "踾" => "Fu", "踿" => "Zu", "蹀" => "Die", "蹁" => "Pian", "蹂" => "Rou", "蹃" => "Nuo",
    "蹄" => "Ti", "蹅" => "Cha", "蹆" => "Tui", "蹇" => "Jian", "蹈" => "Dao", "蹉" => "Cuo",
    "蹊" => "Xi", "蹋" => "Ta", "蹌" => "Qiang", "蹍" => "Zhan", "蹎" => "Dian", "蹏" => "Ti",
    "蹐" => "Ji", "蹑" => "Nie", "蹒" => "Man", "蹓" => "Liu", "蹔" => "Zhan", "蹕" => "Bi",
    "蹖" => "Chong", "蹗" => "Lu", "蹘" => "Liao", "蹙" => "Cu", "蹚" => "Tang", "蹛" => "Dai",
    "蹜" => "Suo", "蹝" => "Xi", "蹞" => "Kui", "蹟" => "Ji", "蹠" => "Zhi", "蹡" => "Qiang",
    "蹢" => "Di", "蹣" => "Man", "蹤" => "Zong", "蹥" => "Lian", "蹦" => "Beng", "蹧" => "Zao",
    "蹨" => "Nian", "蹩" => "Bie", "蹪" => "Tui", "蹫" => "Ju", "蹬" => "Deng", "蹭" => "Ceng",
    "蹮" => "Xian", "蹯" => "Fan", "蹰" => "Chu", "蹱" => "Zhong", "蹲" => "Dun", "蹳" => "Bo",
    "蹴" => "Cu", "蹵" => "Zu", "蹶" => "Jue", "蹷" => "Jue", "蹸" => "Lin", "蹹" => "Ta",
    "蹺" => "Qiao", "蹻" => "Qiao", "蹼" => "Pu", "蹽" => "Liao", "蹾" => "Dun", "蹿" => "Cuan",
    "躀" => "Kuang", "躁" => "Zao", "躂" => "Ta", "躃" => "Bi", "躄" => "Bi", "躅" => "Zhu",
    "躆" => "Ju", "躇" => "Chu", "躈" => "Qiao", "躉" => "Dun", "躊" => "Chou", "躋" => "Ji",
    "躌" => "Wu", "躍" => "Yue", "躎" => "Nian", "躏" => "Lin", "躐" => "Lie", "躑" => "Zhi",
    "躒" => "Li", "躓" => "Zhi", "躔" => "Chan", "躕" => "Chu", "躖" => "Duan", "躗" => "Wei",
    "躘" => "Long", "躙" => "Lin", "躚" => "Xian", "躛" => "Wei", "躜" => "Zuan", "躝" => "Lan",
    "躞" => "Xie", "躟" => "Rang", "躠" => "Xie", "躡" => "Nie", "躢" => "Ta", "躣" => "Qu",
    "躤" => "Jie", "躥" => "Cuan", "躦" => "Zuan", "躧" => "Xi", "躨" => "Kui", "躩" => "Jue",
    "躪" => "Lin", "身" => "Shen", "躬" => "Gong", "躭" => "Dan", "躮" => "Segare", "躯" => "Qu",
    "躰" => "Ti", "躱" => "Duo", "躲" => "Duo", "躳" => "Gong", "躴" => "Lang", "躵" => "Nerau",
    "躶" => "Luo", "躷" => "Ai", "躸" => "Ji", "躹" => "Ju", "躺" => "Tang", "躻" => "Utsuke",
    "躽" => "Yan", "躾" => "Shitsuke", "躿" => "Kang", "軀" => "Qu", "軁" => "Lou", "軂" => "Lao",
    "軃" => "Tuo", "軄" => "Zhi", "軅" => "Yagate", "軆" => "Ti", "軇" => "Dao", "軈" => "Yagate",
    "軉" => "Yu", "車" => "Che", "軋" => "Ya", "軌" => "Gui", "軍" => "Jun", "軎" => "Wei",
    "軏" => "Yue", "軐" => "Xin", "軑" => "Di", "軒" => "Xuan", "軓" => "Fan", "軔" => "Ren",
    "軕" => "Shan", "軖" => "Qiang", "軗" => "Shu", "軘" => "Tun", "軙" => "Chen", "軚" => "Dai",
    "軛" => "E", "軜" => "Na", "軝" => "Qi", "軞" => "Mao", "軟" => "Ruan", "軠" => "Ren",
    "軡" => "Fan", "転" => "Zhuan", "軣" => "Hong", "軤" => "Hu", "軥" => "Qu", "軦" => "Huang",
    "軧" => "Di", "軨" => "Ling", "軩" => "Dai", "軪" => "Ao", "軫" => "Zhen", "軬" => "Fan",
    "軭" => "Kuang", "軮" => "Ang", "軯" => "Peng", "軰" => "Bei", "軱" => "Gu", "軲" => "Ku",
    "軳" => "Pao", "軴" => "Zhu", "軵" => "Rong", "軶" => "E", "軷" => "Ba", "軸" => "Zhou",
    "軹" => "Zhi", "軺" => "Yao", "軻" => "Ke", "軼" => "Yi", "軽" => "Qing", "軾" => "Shi",
    "軿" => "Ping", "輁" => "Qiong", "輂" => "Ju", "較" => "Jiao", "輄" => "Guang", "輅" => "Lu",
    "輆" => "Kai", "輇" => "Quan", "輈" => "Zhou", "載" => "Zai", "輊" => "Zhi", "輋" => "She",
    "輌" => "Liang", "輍" => "Yu", "輎" => "Shao", "輏" => "You", "輐" => "Huan", "輑" => "Yun",
    "輒" => "Zhe", "輓" => "Wan", "輔" => "Fu", "輕" => "Qing", "輖" => "Zhou", "輗" => "Ni",
    "輘" => "Ling", "輙" => "Zhe", "輚" => "Zhan", "輛" => "Liang", "輜" => "Zi", "輝" => "Hui",
    "輞" => "Wang", "輟" => "Chuo", "輠" => "Guo", "輡" => "Kan", "輢" => "Yi", "輣" => "Peng",
    "輤" => "Qian", "輥" => "Gun", "輦" => "Nian", "輧" => "Pian", "輨" => "Guan", "輩" => "Bei",
    "輪" => "Lun", "輫" => "Pai", "輬" => "Liang", "輭" => "Ruan", "輮" => "Rou", "輯" => "Ji",
    "輰" => "Yang", "輱" => "Xian", "輲" => "Chuan", "輳" => "Cou", "輴" => "Qun", "輵" => "Ge",
    "輶" => "You", "輷" => "Hong", "輸" => "Shu", "輹" => "Fu", "輺" => "Zi", "輻" => "Fu",
    "輼" => "Wen", "輽" => "Ben", "輾" => "Zhan", "輿" => "Yu", "轀" => "Wen", "轁" => "Tao",
    "轂" => "Gu", "轃" => "Zhen", "轄" => "Xia", "轅" => "Yuan", "轆" => "Lu", "轇" => "Jiu",
    "轈" => "Chao", "轉" => "Zhuan", "轊" => "Wei", "轋" => "Hun", "轌" => "Sori", "轍" => "Che",
    "轎" => "Jiao", "轏" => "Zhan", "轐" => "Pu", "轑" => "Lao", "轒" => "Fen", "轓" => "Fan",
    "轔" => "Lin", "轕" => "Ge", "轖" => "Se", "轗" => "Kan", "轘" => "Huan", "轙" => "Yi",
    "轚" => "Ji", "轛" => "Dui", "轜" => "Er", "轝" => "Yu", "轞" => "Xian", "轟" => "Hong",
    "轠" => "Lei", "轡" => "Pei", "轢" => "Li", "轣" => "Li", "轤" => "Lu", "轥" => "Lin",
    "车" => "Che", "轧" => "Ya", "轨" => "Gui", "轩" => "Xuan", "轪" => "Di", "轫" => "Ren",
    "转" => "Zhuan", "轭" => "E", "轮" => "Lun", "软" => "Ruan", "轰" => "Hong", "轱" => "Ku",
    "轲" => "Ke", "轳" => "Lu", "轴" => "Zhou", "轵" => "Zhi", "轶" => "Yi", "轷" => "Hu",
    "轸" => "Zhen", "轹" => "Li", "轺" => "Yao", "轻" => "Qing", "轼" => "Shi", "载" => "Zai",
    "轾" => "Zhi", "轿" => "Jiao", "辀" => "Zhou", "辁" => "Quan", "辂" => "Lu", "较" => "Jiao",
    "辄" => "Zhe", "辅" => "Fu", "辆" => "Liang", "辇" => "Nian", "辈" => "Bei", "辉" => "Hui",
    "辊" => "Gun", "辋" => "Wang", "辌" => "Liang", "辍" => "Chuo", "辎" => "Zi", "辏" => "Cou",
    "辐" => "Fu", "辑" => "Ji", "辒" => "Wen", "输" => "Shu", "辔" => "Pei", "辕" => "Yuan",
    "辖" => "Xia", "辗" => "Zhan", "辘" => "Lu", "辙" => "Che", "辚" => "Lin", "辛" => "Xin",
    "辜" => "Gu", "辝" => "Ci", "辞" => "Ci", "辟" => "Pi", "辠" => "Zui", "辡" => "Bian",
    "辢" => "La", "辣" => "La", "辤" => "Ci", "辥" => "Xue", "辦" => "Ban", "辧" => "Bian",
    "辨" => "Bian", "辩" => "Bian", "辫" => "Bian", "辬" => "Ban", "辭" => "Ci", "辮" => "Bian",
    "辯" => "Bian", "辰" => "Chen", "辱" => "Ru", "農" => "Nong", "辳" => "Nong", "辴" => "Zhen",
    "辵" => "Chuo", "辶" => "Chuo", "辷" => "Suberu", "辸" => "Reng", "边" => "Bian", "辺" => "Bian",
    "辻" => "Sip", "込" => "Ip", "辽" => "Liao", "达" => "Da", "辿" => "Chan", "迀" => "Gan",
    "迁" => "Qian", "迂" => "Yu", "迃" => "Yu", "迄" => "Qi", "迅" => "Xun", "迆" => "Yi",
    "过" => "Guo", "迈" => "Mai", "迉" => "Qi", "迊" => "Za", "迋" => "Wang", "迌" => "Jia",
    "迍" => "Zhun", "迎" => "Ying", "迏" => "Ti", "运" => "Yun", "近" => "Jin", "迒" => "Hang",
    "迓" => "Ya", "返" => "Fan", "迕" => "Wu", "迖" => "Da", "迗" => "E", "还" => "Huan",
    "这" => "Zhe", "迚" => "Totemo", "进" => "Jin", "远" => "Yuan", "违" => "Wei", "连" => "Lian",
    "迟" => "Chi", "迠" => "Che", "迡" => "Ni", "迢" => "Tiao", "迣" => "Zhi", "迤" => "Yi",
    "迥" => "Jiong", "迦" => "Jia", "迧" => "Chen", "迨" => "Dai", "迩" => "Er", "迪" => "Di",
    "迫" => "Po", "迬" => "Wang", "迭" => "Die", "迮" => "Ze", "迯" => "Tao", "述" => "Shu",
    "迱" => "Tuo", "迲" => "Kep", "迳" => "Jing", "迴" => "Hui", "迵" => "Tong", "迶" => "You",
    "迷" => "Mi", "迸" => "Beng", "迹" => "Ji", "迺" => "Nai", "迻" => "Yi", "迼" => "Jie",
    "追" => "Zhui", "迾" => "Lie", "迿" => "Xun", "送" => "Song", "适" => "Gua", "逃" => "Tao",
    "逄" => "Pang", "逅" => "Hou", "逆" => "Ni", "逇" => "Dun", "逈" => "Jiong", "选" => "Xuan",
    "逊" => "Xun", "逋" => "Bu", "逌" => "You", "逍" => "Xiao", "逎" => "Qiu", "透" => "Tou",
    "逐" => "Zhu", "逑" => "Qiu", "递" => "Di", "逓" => "Di", "途" => "Tu", "逕" => "Jing",
    "逖" => "Ti", "逗" => "Dou", "逘" => "Yi", "這" => "Zhe", "通" => "Tong", "逛" => "Guang",
    "逜" => "Wu", "逝" => "Shi", "逞" => "Cheng", "速" => "Su", "造" => "Zao", "逡" => "Qun",
    "逢" => "Feng", "連" => "Lian", "逤" => "Suo", "逥" => "Hui", "逦" => "Li", "逧" => "Sako",
    "逨" => "Lai", "逩" => "Ben", "逪" => "Cuo", "逫" => "Jue", "逬" => "Beng", "逭" => "Huan",
    "逮" => "Dai", "逯" => "Lu", "逰" => "You", "週" => "Zhou", "進" => "Jin", "逳" => "Yu",
    "逴" => "Chuo", "逵" => "Kui", "逶" => "Wei", "逷" => "Ti", "逸" => "Yi", "逹" => "Da",
    "逺" => "Yuan", "逻" => "Luo", "逼" => "Bi", "逽" => "Nuo", "逾" => "Yu", "逿" => "Dang",
    "遀" => "Sui", "遁" => "Dun", "遂" => "Sui", "遃" => "Yan", "遄" => "Chuan", "遅" => "Chi",
    "遆" => "Ti", "遇" => "Yu", "遈" => "Shi", "遉" => "Zhen", "遊" => "You", "運" => "Yun",
    "遌" => "E", "遍" => "Bian", "過" => "Guo", "遏" => "E", "遐" => "Xia", "遑" => "Huang",
    "遒" => "Qiu", "道" => "Dao", "達" => "Da", "違" => "Wei", "遖" => "Appare", "遗" => "Yi",
    "遘" => "Gou", "遙" => "Yao", "遚" => "Chu", "遛" => "Liu", "遜" => "Xun", "遝" => "Ta",
    "遞" => "Di", "遟" => "Chi", "遠" => "Yuan", "遡" => "Su", "遢" => "Ta", "遣" => "Qian",
    "遥" => "Yao", "遦" => "Guan", "遧" => "Zhang", "遨" => "Ao", "適" => "Shi", "遪" => "Ce",
    "遫" => "Chi", "遬" => "Su", "遭" => "Zao", "遮" => "Zhe", "遯" => "Dun", "遰" => "Di",
    "遱" => "Lou", "遲" => "Chi", "遳" => "Cuo", "遴" => "Lin", "遵" => "Zun", "遶" => "Rao",
    "遷" => "Qian", "選" => "Xuan", "遹" => "Yu", "遺" => "Yi", "遻" => "Wu", "遼" => "Liao",
    "遽" => "Ju", "遾" => "Shi", "避" => "Bi", "邀" => "Yao", "邁" => "Mai", "邂" => "Xie",
    "邃" => "Sui", "還" => "Huan", "邅" => "Zhan", "邆" => "Teng", "邇" => "Er", "邈" => "Miao",
    "邉" => "Bian", "邊" => "Bian", "邋" => "La", "邌" => "Li", "邍" => "Yuan", "邎" => "Yao",
    "邏" => "Luo", "邐" => "Li", "邑" => "Yi", "邒" => "Ting", "邓" => "Deng", "邔" => "Qi",
    "邕" => "Yong", "邖" => "Shan", "邗" => "Han", "邘" => "Yu", "邙" => "Mang", "邚" => "Ru",
    "邛" => "Qiong", "邝" => "Kuang", "邞" => "Fu", "邟" => "Kang", "邠" => "Bin", "邡" => "Fang",
    "邢" => "Xing", "那" => "Na", "邤" => "Xin", "邥" => "Shen", "邦" => "Bang", "邧" => "Yuan",
    "邨" => "Cun", "邩" => "Huo", "邪" => "Xie", "邫" => "Bang", "邬" => "Wu", "邭" => "Ju",
    "邮" => "You", "邯" => "Han", "邰" => "Tai", "邱" => "Qiu", "邲" => "Bi", "邳" => "Pei",
    "邴" => "Bing", "邵" => "Shao", "邶" => "Bei", "邷" => "Wa", "邸" => "Di", "邹" => "Zou",
    "邺" => "Ye", "邻" => "Lin", "邼" => "Kuang", "邽" => "Gui", "邾" => "Zhu", "邿" => "Shi",
    "郀" => "Ku", "郁" => "Yu", "郂" => "Gai", "郃" => "Ge", "郄" => "Xi", "郅" => "Zhi",
    "郆" => "Ji", "郇" => "Xun", "郈" => "Hou", "郉" => "Xing", "郊" => "Jiao", "郋" => "Xi",
    "郌" => "Gui", "郍" => "Nuo", "郎" => "Lang", "郏" => "Jia", "郐" => "Kuai", "郑" => "Zheng",
    "郒" => "Otoko", "郓" => "Yun", "郔" => "Yan", "郕" => "Cheng", "郖" => "Dou", "郗" => "Chi",
    "郘" => "Lu", "郙" => "Fu", "郚" => "Wu", "郛" => "Fu", "郜" => "Gao", "郝" => "Hao",
    "郞" => "Lang", "郟" => "Jia", "郠" => "Geng", "郡" => "Jun", "郢" => "Ying", "郣" => "Bo",
    "郤" => "Xi", "郥" => "Bei", "郦" => "Li", "郧" => "Yun", "部" => "Bu", "郩" => "Xiao",
    "郪" => "Qi", "郫" => "Pi", "郬" => "Qing", "郭" => "Guo", "郮" => "Zhou", "郯" => "Tan",
    "郰" => "Zou", "郱" => "Ping", "郲" => "Lai", "郳" => "Ni", "郴" => "Chen", "郵" => "You",
    "郶" => "Bu", "郷" => "Xiang", "郸" => "Dan", "郹" => "Ju", "郺" => "Yong", "郻" => "Qiao",
    "郼" => "Yi", "都" => "Du", "郾" => "Yan", "郿" => "Mei", "鄁" => "Bei", "鄂" => "E",
    "鄃" => "Yu", "鄄" => "Juan", "鄅" => "Yu", "鄆" => "Yun", "鄇" => "Hou", "鄈" => "Kui",
    "鄉" => "Xiang", "鄊" => "Xiang", "鄋" => "Sou", "鄌" => "Tang", "鄍" => "Ming", "鄎" => "Xi",
    "鄏" => "Ru", "鄐" => "Chu", "鄑" => "Zi", "鄒" => "Zou", "鄓" => "Ju", "鄔" => "Wu",
    "鄕" => "Xiang", "鄖" => "Yun", "鄗" => "Hao", "鄘" => "Yong", "鄙" => "Bi", "鄚" => "Mo",
    "鄛" => "Chao", "鄜" => "Fu", "鄝" => "Liao", "鄞" => "Yin", "鄟" => "Zhuan", "鄠" => "Hu",
    "鄡" => "Qiao", "鄢" => "Yan", "鄣" => "Zhang", "鄤" => "Fan", "鄥" => "Qiao", "鄦" => "Xu",
    "鄧" => "Deng", "鄨" => "Bi", "鄩" => "Xin", "鄪" => "Bi", "鄫" => "Ceng", "鄬" => "Wei",
    "鄭" => "Zheng", "鄮" => "Mao", "鄯" => "Shan", "鄰" => "Lin", "鄱" => "Po", "鄲" => "Dan",
    "鄳" => "Meng", "鄴" => "Ye", "鄵" => "Cao", "鄶" => "Kuai", "鄷" => "Feng", "鄸" => "Meng",
    "鄹" => "Zou", "鄺" => "Kuang", "鄻" => "Lian", "鄼" => "Zan", "鄽" => "Chan", "鄾" => "You",
    "鄿" => "Qi", "酀" => "Yan", "酁" => "Chan", "酂" => "Zan", "酃" => "Ling", "酄" => "Huan",
    "酅" => "Xi", "酆" => "Feng", "酇" => "Zan", "酈" => "Li", "酉" => "You", "酊" => "Ding",
    "酋" => "Qiu", "酌" => "Zhuo", "配" => "Pei", "酎" => "Zhou", "酏" => "Yi", "酐" => "Hang",
    "酑" => "Yu", "酒" => "Jiu", "酓" => "Yan", "酔" => "Zui", "酕" => "Mao", "酖" => "Dan",
    "酗" => "Xu", "酘" => "Tou", "酙" => "Zhen", "酚" => "Fen", "酛" => "Sakenomoto", "酝" => "Yun",
    "酞" => "Tai", "酟" => "Tian", "酠" => "Qia", "酡" => "Tuo", "酢" => "Zuo", "酣" => "Han",
    "酤" => "Gu", "酥" => "Su", "酦" => "Po", "酧" => "Chou", "酨" => "Zai", "酩" => "Ming",
    "酪" => "Luo", "酫" => "Chuo", "酬" => "Chou", "酭" => "You", "酮" => "Tong", "酯" => "Zhi",
    "酰" => "Xian", "酱" => "Jiang", "酲" => "Cheng", "酳" => "Yin", "酴" => "Tu", "酵" => "Xiao",
    "酶" => "Mei", "酷" => "Ku", "酸" => "Suan", "酹" => "Lei", "酺" => "Pu", "酻" => "Zui",
    "酼" => "Hai", "酽" => "Yan", "酾" => "Xi", "酿" => "Niang", "醀" => "Wei", "醁" => "Lu",
    "醂" => "Lan", "醃" => "Yan", "醄" => "Tao", "醅" => "Pei", "醆" => "Zhan", "醇" => "Chun",
    "醈" => "Tan", "醉" => "Zui", "醊" => "Chuo", "醋" => "Cu", "醌" => "Kun", "醍" => "Ti",
    "醎" => "Mian", "醏" => "Du", "醐" => "Hu", "醑" => "Xu", "醒" => "Xing", "醓" => "Tan",
    "醔" => "Jiu", "醕" => "Chun", "醖" => "Yun", "醗" => "Po", "醘" => "Ke", "醙" => "Sou",
    "醚" => "Mi", "醛" => "Quan", "醜" => "Chou", "醝" => "Cuo", "醞" => "Yun", "醟" => "Yong",
    "醠" => "Ang", "醡" => "Zha", "醢" => "Hai", "醣" => "Tang", "醤" => "Jiang", "醥" => "Piao",
    "醦" => "Shan", "醧" => "Yu", "醨" => "Li", "醩" => "Zao", "醪" => "Lao", "醫" => "Yi",
    "醬" => "Jiang", "醭" => "Pu", "醮" => "Jiao", "醯" => "Xi", "醰" => "Tan", "醱" => "Po",
    "醲" => "Nong", "醳" => "Yi", "醴" => "Li", "醵" => "Ju", "醶" => "Jiao", "醷" => "Yi",
    "醸" => "Niang", "醹" => "Ru", "醺" => "Xun", "醻" => "Chou", "醼" => "Yan", "醽" => "Ling",
    "醾" => "Mi", "醿" => "Mi", "釀" => "Niang", "釁" => "Xin", "釂" => "Jiao", "釃" => "Xi",
    "釄" => "Mi", "釅" => "Yan", "釆" => "Bian", "采" => "Cai", "釈" => "Shi", "釉" => "You",
    "释" => "Shi", "釋" => "Shi", "里" => "Li", "重" => "Zhong", "野" => "Ye", "量" => "Liang",
    "釐" => "Li", "金" => "Jin", "釒" => "Jin", "釓" => "Qiu", "釔" => "Yi", "釕" => "Diao",
    "釖" => "Dao", "釗" => "Zhao", "釘" => "Ding", "釙" => "Po", "釚" => "Qiu", "釛" => "He",
    "釜" => "Fu", "針" => "Zhen", "釞" => "Zhi", "釟" => "Ba", "釠" => "Luan", "釡" => "Fu",
    "釢" => "Nai", "釣" => "Diao", "釤" => "Shan", "釥" => "Qiao", "釦" => "Kou", "釧" => "Chuan",
    "釨" => "Zi", "釩" => "Fan", "釪" => "Yu", "釫" => "Hua", "釬" => "Han", "釭" => "Gong",
    "釮" => "Qi", "釯" => "Mang", "釰" => "Ri", "釱" => "Di", "釲" => "Si", "釳" => "Xi",
    "釴" => "Yi", "釵" => "Chai", "釶" => "Shi", "釷" => "Tu", "釸" => "Xi", "釹" => "Nu",
    "釺" => "Qian", "釻" => "Ishiyumi", "釼" => "Jian", "釽" => "Pi", "釾" => "Ye", "釿" => "Yin",
    "鈁" => "Fang", "鈂" => "Chen", "鈃" => "Xing", "鈄" => "Tou", "鈅" => "Yue", "鈆" => "Yan",
    "鈇" => "Fu", "鈈" => "Pi", "鈉" => "Na", "鈊" => "Xin", "鈋" => "E", "鈌" => "Jue",
    "鈍" => "Dun", "鈎" => "Gou", "鈏" => "Yin", "鈐" => "Qian", "鈑" => "Ban", "鈒" => "Ji",
    "鈓" => "Ren", "鈔" => "Chao", "鈕" => "Niu", "鈖" => "Fen", "鈗" => "Yun", "鈘" => "Ji",
    "鈙" => "Qin", "鈚" => "Pi", "鈛" => "Guo", "鈜" => "Hong", "鈝" => "Yin", "鈞" => "Jun",
    "鈟" => "Shi", "鈠" => "Yi", "鈡" => "Zhong", "鈢" => "Nie", "鈣" => "Gai", "鈤" => "Ri",
    "鈥" => "Huo", "鈦" => "Tai", "鈧" => "Kang", "鈨" => "Habaki", "鈩" => "Irori", "鈪" => "Ngaak",
    "鈬" => "Duo", "鈭" => "Zi", "鈮" => "Ni", "鈯" => "Tu", "鈰" => "Shi", "鈱" => "Min",
    "鈲" => "Gu", "鈳" => "E", "鈴" => "Ling", "鈵" => "Bing", "鈶" => "Yi", "鈷" => "Gu",
    "鈸" => "Ba", "鈹" => "Pi", "鈺" => "Yu", "鈻" => "Si", "鈼" => "Zuo", "鈽" => "Bu",
    "鈾" => "You", "鈿" => "Dian", "鉀" => "Jia", "鉁" => "Zhen", "鉂" => "Shi", "鉃" => "Shi",
    "鉄" => "Tie", "鉅" => "Ju", "鉆" => "Zhan", "鉇" => "Shi", "鉈" => "She", "鉉" => "Xuan",
    "鉊" => "Zhao", "鉋" => "Bao", "鉌" => "He", "鉍" => "Bi", "鉎" => "Sheng", "鉏" => "Chu",
    "鉐" => "Shi", "鉑" => "Bo", "鉒" => "Zhu", "鉓" => "Chi", "鉔" => "Za", "鉕" => "Po",
    "鉖" => "Tong", "鉗" => "Qian", "鉘" => "Fu", "鉙" => "Zhai", "鉚" => "Liu", "鉛" => "Qian",
    "鉜" => "Fu", "鉝" => "Li", "鉞" => "Yue", "鉟" => "Pi", "鉠" => "Yang", "鉡" => "Ban",
    "鉢" => "Bo", "鉣" => "Jie", "鉤" => "Gou", "鉥" => "Shu", "鉦" => "Zheng", "鉧" => "Mu",
    "鉨" => "Ni", "鉩" => "Nie", "鉪" => "Di", "鉫" => "Jia", "鉬" => "Mu", "鉭" => "Dan",
    "鉮" => "Shen", "鉯" => "Yi", "鉰" => "Si", "鉱" => "Kuang", "鉲" => "Ka", "鉳" => "Bei",
    "鉴" => "Jian", "鉵" => "Tong", "鉶" => "Xing", "鉷" => "Hong", "鉸" => "Jiao", "鉹" => "Chi",
    "鉺" => "Er", "鉻" => "Ge", "鉼" => "Bing", "鉽" => "Shi", "鉾" => "Mou", "鉿" => "Jia",
    "銀" => "Yin", "銁" => "Jun", "銂" => "Zhou", "銃" => "Chong", "銄" => "Shang", "銅" => "Tong",
    "銆" => "Mo", "銇" => "Lei", "銈" => "Ji", "銉" => "Yu", "銊" => "Xu", "銋" => "Ren",
    "銌" => "Zun", "銍" => "Zhi", "銎" => "Qiong", "銏" => "Shan", "銐" => "Chi", "銑" => "Xian",
    "銒" => "Xing", "銓" => "Quan", "銔" => "Pi", "銕" => "Tie", "銖" => "Zhu", "銗" => "Hou",
    "銘" => "Ming", "銙" => "Kua", "銚" => "Yao", "銛" => "Xian", "銜" => "Xian", "銝" => "Xiu",
    "銞" => "Jun", "銟" => "Cha", "銠" => "Lao", "銡" => "Ji", "銢" => "Pi", "銣" => "Ru",
    "銤" => "Mi", "銥" => "Yi", "銦" => "Yin", "銧" => "Guang", "銨" => "An", "銩" => "Diou",
    "銪" => "You", "銫" => "Se", "銬" => "Kao", "銭" => "Qian", "銮" => "Luan", "銯" => "Kasugai",
    "銰" => "Ai", "銱" => "Diao", "銲" => "Han", "銳" => "Rui", "銴" => "Shi", "銵" => "Keng",
    "銶" => "Qiu", "銷" => "Xiao", "銸" => "Zhe", "銹" => "Xiu", "銺" => "Zang", "銻" => "Ti",
    "銼" => "Cuo", "銽" => "Gua", "銾" => "Gong", "銿" => "Zhong", "鋀" => "Dou", "鋁" => "Lu",
    "鋂" => "Mei", "鋃" => "Lang", "鋄" => "Wan", "鋅" => "Xin", "鋆" => "Yun", "鋇" => "Bei",
    "鋈" => "Wu", "鋉" => "Su", "鋊" => "Yu", "鋋" => "Chan", "鋌" => "Ting", "鋍" => "Bo",
    "鋎" => "Han", "鋏" => "Jia", "鋐" => "Hong", "鋑" => "Cuan", "鋒" => "Feng", "鋓" => "Chan",
    "鋔" => "Wan", "鋕" => "Zhi", "鋖" => "Si", "鋗" => "Xuan", "鋘" => "Wu", "鋙" => "Wu",
    "鋚" => "Tiao", "鋛" => "Gong", "鋜" => "Zhuo", "鋝" => "Lue", "鋞" => "Xing", "鋟" => "Qian",
    "鋠" => "Shen", "鋡" => "Han", "鋢" => "Lue", "鋣" => "Xie", "鋤" => "Chu", "鋥" => "Zheng",
    "鋦" => "Ju", "鋧" => "Xian", "鋨" => "Tie", "鋩" => "Mang", "鋪" => "Pu", "鋫" => "Li",
    "鋬" => "Pan", "鋭" => "Rui", "鋮" => "Cheng", "鋯" => "Gao", "鋰" => "Li", "鋱" => "Te",
    "鋲" => "Pyeng", "鋳" => "Zhu", "鋵" => "Tu", "鋶" => "Liu", "鋷" => "Zui", "鋸" => "Ju",
    "鋹" => "Chang", "鋺" => "Yuan", "鋻" => "Jian", "鋼" => "Gang", "鋽" => "Diao", "鋾" => "Tao",
    "鋿" => "Chang", "錁" => "Kua", "錂" => "Ling", "錃" => "Bei", "錄" => "Lu", "錅" => "Li",
    "錆" => "Qiang", "錇" => "Pou", "錈" => "Juan", "錉" => "Min", "錊" => "Zui", "錋" => "Peng",
    "錌" => "An", "錍" => "Pi", "錎" => "Xian", "錏" => "Ya", "錐" => "Zhui", "錑" => "Lei",
    "錒" => "A", "錓" => "Kong", "錔" => "Ta", "錕" => "Kun", "錖" => "Du", "錗" => "Wei",
    "錘" => "Chui", "錙" => "Zi", "錚" => "Zheng", "錛" => "Ben", "錜" => "Nie", "錝" => "Cong",
    "錞" => "Qun", "錟" => "Tan", "錠" => "Ding", "錡" => "Qi", "錢" => "Qian", "錣" => "Zhuo",
    "錤" => "Qi", "錥" => "Yu", "錦" => "Jin", "錧" => "Guan", "錨" => "Mao", "錩" => "Chang",
    "錪" => "Tian", "錫" => "Xi", "錬" => "Lian", "錭" => "Tao", "錮" => "Gu", "錯" => "Cuo",
    "錰" => "Shu", "錱" => "Zhen", "録" => "Lu", "錳" => "Meng", "錴" => "Lu", "錵" => "Hua",
    "錶" => "Biao", "錷" => "Ga", "錸" => "Lai", "錹" => "Ken", "錺" => "Kazari", "錻" => "Bu",
    "錼" => "Nai", "錽" => "Wan", "錾" => "Zan", "鍀" => "De", "鍁" => "Xian", "鍃" => "Huo",
    "鍄" => "Liang", "鍆" => "Men", "鍇" => "Kai", "鍈" => "Ying", "鍉" => "Di", "鍊" => "Lian",
    "鍋" => "Guo", "鍌" => "Xian", "鍍" => "Du", "鍎" => "Tu", "鍏" => "Wei", "鍐" => "Cong",
    "鍑" => "Fu", "鍒" => "Rou", "鍓" => "Ji", "鍔" => "E", "鍕" => "Rou", "鍖" => "Chen",
    "鍗" => "Ti", "鍘" => "Zha", "鍙" => "Hong", "鍚" => "Yang", "鍛" => "Duan", "鍜" => "Xia",
    "鍝" => "Yu", "鍞" => "Keng", "鍟" => "Xing", "鍠" => "Huang", "鍡" => "Wei", "鍢" => "Fu",
    "鍣" => "Zhao", "鍤" => "Cha", "鍥" => "Qie", "鍦" => "She", "鍧" => "Hong", "鍨" => "Kui",
    "鍩" => "Tian", "鍪" => "Mou", "鍫" => "Qiao", "鍬" => "Qiao", "鍭" => "Hou", "鍮" => "Tou",
    "鍯" => "Cong", "鍰" => "Huan", "鍱" => "Ye", "鍲" => "Min", "鍳" => "Jian", "鍴" => "Duan",
    "鍵" => "Jian", "鍶" => "Song", "鍷" => "Kui", "鍸" => "Hu", "鍹" => "Xuan", "鍺" => "Duo",
    "鍻" => "Jie", "鍼" => "Zhen", "鍽" => "Bian", "鍾" => "Zhong", "鍿" => "Zi", "鎀" => "Xiu",
    "鎁" => "Ye", "鎂" => "Mei", "鎃" => "Pai", "鎄" => "Ai", "鎅" => "Jie", "鎇" => "Mei",
    "鎈" => "Chuo", "鎉" => "Ta", "鎊" => "Bang", "鎋" => "Xia", "鎌" => "Lian", "鎍" => "Suo",
    "鎎" => "Xi", "鎏" => "Liu", "鎐" => "Zu", "鎑" => "Ye", "鎒" => "Nou", "鎓" => "Weng",
    "鎔" => "Rong", "鎕" => "Tang", "鎖" => "Suo", "鎗" => "Qiang", "鎘" => "Ge", "鎙" => "Shuo",
    "鎚" => "Chui", "鎛" => "Bo", "鎜" => "Pan", "鎝" => "Sa", "鎞" => "Bi", "鎟" => "Sang",
    "鎠" => "Gang", "鎡" => "Zi", "鎢" => "Wu", "鎣" => "Ying", "鎤" => "Huang", "鎥" => "Tiao",
    "鎦" => "Liu", "鎧" => "Kai", "鎨" => "Sun", "鎩" => "Sha", "鎪" => "Sou", "鎫" => "Wan",
    "鎬" => "Hao", "鎭" => "Zhen", "鎮" => "Zhen", "鎯" => "Luo", "鎰" => "Yi", "鎱" => "Yuan",
    "鎲" => "Tang", "鎳" => "Nie", "鎴" => "Xi", "鎵" => "Jia", "鎶" => "Ge", "鎷" => "Ma",
    "鎸" => "Juan", "鎹" => "Kasugai", "鎺" => "Habaki", "鎻" => "Suo", "鎿" => "Na", "鏀" => "Lu",
    "鏁" => "Suo", "鏂" => "Ou", "鏃" => "Zu", "鏄" => "Tuan", "鏅" => "Xiu", "鏆" => "Guan",
    "鏇" => "Xuan", "鏈" => "Lian", "鏉" => "Shou", "鏊" => "Ao", "鏋" => "Man", "鏌" => "Mo",
    "鏍" => "Luo", "鏎" => "Bi", "鏏" => "Wei", "鏐" => "Liu", "鏑" => "Di", "鏒" => "Qiao",
    "鏓" => "Cong", "鏔" => "Yi", "鏕" => "Lu", "鏖" => "Ao", "鏗" => "Keng", "鏘" => "Qiang",
    "鏙" => "Cui", "鏚" => "Qi", "鏛" => "Chang", "鏜" => "Tang", "鏝" => "Man", "鏞" => "Yong",
    "鏟" => "Chan", "鏠" => "Feng", "鏡" => "Jing", "鏢" => "Biao", "鏣" => "Shu", "鏤" => "Lou",
    "鏥" => "Xiu", "鏦" => "Cong", "鏧" => "Long", "鏨" => "Zan", "鏩" => "Jian", "鏪" => "Cao",
    "鏫" => "Li", "鏬" => "Xia", "鏭" => "Xi", "鏮" => "Kang", "鏰" => "Beng", "鏳" => "Zheng",
    "鏴" => "Lu", "鏵" => "Hua", "鏶" => "Ji", "鏷" => "Pu", "鏸" => "Hui", "鏹" => "Qiang",
    "鏺" => "Po", "鏻" => "Lin", "鏼" => "Suo", "鏽" => "Xiu", "鏾" => "San", "鏿" => "Cheng",
    "鐁" => "Si", "鐂" => "Liu", "鐃" => "Nao", "鐄" => "Heng", "鐅" => "Pie", "鐆" => "Sui",
    "鐇" => "Fan", "鐈" => "Qiao", "鐉" => "Quan", "鐊" => "Yang", "鐋" => "Tang", "鐌" => "Xiang",
    "鐍" => "Jue", "鐎" => "Jiao", "鐏" => "Zun", "鐐" => "Liao", "鐑" => "Jie", "鐒" => "Lao",
    "鐓" => "Dui", "鐔" => "Tan", "鐕" => "Zan", "鐖" => "Ji", "鐗" => "Jian", "鐘" => "Zhong",
    "鐙" => "Deng", "鐚" => "Ya", "鐛" => "Ying", "鐜" => "Dui", "鐝" => "Jue", "鐞" => "Nou",
    "鐟" => "Ti", "鐠" => "Pu", "鐡" => "Tie", "鐤" => "Ding", "鐥" => "Shan", "鐦" => "Kai",
    "鐧" => "Jian", "鐨" => "Fei", "鐩" => "Sui", "鐪" => "Lu", "鐫" => "Juan", "鐬" => "Hui",
    "鐭" => "Yu", "鐮" => "Lian", "鐯" => "Zhuo", "鐰" => "Qiao", "鐱" => "Qian", "鐲" => "Zhuo",
    "鐳" => "Lei", "鐴" => "Bi", "鐵" => "Tie", "鐶" => "Huan", "鐷" => "Ye", "鐸" => "Duo",
    "鐹" => "Guo", "鐺" => "Dang", "鐻" => "Ju", "鐼" => "Fen", "鐽" => "Da", "鐾" => "Bei",
    "鐿" => "Yi", "鑀" => "Ai", "鑁" => "Zong", "鑂" => "Xun", "鑃" => "Diao", "鑄" => "Zhu",
    "鑅" => "Heng", "鑆" => "Zhui", "鑇" => "Ji", "鑈" => "Nie", "鑉" => "Ta", "鑊" => "Huo",
    "鑋" => "Qing", "鑌" => "Bin", "鑍" => "Ying", "鑎" => "Kui", "鑏" => "Ning", "鑐" => "Xu",
    "鑑" => "Jian", "鑒" => "Jian", "鑓" => "Yari", "鑔" => "Cha", "鑕" => "Zhi", "鑖" => "Mie",
    "鑗" => "Li", "鑘" => "Lei", "鑙" => "Ji", "鑚" => "Zuan", "鑛" => "Kuang", "鑜" => "Shang",
    "鑝" => "Peng", "鑞" => "La", "鑟" => "Du", "鑠" => "Shuo", "鑡" => "Chuo", "鑢" => "Lu",
    "鑣" => "Biao", "鑤" => "Bao", "鑥" => "Lu", "鑨" => "Long", "鑩" => "E", "鑪" => "Lu",
    "鑫" => "Xin", "鑬" => "Jian", "鑭" => "Lan", "鑮" => "Bo", "鑯" => "Jian", "鑰" => "Yao",
    "鑱" => "Chan", "鑲" => "Xiang", "鑳" => "Jian", "鑴" => "Xi", "鑵" => "Guan", "鑶" => "Cang",
    "鑷" => "Nie", "鑸" => "Lei", "鑹" => "Cuan", "鑺" => "Qu", "鑻" => "Pan", "鑼" => "Luo",
    "鑽" => "Zuan", "鑾" => "Luan", "鑿" => "Zao", "钀" => "Nie", "钁" => "Jue", "钂" => "Tang",
    "钃" => "Shu", "钄" => "Lan", "钅" => "Jin", "钆" => "Qiu", "钇" => "Yi", "针" => "Zhen",
    "钉" => "Ding", "钊" => "Zhao", "钋" => "Po", "钌" => "Diao", "钍" => "Tu", "钎" => "Qian",
    "钏" => "Chuan", "钐" => "Shan", "钑" => "Ji", "钒" => "Fan", "钓" => "Diao", "钔" => "Men",
    "钕" => "Nu", "钖" => "Xi", "钗" => "Chai", "钘" => "Xing", "钙" => "Gai", "钚" => "Bu",
    "钛" => "Tai", "钜" => "Ju", "钝" => "Dun", "钞" => "Chao", "钟" => "Zhong", "钠" => "Na",
    "钡" => "Bei", "钢" => "Gang", "钣" => "Ban", "钤" => "Qian", "钥" => "Yao", "钦" => "Qin",
    "钧" => "Jun", "钨" => "Wu", "钩" => "Gou", "钪" => "Kang", "钫" => "Fang", "钬" => "Huo",
    "钭" => "Tou", "钮" => "Niu", "钯" => "Ba", "钰" => "Yu", "钱" => "Qian", "钲" => "Zheng",
    "钳" => "Qian", "钴" => "Gu", "钵" => "Bo", "钶" => "E", "钷" => "Po", "钸" => "Bu",
    "钹" => "Ba", "钺" => "Yue", "钻" => "Zuan", "钼" => "Mu", "钽" => "Dan", "钾" => "Jia",
    "钿" => "Dian", "铀" => "You", "铁" => "Tie", "铂" => "Bo", "铃" => "Ling", "铄" => "Shuo",
    "铅" => "Qian", "铆" => "Liu", "铇" => "Bao", "铈" => "Shi", "铉" => "Xuan", "铊" => "She",
    "铋" => "Bi", "铌" => "Ni", "铍" => "Pi", "铎" => "Duo", "铏" => "Xing", "铐" => "Kao",
    "铑" => "Lao", "铒" => "Er", "铓" => "Mang", "铔" => "Ya", "铕" => "You", "铖" => "Cheng",
    "铗" => "Jia", "铘" => "Ye", "铙" => "Nao", "铚" => "Zhi", "铛" => "Dang", "铜" => "Tong",
    "铝" => "Lu", "铞" => "Diao", "铟" => "Yin", "铠" => "Kai", "铡" => "Zha", "铢" => "Zhu",
    "铣" => "Xian", "铤" => "Ting", "铥" => "Diu", "铦" => "Xian", "铧" => "Hua", "铨" => "Quan",
    "铩" => "Sha", "铪" => "Jia", "铫" => "Yao", "铬" => "Ge", "铭" => "Ming", "铮" => "Zheng",
    "铯" => "Se", "铰" => "Jiao", "铱" => "Yi", "铲" => "Chan", "铳" => "Chong", "铴" => "Tang",
    "铵" => "An", "银" => "Yin", "铷" => "Ru", "铸" => "Zhu", "铹" => "Lao", "铺" => "Pu",
    "铻" => "Wu", "铼" => "Lai", "铽" => "Te", "链" => "Lian", "铿" => "Keng", "锁" => "Suo",
    "锂" => "Li", "锃" => "Zheng", "锄" => "Chu", "锅" => "Guo", "锆" => "Gao", "锇" => "Tie",
    "锈" => "Xiu", "锉" => "Cuo", "锊" => "Lue", "锋" => "Feng", "锌" => "Xin", "锍" => "Liu",
    "锎" => "Kai", "锏" => "Jian", "锐" => "Rui", "锑" => "Ti", "锒" => "Lang", "锓" => "Qian",
    "锔" => "Ju", "锕" => "A", "锖" => "Qiang", "锗" => "Duo", "锘" => "Tian", "错" => "Cuo",
    "锚" => "Mao", "锛" => "Ben", "锜" => "Qi", "锝" => "De", "锞" => "Kua", "锟" => "Kun",
    "锠" => "Chang", "锡" => "Xi", "锢" => "Gu", "锣" => "Luo", "锤" => "Chui", "锥" => "Zhui",
    "锦" => "Jin", "锧" => "Zhi", "锨" => "Xian", "锩" => "Juan", "锪" => "Huo", "锫" => "Pou",
    "锬" => "Tan", "锭" => "Ding", "键" => "Jian", "锯" => "Ju", "锰" => "Meng", "锱" => "Zi",
    "锲" => "Qie", "锳" => "Ying", "锴" => "Kai", "锵" => "Qiang", "锶" => "Song", "锷" => "E",
    "锸" => "Cha", "锹" => "Qiao", "锺" => "Zhong", "锻" => "Duan", "锼" => "Sou", "锽" => "Huang",
    "锾" => "Huan", "锿" => "Ai", "镀" => "Du", "镁" => "Mei", "镂" => "Lou", "镃" => "Zi",
    "镄" => "Fei", "镅" => "Mei", "镆" => "Mo", "镇" => "Zhen", "镈" => "Bo", "镉" => "Ge",
    "镊" => "Nie", "镋" => "Tang", "镌" => "Juan", "镍" => "Nie", "镎" => "Na", "镏" => "Liu",
    "镐" => "Hao", "镑" => "Bang", "镒" => "Yi", "镓" => "Jia", "镔" => "Bin", "镕" => "Rong",
    "镖" => "Biao", "镗" => "Tang", "镘" => "Man", "镙" => "Luo", "镚" => "Beng", "镛" => "Yong",
    "镜" => "Jing", "镝" => "Di", "镞" => "Zu", "镟" => "Xuan", "镠" => "Liu", "镡" => "Tan",
    "镢" => "Jue", "镣" => "Liao", "镤" => "Pu", "镥" => "Lu", "镦" => "Dui", "镧" => "Lan",
    "镨" => "Pu", "镩" => "Cuan", "镪" => "Qiang", "镫" => "Deng", "镬" => "Huo", "镭" => "Lei",
    "镮" => "Huan", "镯" => "Zhuo", "镰" => "Lian", "镱" => "Yi", "镲" => "Cha", "镳" => "Biao",
    "镴" => "La", "镵" => "Chan", "镶" => "Xiang", "長" => "Chang", "镸" => "Chang", "镹" => "Jiu",
    "镺" => "Ao", "镻" => "Die", "镼" => "Qu", "镽" => "Liao", "镾" => "Mi", "长" => "Chang",
    "門" => "Men", "閁" => "Ma", "閂" => "Shuan", "閃" => "Shan", "閄" => "Huo", "閅" => "Men",
    "閆" => "Yan", "閇" => "Bi", "閈" => "Han", "閉" => "Bi", "閊" => "San", "開" => "Kai",
    "閌" => "Kang", "閍" => "Beng", "閎" => "Hong", "閏" => "Run", "閐" => "San", "閑" => "Xian",
    "閒" => "Xian", "間" => "Jian", "閔" => "Min", "閕" => "Xia", "閖" => "Yuru", "閗" => "Dou",
    "閘" => "Zha", "閙" => "Nao", "閚" => "Jian", "閛" => "Peng", "閜" => "Xia", "閝" => "Ling",
    "閞" => "Bian", "閟" => "Bi", "閠" => "Run", "閡" => "He", "関" => "Guan", "閣" => "Ge",
    "閤" => "Ge", "閥" => "Fa", "閦" => "Chu", "閧" => "Hong", "閨" => "Gui", "閩" => "Min",
    "閪" => "Se", "閫" => "Kun", "閬" => "Lang", "閭" => "Lu", "閮" => "Ting", "閯" => "Sha",
    "閰" => "Ju", "閱" => "Yue", "閲" => "Yue", "閳" => "Chan", "閴" => "Qu", "閵" => "Lin",
    "閶" => "Chang", "閷" => "Shai", "閸" => "Kun", "閹" => "Yan", "閺" => "Min", "閻" => "Yan",
    "閼" => "E", "閽" => "Hun", "閾" => "Yu", "閿" => "Wen", "闀" => "Xiang", "闁" => "Bao",
    "闂" => "Xiang", "闃" => "Qu", "闄" => "Yao", "闅" => "Wen", "闆" => "Ban", "闇" => "An",
    "闈" => "Wei", "闉" => "Yin", "闊" => "Kuo", "闋" => "Que", "闌" => "Lan", "闍" => "Du",
    "闏" => "Phwung", "闐" => "Tian", "闑" => "Nie", "闒" => "Ta", "闓" => "Kai", "闔" => "He",
    "闕" => "Que", "闖" => "Chuang", "闗" => "Guan", "闘" => "Dou", "闙" => "Qi", "闚" => "Kui",
    "闛" => "Tang", "關" => "Guan", "闝" => "Piao", "闞" => "Kan", "闟" => "Xi", "闠" => "Hui",
    "闡" => "Chan", "闢" => "Pi", "闣" => "Dang", "闤" => "Huan", "闥" => "Ta", "闦" => "Wen",
    "门" => "Men", "闩" => "Shuan", "闪" => "Shan", "闫" => "Yan", "闬" => "Han", "闭" => "Bi",
    "问" => "Wen", "闯" => "Chuang", "闰" => "Run", "闱" => "Wei", "闲" => "Xian", "闳" => "Hong",
    "间" => "Jian", "闵" => "Min", "闶" => "Kang", "闷" => "Men", "闸" => "Zha", "闹" => "Nao",
    "闺" => "Gui", "闻" => "Wen", "闼" => "Ta", "闽" => "Min", "闾" => "Lu", "闿" => "Kai",
    "阁" => "Ge", "阂" => "He", "阃" => "Kun", "阄" => "Jiu", "阅" => "Yue", "阆" => "Lang",
    "阇" => "Du", "阈" => "Yu", "阉" => "Yan", "阊" => "Chang", "阋" => "Xi", "阌" => "Wen",
    "阍" => "Hun", "阎" => "Yan", "阏" => "E", "阐" => "Chan", "阑" => "Lan", "阒" => "Qu",
    "阓" => "Hui", "阔" => "Kuo", "阕" => "Que", "阖" => "Ge", "阗" => "Tian", "阘" => "Ta",
    "阙" => "Que", "阚" => "Kan", "阛" => "Huan", "阜" => "Fu", "阝" => "Fu", "阞" => "Le",
    "队" => "Dui", "阠" => "Xin", "阡" => "Qian", "阢" => "Wu", "阣" => "Yi", "阤" => "Tuo",
    "阥" => "Yin", "阦" => "Yang", "阧" => "Dou", "阨" => "E", "阩" => "Sheng", "阪" => "Ban",
    "阫" => "Pei", "阬" => "Keng", "阭" => "Yun", "阮" => "Ruan", "阯" => "Zhi", "阰" => "Pi",
    "阱" => "Jing", "防" => "Fang", "阳" => "Yang", "阴" => "Yin", "阵" => "Zhen", "阶" => "Jie",
    "阷" => "Cheng", "阸" => "E", "阹" => "Qu", "阺" => "Di", "阻" => "Zu", "阼" => "Zuo",
    "阽" => "Dian", "阾" => "Ling", "阿" => "A", "陀" => "Tuo", "陁" => "Tuo", "陂" => "Po",
    "陃" => "Bing", "附" => "Fu", "际" => "Ji", "陆" => "Lu", "陇" => "Long", "陈" => "Chen",
    "陉" => "Xing", "陊" => "Duo", "陋" => "Lou", "陌" => "Mo", "降" => "Jiang", "陎" => "Shu",
    "陏" => "Duo", "限" => "Xian", "陑" => "Er", "陒" => "Gui", "陓" => "Yu", "陔" => "Gai",
    "陕" => "Shan", "陖" => "Xun", "陗" => "Qiao", "陘" => "Xing", "陙" => "Chun", "陚" => "Fu",
    "陛" => "Bi", "陜" => "Xia", "陝" => "Shan", "陞" => "Sheng", "陟" => "Zhi", "陠" => "Pu",
    "陡" => "Dou", "院" => "Yuan", "陣" => "Zhen", "除" => "Chu", "陥" => "Xian", "陦" => "Tou",
    "陧" => "Nie", "陨" => "Yun", "险" => "Xian", "陪" => "Pei", "陫" => "Pei", "陬" => "Zou",
    "陭" => "Yi", "陮" => "Dui", "陯" => "Lun", "陰" => "Yin", "陱" => "Ju", "陲" => "Chui",
    "陳" => "Chen", "陴" => "Pi", "陵" => "Ling", "陶" => "Tao", "陷" => "Xian", "陸" => "Lu",
    "陹" => "Sheng", "険" => "Xian", "陻" => "Yin", "陼" => "Zhu", "陽" => "Yang", "陾" => "Reng",
    "陿" => "Shan", "隀" => "Chong", "隁" => "Yan", "隂" => "Yin", "隃" => "Yu", "隄" => "Ti",
    "隅" => "Yu", "隆" => "Long", "隇" => "Wei", "隈" => "Wei", "隉" => "Nie", "隊" => "Dui",
    "隋" => "Sui", "隌" => "An", "隍" => "Huang", "階" => "Jie", "随" => "Sui", "隐" => "Yin",
    "隑" => "Gai", "隒" => "Yan", "隓" => "Hui", "隔" => "Ge", "隕" => "Yun", "隖" => "Wu",
    "隗" => "Wei", "隘" => "Ai", "隙" => "Xi", "隚" => "Tang", "際" => "Ji", "障" => "Zhang",
    "隝" => "Dao", "隞" => "Ao", "隟" => "Xi", "隠" => "Yin", "隢" => "Rao", "隣" => "Lin",
    "隤" => "Tui", "隥" => "Deng", "隦" => "Pi", "隧" => "Sui", "隨" => "Sui", "隩" => "Yu",
    "險" => "Xian", "隫" => "Fen", "隬" => "Ni", "隭" => "Er", "隮" => "Ji", "隯" => "Dao",
    "隰" => "Xi", "隱" => "Yin", "隲" => "E", "隳" => "Hui", "隴" => "Long", "隵" => "Xi",
    "隶" => "Li", "隷" => "Li", "隸" => "Li", "隹" => "Zhui", "隺" => "He", "隻" => "Zhi",
    "隼" => "Zhun", "隽" => "Jun", "难" => "Nan", "隿" => "Yi", "雀" => "Que", "雁" => "Yan",
    "雂" => "Qian", "雃" => "Ya", "雄" => "Xiong", "雅" => "Ya", "集" => "Ji", "雇" => "Gu",
    "雈" => "Huan", "雉" => "Zhi", "雊" => "Gou", "雋" => "Jun", "雌" => "Ci", "雍" => "Yong",
    "雎" => "Ju", "雏" => "Chu", "雐" => "Hu", "雑" => "Za", "雒" => "Luo", "雓" => "Yu",
    "雔" => "Chou", "雕" => "Diao", "雖" => "Sui", "雗" => "Han", "雘" => "Huo", "雙" => "Shuang",
    "雚" => "Guan", "雛" => "Chu", "雜" => "Za", "雝" => "Yong", "雞" => "Ji", "雟" => "Xi",
    "雠" => "Chou", "雡" => "Liu", "離" => "Li", "難" => "Nan", "雤" => "Xue", "雥" => "Za",
    "雦" => "Ji", "雧" => "Ji", "雨" => "Yu", "雩" => "Yu", "雪" => "Xue", "雫" => "Na",
    "雬" => "Fou", "雭" => "Se", "雮" => "Mu", "雯" => "Wen", "雰" => "Fen", "雱" => "Pang",
    "雲" => "Yun", "雳" => "Li", "雴" => "Li", "雵" => "Ang", "零" => "Ling", "雷" => "Lei",
    "雸" => "An", "雹" => "Bao", "雺" => "Meng", "電" => "Dian", "雼" => "Dang", "雽" => "Xing",
    "雾" => "Wu", "雿" => "Zhao", "霁" => "Ji", "霂" => "Mu", "霃" => "Chen", "霄" => "Xiao",
    "霅" => "Zha", "霆" => "Ting", "震" => "Zhen", "霈" => "Pei", "霉" => "Mei", "霊" => "Ling",
    "霋" => "Qi", "霌" => "Chou", "霍" => "Huo", "霎" => "Sha", "霏" => "Fei", "霐" => "Weng",
    "霑" => "Zhan", "霒" => "Yin", "霓" => "Ni", "霔" => "Chou", "霕" => "Tun", "霖" => "Lin",
    "霘" => "Dong", "霙" => "Ying", "霚" => "Wu", "霛" => "Ling", "霜" => "Shuang", "霝" => "Ling",
    "霞" => "Xia", "霟" => "Hong", "霠" => "Yin", "霡" => "Mo", "霢" => "Mai", "霣" => "Yun",
    "霤" => "Liu", "霥" => "Meng", "霦" => "Bin", "霧" => "Wu", "霨" => "Wei", "霩" => "Huo",
    "霪" => "Yin", "霫" => "Xi", "霬" => "Yi", "霭" => "Ai", "霮" => "Dan", "霯" => "Deng",
    "霰" => "Xian", "霱" => "Yu", "露" => "Lu", "霳" => "Long", "霴" => "Dai", "霵" => "Ji",
    "霶" => "Pang", "霷" => "Yang", "霸" => "Ba", "霹" => "Pi", "霺" => "Wei", "霼" => "Xi",
    "霽" => "Ji", "霾" => "Mai", "霿" => "Meng", "靀" => "Meng", "靁" => "Lei", "靂" => "Li",
    "靃" => "Huo", "靄" => "Ai", "靅" => "Fei", "靆" => "Dai", "靇" => "Long", "靈" => "Ling",
    "靉" => "Ai", "靊" => "Feng", "靋" => "Li", "靌" => "Bao", "靎" => "He", "靏" => "He",
    "靐" => "Bing", "靑" => "Qing", "青" => "Qing", "靓" => "Jing", "靔" => "Tian", "靕" => "Zhen",
    "靖" => "Jing", "靗" => "Cheng", "靘" => "Qing", "静" => "Jing", "靚" => "Jing", "靛" => "Dian",
    "靜" => "Jing", "靝" => "Tian", "非" => "Fei", "靟" => "Fei", "靠" => "Kao", "靡" => "Mi",
    "面" => "Mian", "靣" => "Mian", "靤" => "Pao", "靥" => "Ye", "靦" => "Tian", "靧" => "Hui",
    "靨" => "Ye", "革" => "Ge", "靪" => "Ding", "靫" => "Cha", "靬" => "Jian", "靭" => "Ren",
    "靮" => "Di", "靯" => "Du", "靰" => "Wu", "靱" => "Ren", "靲" => "Qin", "靳" => "Jin",
    "靴" => "Xue", "靵" => "Niu", "靶" => "Ba", "靷" => "Yin", "靸" => "Sa", "靹" => "Na",
    "靺" => "Mo", "靻" => "Zu", "靼" => "Da", "靽" => "Ban", "靾" => "Yi", "靿" => "Yao",
    "鞀" => "Tao", "鞁" => "Tuo", "鞂" => "Jia", "鞃" => "Hong", "鞄" => "Pao", "鞅" => "Yang",
    "鞆" => "Tomo", "鞇" => "Yin", "鞈" => "Jia", "鞉" => "Tao", "鞊" => "Ji", "鞋" => "Xie",
    "鞌" => "An", "鞍" => "An", "鞎" => "Hen", "鞏" => "Gong", "鞐" => "Kohaze", "鞑" => "Da",
    "鞒" => "Qiao", "鞓" => "Ting", "鞔" => "Wan", "鞕" => "Ying", "鞖" => "Sui", "鞗" => "Tiao",
    "鞘" => "Qiao", "鞙" => "Xuan", "鞚" => "Kong", "鞛" => "Beng", "鞜" => "Ta", "鞝" => "Zhang",
    "鞞" => "Bing", "鞟" => "Kuo", "鞠" => "Ju", "鞡" => "La", "鞢" => "Xie", "鞣" => "Rou",
    "鞤" => "Bang", "鞥" => "Yi", "鞦" => "Qiu", "鞧" => "Qiu", "鞨" => "He", "鞩" => "Xiao",
    "鞪" => "Mu", "鞫" => "Ju", "鞬" => "Jian", "鞭" => "Bian", "鞮" => "Di", "鞯" => "Jian",
    "鞰" => "On", "鞱" => "Tao", "鞲" => "Gou", "鞳" => "Ta", "鞴" => "Bei", "鞵" => "Xie",
    "鞶" => "Pan", "鞷" => "Ge", "鞸" => "Bi", "鞹" => "Kuo", "鞺" => "Tang", "鞻" => "Lou",
    "鞼" => "Gui", "鞽" => "Qiao", "鞾" => "Xue", "鞿" => "Ji", "韀" => "Jian", "韁" => "Jiang",
    "韂" => "Chan", "韃" => "Da", "韄" => "Huo", "韅" => "Xian", "韆" => "Qian", "韇" => "Du",
    "韈" => "Wa", "韉" => "Jian", "韊" => "Lan", "韋" => "Wei", "韌" => "Ren", "韍" => "Fu",
    "韎" => "Mei", "韏" => "Juan", "韐" => "Ge", "韑" => "Wei", "韒" => "Qiao", "韓" => "Han",
    "韔" => "Chang", "韖" => "Rou", "韗" => "Xun", "韘" => "She", "韙" => "Wei", "韚" => "Ge",
    "韛" => "Bei", "韜" => "Tao", "韝" => "Gou", "韞" => "Yun", "韠" => "Bi", "韡" => "Wei",
    "韢" => "Hui", "韣" => "Du", "韤" => "Wa", "韥" => "Du", "韦" => "Wei", "韧" => "Ren",
    "韨" => "Fu", "韩" => "Han", "韪" => "Wei", "韫" => "Yun", "韬" => "Tao", "韭" => "Jiu",
    "韮" => "Jiu", "韯" => "Xian", "韰" => "Xie", "韱" => "Xian", "韲" => "Ji", "音" => "Yin",
    "韴" => "Za", "韵" => "Yun", "韶" => "Shao", "韷" => "Le", "韸" => "Peng", "韹" => "Heng",
    "韺" => "Ying", "韻" => "Yun", "韼" => "Peng", "韽" => "Yin", "韾" => "Yin", "響" => "Xiang",
    "頁" => "Ye", "頂" => "Ding", "頃" => "Qing", "頄" => "Pan", "項" => "Xiang", "順" => "Shun",
    "頇" => "Han", "須" => "Xu", "頉" => "Yi", "頊" => "Xu", "頋" => "Gu", "頌" => "Song",
    "頍" => "Kui", "頎" => "Qi", "頏" => "Hang", "預" => "Yu", "頑" => "Wan", "頒" => "Ban",
    "頓" => "Dun", "頔" => "Di", "頕" => "Dan", "頖" => "Pan", "頗" => "Po", "領" => "Ling",
    "頙" => "Ce", "頚" => "Jing", "頛" => "Lei", "頜" => "He", "頝" => "Qiao", "頞" => "E",
    "頟" => "E", "頠" => "Wei", "頡" => "Jie", "頢" => "Gua", "頣" => "Shen", "頤" => "Yi",
    "頥" => "Shen", "頦" => "Hai", "頧" => "Dui", "頨" => "Pian", "頩" => "Ping", "頪" => "Lei",
    "頫" => "Fu", "頬" => "Jia", "頭" => "Tou", "頮" => "Hui", "頯" => "Kui", "頰" => "Jia",
    "頱" => "Le", "頲" => "Tian", "頳" => "Cheng", "頴" => "Ying", "頵" => "Jun", "頶" => "Hu",
    "頷" => "Han", "頸" => "Jing", "頹" => "Tui", "頺" => "Tui", "頻" => "Pin", "頼" => "Lai",
    "頽" => "Tui", "頾" => "Zi", "頿" => "Zi", "顀" => "Chui", "顁" => "Ding", "顂" => "Lai",
    "顃" => "Yan", "顄" => "Han", "顅" => "Jian", "顆" => "Ke", "顇" => "Cui", "顈" => "Jiong",
    "顉" => "Qin", "顊" => "Yi", "顋" => "Sai", "題" => "Ti", "額" => "E", "顎" => "E",
    "顏" => "Yan", "顐" => "Hun", "顑" => "Kan", "顒" => "Yong", "顓" => "Zhuan", "顔" => "Yan",
    "顕" => "Xian", "顖" => "Xin", "顗" => "Yi", "願" => "Yuan", "顙" => "Sang", "顚" => "Dian",
    "顛" => "Dian", "顜" => "Jiang", "顝" => "Ku", "類" => "Lei", "顟" => "Liao", "顠" => "Piao",
    "顡" => "Yi", "顢" => "Man", "顣" => "Qi", "顤" => "Rao", "顥" => "Hao", "顦" => "Qiao",
    "顧" => "Gu", "顨" => "Xun", "顩" => "Qian", "顪" => "Hui", "顫" => "Zhan", "顬" => "Ru",
    "顭" => "Hong", "顮" => "Bin", "顯" => "Xian", "顰" => "Pin", "顱" => "Lu", "顲" => "Lan",
    "顳" => "Nie", "顴" => "Quan", "页" => "Ye", "顶" => "Ding", "顷" => "Qing", "顸" => "Han",
    "项" => "Xiang", "顺" => "Shun", "须" => "Xu", "顼" => "Xu", "顽" => "Wan", "顾" => "Gu",
    "顿" => "Dun", "颀" => "Qi", "颁" => "Ban", "颂" => "Song", "颃" => "Hang", "预" => "Yu",
    "颅" => "Lu", "领" => "Ling", "颇" => "Po", "颈" => "Jing", "颉" => "Jie", "颊" => "Jia",
    "颋" => "Tian", "颌" => "Han", "颍" => "Ying", "颎" => "Jiong", "颏" => "Hai", "颐" => "Yi",
    "频" => "Pin", "颒" => "Hui", "颓" => "Tui", "颔" => "Han", "颕" => "Ying", "颖" => "Ying",
    "颗" => "Ke", "题" => "Ti", "颙" => "Yong", "颚" => "E", "颛" => "Zhuan", "颜" => "Yan",
    "额" => "E", "颞" => "Nie", "颟" => "Man", "颠" => "Dian", "颡" => "Sang", "颢" => "Hao",
    "颣" => "Lei", "颤" => "Zhan", "颥" => "Ru", "颦" => "Pin", "颧" => "Quan", "風" => "Feng",
    "颩" => "Biao", "颪" => "Oroshi", "颫" => "Fu", "颬" => "Xia", "颭" => "Zhan", "颮" => "Biao",
    "颯" => "Sa", "颰" => "Ba", "颱" => "Tai", "颲" => "Lie", "颳" => "Gua", "颴" => "Xuan",
    "颵" => "Shao", "颶" => "Ju", "颷" => "Bi", "颸" => "Si", "颹" => "Wei", "颺" => "Yang",
    "颻" => "Yao", "颼" => "Sou", "颽" => "Kai", "颾" => "Sao", "颿" => "Fan", "飀" => "Liu",
    "飁" => "Xi", "飂" => "Liao", "飃" => "Piao", "飄" => "Piao", "飅" => "Liu", "飆" => "Biao",
    "飇" => "Biao", "飈" => "Biao", "飉" => "Liao", "飋" => "Se", "飌" => "Feng", "飍" => "Biao",
    "风" => "Feng", "飏" => "Yang", "飐" => "Zhan", "飑" => "Biao", "飒" => "Sa", "飓" => "Ju",
    "飔" => "Si", "飕" => "Sou", "飖" => "Yao", "飗" => "Liu", "飘" => "Piao", "飙" => "Biao",
    "飚" => "Biao", "飛" => "Fei", "飜" => "Fan", "飝" => "Fei", "飞" => "Fei", "食" => "Shi",
    "飠" => "Shi", "飡" => "Can", "飢" => "Ji", "飣" => "Ding", "飤" => "Si", "飥" => "Tuo",
    "飦" => "Zhan", "飧" => "Sun", "飨" => "Xiang", "飩" => "Tun", "飪" => "Ren", "飫" => "Yu",
    "飬" => "Juan", "飭" => "Chi", "飮" => "Yin", "飯" => "Fan", "飰" => "Fan", "飱" => "Sun",
    "飲" => "Yin", "飳" => "Zhu", "飴" => "Yi", "飵" => "Zhai", "飶" => "Bi", "飷" => "Jie",
    "飸" => "Tao", "飹" => "Liu", "飺" => "Ci", "飻" => "Tie", "飼" => "Si", "飽" => "Bao",
    "飾" => "Shi", "飿" => "Duo", "餁" => "Ren", "餂" => "Tian", "餃" => "Jiao", "餄" => "Jia",
    "餅" => "Bing", "餆" => "Yao", "餇" => "Tong", "餈" => "Ci", "餉" => "Xiang", "養" => "Yang",
    "餋" => "Yang", "餌" => "Er", "餍" => "Yan", "餎" => "Le", "餏" => "Yi", "餐" => "Can",
    "餑" => "Bo", "餒" => "Nei", "餓" => "E", "餔" => "Bu", "餕" => "Jun", "餖" => "Dou",
    "餗" => "Su", "餘" => "Yu", "餙" => "Shi", "餚" => "Yao", "餛" => "Hun", "餜" => "Guo",
    "餝" => "Shi", "餞" => "Jian", "餟" => "Zhui", "餠" => "Bing", "餡" => "Xian", "餢" => "Bu",
    "餣" => "Ye", "餤" => "Tan", "餥" => "Fei", "餦" => "Zhang", "餧" => "Wei", "館" => "Guan",
    "餩" => "E", "餪" => "Nuan", "餫" => "Hun", "餬" => "Hu", "餭" => "Huang", "餮" => "Tie",
    "餯" => "Hui", "餰" => "Jian", "餱" => "Hou", "餲" => "He", "餳" => "Xing", "餴" => "Fen",
    "餵" => "Wei", "餶" => "Gu", "餷" => "Cha", "餸" => "Song", "餹" => "Tang", "餺" => "Bo",
    "餻" => "Gao", "餼" => "Xi", "餽" => "Kui", "餾" => "Liu", "餿" => "Sou", "饀" => "Tao",
    "饁" => "Ye", "饂" => "Yun", "饃" => "Mo", "饄" => "Tang", "饅" => "Man", "饆" => "Bi",
    "饇" => "Yu", "饈" => "Xiu", "饉" => "Jin", "饊" => "San", "饋" => "Kui", "饌" => "Zhuan",
    "饍" => "Shan", "饎" => "Chi", "饏" => "Dan", "饐" => "Yi", "饑" => "Ji", "饒" => "Rao",
    "饓" => "Cheng", "饔" => "Yong", "饕" => "Tao", "饖" => "Hui", "饗" => "Xiang", "饘" => "Zhan",
    "饙" => "Fen", "饚" => "Hai", "饛" => "Meng", "饜" => "Yan", "饝" => "Mo", "饞" => "Chan",
    "饟" => "Xiang", "饠" => "Luo", "饡" => "Zuan", "饢" => "Nang", "饣" => "Shi", "饤" => "Ding",
    "饥" => "Ji", "饦" => "Tuo", "饧" => "Xing", "饨" => "Tun", "饩" => "Xi", "饪" => "Ren",
    "饫" => "Yu", "饬" => "Chi", "饭" => "Fan", "饮" => "Yin", "饯" => "Jian", "饰" => "Shi",
    "饱" => "Bao", "饲" => "Si", "饳" => "Duo", "饴" => "Yi", "饵" => "Er", "饶" => "Rao",
    "饷" => "Xiang", "饸" => "Jia", "饹" => "Le", "饺" => "Jiao", "饻" => "Yi", "饼" => "Bing",
    "饽" => "Bo", "饾" => "Dou", "饿" => "E", "馀" => "Yu", "馁" => "Nei", "馂" => "Jun",
    "馃" => "Guo", "馄" => "Hun", "馅" => "Xian", "馆" => "Guan", "馇" => "Cha", "馈" => "Kui",
    "馉" => "Gu", "馊" => "Sou", "馋" => "Chan", "馌" => "Ye", "馍" => "Mo", "馎" => "Bo",
    "馏" => "Liu", "馐" => "Xiu", "馑" => "Jin", "馒" => "Man", "馓" => "San", "馔" => "Zhuan",
    "馕" => "Nang", "首" => "Shou", "馗" => "Kui", "馘" => "Guo", "香" => "Xiang", "馚" => "Fen",
    "馛" => "Ba", "馜" => "Ni", "馝" => "Bi", "馞" => "Bo", "馟" => "Tu", "馠" => "Han",
    "馡" => "Fei", "馢" => "Jian", "馣" => "An", "馤" => "Ai", "馥" => "Fu", "馦" => "Xian",
    "馧" => "Wen", "馨" => "Xin", "馩" => "Fen", "馪" => "Bin", "馫" => "Xing", "馬" => "Ma",
    "馭" => "Yu", "馮" => "Feng", "馯" => "Han", "馰" => "Di", "馱" => "Tuo", "馲" => "Tuo",
    "馳" => "Chi", "馴" => "Xun", "馵" => "Zhu", "馶" => "Zhi", "馷" => "Pei", "馸" => "Xin",
    "馹" => "Ri", "馺" => "Sa", "馻" => "Yin", "馼" => "Wen", "馽" => "Zhi", "馾" => "Dan",
    "馿" => "Lu", "駀" => "You", "駁" => "Bo", "駂" => "Bao", "駃" => "Kuai", "駄" => "Tuo",
    "駅" => "Yi", "駆" => "Qu", "駈" => "Qu", "駉" => "Jiong", "駊" => "Bo", "駋" => "Zhao",
    "駌" => "Yuan", "駍" => "Peng", "駎" => "Zhou", "駏" => "Ju", "駐" => "Zhu", "駑" => "Nu",
    "駒" => "Ju", "駓" => "Pi", "駔" => "Zang", "駕" => "Jia", "駖" => "Ling", "駗" => "Zhen",
    "駘" => "Tai", "駙" => "Fu", "駚" => "Yang", "駛" => "Shi", "駜" => "Bi", "駝" => "Tuo",
    "駞" => "Tuo", "駟" => "Si", "駠" => "Liu", "駡" => "Ma", "駢" => "Pian", "駣" => "Tao",
    "駤" => "Zhi", "駥" => "Rong", "駦" => "Teng", "駧" => "Dong", "駨" => "Xun", "駩" => "Quan",
    "駪" => "Shen", "駫" => "Jiong", "駬" => "Er", "駭" => "Hai", "駮" => "Bo", "駯" => "Zhu",
    "駰" => "Yin", "駱" => "Luo", "駲" => "Shuu", "駳" => "Dan", "駴" => "Xie", "駵" => "Liu",
    "駶" => "Ju", "駷" => "Song", "駸" => "Qin", "駹" => "Mang", "駺" => "Liang", "駻" => "Han",
    "駼" => "Tu", "駽" => "Xuan", "駾" => "Tui", "駿" => "Jun", "騁" => "Cheng", "騂" => "Xin",
    "騃" => "Ai", "騄" => "Lu", "騅" => "Zhui", "騆" => "Zhou", "騇" => "She", "騈" => "Pian",
    "騉" => "Kun", "騊" => "Tao", "騋" => "Lai", "騌" => "Zong", "騍" => "Ke", "騎" => "Qi",
    "騏" => "Qi", "騐" => "Yan", "騑" => "Fei", "騒" => "Sao", "験" => "Yan", "騔" => "Jie",
    "騕" => "Yao", "騖" => "Wu", "騗" => "Pian", "騘" => "Cong", "騙" => "Pian", "騚" => "Qian",
    "騛" => "Fei", "騜" => "Huang", "騝" => "Jian", "騞" => "Huo", "騟" => "Yu", "騠" => "Ti",
    "騡" => "Quan", "騢" => "Xia", "騣" => "Zong", "騤" => "Kui", "騥" => "Rou", "騦" => "Si",
    "騧" => "Gua", "騨" => "Tuo", "騩" => "Kui", "騪" => "Sou", "騫" => "Qian", "騬" => "Cheng",
    "騭" => "Zhi", "騮" => "Liu", "騯" => "Pang", "騰" => "Teng", "騱" => "Xi", "騲" => "Cao",
    "騳" => "Du", "騴" => "Yan", "騵" => "Yuan", "騶" => "Zou", "騷" => "Sao", "騸" => "Shan",
    "騹" => "Li", "騺" => "Zhi", "騻" => "Shuang", "騼" => "Lu", "騽" => "Xi", "騾" => "Luo",
    "騿" => "Zhang", "驀" => "Mo", "驁" => "Ao", "驂" => "Can", "驃" => "Piao", "驄" => "Cong",
    "驅" => "Qu", "驆" => "Bi", "驇" => "Zhi", "驈" => "Yu", "驉" => "Xu", "驊" => "Hua",
    "驋" => "Bo", "驌" => "Su", "驍" => "Xiao", "驎" => "Lin", "驏" => "Chan", "驐" => "Dun",
    "驑" => "Liu", "驒" => "Tuo", "驓" => "Zeng", "驔" => "Tan", "驕" => "Jiao", "驖" => "Tie",
    "驗" => "Yan", "驘" => "Luo", "驙" => "Zhan", "驚" => "Jing", "驛" => "Yi", "驜" => "Ye",
    "驝" => "Tuo", "驞" => "Bin", "驟" => "Zou", "驠" => "Yan", "驡" => "Peng", "驢" => "Lu",
    "驣" => "Teng", "驤" => "Xiang", "驥" => "Ji", "驦" => "Shuang", "驧" => "Ju", "驨" => "Xi",
    "驩" => "Huan", "驪" => "Li", "驫" => "Biao", "马" => "Ma", "驭" => "Yu", "驮" => "Tuo",
    "驯" => "Xun", "驰" => "Chi", "驱" => "Qu", "驲" => "Ri", "驳" => "Bo", "驴" => "Lu",
    "驵" => "Zang", "驶" => "Shi", "驷" => "Si", "驸" => "Fu", "驹" => "Ju", "驺" => "Zou",
    "驻" => "Zhu", "驼" => "Tuo", "驽" => "Nu", "驾" => "Jia", "驿" => "Yi", "骀" => "Tai",
    "骁" => "Xiao", "骂" => "Ma", "骃" => "Yin", "骄" => "Jiao", "骅" => "Hua", "骆" => "Luo",
    "骇" => "Hai", "骈" => "Pian", "骉" => "Biao", "骊" => "Li", "骋" => "Cheng", "验" => "Yan",
    "骍" => "Xin", "骎" => "Qin", "骏" => "Jun", "骐" => "Qi", "骑" => "Qi", "骒" => "Ke",
    "骓" => "Zhui", "骔" => "Zong", "骕" => "Su", "骖" => "Can", "骗" => "Pian", "骘" => "Zhi",
    "骙" => "Kui", "骚" => "Sao", "骛" => "Wu", "骜" => "Ao", "骝" => "Liu", "骞" => "Qian",
    "骟" => "Shan", "骠" => "Piao", "骡" => "Luo", "骢" => "Cong", "骣" => "Chan", "骤" => "Zou",
    "骥" => "Ji", "骦" => "Shuang", "骧" => "Xiang", "骨" => "Gu", "骩" => "Wei", "骪" => "Wei",
    "骫" => "Wei", "骬" => "Yu", "骭" => "Gan", "骮" => "Yi", "骯" => "Ang", "骰" => "Tou",
    "骱" => "Xie", "骲" => "Bao", "骳" => "Bi", "骴" => "Chi", "骵" => "Ti", "骶" => "Di",
    "骷" => "Ku", "骸" => "Hai", "骹" => "Qiao", "骺" => "Gou", "骻" => "Kua", "骼" => "Ge",
    "骽" => "Tui", "骾" => "Geng", "骿" => "Pian", "髀" => "Bi", "髁" => "Ke", "髂" => "Ka",
    "髃" => "Yu", "髄" => "Sui", "髅" => "Lou", "髆" => "Bo", "髇" => "Xiao", "髈" => "Pang",
    "髉" => "Bo", "髊" => "Ci", "髋" => "Kuan", "髌" => "Bin", "髍" => "Mo", "髎" => "Liao",
    "髏" => "Lou", "髐" => "Nao", "髑" => "Du", "髒" => "Zang", "髓" => "Sui", "體" => "Ti",
    "髕" => "Bin", "髖" => "Kuan", "髗" => "Lu", "高" => "Gao", "髙" => "Gao", "髚" => "Qiao",
    "髛" => "Kao", "髜" => "Qiao", "髝" => "Lao", "髞" => "Zao", "髟" => "Biao", "髠" => "Kun",
    "髡" => "Kun", "髢" => "Ti", "髣" => "Fang", "髤" => "Xiu", "髥" => "Ran", "髦" => "Mao",
    "髧" => "Dan", "髨" => "Kun", "髩" => "Bin", "髪" => "Fa", "髫" => "Tiao", "髬" => "Peng",
    "髭" => "Zi", "髮" => "Fa", "髯" => "Ran", "髰" => "Ti", "髱" => "Pao", "髲" => "Pi",
    "髳" => "Mao", "髴" => "Fu", "髵" => "Er", "髶" => "Rong", "髷" => "Qu", "髸" => "Gong",
    "髹" => "Xiu", "髺" => "Gua", "髻" => "Ji", "髼" => "Peng", "髽" => "Zhua", "髾" => "Shao",
    "髿" => "Sha", "鬁" => "Li", "鬂" => "Bin", "鬃" => "Zong", "鬄" => "Ti", "鬅" => "Peng",
    "鬆" => "Song", "鬇" => "Zheng", "鬈" => "Quan", "鬉" => "Zong", "鬊" => "Shun", "鬋" => "Jian",
    "鬌" => "Duo", "鬍" => "Hu", "鬎" => "La", "鬏" => "Jiu", "鬐" => "Qi", "鬑" => "Lian",
    "鬒" => "Zhen", "鬓" => "Bin", "鬔" => "Peng", "鬕" => "Mo", "鬖" => "San", "鬗" => "Man",
    "鬘" => "Man", "鬙" => "Seng", "鬚" => "Xu", "鬛" => "Lie", "鬜" => "Qian", "鬝" => "Qian",
    "鬞" => "Nong", "鬟" => "Huan", "鬠" => "Kuai", "鬡" => "Ning", "鬢" => "Bin", "鬣" => "Lie",
    "鬤" => "Rang", "鬥" => "Dou", "鬦" => "Dou", "鬧" => "Nao", "鬨" => "Hong", "鬩" => "Xi",
    "鬪" => "Dou", "鬫" => "Han", "鬬" => "Dou", "鬭" => "Dou", "鬮" => "Jiu", "鬯" => "Chang",
    "鬰" => "Yu", "鬱" => "Yu", "鬲" => "Li", "鬳" => "Juan", "鬴" => "Fu", "鬵" => "Qian",
    "鬶" => "Gui", "鬷" => "Zong", "鬸" => "Liu", "鬹" => "Gui", "鬺" => "Shang", "鬻" => "Yu",
    "鬼" => "Gui", "鬽" => "Mei", "鬾" => "Ji", "鬿" => "Qi", "魀" => "Jie", "魁" => "Kui",
    "魂" => "Hun", "魃" => "Ba", "魄" => "Po", "魅" => "Mei", "魆" => "Xu", "魇" => "Yan",
    "魈" => "Xiao", "魉" => "Liang", "魊" => "Yu", "魋" => "Tui", "魌" => "Qi", "魍" => "Wang",
    "魎" => "Liang", "魏" => "Wei", "魐" => "Jian", "魑" => "Chi", "魒" => "Piao", "魓" => "Bi",
    "魔" => "Mo", "魕" => "Ji", "魖" => "Xu", "魗" => "Chou", "魘" => "Yan", "魙" => "Zhan",
    "魚" => "Yu", "魛" => "Dao", "魜" => "Ren", "魝" => "Ji", "魞" => "Eri", "魟" => "Gong",
    "魠" => "Tuo", "魡" => "Diao", "魢" => "Ji", "魣" => "Xu", "魤" => "E", "魥" => "E",
    "魦" => "Sha", "魧" => "Hang", "魨" => "Tun", "魩" => "Mo", "魪" => "Jie", "魫" => "Shen",
    "魬" => "Fan", "魭" => "Yuan", "魮" => "Bi", "魯" => "Lu", "魰" => "Wen", "魱" => "Hu",
    "魲" => "Lu", "魳" => "Za", "魴" => "Fang", "魵" => "Fen", "魶" => "Na", "魷" => "You",
    "魸" => "Namazu", "魹" => "Todo", "魺" => "He", "魻" => "Xia", "魼" => "Qu", "魽" => "Han",
    "魾" => "Pi", "魿" => "Ling", "鮀" => "Tuo", "鮁" => "Bo", "鮂" => "Qiu", "鮃" => "Ping",
    "鮄" => "Fu", "鮅" => "Bi", "鮆" => "Ji", "鮇" => "Wei", "鮈" => "Ju", "鮉" => "Diao",
    "鮊" => "Bo", "鮋" => "You", "鮌" => "Gun", "鮍" => "Pi", "鮎" => "Nian", "鮏" => "Xing",
    "鮐" => "Tai", "鮑" => "Bao", "鮒" => "Fu", "鮓" => "Zha", "鮔" => "Ju", "鮕" => "Gu",
    "鮖" => "Kajika", "鮗" => "Tong", "鮙" => "Ta", "鮚" => "Jie", "鮛" => "Shu", "鮜" => "Hou",
    "鮝" => "Xiang", "鮞" => "Er", "鮟" => "An", "鮠" => "Wei", "鮡" => "Tiao", "鮢" => "Zhu",
    "鮣" => "Yin", "鮤" => "Lie", "鮥" => "Luo", "鮦" => "Tong", "鮧" => "Yi", "鮨" => "Qi",
    "鮩" => "Bing", "鮪" => "Wei", "鮫" => "Jiao", "鮬" => "Bu", "鮭" => "Gui", "鮮" => "Xian",
    "鮯" => "Ge", "鮰" => "Hui", "鮱" => "Bora", "鮲" => "Mate", "鮳" => "Kao", "鮴" => "Gori",
    "鮵" => "Duo", "鮶" => "Jun", "鮷" => "Ti", "鮸" => "Man", "鮹" => "Xiao", "鮺" => "Za",
    "鮻" => "Sha", "鮼" => "Qin", "鮽" => "Yu", "鮾" => "Nei", "鮿" => "Zhe", "鯀" => "Gun",
    "鯁" => "Geng", "鯂" => "Su", "鯃" => "Wu", "鯄" => "Qiu", "鯅" => "Ting", "鯆" => "Fu",
    "鯇" => "Wan", "鯈" => "You", "鯉" => "Li", "鯊" => "Sha", "鯋" => "Sha", "鯌" => "Gao",
    "鯍" => "Meng", "鯎" => "Ugui", "鯏" => "Asari", "鯐" => "Subashiri", "鯑" => "Kazunoko", "鯒" => "Yong",
    "鯓" => "Ni", "鯔" => "Zi", "鯕" => "Qi", "鯖" => "Qing", "鯗" => "Xiang", "鯘" => "Nei",
    "鯙" => "Chun", "鯚" => "Ji", "鯛" => "Diao", "鯜" => "Qie", "鯝" => "Gu", "鯞" => "Zhou",
    "鯟" => "Dong", "鯠" => "Lai", "鯡" => "Fei", "鯢" => "Ni", "鯣" => "Yi", "鯤" => "Kun",
    "鯥" => "Lu", "鯦" => "Jiu", "鯧" => "Chang", "鯨" => "Jing", "鯩" => "Lun", "鯪" => "Ling",
    "鯫" => "Zou", "鯬" => "Li", "鯭" => "Meng", "鯮" => "Zong", "鯯" => "Zhi", "鯰" => "Nian",
    "鯱" => "Shachi", "鯲" => "Dojou", "鯳" => "Sukesou", "鯴" => "Shi", "鯵" => "Shen", "鯶" => "Hun",
    "鯷" => "Shi", "鯸" => "Hou", "鯹" => "Xing", "鯺" => "Zhu", "鯻" => "La", "鯼" => "Zong",
    "鯽" => "Ji", "鯾" => "Bian", "鯿" => "Bian", "鰁" => "Quan", "鰂" => "Ze", "鰃" => "Wei",
    "鰄" => "Wei", "鰅" => "Yu", "鰆" => "Qun", "鰇" => "Rou", "鰈" => "Die", "鰉" => "Huang",
    "鰊" => "Lian", "鰋" => "Yan", "鰌" => "Qiu", "鰍" => "Qiu", "鰎" => "Jian", "鰏" => "Bi",
    "鰐" => "E", "鰑" => "Yang", "鰒" => "Fu", "鰓" => "Sai", "鰔" => "Jian", "鰕" => "Xia",
    "鰖" => "Tuo", "鰗" => "Hu", "鰘" => "Muroaji", "鰙" => "Ruo", "鰚" => "Haraka", "鰛" => "Wen",
    "鰜" => "Jian", "鰝" => "Hao", "鰞" => "Wu", "鰟" => "Fang", "鰠" => "Sao", "鰡" => "Liu",
    "鰢" => "Ma", "鰣" => "Shi", "鰤" => "Shi", "鰥" => "Yin", "鰦" => "Z", "鰧" => "Teng",
    "鰨" => "Ta", "鰩" => "Yao", "鰪" => "Ge", "鰫" => "Rong", "鰬" => "Qian", "鰭" => "Qi",
    "鰮" => "Wen", "鰯" => "Ruo", "鰰" => "Hatahata", "鰱" => "Lian", "鰲" => "Ao", "鰳" => "Le",
    "鰴" => "Hui", "鰵" => "Min", "鰶" => "Ji", "鰷" => "Tiao", "鰸" => "Qu", "鰹" => "Jian",
    "鰺" => "Sao", "鰻" => "Man", "鰼" => "Xi", "鰽" => "Qiu", "鰾" => "Biao", "鰿" => "Ji",
    "鱀" => "Ji", "鱁" => "Zhu", "鱂" => "Jiang", "鱃" => "Qiu", "鱄" => "Zhuan", "鱅" => "Yong",
    "鱆" => "Zhang", "鱇" => "Kang", "鱈" => "Xue", "鱉" => "Bie", "鱊" => "Jue", "鱋" => "Qu",
    "鱌" => "Xiang", "鱍" => "Bo", "鱎" => "Jiao", "鱏" => "Xun", "鱐" => "Su", "鱑" => "Huang",
    "鱒" => "Zun", "鱓" => "Shan", "鱔" => "Shan", "鱕" => "Fan", "鱖" => "Jue", "鱗" => "Lin",
    "鱘" => "Xun", "鱙" => "Miao", "鱚" => "Xi", "鱛" => "Eso", "鱜" => "Kyou", "鱝" => "Fen",
    "鱞" => "Guan", "鱟" => "Hou", "鱠" => "Kuai", "鱡" => "Zei", "鱢" => "Sao", "鱣" => "Zhan",
    "鱤" => "Gan", "鱥" => "Gui", "鱦" => "Sheng", "鱧" => "Li", "鱨" => "Chang", "鱩" => "Hatahata",
    "鱪" => "Shiira", "鱫" => "Mutsu", "鱬" => "Ru", "鱭" => "Ji", "鱮" => "Xu", "鱯" => "Huo",
    "鱰" => "Shiira", "鱱" => "Li", "鱲" => "Lie", "鱳" => "Li", "鱴" => "Mie", "鱵" => "Zhen",
    "鱶" => "Xiang", "鱷" => "E", "鱸" => "Lu", "鱹" => "Guan", "鱺" => "Li", "鱻" => "Xian",
    "鱼" => "Yu", "鱽" => "Dao", "鱾" => "Ji", "鱿" => "You", "鲀" => "Tun", "鲁" => "Lu",
    "鲂" => "Fang", "鲃" => "Ba", "鲄" => "He", "鲅" => "Bo", "鲆" => "Ping", "鲇" => "Nian",
    "鲈" => "Lu", "鲉" => "You", "鲊" => "Zha", "鲋" => "Fu", "鲌" => "Bo", "鲍" => "Bao",
    "鲎" => "Hou", "鲏" => "Pi", "鲐" => "Tai", "鲑" => "Gui", "鲒" => "Jie", "鲓" => "Kao",
    "鲔" => "Wei", "鲕" => "Er", "鲖" => "Tong", "鲗" => "Ze", "鲘" => "Hou", "鲙" => "Kuai",
    "鲚" => "Ji", "鲛" => "Jiao", "鲜" => "Xian", "鲝" => "Za", "鲞" => "Xiang", "鲟" => "Xun",
    "鲠" => "Geng", "鲡" => "Li", "鲢" => "Lian", "鲣" => "Jian", "鲤" => "Li", "鲥" => "Shi",
    "鲦" => "Tiao", "鲧" => "Gun", "鲨" => "Sha", "鲩" => "Wan", "鲪" => "Jun", "鲫" => "Ji",
    "鲬" => "Yong", "鲭" => "Qing", "鲮" => "Ling", "鲯" => "Qi", "鲰" => "Zou", "鲱" => "Fei",
    "鲲" => "Kun", "鲳" => "Chang", "鲴" => "Gu", "鲵" => "Ni", "鲶" => "Nian", "鲷" => "Diao",
    "鲸" => "Jing", "鲹" => "Shen", "鲺" => "Shi", "鲻" => "Zi", "鲼" => "Fen", "鲽" => "Die",
    "鲾" => "Bi", "鲿" => "Chang", "鳀" => "Shi", "鳁" => "Wen", "鳂" => "Wei", "鳃" => "Sai",
    "鳄" => "E", "鳅" => "Qiu", "鳆" => "Fu", "鳇" => "Huang", "鳈" => "Quan", "鳉" => "Jiang",
    "鳊" => "Bian", "鳋" => "Sao", "鳌" => "Ao", "鳍" => "Qi", "鳎" => "Ta", "鳏" => "Yin",
    "鳐" => "Yao", "鳑" => "Fang", "鳒" => "Jian", "鳓" => "Le", "鳔" => "Biao", "鳕" => "Xue",
    "鳖" => "Bie", "鳗" => "Man", "鳘" => "Min", "鳙" => "Yong", "鳚" => "Wei", "鳛" => "Xi",
    "鳜" => "Jue", "鳝" => "Shan", "鳞" => "Lin", "鳟" => "Zun", "鳠" => "Huo", "鳡" => "Gan",
    "鳢" => "Li", "鳣" => "Zhan", "鳤" => "Guan", "鳥" => "Niao", "鳦" => "Yi", "鳧" => "Fu",
    "鳨" => "Li", "鳩" => "Jiu", "鳪" => "Bu", "鳫" => "Yan", "鳬" => "Fu", "鳭" => "Diao",
    "鳮" => "Ji", "鳯" => "Feng", "鳰" => "Nio", "鳱" => "Gan", "鳲" => "Shi", "鳳" => "Feng",
    "鳴" => "Ming", "鳵" => "Bao", "鳶" => "Yuan", "鳷" => "Zhi", "鳸" => "Hu", "鳹" => "Qin",
    "鳺" => "Fu", "鳻" => "Fen", "鳼" => "Wen", "鳽" => "Jian", "鳾" => "Shi", "鳿" => "Yu",
    "鴁" => "Yiao", "鴂" => "Jue", "鴃" => "Jue", "鴄" => "Pi", "鴅" => "Huan", "鴆" => "Zhen",
    "鴇" => "Bao", "鴈" => "Yan", "鴉" => "Ya", "鴊" => "Zheng", "鴋" => "Fang", "鴌" => "Feng",
    "鴍" => "Wen", "鴎" => "Ou", "鴏" => "Te", "鴐" => "Jia", "鴑" => "Nu", "鴒" => "Ling",
    "鴓" => "Mie", "鴔" => "Fu", "鴕" => "Tuo", "鴖" => "Wen", "鴗" => "Li", "鴘" => "Bian",
    "鴙" => "Zhi", "鴚" => "Ge", "鴛" => "Yuan", "鴜" => "Zi", "鴝" => "Qu", "鴞" => "Xiao",
    "鴟" => "Zhi", "鴠" => "Dan", "鴡" => "Ju", "鴢" => "You", "鴣" => "Gu", "鴤" => "Zhong",
    "鴥" => "Yu", "鴦" => "Yang", "鴧" => "Rong", "鴨" => "Ya", "鴩" => "Tie", "鴪" => "Yu",
    "鴫" => "Shigi", "鴬" => "Ying", "鴭" => "Zhui", "鴮" => "Wu", "鴯" => "Er", "鴰" => "Gua",
    "鴱" => "Ai", "鴲" => "Zhi", "鴳" => "Yan", "鴴" => "Heng", "鴵" => "Jiao", "鴶" => "Ji",
    "鴷" => "Lie", "鴸" => "Zhu", "鴹" => "Ren", "鴺" => "Yi", "鴻" => "Hong", "鴼" => "Luo",
    "鴽" => "Ru", "鴾" => "Mou", "鴿" => "Ge", "鵀" => "Ren", "鵁" => "Jiao", "鵂" => "Xiu",
    "鵃" => "Zhou", "鵄" => "Zhi", "鵅" => "Luo", "鵆" => "Chidori", "鵇" => "Toki", "鵈" => "Ten",
    "鵉" => "Luan", "鵊" => "Jia", "鵋" => "Ji", "鵌" => "Yu", "鵍" => "Huan", "鵎" => "Tuo",
    "鵏" => "Bu", "鵐" => "Wu", "鵑" => "Juan", "鵒" => "Yu", "鵓" => "Bo", "鵔" => "Xun",
    "鵕" => "Xun", "鵖" => "Bi", "鵗" => "Xi", "鵘" => "Jun", "鵙" => "Ju", "鵚" => "Tu",
    "鵛" => "Jing", "鵜" => "Ti", "鵝" => "E", "鵞" => "E", "鵟" => "Kuang", "鵠" => "Hu",
    "鵡" => "Wu", "鵢" => "Shen", "鵣" => "Lai", "鵤" => "Ikaruga", "鵥" => "Kakesu", "鵦" => "Lu",
    "鵧" => "Ping", "鵨" => "Shu", "鵩" => "Fu", "鵪" => "An", "鵫" => "Zhao", "鵬" => "Peng",
    "鵭" => "Qin", "鵮" => "Qian", "鵯" => "Bei", "鵰" => "Diao", "鵱" => "Lu", "鵲" => "Que",
    "鵳" => "Jian", "鵴" => "Ju", "鵵" => "Tu", "鵶" => "Ya", "鵷" => "Yuan", "鵸" => "Qi",
    "鵹" => "Li", "鵺" => "Ye", "鵻" => "Zhui", "鵼" => "Kong", "鵽" => "Zhui", "鵾" => "Kun",
    "鵿" => "Sheng", "鶀" => "Qi", "鶁" => "Jing", "鶂" => "Yi", "鶃" => "Yi", "鶄" => "Jing",
    "鶅" => "Zi", "鶆" => "Lai", "鶇" => "Dong", "鶈" => "Qi", "鶉" => "Chun", "鶊" => "Geng",
    "鶋" => "Ju", "鶌" => "Qu", "鶍" => "Isuka", "鶎" => "Kikuitadaki", "鶏" => "Ji", "鶐" => "Shu",
    "鶒" => "Chi", "鶓" => "Miao", "鶔" => "Rou", "鶕" => "An", "鶖" => "Qiu", "鶗" => "Ti",
    "鶘" => "Hu", "鶙" => "Ti", "鶚" => "E", "鶛" => "Jie", "鶜" => "Mao", "鶝" => "Fu",
    "鶞" => "Chun", "鶟" => "Tu", "鶠" => "Yan", "鶡" => "He", "鶢" => "Yuan", "鶣" => "Pian",
    "鶤" => "Yun", "鶥" => "Mei", "鶦" => "Hu", "鶧" => "Ying", "鶨" => "Dun", "鶩" => "Mu",
    "鶪" => "Ju", "鶫" => "Tsugumi", "鶬" => "Cang", "鶭" => "Fang", "鶮" => "Gu", "鶯" => "Ying",
    "鶰" => "Yuan", "鶱" => "Xuan", "鶲" => "Weng", "鶳" => "Shi", "鶴" => "He", "鶵" => "Chu",
    "鶶" => "Tang", "鶷" => "Xia", "鶸" => "Ruo", "鶹" => "Liu", "鶺" => "Ji", "鶻" => "Gu",
    "鶼" => "Jian", "鶽" => "Zhun", "鶾" => "Han", "鶿" => "Zi", "鷀" => "Zi", "鷁" => "Ni",
    "鷂" => "Yao", "鷃" => "Yan", "鷄" => "Ji", "鷅" => "Li", "鷆" => "Tian", "鷇" => "Kou",
    "鷈" => "Ti", "鷉" => "Ti", "鷊" => "Ni", "鷋" => "Tu", "鷌" => "Ma", "鷍" => "Jiao",
    "鷎" => "Gao", "鷏" => "Tian", "鷐" => "Chen", "鷑" => "Li", "鷒" => "Zhuan", "鷓" => "Zhe",
    "鷔" => "Ao", "鷕" => "Yao", "鷖" => "Yi", "鷗" => "Ou", "鷘" => "Chi", "鷙" => "Zhi",
    "鷚" => "Liao", "鷛" => "Rong", "鷜" => "Lou", "鷝" => "Bi", "鷞" => "Shuang", "鷟" => "Zhuo",
    "鷠" => "Yu", "鷡" => "Wu", "鷢" => "Jue", "鷣" => "Yin", "鷤" => "Quan", "鷥" => "Si",
    "鷦" => "Jiao", "鷧" => "Yi", "鷨" => "Hua", "鷩" => "Bi", "鷪" => "Ying", "鷫" => "Su",
    "鷬" => "Huang", "鷭" => "Fan", "鷮" => "Jiao", "鷯" => "Liao", "鷰" => "Yan", "鷱" => "Kao",
    "鷲" => "Jiu", "鷳" => "Xian", "鷴" => "Xian", "鷵" => "Tu", "鷶" => "Mai", "鷷" => "Zun",
    "鷸" => "Yu", "鷹" => "Ying", "鷺" => "Lu", "鷻" => "Tuan", "鷼" => "Xian", "鷽" => "Xue",
    "鷾" => "Yi", "鷿" => "Pi", "鸁" => "Luo", "鸂" => "Qi", "鸃" => "Yi", "鸄" => "Ji",
    "鸅" => "Zhe", "鸆" => "Yu", "鸇" => "Zhan", "鸈" => "Ye", "鸉" => "Yang", "鸊" => "Pi",
    "鸋" => "Ning", "鸌" => "Huo", "鸍" => "Mi", "鸎" => "Ying", "鸏" => "Meng", "鸐" => "Di",
    "鸑" => "Yue", "鸒" => "Yu", "鸓" => "Lei", "鸔" => "Bao", "鸕" => "Lu", "鸖" => "He",
    "鸗" => "Long", "鸘" => "Shuang", "鸙" => "Yue", "鸚" => "Ying", "鸛" => "Guan", "鸜" => "Qu",
    "鸝" => "Li", "鸞" => "Luan", "鸟" => "Niao", "鸠" => "Jiu", "鸡" => "Ji", "鸢" => "Yuan",
    "鸣" => "Ming", "鸤" => "Shi", "鸥" => "Ou", "鸦" => "Ya", "鸧" => "Cang", "鸨" => "Bao",
    "鸩" => "Zhen", "鸪" => "Gu", "鸫" => "Dong", "鸬" => "Lu", "鸭" => "Ya", "鸮" => "Xiao",
    "鸯" => "Yang", "鸰" => "Ling", "鸱" => "Zhi", "鸲" => "Qu", "鸳" => "Yuan", "鸴" => "Xue",
    "鸵" => "Tuo", "鸶" => "Si", "鸷" => "Zhi", "鸸" => "Er", "鸹" => "Gua", "鸺" => "Xiu",
    "鸻" => "Heng", "鸼" => "Zhou", "鸽" => "Ge", "鸾" => "Luan", "鸿" => "Hong", "鹀" => "Wu",
    "鹁" => "Bo", "鹂" => "Li", "鹃" => "Juan", "鹄" => "Hu", "鹅" => "E", "鹆" => "Yu",
    "鹇" => "Xian", "鹈" => "Ti", "鹉" => "Wu", "鹊" => "Que", "鹋" => "Miao", "鹌" => "An",
    "鹍" => "Kun", "鹎" => "Bei", "鹏" => "Peng", "鹐" => "Qian", "鹑" => "Chun", "鹒" => "Geng",
    "鹓" => "Yuan", "鹔" => "Su", "鹕" => "Hu", "鹖" => "He", "鹗" => "E", "鹘" => "Gu",
    "鹙" => "Qiu", "鹚" => "Zi", "鹛" => "Mei", "鹜" => "Mu", "鹝" => "Ni", "鹞" => "Yao",
    "鹟" => "Weng", "鹠" => "Liu", "鹡" => "Ji", "鹢" => "Ni", "鹣" => "Jian", "鹤" => "He",
    "鹥" => "Yi", "鹦" => "Ying", "鹧" => "Zhe", "鹨" => "Liao", "鹩" => "Liao", "鹪" => "Jiao",
    "鹫" => "Jiu", "鹬" => "Yu", "鹭" => "Lu", "鹮" => "Xuan", "鹯" => "Zhan", "鹰" => "Ying",
    "鹱" => "Huo", "鹲" => "Meng", "鹳" => "Guan", "鹴" => "Shuang", "鹵" => "Lu", "鹶" => "Jin",
    "鹷" => "Ling", "鹸" => "Jian", "鹹" => "Xian", "鹺" => "Cuo", "鹻" => "Jian", "鹼" => "Jian",
    "鹽" => "Yan", "鹾" => "Cuo", "鹿" => "Lu", "麀" => "You", "麁" => "Cu", "麂" => "Ji",
    "麃" => "Biao", "麄" => "Cu", "麅" => "Biao", "麆" => "Zhu", "麇" => "Jun", "麈" => "Zhu",
    "麉" => "Jian", "麊" => "Mi", "麋" => "Mi", "麌" => "Wu", "麍" => "Liu", "麎" => "Chen",
    "麏" => "Jun", "麐" => "Lin", "麑" => "Ni", "麒" => "Qi", "麓" => "Lu", "麔" => "Jiu",
    "麕" => "Jun", "麖" => "Jing", "麗" => "Li", "麘" => "Xiang", "麙" => "Yan", "麚" => "Jia",
    "麛" => "Mi", "麜" => "Li", "麝" => "She", "麞" => "Zhang", "麟" => "Lin", "麠" => "Jing",
    "麡" => "Ji", "麢" => "Ling", "麣" => "Yan", "麤" => "Cu", "麥" => "Mai", "麦" => "Mai",
    "麧" => "Ge", "麨" => "Chao", "麩" => "Fu", "麪" => "Mian", "麫" => "Mian", "麬" => "Fu",
    "麭" => "Pao", "麮" => "Qu", "麯" => "Qu", "麰" => "Mou", "麱" => "Fu", "麲" => "Xian",
    "麳" => "Lai", "麴" => "Qu", "麵" => "Mian", "麷" => "Feng", "麸" => "Fu", "麹" => "Qu",
    "麺" => "Mian", "麻" => "Ma", "麼" => "Mo", "麽" => "Mo", "麾" => "Hui", "麿" => "Ma",
    "黀" => "Zou", "黁" => "Nen", "黂" => "Fen", "黃" => "Huang", "黄" => "Huang", "黅" => "Jin",
    "黆" => "Guang", "黇" => "Tian", "黈" => "Tou", "黉" => "Heng", "黊" => "Xi", "黋" => "Kuang",
    "黌" => "Heng", "黍" => "Shu", "黎" => "Li", "黏" => "Nian", "黐" => "Chi", "黑" => "Hei",
    "黒" => "Hei", "黓" => "Yi", "黔" => "Qian", "黕" => "Dan", "黖" => "Xi", "黗" => "Tuan",
    "默" => "Mo", "黙" => "Mo", "黚" => "Qian", "黛" => "Dai", "黜" => "Chu", "黝" => "You",
    "點" => "Dian", "黟" => "Yi", "黠" => "Xia", "黡" => "Yan", "黢" => "Qu", "黣" => "Mei",
    "黤" => "Yan", "黥" => "Jing", "黦" => "Yu", "黧" => "Li", "黨" => "Dang", "黩" => "Du",
    "黪" => "Can", "黫" => "Yin", "黬" => "An", "黭" => "Yan", "黮" => "Tan", "黯" => "An",
    "黰" => "Zhen", "黱" => "Dai", "黲" => "Can", "黳" => "Yi", "黴" => "Mei", "黵" => "Dan",
    "黶" => "Yan", "黷" => "Du", "黸" => "Lu", "黹" => "Zhi", "黺" => "Fen", "黻" => "Fu",
    "黼" => "Fu", "黽" => "Min", "黾" => "Min", "黿" => "Yuan", "鼁" => "Qu", "鼂" => "Chao",
    "鼃" => "Wa", "鼄" => "Zhu", "鼅" => "Zhi", "鼆" => "Mang", "鼇" => "Ao", "鼈" => "Bie",
    "鼉" => "Tuo", "鼊" => "Bi", "鼋" => "Yuan", "鼌" => "Chao", "鼍" => "Tuo", "鼎" => "Ding",
    "鼏" => "Mi", "鼐" => "Nai", "鼑" => "Ding", "鼒" => "Zi", "鼓" => "Gu", "鼔" => "Gu",
    "鼕" => "Dong", "鼖" => "Fen", "鼗" => "Tao", "鼘" => "Yuan", "鼙" => "Pi", "鼚" => "Chang",
    "鼛" => "Gao", "鼜" => "Qi", "鼝" => "Yuan", "鼞" => "Tang", "鼟" => "Teng", "鼠" => "Shu",
    "鼡" => "Shu", "鼢" => "Fen", "鼣" => "Fei", "鼤" => "Wen", "鼥" => "Ba", "鼦" => "Diao",
    "鼧" => "Tuo", "鼨" => "Tong", "鼩" => "Qu", "鼪" => "Sheng", "鼫" => "Shi", "鼬" => "You",
    "鼭" => "Shi", "鼮" => "Ting", "鼯" => "Wu", "鼰" => "Nian", "鼱" => "Jing", "鼲" => "Hun",
    "鼳" => "Ju", "鼴" => "Yan", "鼵" => "Tu", "鼶" => "Ti", "鼷" => "Xi", "鼸" => "Xian",
    "鼹" => "Yan", "鼺" => "Lei", "鼻" => "Bi", "鼼" => "Yao", "鼽" => "Qiu", "鼾" => "Han",
    "鼿" => "Wu", "齀" => "Wu", "齁" => "Hou", "齂" => "Xi", "齃" => "Ge", "齄" => "Zha",
    "齅" => "Xiu", "齆" => "Weng", "齇" => "Zha", "齈" => "Nong", "齉" => "Nang", "齊" => "Qi",
    "齋" => "Zhai", "齌" => "Ji", "齍" => "Zi", "齎" => "Ji", "齏" => "Ji", "齐" => "Qi",
    "齑" => "Ji", "齒" => "Chi", "齓" => "Chen", "齔" => "Chen", "齕" => "He", "齖" => "Ya",
    "齗" => "Ken", "齘" => "Xie", "齙" => "Pao", "齚" => "Cuo", "齛" => "Shi", "齜" => "Zi",
    "齝" => "Chi", "齞" => "Nian", "齟" => "Ju", "齠" => "Tiao", "齡" => "Ling", "齢" => "Ling",
    "齣" => "Chu", "齤" => "Quan", "齥" => "Xie", "齦" => "Ken", "齧" => "Nie", "齨" => "Jiu",
    "齩" => "Yao", "齪" => "Chuo", "齫" => "Kun", "齬" => "Yu", "齭" => "Chu", "齮" => "Yi",
    "齯" => "Ni", "齰" => "Cuo", "齱" => "Zou", "齲" => "Qu", "齳" => "Nen", "齴" => "Xian",
    "齵" => "Ou", "齶" => "E", "齷" => "Wo", "齸" => "Yi", "齹" => "Chuo", "齺" => "Zou",
    "齻" => "Dian", "齼" => "Chu", "齽" => "Jin", "齾" => "Ya", "齿" => "Chi", "龀" => "Chen",
    "龁" => "He", "龂" => "Ken", "龃" => "Ju", "龄" => "Ling", "龅" => "Pao", "龆" => "Tiao",
    "龇" => "Zi", "龈" => "Ken", "龉" => "Yu", "龊" => "Chuo", "龋" => "Qu", "龌" => "Wo",
    "龍" => "Long", "龎" => "Pang", "龏" => "Gong", "龐" => "Pang", "龑" => "Yan", "龒" => "Long",
    "龓" => "Long", "龔" => "Gong", "龕" => "Kan", "龖" => "Ta", "龗" => "Ling", "龘" => "Ta",
    "龙" => "Long", "龚" => "Gong", "龛" => "Kan", "龜" => "Gui", "龝" => "Qiu", "龞" => "Bie",
    "龟" => "Gui", "龠" => "Yue", "龡" => "Chui", "龢" => "He", "龣" => "Jue", "龤" => "Xie",
    "龥" => "Yu", "ꀁ" => "ix", "ꀂ" => "i", "ꀃ" => "ip", "ꀄ" => "iet", "ꀅ" => "iex",
    "ꀆ" => "ie", "ꀇ" => "iep", "ꀈ" => "at", "ꀉ" => "ax", "ꀊ" => "a", "ꀋ" => "ap",
    "ꀌ" => "uox", "ꀍ" => "uo", "ꀎ" => "uop", "ꀏ" => "ot", "ꀐ" => "ox", "ꀑ" => "o",
    "ꀒ" => "op", "ꀓ" => "ex", "ꀔ" => "e", "ꀕ" => "wu", "ꀖ" => "bit", "ꀗ" => "bix",
    "ꀘ" => "bi", "ꀙ" => "bip", "ꀚ" => "biet", "ꀛ" => "biex", "ꀜ" => "bie", "ꀝ" => "biep",
    "ꀞ" => "bat", "ꀟ" => "bax", "ꀠ" => "ba", "ꀡ" => "bap", "ꀢ" => "buox", "ꀣ" => "buo",
    "ꀤ" => "buop", "ꀥ" => "bot", "ꀦ" => "box", "ꀧ" => "bo", "ꀨ" => "bop", "ꀩ" => "bex",
    "ꀪ" => "be", "ꀫ" => "bep", "ꀬ" => "but", "ꀭ" => "bux", "ꀮ" => "bu", "ꀯ" => "bup",
    "ꀰ" => "burx", "ꀱ" => "bur", "ꀲ" => "byt", "ꀳ" => "byx", "ꀴ" => "by", "ꀵ" => "byp",
    "ꀶ" => "byrx", "ꀷ" => "byr", "ꀸ" => "pit", "ꀹ" => "pix", "ꀺ" => "pi", "ꀻ" => "pip",
    "ꀼ" => "piex", "ꀽ" => "pie", "ꀾ" => "piep", "ꀿ" => "pat", "ꁀ" => "pax", "ꁁ" => "pa",
    "ꁂ" => "pap", "ꁃ" => "puox", "ꁄ" => "puo", "ꁅ" => "puop", "ꁆ" => "pot", "ꁇ" => "pox",
    "ꁈ" => "po", "ꁉ" => "pop", "ꁊ" => "put", "ꁋ" => "pux", "ꁌ" => "pu", "ꁍ" => "pup",
    "ꁎ" => "purx", "ꁏ" => "pur", "ꁐ" => "pyt", "ꁑ" => "pyx", "ꁒ" => "py", "ꁓ" => "pyp",
    "ꁔ" => "pyrx", "ꁕ" => "pyr", "ꁖ" => "bbit", "ꁗ" => "bbix", "ꁘ" => "bbi", "ꁙ" => "bbip",
    "ꁚ" => "bbiet", "ꁛ" => "bbiex", "ꁜ" => "bbie", "ꁝ" => "bbiep", "ꁞ" => "bbat", "ꁟ" => "bbax",
    "ꁠ" => "bba", "ꁡ" => "bbap", "ꁢ" => "bbuox", "ꁣ" => "bbuo", "ꁤ" => "bbuop", "ꁥ" => "bbot",
    "ꁦ" => "bbox", "ꁧ" => "bbo", "ꁨ" => "bbop", "ꁩ" => "bbex", "ꁪ" => "bbe", "ꁫ" => "bbep",
    "ꁬ" => "bbut", "ꁭ" => "bbux", "ꁮ" => "bbu", "ꁯ" => "bbup", "ꁰ" => "bburx", "ꁱ" => "bbur",
    "ꁲ" => "bbyt", "ꁳ" => "bbyx", "ꁴ" => "bby", "ꁵ" => "bbyp", "ꁶ" => "nbit", "ꁷ" => "nbix",
    "ꁸ" => "nbi", "ꁹ" => "nbip", "ꁺ" => "nbiex", "ꁻ" => "nbie", "ꁼ" => "nbiep", "ꁽ" => "nbat",
    "ꁾ" => "nbax", "ꁿ" => "nba", "ꂀ" => "nbap", "ꂁ" => "nbot", "ꂂ" => "nbox", "ꂃ" => "nbo",
    "ꂄ" => "nbop", "ꂅ" => "nbut", "ꂆ" => "nbux", "ꂇ" => "nbu", "ꂈ" => "nbup", "ꂉ" => "nburx",
    "ꂊ" => "nbur", "ꂋ" => "nbyt", "ꂌ" => "nbyx", "ꂍ" => "nby", "ꂎ" => "nbyp", "ꂏ" => "nbyrx",
    "ꂐ" => "nbyr", "ꂑ" => "hmit", "ꂒ" => "hmix", "ꂓ" => "hmi", "ꂔ" => "hmip", "ꂕ" => "hmiex",
    "ꂖ" => "hmie", "ꂗ" => "hmiep", "ꂘ" => "hmat", "ꂙ" => "hmax", "ꂚ" => "hma", "ꂛ" => "hmap",
    "ꂜ" => "hmuox", "ꂝ" => "hmuo", "ꂞ" => "hmuop", "ꂟ" => "hmot", "ꂠ" => "hmox", "ꂡ" => "hmo",
    "ꂢ" => "hmop", "ꂣ" => "hmut", "ꂤ" => "hmux", "ꂥ" => "hmu", "ꂦ" => "hmup", "ꂧ" => "hmurx",
    "ꂨ" => "hmur", "ꂩ" => "hmyx", "ꂪ" => "hmy", "ꂫ" => "hmyp", "ꂬ" => "hmyrx", "ꂭ" => "hmyr",
    "ꂮ" => "mit", "ꂯ" => "mix", "ꂰ" => "mi", "ꂱ" => "mip", "ꂲ" => "miex", "ꂳ" => "mie",
    "ꂴ" => "miep", "ꂵ" => "mat", "ꂶ" => "max", "ꂷ" => "ma", "ꂸ" => "map", "ꂹ" => "muot",
    "ꂺ" => "muox", "ꂻ" => "muo", "ꂼ" => "muop", "ꂽ" => "mot", "ꂾ" => "mox", "ꂿ" => "mo",
    "ꃀ" => "mop", "ꃁ" => "mex", "ꃂ" => "me", "ꃃ" => "mut", "ꃄ" => "mux", "ꃅ" => "mu",
    "ꃆ" => "mup", "ꃇ" => "murx", "ꃈ" => "mur", "ꃉ" => "myt", "ꃊ" => "myx", "ꃋ" => "my",
    "ꃌ" => "myp", "ꃍ" => "fit", "ꃎ" => "fix", "ꃏ" => "fi", "ꃐ" => "fip", "ꃑ" => "fat",
    "ꃒ" => "fax", "ꃓ" => "fa", "ꃔ" => "fap", "ꃕ" => "fox", "ꃖ" => "fo", "ꃗ" => "fop",
    "ꃘ" => "fut", "ꃙ" => "fux", "ꃚ" => "fu", "ꃛ" => "fup", "ꃜ" => "furx", "ꃝ" => "fur",
    "ꃞ" => "fyt", "ꃟ" => "fyx", "ꃠ" => "fy", "ꃡ" => "fyp", "ꃢ" => "vit", "ꃣ" => "vix",
    "ꃤ" => "vi", "ꃥ" => "vip", "ꃦ" => "viet", "ꃧ" => "viex", "ꃨ" => "vie", "ꃩ" => "viep",
    "ꃪ" => "vat", "ꃫ" => "vax", "ꃬ" => "va", "ꃭ" => "vap", "ꃮ" => "vot", "ꃯ" => "vox",
    "ꃰ" => "vo", "ꃱ" => "vop", "ꃲ" => "vex", "ꃳ" => "vep", "ꃴ" => "vut", "ꃵ" => "vux",
    "ꃶ" => "vu", "ꃷ" => "vup", "ꃸ" => "vurx", "ꃹ" => "vur", "ꃺ" => "vyt", "ꃻ" => "vyx",
    "ꃼ" => "vy", "ꃽ" => "vyp", "ꃾ" => "vyrx", "ꃿ" => "vyr", "ꄁ" => "dix", "ꄂ" => "di",
    "ꄃ" => "dip", "ꄄ" => "diex", "ꄅ" => "die", "ꄆ" => "diep", "ꄇ" => "dat", "ꄈ" => "dax",
    "ꄉ" => "da", "ꄊ" => "dap", "ꄋ" => "duox", "ꄌ" => "duo", "ꄍ" => "dot", "ꄎ" => "dox",
    "ꄏ" => "do", "ꄐ" => "dop", "ꄑ" => "dex", "ꄒ" => "de", "ꄓ" => "dep", "ꄔ" => "dut",
    "ꄕ" => "dux", "ꄖ" => "du", "ꄗ" => "dup", "ꄘ" => "durx", "ꄙ" => "dur", "ꄚ" => "tit",
    "ꄛ" => "tix", "ꄜ" => "ti", "ꄝ" => "tip", "ꄞ" => "tiex", "ꄟ" => "tie", "ꄠ" => "tiep",
    "ꄡ" => "tat", "ꄢ" => "tax", "ꄣ" => "ta", "ꄤ" => "tap", "ꄥ" => "tuot", "ꄦ" => "tuox",
    "ꄧ" => "tuo", "ꄨ" => "tuop", "ꄩ" => "tot", "ꄪ" => "tox", "ꄫ" => "to", "ꄬ" => "top",
    "ꄭ" => "tex", "ꄮ" => "te", "ꄯ" => "tep", "ꄰ" => "tut", "ꄱ" => "tux", "ꄲ" => "tu",
    "ꄳ" => "tup", "ꄴ" => "turx", "ꄵ" => "tur", "ꄶ" => "ddit", "ꄷ" => "ddix", "ꄸ" => "ddi",
    "ꄹ" => "ddip", "ꄺ" => "ddiex", "ꄻ" => "ddie", "ꄼ" => "ddiep", "ꄽ" => "ddat", "ꄾ" => "ddax",
    "ꄿ" => "dda", "ꅀ" => "ddap", "ꅁ" => "dduox", "ꅂ" => "dduo", "ꅃ" => "dduop", "ꅄ" => "ddot",
    "ꅅ" => "ddox", "ꅆ" => "ddo", "ꅇ" => "ddop", "ꅈ" => "ddex", "ꅉ" => "dde", "ꅊ" => "ddep",
    "ꅋ" => "ddut", "ꅌ" => "ddux", "ꅍ" => "ddu", "ꅎ" => "ddup", "ꅏ" => "ddurx", "ꅐ" => "ddur",
    "ꅑ" => "ndit", "ꅒ" => "ndix", "ꅓ" => "ndi", "ꅔ" => "ndip", "ꅕ" => "ndiex", "ꅖ" => "ndie",
    "ꅗ" => "ndat", "ꅘ" => "ndax", "ꅙ" => "nda", "ꅚ" => "ndap", "ꅛ" => "ndot", "ꅜ" => "ndox",
    "ꅝ" => "ndo", "ꅞ" => "ndop", "ꅟ" => "ndex", "ꅠ" => "nde", "ꅡ" => "ndep", "ꅢ" => "ndut",
    "ꅣ" => "ndux", "ꅤ" => "ndu", "ꅥ" => "ndup", "ꅦ" => "ndurx", "ꅧ" => "ndur", "ꅨ" => "hnit",
    "ꅩ" => "hnix", "ꅪ" => "hni", "ꅫ" => "hnip", "ꅬ" => "hniet", "ꅭ" => "hniex", "ꅮ" => "hnie",
    "ꅯ" => "hniep", "ꅰ" => "hnat", "ꅱ" => "hnax", "ꅲ" => "hna", "ꅳ" => "hnap", "ꅴ" => "hnuox",
    "ꅵ" => "hnuo", "ꅶ" => "hnot", "ꅷ" => "hnox", "ꅸ" => "hnop", "ꅹ" => "hnex", "ꅺ" => "hne",
    "ꅻ" => "hnep", "ꅼ" => "hnut", "ꅽ" => "nit", "ꅾ" => "nix", "ꅿ" => "ni", "ꆀ" => "nip",
    "ꆁ" => "niex", "ꆂ" => "nie", "ꆃ" => "niep", "ꆄ" => "nax", "ꆅ" => "na", "ꆆ" => "nap",
    "ꆇ" => "nuox", "ꆈ" => "nuo", "ꆉ" => "nuop", "ꆊ" => "not", "ꆋ" => "nox", "ꆌ" => "no",
    "ꆍ" => "nop", "ꆎ" => "nex", "ꆏ" => "ne", "ꆐ" => "nep", "ꆑ" => "nut", "ꆒ" => "nux",
    "ꆓ" => "nu", "ꆔ" => "nup", "ꆕ" => "nurx", "ꆖ" => "nur", "ꆗ" => "hlit", "ꆘ" => "hlix",
    "ꆙ" => "hli", "ꆚ" => "hlip", "ꆛ" => "hliex", "ꆜ" => "hlie", "ꆝ" => "hliep", "ꆞ" => "hlat",
    "ꆟ" => "hlax", "ꆠ" => "hla", "ꆡ" => "hlap", "ꆢ" => "hluox", "ꆣ" => "hluo", "ꆤ" => "hluop",
    "ꆥ" => "hlox", "ꆦ" => "hlo", "ꆧ" => "hlop", "ꆨ" => "hlex", "ꆩ" => "hle", "ꆪ" => "hlep",
    "ꆫ" => "hlut", "ꆬ" => "hlux", "ꆭ" => "hlu", "ꆮ" => "hlup", "ꆯ" => "hlurx", "ꆰ" => "hlur",
    "ꆱ" => "hlyt", "ꆲ" => "hlyx", "ꆳ" => "hly", "ꆴ" => "hlyp", "ꆵ" => "hlyrx", "ꆶ" => "hlyr",
    "ꆷ" => "lit", "ꆸ" => "lix", "ꆹ" => "li", "ꆺ" => "lip", "ꆻ" => "liet", "ꆼ" => "liex",
    "ꆽ" => "lie", "ꆾ" => "liep", "ꆿ" => "lat", "ꇀ" => "lax", "ꇁ" => "la", "ꇂ" => "lap",
    "ꇃ" => "luot", "ꇄ" => "luox", "ꇅ" => "luo", "ꇆ" => "luop", "ꇇ" => "lot", "ꇈ" => "lox",
    "ꇉ" => "lo", "ꇊ" => "lop", "ꇋ" => "lex", "ꇌ" => "le", "ꇍ" => "lep", "ꇎ" => "lut",
    "ꇏ" => "lux", "ꇐ" => "lu", "ꇑ" => "lup", "ꇒ" => "lurx", "ꇓ" => "lur", "ꇔ" => "lyt",
    "ꇕ" => "lyx", "ꇖ" => "ly", "ꇗ" => "lyp", "ꇘ" => "lyrx", "ꇙ" => "lyr", "ꇚ" => "git",
    "ꇛ" => "gix", "ꇜ" => "gi", "ꇝ" => "gip", "ꇞ" => "giet", "ꇟ" => "giex", "ꇠ" => "gie",
    "ꇡ" => "giep", "ꇢ" => "gat", "ꇣ" => "gax", "ꇤ" => "ga", "ꇥ" => "gap", "ꇦ" => "guot",
    "ꇧ" => "guox", "ꇨ" => "guo", "ꇩ" => "guop", "ꇪ" => "got", "ꇫ" => "gox", "ꇬ" => "go",
    "ꇭ" => "gop", "ꇮ" => "get", "ꇯ" => "gex", "ꇰ" => "ge", "ꇱ" => "gep", "ꇲ" => "gut",
    "ꇳ" => "gux", "ꇴ" => "gu", "ꇵ" => "gup", "ꇶ" => "gurx", "ꇷ" => "gur", "ꇸ" => "kit",
    "ꇹ" => "kix", "ꇺ" => "ki", "ꇻ" => "kip", "ꇼ" => "kiex", "ꇽ" => "kie", "ꇾ" => "kiep",
    "ꇿ" => "kat", "ꈁ" => "ka", "ꈂ" => "kap", "ꈃ" => "kuox", "ꈄ" => "kuo", "ꈅ" => "kuop",
    "ꈆ" => "kot", "ꈇ" => "kox", "ꈈ" => "ko", "ꈉ" => "kop", "ꈊ" => "ket", "ꈋ" => "kex",
    "ꈌ" => "ke", "ꈍ" => "kep", "ꈎ" => "kut", "ꈏ" => "kux", "ꈐ" => "ku", "ꈑ" => "kup",
    "ꈒ" => "kurx", "ꈓ" => "kur", "ꈔ" => "ggit", "ꈕ" => "ggix", "ꈖ" => "ggi", "ꈗ" => "ggiex",
    "ꈘ" => "ggie", "ꈙ" => "ggiep", "ꈚ" => "ggat", "ꈛ" => "ggax", "ꈜ" => "gga", "ꈝ" => "ggap",
    "ꈞ" => "gguot", "ꈟ" => "gguox", "ꈠ" => "gguo", "ꈡ" => "gguop", "ꈢ" => "ggot", "ꈣ" => "ggox",
    "ꈤ" => "ggo", "ꈥ" => "ggop", "ꈦ" => "gget", "ꈧ" => "ggex", "ꈨ" => "gge", "ꈩ" => "ggep",
    "ꈪ" => "ggut", "ꈫ" => "ggux", "ꈬ" => "ggu", "ꈭ" => "ggup", "ꈮ" => "ggurx", "ꈯ" => "ggur",
    "ꈰ" => "mgiex", "ꈱ" => "mgie", "ꈲ" => "mgat", "ꈳ" => "mgax", "ꈴ" => "mga", "ꈵ" => "mgap",
    "ꈶ" => "mguox", "ꈷ" => "mguo", "ꈸ" => "mguop", "ꈹ" => "mgot", "ꈺ" => "mgox", "ꈻ" => "mgo",
    "ꈼ" => "mgop", "ꈽ" => "mgex", "ꈾ" => "mge", "ꈿ" => "mgep", "ꉀ" => "mgut", "ꉁ" => "mgux",
    "ꉂ" => "mgu", "ꉃ" => "mgup", "ꉄ" => "mgurx", "ꉅ" => "mgur", "ꉆ" => "hxit", "ꉇ" => "hxix",
    "ꉈ" => "hxi", "ꉉ" => "hxip", "ꉊ" => "hxiet", "ꉋ" => "hxiex", "ꉌ" => "hxie", "ꉍ" => "hxiep",
    "ꉎ" => "hxat", "ꉏ" => "hxax", "ꉐ" => "hxa", "ꉑ" => "hxap", "ꉒ" => "hxuot", "ꉓ" => "hxuox",
    "ꉔ" => "hxuo", "ꉕ" => "hxuop", "ꉖ" => "hxot", "ꉗ" => "hxox", "ꉘ" => "hxo", "ꉙ" => "hxop",
    "ꉚ" => "hxex", "ꉛ" => "hxe", "ꉜ" => "hxep", "ꉝ" => "ngiex", "ꉞ" => "ngie", "ꉟ" => "ngiep",
    "ꉠ" => "ngat", "ꉡ" => "ngax", "ꉢ" => "nga", "ꉣ" => "ngap", "ꉤ" => "nguot", "ꉥ" => "nguox",
    "ꉦ" => "nguo", "ꉧ" => "ngot", "ꉨ" => "ngox", "ꉩ" => "ngo", "ꉪ" => "ngop", "ꉫ" => "ngex",
    "ꉬ" => "nge", "ꉭ" => "ngep", "ꉮ" => "hit", "ꉯ" => "hiex", "ꉰ" => "hie", "ꉱ" => "hat",
    "ꉲ" => "hax", "ꉳ" => "ha", "ꉴ" => "hap", "ꉵ" => "huot", "ꉶ" => "huox", "ꉷ" => "huo",
    "ꉸ" => "huop", "ꉹ" => "hot", "ꉺ" => "hox", "ꉻ" => "ho", "ꉼ" => "hop", "ꉽ" => "hex",
    "ꉾ" => "he", "ꉿ" => "hep", "ꊀ" => "wat", "ꊁ" => "wax", "ꊂ" => "wa", "ꊃ" => "wap",
    "ꊄ" => "wuox", "ꊅ" => "wuo", "ꊆ" => "wuop", "ꊇ" => "wox", "ꊈ" => "wo", "ꊉ" => "wop",
    "ꊊ" => "wex", "ꊋ" => "we", "ꊌ" => "wep", "ꊍ" => "zit", "ꊎ" => "zix", "ꊏ" => "zi",
    "ꊐ" => "zip", "ꊑ" => "ziex", "ꊒ" => "zie", "ꊓ" => "ziep", "ꊔ" => "zat", "ꊕ" => "zax",
    "ꊖ" => "za", "ꊗ" => "zap", "ꊘ" => "zuox", "ꊙ" => "zuo", "ꊚ" => "zuop", "ꊛ" => "zot",
    "ꊜ" => "zox", "ꊝ" => "zo", "ꊞ" => "zop", "ꊟ" => "zex", "ꊠ" => "ze", "ꊡ" => "zep",
    "ꊢ" => "zut", "ꊣ" => "zux", "ꊤ" => "zu", "ꊥ" => "zup", "ꊦ" => "zurx", "ꊧ" => "zur",
    "ꊨ" => "zyt", "ꊩ" => "zyx", "ꊪ" => "zy", "ꊫ" => "zyp", "ꊬ" => "zyrx", "ꊭ" => "zyr",
    "ꊮ" => "cit", "ꊯ" => "cix", "ꊰ" => "ci", "ꊱ" => "cip", "ꊲ" => "ciet", "ꊳ" => "ciex",
    "ꊴ" => "cie", "ꊵ" => "ciep", "ꊶ" => "cat", "ꊷ" => "cax", "ꊸ" => "ca", "ꊹ" => "cap",
    "ꊺ" => "cuox", "ꊻ" => "cuo", "ꊼ" => "cuop", "ꊽ" => "cot", "ꊾ" => "cox", "ꊿ" => "co",
    "ꋀ" => "cop", "ꋁ" => "cex", "ꋂ" => "ce", "ꋃ" => "cep", "ꋄ" => "cut", "ꋅ" => "cux",
    "ꋆ" => "cu", "ꋇ" => "cup", "ꋈ" => "curx", "ꋉ" => "cur", "ꋊ" => "cyt", "ꋋ" => "cyx",
    "ꋌ" => "cy", "ꋍ" => "cyp", "ꋎ" => "cyrx", "ꋏ" => "cyr", "ꋐ" => "zzit", "ꋑ" => "zzix",
    "ꋒ" => "zzi", "ꋓ" => "zzip", "ꋔ" => "zziet", "ꋕ" => "zziex", "ꋖ" => "zzie", "ꋗ" => "zziep",
    "ꋘ" => "zzat", "ꋙ" => "zzax", "ꋚ" => "zza", "ꋛ" => "zzap", "ꋜ" => "zzox", "ꋝ" => "zzo",
    "ꋞ" => "zzop", "ꋟ" => "zzex", "ꋠ" => "zze", "ꋡ" => "zzep", "ꋢ" => "zzux", "ꋣ" => "zzu",
    "ꋤ" => "zzup", "ꋥ" => "zzurx", "ꋦ" => "zzur", "ꋧ" => "zzyt", "ꋨ" => "zzyx", "ꋩ" => "zzy",
    "ꋪ" => "zzyp", "ꋫ" => "zzyrx", "ꋬ" => "zzyr", "ꋭ" => "nzit", "ꋮ" => "nzix", "ꋯ" => "nzi",
    "ꋰ" => "nzip", "ꋱ" => "nziex", "ꋲ" => "nzie", "ꋳ" => "nziep", "ꋴ" => "nzat", "ꋵ" => "nzax",
    "ꋶ" => "nza", "ꋷ" => "nzap", "ꋸ" => "nzuox", "ꋹ" => "nzuo", "ꋺ" => "nzox", "ꋻ" => "nzop",
    "ꋼ" => "nzex", "ꋽ" => "nze", "ꋾ" => "nzux", "ꋿ" => "nzu", "ꌁ" => "nzurx", "ꌂ" => "nzur",
    "ꌃ" => "nzyt", "ꌄ" => "nzyx", "ꌅ" => "nzy", "ꌆ" => "nzyp", "ꌇ" => "nzyrx", "ꌈ" => "nzyr",
    "ꌉ" => "sit", "ꌊ" => "six", "ꌋ" => "si", "ꌌ" => "sip", "ꌍ" => "siex", "ꌎ" => "sie",
    "ꌏ" => "siep", "ꌐ" => "sat", "ꌑ" => "sax", "ꌒ" => "sa", "ꌓ" => "sap", "ꌔ" => "suox",
    "ꌕ" => "suo", "ꌖ" => "suop", "ꌗ" => "sot", "ꌘ" => "sox", "ꌙ" => "so", "ꌚ" => "sop",
    "ꌛ" => "sex", "ꌜ" => "se", "ꌝ" => "sep", "ꌞ" => "sut", "ꌟ" => "sux", "ꌠ" => "su",
    "ꌡ" => "sup", "ꌢ" => "surx", "ꌣ" => "sur", "ꌤ" => "syt", "ꌥ" => "syx", "ꌦ" => "sy",
    "ꌧ" => "syp", "ꌨ" => "syrx", "ꌩ" => "syr", "ꌪ" => "ssit", "ꌫ" => "ssix", "ꌬ" => "ssi",
    "ꌭ" => "ssip", "ꌮ" => "ssiex", "ꌯ" => "ssie", "ꌰ" => "ssiep", "ꌱ" => "ssat", "ꌲ" => "ssax",
    "ꌳ" => "ssa", "ꌴ" => "ssap", "ꌵ" => "ssot", "ꌶ" => "ssox", "ꌷ" => "sso", "ꌸ" => "ssop",
    "ꌹ" => "ssex", "ꌺ" => "sse", "ꌻ" => "ssep", "ꌼ" => "ssut", "ꌽ" => "ssux", "ꌾ" => "ssu",
    "ꌿ" => "ssup", "ꍀ" => "ssyt", "ꍁ" => "ssyx", "ꍂ" => "ssy", "ꍃ" => "ssyp", "ꍄ" => "ssyrx",
    "ꍅ" => "ssyr", "ꍆ" => "zhat", "ꍇ" => "zhax", "ꍈ" => "zha", "ꍉ" => "zhap", "ꍊ" => "zhuox",
    "ꍋ" => "zhuo", "ꍌ" => "zhuop", "ꍍ" => "zhot", "ꍎ" => "zhox", "ꍏ" => "zho", "ꍐ" => "zhop",
    "ꍑ" => "zhet", "ꍒ" => "zhex", "ꍓ" => "zhe", "ꍔ" => "zhep", "ꍕ" => "zhut", "ꍖ" => "zhux",
    "ꍗ" => "zhu", "ꍘ" => "zhup", "ꍙ" => "zhurx", "ꍚ" => "zhur", "ꍛ" => "zhyt", "ꍜ" => "zhyx",
    "ꍝ" => "zhy", "ꍞ" => "zhyp", "ꍟ" => "zhyrx", "ꍠ" => "zhyr", "ꍡ" => "chat", "ꍢ" => "chax",
    "ꍣ" => "cha", "ꍤ" => "chap", "ꍥ" => "chuot", "ꍦ" => "chuox", "ꍧ" => "chuo", "ꍨ" => "chuop",
    "ꍩ" => "chot", "ꍪ" => "chox", "ꍫ" => "cho", "ꍬ" => "chop", "ꍭ" => "chet", "ꍮ" => "chex",
    "ꍯ" => "che", "ꍰ" => "chep", "ꍱ" => "chux", "ꍲ" => "chu", "ꍳ" => "chup", "ꍴ" => "churx",
    "ꍵ" => "chur", "ꍶ" => "chyt", "ꍷ" => "chyx", "ꍸ" => "chy", "ꍹ" => "chyp", "ꍺ" => "chyrx",
    "ꍻ" => "chyr", "ꍼ" => "rrax", "ꍽ" => "rra", "ꍾ" => "rruox", "ꍿ" => "rruo", "ꎀ" => "rrot",
    "ꎁ" => "rrox", "ꎂ" => "rro", "ꎃ" => "rrop", "ꎄ" => "rret", "ꎅ" => "rrex", "ꎆ" => "rre",
    "ꎇ" => "rrep", "ꎈ" => "rrut", "ꎉ" => "rrux", "ꎊ" => "rru", "ꎋ" => "rrup", "ꎌ" => "rrurx",
    "ꎍ" => "rrur", "ꎎ" => "rryt", "ꎏ" => "rryx", "ꎐ" => "rry", "ꎑ" => "rryp", "ꎒ" => "rryrx",
    "ꎓ" => "rryr", "ꎔ" => "nrat", "ꎕ" => "nrax", "ꎖ" => "nra", "ꎗ" => "nrap", "ꎘ" => "nrox",
    "ꎙ" => "nro", "ꎚ" => "nrop", "ꎛ" => "nret", "ꎜ" => "nrex", "ꎝ" => "nre", "ꎞ" => "nrep",
    "ꎟ" => "nrut", "ꎠ" => "nrux", "ꎡ" => "nru", "ꎢ" => "nrup", "ꎣ" => "nrurx", "ꎤ" => "nrur",
    "ꎥ" => "nryt", "ꎦ" => "nryx", "ꎧ" => "nry", "ꎨ" => "nryp", "ꎩ" => "nryrx", "ꎪ" => "nryr",
    "ꎫ" => "shat", "ꎬ" => "shax", "ꎭ" => "sha", "ꎮ" => "shap", "ꎯ" => "shuox", "ꎰ" => "shuo",
    "ꎱ" => "shuop", "ꎲ" => "shot", "ꎳ" => "shox", "ꎴ" => "sho", "ꎵ" => "shop", "ꎶ" => "shet",
    "ꎷ" => "shex", "ꎸ" => "she", "ꎹ" => "shep", "ꎺ" => "shut", "ꎻ" => "shux", "ꎼ" => "shu",
    "ꎽ" => "shup", "ꎾ" => "shurx", "ꎿ" => "shur", "ꏀ" => "shyt", "ꏁ" => "shyx", "ꏂ" => "shy",
    "ꏃ" => "shyp", "ꏄ" => "shyrx", "ꏅ" => "shyr", "ꏆ" => "rat", "ꏇ" => "rax", "ꏈ" => "ra",
    "ꏉ" => "rap", "ꏊ" => "ruox", "ꏋ" => "ruo", "ꏌ" => "ruop", "ꏍ" => "rot", "ꏎ" => "rox",
    "ꏏ" => "ro", "ꏐ" => "rop", "ꏑ" => "rex", "ꏒ" => "re", "ꏓ" => "rep", "ꏔ" => "rut",
    "ꏕ" => "rux", "ꏖ" => "ru", "ꏗ" => "rup", "ꏘ" => "rurx", "ꏙ" => "rur", "ꏚ" => "ryt",
    "ꏛ" => "ryx", "ꏜ" => "ry", "ꏝ" => "ryp", "ꏞ" => "ryrx", "ꏟ" => "ryr", "ꏠ" => "jit",
    "ꏡ" => "jix", "ꏢ" => "ji", "ꏣ" => "jip", "ꏤ" => "jiet", "ꏥ" => "jiex", "ꏦ" => "jie",
    "ꏧ" => "jiep", "ꏨ" => "juot", "ꏩ" => "juox", "ꏪ" => "juo", "ꏫ" => "juop", "ꏬ" => "jot",
    "ꏭ" => "jox", "ꏮ" => "jo", "ꏯ" => "jop", "ꏰ" => "jut", "ꏱ" => "jux", "ꏲ" => "ju",
    "ꏳ" => "jup", "ꏴ" => "jurx", "ꏵ" => "jur", "ꏶ" => "jyt", "ꏷ" => "jyx", "ꏸ" => "jy",
    "ꏹ" => "jyp", "ꏺ" => "jyrx", "ꏻ" => "jyr", "ꏼ" => "qit", "ꏽ" => "qix", "ꏾ" => "qi",
    "ꏿ" => "qip", "ꐁ" => "qiex", "ꐂ" => "qie", "ꐃ" => "qiep", "ꐄ" => "quot", "ꐅ" => "quox",
    "ꐆ" => "quo", "ꐇ" => "quop", "ꐈ" => "qot", "ꐉ" => "qox", "ꐊ" => "qo", "ꐋ" => "qop",
    "ꐌ" => "qut", "ꐍ" => "qux", "ꐎ" => "qu", "ꐏ" => "qup", "ꐐ" => "qurx", "ꐑ" => "qur",
    "ꐒ" => "qyt", "ꐓ" => "qyx", "ꐔ" => "qy", "ꐕ" => "qyp", "ꐖ" => "qyrx", "ꐗ" => "qyr",
    "ꐘ" => "jjit", "ꐙ" => "jjix", "ꐚ" => "jji", "ꐛ" => "jjip", "ꐜ" => "jjiet", "ꐝ" => "jjiex",
    "ꐞ" => "jjie", "ꐟ" => "jjiep", "ꐠ" => "jjuox", "ꐡ" => "jjuo", "ꐢ" => "jjuop", "ꐣ" => "jjot",
    "ꐤ" => "jjox", "ꐥ" => "jjo", "ꐦ" => "jjop", "ꐧ" => "jjut", "ꐨ" => "jjux", "ꐩ" => "jju",
    "ꐪ" => "jjup", "ꐫ" => "jjurx", "ꐬ" => "jjur", "ꐭ" => "jjyt", "ꐮ" => "jjyx", "ꐯ" => "jjy",
    "ꐰ" => "jjyp", "ꐱ" => "njit", "ꐲ" => "njix", "ꐳ" => "nji", "ꐴ" => "njip", "ꐵ" => "njiet",
    "ꐶ" => "njiex", "ꐷ" => "njie", "ꐸ" => "njiep", "ꐹ" => "njuox", "ꐺ" => "njuo", "ꐻ" => "njot",
    "ꐼ" => "njox", "ꐽ" => "njo", "ꐾ" => "njop", "ꐿ" => "njux", "ꑀ" => "nju", "ꑁ" => "njup",
    "ꑂ" => "njurx", "ꑃ" => "njur", "ꑄ" => "njyt", "ꑅ" => "njyx", "ꑆ" => "njy", "ꑇ" => "njyp",
    "ꑈ" => "njyrx", "ꑉ" => "njyr", "ꑊ" => "nyit", "ꑋ" => "nyix", "ꑌ" => "nyi", "ꑍ" => "nyip",
    "ꑎ" => "nyiet", "ꑏ" => "nyiex", "ꑐ" => "nyie", "ꑑ" => "nyiep", "ꑒ" => "nyuox", "ꑓ" => "nyuo",
    "ꑔ" => "nyuop", "ꑕ" => "nyot", "ꑖ" => "nyox", "ꑗ" => "nyo", "ꑘ" => "nyop", "ꑙ" => "nyut",
    "ꑚ" => "nyux", "ꑛ" => "nyu", "ꑜ" => "nyup", "ꑝ" => "xit", "ꑞ" => "xix", "ꑟ" => "xi",
    "ꑠ" => "xip", "ꑡ" => "xiet", "ꑢ" => "xiex", "ꑣ" => "xie", "ꑤ" => "xiep", "ꑥ" => "xuox",
    "ꑦ" => "xuo", "ꑧ" => "xot", "ꑨ" => "xox", "ꑩ" => "xo", "ꑪ" => "xop", "ꑫ" => "xyt",
    "ꑬ" => "xyx", "ꑭ" => "xy", "ꑮ" => "xyp", "ꑯ" => "xyrx", "ꑰ" => "xyr", "ꑱ" => "yit",
    "ꑲ" => "yix", "ꑳ" => "yi", "ꑴ" => "yip", "ꑵ" => "yiet", "ꑶ" => "yiex", "ꑷ" => "yie",
    "ꑸ" => "yiep", "ꑹ" => "yuot", "ꑺ" => "yuox", "ꑻ" => "yuo", "ꑼ" => "yuop", "ꑽ" => "yot",
    "ꑾ" => "yox", "ꑿ" => "yo", "ꒀ" => "yop", "ꒁ" => "yut", "ꒂ" => "yux", "ꒃ" => "yu",
    "ꒄ" => "yup", "ꒅ" => "yurx", "ꒆ" => "yur", "ꒇ" => "yyt", "ꒈ" => "yyx", "ꒉ" => "yy",
    "ꒊ" => "yyp", "ꒋ" => "yyrx", "ꒌ" => "yyr", "꒐" => "Qot", "꒑" => "Li", "꒒" => "Kit",
    "꒓" => "Nyip", "꒔" => "Cyp", "꒕" => "Ssi", "꒖" => "Ggop", "꒗" => "Gep", "꒘" => "Mi",
    "꒙" => "Hxit", "꒚" => "Lyr", "꒛" => "Bbut", "꒜" => "Mop", "꒝" => "Yo", "꒞" => "Put",
    "꒟" => "Hxuo", "꒠" => "Tat", "꒡" => "Ga", "꒤" => "Ddur", "꒥" => "Bur", "꒦" => "Gguo",
    "꒧" => "Nyop", "꒨" => "Tu", "꒩" => "Op", "꒪" => "Jjut", "꒫" => "Zot", "꒬" => "Pyt",
    "꒭" => "Hmo", "꒮" => "Yit", "꒯" => "Vur", "꒰" => "Shy", "꒱" => "Vep", "꒲" => "Za",
    "꒳" => "Jo", "꒵" => "Jjy", "꒶" => "Got", "꒷" => "Jjie", "꒸" => "Wo", "꒹" => "Du",
    "꒺" => "Shur", "꒻" => "Lie", "꒼" => "Cy", "꒽" => "Cuop", "꒾" => "Cip", "꒿" => "Hxop",
    "꓀" => "Shat", "꓂" => "Shop", "꓃" => "Che", "꓄" => "Zziet", "꓆" => "Ke", "각" => "gag",
    "갂" => "gagg", "갃" => "gags", "간" => "gan", "갅" => "ganj", "갆" => "ganh", "갇" => "gad",
    "갈" => "gal", "갉" => "galg", "갊" => "galm", "갋" => "galb", "갌" => "gals", "갍" => "galt",
    "갎" => "galp", "갏" => "galh", "감" => "gam", "갑" => "gab", "값" => "gabs", "갓" => "gas",
    "갔" => "gass", "강" => "gang", "갖" => "gaj", "갗" => "gac", "갘" => "gak", "같" => "gat",
    "갚" => "gap", "갛" => "gah", "개" => "gae", "객" => "gaeg", "갞" => "gaegg", "갟" => "gaegs",
    "갠" => "gaen", "갡" => "gaenj", "갢" => "gaenh", "갣" => "gaed", "갤" => "gael", "갥" => "gaelg",
    "갦" => "gaelm", "갧" => "gaelb", "갨" => "gaels", "갩" => "gaelt", "갪" => "gaelp", "갫" => "gaelh",
    "갬" => "gaem", "갭" => "gaeb", "갮" => "gaebs", "갯" => "gaes", "갰" => "gaess", "갱" => "gaeng",
    "갲" => "gaej", "갳" => "gaec", "갴" => "gaek", "갵" => "gaet", "갶" => "gaep", "갷" => "gaeh",
    "갸" => "gya", "갹" => "gyag", "갺" => "gyagg", "갻" => "gyags", "갼" => "gyan", "갽" => "gyanj",
    "갾" => "gyanh", "갿" => "gyad", "걀" => "gyal", "걁" => "gyalg", "걂" => "gyalm", "걃" => "gyalb",
    "걄" => "gyals", "걅" => "gyalt", "걆" => "gyalp", "걇" => "gyalh", "걈" => "gyam", "걉" => "gyab",
    "걊" => "gyabs", "걋" => "gyas", "걌" => "gyass", "걍" => "gyang", "걎" => "gyaj", "걏" => "gyac",
    "걐" => "gyak", "걑" => "gyat", "걒" => "gyap", "걓" => "gyah", "걔" => "gyae", "걕" => "gyaeg",
    "걖" => "gyaegg", "걗" => "gyaegs", "걘" => "gyaen", "걙" => "gyaenj", "걚" => "gyaenh", "걛" => "gyaed",
    "걜" => "gyael", "걝" => "gyaelg", "걞" => "gyaelm", "걟" => "gyaelb", "걠" => "gyaels", "걡" => "gyaelt",
    "걢" => "gyaelp", "걣" => "gyaelh", "걤" => "gyaem", "걥" => "gyaeb", "걦" => "gyaebs", "걧" => "gyaes",
    "걨" => "gyaess", "걩" => "gyaeng", "걪" => "gyaej", "걫" => "gyaec", "걬" => "gyaek", "걭" => "gyaet",
    "걮" => "gyaep", "걯" => "gyaeh", "거" => "geo", "걱" => "geog", "걲" => "geogg", "걳" => "geogs",
    "건" => "geon", "걵" => "geonj", "걶" => "geonh", "걷" => "geod", "걸" => "geol", "걹" => "geolg",
    "걺" => "geolm", "걻" => "geolb", "걼" => "geols", "걽" => "geolt", "걾" => "geolp", "걿" => "geolh",
    "검" => "geom", "겁" => "geob", "겂" => "geobs", "것" => "geos", "겄" => "geoss", "겅" => "geong",
    "겆" => "geoj", "겇" => "geoc", "겈" => "geok", "겉" => "geot", "겊" => "geop", "겋" => "geoh",
    "게" => "ge", "겍" => "geg", "겎" => "gegg", "겏" => "gegs", "겐" => "gen", "겑" => "genj",
    "겒" => "genh", "겓" => "ged", "겔" => "gel", "겕" => "gelg", "겖" => "gelm", "겗" => "gelb",
    "겘" => "gels", "겙" => "gelt", "겚" => "gelp", "겛" => "gelh", "겜" => "gem", "겝" => "geb",
    "겞" => "gebs", "겟" => "ges", "겠" => "gess", "겡" => "geng", "겢" => "gej", "겣" => "gec",
    "겤" => "gek", "겥" => "get", "겦" => "gep", "겧" => "geh", "겨" => "gyeo", "격" => "gyeog",
    "겪" => "gyeogg", "겫" => "gyeogs", "견" => "gyeon", "겭" => "gyeonj", "겮" => "gyeonh", "겯" => "gyeod",
    "결" => "gyeol", "겱" => "gyeolg", "겲" => "gyeolm", "겳" => "gyeolb", "겴" => "gyeols", "겵" => "gyeolt",
    "겶" => "gyeolp", "겷" => "gyeolh", "겸" => "gyeom", "겹" => "gyeob", "겺" => "gyeobs", "겻" => "gyeos",
    "겼" => "gyeoss", "경" => "gyeong", "겾" => "gyeoj", "겿" => "gyeoc", "곀" => "gyeok", "곁" => "gyeot",
    "곂" => "gyeop", "곃" => "gyeoh", "계" => "gye", "곅" => "gyeg", "곆" => "gyegg", "곇" => "gyegs",
    "곈" => "gyen", "곉" => "gyenj", "곊" => "gyenh", "곋" => "gyed", "곌" => "gyel", "곍" => "gyelg",
    "곎" => "gyelm", "곏" => "gyelb", "곐" => "gyels", "곑" => "gyelt", "곒" => "gyelp", "곓" => "gyelh",
    "곔" => "gyem", "곕" => "gyeb", "곖" => "gyebs", "곗" => "gyes", "곘" => "gyess", "곙" => "gyeng",
    "곚" => "gyej", "곛" => "gyec", "곜" => "gyek", "곝" => "gyet", "곞" => "gyep", "곟" => "gyeh",
    "고" => "go", "곡" => "gog", "곢" => "gogg", "곣" => "gogs", "곤" => "gon", "곥" => "gonj",
    "곦" => "gonh", "곧" => "god", "골" => "gol", "곩" => "golg", "곪" => "golm", "곫" => "golb",
    "곬" => "gols", "곭" => "golt", "곮" => "golp", "곯" => "golh", "곰" => "gom", "곱" => "gob",
    "곲" => "gobs", "곳" => "gos", "곴" => "goss", "공" => "gong", "곶" => "goj", "곷" => "goc",
    "곸" => "gok", "곹" => "got", "곺" => "gop", "곻" => "goh", "과" => "gwa", "곽" => "gwag",
    "곾" => "gwagg", "곿" => "gwags", "괁" => "gwanj", "괂" => "gwanh", "괃" => "gwad", "괄" => "gwal",
    "괅" => "gwalg", "괆" => "gwalm", "괇" => "gwalb", "괈" => "gwals", "괉" => "gwalt", "괊" => "gwalp",
    "괋" => "gwalh", "괌" => "gwam", "괍" => "gwab", "괎" => "gwabs", "괏" => "gwas", "괐" => "gwass",
    "광" => "gwang", "괒" => "gwaj", "괓" => "gwac", "괔" => "gwak", "괕" => "gwat", "괖" => "gwap",
    "괗" => "gwah", "괘" => "gwae", "괙" => "gwaeg", "괚" => "gwaegg", "괛" => "gwaegs", "괜" => "gwaen",
    "괝" => "gwaenj", "괞" => "gwaenh", "괟" => "gwaed", "괠" => "gwael", "괡" => "gwaelg", "괢" => "gwaelm",
    "괣" => "gwaelb", "괤" => "gwaels", "괥" => "gwaelt", "괦" => "gwaelp", "괧" => "gwaelh", "괨" => "gwaem",
    "괩" => "gwaeb", "괪" => "gwaebs", "괫" => "gwaes", "괬" => "gwaess", "괭" => "gwaeng", "괮" => "gwaej",
    "괯" => "gwaec", "괰" => "gwaek", "괱" => "gwaet", "괲" => "gwaep", "괳" => "gwaeh", "괴" => "goe",
    "괵" => "goeg", "괶" => "goegg", "괷" => "goegs", "괸" => "goen", "괹" => "goenj", "괺" => "goenh",
    "괻" => "goed", "괼" => "goel", "괽" => "goelg", "괾" => "goelm", "괿" => "goelb", "굀" => "goels",
    "굁" => "goelt", "굂" => "goelp", "굃" => "goelh", "굄" => "goem", "굅" => "goeb", "굆" => "goebs",
    "굇" => "goes", "굈" => "goess", "굉" => "goeng", "굊" => "goej", "굋" => "goec", "굌" => "goek",
    "굍" => "goet", "굎" => "goep", "굏" => "goeh", "교" => "gyo", "굑" => "gyog", "굒" => "gyogg",
    "굓" => "gyogs", "굔" => "gyon", "굕" => "gyonj", "굖" => "gyonh", "굗" => "gyod", "굘" => "gyol",
    "굙" => "gyolg", "굚" => "gyolm", "굛" => "gyolb", "굜" => "gyols", "굝" => "gyolt", "굞" => "gyolp",
    "굟" => "gyolh", "굠" => "gyom", "굡" => "gyob", "굢" => "gyobs", "굣" => "gyos", "굤" => "gyoss",
    "굥" => "gyong", "굦" => "gyoj", "굧" => "gyoc", "굨" => "gyok", "굩" => "gyot", "굪" => "gyop",
    "굫" => "gyoh", "구" => "gu", "국" => "gug", "굮" => "gugg", "굯" => "gugs", "군" => "gun",
    "굱" => "gunj", "굲" => "gunh", "굳" => "gud", "굴" => "gul", "굵" => "gulg", "굶" => "gulm",
    "굷" => "gulb", "굸" => "guls", "굹" => "gult", "굺" => "gulp", "굻" => "gulh", "굼" => "gum",
    "굽" => "gub", "굾" => "gubs", "굿" => "gus", "궀" => "guss", "궁" => "gung", "궂" => "guj",
    "궃" => "guc", "궄" => "guk", "궅" => "gut", "궆" => "gup", "궇" => "guh", "궈" => "gweo",
    "궉" => "gweog", "궊" => "gweogg", "궋" => "gweogs", "권" => "gweon", "궍" => "gweonj", "궎" => "gweonh",
    "궏" => "gweod", "궐" => "gweol", "궑" => "gweolg", "궒" => "gweolm", "궓" => "gweolb", "궔" => "gweols",
    "궕" => "gweolt", "궖" => "gweolp", "궗" => "gweolh", "궘" => "gweom", "궙" => "gweob", "궚" => "gweobs",
    "궛" => "gweos", "궜" => "gweoss", "궝" => "gweong", "궞" => "gweoj", "궟" => "gweoc", "궠" => "gweok",
    "궡" => "gweot", "궢" => "gweop", "궣" => "gweoh", "궤" => "gwe", "궥" => "gweg", "궦" => "gwegg",
    "궧" => "gwegs", "궨" => "gwen", "궩" => "gwenj", "궪" => "gwenh", "궫" => "gwed", "궬" => "gwel",
    "궭" => "gwelg", "궮" => "gwelm", "궯" => "gwelb", "궰" => "gwels", "궱" => "gwelt", "궲" => "gwelp",
    "궳" => "gwelh", "궴" => "gwem", "궵" => "gweb", "궶" => "gwebs", "궷" => "gwes", "궸" => "gwess",
    "궹" => "gweng", "궺" => "gwej", "궻" => "gwec", "궼" => "gwek", "궽" => "gwet", "궾" => "gwep",
    "궿" => "gweh", "귀" => "gwi", "귁" => "gwig", "귂" => "gwigg", "귃" => "gwigs", "귄" => "gwin",
    "귅" => "gwinj", "귆" => "gwinh", "귇" => "gwid", "귈" => "gwil", "귉" => "gwilg", "귊" => "gwilm",
    "귋" => "gwilb", "귌" => "gwils", "귍" => "gwilt", "귎" => "gwilp", "귏" => "gwilh", "귐" => "gwim",
    "귑" => "gwib", "귒" => "gwibs", "귓" => "gwis", "귔" => "gwiss", "귕" => "gwing", "귖" => "gwij",
    "귗" => "gwic", "귘" => "gwik", "귙" => "gwit", "귚" => "gwip", "귛" => "gwih", "규" => "gyu",
    "귝" => "gyug", "귞" => "gyugg", "귟" => "gyugs", "균" => "gyun", "귡" => "gyunj", "귢" => "gyunh",
    "귣" => "gyud", "귤" => "gyul", "귥" => "gyulg", "귦" => "gyulm", "귧" => "gyulb", "귨" => "gyuls",
    "귩" => "gyult", "귪" => "gyulp", "귫" => "gyulh", "귬" => "gyum", "귭" => "gyub", "귮" => "gyubs",
    "귯" => "gyus", "귰" => "gyuss", "귱" => "gyung", "귲" => "gyuj", "귳" => "gyuc", "귴" => "gyuk",
    "귵" => "gyut", "귶" => "gyup", "귷" => "gyuh", "그" => "geu", "극" => "geug", "귺" => "geugg",
    "귻" => "geugs", "근" => "geun", "귽" => "geunj", "귾" => "geunh", "귿" => "geud", "긁" => "geulg",
    "긂" => "geulm", "긃" => "geulb", "긄" => "geuls", "긅" => "geult", "긆" => "geulp", "긇" => "geulh",
    "금" => "geum", "급" => "geub", "긊" => "geubs", "긋" => "geus", "긌" => "geuss", "긍" => "geung",
    "긎" => "geuj", "긏" => "geuc", "긐" => "geuk", "긑" => "geut", "긒" => "geup", "긓" => "geuh",
    "긔" => "gyi", "긕" => "gyig", "긖" => "gyigg", "긗" => "gyigs", "긘" => "gyin", "긙" => "gyinj",
    "긚" => "gyinh", "긛" => "gyid", "긜" => "gyil", "긝" => "gyilg", "긞" => "gyilm", "긟" => "gyilb",
    "긠" => "gyils", "긡" => "gyilt", "긢" => "gyilp", "긣" => "gyilh", "긤" => "gyim", "긥" => "gyib",
    "긦" => "gyibs", "긧" => "gyis", "긨" => "gyiss", "긩" => "gying", "긪" => "gyij", "긫" => "gyic",
    "긬" => "gyik", "긭" => "gyit", "긮" => "gyip", "긯" => "gyih", "기" => "gi", "긱" => "gig",
    "긲" => "gigg", "긳" => "gigs", "긴" => "gin", "긵" => "ginj", "긶" => "ginh", "긷" => "gid",
    "길" => "gil", "긹" => "gilg", "긺" => "gilm", "긻" => "gilb", "긼" => "gils", "긽" => "gilt",
    "긾" => "gilp", "긿" => "gilh", "김" => "gim", "깁" => "gib", "깂" => "gibs", "깃" => "gis",
    "깄" => "giss", "깅" => "ging", "깆" => "gij", "깇" => "gic", "깈" => "gik", "깉" => "git",
    "깊" => "gip", "깋" => "gih", "까" => "gga", "깍" => "ggag", "깎" => "ggagg", "깏" => "ggags",
    "깐" => "ggan", "깑" => "gganj", "깒" => "gganh", "깓" => "ggad", "깔" => "ggal", "깕" => "ggalg",
    "깖" => "ggalm", "깗" => "ggalb", "깘" => "ggals", "깙" => "ggalt", "깚" => "ggalp", "깛" => "ggalh",
    "깜" => "ggam", "깝" => "ggab", "깞" => "ggabs", "깟" => "ggas", "깠" => "ggass", "깡" => "ggang",
    "깢" => "ggaj", "깣" => "ggac", "깤" => "ggak", "깥" => "ggat", "깦" => "ggap", "깧" => "ggah",
    "깨" => "ggae", "깩" => "ggaeg", "깪" => "ggaegg", "깫" => "ggaegs", "깬" => "ggaen", "깭" => "ggaenj",
    "깮" => "ggaenh", "깯" => "ggaed", "깰" => "ggael", "깱" => "ggaelg", "깲" => "ggaelm", "깳" => "ggaelb",
    "깴" => "ggaels", "깵" => "ggaelt", "깶" => "ggaelp", "깷" => "ggaelh", "깸" => "ggaem", "깹" => "ggaeb",
    "깺" => "ggaebs", "깻" => "ggaes", "깼" => "ggaess", "깽" => "ggaeng", "깾" => "ggaej", "깿" => "ggaec",
    "꺀" => "ggaek", "꺁" => "ggaet", "꺂" => "ggaep", "꺃" => "ggaeh", "꺄" => "ggya", "꺅" => "ggyag",
    "꺆" => "ggyagg", "꺇" => "ggyags", "꺈" => "ggyan", "꺉" => "ggyanj", "꺊" => "ggyanh", "꺋" => "ggyad",
    "꺌" => "ggyal", "꺍" => "ggyalg", "꺎" => "ggyalm", "꺏" => "ggyalb", "꺐" => "ggyals", "꺑" => "ggyalt",
    "꺒" => "ggyalp", "꺓" => "ggyalh", "꺔" => "ggyam", "꺕" => "ggyab", "꺖" => "ggyabs", "꺗" => "ggyas",
    "꺘" => "ggyass", "꺙" => "ggyang", "꺚" => "ggyaj", "꺛" => "ggyac", "꺜" => "ggyak", "꺝" => "ggyat",
    "꺞" => "ggyap", "꺟" => "ggyah", "꺠" => "ggyae", "꺡" => "ggyaeg", "꺢" => "ggyaegg", "꺣" => "ggyaegs",
    "꺤" => "ggyaen", "꺥" => "ggyaenj", "꺦" => "ggyaenh", "꺧" => "ggyaed", "꺨" => "ggyael", "꺩" => "ggyaelg",
    "꺪" => "ggyaelm", "꺫" => "ggyaelb", "꺬" => "ggyaels", "꺭" => "ggyaelt", "꺮" => "ggyaelp", "꺯" => "ggyaelh",
    "꺰" => "ggyaem", "꺱" => "ggyaeb", "꺲" => "ggyaebs", "꺳" => "ggyaes", "꺴" => "ggyaess", "꺵" => "ggyaeng",
    "꺶" => "ggyaej", "꺷" => "ggyaec", "꺸" => "ggyaek", "꺹" => "ggyaet", "꺺" => "ggyaep", "꺻" => "ggyaeh",
    "꺼" => "ggeo", "꺽" => "ggeog", "꺾" => "ggeogg", "꺿" => "ggeogs", "껀" => "ggeon", "껁" => "ggeonj",
    "껂" => "ggeonh", "껃" => "ggeod", "껄" => "ggeol", "껅" => "ggeolg", "껆" => "ggeolm", "껇" => "ggeolb",
    "껈" => "ggeols", "껉" => "ggeolt", "껊" => "ggeolp", "껋" => "ggeolh", "껌" => "ggeom", "껍" => "ggeob",
    "껎" => "ggeobs", "껏" => "ggeos", "껐" => "ggeoss", "껑" => "ggeong", "껒" => "ggeoj", "껓" => "ggeoc",
    "껔" => "ggeok", "껕" => "ggeot", "껖" => "ggeop", "껗" => "ggeoh", "께" => "gge", "껙" => "ggeg",
    "껚" => "ggegg", "껛" => "ggegs", "껜" => "ggen", "껝" => "ggenj", "껞" => "ggenh", "껟" => "gged",
    "껠" => "ggel", "껡" => "ggelg", "껢" => "ggelm", "껣" => "ggelb", "껤" => "ggels", "껥" => "ggelt",
    "껦" => "ggelp", "껧" => "ggelh", "껨" => "ggem", "껩" => "ggeb", "껪" => "ggebs", "껫" => "gges",
    "껬" => "ggess", "껭" => "ggeng", "껮" => "ggej", "껯" => "ggec", "껰" => "ggek", "껱" => "gget",
    "껲" => "ggep", "껳" => "ggeh", "껴" => "ggyeo", "껵" => "ggyeog", "껶" => "ggyeogg", "껷" => "ggyeogs",
    "껸" => "ggyeon", "껹" => "ggyeonj", "껺" => "ggyeonh", "껻" => "ggyeod", "껼" => "ggyeol", "껽" => "ggyeolg",
    "껾" => "ggyeolm", "껿" => "ggyeolb", "꼁" => "ggyeolt", "꼂" => "ggyeolp", "꼃" => "ggyeolh", "꼄" => "ggyeom",
    "꼅" => "ggyeob", "꼆" => "ggyeobs", "꼇" => "ggyeos", "꼈" => "ggyeoss", "꼉" => "ggyeong", "꼊" => "ggyeoj",
    "꼋" => "ggyeoc", "꼌" => "ggyeok", "꼍" => "ggyeot", "꼎" => "ggyeop", "꼏" => "ggyeoh", "꼐" => "ggye",
    "꼑" => "ggyeg", "꼒" => "ggyegg", "꼓" => "ggyegs", "꼔" => "ggyen", "꼕" => "ggyenj", "꼖" => "ggyenh",
    "꼗" => "ggyed", "꼘" => "ggyel", "꼙" => "ggyelg", "꼚" => "ggyelm", "꼛" => "ggyelb", "꼜" => "ggyels",
    "꼝" => "ggyelt", "꼞" => "ggyelp", "꼟" => "ggyelh", "꼠" => "ggyem", "꼡" => "ggyeb", "꼢" => "ggyebs",
    "꼣" => "ggyes", "꼤" => "ggyess", "꼥" => "ggyeng", "꼦" => "ggyej", "꼧" => "ggyec", "꼨" => "ggyek",
    "꼩" => "ggyet", "꼪" => "ggyep", "꼫" => "ggyeh", "꼬" => "ggo", "꼭" => "ggog", "꼮" => "ggogg",
    "꼯" => "ggogs", "꼰" => "ggon", "꼱" => "ggonj", "꼲" => "ggonh", "꼳" => "ggod", "꼴" => "ggol",
    "꼵" => "ggolg", "꼶" => "ggolm", "꼷" => "ggolb", "꼸" => "ggols", "꼹" => "ggolt", "꼺" => "ggolp",
    "꼻" => "ggolh", "꼼" => "ggom", "꼽" => "ggob", "꼾" => "ggobs", "꼿" => "ggos", "꽀" => "ggoss",
    "꽁" => "ggong", "꽂" => "ggoj", "꽃" => "ggoc", "꽄" => "ggok", "꽅" => "ggot", "꽆" => "ggop",
    "꽇" => "ggoh", "꽈" => "ggwa", "꽉" => "ggwag", "꽊" => "ggwagg", "꽋" => "ggwags", "꽌" => "ggwan",
    "꽍" => "ggwanj", "꽎" => "ggwanh", "꽏" => "ggwad", "꽐" => "ggwal", "꽑" => "ggwalg", "꽒" => "ggwalm",
    "꽓" => "ggwalb", "꽔" => "ggwals", "꽕" => "ggwalt", "꽖" => "ggwalp", "꽗" => "ggwalh", "꽘" => "ggwam",
    "꽙" => "ggwab", "꽚" => "ggwabs", "꽛" => "ggwas", "꽜" => "ggwass", "꽝" => "ggwang", "꽞" => "ggwaj",
    "꽟" => "ggwac", "꽠" => "ggwak", "꽡" => "ggwat", "꽢" => "ggwap", "꽣" => "ggwah", "꽤" => "ggwae",
    "꽥" => "ggwaeg", "꽦" => "ggwaegg", "꽧" => "ggwaegs", "꽨" => "ggwaen", "꽩" => "ggwaenj", "꽪" => "ggwaenh",
    "꽫" => "ggwaed", "꽬" => "ggwael", "꽭" => "ggwaelg", "꽮" => "ggwaelm", "꽯" => "ggwaelb", "꽰" => "ggwaels",
    "꽱" => "ggwaelt", "꽲" => "ggwaelp", "꽳" => "ggwaelh", "꽴" => "ggwaem", "꽵" => "ggwaeb", "꽶" => "ggwaebs",
    "꽷" => "ggwaes", "꽸" => "ggwaess", "꽹" => "ggwaeng", "꽺" => "ggwaej", "꽻" => "ggwaec", "꽼" => "ggwaek",
    "꽽" => "ggwaet", "꽾" => "ggwaep", "꽿" => "ggwaeh", "꾀" => "ggoe", "꾁" => "ggoeg", "꾂" => "ggoegg",
    "꾃" => "ggoegs", "꾄" => "ggoen", "꾅" => "ggoenj", "꾆" => "ggoenh", "꾇" => "ggoed", "꾈" => "ggoel",
    "꾉" => "ggoelg", "꾊" => "ggoelm", "꾋" => "ggoelb", "꾌" => "ggoels", "꾍" => "ggoelt", "꾎" => "ggoelp",
    "꾏" => "ggoelh", "꾐" => "ggoem", "꾑" => "ggoeb", "꾒" => "ggoebs", "꾓" => "ggoes", "꾔" => "ggoess",
    "꾕" => "ggoeng", "꾖" => "ggoej", "꾗" => "ggoec", "꾘" => "ggoek", "꾙" => "ggoet", "꾚" => "ggoep",
    "꾛" => "ggoeh", "꾜" => "ggyo", "꾝" => "ggyog", "꾞" => "ggyogg", "꾟" => "ggyogs", "꾠" => "ggyon",
    "꾡" => "ggyonj", "꾢" => "ggyonh", "꾣" => "ggyod", "꾤" => "ggyol", "꾥" => "ggyolg", "꾦" => "ggyolm",
    "꾧" => "ggyolb", "꾨" => "ggyols", "꾩" => "ggyolt", "꾪" => "ggyolp", "꾫" => "ggyolh", "꾬" => "ggyom",
    "꾭" => "ggyob", "꾮" => "ggyobs", "꾯" => "ggyos", "꾰" => "ggyoss", "꾱" => "ggyong", "꾲" => "ggyoj",
    "꾳" => "ggyoc", "꾴" => "ggyok", "꾵" => "ggyot", "꾶" => "ggyop", "꾷" => "ggyoh", "꾸" => "ggu",
    "꾹" => "ggug", "꾺" => "ggugg", "꾻" => "ggugs", "꾼" => "ggun", "꾽" => "ggunj", "꾾" => "ggunh",
    "꾿" => "ggud", "꿀" => "ggul", "꿁" => "ggulg", "꿂" => "ggulm", "꿃" => "ggulb", "꿄" => "gguls",
    "꿅" => "ggult", "꿆" => "ggulp", "꿇" => "ggulh", "꿈" => "ggum", "꿉" => "ggub", "꿊" => "ggubs",
    "꿋" => "ggus", "꿌" => "gguss", "꿍" => "ggung", "꿎" => "gguj", "꿏" => "gguc", "꿐" => "gguk",
    "꿑" => "ggut", "꿒" => "ggup", "꿓" => "gguh", "꿔" => "ggweo", "꿕" => "ggweog", "꿖" => "ggweogg",
    "꿗" => "ggweogs", "꿘" => "ggweon", "꿙" => "ggweonj", "꿚" => "ggweonh", "꿛" => "ggweod", "꿜" => "ggweol",
    "꿝" => "ggweolg", "꿞" => "ggweolm", "꿟" => "ggweolb", "꿠" => "ggweols", "꿡" => "ggweolt", "꿢" => "ggweolp",
    "꿣" => "ggweolh", "꿤" => "ggweom", "꿥" => "ggweob", "꿦" => "ggweobs", "꿧" => "ggweos", "꿨" => "ggweoss",
    "꿩" => "ggweong", "꿪" => "ggweoj", "꿫" => "ggweoc", "꿬" => "ggweok", "꿭" => "ggweot", "꿮" => "ggweop",
    "꿯" => "ggweoh", "꿰" => "ggwe", "꿱" => "ggweg", "꿲" => "ggwegg", "꿳" => "ggwegs", "꿴" => "ggwen",
    "꿵" => "ggwenj", "꿶" => "ggwenh", "꿷" => "ggwed", "꿸" => "ggwel", "꿹" => "ggwelg", "꿺" => "ggwelm",
    "꿻" => "ggwelb", "꿼" => "ggwels", "꿽" => "ggwelt", "꿾" => "ggwelp", "꿿" => "ggwelh", "뀁" => "ggweb",
    "뀂" => "ggwebs", "뀃" => "ggwes", "뀄" => "ggwess", "뀅" => "ggweng", "뀆" => "ggwej", "뀇" => "ggwec",
    "뀈" => "ggwek", "뀉" => "ggwet", "뀊" => "ggwep", "뀋" => "ggweh", "뀌" => "ggwi", "뀍" => "ggwig",
    "뀎" => "ggwigg", "뀏" => "ggwigs", "뀐" => "ggwin", "뀑" => "ggwinj", "뀒" => "ggwinh", "뀓" => "ggwid",
    "뀔" => "ggwil", "뀕" => "ggwilg", "뀖" => "ggwilm", "뀗" => "ggwilb", "뀘" => "ggwils", "뀙" => "ggwilt",
    "뀚" => "ggwilp", "뀛" => "ggwilh", "뀜" => "ggwim", "뀝" => "ggwib", "뀞" => "ggwibs", "뀟" => "ggwis",
    "뀠" => "ggwiss", "뀡" => "ggwing", "뀢" => "ggwij", "뀣" => "ggwic", "뀤" => "ggwik", "뀥" => "ggwit",
    "뀦" => "ggwip", "뀧" => "ggwih", "뀨" => "ggyu", "뀩" => "ggyug", "뀪" => "ggyugg", "뀫" => "ggyugs",
    "뀬" => "ggyun", "뀭" => "ggyunj", "뀮" => "ggyunh", "뀯" => "ggyud", "뀰" => "ggyul", "뀱" => "ggyulg",
    "뀲" => "ggyulm", "뀳" => "ggyulb", "뀴" => "ggyuls", "뀵" => "ggyult", "뀶" => "ggyulp", "뀷" => "ggyulh",
    "뀸" => "ggyum", "뀹" => "ggyub", "뀺" => "ggyubs", "뀻" => "ggyus", "뀼" => "ggyuss", "뀽" => "ggyung",
    "뀾" => "ggyuj", "뀿" => "ggyuc", "끀" => "ggyuk", "끁" => "ggyut", "끂" => "ggyup", "끃" => "ggyuh",
    "끄" => "ggeu", "끅" => "ggeug", "끆" => "ggeugg", "끇" => "ggeugs", "끈" => "ggeun", "끉" => "ggeunj",
    "끊" => "ggeunh", "끋" => "ggeud", "끌" => "ggeul", "끍" => "ggeulg", "끎" => "ggeulm", "끏" => "ggeulb",
    "끐" => "ggeuls", "끑" => "ggeult", "끒" => "ggeulp", "끓" => "ggeulh", "끔" => "ggeum", "끕" => "ggeub",
    "끖" => "ggeubs", "끗" => "ggeus", "끘" => "ggeuss", "끙" => "ggeung", "끚" => "ggeuj", "끛" => "ggeuc",
    "끜" => "ggeuk", "끝" => "ggeut", "끞" => "ggeup", "끟" => "ggeuh", "끠" => "ggyi", "끡" => "ggyig",
    "끢" => "ggyigg", "끣" => "ggyigs", "끤" => "ggyin", "끥" => "ggyinj", "끦" => "ggyinh", "끧" => "ggyid",
    "끨" => "ggyil", "끩" => "ggyilg", "끪" => "ggyilm", "끫" => "ggyilb", "끬" => "ggyils", "끭" => "ggyilt",
    "끮" => "ggyilp", "끯" => "ggyilh", "끰" => "ggyim", "끱" => "ggyib", "끲" => "ggyibs", "끳" => "ggyis",
    "끴" => "ggyiss", "끵" => "ggying", "끶" => "ggyij", "끷" => "ggyic", "끸" => "ggyik", "끹" => "ggyit",
    "끺" => "ggyip", "끻" => "ggyih", "끼" => "ggi", "끽" => "ggig", "끾" => "ggigg", "끿" => "ggigs",
    "낀" => "ggin", "낁" => "gginj", "낂" => "gginh", "낃" => "ggid", "낄" => "ggil", "낅" => "ggilg",
    "낆" => "ggilm", "낇" => "ggilb", "낈" => "ggils", "낉" => "ggilt", "낊" => "ggilp", "낋" => "ggilh",
    "낌" => "ggim", "낍" => "ggib", "낎" => "ggibs", "낏" => "ggis", "낐" => "ggiss", "낑" => "gging",
    "낒" => "ggij", "낓" => "ggic", "낔" => "ggik", "낕" => "ggit", "낖" => "ggip", "낗" => "ggih",
    "나" => "na", "낙" => "nag", "낚" => "nagg", "낛" => "nags", "난" => "nan", "낝" => "nanj",
    "낞" => "nanh", "낟" => "nad", "날" => "nal", "낡" => "nalg", "낢" => "nalm", "낣" => "nalb",
    "낤" => "nals", "낥" => "nalt", "낦" => "nalp", "낧" => "nalh", "남" => "nam", "납" => "nab",
    "낪" => "nabs", "낫" => "nas", "났" => "nass", "낭" => "nang", "낮" => "naj", "낯" => "nac",
    "낰" => "nak", "낱" => "nat", "낲" => "nap", "낳" => "nah", "내" => "nae", "낵" => "naeg",
    "낶" => "naegg", "낷" => "naegs", "낸" => "naen", "낹" => "naenj", "낺" => "naenh", "낻" => "naed",
    "낼" => "nael", "낽" => "naelg", "낾" => "naelm", "낿" => "naelb", "냀" => "naels", "냁" => "naelt",
    "냂" => "naelp", "냃" => "naelh", "냄" => "naem", "냅" => "naeb", "냆" => "naebs", "냇" => "naes",
    "냈" => "naess", "냉" => "naeng", "냊" => "naej", "냋" => "naec", "냌" => "naek", "냍" => "naet",
    "냎" => "naep", "냏" => "naeh", "냐" => "nya", "냑" => "nyag", "냒" => "nyagg", "냓" => "nyags",
    "냔" => "nyan", "냕" => "nyanj", "냖" => "nyanh", "냗" => "nyad", "냘" => "nyal", "냙" => "nyalg",
    "냚" => "nyalm", "냛" => "nyalb", "냜" => "nyals", "냝" => "nyalt", "냞" => "nyalp", "냟" => "nyalh",
    "냠" => "nyam", "냡" => "nyab", "냢" => "nyabs", "냣" => "nyas", "냤" => "nyass", "냥" => "nyang",
    "냦" => "nyaj", "냧" => "nyac", "냨" => "nyak", "냩" => "nyat", "냪" => "nyap", "냫" => "nyah",
    "냬" => "nyae", "냭" => "nyaeg", "냮" => "nyaegg", "냯" => "nyaegs", "냰" => "nyaen", "냱" => "nyaenj",
    "냲" => "nyaenh", "냳" => "nyaed", "냴" => "nyael", "냵" => "nyaelg", "냶" => "nyaelm", "냷" => "nyaelb",
    "냸" => "nyaels", "냹" => "nyaelt", "냺" => "nyaelp", "냻" => "nyaelh", "냼" => "nyaem", "냽" => "nyaeb",
    "냾" => "nyaebs", "냿" => "nyaes", "넁" => "nyaeng", "넂" => "nyaej", "넃" => "nyaec", "넄" => "nyaek",
    "넅" => "nyaet", "넆" => "nyaep", "넇" => "nyaeh", "너" => "neo", "넉" => "neog", "넊" => "neogg",
    "넋" => "neogs", "넌" => "neon", "넍" => "neonj", "넎" => "neonh", "넏" => "neod", "널" => "neol",
    "넑" => "neolg", "넒" => "neolm", "넓" => "neolb", "넔" => "neols", "넕" => "neolt", "넖" => "neolp",
    "넗" => "neolh", "넘" => "neom", "넙" => "neob", "넚" => "neobs", "넛" => "neos", "넜" => "neoss",
    "넝" => "neong", "넞" => "neoj", "넟" => "neoc", "넠" => "neok", "넡" => "neot", "넢" => "neop",
    "넣" => "neoh", "네" => "ne", "넥" => "neg", "넦" => "negg", "넧" => "negs", "넨" => "nen",
    "넩" => "nenj", "넪" => "nenh", "넫" => "ned", "넬" => "nel", "넭" => "nelg", "넮" => "nelm",
    "넯" => "nelb", "넰" => "nels", "넱" => "nelt", "넲" => "nelp", "넳" => "nelh", "넴" => "nem",
    "넵" => "neb", "넶" => "nebs", "넷" => "nes", "넸" => "ness", "넹" => "neng", "넺" => "nej",
    "넻" => "nec", "넼" => "nek", "넽" => "net", "넾" => "nep", "넿" => "neh", "녀" => "nyeo",
    "녁" => "nyeog", "녂" => "nyeogg", "녃" => "nyeogs", "년" => "nyeon", "녅" => "nyeonj", "녆" => "nyeonh",
    "녇" => "nyeod", "녈" => "nyeol", "녉" => "nyeolg", "녊" => "nyeolm", "녋" => "nyeolb", "녌" => "nyeols",
    "녍" => "nyeolt", "녎" => "nyeolp", "녏" => "nyeolh", "념" => "nyeom", "녑" => "nyeob", "녒" => "nyeobs",
    "녓" => "nyeos", "녔" => "nyeoss", "녕" => "nyeong", "녖" => "nyeoj", "녗" => "nyeoc", "녘" => "nyeok",
    "녙" => "nyeot", "녚" => "nyeop", "녛" => "nyeoh", "녜" => "nye", "녝" => "nyeg", "녞" => "nyegg",
    "녟" => "nyegs", "녠" => "nyen", "녡" => "nyenj", "녢" => "nyenh", "녣" => "nyed", "녤" => "nyel",
    "녥" => "nyelg", "녦" => "nyelm", "녧" => "nyelb", "녨" => "nyels", "녩" => "nyelt", "녪" => "nyelp",
    "녫" => "nyelh", "녬" => "nyem", "녭" => "nyeb", "녮" => "nyebs", "녯" => "nyes", "녰" => "nyess",
    "녱" => "nyeng", "녲" => "nyej", "녳" => "nyec", "녴" => "nyek", "녵" => "nyet", "녶" => "nyep",
    "녷" => "nyeh", "노" => "no", "녹" => "nog", "녺" => "nogg", "녻" => "nogs", "논" => "non",
    "녽" => "nonj", "녾" => "nonh", "녿" => "nod", "놀" => "nol", "놁" => "nolg", "놂" => "nolm",
    "놃" => "nolb", "놄" => "nols", "놅" => "nolt", "놆" => "nolp", "놇" => "nolh", "놈" => "nom",
    "놉" => "nob", "놊" => "nobs", "놋" => "nos", "놌" => "noss", "농" => "nong", "놎" => "noj",
    "놏" => "noc", "놐" => "nok", "놑" => "not", "높" => "nop", "놓" => "noh", "놔" => "nwa",
    "놕" => "nwag", "놖" => "nwagg", "놗" => "nwags", "놘" => "nwan", "놙" => "nwanj", "놚" => "nwanh",
    "놛" => "nwad", "놜" => "nwal", "놝" => "nwalg", "놞" => "nwalm", "놟" => "nwalb", "놠" => "nwals",
    "놡" => "nwalt", "놢" => "nwalp", "놣" => "nwalh", "놤" => "nwam", "놥" => "nwab", "놦" => "nwabs",
    "놧" => "nwas", "놨" => "nwass", "놩" => "nwang", "놪" => "nwaj", "놫" => "nwac", "놬" => "nwak",
    "놭" => "nwat", "놮" => "nwap", "놯" => "nwah", "놰" => "nwae", "놱" => "nwaeg", "놲" => "nwaegg",
    "놳" => "nwaegs", "놴" => "nwaen", "놵" => "nwaenj", "놶" => "nwaenh", "놷" => "nwaed", "놸" => "nwael",
    "놹" => "nwaelg", "놺" => "nwaelm", "놻" => "nwaelb", "놼" => "nwaels", "놽" => "nwaelt", "놾" => "nwaelp",
    "놿" => "nwaelh", "뇀" => "nwaem", "뇁" => "nwaeb", "뇂" => "nwaebs", "뇃" => "nwaes", "뇄" => "nwaess",
    "뇅" => "nwaeng", "뇆" => "nwaej", "뇇" => "nwaec", "뇈" => "nwaek", "뇉" => "nwaet", "뇊" => "nwaep",
    "뇋" => "nwaeh", "뇌" => "noe", "뇍" => "noeg", "뇎" => "noegg", "뇏" => "noegs", "뇐" => "noen",
    "뇑" => "noenj", "뇒" => "noenh", "뇓" => "noed", "뇔" => "noel", "뇕" => "noelg", "뇖" => "noelm",
    "뇗" => "noelb", "뇘" => "noels", "뇙" => "noelt", "뇚" => "noelp", "뇛" => "noelh", "뇜" => "noem",
    "뇝" => "noeb", "뇞" => "noebs", "뇟" => "noes", "뇠" => "noess", "뇡" => "noeng", "뇢" => "noej",
    "뇣" => "noec", "뇤" => "noek", "뇥" => "noet", "뇦" => "noep", "뇧" => "noeh", "뇨" => "nyo",
    "뇩" => "nyog", "뇪" => "nyogg", "뇫" => "nyogs", "뇬" => "nyon", "뇭" => "nyonj", "뇮" => "nyonh",
    "뇯" => "nyod", "뇰" => "nyol", "뇱" => "nyolg", "뇲" => "nyolm", "뇳" => "nyolb", "뇴" => "nyols",
    "뇵" => "nyolt", "뇶" => "nyolp", "뇷" => "nyolh", "뇸" => "nyom", "뇹" => "nyob", "뇺" => "nyobs",
    "뇻" => "nyos", "뇼" => "nyoss", "뇽" => "nyong", "뇾" => "nyoj", "뇿" => "nyoc", "눁" => "nyot",
    "눂" => "nyop", "눃" => "nyoh", "누" => "nu", "눅" => "nug", "눆" => "nugg", "눇" => "nugs",
    "눈" => "nun", "눉" => "nunj", "눊" => "nunh", "눋" => "nud", "눌" => "nul", "눍" => "nulg",
    "눎" => "nulm", "눏" => "nulb", "눐" => "nuls", "눑" => "nult", "눒" => "nulp", "눓" => "nulh",
    "눔" => "num", "눕" => "nub", "눖" => "nubs", "눗" => "nus", "눘" => "nuss", "눙" => "nung",
    "눚" => "nuj", "눛" => "nuc", "눜" => "nuk", "눝" => "nut", "눞" => "nup", "눟" => "nuh",
    "눠" => "nweo", "눡" => "nweog", "눢" => "nweogg", "눣" => "nweogs", "눤" => "nweon", "눥" => "nweonj",
    "눦" => "nweonh", "눧" => "nweod", "눨" => "nweol", "눩" => "nweolg", "눪" => "nweolm", "눫" => "nweolb",
    "눬" => "nweols", "눭" => "nweolt", "눮" => "nweolp", "눯" => "nweolh", "눰" => "nweom", "눱" => "nweob",
    "눲" => "nweobs", "눳" => "nweos", "눴" => "nweoss", "눵" => "nweong", "눶" => "nweoj", "눷" => "nweoc",
    "눸" => "nweok", "눹" => "nweot", "눺" => "nweop", "눻" => "nweoh", "눼" => "nwe", "눽" => "nweg",
    "눾" => "nwegg", "눿" => "nwegs", "뉀" => "nwen", "뉁" => "nwenj", "뉂" => "nwenh", "뉃" => "nwed",
    "뉄" => "nwel", "뉅" => "nwelg", "뉆" => "nwelm", "뉇" => "nwelb", "뉈" => "nwels", "뉉" => "nwelt",
    "뉊" => "nwelp", "뉋" => "nwelh", "뉌" => "nwem", "뉍" => "nweb", "뉎" => "nwebs", "뉏" => "nwes",
    "뉐" => "nwess", "뉑" => "nweng", "뉒" => "nwej", "뉓" => "nwec", "뉔" => "nwek", "뉕" => "nwet",
    "뉖" => "nwep", "뉗" => "nweh", "뉘" => "nwi", "뉙" => "nwig", "뉚" => "nwigg", "뉛" => "nwigs",
    "뉜" => "nwin", "뉝" => "nwinj", "뉞" => "nwinh", "뉟" => "nwid", "뉠" => "nwil", "뉡" => "nwilg",
    "뉢" => "nwilm", "뉣" => "nwilb", "뉤" => "nwils", "뉥" => "nwilt", "뉦" => "nwilp", "뉧" => "nwilh",
    "뉨" => "nwim", "뉩" => "nwib", "뉪" => "nwibs", "뉫" => "nwis", "뉬" => "nwiss", "뉭" => "nwing",
    "뉮" => "nwij", "뉯" => "nwic", "뉰" => "nwik", "뉱" => "nwit", "뉲" => "nwip", "뉳" => "nwih",
    "뉴" => "nyu", "뉵" => "nyug", "뉶" => "nyugg", "뉷" => "nyugs", "뉸" => "nyun", "뉹" => "nyunj",
    "뉺" => "nyunh", "뉻" => "nyud", "뉼" => "nyul", "뉽" => "nyulg", "뉾" => "nyulm", "뉿" => "nyulb",
    "늀" => "nyuls", "늁" => "nyult", "늂" => "nyulp", "늃" => "nyulh", "늄" => "nyum", "늅" => "nyub",
    "늆" => "nyubs", "늇" => "nyus", "늈" => "nyuss", "늉" => "nyung", "늊" => "nyuj", "늋" => "nyuc",
    "늌" => "nyuk", "늍" => "nyut", "늎" => "nyup", "늏" => "nyuh", "느" => "neu", "늑" => "neug",
    "늒" => "neugg", "늓" => "neugs", "는" => "neun", "늕" => "neunj", "늖" => "neunh", "늗" => "neud",
    "늘" => "neul", "늙" => "neulg", "늚" => "neulm", "늛" => "neulb", "늜" => "neuls", "늝" => "neult",
    "늞" => "neulp", "늟" => "neulh", "늠" => "neum", "늡" => "neub", "늢" => "neubs", "늣" => "neus",
    "늤" => "neuss", "능" => "neung", "늦" => "neuj", "늧" => "neuc", "늨" => "neuk", "늩" => "neut",
    "늪" => "neup", "늫" => "neuh", "늬" => "nyi", "늭" => "nyig", "늮" => "nyigg", "늯" => "nyigs",
    "늰" => "nyin", "늱" => "nyinj", "늲" => "nyinh", "늳" => "nyid", "늴" => "nyil", "늵" => "nyilg",
    "늶" => "nyilm", "늷" => "nyilb", "늸" => "nyils", "늹" => "nyilt", "늺" => "nyilp", "늻" => "nyilh",
    "늼" => "nyim", "늽" => "nyib", "늾" => "nyibs", "늿" => "nyis", "닀" => "nyiss", "닁" => "nying",
    "닂" => "nyij", "닃" => "nyic", "닄" => "nyik", "닅" => "nyit", "닆" => "nyip", "닇" => "nyih",
    "니" => "ni", "닉" => "nig", "닊" => "nigg", "닋" => "nigs", "닌" => "nin", "닍" => "ninj",
    "닎" => "ninh", "닏" => "nid", "닐" => "nil", "닑" => "nilg", "닒" => "nilm", "닓" => "nilb",
    "닔" => "nils", "닕" => "nilt", "닖" => "nilp", "닗" => "nilh", "님" => "nim", "닙" => "nib",
    "닚" => "nibs", "닛" => "nis", "닜" => "niss", "닝" => "ning", "닞" => "nij", "닟" => "nic",
    "닠" => "nik", "닡" => "nit", "닢" => "nip", "닣" => "nih", "다" => "da", "닥" => "dag",
    "닦" => "dagg", "닧" => "dags", "단" => "dan", "닩" => "danj", "닪" => "danh", "닫" => "dad",
    "달" => "dal", "닭" => "dalg", "닮" => "dalm", "닯" => "dalb", "닰" => "dals", "닱" => "dalt",
    "닲" => "dalp", "닳" => "dalh", "담" => "dam", "답" => "dab", "닶" => "dabs", "닷" => "das",
    "닸" => "dass", "당" => "dang", "닺" => "daj", "닻" => "dac", "닼" => "dak", "닽" => "dat",
    "닾" => "dap", "닿" => "dah", "댁" => "daeg", "댂" => "daegg", "댃" => "daegs", "댄" => "daen",
    "댅" => "daenj", "댆" => "daenh", "댇" => "daed", "댈" => "dael", "댉" => "daelg", "댊" => "daelm",
    "댋" => "daelb", "댌" => "daels", "댍" => "daelt", "댎" => "daelp", "댏" => "daelh", "댐" => "daem",
    "댑" => "daeb", "댒" => "daebs", "댓" => "daes", "댔" => "daess", "댕" => "daeng", "댖" => "daej",
    "댗" => "daec", "댘" => "daek", "댙" => "daet", "댚" => "daep", "댛" => "daeh", "댜" => "dya",
    "댝" => "dyag", "댞" => "dyagg", "댟" => "dyags", "댠" => "dyan", "댡" => "dyanj", "댢" => "dyanh",
    "댣" => "dyad", "댤" => "dyal", "댥" => "dyalg", "댦" => "dyalm", "댧" => "dyalb", "댨" => "dyals",
    "댩" => "dyalt", "댪" => "dyalp", "댫" => "dyalh", "댬" => "dyam", "댭" => "dyab", "댮" => "dyabs",
    "댯" => "dyas", "댰" => "dyass", "댱" => "dyang", "댲" => "dyaj", "댳" => "dyac", "댴" => "dyak",
    "댵" => "dyat", "댶" => "dyap", "댷" => "dyah", "댸" => "dyae", "댹" => "dyaeg", "댺" => "dyaegg",
    "댻" => "dyaegs", "댼" => "dyaen", "댽" => "dyaenj", "댾" => "dyaenh", "댿" => "dyaed", "덀" => "dyael",
    "덁" => "dyaelg", "덂" => "dyaelm", "덃" => "dyaelb", "덄" => "dyaels", "덅" => "dyaelt", "덆" => "dyaelp",
    "덇" => "dyaelh", "덈" => "dyaem", "덉" => "dyaeb", "덊" => "dyaebs", "덋" => "dyaes", "덌" => "dyaess",
    "덍" => "dyaeng", "덎" => "dyaej", "덏" => "dyaec", "덐" => "dyaek", "덑" => "dyaet", "덒" => "dyaep",
    "덓" => "dyaeh", "더" => "deo", "덕" => "deog", "덖" => "deogg", "덗" => "deogs", "던" => "deon",
    "덙" => "deonj", "덚" => "deonh", "덛" => "deod", "덜" => "deol", "덝" => "deolg", "덞" => "deolm",
    "덟" => "deolb", "덠" => "deols", "덡" => "deolt", "덢" => "deolp", "덣" => "deolh", "덤" => "deom",
    "덥" => "deob", "덦" => "deobs", "덧" => "deos", "덨" => "deoss", "덩" => "deong", "덪" => "deoj",
    "덫" => "deoc", "덬" => "deok", "덭" => "deot", "덮" => "deop", "덯" => "deoh", "데" => "de",
    "덱" => "deg", "덲" => "degg", "덳" => "degs", "덴" => "den", "덵" => "denj", "덶" => "denh",
    "덷" => "ded", "델" => "del", "덹" => "delg", "덺" => "delm", "덻" => "delb", "덼" => "dels",
    "덽" => "delt", "덾" => "delp", "덿" => "delh", "뎀" => "dem", "뎁" => "deb", "뎂" => "debs",
    "뎃" => "des", "뎄" => "dess", "뎅" => "deng", "뎆" => "dej", "뎇" => "dec", "뎈" => "dek",
    "뎉" => "det", "뎊" => "dep", "뎋" => "deh", "뎌" => "dyeo", "뎍" => "dyeog", "뎎" => "dyeogg",
    "뎏" => "dyeogs", "뎐" => "dyeon", "뎑" => "dyeonj", "뎒" => "dyeonh", "뎓" => "dyeod", "뎔" => "dyeol",
    "뎕" => "dyeolg", "뎖" => "dyeolm", "뎗" => "dyeolb", "뎘" => "dyeols", "뎙" => "dyeolt", "뎚" => "dyeolp",
    "뎛" => "dyeolh", "뎜" => "dyeom", "뎝" => "dyeob", "뎞" => "dyeobs", "뎟" => "dyeos", "뎠" => "dyeoss",
    "뎡" => "dyeong", "뎢" => "dyeoj", "뎣" => "dyeoc", "뎤" => "dyeok", "뎥" => "dyeot", "뎦" => "dyeop",
    "뎧" => "dyeoh", "뎨" => "dye", "뎩" => "dyeg", "뎪" => "dyegg", "뎫" => "dyegs", "뎬" => "dyen",
    "뎭" => "dyenj", "뎮" => "dyenh", "뎯" => "dyed", "뎰" => "dyel", "뎱" => "dyelg", "뎲" => "dyelm",
    "뎳" => "dyelb", "뎴" => "dyels", "뎵" => "dyelt", "뎶" => "dyelp", "뎷" => "dyelh", "뎸" => "dyem",
    "뎹" => "dyeb", "뎺" => "dyebs", "뎻" => "dyes", "뎼" => "dyess", "뎽" => "dyeng", "뎾" => "dyej",
    "뎿" => "dyec", "돀" => "dyek", "돁" => "dyet", "돂" => "dyep", "돃" => "dyeh", "도" => "do",
    "독" => "dog", "돆" => "dogg", "돇" => "dogs", "돈" => "don", "돉" => "donj", "돊" => "donh",
    "돋" => "dod", "돌" => "dol", "돍" => "dolg", "돎" => "dolm", "돏" => "dolb", "돐" => "dols",
    "돑" => "dolt", "돒" => "dolp", "돓" => "dolh", "돔" => "dom", "돕" => "dob", "돖" => "dobs",
    "돗" => "dos", "돘" => "doss", "동" => "dong", "돚" => "doj", "돛" => "doc", "돜" => "dok",
    "돝" => "dot", "돞" => "dop", "돟" => "doh", "돠" => "dwa", "돡" => "dwag", "돢" => "dwagg",
    "돣" => "dwags", "돤" => "dwan", "돥" => "dwanj", "돦" => "dwanh", "돧" => "dwad", "돨" => "dwal",
    "돩" => "dwalg", "돪" => "dwalm", "돫" => "dwalb", "돬" => "dwals", "돭" => "dwalt", "돮" => "dwalp",
    "돯" => "dwalh", "돰" => "dwam", "돱" => "dwab", "돲" => "dwabs", "돳" => "dwas", "돴" => "dwass",
    "돵" => "dwang", "돶" => "dwaj", "돷" => "dwac", "돸" => "dwak", "돹" => "dwat", "돺" => "dwap",
    "돻" => "dwah", "돼" => "dwae", "돽" => "dwaeg", "돾" => "dwaegg", "돿" => "dwaegs", "됁" => "dwaenj",
    "됂" => "dwaenh", "됃" => "dwaed", "됄" => "dwael", "됅" => "dwaelg", "됆" => "dwaelm", "됇" => "dwaelb",
    "됈" => "dwaels", "됉" => "dwaelt", "됊" => "dwaelp", "됋" => "dwaelh", "됌" => "dwaem", "됍" => "dwaeb",
    "됎" => "dwaebs", "됏" => "dwaes", "됐" => "dwaess", "됑" => "dwaeng", "됒" => "dwaej", "됓" => "dwaec",
    "됔" => "dwaek", "됕" => "dwaet", "됖" => "dwaep", "됗" => "dwaeh", "되" => "doe", "됙" => "doeg",
    "됚" => "doegg", "됛" => "doegs", "된" => "doen", "됝" => "doenj", "됞" => "doenh", "됟" => "doed",
    "될" => "doel", "됡" => "doelg", "됢" => "doelm", "됣" => "doelb", "됤" => "doels", "됥" => "doelt",
    "됦" => "doelp", "됧" => "doelh", "됨" => "doem", "됩" => "doeb", "됪" => "doebs", "됫" => "does",
    "됬" => "doess", "됭" => "doeng", "됮" => "doej", "됯" => "doec", "됰" => "doek", "됱" => "doet",
    "됲" => "doep", "됳" => "doeh", "됴" => "dyo", "됵" => "dyog", "됶" => "dyogg", "됷" => "dyogs",
    "됸" => "dyon", "됹" => "dyonj", "됺" => "dyonh", "됻" => "dyod", "됼" => "dyol", "됽" => "dyolg",
    "됾" => "dyolm", "됿" => "dyolb", "둀" => "dyols", "둁" => "dyolt", "둂" => "dyolp", "둃" => "dyolh",
    "둄" => "dyom", "둅" => "dyob", "둆" => "dyobs", "둇" => "dyos", "둈" => "dyoss", "둉" => "dyong",
    "둊" => "dyoj", "둋" => "dyoc", "둌" => "dyok", "둍" => "dyot", "둎" => "dyop", "둏" => "dyoh",
    "두" => "du", "둑" => "dug", "둒" => "dugg", "둓" => "dugs", "둔" => "dun", "둕" => "dunj",
    "둖" => "dunh", "둗" => "dud", "둘" => "dul", "둙" => "dulg", "둚" => "dulm", "둛" => "dulb",
    "둜" => "duls", "둝" => "dult", "둞" => "dulp", "둟" => "dulh", "둠" => "dum", "둡" => "dub",
    "둢" => "dubs", "둣" => "dus", "둤" => "duss", "둥" => "dung", "둦" => "duj", "둧" => "duc",
    "둨" => "duk", "둩" => "dut", "둪" => "dup", "둫" => "duh", "둬" => "dweo", "둭" => "dweog",
    "둮" => "dweogg", "둯" => "dweogs", "둰" => "dweon", "둱" => "dweonj", "둲" => "dweonh", "둳" => "dweod",
    "둴" => "dweol", "둵" => "dweolg", "둶" => "dweolm", "둷" => "dweolb", "둸" => "dweols", "둹" => "dweolt",
    "둺" => "dweolp", "둻" => "dweolh", "둼" => "dweom", "둽" => "dweob", "둾" => "dweobs", "둿" => "dweos",
    "뒀" => "dweoss", "뒁" => "dweong", "뒂" => "dweoj", "뒃" => "dweoc", "뒄" => "dweok", "뒅" => "dweot",
    "뒆" => "dweop", "뒇" => "dweoh", "뒈" => "dwe", "뒉" => "dweg", "뒊" => "dwegg", "뒋" => "dwegs",
    "뒌" => "dwen", "뒍" => "dwenj", "뒎" => "dwenh", "뒏" => "dwed", "뒐" => "dwel", "뒑" => "dwelg",
    "뒒" => "dwelm", "뒓" => "dwelb", "뒔" => "dwels", "뒕" => "dwelt", "뒖" => "dwelp", "뒗" => "dwelh",
    "뒘" => "dwem", "뒙" => "dweb", "뒚" => "dwebs", "뒛" => "dwes", "뒜" => "dwess", "뒝" => "dweng",
    "뒞" => "dwej", "뒟" => "dwec", "뒠" => "dwek", "뒡" => "dwet", "뒢" => "dwep", "뒣" => "dweh",
    "뒤" => "dwi", "뒥" => "dwig", "뒦" => "dwigg", "뒧" => "dwigs", "뒨" => "dwin", "뒩" => "dwinj",
    "뒪" => "dwinh", "뒫" => "dwid", "뒬" => "dwil", "뒭" => "dwilg", "뒮" => "dwilm", "뒯" => "dwilb",
    "뒰" => "dwils", "뒱" => "dwilt", "뒲" => "dwilp", "뒳" => "dwilh", "뒴" => "dwim", "뒵" => "dwib",
    "뒶" => "dwibs", "뒷" => "dwis", "뒸" => "dwiss", "뒹" => "dwing", "뒺" => "dwij", "뒻" => "dwic",
    "뒼" => "dwik", "뒽" => "dwit", "뒾" => "dwip", "뒿" => "dwih", "듀" => "dyu", "듁" => "dyug",
    "듂" => "dyugg", "듃" => "dyugs", "듄" => "dyun", "듅" => "dyunj", "듆" => "dyunh", "듇" => "dyud",
    "듈" => "dyul", "듉" => "dyulg", "듊" => "dyulm", "듋" => "dyulb", "듌" => "dyuls", "듍" => "dyult",
    "듎" => "dyulp", "듏" => "dyulh", "듐" => "dyum", "듑" => "dyub", "듒" => "dyubs", "듓" => "dyus",
    "듔" => "dyuss", "듕" => "dyung", "듖" => "dyuj", "듗" => "dyuc", "듘" => "dyuk", "듙" => "dyut",
    "듚" => "dyup", "듛" => "dyuh", "드" => "deu", "득" => "deug", "듞" => "deugg", "듟" => "deugs",
    "든" => "deun", "듡" => "deunj", "듢" => "deunh", "듣" => "deud", "들" => "deul", "듥" => "deulg",
    "듦" => "deulm", "듧" => "deulb", "듨" => "deuls", "듩" => "deult", "듪" => "deulp", "듫" => "deulh",
    "듬" => "deum", "듭" => "deub", "듮" => "deubs", "듯" => "deus", "듰" => "deuss", "등" => "deung",
    "듲" => "deuj", "듳" => "deuc", "듴" => "deuk", "듵" => "deut", "듶" => "deup", "듷" => "deuh",
    "듸" => "dyi", "듹" => "dyig", "듺" => "dyigg", "듻" => "dyigs", "듼" => "dyin", "듽" => "dyinj",
    "듾" => "dyinh", "듿" => "dyid", "딁" => "dyilg", "딂" => "dyilm", "딃" => "dyilb", "딄" => "dyils",
    "딅" => "dyilt", "딆" => "dyilp", "딇" => "dyilh", "딈" => "dyim", "딉" => "dyib", "딊" => "dyibs",
    "딋" => "dyis", "딌" => "dyiss", "딍" => "dying", "딎" => "dyij", "딏" => "dyic", "딐" => "dyik",
    "딑" => "dyit", "딒" => "dyip", "딓" => "dyih", "디" => "di", "딕" => "dig", "딖" => "digg",
    "딗" => "digs", "딘" => "din", "딙" => "dinj", "딚" => "dinh", "딛" => "did", "딜" => "dil",
    "딝" => "dilg", "딞" => "dilm", "딟" => "dilb", "딠" => "dils", "딡" => "dilt", "딢" => "dilp",
    "딣" => "dilh", "딤" => "dim", "딥" => "dib", "딦" => "dibs", "딧" => "dis", "딨" => "diss",
    "딩" => "ding", "딪" => "dij", "딫" => "dic", "딬" => "dik", "딭" => "dit", "딮" => "dip",
    "딯" => "dih", "따" => "dda", "딱" => "ddag", "딲" => "ddagg", "딳" => "ddags", "딴" => "ddan",
    "딵" => "ddanj", "딶" => "ddanh", "딷" => "ddad", "딸" => "ddal", "딹" => "ddalg", "딺" => "ddalm",
    "딻" => "ddalb", "딼" => "ddals", "딽" => "ddalt", "딾" => "ddalp", "딿" => "ddalh", "땀" => "ddam",
    "땁" => "ddab", "땂" => "ddabs", "땃" => "ddas", "땄" => "ddass", "땅" => "ddang", "땆" => "ddaj",
    "땇" => "ddac", "땈" => "ddak", "땉" => "ddat", "땊" => "ddap", "땋" => "ddah", "때" => "ddae",
    "땍" => "ddaeg", "땎" => "ddaegg", "땏" => "ddaegs", "땐" => "ddaen", "땑" => "ddaenj", "땒" => "ddaenh",
    "땓" => "ddaed", "땔" => "ddael", "땕" => "ddaelg", "땖" => "ddaelm", "땗" => "ddaelb", "땘" => "ddaels",
    "땙" => "ddaelt", "땚" => "ddaelp", "땛" => "ddaelh", "땜" => "ddaem", "땝" => "ddaeb", "땞" => "ddaebs",
    "땟" => "ddaes", "땠" => "ddaess", "땡" => "ddaeng", "땢" => "ddaej", "땣" => "ddaec", "땤" => "ddaek",
    "땥" => "ddaet", "땦" => "ddaep", "땧" => "ddaeh", "땨" => "ddya", "땩" => "ddyag", "땪" => "ddyagg",
    "땫" => "ddyags", "땬" => "ddyan", "땭" => "ddyanj", "땮" => "ddyanh", "땯" => "ddyad", "땰" => "ddyal",
    "땱" => "ddyalg", "땲" => "ddyalm", "땳" => "ddyalb", "땴" => "ddyals", "땵" => "ddyalt", "땶" => "ddyalp",
    "땷" => "ddyalh", "땸" => "ddyam", "땹" => "ddyab", "땺" => "ddyabs", "땻" => "ddyas", "땼" => "ddyass",
    "땽" => "ddyang", "땾" => "ddyaj", "땿" => "ddyac", "떀" => "ddyak", "떁" => "ddyat", "떂" => "ddyap",
    "떃" => "ddyah", "떄" => "ddyae", "떅" => "ddyaeg", "떆" => "ddyaegg", "떇" => "ddyaegs", "떈" => "ddyaen",
    "떉" => "ddyaenj", "떊" => "ddyaenh", "떋" => "ddyaed", "떌" => "ddyael", "떍" => "ddyaelg", "떎" => "ddyaelm",
    "떏" => "ddyaelb", "떐" => "ddyaels", "떑" => "ddyaelt", "떒" => "ddyaelp", "떓" => "ddyaelh", "떔" => "ddyaem",
    "떕" => "ddyaeb", "떖" => "ddyaebs", "떗" => "ddyaes", "떘" => "ddyaess", "떙" => "ddyaeng", "떚" => "ddyaej",
    "떛" => "ddyaec", "떜" => "ddyaek", "떝" => "ddyaet", "떞" => "ddyaep", "떟" => "ddyaeh", "떠" => "ddeo",
    "떡" => "ddeog", "떢" => "ddeogg", "떣" => "ddeogs", "떤" => "ddeon", "떥" => "ddeonj", "떦" => "ddeonh",
    "떧" => "ddeod", "떨" => "ddeol", "떩" => "ddeolg", "떪" => "ddeolm", "떫" => "ddeolb", "떬" => "ddeols",
    "떭" => "ddeolt", "떮" => "ddeolp", "떯" => "ddeolh", "떰" => "ddeom", "떱" => "ddeob", "떲" => "ddeobs",
    "떳" => "ddeos", "떴" => "ddeoss", "떵" => "ddeong", "떶" => "ddeoj", "떷" => "ddeoc", "떸" => "ddeok",
    "떹" => "ddeot", "떺" => "ddeop", "떻" => "ddeoh", "떼" => "dde", "떽" => "ddeg", "떾" => "ddegg",
    "떿" => "ddegs", "뗀" => "dden", "뗁" => "ddenj", "뗂" => "ddenh", "뗃" => "dded", "뗄" => "ddel",
    "뗅" => "ddelg", "뗆" => "ddelm", "뗇" => "ddelb", "뗈" => "ddels", "뗉" => "ddelt", "뗊" => "ddelp",
    "뗋" => "ddelh", "뗌" => "ddem", "뗍" => "ddeb", "뗎" => "ddebs", "뗏" => "ddes", "뗐" => "ddess",
    "뗑" => "ddeng", "뗒" => "ddej", "뗓" => "ddec", "뗔" => "ddek", "뗕" => "ddet", "뗖" => "ddep",
    "뗗" => "ddeh", "뗘" => "ddyeo", "뗙" => "ddyeog", "뗚" => "ddyeogg", "뗛" => "ddyeogs", "뗜" => "ddyeon",
    "뗝" => "ddyeonj", "뗞" => "ddyeonh", "뗟" => "ddyeod", "뗠" => "ddyeol", "뗡" => "ddyeolg", "뗢" => "ddyeolm",
    "뗣" => "ddyeolb", "뗤" => "ddyeols", "뗥" => "ddyeolt", "뗦" => "ddyeolp", "뗧" => "ddyeolh", "뗨" => "ddyeom",
    "뗩" => "ddyeob", "뗪" => "ddyeobs", "뗫" => "ddyeos", "뗬" => "ddyeoss", "뗭" => "ddyeong", "뗮" => "ddyeoj",
    "뗯" => "ddyeoc", "뗰" => "ddyeok", "뗱" => "ddyeot", "뗲" => "ddyeop", "뗳" => "ddyeoh", "뗴" => "ddye",
    "뗵" => "ddyeg", "뗶" => "ddyegg", "뗷" => "ddyegs", "뗸" => "ddyen", "뗹" => "ddyenj", "뗺" => "ddyenh",
    "뗻" => "ddyed", "뗼" => "ddyel", "뗽" => "ddyelg", "뗾" => "ddyelm", "뗿" => "ddyelb", "똁" => "ddyelt",
    "똂" => "ddyelp", "똃" => "ddyelh", "똄" => "ddyem", "똅" => "ddyeb", "똆" => "ddyebs", "똇" => "ddyes",
    "똈" => "ddyess", "똉" => "ddyeng", "똊" => "ddyej", "똋" => "ddyec", "똌" => "ddyek", "똍" => "ddyet",
    "똎" => "ddyep", "똏" => "ddyeh", "또" => "ddo", "똑" => "ddog", "똒" => "ddogg", "똓" => "ddogs",
    "똔" => "ddon", "똕" => "ddonj", "똖" => "ddonh", "똗" => "ddod", "똘" => "ddol", "똙" => "ddolg",
    "똚" => "ddolm", "똛" => "ddolb", "똜" => "ddols", "똝" => "ddolt", "똞" => "ddolp", "똟" => "ddolh",
    "똠" => "ddom", "똡" => "ddob", "똢" => "ddobs", "똣" => "ddos", "똤" => "ddoss", "똥" => "ddong",
    "똦" => "ddoj", "똧" => "ddoc", "똨" => "ddok", "똩" => "ddot", "똪" => "ddop", "똫" => "ddoh",
    "똬" => "ddwa", "똭" => "ddwag", "똮" => "ddwagg", "똯" => "ddwags", "똰" => "ddwan", "똱" => "ddwanj",
    "똲" => "ddwanh", "똳" => "ddwad", "똴" => "ddwal", "똵" => "ddwalg", "똶" => "ddwalm", "똷" => "ddwalb",
    "똸" => "ddwals", "똹" => "ddwalt", "똺" => "ddwalp", "똻" => "ddwalh", "똼" => "ddwam", "똽" => "ddwab",
    "똾" => "ddwabs", "똿" => "ddwas", "뙀" => "ddwass", "뙁" => "ddwang", "뙂" => "ddwaj", "뙃" => "ddwac",
    "뙄" => "ddwak", "뙅" => "ddwat", "뙆" => "ddwap", "뙇" => "ddwah", "뙈" => "ddwae", "뙉" => "ddwaeg",
    "뙊" => "ddwaegg", "뙋" => "ddwaegs", "뙌" => "ddwaen", "뙍" => "ddwaenj", "뙎" => "ddwaenh", "뙏" => "ddwaed",
    "뙐" => "ddwael", "뙑" => "ddwaelg", "뙒" => "ddwaelm", "뙓" => "ddwaelb", "뙔" => "ddwaels", "뙕" => "ddwaelt",
    "뙖" => "ddwaelp", "뙗" => "ddwaelh", "뙘" => "ddwaem", "뙙" => "ddwaeb", "뙚" => "ddwaebs", "뙛" => "ddwaes",
    "뙜" => "ddwaess", "뙝" => "ddwaeng", "뙞" => "ddwaej", "뙟" => "ddwaec", "뙠" => "ddwaek", "뙡" => "ddwaet",
    "뙢" => "ddwaep", "뙣" => "ddwaeh", "뙤" => "ddoe", "뙥" => "ddoeg", "뙦" => "ddoegg", "뙧" => "ddoegs",
    "뙨" => "ddoen", "뙩" => "ddoenj", "뙪" => "ddoenh", "뙫" => "ddoed", "뙬" => "ddoel", "뙭" => "ddoelg",
    "뙮" => "ddoelm", "뙯" => "ddoelb", "뙰" => "ddoels", "뙱" => "ddoelt", "뙲" => "ddoelp", "뙳" => "ddoelh",
    "뙴" => "ddoem", "뙵" => "ddoeb", "뙶" => "ddoebs", "뙷" => "ddoes", "뙸" => "ddoess", "뙹" => "ddoeng",
    "뙺" => "ddoej", "뙻" => "ddoec", "뙼" => "ddoek", "뙽" => "ddoet", "뙾" => "ddoep", "뙿" => "ddoeh",
    "뚀" => "ddyo", "뚁" => "ddyog", "뚂" => "ddyogg", "뚃" => "ddyogs", "뚄" => "ddyon", "뚅" => "ddyonj",
    "뚆" => "ddyonh", "뚇" => "ddyod", "뚈" => "ddyol", "뚉" => "ddyolg", "뚊" => "ddyolm", "뚋" => "ddyolb",
    "뚌" => "ddyols", "뚍" => "ddyolt", "뚎" => "ddyolp", "뚏" => "ddyolh", "뚐" => "ddyom", "뚑" => "ddyob",
    "뚒" => "ddyobs", "뚓" => "ddyos", "뚔" => "ddyoss", "뚕" => "ddyong", "뚖" => "ddyoj", "뚗" => "ddyoc",
    "뚘" => "ddyok", "뚙" => "ddyot", "뚚" => "ddyop", "뚛" => "ddyoh", "뚜" => "ddu", "뚝" => "ddug",
    "뚞" => "ddugg", "뚟" => "ddugs", "뚠" => "ddun", "뚡" => "ddunj", "뚢" => "ddunh", "뚣" => "ddud",
    "뚤" => "ddul", "뚥" => "ddulg", "뚦" => "ddulm", "뚧" => "ddulb", "뚨" => "dduls", "뚩" => "ddult",
    "뚪" => "ddulp", "뚫" => "ddulh", "뚬" => "ddum", "뚭" => "ddub", "뚮" => "ddubs", "뚯" => "ddus",
    "뚰" => "dduss", "뚱" => "ddung", "뚲" => "dduj", "뚳" => "dduc", "뚴" => "dduk", "뚵" => "ddut",
    "뚶" => "ddup", "뚷" => "dduh", "뚸" => "ddweo", "뚹" => "ddweog", "뚺" => "ddweogg", "뚻" => "ddweogs",
    "뚼" => "ddweon", "뚽" => "ddweonj", "뚾" => "ddweonh", "뚿" => "ddweod", "뛀" => "ddweol", "뛁" => "ddweolg",
    "뛂" => "ddweolm", "뛃" => "ddweolb", "뛄" => "ddweols", "뛅" => "ddweolt", "뛆" => "ddweolp", "뛇" => "ddweolh",
    "뛈" => "ddweom", "뛉" => "ddweob", "뛊" => "ddweobs", "뛋" => "ddweos", "뛌" => "ddweoss", "뛍" => "ddweong",
    "뛎" => "ddweoj", "뛏" => "ddweoc", "뛐" => "ddweok", "뛑" => "ddweot", "뛒" => "ddweop", "뛓" => "ddweoh",
    "뛔" => "ddwe", "뛕" => "ddweg", "뛖" => "ddwegg", "뛗" => "ddwegs", "뛘" => "ddwen", "뛙" => "ddwenj",
    "뛚" => "ddwenh", "뛛" => "ddwed", "뛜" => "ddwel", "뛝" => "ddwelg", "뛞" => "ddwelm", "뛟" => "ddwelb",
    "뛠" => "ddwels", "뛡" => "ddwelt", "뛢" => "ddwelp", "뛣" => "ddwelh", "뛤" => "ddwem", "뛥" => "ddweb",
    "뛦" => "ddwebs", "뛧" => "ddwes", "뛨" => "ddwess", "뛩" => "ddweng", "뛪" => "ddwej", "뛫" => "ddwec",
    "뛬" => "ddwek", "뛭" => "ddwet", "뛮" => "ddwep", "뛯" => "ddweh", "뛰" => "ddwi", "뛱" => "ddwig",
    "뛲" => "ddwigg", "뛳" => "ddwigs", "뛴" => "ddwin", "뛵" => "ddwinj", "뛶" => "ddwinh", "뛷" => "ddwid",
    "뛸" => "ddwil", "뛹" => "ddwilg", "뛺" => "ddwilm", "뛻" => "ddwilb", "뛼" => "ddwils", "뛽" => "ddwilt",
    "뛾" => "ddwilp", "뛿" => "ddwilh", "뜁" => "ddwib", "뜂" => "ddwibs", "뜃" => "ddwis", "뜄" => "ddwiss",
    "뜅" => "ddwing", "뜆" => "ddwij", "뜇" => "ddwic", "뜈" => "ddwik", "뜉" => "ddwit", "뜊" => "ddwip",
    "뜋" => "ddwih", "뜌" => "ddyu", "뜍" => "ddyug", "뜎" => "ddyugg", "뜏" => "ddyugs", "뜐" => "ddyun",
    "뜑" => "ddyunj", "뜒" => "ddyunh", "뜓" => "ddyud", "뜔" => "ddyul", "뜕" => "ddyulg", "뜖" => "ddyulm",
    "뜗" => "ddyulb", "뜘" => "ddyuls", "뜙" => "ddyult", "뜚" => "ddyulp", "뜛" => "ddyulh", "뜜" => "ddyum",
    "뜝" => "ddyub", "뜞" => "ddyubs", "뜟" => "ddyus", "뜠" => "ddyuss", "뜡" => "ddyung", "뜢" => "ddyuj",
    "뜣" => "ddyuc", "뜤" => "ddyuk", "뜥" => "ddyut", "뜦" => "ddyup", "뜧" => "ddyuh", "뜨" => "ddeu",
    "뜩" => "ddeug", "뜪" => "ddeugg", "뜫" => "ddeugs", "뜬" => "ddeun", "뜭" => "ddeunj", "뜮" => "ddeunh",
    "뜯" => "ddeud", "뜰" => "ddeul", "뜱" => "ddeulg", "뜲" => "ddeulm", "뜳" => "ddeulb", "뜴" => "ddeuls",
    "뜵" => "ddeult", "뜶" => "ddeulp", "뜷" => "ddeulh", "뜸" => "ddeum", "뜹" => "ddeub", "뜺" => "ddeubs",
    "뜻" => "ddeus", "뜼" => "ddeuss", "뜽" => "ddeung", "뜾" => "ddeuj", "뜿" => "ddeuc", "띀" => "ddeuk",
    "띁" => "ddeut", "띂" => "ddeup", "띃" => "ddeuh", "띄" => "ddyi", "띅" => "ddyig", "띆" => "ddyigg",
    "띇" => "ddyigs", "띈" => "ddyin", "띉" => "ddyinj", "띊" => "ddyinh", "띋" => "ddyid", "띌" => "ddyil",
    "띍" => "ddyilg", "띎" => "ddyilm", "띏" => "ddyilb", "띐" => "ddyils", "띑" => "ddyilt", "띒" => "ddyilp",
    "띓" => "ddyilh", "띔" => "ddyim", "띕" => "ddyib", "띖" => "ddyibs", "띗" => "ddyis", "띘" => "ddyiss",
    "띙" => "ddying", "띚" => "ddyij", "띛" => "ddyic", "띜" => "ddyik", "띝" => "ddyit", "띞" => "ddyip",
    "띟" => "ddyih", "띠" => "ddi", "띡" => "ddig", "띢" => "ddigg", "띣" => "ddigs", "띤" => "ddin",
    "띥" => "ddinj", "띦" => "ddinh", "띧" => "ddid", "띨" => "ddil", "띩" => "ddilg", "띪" => "ddilm",
    "띫" => "ddilb", "띬" => "ddils", "띭" => "ddilt", "띮" => "ddilp", "띯" => "ddilh", "띰" => "ddim",
    "띱" => "ddib", "띲" => "ddibs", "띳" => "ddis", "띴" => "ddiss", "띵" => "dding", "띶" => "ddij",
    "띷" => "ddic", "띸" => "ddik", "띹" => "ddit", "띺" => "ddip", "띻" => "ddih", "라" => "ra",
    "락" => "rag", "띾" => "ragg", "띿" => "rags", "란" => "ran", "랁" => "ranj", "랂" => "ranh",
    "랃" => "rad", "랄" => "ral", "랅" => "ralg", "랆" => "ralm", "랇" => "ralb", "랈" => "rals",
    "랉" => "ralt", "랊" => "ralp", "랋" => "ralh", "람" => "ram", "랍" => "rab", "랎" => "rabs",
    "랏" => "ras", "랐" => "rass", "랑" => "rang", "랒" => "raj", "랓" => "rac", "랔" => "rak",
    "랕" => "rat", "랖" => "rap", "랗" => "rah", "래" => "rae", "랙" => "raeg", "랚" => "raegg",
    "랛" => "raegs", "랜" => "raen", "랝" => "raenj", "랞" => "raenh", "랟" => "raed", "랠" => "rael",
    "랡" => "raelg", "랢" => "raelm", "랣" => "raelb", "랤" => "raels", "랥" => "raelt", "랦" => "raelp",
    "랧" => "raelh", "램" => "raem", "랩" => "raeb", "랪" => "raebs", "랫" => "raes", "랬" => "raess",
    "랭" => "raeng", "랮" => "raej", "랯" => "raec", "랰" => "raek", "랱" => "raet", "랲" => "raep",
    "랳" => "raeh", "랴" => "rya", "략" => "ryag", "랶" => "ryagg", "랷" => "ryags", "랸" => "ryan",
    "랹" => "ryanj", "랺" => "ryanh", "랻" => "ryad", "랼" => "ryal", "랽" => "ryalg", "랾" => "ryalm",
    "랿" => "ryalb", "럀" => "ryals", "럁" => "ryalt", "럂" => "ryalp", "럃" => "ryalh", "럄" => "ryam",
    "럅" => "ryab", "럆" => "ryabs", "럇" => "ryas", "럈" => "ryass", "량" => "ryang", "럊" => "ryaj",
    "럋" => "ryac", "럌" => "ryak", "럍" => "ryat", "럎" => "ryap", "럏" => "ryah", "럐" => "ryae",
    "럑" => "ryaeg", "럒" => "ryaegg", "럓" => "ryaegs", "럔" => "ryaen", "럕" => "ryaenj", "럖" => "ryaenh",
    "럗" => "ryaed", "럘" => "ryael", "럙" => "ryaelg", "럚" => "ryaelm", "럛" => "ryaelb", "럜" => "ryaels",
    "럝" => "ryaelt", "럞" => "ryaelp", "럟" => "ryaelh", "럠" => "ryaem", "럡" => "ryaeb", "럢" => "ryaebs",
    "럣" => "ryaes", "럤" => "ryaess", "럥" => "ryaeng", "럦" => "ryaej", "럧" => "ryaec", "럨" => "ryaek",
    "럩" => "ryaet", "럪" => "ryaep", "럫" => "ryaeh", "러" => "reo", "럭" => "reog", "럮" => "reogg",
    "럯" => "reogs", "런" => "reon", "럱" => "reonj", "럲" => "reonh", "럳" => "reod", "럴" => "reol",
    "럵" => "reolg", "럶" => "reolm", "럷" => "reolb", "럸" => "reols", "럹" => "reolt", "럺" => "reolp",
    "럻" => "reolh", "럼" => "reom", "럽" => "reob", "럾" => "reobs", "럿" => "reos", "렁" => "reong",
    "렂" => "reoj", "렃" => "reoc", "렄" => "reok", "렅" => "reot", "렆" => "reop", "렇" => "reoh",
    "레" => "re", "렉" => "reg", "렊" => "regg", "렋" => "regs", "렌" => "ren", "렍" => "renj",
    "렎" => "renh", "렏" => "red", "렐" => "rel", "렑" => "relg", "렒" => "relm", "렓" => "relb",
    "렔" => "rels", "렕" => "relt", "렖" => "relp", "렗" => "relh", "렘" => "rem", "렙" => "reb",
    "렚" => "rebs", "렛" => "res", "렜" => "ress", "렝" => "reng", "렞" => "rej", "렟" => "rec",
    "렠" => "rek", "렡" => "ret", "렢" => "rep", "렣" => "reh", "려" => "ryeo", "력" => "ryeog",
    "렦" => "ryeogg", "렧" => "ryeogs", "련" => "ryeon", "렩" => "ryeonj", "렪" => "ryeonh", "렫" => "ryeod",
    "렬" => "ryeol", "렭" => "ryeolg", "렮" => "ryeolm", "렯" => "ryeolb", "렰" => "ryeols", "렱" => "ryeolt",
    "렲" => "ryeolp", "렳" => "ryeolh", "렴" => "ryeom", "렵" => "ryeob", "렶" => "ryeobs", "렷" => "ryeos",
    "렸" => "ryeoss", "령" => "ryeong", "렺" => "ryeoj", "렻" => "ryeoc", "렼" => "ryeok", "렽" => "ryeot",
    "렾" => "ryeop", "렿" => "ryeoh", "례" => "rye", "롁" => "ryeg", "롂" => "ryegg", "롃" => "ryegs",
    "롄" => "ryen", "롅" => "ryenj", "롆" => "ryenh", "롇" => "ryed", "롈" => "ryel", "롉" => "ryelg",
    "롊" => "ryelm", "롋" => "ryelb", "롌" => "ryels", "롍" => "ryelt", "롎" => "ryelp", "롏" => "ryelh",
    "롐" => "ryem", "롑" => "ryeb", "롒" => "ryebs", "롓" => "ryes", "롔" => "ryess", "롕" => "ryeng",
    "롖" => "ryej", "롗" => "ryec", "롘" => "ryek", "롙" => "ryet", "롚" => "ryep", "롛" => "ryeh",
    "로" => "ro", "록" => "rog", "롞" => "rogg", "롟" => "rogs", "론" => "ron", "롡" => "ronj",
    "롢" => "ronh", "롣" => "rod", "롤" => "rol", "롥" => "rolg", "롦" => "rolm", "롧" => "rolb",
    "롨" => "rols", "롩" => "rolt", "롪" => "rolp", "롫" => "rolh", "롬" => "rom", "롭" => "rob",
    "롮" => "robs", "롯" => "ros", "롰" => "ross", "롱" => "rong", "롲" => "roj", "롳" => "roc",
    "롴" => "rok", "롵" => "rot", "롶" => "rop", "롷" => "roh", "롸" => "rwa", "롹" => "rwag",
    "롺" => "rwagg", "롻" => "rwags", "롼" => "rwan", "롽" => "rwanj", "롾" => "rwanh", "롿" => "rwad",
    "뢀" => "rwal", "뢁" => "rwalg", "뢂" => "rwalm", "뢃" => "rwalb", "뢄" => "rwals", "뢅" => "rwalt",
    "뢆" => "rwalp", "뢇" => "rwalh", "뢈" => "rwam", "뢉" => "rwab", "뢊" => "rwabs", "뢋" => "rwas",
    "뢌" => "rwass", "뢍" => "rwang", "뢎" => "rwaj", "뢏" => "rwac", "뢐" => "rwak", "뢑" => "rwat",
    "뢒" => "rwap", "뢓" => "rwah", "뢔" => "rwae", "뢕" => "rwaeg", "뢖" => "rwaegg", "뢗" => "rwaegs",
    "뢘" => "rwaen", "뢙" => "rwaenj", "뢚" => "rwaenh", "뢛" => "rwaed", "뢜" => "rwael", "뢝" => "rwaelg",
    "뢞" => "rwaelm", "뢟" => "rwaelb", "뢠" => "rwaels", "뢡" => "rwaelt", "뢢" => "rwaelp", "뢣" => "rwaelh",
    "뢤" => "rwaem", "뢥" => "rwaeb", "뢦" => "rwaebs", "뢧" => "rwaes", "뢨" => "rwaess", "뢩" => "rwaeng",
    "뢪" => "rwaej", "뢫" => "rwaec", "뢬" => "rwaek", "뢭" => "rwaet", "뢮" => "rwaep", "뢯" => "rwaeh",
    "뢰" => "roe", "뢱" => "roeg", "뢲" => "roegg", "뢳" => "roegs", "뢴" => "roen", "뢵" => "roenj",
    "뢶" => "roenh", "뢷" => "roed", "뢸" => "roel", "뢹" => "roelg", "뢺" => "roelm", "뢻" => "roelb",
    "뢼" => "roels", "뢽" => "roelt", "뢾" => "roelp", "뢿" => "roelh", "룀" => "roem", "룁" => "roeb",
    "룂" => "roebs", "룃" => "roes", "룄" => "roess", "룅" => "roeng", "룆" => "roej", "룇" => "roec",
    "룈" => "roek", "룉" => "roet", "룊" => "roep", "룋" => "roeh", "료" => "ryo", "룍" => "ryog",
    "룎" => "ryogg", "룏" => "ryogs", "룐" => "ryon", "룑" => "ryonj", "룒" => "ryonh", "룓" => "ryod",
    "룔" => "ryol", "룕" => "ryolg", "룖" => "ryolm", "룗" => "ryolb", "룘" => "ryols", "룙" => "ryolt",
    "룚" => "ryolp", "룛" => "ryolh", "룜" => "ryom", "룝" => "ryob", "룞" => "ryobs", "룟" => "ryos",
    "룠" => "ryoss", "룡" => "ryong", "룢" => "ryoj", "룣" => "ryoc", "룤" => "ryok", "룥" => "ryot",
    "룦" => "ryop", "룧" => "ryoh", "루" => "ru", "룩" => "rug", "룪" => "rugg", "룫" => "rugs",
    "룬" => "run", "룭" => "runj", "룮" => "runh", "룯" => "rud", "룰" => "rul", "룱" => "rulg",
    "룲" => "rulm", "룳" => "rulb", "룴" => "ruls", "룵" => "rult", "룶" => "rulp", "룷" => "rulh",
    "룸" => "rum", "룹" => "rub", "룺" => "rubs", "룻" => "rus", "룼" => "russ", "룽" => "rung",
    "룾" => "ruj", "룿" => "ruc", "뤁" => "rut", "뤂" => "rup", "뤃" => "ruh", "뤄" => "rweo",
    "뤅" => "rweog", "뤆" => "rweogg", "뤇" => "rweogs", "뤈" => "rweon", "뤉" => "rweonj", "뤊" => "rweonh",
    "뤋" => "rweod", "뤌" => "rweol", "뤍" => "rweolg", "뤎" => "rweolm", "뤏" => "rweolb", "뤐" => "rweols",
    "뤑" => "rweolt", "뤒" => "rweolp", "뤓" => "rweolh", "뤔" => "rweom", "뤕" => "rweob", "뤖" => "rweobs",
    "뤗" => "rweos", "뤘" => "rweoss", "뤙" => "rweong", "뤚" => "rweoj", "뤛" => "rweoc", "뤜" => "rweok",
    "뤝" => "rweot", "뤞" => "rweop", "뤟" => "rweoh", "뤠" => "rwe", "뤡" => "rweg", "뤢" => "rwegg",
    "뤣" => "rwegs", "뤤" => "rwen", "뤥" => "rwenj", "뤦" => "rwenh", "뤧" => "rwed", "뤨" => "rwel",
    "뤩" => "rwelg", "뤪" => "rwelm", "뤫" => "rwelb", "뤬" => "rwels", "뤭" => "rwelt", "뤮" => "rwelp",
    "뤯" => "rwelh", "뤰" => "rwem", "뤱" => "rweb", "뤲" => "rwebs", "뤳" => "rwes", "뤴" => "rwess",
    "뤵" => "rweng", "뤶" => "rwej", "뤷" => "rwec", "뤸" => "rwek", "뤹" => "rwet", "뤺" => "rwep",
    "뤻" => "rweh", "뤼" => "rwi", "뤽" => "rwig", "뤾" => "rwigg", "뤿" => "rwigs", "륀" => "rwin",
    "륁" => "rwinj", "륂" => "rwinh", "륃" => "rwid", "륄" => "rwil", "륅" => "rwilg", "륆" => "rwilm",
    "륇" => "rwilb", "륈" => "rwils", "륉" => "rwilt", "륊" => "rwilp", "륋" => "rwilh", "륌" => "rwim",
    "륍" => "rwib", "륎" => "rwibs", "륏" => "rwis", "륐" => "rwiss", "륑" => "rwing", "륒" => "rwij",
    "륓" => "rwic", "륔" => "rwik", "륕" => "rwit", "륖" => "rwip", "륗" => "rwih", "류" => "ryu",
    "륙" => "ryug", "륚" => "ryugg", "륛" => "ryugs", "륜" => "ryun", "륝" => "ryunj", "륞" => "ryunh",
    "륟" => "ryud", "률" => "ryul", "륡" => "ryulg", "륢" => "ryulm", "륣" => "ryulb", "륤" => "ryuls",
    "륥" => "ryult", "륦" => "ryulp", "륧" => "ryulh", "륨" => "ryum", "륩" => "ryub", "륪" => "ryubs",
    "륫" => "ryus", "륬" => "ryuss", "륭" => "ryung", "륮" => "ryuj", "륯" => "ryuc", "륰" => "ryuk",
    "륱" => "ryut", "륲" => "ryup", "륳" => "ryuh", "르" => "reu", "륵" => "reug", "륶" => "reugg",
    "륷" => "reugs", "른" => "reun", "륹" => "reunj", "륺" => "reunh", "륻" => "reud", "를" => "reul",
    "륽" => "reulg", "륾" => "reulm", "륿" => "reulb", "릀" => "reuls", "릁" => "reult", "릂" => "reulp",
    "릃" => "reulh", "름" => "reum", "릅" => "reub", "릆" => "reubs", "릇" => "reus", "릈" => "reuss",
    "릉" => "reung", "릊" => "reuj", "릋" => "reuc", "릌" => "reuk", "릍" => "reut", "릎" => "reup",
    "릏" => "reuh", "릐" => "ryi", "릑" => "ryig", "릒" => "ryigg", "릓" => "ryigs", "릔" => "ryin",
    "릕" => "ryinj", "릖" => "ryinh", "릗" => "ryid", "릘" => "ryil", "릙" => "ryilg", "릚" => "ryilm",
    "릛" => "ryilb", "릜" => "ryils", "릝" => "ryilt", "릞" => "ryilp", "릟" => "ryilh", "릠" => "ryim",
    "릡" => "ryib", "릢" => "ryibs", "릣" => "ryis", "릤" => "ryiss", "릥" => "rying", "릦" => "ryij",
    "릧" => "ryic", "릨" => "ryik", "릩" => "ryit", "릪" => "ryip", "릫" => "ryih", "리" => "ri",
    "릭" => "rig", "릮" => "rigg", "릯" => "rigs", "린" => "rin", "릱" => "rinj", "릲" => "rinh",
    "릳" => "rid", "릴" => "ril", "릵" => "rilg", "릶" => "rilm", "릷" => "rilb", "릸" => "rils",
    "릹" => "rilt", "릺" => "rilp", "릻" => "rilh", "림" => "rim", "립" => "rib", "릾" => "ribs",
    "릿" => "ris", "맀" => "riss", "링" => "ring", "맂" => "rij", "맃" => "ric", "맄" => "rik",
    "맅" => "rit", "맆" => "rip", "맇" => "rih", "마" => "ma", "막" => "mag", "맊" => "magg",
    "맋" => "mags", "만" => "man", "맍" => "manj", "많" => "manh", "맏" => "mad", "말" => "mal",
    "맑" => "malg", "맒" => "malm", "맓" => "malb", "맔" => "mals", "맕" => "malt", "맖" => "malp",
    "맗" => "malh", "맘" => "mam", "맙" => "mab", "맚" => "mabs", "맛" => "mas", "맜" => "mass",
    "망" => "mang", "맞" => "maj", "맟" => "mac", "맠" => "mak", "맡" => "mat", "맢" => "map",
    "맣" => "mah", "매" => "mae", "맥" => "maeg", "맦" => "maegg", "맧" => "maegs", "맨" => "maen",
    "맩" => "maenj", "맪" => "maenh", "맫" => "maed", "맬" => "mael", "맭" => "maelg", "맮" => "maelm",
    "맯" => "maelb", "맰" => "maels", "맱" => "maelt", "맲" => "maelp", "맳" => "maelh", "맴" => "maem",
    "맵" => "maeb", "맶" => "maebs", "맷" => "maes", "맸" => "maess", "맹" => "maeng", "맺" => "maej",
    "맻" => "maec", "맼" => "maek", "맽" => "maet", "맾" => "maep", "맿" => "maeh", "먁" => "myag",
    "먂" => "myagg", "먃" => "myags", "먄" => "myan", "먅" => "myanj", "먆" => "myanh", "먇" => "myad",
    "먈" => "myal", "먉" => "myalg", "먊" => "myalm", "먋" => "myalb", "먌" => "myals", "먍" => "myalt",
    "먎" => "myalp", "먏" => "myalh", "먐" => "myam", "먑" => "myab", "먒" => "myabs", "먓" => "myas",
    "먔" => "myass", "먕" => "myang", "먖" => "myaj", "먗" => "myac", "먘" => "myak", "먙" => "myat",
    "먚" => "myap", "먛" => "myah", "먜" => "myae", "먝" => "myaeg", "먞" => "myaegg", "먟" => "myaegs",
    "먠" => "myaen", "먡" => "myaenj", "먢" => "myaenh", "먣" => "myaed", "먤" => "myael", "먥" => "myaelg",
    "먦" => "myaelm", "먧" => "myaelb", "먨" => "myaels", "먩" => "myaelt", "먪" => "myaelp", "먫" => "myaelh",
    "먬" => "myaem", "먭" => "myaeb", "먮" => "myaebs", "먯" => "myaes", "먰" => "myaess", "먱" => "myaeng",
    "먲" => "myaej", "먳" => "myaec", "먴" => "myaek", "먵" => "myaet", "먶" => "myaep", "먷" => "myaeh",
    "머" => "meo", "먹" => "meog", "먺" => "meogg", "먻" => "meogs", "먼" => "meon", "먽" => "meonj",
    "먾" => "meonh", "먿" => "meod", "멀" => "meol", "멁" => "meolg", "멂" => "meolm", "멃" => "meolb",
    "멄" => "meols", "멅" => "meolt", "멆" => "meolp", "멇" => "meolh", "멈" => "meom", "멉" => "meob",
    "멊" => "meobs", "멋" => "meos", "멌" => "meoss", "멍" => "meong", "멎" => "meoj", "멏" => "meoc",
    "멐" => "meok", "멑" => "meot", "멒" => "meop", "멓" => "meoh", "메" => "me", "멕" => "meg",
    "멖" => "megg", "멗" => "megs", "멘" => "men", "멙" => "menj", "멚" => "menh", "멛" => "med",
    "멜" => "mel", "멝" => "melg", "멞" => "melm", "멟" => "melb", "멠" => "mels", "멡" => "melt",
    "멢" => "melp", "멣" => "melh", "멤" => "mem", "멥" => "meb", "멦" => "mebs", "멧" => "mes",
    "멨" => "mess", "멩" => "meng", "멪" => "mej", "멫" => "mec", "멬" => "mek", "멭" => "met",
    "멮" => "mep", "멯" => "meh", "며" => "myeo", "멱" => "myeog", "멲" => "myeogg", "멳" => "myeogs",
    "면" => "myeon", "멵" => "myeonj", "멶" => "myeonh", "멷" => "myeod", "멸" => "myeol", "멹" => "myeolg",
    "멺" => "myeolm", "멻" => "myeolb", "멼" => "myeols", "멽" => "myeolt", "멾" => "myeolp", "멿" => "myeolh",
    "몀" => "myeom", "몁" => "myeob", "몂" => "myeobs", "몃" => "myeos", "몄" => "myeoss", "명" => "myeong",
    "몆" => "myeoj", "몇" => "myeoc", "몈" => "myeok", "몉" => "myeot", "몊" => "myeop", "몋" => "myeoh",
    "몌" => "mye", "몍" => "myeg", "몎" => "myegg", "몏" => "myegs", "몐" => "myen", "몑" => "myenj",
    "몒" => "myenh", "몓" => "myed", "몔" => "myel", "몕" => "myelg", "몖" => "myelm", "몗" => "myelb",
    "몘" => "myels", "몙" => "myelt", "몚" => "myelp", "몛" => "myelh", "몜" => "myem", "몝" => "myeb",
    "몞" => "myebs", "몟" => "myes", "몠" => "myess", "몡" => "myeng", "몢" => "myej", "몣" => "myec",
    "몤" => "myek", "몥" => "myet", "몦" => "myep", "몧" => "myeh", "모" => "mo", "목" => "mog",
    "몪" => "mogg", "몫" => "mogs", "몬" => "mon", "몭" => "monj", "몮" => "monh", "몯" => "mod",
    "몰" => "mol", "몱" => "molg", "몲" => "molm", "몳" => "molb", "몴" => "mols", "몵" => "molt",
    "몶" => "molp", "몷" => "molh", "몸" => "mom", "몹" => "mob", "몺" => "mobs", "못" => "mos",
    "몼" => "moss", "몽" => "mong", "몾" => "moj", "몿" => "moc", "뫀" => "mok", "뫁" => "mot",
    "뫂" => "mop", "뫃" => "moh", "뫄" => "mwa", "뫅" => "mwag", "뫆" => "mwagg", "뫇" => "mwags",
    "뫈" => "mwan", "뫉" => "mwanj", "뫊" => "mwanh", "뫋" => "mwad", "뫌" => "mwal", "뫍" => "mwalg",
    "뫎" => "mwalm", "뫏" => "mwalb", "뫐" => "mwals", "뫑" => "mwalt", "뫒" => "mwalp", "뫓" => "mwalh",
    "뫔" => "mwam", "뫕" => "mwab", "뫖" => "mwabs", "뫗" => "mwas", "뫘" => "mwass", "뫙" => "mwang",
    "뫚" => "mwaj", "뫛" => "mwac", "뫜" => "mwak", "뫝" => "mwat", "뫞" => "mwap", "뫟" => "mwah",
    "뫠" => "mwae", "뫡" => "mwaeg", "뫢" => "mwaegg", "뫣" => "mwaegs", "뫤" => "mwaen", "뫥" => "mwaenj",
    "뫦" => "mwaenh", "뫧" => "mwaed", "뫨" => "mwael", "뫩" => "mwaelg", "뫪" => "mwaelm", "뫫" => "mwaelb",
    "뫬" => "mwaels", "뫭" => "mwaelt", "뫮" => "mwaelp", "뫯" => "mwaelh", "뫰" => "mwaem", "뫱" => "mwaeb",
    "뫲" => "mwaebs", "뫳" => "mwaes", "뫴" => "mwaess", "뫵" => "mwaeng", "뫶" => "mwaej", "뫷" => "mwaec",
    "뫸" => "mwaek", "뫹" => "mwaet", "뫺" => "mwaep", "뫻" => "mwaeh", "뫼" => "moe", "뫽" => "moeg",
    "뫾" => "moegg", "뫿" => "moegs", "묁" => "moenj", "묂" => "moenh", "묃" => "moed", "묄" => "moel",
    "묅" => "moelg", "묆" => "moelm", "묇" => "moelb", "묈" => "moels", "묉" => "moelt", "묊" => "moelp",
    "묋" => "moelh", "묌" => "moem", "묍" => "moeb", "묎" => "moebs", "묏" => "moes", "묐" => "moess",
    "묑" => "moeng", "묒" => "moej", "묓" => "moec", "묔" => "moek", "묕" => "moet", "묖" => "moep",
    "묗" => "moeh", "묘" => "myo", "묙" => "myog", "묚" => "myogg", "묛" => "myogs", "묜" => "myon",
    "묝" => "myonj", "묞" => "myonh", "묟" => "myod", "묠" => "myol", "묡" => "myolg", "묢" => "myolm",
    "묣" => "myolb", "묤" => "myols", "묥" => "myolt", "묦" => "myolp", "묧" => "myolh", "묨" => "myom",
    "묩" => "myob", "묪" => "myobs", "묫" => "myos", "묬" => "myoss", "묭" => "myong", "묮" => "myoj",
    "묯" => "myoc", "묰" => "myok", "묱" => "myot", "묲" => "myop", "묳" => "myoh", "무" => "mu",
    "묵" => "mug", "묶" => "mugg", "묷" => "mugs", "문" => "mun", "묹" => "munj", "묺" => "munh",
    "묻" => "mud", "물" => "mul", "묽" => "mulg", "묾" => "mulm", "묿" => "mulb", "뭀" => "muls",
    "뭁" => "mult", "뭂" => "mulp", "뭃" => "mulh", "뭄" => "mum", "뭅" => "mub", "뭆" => "mubs",
    "뭇" => "mus", "뭈" => "muss", "뭉" => "mung", "뭊" => "muj", "뭋" => "muc", "뭌" => "muk",
    "뭍" => "mut", "뭎" => "mup", "뭏" => "muh", "뭐" => "mweo", "뭑" => "mweog", "뭒" => "mweogg",
    "뭓" => "mweogs", "뭔" => "mweon", "뭕" => "mweonj", "뭖" => "mweonh", "뭗" => "mweod", "뭘" => "mweol",
    "뭙" => "mweolg", "뭚" => "mweolm", "뭛" => "mweolb", "뭜" => "mweols", "뭝" => "mweolt", "뭞" => "mweolp",
    "뭟" => "mweolh", "뭠" => "mweom", "뭡" => "mweob", "뭢" => "mweobs", "뭣" => "mweos", "뭤" => "mweoss",
    "뭥" => "mweong", "뭦" => "mweoj", "뭧" => "mweoc", "뭨" => "mweok", "뭩" => "mweot", "뭪" => "mweop",
    "뭫" => "mweoh", "뭬" => "mwe", "뭭" => "mweg", "뭮" => "mwegg", "뭯" => "mwegs", "뭰" => "mwen",
    "뭱" => "mwenj", "뭲" => "mwenh", "뭳" => "mwed", "뭴" => "mwel", "뭵" => "mwelg", "뭶" => "mwelm",
    "뭷" => "mwelb", "뭸" => "mwels", "뭹" => "mwelt", "뭺" => "mwelp", "뭻" => "mwelh", "뭼" => "mwem",
    "뭽" => "mweb", "뭾" => "mwebs", "뭿" => "mwes", "뮀" => "mwess", "뮁" => "mweng", "뮂" => "mwej",
    "뮃" => "mwec", "뮄" => "mwek", "뮅" => "mwet", "뮆" => "mwep", "뮇" => "mweh", "뮈" => "mwi",
    "뮉" => "mwig", "뮊" => "mwigg", "뮋" => "mwigs", "뮌" => "mwin", "뮍" => "mwinj", "뮎" => "mwinh",
    "뮏" => "mwid", "뮐" => "mwil", "뮑" => "mwilg", "뮒" => "mwilm", "뮓" => "mwilb", "뮔" => "mwils",
    "뮕" => "mwilt", "뮖" => "mwilp", "뮗" => "mwilh", "뮘" => "mwim", "뮙" => "mwib", "뮚" => "mwibs",
    "뮛" => "mwis", "뮜" => "mwiss", "뮝" => "mwing", "뮞" => "mwij", "뮟" => "mwic", "뮠" => "mwik",
    "뮡" => "mwit", "뮢" => "mwip", "뮣" => "mwih", "뮤" => "myu", "뮥" => "myug", "뮦" => "myugg",
    "뮧" => "myugs", "뮨" => "myun", "뮩" => "myunj", "뮪" => "myunh", "뮫" => "myud", "뮬" => "myul",
    "뮭" => "myulg", "뮮" => "myulm", "뮯" => "myulb", "뮰" => "myuls", "뮱" => "myult", "뮲" => "myulp",
    "뮳" => "myulh", "뮴" => "myum", "뮵" => "myub", "뮶" => "myubs", "뮷" => "myus", "뮸" => "myuss",
    "뮹" => "myung", "뮺" => "myuj", "뮻" => "myuc", "뮼" => "myuk", "뮽" => "myut", "뮾" => "myup",
    "뮿" => "myuh", "므" => "meu", "믁" => "meug", "믂" => "meugg", "믃" => "meugs", "믄" => "meun",
    "믅" => "meunj", "믆" => "meunh", "믇" => "meud", "믈" => "meul", "믉" => "meulg", "믊" => "meulm",
    "믋" => "meulb", "믌" => "meuls", "믍" => "meult", "믎" => "meulp", "믏" => "meulh", "믐" => "meum",
    "믑" => "meub", "믒" => "meubs", "믓" => "meus", "믔" => "meuss", "믕" => "meung", "믖" => "meuj",
    "믗" => "meuc", "믘" => "meuk", "믙" => "meut", "믚" => "meup", "믛" => "meuh", "믜" => "myi",
    "믝" => "myig", "믞" => "myigg", "믟" => "myigs", "믠" => "myin", "믡" => "myinj", "믢" => "myinh",
    "믣" => "myid", "믤" => "myil", "믥" => "myilg", "믦" => "myilm", "믧" => "myilb", "믨" => "myils",
    "믩" => "myilt", "믪" => "myilp", "믫" => "myilh", "믬" => "myim", "믭" => "myib", "믮" => "myibs",
    "믯" => "myis", "믰" => "myiss", "믱" => "mying", "믲" => "myij", "믳" => "myic", "믴" => "myik",
    "믵" => "myit", "믶" => "myip", "믷" => "myih", "미" => "mi", "믹" => "mig", "믺" => "migg",
    "믻" => "migs", "민" => "min", "믽" => "minj", "믾" => "minh", "믿" => "mid", "밁" => "milg",
    "밂" => "milm", "밃" => "milb", "밄" => "mils", "밅" => "milt", "밆" => "milp", "밇" => "milh",
    "밈" => "mim", "밉" => "mib", "밊" => "mibs", "밋" => "mis", "밌" => "miss", "밍" => "ming",
    "밎" => "mij", "및" => "mic", "밐" => "mik", "밑" => "mit", "밒" => "mip", "밓" => "mih",
    "바" => "ba", "박" => "bag", "밖" => "bagg", "밗" => "bags", "반" => "ban", "밙" => "banj",
    "밚" => "banh", "받" => "bad", "발" => "bal", "밝" => "balg", "밞" => "balm", "밟" => "balb",
    "밠" => "bals", "밡" => "balt", "밢" => "balp", "밣" => "balh", "밤" => "bam", "밥" => "bab",
    "밦" => "babs", "밧" => "bas", "밨" => "bass", "방" => "bang", "밪" => "baj", "밫" => "bac",
    "밬" => "bak", "밭" => "bat", "밮" => "bap", "밯" => "bah", "배" => "bae", "백" => "baeg",
    "밲" => "baegg", "밳" => "baegs", "밴" => "baen", "밵" => "baenj", "밶" => "baenh", "밷" => "baed",
    "밸" => "bael", "밹" => "baelg", "밺" => "baelm", "밻" => "baelb", "밼" => "baels", "밽" => "baelt",
    "밾" => "baelp", "밿" => "baelh", "뱀" => "baem", "뱁" => "baeb", "뱂" => "baebs", "뱃" => "baes",
    "뱄" => "baess", "뱅" => "baeng", "뱆" => "baej", "뱇" => "baec", "뱈" => "baek", "뱉" => "baet",
    "뱊" => "baep", "뱋" => "baeh", "뱌" => "bya", "뱍" => "byag", "뱎" => "byagg", "뱏" => "byags",
    "뱐" => "byan", "뱑" => "byanj", "뱒" => "byanh", "뱓" => "byad", "뱔" => "byal", "뱕" => "byalg",
    "뱖" => "byalm", "뱗" => "byalb", "뱘" => "byals", "뱙" => "byalt", "뱚" => "byalp", "뱛" => "byalh",
    "뱜" => "byam", "뱝" => "byab", "뱞" => "byabs", "뱟" => "byas", "뱠" => "byass", "뱡" => "byang",
    "뱢" => "byaj", "뱣" => "byac", "뱤" => "byak", "뱥" => "byat", "뱦" => "byap", "뱧" => "byah",
    "뱨" => "byae", "뱩" => "byaeg", "뱪" => "byaegg", "뱫" => "byaegs", "뱬" => "byaen", "뱭" => "byaenj",
    "뱮" => "byaenh", "뱯" => "byaed", "뱰" => "byael", "뱱" => "byaelg", "뱲" => "byaelm", "뱳" => "byaelb",
    "뱴" => "byaels", "뱵" => "byaelt", "뱶" => "byaelp", "뱷" => "byaelh", "뱸" => "byaem", "뱹" => "byaeb",
    "뱺" => "byaebs", "뱻" => "byaes", "뱼" => "byaess", "뱽" => "byaeng", "뱾" => "byaej", "뱿" => "byaec",
    "벀" => "byaek", "벁" => "byaet", "벂" => "byaep", "벃" => "byaeh", "버" => "beo", "벅" => "beog",
    "벆" => "beogg", "벇" => "beogs", "번" => "beon", "벉" => "beonj", "벊" => "beonh", "벋" => "beod",
    "벌" => "beol", "벍" => "beolg", "벎" => "beolm", "벏" => "beolb", "벐" => "beols", "벑" => "beolt",
    "벒" => "beolp", "벓" => "beolh", "범" => "beom", "법" => "beob", "벖" => "beobs", "벗" => "beos",
    "벘" => "beoss", "벙" => "beong", "벚" => "beoj", "벛" => "beoc", "벜" => "beok", "벝" => "beot",
    "벞" => "beop", "벟" => "beoh", "베" => "be", "벡" => "beg", "벢" => "begg", "벣" => "begs",
    "벤" => "ben", "벥" => "benj", "벦" => "benh", "벧" => "bed", "벨" => "bel", "벩" => "belg",
    "벪" => "belm", "벫" => "belb", "벬" => "bels", "벭" => "belt", "벮" => "belp", "벯" => "belh",
    "벰" => "bem", "벱" => "beb", "벲" => "bebs", "벳" => "bes", "벴" => "bess", "벵" => "beng",
    "벶" => "bej", "벷" => "bec", "벸" => "bek", "벹" => "bet", "벺" => "bep", "벻" => "beh",
    "벼" => "byeo", "벽" => "byeog", "벾" => "byeogg", "벿" => "byeogs", "변" => "byeon", "볁" => "byeonj",
    "볂" => "byeonh", "볃" => "byeod", "별" => "byeol", "볅" => "byeolg", "볆" => "byeolm", "볇" => "byeolb",
    "볈" => "byeols", "볉" => "byeolt", "볊" => "byeolp", "볋" => "byeolh", "볌" => "byeom", "볍" => "byeob",
    "볎" => "byeobs", "볏" => "byeos", "볐" => "byeoss", "병" => "byeong", "볒" => "byeoj", "볓" => "byeoc",
    "볔" => "byeok", "볕" => "byeot", "볖" => "byeop", "볗" => "byeoh", "볘" => "bye", "볙" => "byeg",
    "볚" => "byegg", "볛" => "byegs", "볜" => "byen", "볝" => "byenj", "볞" => "byenh", "볟" => "byed",
    "볠" => "byel", "볡" => "byelg", "볢" => "byelm", "볣" => "byelb", "볤" => "byels", "볥" => "byelt",
    "볦" => "byelp", "볧" => "byelh", "볨" => "byem", "볩" => "byeb", "볪" => "byebs", "볫" => "byes",
    "볬" => "byess", "볭" => "byeng", "볮" => "byej", "볯" => "byec", "볰" => "byek", "볱" => "byet",
    "볲" => "byep", "볳" => "byeh", "보" => "bo", "복" => "bog", "볶" => "bogg", "볷" => "bogs",
    "본" => "bon", "볹" => "bonj", "볺" => "bonh", "볻" => "bod", "볼" => "bol", "볽" => "bolg",
    "볾" => "bolm", "볿" => "bolb", "봁" => "bolt", "봂" => "bolp", "봃" => "bolh", "봄" => "bom",
    "봅" => "bob", "봆" => "bobs", "봇" => "bos", "봈" => "boss", "봉" => "bong", "봊" => "boj",
    "봋" => "boc", "봌" => "bok", "봍" => "bot", "봎" => "bop", "봏" => "boh", "봐" => "bwa",
    "봑" => "bwag", "봒" => "bwagg", "봓" => "bwags", "봔" => "bwan", "봕" => "bwanj", "봖" => "bwanh",
    "봗" => "bwad", "봘" => "bwal", "봙" => "bwalg", "봚" => "bwalm", "봛" => "bwalb", "봜" => "bwals",
    "봝" => "bwalt", "봞" => "bwalp", "봟" => "bwalh", "봠" => "bwam", "봡" => "bwab", "봢" => "bwabs",
    "봣" => "bwas", "봤" => "bwass", "봥" => "bwang", "봦" => "bwaj", "봧" => "bwac", "봨" => "bwak",
    "봩" => "bwat", "봪" => "bwap", "봫" => "bwah", "봬" => "bwae", "봭" => "bwaeg", "봮" => "bwaegg",
    "봯" => "bwaegs", "봰" => "bwaen", "봱" => "bwaenj", "봲" => "bwaenh", "봳" => "bwaed", "봴" => "bwael",
    "봵" => "bwaelg", "봶" => "bwaelm", "봷" => "bwaelb", "봸" => "bwaels", "봹" => "bwaelt", "봺" => "bwaelp",
    "봻" => "bwaelh", "봼" => "bwaem", "봽" => "bwaeb", "봾" => "bwaebs", "봿" => "bwaes", "뵀" => "bwaess",
    "뵁" => "bwaeng", "뵂" => "bwaej", "뵃" => "bwaec", "뵄" => "bwaek", "뵅" => "bwaet", "뵆" => "bwaep",
    "뵇" => "bwaeh", "뵈" => "boe", "뵉" => "boeg", "뵊" => "boegg", "뵋" => "boegs", "뵌" => "boen",
    "뵍" => "boenj", "뵎" => "boenh", "뵏" => "boed", "뵐" => "boel", "뵑" => "boelg", "뵒" => "boelm",
    "뵓" => "boelb", "뵔" => "boels", "뵕" => "boelt", "뵖" => "boelp", "뵗" => "boelh", "뵘" => "boem",
    "뵙" => "boeb", "뵚" => "boebs", "뵛" => "boes", "뵜" => "boess", "뵝" => "boeng", "뵞" => "boej",
    "뵟" => "boec", "뵠" => "boek", "뵡" => "boet", "뵢" => "boep", "뵣" => "boeh", "뵤" => "byo",
    "뵥" => "byog", "뵦" => "byogg", "뵧" => "byogs", "뵨" => "byon", "뵩" => "byonj", "뵪" => "byonh",
    "뵫" => "byod", "뵬" => "byol", "뵭" => "byolg", "뵮" => "byolm", "뵯" => "byolb", "뵰" => "byols",
    "뵱" => "byolt", "뵲" => "byolp", "뵳" => "byolh", "뵴" => "byom", "뵵" => "byob", "뵶" => "byobs",
    "뵷" => "byos", "뵸" => "byoss", "뵹" => "byong", "뵺" => "byoj", "뵻" => "byoc", "뵼" => "byok",
    "뵽" => "byot", "뵾" => "byop", "뵿" => "byoh", "부" => "bu", "북" => "bug", "붂" => "bugg",
    "붃" => "bugs", "분" => "bun", "붅" => "bunj", "붆" => "bunh", "붇" => "bud", "불" => "bul",
    "붉" => "bulg", "붊" => "bulm", "붋" => "bulb", "붌" => "buls", "붍" => "bult", "붎" => "bulp",
    "붏" => "bulh", "붐" => "bum", "붑" => "bub", "붒" => "bubs", "붓" => "bus", "붔" => "buss",
    "붕" => "bung", "붖" => "buj", "붗" => "buc", "붘" => "buk", "붙" => "but", "붚" => "bup",
    "붛" => "buh", "붜" => "bweo", "붝" => "bweog", "붞" => "bweogg", "붟" => "bweogs", "붠" => "bweon",
    "붡" => "bweonj", "붢" => "bweonh", "붣" => "bweod", "붤" => "bweol", "붥" => "bweolg", "붦" => "bweolm",
    "붧" => "bweolb", "붨" => "bweols", "붩" => "bweolt", "붪" => "bweolp", "붫" => "bweolh", "붬" => "bweom",
    "붭" => "bweob", "붮" => "bweobs", "붯" => "bweos", "붰" => "bweoss", "붱" => "bweong", "붲" => "bweoj",
    "붳" => "bweoc", "붴" => "bweok", "붵" => "bweot", "붶" => "bweop", "붷" => "bweoh", "붸" => "bwe",
    "붹" => "bweg", "붺" => "bwegg", "붻" => "bwegs", "붼" => "bwen", "붽" => "bwenj", "붾" => "bwenh",
    "붿" => "bwed", "뷀" => "bwel", "뷁" => "bwelg", "뷂" => "bwelm", "뷃" => "bwelb", "뷄" => "bwels",
    "뷅" => "bwelt", "뷆" => "bwelp", "뷇" => "bwelh", "뷈" => "bwem", "뷉" => "bweb", "뷊" => "bwebs",
    "뷋" => "bwes", "뷌" => "bwess", "뷍" => "bweng", "뷎" => "bwej", "뷏" => "bwec", "뷐" => "bwek",
    "뷑" => "bwet", "뷒" => "bwep", "뷓" => "bweh", "뷔" => "bwi", "뷕" => "bwig", "뷖" => "bwigg",
    "뷗" => "bwigs", "뷘" => "bwin", "뷙" => "bwinj", "뷚" => "bwinh", "뷛" => "bwid", "뷜" => "bwil",
    "뷝" => "bwilg", "뷞" => "bwilm", "뷟" => "bwilb", "뷠" => "bwils", "뷡" => "bwilt", "뷢" => "bwilp",
    "뷣" => "bwilh", "뷤" => "bwim", "뷥" => "bwib", "뷦" => "bwibs", "뷧" => "bwis", "뷨" => "bwiss",
    "뷩" => "bwing", "뷪" => "bwij", "뷫" => "bwic", "뷬" => "bwik", "뷭" => "bwit", "뷮" => "bwip",
    "뷯" => "bwih", "뷰" => "byu", "뷱" => "byug", "뷲" => "byugg", "뷳" => "byugs", "뷴" => "byun",
    "뷵" => "byunj", "뷶" => "byunh", "뷷" => "byud", "뷸" => "byul", "뷹" => "byulg", "뷺" => "byulm",
    "뷻" => "byulb", "뷼" => "byuls", "뷽" => "byult", "뷾" => "byulp", "뷿" => "byulh", "븁" => "byub",
    "븂" => "byubs", "븃" => "byus", "븄" => "byuss", "븅" => "byung", "븆" => "byuj", "븇" => "byuc",
    "븈" => "byuk", "븉" => "byut", "븊" => "byup", "븋" => "byuh", "브" => "beu", "븍" => "beug",
    "븎" => "beugg", "븏" => "beugs", "븐" => "beun", "븑" => "beunj", "븒" => "beunh", "븓" => "beud",
    "블" => "beul", "븕" => "beulg", "븖" => "beulm", "븗" => "beulb", "븘" => "beuls", "븙" => "beult",
    "븚" => "beulp", "븛" => "beulh", "븜" => "beum", "븝" => "beub", "븞" => "beubs", "븟" => "beus",
    "븠" => "beuss", "븡" => "beung", "븢" => "beuj", "븣" => "beuc", "븤" => "beuk", "븥" => "beut",
    "븦" => "beup", "븧" => "beuh", "븨" => "byi", "븩" => "byig", "븪" => "byigg", "븫" => "byigs",
    "븬" => "byin", "븭" => "byinj", "븮" => "byinh", "븯" => "byid", "븰" => "byil", "븱" => "byilg",
    "븲" => "byilm", "븳" => "byilb", "븴" => "byils", "븵" => "byilt", "븶" => "byilp", "븷" => "byilh",
    "븸" => "byim", "븹" => "byib", "븺" => "byibs", "븻" => "byis", "븼" => "byiss", "븽" => "bying",
    "븾" => "byij", "븿" => "byic", "빀" => "byik", "빁" => "byit", "빂" => "byip", "빃" => "byih",
    "비" => "bi", "빅" => "big", "빆" => "bigg", "빇" => "bigs", "빈" => "bin", "빉" => "binj",
    "빊" => "binh", "빋" => "bid", "빌" => "bil", "빍" => "bilg", "빎" => "bilm", "빏" => "bilb",
    "빐" => "bils", "빑" => "bilt", "빒" => "bilp", "빓" => "bilh", "빔" => "bim", "빕" => "bib",
    "빖" => "bibs", "빗" => "bis", "빘" => "biss", "빙" => "bing", "빚" => "bij", "빛" => "bic",
    "빜" => "bik", "빝" => "bit", "빞" => "bip", "빟" => "bih", "빠" => "bba", "빡" => "bbag",
    "빢" => "bbagg", "빣" => "bbags", "빤" => "bban", "빥" => "bbanj", "빦" => "bbanh", "빧" => "bbad",
    "빨" => "bbal", "빩" => "bbalg", "빪" => "bbalm", "빫" => "bbalb", "빬" => "bbals", "빭" => "bbalt",
    "빮" => "bbalp", "빯" => "bbalh", "빰" => "bbam", "빱" => "bbab", "빲" => "bbabs", "빳" => "bbas",
    "빴" => "bbass", "빵" => "bbang", "빶" => "bbaj", "빷" => "bbac", "빸" => "bbak", "빹" => "bbat",
    "빺" => "bbap", "빻" => "bbah", "빼" => "bbae", "빽" => "bbaeg", "빾" => "bbaegg", "빿" => "bbaegs",
    "뺀" => "bbaen", "뺁" => "bbaenj", "뺂" => "bbaenh", "뺃" => "bbaed", "뺄" => "bbael", "뺅" => "bbaelg",
    "뺆" => "bbaelm", "뺇" => "bbaelb", "뺈" => "bbaels", "뺉" => "bbaelt", "뺊" => "bbaelp", "뺋" => "bbaelh",
    "뺌" => "bbaem", "뺍" => "bbaeb", "뺎" => "bbaebs", "뺏" => "bbaes", "뺐" => "bbaess", "뺑" => "bbaeng",
    "뺒" => "bbaej", "뺓" => "bbaec", "뺔" => "bbaek", "뺕" => "bbaet", "뺖" => "bbaep", "뺗" => "bbaeh",
    "뺘" => "bbya", "뺙" => "bbyag", "뺚" => "bbyagg", "뺛" => "bbyags", "뺜" => "bbyan", "뺝" => "bbyanj",
    "뺞" => "bbyanh", "뺟" => "bbyad", "뺠" => "bbyal", "뺡" => "bbyalg", "뺢" => "bbyalm", "뺣" => "bbyalb",
    "뺤" => "bbyals", "뺥" => "bbyalt", "뺦" => "bbyalp", "뺧" => "bbyalh", "뺨" => "bbyam", "뺩" => "bbyab",
    "뺪" => "bbyabs", "뺫" => "bbyas", "뺬" => "bbyass", "뺭" => "bbyang", "뺮" => "bbyaj", "뺯" => "bbyac",
    "뺰" => "bbyak", "뺱" => "bbyat", "뺲" => "bbyap", "뺳" => "bbyah", "뺴" => "bbyae", "뺵" => "bbyaeg",
    "뺶" => "bbyaegg", "뺷" => "bbyaegs", "뺸" => "bbyaen", "뺹" => "bbyaenj", "뺺" => "bbyaenh", "뺻" => "bbyaed",
    "뺼" => "bbyael", "뺽" => "bbyaelg", "뺾" => "bbyaelm", "뺿" => "bbyaelb", "뻀" => "bbyaels", "뻁" => "bbyaelt",
    "뻂" => "bbyaelp", "뻃" => "bbyaelh", "뻄" => "bbyaem", "뻅" => "bbyaeb", "뻆" => "bbyaebs", "뻇" => "bbyaes",
    "뻈" => "bbyaess", "뻉" => "bbyaeng", "뻊" => "bbyaej", "뻋" => "bbyaec", "뻌" => "bbyaek", "뻍" => "bbyaet",
    "뻎" => "bbyaep", "뻏" => "bbyaeh", "뻐" => "bbeo", "뻑" => "bbeog", "뻒" => "bbeogg", "뻓" => "bbeogs",
    "뻔" => "bbeon", "뻕" => "bbeonj", "뻖" => "bbeonh", "뻗" => "bbeod", "뻘" => "bbeol", "뻙" => "bbeolg",
    "뻚" => "bbeolm", "뻛" => "bbeolb", "뻜" => "bbeols", "뻝" => "bbeolt", "뻞" => "bbeolp", "뻟" => "bbeolh",
    "뻠" => "bbeom", "뻡" => "bbeob", "뻢" => "bbeobs", "뻣" => "bbeos", "뻤" => "bbeoss", "뻥" => "bbeong",
    "뻦" => "bbeoj", "뻧" => "bbeoc", "뻨" => "bbeok", "뻩" => "bbeot", "뻪" => "bbeop", "뻫" => "bbeoh",
    "뻬" => "bbe", "뻭" => "bbeg", "뻮" => "bbegg", "뻯" => "bbegs", "뻰" => "bben", "뻱" => "bbenj",
    "뻲" => "bbenh", "뻳" => "bbed", "뻴" => "bbel", "뻵" => "bbelg", "뻶" => "bbelm", "뻷" => "bbelb",
    "뻸" => "bbels", "뻹" => "bbelt", "뻺" => "bbelp", "뻻" => "bbelh", "뻼" => "bbem", "뻽" => "bbeb",
    "뻾" => "bbebs", "뻿" => "bbes", "뼁" => "bbeng", "뼂" => "bbej", "뼃" => "bbec", "뼄" => "bbek",
    "뼅" => "bbet", "뼆" => "bbep", "뼇" => "bbeh", "뼈" => "bbyeo", "뼉" => "bbyeog", "뼊" => "bbyeogg",
    "뼋" => "bbyeogs", "뼌" => "bbyeon", "뼍" => "bbyeonj", "뼎" => "bbyeonh", "뼏" => "bbyeod", "뼐" => "bbyeol",
    "뼑" => "bbyeolg", "뼒" => "bbyeolm", "뼓" => "bbyeolb", "뼔" => "bbyeols", "뼕" => "bbyeolt", "뼖" => "bbyeolp",
    "뼗" => "bbyeolh", "뼘" => "bbyeom", "뼙" => "bbyeob", "뼚" => "bbyeobs", "뼛" => "bbyeos", "뼜" => "bbyeoss",
    "뼝" => "bbyeong", "뼞" => "bbyeoj", "뼟" => "bbyeoc", "뼠" => "bbyeok", "뼡" => "bbyeot", "뼢" => "bbyeop",
    "뼣" => "bbyeoh", "뼤" => "bbye", "뼥" => "bbyeg", "뼦" => "bbyegg", "뼧" => "bbyegs", "뼨" => "bbyen",
    "뼩" => "bbyenj", "뼪" => "bbyenh", "뼫" => "bbyed", "뼬" => "bbyel", "뼭" => "bbyelg", "뼮" => "bbyelm",
    "뼯" => "bbyelb", "뼰" => "bbyels", "뼱" => "bbyelt", "뼲" => "bbyelp", "뼳" => "bbyelh", "뼴" => "bbyem",
    "뼵" => "bbyeb", "뼶" => "bbyebs", "뼷" => "bbyes", "뼸" => "bbyess", "뼹" => "bbyeng", "뼺" => "bbyej",
    "뼻" => "bbyec", "뼼" => "bbyek", "뼽" => "bbyet", "뼾" => "bbyep", "뼿" => "bbyeh", "뽀" => "bbo",
    "뽁" => "bbog", "뽂" => "bbogg", "뽃" => "bbogs", "뽄" => "bbon", "뽅" => "bbonj", "뽆" => "bbonh",
    "뽇" => "bbod", "뽈" => "bbol", "뽉" => "bbolg", "뽊" => "bbolm", "뽋" => "bbolb", "뽌" => "bbols",
    "뽍" => "bbolt", "뽎" => "bbolp", "뽏" => "bbolh", "뽐" => "bbom", "뽑" => "bbob", "뽒" => "bbobs",
    "뽓" => "bbos", "뽔" => "bboss", "뽕" => "bbong", "뽖" => "bboj", "뽗" => "bboc", "뽘" => "bbok",
    "뽙" => "bbot", "뽚" => "bbop", "뽛" => "bboh", "뽜" => "bbwa", "뽝" => "bbwag", "뽞" => "bbwagg",
    "뽟" => "bbwags", "뽠" => "bbwan", "뽡" => "bbwanj", "뽢" => "bbwanh", "뽣" => "bbwad", "뽤" => "bbwal",
    "뽥" => "bbwalg", "뽦" => "bbwalm", "뽧" => "bbwalb", "뽨" => "bbwals", "뽩" => "bbwalt", "뽪" => "bbwalp",
    "뽫" => "bbwalh", "뽬" => "bbwam", "뽭" => "bbwab", "뽮" => "bbwabs", "뽯" => "bbwas", "뽰" => "bbwass",
    "뽱" => "bbwang", "뽲" => "bbwaj", "뽳" => "bbwac", "뽴" => "bbwak", "뽵" => "bbwat", "뽶" => "bbwap",
    "뽷" => "bbwah", "뽸" => "bbwae", "뽹" => "bbwaeg", "뽺" => "bbwaegg", "뽻" => "bbwaegs", "뽼" => "bbwaen",
    "뽽" => "bbwaenj", "뽾" => "bbwaenh", "뽿" => "bbwaed", "뾀" => "bbwael", "뾁" => "bbwaelg", "뾂" => "bbwaelm",
    "뾃" => "bbwaelb", "뾄" => "bbwaels", "뾅" => "bbwaelt", "뾆" => "bbwaelp", "뾇" => "bbwaelh", "뾈" => "bbwaem",
    "뾉" => "bbwaeb", "뾊" => "bbwaebs", "뾋" => "bbwaes", "뾌" => "bbwaess", "뾍" => "bbwaeng", "뾎" => "bbwaej",
    "뾏" => "bbwaec", "뾐" => "bbwaek", "뾑" => "bbwaet", "뾒" => "bbwaep", "뾓" => "bbwaeh", "뾔" => "bboe",
    "뾕" => "bboeg", "뾖" => "bboegg", "뾗" => "bboegs", "뾘" => "bboen", "뾙" => "bboenj", "뾚" => "bboenh",
    "뾛" => "bboed", "뾜" => "bboel", "뾝" => "bboelg", "뾞" => "bboelm", "뾟" => "bboelb", "뾠" => "bboels",
    "뾡" => "bboelt", "뾢" => "bboelp", "뾣" => "bboelh", "뾤" => "bboem", "뾥" => "bboeb", "뾦" => "bboebs",
    "뾧" => "bboes", "뾨" => "bboess", "뾩" => "bboeng", "뾪" => "bboej", "뾫" => "bboec", "뾬" => "bboek",
    "뾭" => "bboet", "뾮" => "bboep", "뾯" => "bboeh", "뾰" => "bbyo", "뾱" => "bbyog", "뾲" => "bbyogg",
    "뾳" => "bbyogs", "뾴" => "bbyon", "뾵" => "bbyonj", "뾶" => "bbyonh", "뾷" => "bbyod", "뾸" => "bbyol",
    "뾹" => "bbyolg", "뾺" => "bbyolm", "뾻" => "bbyolb", "뾼" => "bbyols", "뾽" => "bbyolt", "뾾" => "bbyolp",
    "뾿" => "bbyolh", "뿀" => "bbyom", "뿁" => "bbyob", "뿂" => "bbyobs", "뿃" => "bbyos", "뿄" => "bbyoss",
    "뿅" => "bbyong", "뿆" => "bbyoj", "뿇" => "bbyoc", "뿈" => "bbyok", "뿉" => "bbyot", "뿊" => "bbyop",
    "뿋" => "bbyoh", "뿌" => "bbu", "뿍" => "bbug", "뿎" => "bbugg", "뿏" => "bbugs", "뿐" => "bbun",
    "뿑" => "bbunj", "뿒" => "bbunh", "뿓" => "bbud", "뿔" => "bbul", "뿕" => "bbulg", "뿖" => "bbulm",
    "뿗" => "bbulb", "뿘" => "bbuls", "뿙" => "bbult", "뿚" => "bbulp", "뿛" => "bbulh", "뿜" => "bbum",
    "뿝" => "bbub", "뿞" => "bbubs", "뿟" => "bbus", "뿠" => "bbuss", "뿡" => "bbung", "뿢" => "bbuj",
    "뿣" => "bbuc", "뿤" => "bbuk", "뿥" => "bbut", "뿦" => "bbup", "뿧" => "bbuh", "뿨" => "bbweo",
    "뿩" => "bbweog", "뿪" => "bbweogg", "뿫" => "bbweogs", "뿬" => "bbweon", "뿭" => "bbweonj", "뿮" => "bbweonh",
    "뿯" => "bbweod", "뿰" => "bbweol", "뿱" => "bbweolg", "뿲" => "bbweolm", "뿳" => "bbweolb", "뿴" => "bbweols",
    "뿵" => "bbweolt", "뿶" => "bbweolp", "뿷" => "bbweolh", "뿸" => "bbweom", "뿹" => "bbweob", "뿺" => "bbweobs",
    "뿻" => "bbweos", "뿼" => "bbweoss", "뿽" => "bbweong", "뿾" => "bbweoj", "뿿" => "bbweoc", "쀁" => "bbweot",
    "쀂" => "bbweop", "쀃" => "bbweoh", "쀄" => "bbwe", "쀅" => "bbweg", "쀆" => "bbwegg", "쀇" => "bbwegs",
    "쀈" => "bbwen", "쀉" => "bbwenj", "쀊" => "bbwenh", "쀋" => "bbwed", "쀌" => "bbwel", "쀍" => "bbwelg",
    "쀎" => "bbwelm", "쀏" => "bbwelb", "쀐" => "bbwels", "쀑" => "bbwelt", "쀒" => "bbwelp", "쀓" => "bbwelh",
    "쀔" => "bbwem", "쀕" => "bbweb", "쀖" => "bbwebs", "쀗" => "bbwes", "쀘" => "bbwess", "쀙" => "bbweng",
    "쀚" => "bbwej", "쀛" => "bbwec", "쀜" => "bbwek", "쀝" => "bbwet", "쀞" => "bbwep", "쀟" => "bbweh",
    "쀠" => "bbwi", "쀡" => "bbwig", "쀢" => "bbwigg", "쀣" => "bbwigs", "쀤" => "bbwin", "쀥" => "bbwinj",
    "쀦" => "bbwinh", "쀧" => "bbwid", "쀨" => "bbwil", "쀩" => "bbwilg", "쀪" => "bbwilm", "쀫" => "bbwilb",
    "쀬" => "bbwils", "쀭" => "bbwilt", "쀮" => "bbwilp", "쀯" => "bbwilh", "쀰" => "bbwim", "쀱" => "bbwib",
    "쀲" => "bbwibs", "쀳" => "bbwis", "쀴" => "bbwiss", "쀵" => "bbwing", "쀶" => "bbwij", "쀷" => "bbwic",
    "쀸" => "bbwik", "쀹" => "bbwit", "쀺" => "bbwip", "쀻" => "bbwih", "쀼" => "bbyu", "쀽" => "bbyug",
    "쀾" => "bbyugg", "쀿" => "bbyugs", "쁀" => "bbyun", "쁁" => "bbyunj", "쁂" => "bbyunh", "쁃" => "bbyud",
    "쁄" => "bbyul", "쁅" => "bbyulg", "쁆" => "bbyulm", "쁇" => "bbyulb", "쁈" => "bbyuls", "쁉" => "bbyult",
    "쁊" => "bbyulp", "쁋" => "bbyulh", "쁌" => "bbyum", "쁍" => "bbyub", "쁎" => "bbyubs", "쁏" => "bbyus",
    "쁐" => "bbyuss", "쁑" => "bbyung", "쁒" => "bbyuj", "쁓" => "bbyuc", "쁔" => "bbyuk", "쁕" => "bbyut",
    "쁖" => "bbyup", "쁗" => "bbyuh", "쁘" => "bbeu", "쁙" => "bbeug", "쁚" => "bbeugg", "쁛" => "bbeugs",
    "쁜" => "bbeun", "쁝" => "bbeunj", "쁞" => "bbeunh", "쁟" => "bbeud", "쁠" => "bbeul", "쁡" => "bbeulg",
    "쁢" => "bbeulm", "쁣" => "bbeulb", "쁤" => "bbeuls", "쁥" => "bbeult", "쁦" => "bbeulp", "쁧" => "bbeulh",
    "쁨" => "bbeum", "쁩" => "bbeub", "쁪" => "bbeubs", "쁫" => "bbeus", "쁬" => "bbeuss", "쁭" => "bbeung",
    "쁮" => "bbeuj", "쁯" => "bbeuc", "쁰" => "bbeuk", "쁱" => "bbeut", "쁲" => "bbeup", "쁳" => "bbeuh",
    "쁴" => "bbyi", "쁵" => "bbyig", "쁶" => "bbyigg", "쁷" => "bbyigs", "쁸" => "bbyin", "쁹" => "bbyinj",
    "쁺" => "bbyinh", "쁻" => "bbyid", "쁼" => "bbyil", "쁽" => "bbyilg", "쁾" => "bbyilm", "쁿" => "bbyilb",
    "삀" => "bbyils", "삁" => "bbyilt", "삂" => "bbyilp", "삃" => "bbyilh", "삄" => "bbyim", "삅" => "bbyib",
    "삆" => "bbyibs", "삇" => "bbyis", "삈" => "bbyiss", "삉" => "bbying", "삊" => "bbyij", "삋" => "bbyic",
    "삌" => "bbyik", "삍" => "bbyit", "삎" => "bbyip", "삏" => "bbyih", "삐" => "bbi", "삑" => "bbig",
    "삒" => "bbigg", "삓" => "bbigs", "삔" => "bbin", "삕" => "bbinj", "삖" => "bbinh", "삗" => "bbid",
    "삘" => "bbil", "삙" => "bbilg", "삚" => "bbilm", "삛" => "bbilb", "삜" => "bbils", "삝" => "bbilt",
    "삞" => "bbilp", "삟" => "bbilh", "삠" => "bbim", "삡" => "bbib", "삢" => "bbibs", "삣" => "bbis",
    "삤" => "bbiss", "삥" => "bbing", "삦" => "bbij", "삧" => "bbic", "삨" => "bbik", "삩" => "bbit",
    "삪" => "bbip", "삫" => "bbih", "사" => "sa", "삭" => "sag", "삮" => "sagg", "삯" => "sags",
    "산" => "san", "삱" => "sanj", "삲" => "sanh", "삳" => "sad", "살" => "sal", "삵" => "salg",
    "삶" => "salm", "삷" => "salb", "삸" => "sals", "삹" => "salt", "삺" => "salp", "삻" => "salh",
    "삼" => "sam", "삽" => "sab", "삾" => "sabs", "삿" => "sas", "샀" => "sass", "상" => "sang",
    "샂" => "saj", "샃" => "sac", "샄" => "sak", "샅" => "sat", "샆" => "sap", "샇" => "sah",
    "새" => "sae", "색" => "saeg", "샊" => "saegg", "샋" => "saegs", "샌" => "saen", "샍" => "saenj",
    "샎" => "saenh", "샏" => "saed", "샐" => "sael", "샑" => "saelg", "샒" => "saelm", "샓" => "saelb",
    "샔" => "saels", "샕" => "saelt", "샖" => "saelp", "샗" => "saelh", "샘" => "saem", "샙" => "saeb",
    "샚" => "saebs", "샛" => "saes", "샜" => "saess", "생" => "saeng", "샞" => "saej", "샟" => "saec",
    "샠" => "saek", "샡" => "saet", "샢" => "saep", "샣" => "saeh", "샤" => "sya", "샥" => "syag",
    "샦" => "syagg", "샧" => "syags", "샨" => "syan", "샩" => "syanj", "샪" => "syanh", "샫" => "syad",
    "샬" => "syal", "샭" => "syalg", "샮" => "syalm", "샯" => "syalb", "샰" => "syals", "샱" => "syalt",
    "샲" => "syalp", "샳" => "syalh", "샴" => "syam", "샵" => "syab", "샶" => "syabs", "샷" => "syas",
    "샸" => "syass", "샹" => "syang", "샺" => "syaj", "샻" => "syac", "샼" => "syak", "샽" => "syat",
    "샾" => "syap", "샿" => "syah", "섁" => "syaeg", "섂" => "syaegg", "섃" => "syaegs", "섄" => "syaen",
    "섅" => "syaenj", "섆" => "syaenh", "섇" => "syaed", "섈" => "syael", "섉" => "syaelg", "섊" => "syaelm",
    "섋" => "syaelb", "섌" => "syaels", "섍" => "syaelt", "섎" => "syaelp", "섏" => "syaelh", "섐" => "syaem",
    "섑" => "syaeb", "섒" => "syaebs", "섓" => "syaes", "섔" => "syaess", "섕" => "syaeng", "섖" => "syaej",
    "섗" => "syaec", "섘" => "syaek", "섙" => "syaet", "섚" => "syaep", "섛" => "syaeh", "서" => "seo",
    "석" => "seog", "섞" => "seogg", "섟" => "seogs", "선" => "seon", "섡" => "seonj", "섢" => "seonh",
    "섣" => "seod", "설" => "seol", "섥" => "seolg", "섦" => "seolm", "섧" => "seolb", "섨" => "seols",
    "섩" => "seolt", "섪" => "seolp", "섫" => "seolh", "섬" => "seom", "섭" => "seob", "섮" => "seobs",
    "섯" => "seos", "섰" => "seoss", "성" => "seong", "섲" => "seoj", "섳" => "seoc", "섴" => "seok",
    "섵" => "seot", "섶" => "seop", "섷" => "seoh", "세" => "se", "섹" => "seg", "섺" => "segg",
    "섻" => "segs", "센" => "sen", "섽" => "senj", "섾" => "senh", "섿" => "sed", "셀" => "sel",
    "셁" => "selg", "셂" => "selm", "셃" => "selb", "셄" => "sels", "셅" => "selt", "셆" => "selp",
    "셇" => "selh", "셈" => "sem", "셉" => "seb", "셊" => "sebs", "셋" => "ses", "셌" => "sess",
    "셍" => "seng", "셎" => "sej", "셏" => "sec", "셐" => "sek", "셑" => "set", "셒" => "sep",
    "셓" => "seh", "셔" => "syeo", "셕" => "syeog", "셖" => "syeogg", "셗" => "syeogs", "션" => "syeon",
    "셙" => "syeonj", "셚" => "syeonh", "셛" => "syeod", "셜" => "syeol", "셝" => "syeolg", "셞" => "syeolm",
    "셟" => "syeolb", "셠" => "syeols", "셡" => "syeolt", "셢" => "syeolp", "셣" => "syeolh", "셤" => "syeom",
    "셥" => "syeob", "셦" => "syeobs", "셧" => "syeos", "셨" => "syeoss", "셩" => "syeong", "셪" => "syeoj",
    "셫" => "syeoc", "셬" => "syeok", "셭" => "syeot", "셮" => "syeop", "셯" => "syeoh", "셰" => "sye",
    "셱" => "syeg", "셲" => "syegg", "셳" => "syegs", "셴" => "syen", "셵" => "syenj", "셶" => "syenh",
    "셷" => "syed", "셸" => "syel", "셹" => "syelg", "셺" => "syelm", "셻" => "syelb", "셼" => "syels",
    "셽" => "syelt", "셾" => "syelp", "셿" => "syelh", "솀" => "syem", "솁" => "syeb", "솂" => "syebs",
    "솃" => "syes", "솄" => "syess", "솅" => "syeng", "솆" => "syej", "솇" => "syec", "솈" => "syek",
    "솉" => "syet", "솊" => "syep", "솋" => "syeh", "소" => "so", "속" => "sog", "솎" => "sogg",
    "솏" => "sogs", "손" => "son", "솑" => "sonj", "솒" => "sonh", "솓" => "sod", "솔" => "sol",
    "솕" => "solg", "솖" => "solm", "솗" => "solb", "솘" => "sols", "솙" => "solt", "솚" => "solp",
    "솛" => "solh", "솜" => "som", "솝" => "sob", "솞" => "sobs", "솟" => "sos", "솠" => "soss",
    "송" => "song", "솢" => "soj", "솣" => "soc", "솤" => "sok", "솥" => "sot", "솦" => "sop",
    "솧" => "soh", "솨" => "swa", "솩" => "swag", "솪" => "swagg", "솫" => "swags", "솬" => "swan",
    "솭" => "swanj", "솮" => "swanh", "솯" => "swad", "솰" => "swal", "솱" => "swalg", "솲" => "swalm",
    "솳" => "swalb", "솴" => "swals", "솵" => "swalt", "솶" => "swalp", "솷" => "swalh", "솸" => "swam",
    "솹" => "swab", "솺" => "swabs", "솻" => "swas", "솼" => "swass", "솽" => "swang", "솾" => "swaj",
    "솿" => "swac", "쇀" => "swak", "쇁" => "swat", "쇂" => "swap", "쇃" => "swah", "쇄" => "swae",
    "쇅" => "swaeg", "쇆" => "swaegg", "쇇" => "swaegs", "쇈" => "swaen", "쇉" => "swaenj", "쇊" => "swaenh",
    "쇋" => "swaed", "쇌" => "swael", "쇍" => "swaelg", "쇎" => "swaelm", "쇏" => "swaelb", "쇐" => "swaels",
    "쇑" => "swaelt", "쇒" => "swaelp", "쇓" => "swaelh", "쇔" => "swaem", "쇕" => "swaeb", "쇖" => "swaebs",
    "쇗" => "swaes", "쇘" => "swaess", "쇙" => "swaeng", "쇚" => "swaej", "쇛" => "swaec", "쇜" => "swaek",
    "쇝" => "swaet", "쇞" => "swaep", "쇟" => "swaeh", "쇠" => "soe", "쇡" => "soeg", "쇢" => "soegg",
    "쇣" => "soegs", "쇤" => "soen", "쇥" => "soenj", "쇦" => "soenh", "쇧" => "soed", "쇨" => "soel",
    "쇩" => "soelg", "쇪" => "soelm", "쇫" => "soelb", "쇬" => "soels", "쇭" => "soelt", "쇮" => "soelp",
    "쇯" => "soelh", "쇰" => "soem", "쇱" => "soeb", "쇲" => "soebs", "쇳" => "soes", "쇴" => "soess",
    "쇵" => "soeng", "쇶" => "soej", "쇷" => "soec", "쇸" => "soek", "쇹" => "soet", "쇺" => "soep",
    "쇻" => "soeh", "쇼" => "syo", "쇽" => "syog", "쇾" => "syogg", "쇿" => "syogs", "숁" => "syonj",
    "숂" => "syonh", "숃" => "syod", "숄" => "syol", "숅" => "syolg", "숆" => "syolm", "숇" => "syolb",
    "숈" => "syols", "숉" => "syolt", "숊" => "syolp", "숋" => "syolh", "숌" => "syom", "숍" => "syob",
    "숎" => "syobs", "숏" => "syos", "숐" => "syoss", "숑" => "syong", "숒" => "syoj", "숓" => "syoc",
    "숔" => "syok", "숕" => "syot", "숖" => "syop", "숗" => "syoh", "수" => "su", "숙" => "sug",
    "숚" => "sugg", "숛" => "sugs", "순" => "sun", "숝" => "sunj", "숞" => "sunh", "숟" => "sud",
    "술" => "sul", "숡" => "sulg", "숢" => "sulm", "숣" => "sulb", "숤" => "suls", "숥" => "sult",
    "숦" => "sulp", "숧" => "sulh", "숨" => "sum", "숩" => "sub", "숪" => "subs", "숫" => "sus",
    "숬" => "suss", "숭" => "sung", "숮" => "suj", "숯" => "suc", "숰" => "suk", "숱" => "sut",
    "숲" => "sup", "숳" => "suh", "숴" => "sweo", "숵" => "sweog", "숶" => "sweogg", "숷" => "sweogs",
    "숸" => "sweon", "숹" => "sweonj", "숺" => "sweonh", "숻" => "sweod", "숼" => "sweol", "숽" => "sweolg",
    "숾" => "sweolm", "숿" => "sweolb", "쉀" => "sweols", "쉁" => "sweolt", "쉂" => "sweolp", "쉃" => "sweolh",
    "쉄" => "sweom", "쉅" => "sweob", "쉆" => "sweobs", "쉇" => "sweos", "쉈" => "sweoss", "쉉" => "sweong",
    "쉊" => "sweoj", "쉋" => "sweoc", "쉌" => "sweok", "쉍" => "sweot", "쉎" => "sweop", "쉏" => "sweoh",
    "쉐" => "swe", "쉑" => "sweg", "쉒" => "swegg", "쉓" => "swegs", "쉔" => "swen", "쉕" => "swenj",
    "쉖" => "swenh", "쉗" => "swed", "쉘" => "swel", "쉙" => "swelg", "쉚" => "swelm", "쉛" => "swelb",
    "쉜" => "swels", "쉝" => "swelt", "쉞" => "swelp", "쉟" => "swelh", "쉠" => "swem", "쉡" => "sweb",
    "쉢" => "swebs", "쉣" => "swes", "쉤" => "swess", "쉥" => "sweng", "쉦" => "swej", "쉧" => "swec",
    "쉨" => "swek", "쉩" => "swet", "쉪" => "swep", "쉫" => "sweh", "쉬" => "swi", "쉭" => "swig",
    "쉮" => "swigg", "쉯" => "swigs", "쉰" => "swin", "쉱" => "swinj", "쉲" => "swinh", "쉳" => "swid",
    "쉴" => "swil", "쉵" => "swilg", "쉶" => "swilm", "쉷" => "swilb", "쉸" => "swils", "쉹" => "swilt",
    "쉺" => "swilp", "쉻" => "swilh", "쉼" => "swim", "쉽" => "swib", "쉾" => "swibs", "쉿" => "swis",
    "슀" => "swiss", "슁" => "swing", "슂" => "swij", "슃" => "swic", "슄" => "swik", "슅" => "swit",
    "슆" => "swip", "슇" => "swih", "슈" => "syu", "슉" => "syug", "슊" => "syugg", "슋" => "syugs",
    "슌" => "syun", "슍" => "syunj", "슎" => "syunh", "슏" => "syud", "슐" => "syul", "슑" => "syulg",
    "슒" => "syulm", "슓" => "syulb", "슔" => "syuls", "슕" => "syult", "슖" => "syulp", "슗" => "syulh",
    "슘" => "syum", "슙" => "syub", "슚" => "syubs", "슛" => "syus", "슜" => "syuss", "슝" => "syung",
    "슞" => "syuj", "슟" => "syuc", "슠" => "syuk", "슡" => "syut", "슢" => "syup", "슣" => "syuh",
    "스" => "seu", "슥" => "seug", "슦" => "seugg", "슧" => "seugs", "슨" => "seun", "슩" => "seunj",
    "슪" => "seunh", "슫" => "seud", "슬" => "seul", "슭" => "seulg", "슮" => "seulm", "슯" => "seulb",
    "슰" => "seuls", "슱" => "seult", "슲" => "seulp", "슳" => "seulh", "슴" => "seum", "습" => "seub",
    "슶" => "seubs", "슷" => "seus", "슸" => "seuss", "승" => "seung", "슺" => "seuj", "슻" => "seuc",
    "슼" => "seuk", "슽" => "seut", "슾" => "seup", "슿" => "seuh", "싀" => "syi", "싁" => "syig",
    "싂" => "syigg", "싃" => "syigs", "싄" => "syin", "싅" => "syinj", "싆" => "syinh", "싇" => "syid",
    "싈" => "syil", "싉" => "syilg", "싊" => "syilm", "싋" => "syilb", "싌" => "syils", "싍" => "syilt",
    "싎" => "syilp", "싏" => "syilh", "싐" => "syim", "싑" => "syib", "싒" => "syibs", "싓" => "syis",
    "싔" => "syiss", "싕" => "sying", "싖" => "syij", "싗" => "syic", "싘" => "syik", "싙" => "syit",
    "싚" => "syip", "싛" => "syih", "시" => "si", "식" => "sig", "싞" => "sigg", "싟" => "sigs",
    "신" => "sin", "싡" => "sinj", "싢" => "sinh", "싣" => "sid", "실" => "sil", "싥" => "silg",
    "싦" => "silm", "싧" => "silb", "싨" => "sils", "싩" => "silt", "싪" => "silp", "싫" => "silh",
    "심" => "sim", "십" => "sib", "싮" => "sibs", "싯" => "sis", "싰" => "siss", "싱" => "sing",
    "싲" => "sij", "싳" => "sic", "싴" => "sik", "싵" => "sit", "싶" => "sip", "싷" => "sih",
    "싸" => "ssa", "싹" => "ssag", "싺" => "ssagg", "싻" => "ssags", "싼" => "ssan", "싽" => "ssanj",
    "싾" => "ssanh", "싿" => "ssad", "쌁" => "ssalg", "쌂" => "ssalm", "쌃" => "ssalb", "쌄" => "ssals",
    "쌅" => "ssalt", "쌆" => "ssalp", "쌇" => "ssalh", "쌈" => "ssam", "쌉" => "ssab", "쌊" => "ssabs",
    "쌋" => "ssas", "쌌" => "ssass", "쌍" => "ssang", "쌎" => "ssaj", "쌏" => "ssac", "쌐" => "ssak",
    "쌑" => "ssat", "쌒" => "ssap", "쌓" => "ssah", "쌔" => "ssae", "쌕" => "ssaeg", "쌖" => "ssaegg",
    "쌗" => "ssaegs", "쌘" => "ssaen", "쌙" => "ssaenj", "쌚" => "ssaenh", "쌛" => "ssaed", "쌜" => "ssael",
    "쌝" => "ssaelg", "쌞" => "ssaelm", "쌟" => "ssaelb", "쌠" => "ssaels", "쌡" => "ssaelt", "쌢" => "ssaelp",
    "쌣" => "ssaelh", "쌤" => "ssaem", "쌥" => "ssaeb", "쌦" => "ssaebs", "쌧" => "ssaes", "쌨" => "ssaess",
    "쌩" => "ssaeng", "쌪" => "ssaej", "쌫" => "ssaec", "쌬" => "ssaek", "쌭" => "ssaet", "쌮" => "ssaep",
    "쌯" => "ssaeh", "쌰" => "ssya", "쌱" => "ssyag", "쌲" => "ssyagg", "쌳" => "ssyags", "쌴" => "ssyan",
    "쌵" => "ssyanj", "쌶" => "ssyanh", "쌷" => "ssyad", "쌸" => "ssyal", "쌹" => "ssyalg", "쌺" => "ssyalm",
    "쌻" => "ssyalb", "쌼" => "ssyals", "쌽" => "ssyalt", "쌾" => "ssyalp", "쌿" => "ssyalh", "썀" => "ssyam",
    "썁" => "ssyab", "썂" => "ssyabs", "썃" => "ssyas", "썄" => "ssyass", "썅" => "ssyang", "썆" => "ssyaj",
    "썇" => "ssyac", "썈" => "ssyak", "썉" => "ssyat", "썊" => "ssyap", "썋" => "ssyah", "썌" => "ssyae",
    "썍" => "ssyaeg", "썎" => "ssyaegg", "썏" => "ssyaegs", "썐" => "ssyaen", "썑" => "ssyaenj", "썒" => "ssyaenh",
    "썓" => "ssyaed", "썔" => "ssyael", "썕" => "ssyaelg", "썖" => "ssyaelm", "썗" => "ssyaelb", "썘" => "ssyaels",
    "썙" => "ssyaelt", "썚" => "ssyaelp", "썛" => "ssyaelh", "썜" => "ssyaem", "썝" => "ssyaeb", "썞" => "ssyaebs",
    "썟" => "ssyaes", "썠" => "ssyaess", "썡" => "ssyaeng", "썢" => "ssyaej", "썣" => "ssyaec", "썤" => "ssyaek",
    "썥" => "ssyaet", "썦" => "ssyaep", "썧" => "ssyaeh", "써" => "sseo", "썩" => "sseog", "썪" => "sseogg",
    "썫" => "sseogs", "썬" => "sseon", "썭" => "sseonj", "썮" => "sseonh", "썯" => "sseod", "썰" => "sseol",
    "썱" => "sseolg", "썲" => "sseolm", "썳" => "sseolb", "썴" => "sseols", "썵" => "sseolt", "썶" => "sseolp",
    "썷" => "sseolh", "썸" => "sseom", "썹" => "sseob", "썺" => "sseobs", "썻" => "sseos", "썼" => "sseoss",
    "썽" => "sseong", "썾" => "sseoj", "썿" => "sseoc", "쎀" => "sseok", "쎁" => "sseot", "쎂" => "sseop",
    "쎃" => "sseoh", "쎄" => "sse", "쎅" => "sseg", "쎆" => "ssegg", "쎇" => "ssegs", "쎈" => "ssen",
    "쎉" => "ssenj", "쎊" => "ssenh", "쎋" => "ssed", "쎌" => "ssel", "쎍" => "sselg", "쎎" => "sselm",
    "쎏" => "sselb", "쎐" => "ssels", "쎑" => "sselt", "쎒" => "sselp", "쎓" => "sselh", "쎔" => "ssem",
    "쎕" => "sseb", "쎖" => "ssebs", "쎗" => "sses", "쎘" => "ssess", "쎙" => "sseng", "쎚" => "ssej",
    "쎛" => "ssec", "쎜" => "ssek", "쎝" => "sset", "쎞" => "ssep", "쎟" => "sseh", "쎠" => "ssyeo",
    "쎡" => "ssyeog", "쎢" => "ssyeogg", "쎣" => "ssyeogs", "쎤" => "ssyeon", "쎥" => "ssyeonj", "쎦" => "ssyeonh",
    "쎧" => "ssyeod", "쎨" => "ssyeol", "쎩" => "ssyeolg", "쎪" => "ssyeolm", "쎫" => "ssyeolb", "쎬" => "ssyeols",
    "쎭" => "ssyeolt", "쎮" => "ssyeolp", "쎯" => "ssyeolh", "쎰" => "ssyeom", "쎱" => "ssyeob", "쎲" => "ssyeobs",
    "쎳" => "ssyeos", "쎴" => "ssyeoss", "쎵" => "ssyeong", "쎶" => "ssyeoj", "쎷" => "ssyeoc", "쎸" => "ssyeok",
    "쎹" => "ssyeot", "쎺" => "ssyeop", "쎻" => "ssyeoh", "쎼" => "ssye", "쎽" => "ssyeg", "쎾" => "ssyegg",
    "쎿" => "ssyegs", "쏀" => "ssyen", "쏁" => "ssyenj", "쏂" => "ssyenh", "쏃" => "ssyed", "쏄" => "ssyel",
    "쏅" => "ssyelg", "쏆" => "ssyelm", "쏇" => "ssyelb", "쏈" => "ssyels", "쏉" => "ssyelt", "쏊" => "ssyelp",
    "쏋" => "ssyelh", "쏌" => "ssyem", "쏍" => "ssyeb", "쏎" => "ssyebs", "쏏" => "ssyes", "쏐" => "ssyess",
    "쏑" => "ssyeng", "쏒" => "ssyej", "쏓" => "ssyec", "쏔" => "ssyek", "쏕" => "ssyet", "쏖" => "ssyep",
    "쏗" => "ssyeh", "쏘" => "sso", "쏙" => "ssog", "쏚" => "ssogg", "쏛" => "ssogs", "쏜" => "sson",
    "쏝" => "ssonj", "쏞" => "ssonh", "쏟" => "ssod", "쏠" => "ssol", "쏡" => "ssolg", "쏢" => "ssolm",
    "쏣" => "ssolb", "쏤" => "ssols", "쏥" => "ssolt", "쏦" => "ssolp", "쏧" => "ssolh", "쏨" => "ssom",
    "쏩" => "ssob", "쏪" => "ssobs", "쏫" => "ssos", "쏬" => "ssoss", "쏭" => "ssong", "쏮" => "ssoj",
    "쏯" => "ssoc", "쏰" => "ssok", "쏱" => "ssot", "쏲" => "ssop", "쏳" => "ssoh", "쏴" => "sswa",
    "쏵" => "sswag", "쏶" => "sswagg", "쏷" => "sswags", "쏸" => "sswan", "쏹" => "sswanj", "쏺" => "sswanh",
    "쏻" => "sswad", "쏼" => "sswal", "쏽" => "sswalg", "쏾" => "sswalm", "쏿" => "sswalb", "쐁" => "sswalt",
    "쐂" => "sswalp", "쐃" => "sswalh", "쐄" => "sswam", "쐅" => "sswab", "쐆" => "sswabs", "쐇" => "sswas",
    "쐈" => "sswass", "쐉" => "sswang", "쐊" => "sswaj", "쐋" => "sswac", "쐌" => "sswak", "쐍" => "sswat",
    "쐎" => "sswap", "쐏" => "sswah", "쐐" => "sswae", "쐑" => "sswaeg", "쐒" => "sswaegg", "쐓" => "sswaegs",
    "쐔" => "sswaen", "쐕" => "sswaenj", "쐖" => "sswaenh", "쐗" => "sswaed", "쐘" => "sswael", "쐙" => "sswaelg",
    "쐚" => "sswaelm", "쐛" => "sswaelb", "쐜" => "sswaels", "쐝" => "sswaelt", "쐞" => "sswaelp", "쐟" => "sswaelh",
    "쐠" => "sswaem", "쐡" => "sswaeb", "쐢" => "sswaebs", "쐣" => "sswaes", "쐤" => "sswaess", "쐥" => "sswaeng",
    "쐦" => "sswaej", "쐧" => "sswaec", "쐨" => "sswaek", "쐩" => "sswaet", "쐪" => "sswaep", "쐫" => "sswaeh",
    "쐬" => "ssoe", "쐭" => "ssoeg", "쐮" => "ssoegg", "쐯" => "ssoegs", "쐰" => "ssoen", "쐱" => "ssoenj",
    "쐲" => "ssoenh", "쐳" => "ssoed", "쐴" => "ssoel", "쐵" => "ssoelg", "쐶" => "ssoelm", "쐷" => "ssoelb",
    "쐸" => "ssoels", "쐹" => "ssoelt", "쐺" => "ssoelp", "쐻" => "ssoelh", "쐼" => "ssoem", "쐽" => "ssoeb",
    "쐾" => "ssoebs", "쐿" => "ssoes", "쑀" => "ssoess", "쑁" => "ssoeng", "쑂" => "ssoej", "쑃" => "ssoec",
    "쑄" => "ssoek", "쑅" => "ssoet", "쑆" => "ssoep", "쑇" => "ssoeh", "쑈" => "ssyo", "쑉" => "ssyog",
    "쑊" => "ssyogg", "쑋" => "ssyogs", "쑌" => "ssyon", "쑍" => "ssyonj", "쑎" => "ssyonh", "쑏" => "ssyod",
    "쑐" => "ssyol", "쑑" => "ssyolg", "쑒" => "ssyolm", "쑓" => "ssyolb", "쑔" => "ssyols", "쑕" => "ssyolt",
    "쑖" => "ssyolp", "쑗" => "ssyolh", "쑘" => "ssyom", "쑙" => "ssyob", "쑚" => "ssyobs", "쑛" => "ssyos",
    "쑜" => "ssyoss", "쑝" => "ssyong", "쑞" => "ssyoj", "쑟" => "ssyoc", "쑠" => "ssyok", "쑡" => "ssyot",
    "쑢" => "ssyop", "쑣" => "ssyoh", "쑤" => "ssu", "쑥" => "ssug", "쑦" => "ssugg", "쑧" => "ssugs",
    "쑨" => "ssun", "쑩" => "ssunj", "쑪" => "ssunh", "쑫" => "ssud", "쑬" => "ssul", "쑭" => "ssulg",
    "쑮" => "ssulm", "쑯" => "ssulb", "쑰" => "ssuls", "쑱" => "ssult", "쑲" => "ssulp", "쑳" => "ssulh",
    "쑴" => "ssum", "쑵" => "ssub", "쑶" => "ssubs", "쑷" => "ssus", "쑸" => "ssuss", "쑹" => "ssung",
    "쑺" => "ssuj", "쑻" => "ssuc", "쑼" => "ssuk", "쑽" => "ssut", "쑾" => "ssup", "쑿" => "ssuh",
    "쒀" => "ssweo", "쒁" => "ssweog", "쒂" => "ssweogg", "쒃" => "ssweogs", "쒄" => "ssweon", "쒅" => "ssweonj",
    "쒆" => "ssweonh", "쒇" => "ssweod", "쒈" => "ssweol", "쒉" => "ssweolg", "쒊" => "ssweolm", "쒋" => "ssweolb",
    "쒌" => "ssweols", "쒍" => "ssweolt", "쒎" => "ssweolp", "쒏" => "ssweolh", "쒐" => "ssweom", "쒑" => "ssweob",
    "쒒" => "ssweobs", "쒓" => "ssweos", "쒔" => "ssweoss", "쒕" => "ssweong", "쒖" => "ssweoj", "쒗" => "ssweoc",
    "쒘" => "ssweok", "쒙" => "ssweot", "쒚" => "ssweop", "쒛" => "ssweoh", "쒜" => "sswe", "쒝" => "ssweg",
    "쒞" => "sswegg", "쒟" => "sswegs", "쒠" => "sswen", "쒡" => "sswenj", "쒢" => "sswenh", "쒣" => "sswed",
    "쒤" => "sswel", "쒥" => "sswelg", "쒦" => "sswelm", "쒧" => "sswelb", "쒨" => "sswels", "쒩" => "sswelt",
    "쒪" => "sswelp", "쒫" => "sswelh", "쒬" => "sswem", "쒭" => "ssweb", "쒮" => "sswebs", "쒯" => "sswes",
    "쒰" => "sswess", "쒱" => "ssweng", "쒲" => "sswej", "쒳" => "sswec", "쒴" => "sswek", "쒵" => "sswet",
    "쒶" => "sswep", "쒷" => "ssweh", "쒸" => "sswi", "쒹" => "sswig", "쒺" => "sswigg", "쒻" => "sswigs",
    "쒼" => "sswin", "쒽" => "sswinj", "쒾" => "sswinh", "쒿" => "sswid", "쓀" => "sswil", "쓁" => "sswilg",
    "쓂" => "sswilm", "쓃" => "sswilb", "쓄" => "sswils", "쓅" => "sswilt", "쓆" => "sswilp", "쓇" => "sswilh",
    "쓈" => "sswim", "쓉" => "sswib", "쓊" => "sswibs", "쓋" => "sswis", "쓌" => "sswiss", "쓍" => "sswing",
    "쓎" => "sswij", "쓏" => "sswic", "쓐" => "sswik", "쓑" => "sswit", "쓒" => "sswip", "쓓" => "sswih",
    "쓔" => "ssyu", "쓕" => "ssyug", "쓖" => "ssyugg", "쓗" => "ssyugs", "쓘" => "ssyun", "쓙" => "ssyunj",
    "쓚" => "ssyunh", "쓛" => "ssyud", "쓜" => "ssyul", "쓝" => "ssyulg", "쓞" => "ssyulm", "쓟" => "ssyulb",
    "쓠" => "ssyuls", "쓡" => "ssyult", "쓢" => "ssyulp", "쓣" => "ssyulh", "쓤" => "ssyum", "쓥" => "ssyub",
    "쓦" => "ssyubs", "쓧" => "ssyus", "쓨" => "ssyuss", "쓩" => "ssyung", "쓪" => "ssyuj", "쓫" => "ssyuc",
    "쓬" => "ssyuk", "쓭" => "ssyut", "쓮" => "ssyup", "쓯" => "ssyuh", "쓰" => "sseu", "쓱" => "sseug",
    "쓲" => "sseugg", "쓳" => "sseugs", "쓴" => "sseun", "쓵" => "sseunj", "쓶" => "sseunh", "쓷" => "sseud",
    "쓸" => "sseul", "쓹" => "sseulg", "쓺" => "sseulm", "쓻" => "sseulb", "쓼" => "sseuls", "쓽" => "sseult",
    "쓾" => "sseulp", "쓿" => "sseulh", "씁" => "sseub", "씂" => "sseubs", "씃" => "sseus", "씄" => "sseuss",
    "씅" => "sseung", "씆" => "sseuj", "씇" => "sseuc", "씈" => "sseuk", "씉" => "sseut", "씊" => "sseup",
    "씋" => "sseuh", "씌" => "ssyi", "씍" => "ssyig", "씎" => "ssyigg", "씏" => "ssyigs", "씐" => "ssyin",
    "씑" => "ssyinj", "씒" => "ssyinh", "씓" => "ssyid", "씔" => "ssyil", "씕" => "ssyilg", "씖" => "ssyilm",
    "씗" => "ssyilb", "씘" => "ssyils", "씙" => "ssyilt", "씚" => "ssyilp", "씛" => "ssyilh", "씜" => "ssyim",
    "씝" => "ssyib", "씞" => "ssyibs", "씟" => "ssyis", "씠" => "ssyiss", "씡" => "ssying", "씢" => "ssyij",
    "씣" => "ssyic", "씤" => "ssyik", "씥" => "ssyit", "씦" => "ssyip", "씧" => "ssyih", "씨" => "ssi",
    "씩" => "ssig", "씪" => "ssigg", "씫" => "ssigs", "씬" => "ssin", "씭" => "ssinj", "씮" => "ssinh",
    "씯" => "ssid", "씰" => "ssil", "씱" => "ssilg", "씲" => "ssilm", "씳" => "ssilb", "씴" => "ssils",
    "씵" => "ssilt", "씶" => "ssilp", "씷" => "ssilh", "씸" => "ssim", "씹" => "ssib", "씺" => "ssibs",
    "씻" => "ssis", "씼" => "ssiss", "씽" => "ssing", "씾" => "ssij", "씿" => "ssic", "앀" => "ssik",
    "앁" => "ssit", "앂" => "ssip", "앃" => "ssih", "아" => "a", "악" => "ag", "앆" => "agg",
    "앇" => "ags", "안" => "an", "앉" => "anj", "않" => "anh", "앋" => "ad", "알" => "al",
    "앍" => "alg", "앎" => "alm", "앏" => "alb", "앐" => "als", "앑" => "alt", "앒" => "alp",
    "앓" => "alh", "암" => "am", "압" => "ab", "앖" => "abs", "앗" => "as", "았" => "ass",
    "앙" => "ang", "앚" => "aj", "앛" => "ac", "앜" => "ak", "앝" => "at", "앞" => "ap",
    "앟" => "ah", "애" => "ae", "액" => "aeg", "앢" => "aegg", "앣" => "aegs", "앤" => "aen",
    "앥" => "aenj", "앦" => "aenh", "앧" => "aed", "앨" => "ael", "앩" => "aelg", "앪" => "aelm",
    "앫" => "aelb", "앬" => "aels", "앭" => "aelt", "앮" => "aelp", "앯" => "aelh", "앰" => "aem",
    "앱" => "aeb", "앲" => "aebs", "앳" => "aes", "앴" => "aess", "앵" => "aeng", "앶" => "aej",
    "앷" => "aec", "앸" => "aek", "앹" => "aet", "앺" => "aep", "앻" => "aeh", "야" => "ya",
    "약" => "yag", "앾" => "yagg", "앿" => "yags", "얀" => "yan", "얁" => "yanj", "얂" => "yanh",
    "얃" => "yad", "얄" => "yal", "얅" => "yalg", "얆" => "yalm", "얇" => "yalb", "얈" => "yals",
    "얉" => "yalt", "얊" => "yalp", "얋" => "yalh", "얌" => "yam", "얍" => "yab", "얎" => "yabs",
    "얏" => "yas", "얐" => "yass", "양" => "yang", "얒" => "yaj", "얓" => "yac", "얔" => "yak",
    "얕" => "yat", "얖" => "yap", "얗" => "yah", "얘" => "yae", "얙" => "yaeg", "얚" => "yaegg",
    "얛" => "yaegs", "얜" => "yaen", "얝" => "yaenj", "얞" => "yaenh", "얟" => "yaed", "얠" => "yael",
    "얡" => "yaelg", "얢" => "yaelm", "얣" => "yaelb", "얤" => "yaels", "얥" => "yaelt", "얦" => "yaelp",
    "얧" => "yaelh", "얨" => "yaem", "얩" => "yaeb", "얪" => "yaebs", "얫" => "yaes", "얬" => "yaess",
    "얭" => "yaeng", "얮" => "yaej", "얯" => "yaec", "얰" => "yaek", "얱" => "yaet", "얲" => "yaep",
    "얳" => "yaeh", "어" => "eo", "억" => "eog", "얶" => "eogg", "얷" => "eogs", "언" => "eon",
    "얹" => "eonj", "얺" => "eonh", "얻" => "eod", "얼" => "eol", "얽" => "eolg", "얾" => "eolm",
    "얿" => "eolb", "엀" => "eols", "엁" => "eolt", "엂" => "eolp", "엃" => "eolh", "엄" => "eom",
    "업" => "eob", "없" => "eobs", "엇" => "eos", "었" => "eoss", "엉" => "eong", "엊" => "eoj",
    "엋" => "eoc", "엌" => "eok", "엍" => "eot", "엎" => "eop", "엏" => "eoh", "에" => "e",
    "엑" => "eg", "엒" => "egg", "엓" => "egs", "엔" => "en", "엕" => "enj", "엖" => "enh",
    "엗" => "ed", "엘" => "el", "엙" => "elg", "엚" => "elm", "엛" => "elb", "엜" => "els",
    "엝" => "elt", "엞" => "elp", "엟" => "elh", "엠" => "em", "엡" => "eb", "엢" => "ebs",
    "엣" => "es", "엤" => "ess", "엥" => "eng", "엦" => "ej", "엧" => "ec", "엨" => "ek",
    "엩" => "et", "엪" => "ep", "엫" => "eh", "여" => "yeo", "역" => "yeog", "엮" => "yeogg",
    "엯" => "yeogs", "연" => "yeon", "엱" => "yeonj", "엲" => "yeonh", "엳" => "yeod", "열" => "yeol",
    "엵" => "yeolg", "엶" => "yeolm", "엷" => "yeolb", "엸" => "yeols", "엹" => "yeolt", "엺" => "yeolp",
    "엻" => "yeolh", "염" => "yeom", "엽" => "yeob", "엾" => "yeobs", "엿" => "yeos", "영" => "yeong",
    "옂" => "yeoj", "옃" => "yeoc", "옄" => "yeok", "옅" => "yeot", "옆" => "yeop", "옇" => "yeoh",
    "예" => "ye", "옉" => "yeg", "옊" => "yegg", "옋" => "yegs", "옌" => "yen", "옍" => "yenj",
    "옎" => "yenh", "옏" => "yed", "옐" => "yel", "옑" => "yelg", "옒" => "yelm", "옓" => "yelb",
    "옔" => "yels", "옕" => "yelt", "옖" => "yelp", "옗" => "yelh", "옘" => "yem", "옙" => "yeb",
    "옚" => "yebs", "옛" => "yes", "옜" => "yess", "옝" => "yeng", "옞" => "yej", "옟" => "yec",
    "옠" => "yek", "옡" => "yet", "옢" => "yep", "옣" => "yeh", "오" => "o", "옥" => "og",
    "옦" => "ogg", "옧" => "ogs", "온" => "on", "옩" => "onj", "옪" => "onh", "옫" => "od",
    "올" => "ol", "옭" => "olg", "옮" => "olm", "옯" => "olb", "옰" => "ols", "옱" => "olt",
    "옲" => "olp", "옳" => "olh", "옴" => "om", "옵" => "ob", "옶" => "obs", "옷" => "os",
    "옸" => "oss", "옹" => "ong", "옺" => "oj", "옻" => "oc", "옼" => "ok", "옽" => "ot",
    "옾" => "op", "옿" => "oh", "와" => "wa", "왁" => "wag", "왂" => "wagg", "왃" => "wags",
    "완" => "wan", "왅" => "wanj", "왆" => "wanh", "왇" => "wad", "왈" => "wal", "왉" => "walg",
    "왊" => "walm", "왋" => "walb", "왌" => "wals", "왍" => "walt", "왎" => "walp", "왏" => "walh",
    "왐" => "wam", "왑" => "wab", "왒" => "wabs", "왓" => "was", "왔" => "wass", "왕" => "wang",
    "왖" => "waj", "왗" => "wac", "왘" => "wak", "왙" => "wat", "왚" => "wap", "왛" => "wah",
    "왜" => "wae", "왝" => "waeg", "왞" => "waegg", "왟" => "waegs", "왠" => "waen", "왡" => "waenj",
    "왢" => "waenh", "왣" => "waed", "왤" => "wael", "왥" => "waelg", "왦" => "waelm", "왧" => "waelb",
    "왨" => "waels", "왩" => "waelt", "왪" => "waelp", "왫" => "waelh", "왬" => "waem", "왭" => "waeb",
    "왮" => "waebs", "왯" => "waes", "왰" => "waess", "왱" => "waeng", "왲" => "waej", "왳" => "waec",
    "왴" => "waek", "왵" => "waet", "왶" => "waep", "왷" => "waeh", "외" => "oe", "왹" => "oeg",
    "왺" => "oegg", "왻" => "oegs", "왼" => "oen", "왽" => "oenj", "왾" => "oenh", "왿" => "oed",
    "욀" => "oel", "욁" => "oelg", "욂" => "oelm", "욃" => "oelb", "욄" => "oels", "욅" => "oelt",
    "욆" => "oelp", "욇" => "oelh", "욈" => "oem", "욉" => "oeb", "욊" => "oebs", "욋" => "oes",
    "욌" => "oess", "욍" => "oeng", "욎" => "oej", "욏" => "oec", "욐" => "oek", "욑" => "oet",
    "욒" => "oep", "욓" => "oeh", "요" => "yo", "욕" => "yog", "욖" => "yogg", "욗" => "yogs",
    "욘" => "yon", "욙" => "yonj", "욚" => "yonh", "욛" => "yod", "욜" => "yol", "욝" => "yolg",
    "욞" => "yolm", "욟" => "yolb", "욠" => "yols", "욡" => "yolt", "욢" => "yolp", "욣" => "yolh",
    "욤" => "yom", "욥" => "yob", "욦" => "yobs", "욧" => "yos", "욨" => "yoss", "용" => "yong",
    "욪" => "yoj", "욫" => "yoc", "욬" => "yok", "욭" => "yot", "욮" => "yop", "욯" => "yoh",
    "우" => "u", "욱" => "ug", "욲" => "ugg", "욳" => "ugs", "운" => "un", "욵" => "unj",
    "욶" => "unh", "욷" => "ud", "울" => "ul", "욹" => "ulg", "욺" => "ulm", "욻" => "ulb",
    "욼" => "uls", "욽" => "ult", "욾" => "ulp", "욿" => "ulh", "움" => "um", "웁" => "ub",
    "웂" => "ubs", "웃" => "us", "웄" => "uss", "웅" => "ung", "웆" => "uj", "웇" => "uc",
    "웈" => "uk", "웉" => "ut", "웊" => "up", "웋" => "uh", "워" => "weo", "웍" => "weog",
    "웎" => "weogg", "웏" => "weogs", "원" => "weon", "웑" => "weonj", "웒" => "weonh", "웓" => "weod",
    "월" => "weol", "웕" => "weolg", "웖" => "weolm", "웗" => "weolb", "웘" => "weols", "웙" => "weolt",
    "웚" => "weolp", "웛" => "weolh", "웜" => "weom", "웝" => "weob", "웞" => "weobs", "웟" => "weos",
    "웠" => "weoss", "웡" => "weong", "웢" => "weoj", "웣" => "weoc", "웤" => "weok", "웥" => "weot",
    "웦" => "weop", "웧" => "weoh", "웨" => "we", "웩" => "weg", "웪" => "wegg", "웫" => "wegs",
    "웬" => "wen", "웭" => "wenj", "웮" => "wenh", "웯" => "wed", "웰" => "wel", "웱" => "welg",
    "웲" => "welm", "웳" => "welb", "웴" => "wels", "웵" => "welt", "웶" => "welp", "웷" => "welh",
    "웸" => "wem", "웹" => "web", "웺" => "webs", "웻" => "wes", "웼" => "wess", "웽" => "weng",
    "웾" => "wej", "웿" => "wec", "윁" => "wet", "윂" => "wep", "윃" => "weh", "위" => "wi",
    "윅" => "wig", "윆" => "wigg", "윇" => "wigs", "윈" => "win", "윉" => "winj", "윊" => "winh",
    "윋" => "wid", "윌" => "wil", "윍" => "wilg", "윎" => "wilm", "윏" => "wilb", "윐" => "wils",
    "윑" => "wilt", "윒" => "wilp", "윓" => "wilh", "윔" => "wim", "윕" => "wib", "윖" => "wibs",
    "윗" => "wis", "윘" => "wiss", "윙" => "wing", "윚" => "wij", "윛" => "wic", "윜" => "wik",
    "윝" => "wit", "윞" => "wip", "윟" => "wih", "유" => "yu", "육" => "yug", "윢" => "yugg",
    "윣" => "yugs", "윤" => "yun", "윥" => "yunj", "윦" => "yunh", "윧" => "yud", "율" => "yul",
    "윩" => "yulg", "윪" => "yulm", "윫" => "yulb", "윬" => "yuls", "윭" => "yult", "윮" => "yulp",
    "윯" => "yulh", "윰" => "yum", "윱" => "yub", "윲" => "yubs", "윳" => "yus", "윴" => "yuss",
    "융" => "yung", "윶" => "yuj", "윷" => "yuc", "윸" => "yuk", "윹" => "yut", "윺" => "yup",
    "윻" => "yuh", "으" => "eu", "윽" => "eug", "윾" => "eugg", "윿" => "eugs", "은" => "eun",
    "읁" => "eunj", "읂" => "eunh", "읃" => "eud", "을" => "eul", "읅" => "eulg", "읆" => "eulm",
    "읇" => "eulb", "읈" => "euls", "읉" => "eult", "읊" => "eulp", "읋" => "eulh", "음" => "eum",
    "읍" => "eub", "읎" => "eubs", "읏" => "eus", "읐" => "euss", "응" => "eung", "읒" => "euj",
    "읓" => "euc", "읔" => "euk", "읕" => "eut", "읖" => "eup", "읗" => "euh", "의" => "yi",
    "읙" => "yig", "읚" => "yigg", "읛" => "yigs", "읜" => "yin", "읝" => "yinj", "읞" => "yinh",
    "읟" => "yid", "읠" => "yil", "읡" => "yilg", "읢" => "yilm", "읣" => "yilb", "읤" => "yils",
    "읥" => "yilt", "읦" => "yilp", "읧" => "yilh", "읨" => "yim", "읩" => "yib", "읪" => "yibs",
    "읫" => "yis", "읬" => "yiss", "읭" => "ying", "읮" => "yij", "읯" => "yic", "읰" => "yik",
    "읱" => "yit", "읲" => "yip", "읳" => "yih", "이" => "i", "익" => "ig", "읶" => "igg",
    "읷" => "igs", "인" => "in", "읹" => "inj", "읺" => "inh", "읻" => "id", "일" => "il",
    "읽" => "ilg", "읾" => "ilm", "읿" => "ilb", "잀" => "ils", "잁" => "ilt", "잂" => "ilp",
    "잃" => "ilh", "임" => "im", "입" => "ib", "잆" => "ibs", "잇" => "is", "있" => "iss",
    "잉" => "ing", "잊" => "ij", "잋" => "ic", "잌" => "ik", "잍" => "it", "잎" => "ip",
    "잏" => "ih", "자" => "ja", "작" => "jag", "잒" => "jagg", "잓" => "jags", "잔" => "jan",
    "잕" => "janj", "잖" => "janh", "잗" => "jad", "잘" => "jal", "잙" => "jalg", "잚" => "jalm",
    "잛" => "jalb", "잜" => "jals", "잝" => "jalt", "잞" => "jalp", "잟" => "jalh", "잠" => "jam",
    "잡" => "jab", "잢" => "jabs", "잣" => "jas", "잤" => "jass", "장" => "jang", "잦" => "jaj",
    "잧" => "jac", "잨" => "jak", "잩" => "jat", "잪" => "jap", "잫" => "jah", "재" => "jae",
    "잭" => "jaeg", "잮" => "jaegg", "잯" => "jaegs", "잰" => "jaen", "잱" => "jaenj", "잲" => "jaenh",
    "잳" => "jaed", "잴" => "jael", "잵" => "jaelg", "잶" => "jaelm", "잷" => "jaelb", "잸" => "jaels",
    "잹" => "jaelt", "잺" => "jaelp", "잻" => "jaelh", "잼" => "jaem", "잽" => "jaeb", "잾" => "jaebs",
    "잿" => "jaes", "쟀" => "jaess", "쟁" => "jaeng", "쟂" => "jaej", "쟃" => "jaec", "쟄" => "jaek",
    "쟅" => "jaet", "쟆" => "jaep", "쟇" => "jaeh", "쟈" => "jya", "쟉" => "jyag", "쟊" => "jyagg",
    "쟋" => "jyags", "쟌" => "jyan", "쟍" => "jyanj", "쟎" => "jyanh", "쟏" => "jyad", "쟐" => "jyal",
    "쟑" => "jyalg", "쟒" => "jyalm", "쟓" => "jyalb", "쟔" => "jyals", "쟕" => "jyalt", "쟖" => "jyalp",
    "쟗" => "jyalh", "쟘" => "jyam", "쟙" => "jyab", "쟚" => "jyabs", "쟛" => "jyas", "쟜" => "jyass",
    "쟝" => "jyang", "쟞" => "jyaj", "쟟" => "jyac", "쟠" => "jyak", "쟡" => "jyat", "쟢" => "jyap",
    "쟣" => "jyah", "쟤" => "jyae", "쟥" => "jyaeg", "쟦" => "jyaegg", "쟧" => "jyaegs", "쟨" => "jyaen",
    "쟩" => "jyaenj", "쟪" => "jyaenh", "쟫" => "jyaed", "쟬" => "jyael", "쟭" => "jyaelg", "쟮" => "jyaelm",
    "쟯" => "jyaelb", "쟰" => "jyaels", "쟱" => "jyaelt", "쟲" => "jyaelp", "쟳" => "jyaelh", "쟴" => "jyaem",
    "쟵" => "jyaeb", "쟶" => "jyaebs", "쟷" => "jyaes", "쟸" => "jyaess", "쟹" => "jyaeng", "쟺" => "jyaej",
    "쟻" => "jyaec", "쟼" => "jyaek", "쟽" => "jyaet", "쟾" => "jyaep", "쟿" => "jyaeh", "적" => "jeog",
    "젂" => "jeogg", "젃" => "jeogs", "전" => "jeon", "젅" => "jeonj", "젆" => "jeonh", "젇" => "jeod",
    "절" => "jeol", "젉" => "jeolg", "젊" => "jeolm", "젋" => "jeolb", "젌" => "jeols", "젍" => "jeolt",
    "젎" => "jeolp", "젏" => "jeolh", "점" => "jeom", "접" => "jeob", "젒" => "jeobs", "젓" => "jeos",
    "젔" => "jeoss", "정" => "jeong", "젖" => "jeoj", "젗" => "jeoc", "젘" => "jeok", "젙" => "jeot",
    "젚" => "jeop", "젛" => "jeoh", "제" => "je", "젝" => "jeg", "젞" => "jegg", "젟" => "jegs",
    "젠" => "jen", "젡" => "jenj", "젢" => "jenh", "젣" => "jed", "젤" => "jel", "젥" => "jelg",
    "젦" => "jelm", "젧" => "jelb", "젨" => "jels", "젩" => "jelt", "젪" => "jelp", "젫" => "jelh",
    "젬" => "jem", "젭" => "jeb", "젮" => "jebs", "젯" => "jes", "젰" => "jess", "젱" => "jeng",
    "젲" => "jej", "젳" => "jec", "젴" => "jek", "젵" => "jet", "젶" => "jep", "젷" => "jeh",
    "져" => "jyeo", "젹" => "jyeog", "젺" => "jyeogg", "젻" => "jyeogs", "젼" => "jyeon", "젽" => "jyeonj",
    "젾" => "jyeonh", "젿" => "jyeod", "졀" => "jyeol", "졁" => "jyeolg", "졂" => "jyeolm", "졃" => "jyeolb",
    "졄" => "jyeols", "졅" => "jyeolt", "졆" => "jyeolp", "졇" => "jyeolh", "졈" => "jyeom", "졉" => "jyeob",
    "졊" => "jyeobs", "졋" => "jyeos", "졌" => "jyeoss", "졍" => "jyeong", "졎" => "jyeoj", "졏" => "jyeoc",
    "졐" => "jyeok", "졑" => "jyeot", "졒" => "jyeop", "졓" => "jyeoh", "졔" => "jye", "졕" => "jyeg",
    "졖" => "jyegg", "졗" => "jyegs", "졘" => "jyen", "졙" => "jyenj", "졚" => "jyenh", "졛" => "jyed",
    "졜" => "jyel", "졝" => "jyelg", "졞" => "jyelm", "졟" => "jyelb", "졠" => "jyels", "졡" => "jyelt",
    "졢" => "jyelp", "졣" => "jyelh", "졤" => "jyem", "졥" => "jyeb", "졦" => "jyebs", "졧" => "jyes",
    "졨" => "jyess", "졩" => "jyeng", "졪" => "jyej", "졫" => "jyec", "졬" => "jyek", "졭" => "jyet",
    "졮" => "jyep", "졯" => "jyeh", "조" => "jo", "족" => "jog", "졲" => "jogg", "졳" => "jogs",
    "존" => "jon", "졵" => "jonj", "졶" => "jonh", "졷" => "jod", "졸" => "jol", "졹" => "jolg",
    "졺" => "jolm", "졻" => "jolb", "졼" => "jols", "졽" => "jolt", "졾" => "jolp", "졿" => "jolh",
    "좀" => "jom", "좁" => "job", "좂" => "jobs", "좃" => "jos", "좄" => "joss", "종" => "jong",
    "좆" => "joj", "좇" => "joc", "좈" => "jok", "좉" => "jot", "좊" => "jop", "좋" => "joh",
    "좌" => "jwa", "좍" => "jwag", "좎" => "jwagg", "좏" => "jwags", "좐" => "jwan", "좑" => "jwanj",
    "좒" => "jwanh", "좓" => "jwad", "좔" => "jwal", "좕" => "jwalg", "좖" => "jwalm", "좗" => "jwalb",
    "좘" => "jwals", "좙" => "jwalt", "좚" => "jwalp", "좛" => "jwalh", "좜" => "jwam", "좝" => "jwab",
    "좞" => "jwabs", "좟" => "jwas", "좠" => "jwass", "좡" => "jwang", "좢" => "jwaj", "좣" => "jwac",
    "좤" => "jwak", "좥" => "jwat", "좦" => "jwap", "좧" => "jwah", "좨" => "jwae", "좩" => "jwaeg",
    "좪" => "jwaegg", "좫" => "jwaegs", "좬" => "jwaen", "좭" => "jwaenj", "좮" => "jwaenh", "좯" => "jwaed",
    "좰" => "jwael", "좱" => "jwaelg", "좲" => "jwaelm", "좳" => "jwaelb", "좴" => "jwaels", "좵" => "jwaelt",
    "좶" => "jwaelp", "좷" => "jwaelh", "좸" => "jwaem", "좹" => "jwaeb", "좺" => "jwaebs", "좻" => "jwaes",
    "좼" => "jwaess", "좽" => "jwaeng", "좾" => "jwaej", "좿" => "jwaec", "죀" => "jwaek", "죁" => "jwaet",
    "죂" => "jwaep", "죃" => "jwaeh", "죄" => "joe", "죅" => "joeg", "죆" => "joegg", "죇" => "joegs",
    "죈" => "joen", "죉" => "joenj", "죊" => "joenh", "죋" => "joed", "죌" => "joel", "죍" => "joelg",
    "죎" => "joelm", "죏" => "joelb", "죐" => "joels", "죑" => "joelt", "죒" => "joelp", "죓" => "joelh",
    "죔" => "joem", "죕" => "joeb", "죖" => "joebs", "죗" => "joes", "죘" => "joess", "죙" => "joeng",
    "죚" => "joej", "죛" => "joec", "죜" => "joek", "죝" => "joet", "죞" => "joep", "죟" => "joeh",
    "죠" => "jyo", "죡" => "jyog", "죢" => "jyogg", "죣" => "jyogs", "죤" => "jyon", "죥" => "jyonj",
    "죦" => "jyonh", "죧" => "jyod", "죨" => "jyol", "죩" => "jyolg", "죪" => "jyolm", "죫" => "jyolb",
    "죬" => "jyols", "죭" => "jyolt", "죮" => "jyolp", "죯" => "jyolh", "죰" => "jyom", "죱" => "jyob",
    "죲" => "jyobs", "죳" => "jyos", "죴" => "jyoss", "죵" => "jyong", "죶" => "jyoj", "죷" => "jyoc",
    "죸" => "jyok", "죹" => "jyot", "죺" => "jyop", "죻" => "jyoh", "주" => "ju", "죽" => "jug",
    "죾" => "jugg", "죿" => "jugs", "줁" => "junj", "줂" => "junh", "줃" => "jud", "줄" => "jul",
    "줅" => "julg", "줆" => "julm", "줇" => "julb", "줈" => "juls", "줉" => "jult", "줊" => "julp",
    "줋" => "julh", "줌" => "jum", "줍" => "jub", "줎" => "jubs", "줏" => "jus", "줐" => "juss",
    "중" => "jung", "줒" => "juj", "줓" => "juc", "줔" => "juk", "줕" => "jut", "줖" => "jup",
    "줗" => "juh", "줘" => "jweo", "줙" => "jweog", "줚" => "jweogg", "줛" => "jweogs", "줜" => "jweon",
    "줝" => "jweonj", "줞" => "jweonh", "줟" => "jweod", "줠" => "jweol", "줡" => "jweolg", "줢" => "jweolm",
    "줣" => "jweolb", "줤" => "jweols", "줥" => "jweolt", "줦" => "jweolp", "줧" => "jweolh", "줨" => "jweom",
    "줩" => "jweob", "줪" => "jweobs", "줫" => "jweos", "줬" => "jweoss", "줭" => "jweong", "줮" => "jweoj",
    "줯" => "jweoc", "줰" => "jweok", "줱" => "jweot", "줲" => "jweop", "줳" => "jweoh", "줴" => "jwe",
    "줵" => "jweg", "줶" => "jwegg", "줷" => "jwegs", "줸" => "jwen", "줹" => "jwenj", "줺" => "jwenh",
    "줻" => "jwed", "줼" => "jwel", "줽" => "jwelg", "줾" => "jwelm", "줿" => "jwelb", "쥀" => "jwels",
    "쥁" => "jwelt", "쥂" => "jwelp", "쥃" => "jwelh", "쥄" => "jwem", "쥅" => "jweb", "쥆" => "jwebs",
    "쥇" => "jwes", "쥈" => "jwess", "쥉" => "jweng", "쥊" => "jwej", "쥋" => "jwec", "쥌" => "jwek",
    "쥍" => "jwet", "쥎" => "jwep", "쥏" => "jweh", "쥐" => "jwi", "쥑" => "jwig", "쥒" => "jwigg",
    "쥓" => "jwigs", "쥔" => "jwin", "쥕" => "jwinj", "쥖" => "jwinh", "쥗" => "jwid", "쥘" => "jwil",
    "쥙" => "jwilg", "쥚" => "jwilm", "쥛" => "jwilb", "쥜" => "jwils", "쥝" => "jwilt", "쥞" => "jwilp",
    "쥟" => "jwilh", "쥠" => "jwim", "쥡" => "jwib", "쥢" => "jwibs", "쥣" => "jwis", "쥤" => "jwiss",
    "쥥" => "jwing", "쥦" => "jwij", "쥧" => "jwic", "쥨" => "jwik", "쥩" => "jwit", "쥪" => "jwip",
    "쥫" => "jwih", "쥬" => "jyu", "쥭" => "jyug", "쥮" => "jyugg", "쥯" => "jyugs", "쥰" => "jyun",
    "쥱" => "jyunj", "쥲" => "jyunh", "쥳" => "jyud", "쥴" => "jyul", "쥵" => "jyulg", "쥶" => "jyulm",
    "쥷" => "jyulb", "쥸" => "jyuls", "쥹" => "jyult", "쥺" => "jyulp", "쥻" => "jyulh", "쥼" => "jyum",
    "쥽" => "jyub", "쥾" => "jyubs", "쥿" => "jyus", "즀" => "jyuss", "즁" => "jyung", "즂" => "jyuj",
    "즃" => "jyuc", "즄" => "jyuk", "즅" => "jyut", "즆" => "jyup", "즇" => "jyuh", "즈" => "jeu",
    "즉" => "jeug", "즊" => "jeugg", "즋" => "jeugs", "즌" => "jeun", "즍" => "jeunj", "즎" => "jeunh",
    "즏" => "jeud", "즐" => "jeul", "즑" => "jeulg", "즒" => "jeulm", "즓" => "jeulb", "즔" => "jeuls",
    "즕" => "jeult", "즖" => "jeulp", "즗" => "jeulh", "즘" => "jeum", "즙" => "jeub", "즚" => "jeubs",
    "즛" => "jeus", "즜" => "jeuss", "증" => "jeung", "즞" => "jeuj", "즟" => "jeuc", "즠" => "jeuk",
    "즡" => "jeut", "즢" => "jeup", "즣" => "jeuh", "즤" => "jyi", "즥" => "jyig", "즦" => "jyigg",
    "즧" => "jyigs", "즨" => "jyin", "즩" => "jyinj", "즪" => "jyinh", "즫" => "jyid", "즬" => "jyil",
    "즭" => "jyilg", "즮" => "jyilm", "즯" => "jyilb", "즰" => "jyils", "즱" => "jyilt", "즲" => "jyilp",
    "즳" => "jyilh", "즴" => "jyim", "즵" => "jyib", "즶" => "jyibs", "즷" => "jyis", "즸" => "jyiss",
    "즹" => "jying", "즺" => "jyij", "즻" => "jyic", "즼" => "jyik", "즽" => "jyit", "즾" => "jyip",
    "즿" => "jyih", "지" => "ji", "직" => "jig", "짂" => "jigg", "짃" => "jigs", "진" => "jin",
    "짅" => "jinj", "짆" => "jinh", "짇" => "jid", "질" => "jil", "짉" => "jilg", "짊" => "jilm",
    "짋" => "jilb", "짌" => "jils", "짍" => "jilt", "짎" => "jilp", "짏" => "jilh", "짐" => "jim",
    "집" => "jib", "짒" => "jibs", "짓" => "jis", "짔" => "jiss", "징" => "jing", "짖" => "jij",
    "짗" => "jic", "짘" => "jik", "짙" => "jit", "짚" => "jip", "짛" => "jih", "짜" => "jja",
    "짝" => "jjag", "짞" => "jjagg", "짟" => "jjags", "짠" => "jjan", "짡" => "jjanj", "짢" => "jjanh",
    "짣" => "jjad", "짤" => "jjal", "짥" => "jjalg", "짦" => "jjalm", "짧" => "jjalb", "짨" => "jjals",
    "짩" => "jjalt", "짪" => "jjalp", "짫" => "jjalh", "짬" => "jjam", "짭" => "jjab", "짮" => "jjabs",
    "짯" => "jjas", "짰" => "jjass", "짱" => "jjang", "짲" => "jjaj", "짳" => "jjac", "짴" => "jjak",
    "짵" => "jjat", "짶" => "jjap", "짷" => "jjah", "째" => "jjae", "짹" => "jjaeg", "짺" => "jjaegg",
    "짻" => "jjaegs", "짼" => "jjaen", "짽" => "jjaenj", "짾" => "jjaenh", "짿" => "jjaed", "쨁" => "jjaelg",
    "쨂" => "jjaelm", "쨃" => "jjaelb", "쨄" => "jjaels", "쨅" => "jjaelt", "쨆" => "jjaelp", "쨇" => "jjaelh",
    "쨈" => "jjaem", "쨉" => "jjaeb", "쨊" => "jjaebs", "쨋" => "jjaes", "쨌" => "jjaess", "쨍" => "jjaeng",
    "쨎" => "jjaej", "쨏" => "jjaec", "쨐" => "jjaek", "쨑" => "jjaet", "쨒" => "jjaep", "쨓" => "jjaeh",
    "쨔" => "jjya", "쨕" => "jjyag", "쨖" => "jjyagg", "쨗" => "jjyags", "쨘" => "jjyan", "쨙" => "jjyanj",
    "쨚" => "jjyanh", "쨛" => "jjyad", "쨜" => "jjyal", "쨝" => "jjyalg", "쨞" => "jjyalm", "쨟" => "jjyalb",
    "쨠" => "jjyals", "쨡" => "jjyalt", "쨢" => "jjyalp", "쨣" => "jjyalh", "쨤" => "jjyam", "쨥" => "jjyab",
    "쨦" => "jjyabs", "쨧" => "jjyas", "쨨" => "jjyass", "쨩" => "jjyang", "쨪" => "jjyaj", "쨫" => "jjyac",
    "쨬" => "jjyak", "쨭" => "jjyat", "쨮" => "jjyap", "쨯" => "jjyah", "쨰" => "jjyae", "쨱" => "jjyaeg",
    "쨲" => "jjyaegg", "쨳" => "jjyaegs", "쨴" => "jjyaen", "쨵" => "jjyaenj", "쨶" => "jjyaenh", "쨷" => "jjyaed",
    "쨸" => "jjyael", "쨹" => "jjyaelg", "쨺" => "jjyaelm", "쨻" => "jjyaelb", "쨼" => "jjyaels", "쨽" => "jjyaelt",
    "쨾" => "jjyaelp", "쨿" => "jjyaelh", "쩀" => "jjyaem", "쩁" => "jjyaeb", "쩂" => "jjyaebs", "쩃" => "jjyaes",
    "쩄" => "jjyaess", "쩅" => "jjyaeng", "쩆" => "jjyaej", "쩇" => "jjyaec", "쩈" => "jjyaek", "쩉" => "jjyaet",
    "쩊" => "jjyaep", "쩋" => "jjyaeh", "쩌" => "jjeo", "쩍" => "jjeog", "쩎" => "jjeogg", "쩏" => "jjeogs",
    "쩐" => "jjeon", "쩑" => "jjeonj", "쩒" => "jjeonh", "쩓" => "jjeod", "쩔" => "jjeol", "쩕" => "jjeolg",
    "쩖" => "jjeolm", "쩗" => "jjeolb", "쩘" => "jjeols", "쩙" => "jjeolt", "쩚" => "jjeolp", "쩛" => "jjeolh",
    "쩜" => "jjeom", "쩝" => "jjeob", "쩞" => "jjeobs", "쩟" => "jjeos", "쩠" => "jjeoss", "쩡" => "jjeong",
    "쩢" => "jjeoj", "쩣" => "jjeoc", "쩤" => "jjeok", "쩥" => "jjeot", "쩦" => "jjeop", "쩧" => "jjeoh",
    "쩨" => "jje", "쩩" => "jjeg", "쩪" => "jjegg", "쩫" => "jjegs", "쩬" => "jjen", "쩭" => "jjenj",
    "쩮" => "jjenh", "쩯" => "jjed", "쩰" => "jjel", "쩱" => "jjelg", "쩲" => "jjelm", "쩳" => "jjelb",
    "쩴" => "jjels", "쩵" => "jjelt", "쩶" => "jjelp", "쩷" => "jjelh", "쩸" => "jjem", "쩹" => "jjeb",
    "쩺" => "jjebs", "쩻" => "jjes", "쩼" => "jjess", "쩽" => "jjeng", "쩾" => "jjej", "쩿" => "jjec",
    "쪀" => "jjek", "쪁" => "jjet", "쪂" => "jjep", "쪃" => "jjeh", "쪄" => "jjyeo", "쪅" => "jjyeog",
    "쪆" => "jjyeogg", "쪇" => "jjyeogs", "쪈" => "jjyeon", "쪉" => "jjyeonj", "쪊" => "jjyeonh", "쪋" => "jjyeod",
    "쪌" => "jjyeol", "쪍" => "jjyeolg", "쪎" => "jjyeolm", "쪏" => "jjyeolb", "쪐" => "jjyeols", "쪑" => "jjyeolt",
    "쪒" => "jjyeolp", "쪓" => "jjyeolh", "쪔" => "jjyeom", "쪕" => "jjyeob", "쪖" => "jjyeobs", "쪗" => "jjyeos",
    "쪘" => "jjyeoss", "쪙" => "jjyeong", "쪚" => "jjyeoj", "쪛" => "jjyeoc", "쪜" => "jjyeok", "쪝" => "jjyeot",
    "쪞" => "jjyeop", "쪟" => "jjyeoh", "쪠" => "jjye", "쪡" => "jjyeg", "쪢" => "jjyegg", "쪣" => "jjyegs",
    "쪤" => "jjyen", "쪥" => "jjyenj", "쪦" => "jjyenh", "쪧" => "jjyed", "쪨" => "jjyel", "쪩" => "jjyelg",
    "쪪" => "jjyelm", "쪫" => "jjyelb", "쪬" => "jjyels", "쪭" => "jjyelt", "쪮" => "jjyelp", "쪯" => "jjyelh",
    "쪰" => "jjyem", "쪱" => "jjyeb", "쪲" => "jjyebs", "쪳" => "jjyes", "쪴" => "jjyess", "쪵" => "jjyeng",
    "쪶" => "jjyej", "쪷" => "jjyec", "쪸" => "jjyek", "쪹" => "jjyet", "쪺" => "jjyep", "쪻" => "jjyeh",
    "쪼" => "jjo", "쪽" => "jjog", "쪾" => "jjogg", "쪿" => "jjogs", "쫀" => "jjon", "쫁" => "jjonj",
    "쫂" => "jjonh", "쫃" => "jjod", "쫄" => "jjol", "쫅" => "jjolg", "쫆" => "jjolm", "쫇" => "jjolb",
    "쫈" => "jjols", "쫉" => "jjolt", "쫊" => "jjolp", "쫋" => "jjolh", "쫌" => "jjom", "쫍" => "jjob",
    "쫎" => "jjobs", "쫏" => "jjos", "쫐" => "jjoss", "쫑" => "jjong", "쫒" => "jjoj", "쫓" => "jjoc",
    "쫔" => "jjok", "쫕" => "jjot", "쫖" => "jjop", "쫗" => "jjoh", "쫘" => "jjwa", "쫙" => "jjwag",
    "쫚" => "jjwagg", "쫛" => "jjwags", "쫜" => "jjwan", "쫝" => "jjwanj", "쫞" => "jjwanh", "쫟" => "jjwad",
    "쫠" => "jjwal", "쫡" => "jjwalg", "쫢" => "jjwalm", "쫣" => "jjwalb", "쫤" => "jjwals", "쫥" => "jjwalt",
    "쫦" => "jjwalp", "쫧" => "jjwalh", "쫨" => "jjwam", "쫩" => "jjwab", "쫪" => "jjwabs", "쫫" => "jjwas",
    "쫬" => "jjwass", "쫭" => "jjwang", "쫮" => "jjwaj", "쫯" => "jjwac", "쫰" => "jjwak", "쫱" => "jjwat",
    "쫲" => "jjwap", "쫳" => "jjwah", "쫴" => "jjwae", "쫵" => "jjwaeg", "쫶" => "jjwaegg", "쫷" => "jjwaegs",
    "쫸" => "jjwaen", "쫹" => "jjwaenj", "쫺" => "jjwaenh", "쫻" => "jjwaed", "쫼" => "jjwael", "쫽" => "jjwaelg",
    "쫾" => "jjwaelm", "쫿" => "jjwaelb", "쬁" => "jjwaelt", "쬂" => "jjwaelp", "쬃" => "jjwaelh", "쬄" => "jjwaem",
    "쬅" => "jjwaeb", "쬆" => "jjwaebs", "쬇" => "jjwaes", "쬈" => "jjwaess", "쬉" => "jjwaeng", "쬊" => "jjwaej",
    "쬋" => "jjwaec", "쬌" => "jjwaek", "쬍" => "jjwaet", "쬎" => "jjwaep", "쬏" => "jjwaeh", "쬐" => "jjoe",
    "쬑" => "jjoeg", "쬒" => "jjoegg", "쬓" => "jjoegs", "쬔" => "jjoen", "쬕" => "jjoenj", "쬖" => "jjoenh",
    "쬗" => "jjoed", "쬘" => "jjoel", "쬙" => "jjoelg", "쬚" => "jjoelm", "쬛" => "jjoelb", "쬜" => "jjoels",
    "쬝" => "jjoelt", "쬞" => "jjoelp", "쬟" => "jjoelh", "쬠" => "jjoem", "쬡" => "jjoeb", "쬢" => "jjoebs",
    "쬣" => "jjoes", "쬤" => "jjoess", "쬥" => "jjoeng", "쬦" => "jjoej", "쬧" => "jjoec", "쬨" => "jjoek",
    "쬩" => "jjoet", "쬪" => "jjoep", "쬫" => "jjoeh", "쬬" => "jjyo", "쬭" => "jjyog", "쬮" => "jjyogg",
    "쬯" => "jjyogs", "쬰" => "jjyon", "쬱" => "jjyonj", "쬲" => "jjyonh", "쬳" => "jjyod", "쬴" => "jjyol",
    "쬵" => "jjyolg", "쬶" => "jjyolm", "쬷" => "jjyolb", "쬸" => "jjyols", "쬹" => "jjyolt", "쬺" => "jjyolp",
    "쬻" => "jjyolh", "쬼" => "jjyom", "쬽" => "jjyob", "쬾" => "jjyobs", "쬿" => "jjyos", "쭀" => "jjyoss",
    "쭁" => "jjyong", "쭂" => "jjyoj", "쭃" => "jjyoc", "쭄" => "jjyok", "쭅" => "jjyot", "쭆" => "jjyop",
    "쭇" => "jjyoh", "쭈" => "jju", "쭉" => "jjug", "쭊" => "jjugg", "쭋" => "jjugs", "쭌" => "jjun",
    "쭍" => "jjunj", "쭎" => "jjunh", "쭏" => "jjud", "쭐" => "jjul", "쭑" => "jjulg", "쭒" => "jjulm",
    "쭓" => "jjulb", "쭔" => "jjuls", "쭕" => "jjult", "쭖" => "jjulp", "쭗" => "jjulh", "쭘" => "jjum",
    "쭙" => "jjub", "쭚" => "jjubs", "쭛" => "jjus", "쭜" => "jjuss", "쭝" => "jjung", "쭞" => "jjuj",
    "쭟" => "jjuc", "쭠" => "jjuk", "쭡" => "jjut", "쭢" => "jjup", "쭣" => "jjuh", "쭤" => "jjweo",
    "쭥" => "jjweog", "쭦" => "jjweogg", "쭧" => "jjweogs", "쭨" => "jjweon", "쭩" => "jjweonj", "쭪" => "jjweonh",
    "쭫" => "jjweod", "쭬" => "jjweol", "쭭" => "jjweolg", "쭮" => "jjweolm", "쭯" => "jjweolb", "쭰" => "jjweols",
    "쭱" => "jjweolt", "쭲" => "jjweolp", "쭳" => "jjweolh", "쭴" => "jjweom", "쭵" => "jjweob", "쭶" => "jjweobs",
    "쭷" => "jjweos", "쭸" => "jjweoss", "쭹" => "jjweong", "쭺" => "jjweoj", "쭻" => "jjweoc", "쭼" => "jjweok",
    "쭽" => "jjweot", "쭾" => "jjweop", "쭿" => "jjweoh", "쮀" => "jjwe", "쮁" => "jjweg", "쮂" => "jjwegg",
    "쮃" => "jjwegs", "쮄" => "jjwen", "쮅" => "jjwenj", "쮆" => "jjwenh", "쮇" => "jjwed", "쮈" => "jjwel",
    "쮉" => "jjwelg", "쮊" => "jjwelm", "쮋" => "jjwelb", "쮌" => "jjwels", "쮍" => "jjwelt", "쮎" => "jjwelp",
    "쮏" => "jjwelh", "쮐" => "jjwem", "쮑" => "jjweb", "쮒" => "jjwebs", "쮓" => "jjwes", "쮔" => "jjwess",
    "쮕" => "jjweng", "쮖" => "jjwej", "쮗" => "jjwec", "쮘" => "jjwek", "쮙" => "jjwet", "쮚" => "jjwep",
    "쮛" => "jjweh", "쮜" => "jjwi", "쮝" => "jjwig", "쮞" => "jjwigg", "쮟" => "jjwigs", "쮠" => "jjwin",
    "쮡" => "jjwinj", "쮢" => "jjwinh", "쮣" => "jjwid", "쮤" => "jjwil", "쮥" => "jjwilg", "쮦" => "jjwilm",
    "쮧" => "jjwilb", "쮨" => "jjwils", "쮩" => "jjwilt", "쮪" => "jjwilp", "쮫" => "jjwilh", "쮬" => "jjwim",
    "쮭" => "jjwib", "쮮" => "jjwibs", "쮯" => "jjwis", "쮰" => "jjwiss", "쮱" => "jjwing", "쮲" => "jjwij",
    "쮳" => "jjwic", "쮴" => "jjwik", "쮵" => "jjwit", "쮶" => "jjwip", "쮷" => "jjwih", "쮸" => "jjyu",
    "쮹" => "jjyug", "쮺" => "jjyugg", "쮻" => "jjyugs", "쮼" => "jjyun", "쮽" => "jjyunj", "쮾" => "jjyunh",
    "쮿" => "jjyud", "쯀" => "jjyul", "쯁" => "jjyulg", "쯂" => "jjyulm", "쯃" => "jjyulb", "쯄" => "jjyuls",
    "쯅" => "jjyult", "쯆" => "jjyulp", "쯇" => "jjyulh", "쯈" => "jjyum", "쯉" => "jjyub", "쯊" => "jjyubs",
    "쯋" => "jjyus", "쯌" => "jjyuss", "쯍" => "jjyung", "쯎" => "jjyuj", "쯏" => "jjyuc", "쯐" => "jjyuk",
    "쯑" => "jjyut", "쯒" => "jjyup", "쯓" => "jjyuh", "쯔" => "jjeu", "쯕" => "jjeug", "쯖" => "jjeugg",
    "쯗" => "jjeugs", "쯘" => "jjeun", "쯙" => "jjeunj", "쯚" => "jjeunh", "쯛" => "jjeud", "쯜" => "jjeul",
    "쯝" => "jjeulg", "쯞" => "jjeulm", "쯟" => "jjeulb", "쯠" => "jjeuls", "쯡" => "jjeult", "쯢" => "jjeulp",
    "쯣" => "jjeulh", "쯤" => "jjeum", "쯥" => "jjeub", "쯦" => "jjeubs", "쯧" => "jjeus", "쯨" => "jjeuss",
    "쯩" => "jjeung", "쯪" => "jjeuj", "쯫" => "jjeuc", "쯬" => "jjeuk", "쯭" => "jjeut", "쯮" => "jjeup",
    "쯯" => "jjeuh", "쯰" => "jjyi", "쯱" => "jjyig", "쯲" => "jjyigg", "쯳" => "jjyigs", "쯴" => "jjyin",
    "쯵" => "jjyinj", "쯶" => "jjyinh", "쯷" => "jjyid", "쯸" => "jjyil", "쯹" => "jjyilg", "쯺" => "jjyilm",
    "쯻" => "jjyilb", "쯼" => "jjyils", "쯽" => "jjyilt", "쯾" => "jjyilp", "쯿" => "jjyilh", "찁" => "jjyib",
    "찂" => "jjyibs", "찃" => "jjyis", "찄" => "jjyiss", "찅" => "jjying", "찆" => "jjyij", "찇" => "jjyic",
    "찈" => "jjyik", "찉" => "jjyit", "찊" => "jjyip", "찋" => "jjyih", "찌" => "jji", "찍" => "jjig",
    "찎" => "jjigg", "찏" => "jjigs", "찐" => "jjin", "찑" => "jjinj", "찒" => "jjinh", "찓" => "jjid",
    "찔" => "jjil", "찕" => "jjilg", "찖" => "jjilm", "찗" => "jjilb", "찘" => "jjils", "찙" => "jjilt",
    "찚" => "jjilp", "찛" => "jjilh", "찜" => "jjim", "찝" => "jjib", "찞" => "jjibs", "찟" => "jjis",
    "찠" => "jjiss", "찡" => "jjing", "찢" => "jjij", "찣" => "jjic", "찤" => "jjik", "찥" => "jjit",
    "찦" => "jjip", "찧" => "jjih", "차" => "ca", "착" => "cag", "찪" => "cagg", "찫" => "cags",
    "찬" => "can", "찭" => "canj", "찮" => "canh", "찯" => "cad", "찰" => "cal", "찱" => "calg",
    "찲" => "calm", "찳" => "calb", "찴" => "cals", "찵" => "calt", "찶" => "calp", "찷" => "calh",
    "참" => "cam", "찹" => "cab", "찺" => "cabs", "찻" => "cas", "찼" => "cass", "창" => "cang",
    "찾" => "caj", "찿" => "cac", "챀" => "cak", "챁" => "cat", "챂" => "cap", "챃" => "cah",
    "채" => "cae", "책" => "caeg", "챆" => "caegg", "챇" => "caegs", "챈" => "caen", "챉" => "caenj",
    "챊" => "caenh", "챋" => "caed", "챌" => "cael", "챍" => "caelg", "챎" => "caelm", "챏" => "caelb",
    "챐" => "caels", "챑" => "caelt", "챒" => "caelp", "챓" => "caelh", "챔" => "caem", "챕" => "caeb",
    "챖" => "caebs", "챗" => "caes", "챘" => "caess", "챙" => "caeng", "챚" => "caej", "챛" => "caec",
    "챜" => "caek", "챝" => "caet", "챞" => "caep", "챟" => "caeh", "챠" => "cya", "챡" => "cyag",
    "챢" => "cyagg", "챣" => "cyags", "챤" => "cyan", "챥" => "cyanj", "챦" => "cyanh", "챧" => "cyad",
    "챨" => "cyal", "챩" => "cyalg", "챪" => "cyalm", "챫" => "cyalb", "챬" => "cyals", "챭" => "cyalt",
    "챮" => "cyalp", "챯" => "cyalh", "챰" => "cyam", "챱" => "cyab", "챲" => "cyabs", "챳" => "cyas",
    "챴" => "cyass", "챵" => "cyang", "챶" => "cyaj", "챷" => "cyac", "챸" => "cyak", "챹" => "cyat",
    "챺" => "cyap", "챻" => "cyah", "챼" => "cyae", "챽" => "cyaeg", "챾" => "cyaegg", "챿" => "cyaegs",
    "첀" => "cyaen", "첁" => "cyaenj", "첂" => "cyaenh", "첃" => "cyaed", "첄" => "cyael", "첅" => "cyaelg",
    "첆" => "cyaelm", "첇" => "cyaelb", "첈" => "cyaels", "첉" => "cyaelt", "첊" => "cyaelp", "첋" => "cyaelh",
    "첌" => "cyaem", "첍" => "cyaeb", "첎" => "cyaebs", "첏" => "cyaes", "첐" => "cyaess", "첑" => "cyaeng",
    "첒" => "cyaej", "첓" => "cyaec", "첔" => "cyaek", "첕" => "cyaet", "첖" => "cyaep", "첗" => "cyaeh",
    "처" => "ceo", "척" => "ceog", "첚" => "ceogg", "첛" => "ceogs", "천" => "ceon", "첝" => "ceonj",
    "첞" => "ceonh", "첟" => "ceod", "철" => "ceol", "첡" => "ceolg", "첢" => "ceolm", "첣" => "ceolb",
    "첤" => "ceols", "첥" => "ceolt", "첦" => "ceolp", "첧" => "ceolh", "첨" => "ceom", "첩" => "ceob",
    "첪" => "ceobs", "첫" => "ceos", "첬" => "ceoss", "청" => "ceong", "첮" => "ceoj", "첯" => "ceoc",
    "첰" => "ceok", "첱" => "ceot", "첲" => "ceop", "첳" => "ceoh", "체" => "ce", "첵" => "ceg",
    "첶" => "cegg", "첷" => "cegs", "첸" => "cen", "첹" => "cenj", "첺" => "cenh", "첻" => "ced",
    "첼" => "cel", "첽" => "celg", "첾" => "celm", "첿" => "celb", "쳀" => "cels", "쳁" => "celt",
    "쳂" => "celp", "쳃" => "celh", "쳄" => "cem", "쳅" => "ceb", "쳆" => "cebs", "쳇" => "ces",
    "쳈" => "cess", "쳉" => "ceng", "쳊" => "cej", "쳋" => "cec", "쳌" => "cek", "쳍" => "cet",
    "쳎" => "cep", "쳏" => "ceh", "쳐" => "cyeo", "쳑" => "cyeog", "쳒" => "cyeogg", "쳓" => "cyeogs",
    "쳔" => "cyeon", "쳕" => "cyeonj", "쳖" => "cyeonh", "쳗" => "cyeod", "쳘" => "cyeol", "쳙" => "cyeolg",
    "쳚" => "cyeolm", "쳛" => "cyeolb", "쳜" => "cyeols", "쳝" => "cyeolt", "쳞" => "cyeolp", "쳟" => "cyeolh",
    "쳠" => "cyeom", "쳡" => "cyeob", "쳢" => "cyeobs", "쳣" => "cyeos", "쳤" => "cyeoss", "쳥" => "cyeong",
    "쳦" => "cyeoj", "쳧" => "cyeoc", "쳨" => "cyeok", "쳩" => "cyeot", "쳪" => "cyeop", "쳫" => "cyeoh",
    "쳬" => "cye", "쳭" => "cyeg", "쳮" => "cyegg", "쳯" => "cyegs", "쳰" => "cyen", "쳱" => "cyenj",
    "쳲" => "cyenh", "쳳" => "cyed", "쳴" => "cyel", "쳵" => "cyelg", "쳶" => "cyelm", "쳷" => "cyelb",
    "쳸" => "cyels", "쳹" => "cyelt", "쳺" => "cyelp", "쳻" => "cyelh", "쳼" => "cyem", "쳽" => "cyeb",
    "쳾" => "cyebs", "쳿" => "cyes", "촁" => "cyeng", "촂" => "cyej", "촃" => "cyec", "촄" => "cyek",
    "촅" => "cyet", "촆" => "cyep", "촇" => "cyeh", "초" => "co", "촉" => "cog", "촊" => "cogg",
    "촋" => "cogs", "촌" => "con", "촍" => "conj", "촎" => "conh", "촏" => "cod", "촐" => "col",
    "촑" => "colg", "촒" => "colm", "촓" => "colb", "촔" => "cols", "촕" => "colt", "촖" => "colp",
    "촗" => "colh", "촘" => "com", "촙" => "cob", "촚" => "cobs", "촛" => "cos", "촜" => "coss",
    "총" => "cong", "촞" => "coj", "촟" => "coc", "촠" => "cok", "촡" => "cot", "촢" => "cop",
    "촣" => "coh", "촤" => "cwa", "촥" => "cwag", "촦" => "cwagg", "촧" => "cwags", "촨" => "cwan",
    "촩" => "cwanj", "촪" => "cwanh", "촫" => "cwad", "촬" => "cwal", "촭" => "cwalg", "촮" => "cwalm",
    "촯" => "cwalb", "촰" => "cwals", "촱" => "cwalt", "촲" => "cwalp", "촳" => "cwalh", "촴" => "cwam",
    "촵" => "cwab", "촶" => "cwabs", "촷" => "cwas", "촸" => "cwass", "촹" => "cwang", "촺" => "cwaj",
    "촻" => "cwac", "촼" => "cwak", "촽" => "cwat", "촾" => "cwap", "촿" => "cwah", "쵀" => "cwae",
    "쵁" => "cwaeg", "쵂" => "cwaegg", "쵃" => "cwaegs", "쵄" => "cwaen", "쵅" => "cwaenj", "쵆" => "cwaenh",
    "쵇" => "cwaed", "쵈" => "cwael", "쵉" => "cwaelg", "쵊" => "cwaelm", "쵋" => "cwaelb", "쵌" => "cwaels",
    "쵍" => "cwaelt", "쵎" => "cwaelp", "쵏" => "cwaelh", "쵐" => "cwaem", "쵑" => "cwaeb", "쵒" => "cwaebs",
    "쵓" => "cwaes", "쵔" => "cwaess", "쵕" => "cwaeng", "쵖" => "cwaej", "쵗" => "cwaec", "쵘" => "cwaek",
    "쵙" => "cwaet", "쵚" => "cwaep", "쵛" => "cwaeh", "최" => "coe", "쵝" => "coeg", "쵞" => "coegg",
    "쵟" => "coegs", "쵠" => "coen", "쵡" => "coenj", "쵢" => "coenh", "쵣" => "coed", "쵤" => "coel",
    "쵥" => "coelg", "쵦" => "coelm", "쵧" => "coelb", "쵨" => "coels", "쵩" => "coelt", "쵪" => "coelp",
    "쵫" => "coelh", "쵬" => "coem", "쵭" => "coeb", "쵮" => "coebs", "쵯" => "coes", "쵰" => "coess",
    "쵱" => "coeng", "쵲" => "coej", "쵳" => "coec", "쵴" => "coek", "쵵" => "coet", "쵶" => "coep",
    "쵷" => "coeh", "쵸" => "cyo", "쵹" => "cyog", "쵺" => "cyogg", "쵻" => "cyogs", "쵼" => "cyon",
    "쵽" => "cyonj", "쵾" => "cyonh", "쵿" => "cyod", "춀" => "cyol", "춁" => "cyolg", "춂" => "cyolm",
    "춃" => "cyolb", "춄" => "cyols", "춅" => "cyolt", "춆" => "cyolp", "춇" => "cyolh", "춈" => "cyom",
    "춉" => "cyob", "춊" => "cyobs", "춋" => "cyos", "춌" => "cyoss", "춍" => "cyong", "춎" => "cyoj",
    "춏" => "cyoc", "춐" => "cyok", "춑" => "cyot", "춒" => "cyop", "춓" => "cyoh", "추" => "cu",
    "축" => "cug", "춖" => "cugg", "춗" => "cugs", "춘" => "cun", "춙" => "cunj", "춚" => "cunh",
    "춛" => "cud", "출" => "cul", "춝" => "culg", "춞" => "culm", "춟" => "culb", "춠" => "culs",
    "춡" => "cult", "춢" => "culp", "춣" => "culh", "춤" => "cum", "춥" => "cub", "춦" => "cubs",
    "춧" => "cus", "춨" => "cuss", "충" => "cung", "춪" => "cuj", "춫" => "cuc", "춬" => "cuk",
    "춭" => "cut", "춮" => "cup", "춯" => "cuh", "춰" => "cweo", "춱" => "cweog", "춲" => "cweogg",
    "춳" => "cweogs", "춴" => "cweon", "춵" => "cweonj", "춶" => "cweonh", "춷" => "cweod", "춸" => "cweol",
    "춹" => "cweolg", "춺" => "cweolm", "춻" => "cweolb", "춼" => "cweols", "춽" => "cweolt", "춾" => "cweolp",
    "춿" => "cweolh", "췀" => "cweom", "췁" => "cweob", "췂" => "cweobs", "췃" => "cweos", "췄" => "cweoss",
    "췅" => "cweong", "췆" => "cweoj", "췇" => "cweoc", "췈" => "cweok", "췉" => "cweot", "췊" => "cweop",
    "췋" => "cweoh", "췌" => "cwe", "췍" => "cweg", "췎" => "cwegg", "췏" => "cwegs", "췐" => "cwen",
    "췑" => "cwenj", "췒" => "cwenh", "췓" => "cwed", "췔" => "cwel", "췕" => "cwelg", "췖" => "cwelm",
    "췗" => "cwelb", "췘" => "cwels", "췙" => "cwelt", "췚" => "cwelp", "췛" => "cwelh", "췜" => "cwem",
    "췝" => "cweb", "췞" => "cwebs", "췟" => "cwes", "췠" => "cwess", "췡" => "cweng", "췢" => "cwej",
    "췣" => "cwec", "췤" => "cwek", "췥" => "cwet", "췦" => "cwep", "췧" => "cweh", "취" => "cwi",
    "췩" => "cwig", "췪" => "cwigg", "췫" => "cwigs", "췬" => "cwin", "췭" => "cwinj", "췮" => "cwinh",
    "췯" => "cwid", "췰" => "cwil", "췱" => "cwilg", "췲" => "cwilm", "췳" => "cwilb", "췴" => "cwils",
    "췵" => "cwilt", "췶" => "cwilp", "췷" => "cwilh", "췸" => "cwim", "췹" => "cwib", "췺" => "cwibs",
    "췻" => "cwis", "췼" => "cwiss", "췽" => "cwing", "췾" => "cwij", "췿" => "cwic", "츁" => "cwit",
    "츂" => "cwip", "츃" => "cwih", "츄" => "cyu", "츅" => "cyug", "츆" => "cyugg", "츇" => "cyugs",
    "츈" => "cyun", "츉" => "cyunj", "츊" => "cyunh", "츋" => "cyud", "츌" => "cyul", "츍" => "cyulg",
    "츎" => "cyulm", "츏" => "cyulb", "츐" => "cyuls", "츑" => "cyult", "츒" => "cyulp", "츓" => "cyulh",
    "츔" => "cyum", "츕" => "cyub", "츖" => "cyubs", "츗" => "cyus", "츘" => "cyuss", "츙" => "cyung",
    "츚" => "cyuj", "츛" => "cyuc", "츜" => "cyuk", "츝" => "cyut", "츞" => "cyup", "츟" => "cyuh",
    "츠" => "ceu", "측" => "ceug", "츢" => "ceugg", "츣" => "ceugs", "츤" => "ceun", "츥" => "ceunj",
    "츦" => "ceunh", "츧" => "ceud", "츨" => "ceul", "츩" => "ceulg", "츪" => "ceulm", "츫" => "ceulb",
    "츬" => "ceuls", "츭" => "ceult", "츮" => "ceulp", "츯" => "ceulh", "츰" => "ceum", "츱" => "ceub",
    "츲" => "ceubs", "츳" => "ceus", "츴" => "ceuss", "층" => "ceung", "츶" => "ceuj", "츷" => "ceuc",
    "츸" => "ceuk", "츹" => "ceut", "츺" => "ceup", "츻" => "ceuh", "츼" => "cyi", "츽" => "cyig",
    "츾" => "cyigg", "츿" => "cyigs", "칀" => "cyin", "칁" => "cyinj", "칂" => "cyinh", "칃" => "cyid",
    "칄" => "cyil", "칅" => "cyilg", "칆" => "cyilm", "칇" => "cyilb", "칈" => "cyils", "칉" => "cyilt",
    "칊" => "cyilp", "칋" => "cyilh", "칌" => "cyim", "칍" => "cyib", "칎" => "cyibs", "칏" => "cyis",
    "칐" => "cyiss", "칑" => "cying", "칒" => "cyij", "칓" => "cyic", "칔" => "cyik", "칕" => "cyit",
    "칖" => "cyip", "칗" => "cyih", "치" => "ci", "칙" => "cig", "칚" => "cigg", "칛" => "cigs",
    "친" => "cin", "칝" => "cinj", "칞" => "cinh", "칟" => "cid", "칠" => "cil", "칡" => "cilg",
    "칢" => "cilm", "칣" => "cilb", "칤" => "cils", "칥" => "cilt", "칦" => "cilp", "칧" => "cilh",
    "침" => "cim", "칩" => "cib", "칪" => "cibs", "칫" => "cis", "칬" => "ciss", "칭" => "cing",
    "칮" => "cij", "칯" => "cic", "칰" => "cik", "칱" => "cit", "칲" => "cip", "칳" => "cih",
    "카" => "ka", "칵" => "kag", "칶" => "kagg", "칷" => "kags", "칸" => "kan", "칹" => "kanj",
    "칺" => "kanh", "칻" => "kad", "칼" => "kal", "칽" => "kalg", "칾" => "kalm", "칿" => "kalb",
    "캀" => "kals", "캁" => "kalt", "캂" => "kalp", "캃" => "kalh", "캄" => "kam", "캅" => "kab",
    "캆" => "kabs", "캇" => "kas", "캈" => "kass", "캉" => "kang", "캊" => "kaj", "캋" => "kac",
    "캌" => "kak", "캍" => "kat", "캎" => "kap", "캏" => "kah", "캐" => "kae", "캑" => "kaeg",
    "캒" => "kaegg", "캓" => "kaegs", "캔" => "kaen", "캕" => "kaenj", "캖" => "kaenh", "캗" => "kaed",
    "캘" => "kael", "캙" => "kaelg", "캚" => "kaelm", "캛" => "kaelb", "캜" => "kaels", "캝" => "kaelt",
    "캞" => "kaelp", "캟" => "kaelh", "캠" => "kaem", "캡" => "kaeb", "캢" => "kaebs", "캣" => "kaes",
    "캤" => "kaess", "캥" => "kaeng", "캦" => "kaej", "캧" => "kaec", "캨" => "kaek", "캩" => "kaet",
    "캪" => "kaep", "캫" => "kaeh", "캬" => "kya", "캭" => "kyag", "캮" => "kyagg", "캯" => "kyags",
    "캰" => "kyan", "캱" => "kyanj", "캲" => "kyanh", "캳" => "kyad", "캴" => "kyal", "캵" => "kyalg",
    "캶" => "kyalm", "캷" => "kyalb", "캸" => "kyals", "캹" => "kyalt", "캺" => "kyalp", "캻" => "kyalh",
    "캼" => "kyam", "캽" => "kyab", "캾" => "kyabs", "캿" => "kyas", "컀" => "kyass", "컁" => "kyang",
    "컂" => "kyaj", "컃" => "kyac", "컄" => "kyak", "컅" => "kyat", "컆" => "kyap", "컇" => "kyah",
    "컈" => "kyae", "컉" => "kyaeg", "컊" => "kyaegg", "컋" => "kyaegs", "컌" => "kyaen", "컍" => "kyaenj",
    "컎" => "kyaenh", "컏" => "kyaed", "컐" => "kyael", "컑" => "kyaelg", "컒" => "kyaelm", "컓" => "kyaelb",
    "컔" => "kyaels", "컕" => "kyaelt", "컖" => "kyaelp", "컗" => "kyaelh", "컘" => "kyaem", "컙" => "kyaeb",
    "컚" => "kyaebs", "컛" => "kyaes", "컜" => "kyaess", "컝" => "kyaeng", "컞" => "kyaej", "컟" => "kyaec",
    "컠" => "kyaek", "컡" => "kyaet", "컢" => "kyaep", "컣" => "kyaeh", "커" => "keo", "컥" => "keog",
    "컦" => "keogg", "컧" => "keogs", "컨" => "keon", "컩" => "keonj", "컪" => "keonh", "컫" => "keod",
    "컬" => "keol", "컭" => "keolg", "컮" => "keolm", "컯" => "keolb", "컰" => "keols", "컱" => "keolt",
    "컲" => "keolp", "컳" => "keolh", "컴" => "keom", "컵" => "keob", "컶" => "keobs", "컷" => "keos",
    "컸" => "keoss", "컹" => "keong", "컺" => "keoj", "컻" => "keoc", "컼" => "keok", "컽" => "keot",
    "컾" => "keop", "컿" => "keoh", "켁" => "keg", "켂" => "kegg", "켃" => "kegs", "켄" => "ken",
    "켅" => "kenj", "켆" => "kenh", "켇" => "ked", "켈" => "kel", "켉" => "kelg", "켊" => "kelm",
    "켋" => "kelb", "켌" => "kels", "켍" => "kelt", "켎" => "kelp", "켏" => "kelh", "켐" => "kem",
    "켑" => "keb", "켒" => "kebs", "켓" => "kes", "켔" => "kess", "켕" => "keng", "켖" => "kej",
    "켗" => "kec", "켘" => "kek", "켙" => "ket", "켚" => "kep", "켛" => "keh", "켜" => "kyeo",
    "켝" => "kyeog", "켞" => "kyeogg", "켟" => "kyeogs", "켠" => "kyeon", "켡" => "kyeonj", "켢" => "kyeonh",
    "켣" => "kyeod", "켤" => "kyeol", "켥" => "kyeolg", "켦" => "kyeolm", "켧" => "kyeolb", "켨" => "kyeols",
    "켩" => "kyeolt", "켪" => "kyeolp", "켫" => "kyeolh", "켬" => "kyeom", "켭" => "kyeob", "켮" => "kyeobs",
    "켯" => "kyeos", "켰" => "kyeoss", "켱" => "kyeong", "켲" => "kyeoj", "켳" => "kyeoc", "켴" => "kyeok",
    "켵" => "kyeot", "켶" => "kyeop", "켷" => "kyeoh", "켸" => "kye", "켹" => "kyeg", "켺" => "kyegg",
    "켻" => "kyegs", "켼" => "kyen", "켽" => "kyenj", "켾" => "kyenh", "켿" => "kyed", "콀" => "kyel",
    "콁" => "kyelg", "콂" => "kyelm", "콃" => "kyelb", "콄" => "kyels", "콅" => "kyelt", "콆" => "kyelp",
    "콇" => "kyelh", "콈" => "kyem", "콉" => "kyeb", "콊" => "kyebs", "콋" => "kyes", "콌" => "kyess",
    "콍" => "kyeng", "콎" => "kyej", "콏" => "kyec", "콐" => "kyek", "콑" => "kyet", "콒" => "kyep",
    "콓" => "kyeh", "코" => "ko", "콕" => "kog", "콖" => "kogg", "콗" => "kogs", "콘" => "kon",
    "콙" => "konj", "콚" => "konh", "콛" => "kod", "콜" => "kol", "콝" => "kolg", "콞" => "kolm",
    "콟" => "kolb", "콠" => "kols", "콡" => "kolt", "콢" => "kolp", "콣" => "kolh", "콤" => "kom",
    "콥" => "kob", "콦" => "kobs", "콧" => "kos", "콨" => "koss", "콩" => "kong", "콪" => "koj",
    "콫" => "koc", "콬" => "kok", "콭" => "kot", "콮" => "kop", "콯" => "koh", "콰" => "kwa",
    "콱" => "kwag", "콲" => "kwagg", "콳" => "kwags", "콴" => "kwan", "콵" => "kwanj", "콶" => "kwanh",
    "콷" => "kwad", "콸" => "kwal", "콹" => "kwalg", "콺" => "kwalm", "콻" => "kwalb", "콼" => "kwals",
    "콽" => "kwalt", "콾" => "kwalp", "콿" => "kwalh", "쾀" => "kwam", "쾁" => "kwab", "쾂" => "kwabs",
    "쾃" => "kwas", "쾄" => "kwass", "쾅" => "kwang", "쾆" => "kwaj", "쾇" => "kwac", "쾈" => "kwak",
    "쾉" => "kwat", "쾊" => "kwap", "쾋" => "kwah", "쾌" => "kwae", "쾍" => "kwaeg", "쾎" => "kwaegg",
    "쾏" => "kwaegs", "쾐" => "kwaen", "쾑" => "kwaenj", "쾒" => "kwaenh", "쾓" => "kwaed", "쾔" => "kwael",
    "쾕" => "kwaelg", "쾖" => "kwaelm", "쾗" => "kwaelb", "쾘" => "kwaels", "쾙" => "kwaelt", "쾚" => "kwaelp",
    "쾛" => "kwaelh", "쾜" => "kwaem", "쾝" => "kwaeb", "쾞" => "kwaebs", "쾟" => "kwaes", "쾠" => "kwaess",
    "쾡" => "kwaeng", "쾢" => "kwaej", "쾣" => "kwaec", "쾤" => "kwaek", "쾥" => "kwaet", "쾦" => "kwaep",
    "쾧" => "kwaeh", "쾨" => "koe", "쾩" => "koeg", "쾪" => "koegg", "쾫" => "koegs", "쾬" => "koen",
    "쾭" => "koenj", "쾮" => "koenh", "쾯" => "koed", "쾰" => "koel", "쾱" => "koelg", "쾲" => "koelm",
    "쾳" => "koelb", "쾴" => "koels", "쾵" => "koelt", "쾶" => "koelp", "쾷" => "koelh", "쾸" => "koem",
    "쾹" => "koeb", "쾺" => "koebs", "쾻" => "koes", "쾼" => "koess", "쾽" => "koeng", "쾾" => "koej",
    "쾿" => "koec", "쿀" => "koek", "쿁" => "koet", "쿂" => "koep", "쿃" => "koeh", "쿄" => "kyo",
    "쿅" => "kyog", "쿆" => "kyogg", "쿇" => "kyogs", "쿈" => "kyon", "쿉" => "kyonj", "쿊" => "kyonh",
    "쿋" => "kyod", "쿌" => "kyol", "쿍" => "kyolg", "쿎" => "kyolm", "쿏" => "kyolb", "쿐" => "kyols",
    "쿑" => "kyolt", "쿒" => "kyolp", "쿓" => "kyolh", "쿔" => "kyom", "쿕" => "kyob", "쿖" => "kyobs",
    "쿗" => "kyos", "쿘" => "kyoss", "쿙" => "kyong", "쿚" => "kyoj", "쿛" => "kyoc", "쿜" => "kyok",
    "쿝" => "kyot", "쿞" => "kyop", "쿟" => "kyoh", "쿠" => "ku", "쿡" => "kug", "쿢" => "kugg",
    "쿣" => "kugs", "쿤" => "kun", "쿥" => "kunj", "쿦" => "kunh", "쿧" => "kud", "쿨" => "kul",
    "쿩" => "kulg", "쿪" => "kulm", "쿫" => "kulb", "쿬" => "kuls", "쿭" => "kult", "쿮" => "kulp",
    "쿯" => "kulh", "쿰" => "kum", "쿱" => "kub", "쿲" => "kubs", "쿳" => "kus", "쿴" => "kuss",
    "쿵" => "kung", "쿶" => "kuj", "쿷" => "kuc", "쿸" => "kuk", "쿹" => "kut", "쿺" => "kup",
    "쿻" => "kuh", "쿼" => "kweo", "쿽" => "kweog", "쿾" => "kweogg", "쿿" => "kweogs", "퀁" => "kweonj",
    "퀂" => "kweonh", "퀃" => "kweod", "퀄" => "kweol", "퀅" => "kweolg", "퀆" => "kweolm", "퀇" => "kweolb",
    "퀈" => "kweols", "퀉" => "kweolt", "퀊" => "kweolp", "퀋" => "kweolh", "퀌" => "kweom", "퀍" => "kweob",
    "퀎" => "kweobs", "퀏" => "kweos", "퀐" => "kweoss", "퀑" => "kweong", "퀒" => "kweoj", "퀓" => "kweoc",
    "퀔" => "kweok", "퀕" => "kweot", "퀖" => "kweop", "퀗" => "kweoh", "퀘" => "kwe", "퀙" => "kweg",
    "퀚" => "kwegg", "퀛" => "kwegs", "퀜" => "kwen", "퀝" => "kwenj", "퀞" => "kwenh", "퀟" => "kwed",
    "퀠" => "kwel", "퀡" => "kwelg", "퀢" => "kwelm", "퀣" => "kwelb", "퀤" => "kwels", "퀥" => "kwelt",
    "퀦" => "kwelp", "퀧" => "kwelh", "퀨" => "kwem", "퀩" => "kweb", "퀪" => "kwebs", "퀫" => "kwes",
    "퀬" => "kwess", "퀭" => "kweng", "퀮" => "kwej", "퀯" => "kwec", "퀰" => "kwek", "퀱" => "kwet",
    "퀲" => "kwep", "퀳" => "kweh", "퀴" => "kwi", "퀵" => "kwig", "퀶" => "kwigg", "퀷" => "kwigs",
    "퀸" => "kwin", "퀹" => "kwinj", "퀺" => "kwinh", "퀻" => "kwid", "퀼" => "kwil", "퀽" => "kwilg",
    "퀾" => "kwilm", "퀿" => "kwilb", "큀" => "kwils", "큁" => "kwilt", "큂" => "kwilp", "큃" => "kwilh",
    "큄" => "kwim", "큅" => "kwib", "큆" => "kwibs", "큇" => "kwis", "큈" => "kwiss", "큉" => "kwing",
    "큊" => "kwij", "큋" => "kwic", "큌" => "kwik", "큍" => "kwit", "큎" => "kwip", "큏" => "kwih",
    "큐" => "kyu", "큑" => "kyug", "큒" => "kyugg", "큓" => "kyugs", "큔" => "kyun", "큕" => "kyunj",
    "큖" => "kyunh", "큗" => "kyud", "큘" => "kyul", "큙" => "kyulg", "큚" => "kyulm", "큛" => "kyulb",
    "큜" => "kyuls", "큝" => "kyult", "큞" => "kyulp", "큟" => "kyulh", "큠" => "kyum", "큡" => "kyub",
    "큢" => "kyubs", "큣" => "kyus", "큤" => "kyuss", "큥" => "kyung", "큦" => "kyuj", "큧" => "kyuc",
    "큨" => "kyuk", "큩" => "kyut", "큪" => "kyup", "큫" => "kyuh", "크" => "keu", "큭" => "keug",
    "큮" => "keugg", "큯" => "keugs", "큰" => "keun", "큱" => "keunj", "큲" => "keunh", "큳" => "keud",
    "클" => "keul", "큵" => "keulg", "큶" => "keulm", "큷" => "keulb", "큸" => "keuls", "큹" => "keult",
    "큺" => "keulp", "큻" => "keulh", "큼" => "keum", "큽" => "keub", "큾" => "keubs", "큿" => "keus",
    "킀" => "keuss", "킁" => "keung", "킂" => "keuj", "킃" => "keuc", "킄" => "keuk", "킅" => "keut",
    "킆" => "keup", "킇" => "keuh", "킈" => "kyi", "킉" => "kyig", "킊" => "kyigg", "킋" => "kyigs",
    "킌" => "kyin", "킍" => "kyinj", "킎" => "kyinh", "킏" => "kyid", "킐" => "kyil", "킑" => "kyilg",
    "킒" => "kyilm", "킓" => "kyilb", "킔" => "kyils", "킕" => "kyilt", "킖" => "kyilp", "킗" => "kyilh",
    "킘" => "kyim", "킙" => "kyib", "킚" => "kyibs", "킛" => "kyis", "킜" => "kyiss", "킝" => "kying",
    "킞" => "kyij", "킟" => "kyic", "킠" => "kyik", "킡" => "kyit", "킢" => "kyip", "킣" => "kyih",
    "키" => "ki", "킥" => "kig", "킦" => "kigg", "킧" => "kigs", "킨" => "kin", "킩" => "kinj",
    "킪" => "kinh", "킫" => "kid", "킬" => "kil", "킭" => "kilg", "킮" => "kilm", "킯" => "kilb",
    "킰" => "kils", "킱" => "kilt", "킲" => "kilp", "킳" => "kilh", "킴" => "kim", "킵" => "kib",
    "킶" => "kibs", "킷" => "kis", "킸" => "kiss", "킹" => "king", "킺" => "kij", "킻" => "kic",
    "킼" => "kik", "킽" => "kit", "킾" => "kip", "킿" => "kih", "타" => "ta", "탁" => "tag",
    "탂" => "tagg", "탃" => "tags", "탄" => "tan", "탅" => "tanj", "탆" => "tanh", "탇" => "tad",
    "탈" => "tal", "탉" => "talg", "탊" => "talm", "탋" => "talb", "탌" => "tals", "탍" => "talt",
    "탎" => "talp", "탏" => "talh", "탐" => "tam", "탑" => "tab", "탒" => "tabs", "탓" => "tas",
    "탔" => "tass", "탕" => "tang", "탖" => "taj", "탗" => "tac", "탘" => "tak", "탙" => "tat",
    "탚" => "tap", "탛" => "tah", "태" => "tae", "택" => "taeg", "탞" => "taegg", "탟" => "taegs",
    "탠" => "taen", "탡" => "taenj", "탢" => "taenh", "탣" => "taed", "탤" => "tael", "탥" => "taelg",
    "탦" => "taelm", "탧" => "taelb", "탨" => "taels", "탩" => "taelt", "탪" => "taelp", "탫" => "taelh",
    "탬" => "taem", "탭" => "taeb", "탮" => "taebs", "탯" => "taes", "탰" => "taess", "탱" => "taeng",
    "탲" => "taej", "탳" => "taec", "탴" => "taek", "탵" => "taet", "탶" => "taep", "탷" => "taeh",
    "탸" => "tya", "탹" => "tyag", "탺" => "tyagg", "탻" => "tyags", "탼" => "tyan", "탽" => "tyanj",
    "탾" => "tyanh", "탿" => "tyad", "턁" => "tyalg", "턂" => "tyalm", "턃" => "tyalb", "턄" => "tyals",
    "턅" => "tyalt", "턆" => "tyalp", "턇" => "tyalh", "턈" => "tyam", "턉" => "tyab", "턊" => "tyabs",
    "턋" => "tyas", "턌" => "tyass", "턍" => "tyang", "턎" => "tyaj", "턏" => "tyac", "턐" => "tyak",
    "턑" => "tyat", "턒" => "tyap", "턓" => "tyah", "턔" => "tyae", "턕" => "tyaeg", "턖" => "tyaegg",
    "턗" => "tyaegs", "턘" => "tyaen", "턙" => "tyaenj", "턚" => "tyaenh", "턛" => "tyaed", "턜" => "tyael",
    "턝" => "tyaelg", "턞" => "tyaelm", "턟" => "tyaelb", "턠" => "tyaels", "턡" => "tyaelt", "턢" => "tyaelp",
    "턣" => "tyaelh", "턤" => "tyaem", "턥" => "tyaeb", "턦" => "tyaebs", "턧" => "tyaes", "턨" => "tyaess",
    "턩" => "tyaeng", "턪" => "tyaej", "턫" => "tyaec", "턬" => "tyaek", "턭" => "tyaet", "턮" => "tyaep",
    "턯" => "tyaeh", "터" => "teo", "턱" => "teog", "턲" => "teogg", "턳" => "teogs", "턴" => "teon",
    "턵" => "teonj", "턶" => "teonh", "턷" => "teod", "털" => "teol", "턹" => "teolg", "턺" => "teolm",
    "턻" => "teolb", "턼" => "teols", "턽" => "teolt", "턾" => "teolp", "턿" => "teolh", "텀" => "teom",
    "텁" => "teob", "텂" => "teobs", "텃" => "teos", "텄" => "teoss", "텅" => "teong", "텆" => "teoj",
    "텇" => "teoc", "텈" => "teok", "텉" => "teot", "텊" => "teop", "텋" => "teoh", "테" => "te",
    "텍" => "teg", "텎" => "tegg", "텏" => "tegs", "텐" => "ten", "텑" => "tenj", "텒" => "tenh",
    "텓" => "ted", "텔" => "tel", "텕" => "telg", "텖" => "telm", "텗" => "telb", "텘" => "tels",
    "텙" => "telt", "텚" => "telp", "텛" => "telh", "템" => "tem", "텝" => "teb", "텞" => "tebs",
    "텟" => "tes", "텠" => "tess", "텡" => "teng", "텢" => "tej", "텣" => "tec", "텤" => "tek",
    "텥" => "tet", "텦" => "tep", "텧" => "teh", "텨" => "tyeo", "텩" => "tyeog", "텪" => "tyeogg",
    "텫" => "tyeogs", "텬" => "tyeon", "텭" => "tyeonj", "텮" => "tyeonh", "텯" => "tyeod", "텰" => "tyeol",
    "텱" => "tyeolg", "텲" => "tyeolm", "텳" => "tyeolb", "텴" => "tyeols", "텵" => "tyeolt", "텶" => "tyeolp",
    "텷" => "tyeolh", "텸" => "tyeom", "텹" => "tyeob", "텺" => "tyeobs", "텻" => "tyeos", "텼" => "tyeoss",
    "텽" => "tyeong", "텾" => "tyeoj", "텿" => "tyeoc", "톀" => "tyeok", "톁" => "tyeot", "톂" => "tyeop",
    "톃" => "tyeoh", "톄" => "tye", "톅" => "tyeg", "톆" => "tyegg", "톇" => "tyegs", "톈" => "tyen",
    "톉" => "tyenj", "톊" => "tyenh", "톋" => "tyed", "톌" => "tyel", "톍" => "tyelg", "톎" => "tyelm",
    "톏" => "tyelb", "톐" => "tyels", "톑" => "tyelt", "톒" => "tyelp", "톓" => "tyelh", "톔" => "tyem",
    "톕" => "tyeb", "톖" => "tyebs", "톗" => "tyes", "톘" => "tyess", "톙" => "tyeng", "톚" => "tyej",
    "톛" => "tyec", "톜" => "tyek", "톝" => "tyet", "톞" => "tyep", "톟" => "tyeh", "토" => "to",
    "톡" => "tog", "톢" => "togg", "톣" => "togs", "톤" => "ton", "톥" => "tonj", "톦" => "tonh",
    "톧" => "tod", "톨" => "tol", "톩" => "tolg", "톪" => "tolm", "톫" => "tolb", "톬" => "tols",
    "톭" => "tolt", "톮" => "tolp", "톯" => "tolh", "톰" => "tom", "톱" => "tob", "톲" => "tobs",
    "톳" => "tos", "톴" => "toss", "통" => "tong", "톶" => "toj", "톷" => "toc", "톸" => "tok",
    "톹" => "tot", "톺" => "top", "톻" => "toh", "톼" => "twa", "톽" => "twag", "톾" => "twagg",
    "톿" => "twags", "퇀" => "twan", "퇁" => "twanj", "퇂" => "twanh", "퇃" => "twad", "퇄" => "twal",
    "퇅" => "twalg", "퇆" => "twalm", "퇇" => "twalb", "퇈" => "twals", "퇉" => "twalt", "퇊" => "twalp",
    "퇋" => "twalh", "퇌" => "twam", "퇍" => "twab", "퇎" => "twabs", "퇏" => "twas", "퇐" => "twass",
    "퇑" => "twang", "퇒" => "twaj", "퇓" => "twac", "퇔" => "twak", "퇕" => "twat", "퇖" => "twap",
    "퇗" => "twah", "퇘" => "twae", "퇙" => "twaeg", "퇚" => "twaegg", "퇛" => "twaegs", "퇜" => "twaen",
    "퇝" => "twaenj", "퇞" => "twaenh", "퇟" => "twaed", "퇠" => "twael", "퇡" => "twaelg", "퇢" => "twaelm",
    "퇣" => "twaelb", "퇤" => "twaels", "퇥" => "twaelt", "퇦" => "twaelp", "퇧" => "twaelh", "퇨" => "twaem",
    "퇩" => "twaeb", "퇪" => "twaebs", "퇫" => "twaes", "퇬" => "twaess", "퇭" => "twaeng", "퇮" => "twaej",
    "퇯" => "twaec", "퇰" => "twaek", "퇱" => "twaet", "퇲" => "twaep", "퇳" => "twaeh", "퇴" => "toe",
    "퇵" => "toeg", "퇶" => "toegg", "퇷" => "toegs", "퇸" => "toen", "퇹" => "toenj", "퇺" => "toenh",
    "퇻" => "toed", "퇼" => "toel", "퇽" => "toelg", "퇾" => "toelm", "퇿" => "toelb", "툁" => "toelt",
    "툂" => "toelp", "툃" => "toelh", "툄" => "toem", "툅" => "toeb", "툆" => "toebs", "툇" => "toes",
    "툈" => "toess", "툉" => "toeng", "툊" => "toej", "툋" => "toec", "툌" => "toek", "툍" => "toet",
    "툎" => "toep", "툏" => "toeh", "툐" => "tyo", "툑" => "tyog", "툒" => "tyogg", "툓" => "tyogs",
    "툔" => "tyon", "툕" => "tyonj", "툖" => "tyonh", "툗" => "tyod", "툘" => "tyol", "툙" => "tyolg",
    "툚" => "tyolm", "툛" => "tyolb", "툜" => "tyols", "툝" => "tyolt", "툞" => "tyolp", "툟" => "tyolh",
    "툠" => "tyom", "툡" => "tyob", "툢" => "tyobs", "툣" => "tyos", "툤" => "tyoss", "툥" => "tyong",
    "툦" => "tyoj", "툧" => "tyoc", "툨" => "tyok", "툩" => "tyot", "툪" => "tyop", "툫" => "tyoh",
    "투" => "tu", "툭" => "tug", "툮" => "tugg", "툯" => "tugs", "툰" => "tun", "툱" => "tunj",
    "툲" => "tunh", "툳" => "tud", "툴" => "tul", "툵" => "tulg", "툶" => "tulm", "툷" => "tulb",
    "툸" => "tuls", "툹" => "tult", "툺" => "tulp", "툻" => "tulh", "툼" => "tum", "툽" => "tub",
    "툾" => "tubs", "툿" => "tus", "퉀" => "tuss", "퉁" => "tung", "퉂" => "tuj", "퉃" => "tuc",
    "퉄" => "tuk", "퉅" => "tut", "퉆" => "tup", "퉇" => "tuh", "퉈" => "tweo", "퉉" => "tweog",
    "퉊" => "tweogg", "퉋" => "tweogs", "퉌" => "tweon", "퉍" => "tweonj", "퉎" => "tweonh", "퉏" => "tweod",
    "퉐" => "tweol", "퉑" => "tweolg", "퉒" => "tweolm", "퉓" => "tweolb", "퉔" => "tweols", "퉕" => "tweolt",
    "퉖" => "tweolp", "퉗" => "tweolh", "퉘" => "tweom", "퉙" => "tweob", "퉚" => "tweobs", "퉛" => "tweos",
    "퉜" => "tweoss", "퉝" => "tweong", "퉞" => "tweoj", "퉟" => "tweoc", "퉠" => "tweok", "퉡" => "tweot",
    "퉢" => "tweop", "퉣" => "tweoh", "퉤" => "twe", "퉥" => "tweg", "퉦" => "twegg", "퉧" => "twegs",
    "퉨" => "twen", "퉩" => "twenj", "퉪" => "twenh", "퉫" => "twed", "퉬" => "twel", "퉭" => "twelg",
    "퉮" => "twelm", "퉯" => "twelb", "퉰" => "twels", "퉱" => "twelt", "퉲" => "twelp", "퉳" => "twelh",
    "퉴" => "twem", "퉵" => "tweb", "퉶" => "twebs", "퉷" => "twes", "퉸" => "twess", "퉹" => "tweng",
    "퉺" => "twej", "퉻" => "twec", "퉼" => "twek", "퉽" => "twet", "퉾" => "twep", "퉿" => "tweh",
    "튀" => "twi", "튁" => "twig", "튂" => "twigg", "튃" => "twigs", "튄" => "twin", "튅" => "twinj",
    "튆" => "twinh", "튇" => "twid", "튈" => "twil", "튉" => "twilg", "튊" => "twilm", "튋" => "twilb",
    "튌" => "twils", "튍" => "twilt", "튎" => "twilp", "튏" => "twilh", "튐" => "twim", "튑" => "twib",
    "튒" => "twibs", "튓" => "twis", "튔" => "twiss", "튕" => "twing", "튖" => "twij", "튗" => "twic",
    "튘" => "twik", "튙" => "twit", "튚" => "twip", "튛" => "twih", "튜" => "tyu", "튝" => "tyug",
    "튞" => "tyugg", "튟" => "tyugs", "튠" => "tyun", "튡" => "tyunj", "튢" => "tyunh", "튣" => "tyud",
    "튤" => "tyul", "튥" => "tyulg", "튦" => "tyulm", "튧" => "tyulb", "튨" => "tyuls", "튩" => "tyult",
    "튪" => "tyulp", "튫" => "tyulh", "튬" => "tyum", "튭" => "tyub", "튮" => "tyubs", "튯" => "tyus",
    "튰" => "tyuss", "튱" => "tyung", "튲" => "tyuj", "튳" => "tyuc", "튴" => "tyuk", "튵" => "tyut",
    "튶" => "tyup", "튷" => "tyuh", "트" => "teu", "특" => "teug", "튺" => "teugg", "튻" => "teugs",
    "튼" => "teun", "튽" => "teunj", "튾" => "teunh", "튿" => "teud", "틀" => "teul", "틁" => "teulg",
    "틂" => "teulm", "틃" => "teulb", "틄" => "teuls", "틅" => "teult", "틆" => "teulp", "틇" => "teulh",
    "틈" => "teum", "틉" => "teub", "틊" => "teubs", "틋" => "teus", "틌" => "teuss", "틍" => "teung",
    "틎" => "teuj", "틏" => "teuc", "틐" => "teuk", "틑" => "teut", "틒" => "teup", "틓" => "teuh",
    "틔" => "tyi", "틕" => "tyig", "틖" => "tyigg", "틗" => "tyigs", "틘" => "tyin", "틙" => "tyinj",
    "틚" => "tyinh", "틛" => "tyid", "틜" => "tyil", "틝" => "tyilg", "틞" => "tyilm", "틟" => "tyilb",
    "틠" => "tyils", "틡" => "tyilt", "틢" => "tyilp", "틣" => "tyilh", "틤" => "tyim", "틥" => "tyib",
    "틦" => "tyibs", "틧" => "tyis", "틨" => "tyiss", "틩" => "tying", "틪" => "tyij", "틫" => "tyic",
    "틬" => "tyik", "틭" => "tyit", "틮" => "tyip", "틯" => "tyih", "티" => "ti", "틱" => "tig",
    "틲" => "tigg", "틳" => "tigs", "틴" => "tin", "틵" => "tinj", "틶" => "tinh", "틷" => "tid",
    "틸" => "til", "틹" => "tilg", "틺" => "tilm", "틻" => "tilb", "틼" => "tils", "틽" => "tilt",
    "틾" => "tilp", "틿" => "tilh", "팁" => "tib", "팂" => "tibs", "팃" => "tis", "팄" => "tiss",
    "팅" => "ting", "팆" => "tij", "팇" => "tic", "팈" => "tik", "팉" => "tit", "팊" => "tip",
    "팋" => "tih", "파" => "pa", "팍" => "pag", "팎" => "pagg", "팏" => "pags", "판" => "pan",
    "팑" => "panj", "팒" => "panh", "팓" => "pad", "팔" => "pal", "팕" => "palg", "팖" => "palm",
    "팗" => "palb", "팘" => "pals", "팙" => "palt", "팚" => "palp", "팛" => "palh", "팜" => "pam",
    "팝" => "pab", "팞" => "pabs", "팟" => "pas", "팠" => "pass", "팡" => "pang", "팢" => "paj",
    "팣" => "pac", "팤" => "pak", "팥" => "pat", "팦" => "pap", "팧" => "pah", "패" => "pae",
    "팩" => "paeg", "팪" => "paegg", "팫" => "paegs", "팬" => "paen", "팭" => "paenj", "팮" => "paenh",
    "팯" => "paed", "팰" => "pael", "팱" => "paelg", "팲" => "paelm", "팳" => "paelb", "팴" => "paels",
    "팵" => "paelt", "팶" => "paelp", "팷" => "paelh", "팸" => "paem", "팹" => "paeb", "팺" => "paebs",
    "팻" => "paes", "팼" => "paess", "팽" => "paeng", "팾" => "paej", "팿" => "paec", "퍀" => "paek",
    "퍁" => "paet", "퍂" => "paep", "퍃" => "paeh", "퍄" => "pya", "퍅" => "pyag", "퍆" => "pyagg",
    "퍇" => "pyags", "퍈" => "pyan", "퍉" => "pyanj", "퍊" => "pyanh", "퍋" => "pyad", "퍌" => "pyal",
    "퍍" => "pyalg", "퍎" => "pyalm", "퍏" => "pyalb", "퍐" => "pyals", "퍑" => "pyalt", "퍒" => "pyalp",
    "퍓" => "pyalh", "퍔" => "pyam", "퍕" => "pyab", "퍖" => "pyabs", "퍗" => "pyas", "퍘" => "pyass",
    "퍙" => "pyang", "퍚" => "pyaj", "퍛" => "pyac", "퍜" => "pyak", "퍝" => "pyat", "퍞" => "pyap",
    "퍟" => "pyah", "퍠" => "pyae", "퍡" => "pyaeg", "퍢" => "pyaegg", "퍣" => "pyaegs", "퍤" => "pyaen",
    "퍥" => "pyaenj", "퍦" => "pyaenh", "퍧" => "pyaed", "퍨" => "pyael", "퍩" => "pyaelg", "퍪" => "pyaelm",
    "퍫" => "pyaelb", "퍬" => "pyaels", "퍭" => "pyaelt", "퍮" => "pyaelp", "퍯" => "pyaelh", "퍰" => "pyaem",
    "퍱" => "pyaeb", "퍲" => "pyaebs", "퍳" => "pyaes", "퍴" => "pyaess", "퍵" => "pyaeng", "퍶" => "pyaej",
    "퍷" => "pyaec", "퍸" => "pyaek", "퍹" => "pyaet", "퍺" => "pyaep", "퍻" => "pyaeh", "퍼" => "peo",
    "퍽" => "peog", "퍾" => "peogg", "퍿" => "peogs", "펀" => "peon", "펁" => "peonj", "펂" => "peonh",
    "펃" => "peod", "펄" => "peol", "펅" => "peolg", "펆" => "peolm", "펇" => "peolb", "펈" => "peols",
    "펉" => "peolt", "펊" => "peolp", "펋" => "peolh", "펌" => "peom", "펍" => "peob", "펎" => "peobs",
    "펏" => "peos", "펐" => "peoss", "펑" => "peong", "펒" => "peoj", "펓" => "peoc", "펔" => "peok",
    "펕" => "peot", "펖" => "peop", "펗" => "peoh", "페" => "pe", "펙" => "peg", "펚" => "pegg",
    "펛" => "pegs", "펜" => "pen", "펝" => "penj", "펞" => "penh", "펟" => "ped", "펠" => "pel",
    "펡" => "pelg", "펢" => "pelm", "펣" => "pelb", "펤" => "pels", "펥" => "pelt", "펦" => "pelp",
    "펧" => "pelh", "펨" => "pem", "펩" => "peb", "펪" => "pebs", "펫" => "pes", "펬" => "pess",
    "펭" => "peng", "펮" => "pej", "펯" => "pec", "펰" => "pek", "펱" => "pet", "펲" => "pep",
    "펳" => "peh", "펴" => "pyeo", "펵" => "pyeog", "펶" => "pyeogg", "펷" => "pyeogs", "편" => "pyeon",
    "펹" => "pyeonj", "펺" => "pyeonh", "펻" => "pyeod", "펼" => "pyeol", "펽" => "pyeolg", "펾" => "pyeolm",
    "펿" => "pyeolb", "폀" => "pyeols", "폁" => "pyeolt", "폂" => "pyeolp", "폃" => "pyeolh", "폄" => "pyeom",
    "폅" => "pyeob", "폆" => "pyeobs", "폇" => "pyeos", "폈" => "pyeoss", "평" => "pyeong", "폊" => "pyeoj",
    "폋" => "pyeoc", "폌" => "pyeok", "폍" => "pyeot", "폎" => "pyeop", "폏" => "pyeoh", "폐" => "pye",
    "폑" => "pyeg", "폒" => "pyegg", "폓" => "pyegs", "폔" => "pyen", "폕" => "pyenj", "폖" => "pyenh",
    "폗" => "pyed", "폘" => "pyel", "폙" => "pyelg", "폚" => "pyelm", "폛" => "pyelb", "폜" => "pyels",
    "폝" => "pyelt", "폞" => "pyelp", "폟" => "pyelh", "폠" => "pyem", "폡" => "pyeb", "폢" => "pyebs",
    "폣" => "pyes", "폤" => "pyess", "폥" => "pyeng", "폦" => "pyej", "폧" => "pyec", "폨" => "pyek",
    "폩" => "pyet", "폪" => "pyep", "폫" => "pyeh", "포" => "po", "폭" => "pog", "폮" => "pogg",
    "폯" => "pogs", "폰" => "pon", "폱" => "ponj", "폲" => "ponh", "폳" => "pod", "폴" => "pol",
    "폵" => "polg", "폶" => "polm", "폷" => "polb", "폸" => "pols", "폹" => "polt", "폺" => "polp",
    "폻" => "polh", "폼" => "pom", "폽" => "pob", "폾" => "pobs", "폿" => "pos", "퐁" => "pong",
    "퐂" => "poj", "퐃" => "poc", "퐄" => "pok", "퐅" => "pot", "퐆" => "pop", "퐇" => "poh",
    "퐈" => "pwa", "퐉" => "pwag", "퐊" => "pwagg", "퐋" => "pwags", "퐌" => "pwan", "퐍" => "pwanj",
    "퐎" => "pwanh", "퐏" => "pwad", "퐐" => "pwal", "퐑" => "pwalg", "퐒" => "pwalm", "퐓" => "pwalb",
    "퐔" => "pwals", "퐕" => "pwalt", "퐖" => "pwalp", "퐗" => "pwalh", "퐘" => "pwam", "퐙" => "pwab",
    "퐚" => "pwabs", "퐛" => "pwas", "퐜" => "pwass", "퐝" => "pwang", "퐞" => "pwaj", "퐟" => "pwac",
    "퐠" => "pwak", "퐡" => "pwat", "퐢" => "pwap", "퐣" => "pwah", "퐤" => "pwae", "퐥" => "pwaeg",
    "퐦" => "pwaegg", "퐧" => "pwaegs", "퐨" => "pwaen", "퐩" => "pwaenj", "퐪" => "pwaenh", "퐫" => "pwaed",
    "퐬" => "pwael", "퐭" => "pwaelg", "퐮" => "pwaelm", "퐯" => "pwaelb", "퐰" => "pwaels", "퐱" => "pwaelt",
    "퐲" => "pwaelp", "퐳" => "pwaelh", "퐴" => "pwaem", "퐵" => "pwaeb", "퐶" => "pwaebs", "퐷" => "pwaes",
    "퐸" => "pwaess", "퐹" => "pwaeng", "퐺" => "pwaej", "퐻" => "pwaec", "퐼" => "pwaek", "퐽" => "pwaet",
    "퐾" => "pwaep", "퐿" => "pwaeh", "푀" => "poe", "푁" => "poeg", "푂" => "poegg", "푃" => "poegs",
    "푄" => "poen", "푅" => "poenj", "푆" => "poenh", "푇" => "poed", "푈" => "poel", "푉" => "poelg",
    "푊" => "poelm", "푋" => "poelb", "푌" => "poels", "푍" => "poelt", "푎" => "poelp", "푏" => "poelh",
    "푐" => "poem", "푑" => "poeb", "푒" => "poebs", "푓" => "poes", "푔" => "poess", "푕" => "poeng",
    "푖" => "poej", "푗" => "poec", "푘" => "poek", "푙" => "poet", "푚" => "poep", "푛" => "poeh",
    "표" => "pyo", "푝" => "pyog", "푞" => "pyogg", "푟" => "pyogs", "푠" => "pyon", "푡" => "pyonj",
    "푢" => "pyonh", "푣" => "pyod", "푤" => "pyol", "푥" => "pyolg", "푦" => "pyolm", "푧" => "pyolb",
    "푨" => "pyols", "푩" => "pyolt", "푪" => "pyolp", "푫" => "pyolh", "푬" => "pyom", "푭" => "pyob",
    "푮" => "pyobs", "푯" => "pyos", "푰" => "pyoss", "푱" => "pyong", "푲" => "pyoj", "푳" => "pyoc",
    "푴" => "pyok", "푵" => "pyot", "푶" => "pyop", "푷" => "pyoh", "푸" => "pu", "푹" => "pug",
    "푺" => "pugg", "푻" => "pugs", "푼" => "pun", "푽" => "punj", "푾" => "punh", "푿" => "pud",
    "풀" => "pul", "풁" => "pulg", "풂" => "pulm", "풃" => "pulb", "풄" => "puls", "풅" => "pult",
    "풆" => "pulp", "풇" => "pulh", "품" => "pum", "풉" => "pub", "풊" => "pubs", "풋" => "pus",
    "풌" => "puss", "풍" => "pung", "풎" => "puj", "풏" => "puc", "풐" => "puk", "풑" => "put",
    "풒" => "pup", "풓" => "puh", "풔" => "pweo", "풕" => "pweog", "풖" => "pweogg", "풗" => "pweogs",
    "풘" => "pweon", "풙" => "pweonj", "풚" => "pweonh", "풛" => "pweod", "풜" => "pweol", "풝" => "pweolg",
    "풞" => "pweolm", "풟" => "pweolb", "풠" => "pweols", "풡" => "pweolt", "풢" => "pweolp", "풣" => "pweolh",
    "풤" => "pweom", "풥" => "pweob", "풦" => "pweobs", "풧" => "pweos", "풨" => "pweoss", "풩" => "pweong",
    "풪" => "pweoj", "풫" => "pweoc", "풬" => "pweok", "풭" => "pweot", "풮" => "pweop", "풯" => "pweoh",
    "풰" => "pwe", "풱" => "pweg", "풲" => "pwegg", "풳" => "pwegs", "풴" => "pwen", "풵" => "pwenj",
    "풶" => "pwenh", "풷" => "pwed", "풸" => "pwel", "풹" => "pwelg", "풺" => "pwelm", "풻" => "pwelb",
    "풼" => "pwels", "풽" => "pwelt", "풾" => "pwelp", "풿" => "pwelh", "퓀" => "pwem", "퓁" => "pweb",
    "퓂" => "pwebs", "퓃" => "pwes", "퓄" => "pwess", "퓅" => "pweng", "퓆" => "pwej", "퓇" => "pwec",
    "퓈" => "pwek", "퓉" => "pwet", "퓊" => "pwep", "퓋" => "pweh", "퓌" => "pwi", "퓍" => "pwig",
    "퓎" => "pwigg", "퓏" => "pwigs", "퓐" => "pwin", "퓑" => "pwinj", "퓒" => "pwinh", "퓓" => "pwid",
    "퓔" => "pwil", "퓕" => "pwilg", "퓖" => "pwilm", "퓗" => "pwilb", "퓘" => "pwils", "퓙" => "pwilt",
    "퓚" => "pwilp", "퓛" => "pwilh", "퓜" => "pwim", "퓝" => "pwib", "퓞" => "pwibs", "퓟" => "pwis",
    "퓠" => "pwiss", "퓡" => "pwing", "퓢" => "pwij", "퓣" => "pwic", "퓤" => "pwik", "퓥" => "pwit",
    "퓦" => "pwip", "퓧" => "pwih", "퓨" => "pyu", "퓩" => "pyug", "퓪" => "pyugg", "퓫" => "pyugs",
    "퓬" => "pyun", "퓭" => "pyunj", "퓮" => "pyunh", "퓯" => "pyud", "퓰" => "pyul", "퓱" => "pyulg",
    "퓲" => "pyulm", "퓳" => "pyulb", "퓴" => "pyuls", "퓵" => "pyult", "퓶" => "pyulp", "퓷" => "pyulh",
    "퓸" => "pyum", "퓹" => "pyub", "퓺" => "pyubs", "퓻" => "pyus", "퓼" => "pyuss", "퓽" => "pyung",
    "퓾" => "pyuj", "퓿" => "pyuc", "픁" => "pyut", "픂" => "pyup", "픃" => "pyuh", "프" => "peu",
    "픅" => "peug", "픆" => "peugg", "픇" => "peugs", "픈" => "peun", "픉" => "peunj", "픊" => "peunh",
    "픋" => "peud", "플" => "peul", "픍" => "peulg", "픎" => "peulm", "픏" => "peulb", "픐" => "peuls",
    "픑" => "peult", "픒" => "peulp", "픓" => "peulh", "픔" => "peum", "픕" => "peub", "픖" => "peubs",
    "픗" => "peus", "픘" => "peuss", "픙" => "peung", "픚" => "peuj", "픛" => "peuc", "픜" => "peuk",
    "픝" => "peut", "픞" => "peup", "픟" => "peuh", "픠" => "pyi", "픡" => "pyig", "픢" => "pyigg",
    "픣" => "pyigs", "픤" => "pyin", "픥" => "pyinj", "픦" => "pyinh", "픧" => "pyid", "픨" => "pyil",
    "픩" => "pyilg", "픪" => "pyilm", "픫" => "pyilb", "픬" => "pyils", "픭" => "pyilt", "픮" => "pyilp",
    "픯" => "pyilh", "픰" => "pyim", "픱" => "pyib", "픲" => "pyibs", "픳" => "pyis", "픴" => "pyiss",
    "픵" => "pying", "픶" => "pyij", "픷" => "pyic", "픸" => "pyik", "픹" => "pyit", "픺" => "pyip",
    "픻" => "pyih", "피" => "pi", "픽" => "pig", "픾" => "pigg", "픿" => "pigs", "핀" => "pin",
    "핁" => "pinj", "핂" => "pinh", "핃" => "pid", "필" => "pil", "핅" => "pilg", "핆" => "pilm",
    "핇" => "pilb", "핈" => "pils", "핉" => "pilt", "핊" => "pilp", "핋" => "pilh", "핌" => "pim",
    "핍" => "pib", "핎" => "pibs", "핏" => "pis", "핐" => "piss", "핑" => "ping", "핒" => "pij",
    "핓" => "pic", "핔" => "pik", "핕" => "pit", "핖" => "pip", "핗" => "pih", "하" => "ha",
    "학" => "hag", "핚" => "hagg", "핛" => "hags", "한" => "han", "핝" => "hanj", "핞" => "hanh",
    "핟" => "had", "할" => "hal", "핡" => "halg", "핢" => "halm", "핣" => "halb", "핤" => "hals",
    "핥" => "halt", "핦" => "halp", "핧" => "halh", "함" => "ham", "합" => "hab", "핪" => "habs",
    "핫" => "has", "핬" => "hass", "항" => "hang", "핮" => "haj", "핯" => "hac", "핰" => "hak",
    "핱" => "hat", "핲" => "hap", "핳" => "hah", "해" => "hae", "핵" => "haeg", "핶" => "haegg",
    "핷" => "haegs", "핸" => "haen", "핹" => "haenj", "핺" => "haenh", "핻" => "haed", "핼" => "hael",
    "핽" => "haelg", "핾" => "haelm", "핿" => "haelb", "햀" => "haels", "햁" => "haelt", "햂" => "haelp",
    "햃" => "haelh", "햄" => "haem", "햅" => "haeb", "햆" => "haebs", "햇" => "haes", "했" => "haess",
    "행" => "haeng", "햊" => "haej", "햋" => "haec", "햌" => "haek", "햍" => "haet", "햎" => "haep",
    "햏" => "haeh", "햐" => "hya", "햑" => "hyag", "햒" => "hyagg", "햓" => "hyags", "햔" => "hyan",
    "햕" => "hyanj", "햖" => "hyanh", "햗" => "hyad", "햘" => "hyal", "햙" => "hyalg", "햚" => "hyalm",
    "햛" => "hyalb", "햜" => "hyals", "햝" => "hyalt", "햞" => "hyalp", "햟" => "hyalh", "햠" => "hyam",
    "햡" => "hyab", "햢" => "hyabs", "햣" => "hyas", "햤" => "hyass", "향" => "hyang", "햦" => "hyaj",
    "햧" => "hyac", "햨" => "hyak", "햩" => "hyat", "햪" => "hyap", "햫" => "hyah", "햬" => "hyae",
    "햭" => "hyaeg", "햮" => "hyaegg", "햯" => "hyaegs", "햰" => "hyaen", "햱" => "hyaenj", "햲" => "hyaenh",
    "햳" => "hyaed", "햴" => "hyael", "햵" => "hyaelg", "햶" => "hyaelm", "햷" => "hyaelb", "햸" => "hyaels",
    "햹" => "hyaelt", "햺" => "hyaelp", "햻" => "hyaelh", "햼" => "hyaem", "햽" => "hyaeb", "햾" => "hyaebs",
    "햿" => "hyaes", "헀" => "hyaess", "헁" => "hyaeng", "헂" => "hyaej", "헃" => "hyaec", "헄" => "hyaek",
    "헅" => "hyaet", "헆" => "hyaep", "헇" => "hyaeh", "허" => "heo", "헉" => "heog", "헊" => "heogg",
    "헋" => "heogs", "헌" => "heon", "헍" => "heonj", "헎" => "heonh", "헏" => "heod", "헐" => "heol",
    "헑" => "heolg", "헒" => "heolm", "헓" => "heolb", "헔" => "heols", "헕" => "heolt", "헖" => "heolp",
    "헗" => "heolh", "험" => "heom", "헙" => "heob", "헚" => "heobs", "헛" => "heos", "헜" => "heoss",
    "헝" => "heong", "헞" => "heoj", "헟" => "heoc", "헠" => "heok", "헡" => "heot", "헢" => "heop",
    "헣" => "heoh", "헤" => "he", "헥" => "heg", "헦" => "hegg", "헧" => "hegs", "헨" => "hen",
    "헩" => "henj", "헪" => "henh", "헫" => "hed", "헬" => "hel", "헭" => "helg", "헮" => "helm",
    "헯" => "helb", "헰" => "hels", "헱" => "helt", "헲" => "help", "헳" => "helh", "헴" => "hem",
    "헵" => "heb", "헶" => "hebs", "헷" => "hes", "헸" => "hess", "헹" => "heng", "헺" => "hej",
    "헻" => "hec", "헼" => "hek", "헽" => "het", "헾" => "hep", "헿" => "heh", "혁" => "hyeog",
    "혂" => "hyeogg", "혃" => "hyeogs", "현" => "hyeon", "혅" => "hyeonj", "혆" => "hyeonh", "혇" => "hyeod",
    "혈" => "hyeol", "혉" => "hyeolg", "혊" => "hyeolm", "혋" => "hyeolb", "혌" => "hyeols", "혍" => "hyeolt",
    "혎" => "hyeolp", "혏" => "hyeolh", "혐" => "hyeom", "협" => "hyeob", "혒" => "hyeobs", "혓" => "hyeos",
    "혔" => "hyeoss", "형" => "hyeong", "혖" => "hyeoj", "혗" => "hyeoc", "혘" => "hyeok", "혙" => "hyeot",
    "혚" => "hyeop", "혛" => "hyeoh", "혜" => "hye", "혝" => "hyeg", "혞" => "hyegg", "혟" => "hyegs",
    "혠" => "hyen", "혡" => "hyenj", "혢" => "hyenh", "혣" => "hyed", "혤" => "hyel", "혥" => "hyelg",
    "혦" => "hyelm", "혧" => "hyelb", "혨" => "hyels", "혩" => "hyelt", "혪" => "hyelp", "혫" => "hyelh",
    "혬" => "hyem", "혭" => "hyeb", "혮" => "hyebs", "혯" => "hyes", "혰" => "hyess", "혱" => "hyeng",
    "혲" => "hyej", "혳" => "hyec", "혴" => "hyek", "혵" => "hyet", "혶" => "hyep", "혷" => "hyeh",
    "호" => "ho", "혹" => "hog", "혺" => "hogg", "혻" => "hogs", "혼" => "hon", "혽" => "honj",
    "혾" => "honh", "혿" => "hod", "홀" => "hol", "홁" => "holg", "홂" => "holm", "홃" => "holb",
    "홄" => "hols", "홅" => "holt", "홆" => "holp", "홇" => "holh", "홈" => "hom", "홉" => "hob",
    "홊" => "hobs", "홋" => "hos", "홌" => "hoss", "홍" => "hong", "홎" => "hoj", "홏" => "hoc",
    "홐" => "hok", "홑" => "hot", "홒" => "hop", "홓" => "hoh", "화" => "hwa", "확" => "hwag",
    "홖" => "hwagg", "홗" => "hwags", "환" => "hwan", "홙" => "hwanj", "홚" => "hwanh", "홛" => "hwad",
    "활" => "hwal", "홝" => "hwalg", "홞" => "hwalm", "홟" => "hwalb", "홠" => "hwals", "홡" => "hwalt",
    "홢" => "hwalp", "홣" => "hwalh", "홤" => "hwam", "홥" => "hwab", "홦" => "hwabs", "홧" => "hwas",
    "홨" => "hwass", "황" => "hwang", "홪" => "hwaj", "홫" => "hwac", "홬" => "hwak", "홭" => "hwat",
    "홮" => "hwap", "홯" => "hwah", "홰" => "hwae", "홱" => "hwaeg", "홲" => "hwaegg", "홳" => "hwaegs",
    "홴" => "hwaen", "홵" => "hwaenj", "홶" => "hwaenh", "홷" => "hwaed", "홸" => "hwael", "홹" => "hwaelg",
    "홺" => "hwaelm", "홻" => "hwaelb", "홼" => "hwaels", "홽" => "hwaelt", "홾" => "hwaelp", "홿" => "hwaelh",
    "횀" => "hwaem", "횁" => "hwaeb", "횂" => "hwaebs", "횃" => "hwaes", "횄" => "hwaess", "횅" => "hwaeng",
    "횆" => "hwaej", "횇" => "hwaec", "횈" => "hwaek", "횉" => "hwaet", "횊" => "hwaep", "횋" => "hwaeh",
    "회" => "hoe", "획" => "hoeg", "횎" => "hoegg", "횏" => "hoegs", "횐" => "hoen", "횑" => "hoenj",
    "횒" => "hoenh", "횓" => "hoed", "횔" => "hoel", "횕" => "hoelg", "횖" => "hoelm", "횗" => "hoelb",
    "횘" => "hoels", "횙" => "hoelt", "횚" => "hoelp", "횛" => "hoelh", "횜" => "hoem", "횝" => "hoeb",
    "횞" => "hoebs", "횟" => "hoes", "횠" => "hoess", "횡" => "hoeng", "횢" => "hoej", "횣" => "hoec",
    "횤" => "hoek", "횥" => "hoet", "횦" => "hoep", "횧" => "hoeh", "효" => "hyo", "횩" => "hyog",
    "횪" => "hyogg", "횫" => "hyogs", "횬" => "hyon", "횭" => "hyonj", "횮" => "hyonh", "횯" => "hyod",
    "횰" => "hyol", "횱" => "hyolg", "횲" => "hyolm", "횳" => "hyolb", "횴" => "hyols", "횵" => "hyolt",
    "횶" => "hyolp", "횷" => "hyolh", "횸" => "hyom", "횹" => "hyob", "횺" => "hyobs", "횻" => "hyos",
    "횼" => "hyoss", "횽" => "hyong", "횾" => "hyoj", "횿" => "hyoc", "훀" => "hyok", "훁" => "hyot",
    "훂" => "hyop", "훃" => "hyoh", "후" => "hu", "훅" => "hug", "훆" => "hugg", "훇" => "hugs",
    "훈" => "hun", "훉" => "hunj", "훊" => "hunh", "훋" => "hud", "훌" => "hul", "훍" => "hulg",
    "훎" => "hulm", "훏" => "hulb", "훐" => "huls", "훑" => "hult", "훒" => "hulp", "훓" => "hulh",
    "훔" => "hum", "훕" => "hub", "훖" => "hubs", "훗" => "hus", "훘" => "huss", "훙" => "hung",
    "훚" => "huj", "훛" => "huc", "훜" => "huk", "훝" => "hut", "훞" => "hup", "훟" => "huh",
    "훠" => "hweo", "훡" => "hweog", "훢" => "hweogg", "훣" => "hweogs", "훤" => "hweon", "훥" => "hweonj",
    "훦" => "hweonh", "훧" => "hweod", "훨" => "hweol", "훩" => "hweolg", "훪" => "hweolm", "훫" => "hweolb",
    "훬" => "hweols", "훭" => "hweolt", "훮" => "hweolp", "훯" => "hweolh", "훰" => "hweom", "훱" => "hweob",
    "훲" => "hweobs", "훳" => "hweos", "훴" => "hweoss", "훵" => "hweong", "훶" => "hweoj", "훷" => "hweoc",
    "훸" => "hweok", "훹" => "hweot", "훺" => "hweop", "훻" => "hweoh", "훼" => "hwe", "훽" => "hweg",
    "훾" => "hwegg", "훿" => "hwegs", "휁" => "hwenj", "휂" => "hwenh", "휃" => "hwed", "휄" => "hwel",
    "휅" => "hwelg", "휆" => "hwelm", "휇" => "hwelb", "휈" => "hwels", "휉" => "hwelt", "휊" => "hwelp",
    "휋" => "hwelh", "휌" => "hwem", "휍" => "hweb", "휎" => "hwebs", "휏" => "hwes", "휐" => "hwess",
    "휑" => "hweng", "휒" => "hwej", "휓" => "hwec", "휔" => "hwek", "휕" => "hwet", "휖" => "hwep",
    "휗" => "hweh", "휘" => "hwi", "휙" => "hwig", "휚" => "hwigg", "휛" => "hwigs", "휜" => "hwin",
    "휝" => "hwinj", "휞" => "hwinh", "휟" => "hwid", "휠" => "hwil", "휡" => "hwilg", "휢" => "hwilm",
    "휣" => "hwilb", "휤" => "hwils", "휥" => "hwilt", "휦" => "hwilp", "휧" => "hwilh", "휨" => "hwim",
    "휩" => "hwib", "휪" => "hwibs", "휫" => "hwis", "휬" => "hwiss", "휭" => "hwing", "휮" => "hwij",
    "휯" => "hwic", "휰" => "hwik", "휱" => "hwit", "휲" => "hwip", "휳" => "hwih", "휴" => "hyu",
    "휵" => "hyug", "휶" => "hyugg", "휷" => "hyugs", "휸" => "hyun", "휹" => "hyunj", "휺" => "hyunh",
    "휻" => "hyud", "휼" => "hyul", "휽" => "hyulg", "휾" => "hyulm", "휿" => "hyulb", "흀" => "hyuls",
    "흁" => "hyult", "흂" => "hyulp", "흃" => "hyulh", "흄" => "hyum", "흅" => "hyub", "흆" => "hyubs",
    "흇" => "hyus", "흈" => "hyuss", "흉" => "hyung", "흊" => "hyuj", "흋" => "hyuc", "흌" => "hyuk",
    "흍" => "hyut", "흎" => "hyup", "흏" => "hyuh", "흐" => "heu", "흑" => "heug", "흒" => "heugg",
    "흓" => "heugs", "흔" => "heun", "흕" => "heunj", "흖" => "heunh", "흗" => "heud", "흘" => "heul",
    "흙" => "heulg", "흚" => "heulm", "흛" => "heulb", "흜" => "heuls", "흝" => "heult", "흞" => "heulp",
    "흟" => "heulh", "흠" => "heum", "흡" => "heub", "흢" => "heubs", "흣" => "heus", "흤" => "heuss",
    "흥" => "heung", "흦" => "heuj", "흧" => "heuc", "흨" => "heuk", "흩" => "heut", "흪" => "heup",
    "흫" => "heuh", "희" => "hyi", "흭" => "hyig", "흮" => "hyigg", "흯" => "hyigs", "흰" => "hyin",
    "흱" => "hyinj", "흲" => "hyinh", "흳" => "hyid", "흴" => "hyil", "흵" => "hyilg", "흶" => "hyilm",
    "흷" => "hyilb", "흸" => "hyils", "흹" => "hyilt", "흺" => "hyilp", "흻" => "hyilh", "흼" => "hyim",
    "흽" => "hyib", "흾" => "hyibs", "흿" => "hyis", "힀" => "hyiss", "힁" => "hying", "힂" => "hyij",
    "힃" => "hyic", "힄" => "hyik", "힅" => "hyit", "힆" => "hyip", "힇" => "hyih", "히" => "hi",
    "힉" => "hig", "힊" => "higg", "힋" => "higs", "힌" => "hin", "힍" => "hinj", "힎" => "hinh",
    "힏" => "hid", "힐" => "hil", "힑" => "hilg", "힒" => "hilm", "힓" => "hilb", "힔" => "hils",
    "힕" => "hilt", "힖" => "hilp", "힗" => "hilh", "힘" => "him", "힙" => "hib", "힚" => "hibs",
    "힛" => "his", "힜" => "hiss", "힝" => "hing", "힞" => "hij", "힟" => "hic", "힠" => "hik",
    "힡" => "hit", "힢" => "hip", "힣" => "hih", "更" => "Kayng", "車" => "Ke", "賈" => "Ko",
    "滑" => "Kol", "串" => "Koc", "句" => "Kwi", "龜" => "Kwi", "龜" => "Kyun", "契" => "Kul",
    "金" => "Kum", "喇" => "Na", "奈" => "Na", "懶" => "Na", "癩" => "La", "羅" => "Na",
    "蘿" => "Na", "螺" => "Na", "裸" => "Na", "邏" => "Na", "樂" => "Nak", "洛" => "Nak",
    "烙" => "Nak", "珞" => "Nak", "落" => "Nak", "酪" => "Nak", "駱" => "Nak", "亂" => "Nan",
    "卵" => "Nan", "欄" => "Nan", "爛" => "Nan", "蘭" => "Nan", "鸞" => "Nan", "嵐" => "Nam",
    "濫" => "Nam", "藍" => "Nam", "襤" => "Nam", "拉" => "Nap", "臘" => "Nap", "蠟" => "Nap",
    "廊" => "Nang", "朗" => "Nang", "浪" => "Nang", "狼" => "Nang", "郎" => "Nang", "來" => "Nay",
    "冷" => "Nayng", "勞" => "No", "擄" => "No", "櫓" => "No", "爐" => "No", "盧" => "No",
    "老" => "No", "蘆" => "No", "虜" => "No", "路" => "No", "露" => "No", "魯" => "No",
    "鷺" => "No", "碌" => "Nok", "祿" => "Nok", "綠" => "Nok", "菉" => "Nok", "錄" => "Nok",
    "鹿" => "Nok", "論" => "Non", "壟" => "Nong", "弄" => "Nong", "籠" => "Nong", "聾" => "Nong",
    "牢" => "Noy", "磊" => "Noy", "賂" => "Noy", "雷" => "Noy", "壘" => "Nwu", "屢" => "Nwu",
    "樓" => "Nwu", "淚" => "Nwu", "漏" => "Nwu", "累" => "Nwu", "縷" => "Nwu", "陋" => "Nwu",
    "勒" => "Nuk", "肋" => "Nuk", "凜" => "Num", "凌" => "Nung", "稜" => "Nung", "綾" => "Nung",
    "菱" => "Nung", "陵" => "Nung", "讀" => "Twu", "拏" => "La", "樂" => "Lak", "諾" => "Lak",
    "丹" => "Lan", "寧" => "Lyeng", "怒" => "Lo", "率" => "Lyul", "異" => "Li", "北" => "Pey",
    "磻" => "Pen", "便" => "Pyen", "復" => "Pwu", "不" => "Pwul", "泌" => "Pi", "數" => "Sak",
    "索" => "Sak", "參" => "Sam", "塞" => "Sayk", "省" => "Sayng", "葉" => "Sep", "說" => "Sey",
    "殺" => "Sway", "辰" => "Sin", "沈" => "Sim", "拾" => "Sip", "若" => "Ya", "掠" => "Yak",
    "略" => "Yak", "亮" => "Yang", "兩" => "Yang", "凉" => "Yang", "梁" => "Yang", "糧" => "Yang",
    "良" => "Yang", "諒" => "Yang", "量" => "Yang", "勵" => "Ye", "呂" => "Ye", "女" => "Ye",
    "廬" => "Ye", "旅" => "Ye", "濾" => "Ye", "礪" => "Ye", "閭" => "Ye", "驪" => "Ye",
    "麗" => "Ye", "黎" => "Ye", "力" => "Yek", "曆" => "Yek", "歷" => "Yek", "轢" => "Yek",
    "年" => "Yen", "憐" => "Yen", "戀" => "Yen", "撚" => "Yen", "漣" => "Yen", "煉" => "Yen",
    "璉" => "Yen", "秊" => "Yen", "練" => "Yen", "聯" => "Yen", "輦" => "Yen", "蓮" => "Yen",
    "連" => "Yen", "鍊" => "Yen", "列" => "Yel", "劣" => "Yel", "咽" => "Yel", "烈" => "Yel",
    "裂" => "Yel", "說" => "Yel", "廉" => "Yem", "念" => "Yem", "捻" => "Yem", "殮" => "Yem",
    "簾" => "Yem", "獵" => "Yep", "令" => "Yeng", "囹" => "Yeng", "寧" => "Yeng", "嶺" => "Yeng",
    "怜" => "Yeng", "玲" => "Yeng", "瑩" => "Yeng", "羚" => "Yeng", "聆" => "Yeng", "鈴" => "Yeng",
    "零" => "Yeng", "靈" => "Yeng", "領" => "Yeng", "例" => "Yey", "禮" => "Yey", "醴" => "Yey",
    "隸" => "Yey", "惡" => "O", "了" => "Yo", "僚" => "Yo", "寮" => "Yo", "尿" => "Yo",
    "料" => "Yo", "樂" => "Yo", "燎" => "Yo", "療" => "Yo", "蓼" => "Yo", "遼" => "Yo",
    "龍" => "Yong", "暈" => "Wun", "阮" => "Wen", "劉" => "Yu", "杻" => "Yu", "柳" => "Yu",
    "流" => "Yu", "溜" => "Yu", "琉" => "Yu", "留" => "Yu", "硫" => "Yu", "紐" => "Yu",
    "類" => "Yu", "六" => "Yuk", "戮" => "Yuk", "陸" => "Yuk", "倫" => "Yun", "崙" => "Yun",
    "淪" => "Yun", "輪" => "Yun", "律" => "Yul", "慄" => "Yul", "栗" => "Yul", "率" => "Yul",
    "隆" => "Yung", "利" => "I", "吏" => "I", "履" => "I", "易" => "I", "李" => "I",
    "梨" => "I", "泥" => "I", "理" => "I", "痢" => "I", "罹" => "I", "裏" => "I",
    "裡" => "I", "里" => "I", "離" => "I", "匿" => "Ik", "溺" => "Ik", "吝" => "In",
    "燐" => "In", "璘" => "In", "藺" => "In", "隣" => "In", "鱗" => "In", "麟" => "In",
    "林" => "Im", "淋" => "Im", "臨" => "Im", "立" => "Ip", "笠" => "Ip", "粒" => "Ip",
    "狀" => "Cang", "炙" => "Cek", "識" => "Ci", "什" => "Cip", "茶" => "Cha", "刺" => "Chek",
    "度" => "Thak", "拓" => "Thak", "糖" => "Thang", "宅" => "Thayk", "洞" => "Thong", "暴" => "Pho",
    "輻" => "Phok", "行" => "Hang", "降" => "Hang", "見" => "Hyen", "廓" => "Hwak", "兀" => "Wu",
    "嗀" => "Huo", "塚" => "Zhong", "晴" => "Qing", "凞" => "Xi", "猪" => "Zhu", "益" => "Yi",
    "礼" => "Li", "神" => "Shen", "祥" => "Xiang", "福" => "Fu", "靖" => "Jing", "精" => "Jing",
    "羽" => "Yu", "蘒" => "Hagi", "諸" => "Zhu", "逸" => "Yi", "都" => "Du", "飯" => "Fan",
    "飼" => "Si", "館" => "Guan", "ﬁ" => "fi", "ﬂ" => "fl", "ﬃ" => "ffi", "ﬄ" => "ffl",
    "ﬅ" => "st", "ﬆ" => "st", "ﬓ" => "mn", "ﬔ" => "me", "ﬕ" => "mi", "ﬖ" => "vn",
    "ﬗ" => "mkh", "יִ" => "yi", "ײַ" => "ay", "ﬢ" => "d", "ﬣ" => "h", "ﬤ" => "k",
    "ﬥ" => "l", "ﬦ" => "m", "ﬧ" => "m", "ﬨ" => "t", "שׁ" => "sh", "שׂ" => "s",
    "שּׁ" => "sh", "שּׂ" => "s", "אַ" => "a", "אָ" => "a", "בּ" => "b", "גּ" => "g",
    "דּ" => "d", "הּ" => "h", "וּ" => "v", "זּ" => "z", "טּ" => "t", "יּ" => "y",
    "ךּ" => "k", "כּ" => "k", "לּ" => "l", "מּ" => "l", "נּ" => "n", "סּ" => "n",
    "ףּ" => "p", "פּ" => "p", "צּ" => "ts", "קּ" => "ts", "רּ" => "r", "שּ" => "sh",
    "תּ" => "t", "וֹ" => "vo", "בֿ" => "b", "כֿ" => "k", "פֿ" => "p", "ﭏ" => "l",
    "１" => "1", "２" => "2", "３" => "3", "４" => "4", "５" => "5", "６" => "6",
    "７" => "7", "８" => "8", "９" => "9", "Ａ" => "A", "Ｂ" => "B", "Ｃ" => "C",
    "Ｄ" => "D", "Ｅ" => "E", "Ｆ" => "F", "Ｇ" => "G", "Ｈ" => "H", "Ｉ" => "I",
    "Ｊ" => "J", "Ｋ" => "K", "Ｌ" => "L", "Ｍ" => "M", "Ｎ" => "N", "Ｏ" => "O",
    "Ｐ" => "P", "Ｑ" => "Q", "Ｒ" => "R", "Ｓ" => "S", "Ｔ" => "T", "Ｕ" => "U",
    "Ｖ" => "V", "Ｗ" => "W", "Ｘ" => "X", "Ｙ" => "Y", "Ｚ" => "Z", "ａ" => "a",
    "ｂ" => "b", "ｃ" => "c", "ｄ" => "d", "ｅ" => "e", "ｆ" => "f", "ｇ" => "g",
    "ｈ" => "h", "ｉ" => "i", "ｊ" => "j", "ｋ" => "k", "ｌ" => "l", "ｍ" => "m",
    "ｎ" => "n", "ｏ" => "o", "ｐ" => "p", "ｑ" => "q", "ｒ" => "r", "ｓ" => "s",
    "ｔ" => "t", "ｕ" => "u", "ｖ" => "v", "ｗ" => "w", "ｘ" => "x", "ｙ" => "y",
    "ｚ" => "z", "ｦ" => "wo", "ｧ" => "a", "ｨ" => "i", "ｩ" => "u", "ｪ" => "e",
    "ｫ" => "o", "ｬ" => "ya", "ｭ" => "yu", "ｮ" => "yo", "ｯ" => "tu", "ｱ" => "a",
    "ｲ" => "i", "ｳ" => "u", "ｴ" => "e", "ｵ" => "o", "ｶ" => "ka", "ｷ" => "ki",
    "ｸ" => "ku", "ｹ" => "ke", "ｺ" => "ko", "ｻ" => "sa", "ｼ" => "si", "ｽ" => "su",
    "ｾ" => "se", "ｿ" => "so", "ﾀ" => "ta", "ﾁ" => "ti", "ﾂ" => "tu", "ﾃ" => "te",
    "ﾄ" => "to", "ﾅ" => "na", "ﾆ" => "ni", "ﾇ" => "nu", "ﾈ" => "ne", "ﾉ" => "no",
    "ﾊ" => "ha", "ﾋ" => "hi", "ﾌ" => "hu", "ﾍ" => "he", "ﾎ" => "ho", "ﾏ" => "ma",
    "ﾐ" => "mi", "ﾑ" => "mu", "ﾒ" => "me", "ﾓ" => "mo", "ﾔ" => "ya", "ﾕ" => "yu",
    "ﾖ" => "yo", "ﾗ" => "ra", "ﾘ" => "ri", "ﾙ" => "ru", "ﾚ" => "re", "ﾛ" => "ro",
    "ﾜ" => "wa", "ﾝ" => "n", "ﾡ" => "g", "ﾢ" => "gg", "ﾣ" => "gs", "ﾤ" => "n",
    "ﾥ" => "nj", "ﾦ" => "nh", "ﾧ" => "d", "ﾨ" => "dd", "ﾩ" => "r", "ﾪ" => "lg",
    "ﾫ" => "lm", "ﾬ" => "lb", "ﾭ" => "ls", "ﾮ" => "lt", "ﾯ" => "lp", "ﾰ" => "rh",
    "ﾱ" => "m", "ﾲ" => "b", "ﾳ" => "bb", "ﾴ" => "bs", "ﾵ" => "s", "ﾶ" => "ss",
    "ﾸ" => "j", "ﾹ" => "jj", "ﾺ" => "c", "ﾻ" => "k", "ﾼ" => "t", "ﾽ" => "p",
    "ﾾ" => "h", "ￂ" => "a", "ￃ" => "ae", "ￄ" => "ya", "ￅ" => "yae", "ￆ" => "eo",
    "ￇ" => "e", "ￊ" => "yeo", "ￋ" => "ye", "ￌ" => "o", "ￍ" => "wa", "ￎ" => "wae",
    "ￏ" => "oe", "ￒ" => "yo", "ￓ" => "u", "ￔ" => "weo", "ￕ" => "we", "ￖ" => "wi",
    "ￗ" => "yu", "ￚ" => "eu", "ￛ" => "yi", "ￜ" => "i", "￠" => "C", "￡" => "PS",
    "￥" => "Y=", "￦" => "W=", "￮" => "O"
  );

  static function utf8_to_ascii($str) {
    static $keys = null;
    static $values = null;
    if (!$keys) {
      $keys = array_keys(self::$UTF8_TRANSLATE);
      $values = array_values(self::$UTF8_TRANSLATE);
    }

    return str_replace($keys, $values, $str);
  }
}
